<?php
$eternity = new Eternity();
$evp = new EVP($config['evp']);
$config = Registry::retrieve('config');
$config['locations']['themeDir'] = $config['locations']['absolute'].$config['locations']['folder_name'].'/themes/'.$evp->settings->theme.'/';
$config['locations']['themeDirRelative'] = $config['locations']['relative'].$config['locations']['folder_name'].'/themes/'.$evp->settings->theme.'/';
$config['locations']['themePath'] = $config['paths']['base'].'/'.$config['locations']['folder_name'].'/themes/'.$evp->settings->theme.'/';

if($evp->options->hosted === true) {
	$config['locations']['themeDir'] = $config['locations']['protocol'].'://'.$evp->settings->s3_bucket.'.s3.amazonaws.com/'.$config['locations']['folder_name'].'/themes/'.$evp->settings->theme.'/';
	$config['locations']['folder_absolute'] = url($config['locations']['protocol'].'://'.$evp->settings->s3_bucket.'.s3.amazonaws.com/'.$config['locations']['folder_name'].'/');
}

Registry::store('config', $config);

$xs->checkCurrent();

function fileLink($file_ref, $page) {
	$parts = explode('::', $file_ref, 2);
	$file_id = $parts[0];
	$profile = $parts[1];
	if(empty($profile)) $profile = '';
	return url('admin/'.$page, array('id' => $file_id, 'profile' => $profile));
}

function assets($ref) {
	$config = Registry::retrieve('config');
	return url($config['locations']['themeDir'].$ref);
}

$isClient = false;
if($xs->isMemberOf($xs->userData->id, 'Users') || $xs->isMemberOf($xs->userData->id, 'Clients')) {
	$isClient = true;
}

function onTemplateMerge($event, $master, $template, $page) {
	global $isClient;
	
	$config = Registry::retrieve('config');
	$xs = Registry::retrieve('users');
	$evp = Registry::get('EVP');
	
	header('Content-Type: text/html; charset=utf-8');
	
	if($_GET['XDEBUG_PROFILE'] == 1 && $evp->options->debug == true) {
		$database = Registry::retrieve('database');
		$queries = $database->getQueries();
		file_put_contents($config['paths']['base'].'/assets/cache/log-'.str_replace('/', '-', str_replace($config['paths']['base'].'/', '', $template->name)).'.txt', implode($queries, ";\n\n"));
	}
	
	$page->set('isClient', $isClient);
	
	// Page data etc
	$page->meta('Content-Type', 'text/html; charset=utf-8');
	
	// JavaScript
	$page->js(url('player/')); // This is to play the help videos and such
	if($evp->options->hosted == false || ($evp->options->hosted == true && $evp->options->debug == true)) {
		$page->js('scripts/libraries/mootools-1.4.1-more-clientcide.js', array('position' => 'start'));
		$page->js('scripts/custom/mootools-events.js');
		$page->js('scripts/custom/mootools-behaviors.js');
		$page->js('scripts/custom/mootools-extensions.js');
		$page->js('scripts/custom/behaviors.js');
		$page->js('scripts/libraries/scrollspy.js');
		$page->js('scripts/libraries/moobutton.js');
		$page->js('scripts/libraries/mooselecta.js');
		$page->js('scripts/libraries/iphone-checkbox.js');
		$page->js('scripts/libraries/phpjs.js');
		$page->js('scripts/libraries/radiogroup.js');
		$page->js('scripts/libraries/thumbnailcycle.js');
		$page->js('scripts/libraries/Element.Style.Transform.js');
		$page->js('scripts/libraries/Element.Serialize.js');
		$page->js('scripts/global.js');
	} else {
		$page->js($config['locations']['themeDir'].'scripts/compiled.js', array('position' => 'start'));
	}/* else {
		$page->js('../../../external/min/?b='.trim($config['locations']['themeDirRelative'], '/').'/scripts&f=libraries/mootools-1.4.1-more-clientcide.js,custom/mootools-events.js,custom/mootools-behaviors.js,custom/mootools-extensions.js,custom/behaviors.js,libraries/scrollspy.js,libraries/moobutton.js,libraries/mooselecta.js,libraries/iphone-checkbox.js,libraries/phpjs.js,libraries/radiogroup.js,libraries/thumbnailcycle.js,libraries/Element.Style.Transform.js,libraries/Element.Serialize.js,global.js', array('position' => 'start'));
	}*/
	$page->js("Clientcide.setAssetLocation('".assets('assets/clientcide')."');");
	$page->js("window.store('themeDir', '{$config['locations']['themeDir']}');");
	
	// CSS
	if($evp->options->hosted == false || ($evp->options->hosted == true && $evp->options->debug == true)) {
		$page->css('styles/style.reset.css');
		$page->css('styles/style.basics.css');
		$page->css('styles/style.components.css');
		$page->css('styles/style.actions.css');
	} else {
		$page->css($config['locations']['themeDir'].'styles/compiled.css?v='.$evp->options->project_version);
	}/* else {
		$page->css('../../../external/min/?b='.trim($config['locations']['themeDirRelative'], '/').'/styles&f=style.reset.css,style.basics.css,style.components.css,style.actions.css');
	}*/
	
	if($master->isiPhone()) $page->meta('viewport', 'user-scalable=no,width=device-width');
	
	// And the master variables needed
	$master->set('tpl_master', $master);
	$master->set('config', $config);
	$master->set('themeDir', $config['locations']['themeDir']);
	$master->set('themePath', $config['locations']['themePath']);
	$master->set('evp', Registry::get('EVP'));
	$master->set('eternity', Registry::get('Eternity'));
	$master->set('xs', $xs);
	$master->set('currentUser', $xs->userData);
}
?>