<?php
require('application.php');
require('application.bootstrap.php');
$page = new Page('files.embed.php', 'master.php', array('theme' => $evp->settings->theme, 'version' => $evp->options->project_version));
$page->title(array(pick($evp->settings->site_name, $evp->options->project_name), 'Your Files', 'Embed code'));
$xs->restrictTo(array('groups' => array('Administrators', 'Managers', 'Clients', 'Users')), 'signin.php', array('return' => pass_create()), true);

//if($_GET['refresh_cache'] == 1) $evp->primeFileCache();
//$evp->primeFileCache();

// We ready for a file?
$id = escape(trim($_GET['id']));
if(empty($id)) {
	echo 'The file you requested could not be found!';
} else {
	// Profile?
	$file_ref = $id;
	$profile = makeSeed($_GET['profile']);
	if(!empty($profile)) {
		$file_ref.= '::'.$profile;
	}
	
	// Grab the data
	$file = $evp->getFile($file_ref);
	
	// Let's get the embed code for this file
	$embed_code = $evp->videoEmbedCode($file, 'sd', $profile);
	
	// And the iframe embed code
	$embed_code_iframe = $evp->videoEmbedCode($file, 'sd', $profile, false, 'iframe');
	
	// And the responsive embed code
	$embed_code_responsive = $evp->videoEmbedCode($file, 'sd', $profile, false, 'responsive');
	
	// And the iframe embed code
	$embed_code_object = $evp->videoEmbedCode($file, 'sd', $profile, false, 'object');
	
	// And the url, for microdata use
	$embed_code_url = $evp->videoEmbedCode($file, 'sd', $profile, false, 'url');
	
	// And the internal code without any tracking
	$embed_code_internal = $evp->videoEmbedCode($file, 'sd', $profile, false, 'js', '{"disable_stat_tracking":true}');
	
	// And the settings, which we need to expose for sales tracking config on this page
	$file_settings = $evp->collateFileSettings($file, $profile);
	
	// And expose
	$page->set(array(
		'profile' => $profile,
		'file' => $file,
		'file_settings' => $file_settings,
		'file_ref' => $file_ref,
		'file_settings' => $file_settings,
		'embed_code' => $embed_code,
		'embed_code_iframe' => $embed_code_iframe,
		'embed_code_object' => $embed_code_object,
		'embed_code_responsive' => $embed_code_responsive,
		'embed_code_internal' => $embed_code_internal,
		'embed_code_url' => $embed_code_url
	));
}

$page->js('scripts/custom/evp-ties.js');
$page->js('scripts/libraries/Meio.Mask.js');
$page->js('scripts/libraries/Meio.Mask.Fixed.js');
$page->js('scripts/libraries/Meio.Mask.Reverse.js');
$page->js('scripts/libraries/Meio.Mask.Extras.js');

// Any special things this page needs?
$page->addEvent('onTemplateMerge', 'onTemplateMerge');
echo $page->parse();
?>