<?php
require('application.php');
require('application.bootstrap.php');

$operation_type = pick($_GET['operation'], 'permissions');

$page = new Page('files.operate.php', 'master.php', array('theme' => $evp->settings->theme, 'version' => $evp->options->project_version));
$xs->restrictTo(array('groups' => array('Administrators')), 'signin.php', array('return' => pass_create()), true);

if(!$evp->s3) redirect('admin/settings.php');

$files = $evp->s3->getFiles();

switch($operation_type) {
	case 'permissions':
		$operation_title = 'Update your file permissions';
		$direction = pick($_GET['direction'], 'private');
		$page->set('direction', $direction);
		$operation_json = array('method' => 's3-set-acl', 'set' => $direction);
		
		break;
	case 'contentdisposition':
		$operation_title = 'Set your Content Disposition headers';
		$operation_json = array('method' => 's3-set-contentdisposition');
		
		break;
}

$page->set('operation_json', $operation_json);
$page->set('operation_title', $operation_title);
$page->set('files', $files);

$return_url = pass_resolve($_GET['pass']);
if(empty($return_url)) $return_url = url('admin/list.files.php');
$page->set('return_url', $return_url);

if(empty($files)) redirect($return_url);

$page->title(array(pick($evp->settings->site_name, $evp->options->project_name), 'Files', $operation_title));

$page->css('styles/style.page.upload.copy.css');
$page->addEvent('onTemplateMerge', 'onTemplateMerge');
echo $page->parse();
?>