<?php
require('application.php');
require('application.bootstrap.php');
$page = new Page('files.page.php', 'master.php', array('theme' => $evp->settings->theme, 'version' => $evp->options->project_version));
$page->title(array(pick($evp->settings->site_name, $evp->options->project_name), 'Your Files', 'Create a Page'));
$xs->restrictTo(array('groups' => array('Administrators', 'Managers', 'Clients')), 'signin.php', array('return' => pass_create()), true);

// We ready for a file?
$id = escape(trim($_GET['id']));
if(empty($id)) {
	echo 'The file you requested could not be found!';
} else {
	// Grab the data
	$file = $evp->getFile($id);
	
	$file_ref = $file->id;
	
	// Get all the profiles
	$profiles = $evp->getProfiles($id);
	$profiles_simple = array('' => 'Default Profile');
	if(!empty($profiles)) {
		foreach($profiles as $p) {
			$profiles_simple[$p->id] = $p->name;
		}
	}
	
	// Profile info?
	$profile = makeSeed($_GET['profile']);
	if($profile == 'default') $profile = '';
	if(!empty($profile)) {
		$file_ref.= '::'.$profile;
	}
	
	// Let's get the embed code for this file
	$file_settings = $evp->collateFileSettings($file, $profile);
	
	// And expose
	$page->set(array(
		'profiles' => $profiles,
		'profiles_simple' => $profiles_simple,
		'profile' => $profile,
		'file' => $file,
		'file_settings' => $file_settings,
		'file_ref' => $file_ref
	));
}

// Any special things this page needs?
$page->css('styles/style.page.files.page.css');
$page->js('scripts/custom/evp-ties.js');
$page->js('scripts/libraries/moorainbow.js');
$page->js('scripts/libraries/scroll.js');

$page->js('scripts/libraries/jquery-1.5.1.min.js');
$page->js('jQuery.noConflict();');
$page->js('scripts/libraries/plupload/plupload.js');
$page->js('scripts/libraries/plupload/plupload.html5.js');

$page->css('scripts/libraries/cleditor/jquery.cleditor.css');
$page->js('scripts/libraries/cleditor/jquery.cleditor.min.js');

// And end!
$page->addEvent('onTemplateMerge', 'onTemplateMerge');
echo $page->parse();
?>