<?php
require('application.php');
require('application.bootstrap.php');
$page = new Page('files.settings.php', 'master.php', array('theme' => $evp->settings->theme, 'version' => $evp->options->project_version));
$page->title(array(pick($evp->settings->site_name, $evp->options->project_name), 'Your Files', 'Settings'));
$xs->restrictTo(array('groups' => array('Administrators', 'Managers', 'Clients')), 'signin.php', array('return' => pass_create()), true);

if($_GET['refresh_cache'] == 1) $evp->primeFileCache();

// We ready for a file?
$id = escape(trim($_GET['id']));
if(empty($id)) {
	echo 'The file you requested could not be found!';
} else {
	// Grab the data
	$file = $evp->getFile($id);

	$file_ref = $file->id;

	// Get all the profiles
	$profiles = $evp->getProfiles($id);
	$profiles_simple = array('' => 'Default Profile');
	if(!empty($profiles)) {
		foreach($profiles as $p) {
			$profiles_simple[$p->id] = $p->name;
		}
	}

	// Profile info?
	$profile = makeSeed($_GET['profile']);
	if($profile == 'default') $profile = '';
	if(!empty($profile)) {
		$file_ref.= '::'.$profile;
	}

	// Let's get the embed code for this file
//$file_settings = $evp->collateFileSettings($file, $profile);

	// And expose
	$page->set(array(
		'profiles' => $profiles,
		'profiles_simple' => $profiles_simple,
		'profile' => $profile,
		'file' => $file,
	//'file_settings' => $file_settings,
		'file_ref' => $file_ref
	));
}

// Any special things this page needs?
$page->css('styles/style.page.files.settings.css');
$page->css(url('player/assets/animate.css?v=1'));
$page->js('scripts/custom/evp-ties.js');
$page->js('scripts/libraries/moorainbow.js');
$page->js('scripts/libraries/scroll.js');

$page->js('scripts/libraries/jquery-1.5.1.min.js');
$page->js('jQuery.noConflict();');
$page->js('scripts/libraries/plupload/plupload.js');
$page->js('scripts/libraries/plupload/plupload.html5.js');
$page->css('scripts/libraries/cleditor/jquery.cleditor.css');
$page->js('scripts/libraries/cleditor/jquery.cleditor.min.js');

$page->js(array(
	'scripts/libraries/datepicker/Locale.en-US.DatePicker.js',
	'scripts/libraries/datepicker/Picker.js',
	'scripts/libraries/datepicker/Picker.Attach.js',
	'scripts/libraries/datepicker/Picker.Date.js',
	'scripts/libraries/datepicker/Picker.Date.Range.js',
	'scripts/libraries/datepicker/Picker.js'
));

$page->css('scripts/libraries/datepicker/datepicker.css');

// Expose a big styling for custom audio preview heights
$css = array();
foreach($evp->options->skins as $name => $d) {
	$take_up = $d['skin_height'] + $d['skin_audio_preview_extra'];
	$preview_height = round($take_up * 0.314815); // This is 170 / 540, which is the preview width as a percentage of the actual full-size image width
	$css[] = "#player-preview-area.player-preview-type-audio #player-preview[data-skin-slug=\"{$name}\"] #player-preview-frame { height: {$take_up}px; }";
	$css[] = "#player-preview-area.player-preview-type-audio #player-preview-skin.{$name} { height: {$take_up}px; }";
	$css[] = ".ui-settings-selector-skin-audio .skin-selector-skin#{$name} div.container { height: ".($preview_height)."px; }";
	$css[] = ".ui-settings-selector-skin-audio .skin-selector-skin#{$name} .skin-selector-screenshot { top: -".(88 - $preview_height)."px; }";
}
$page->css(implode("\n", $css));

// And end!
$page->addEvent('onTemplateMerge', 'onTemplateMerge');
echo $page->parse();
?>
