<?php
if(empty($_GET['profile'])) {
	header("Location: files.livestats.php?id={$_GET['id']}");
} else {
	header("Location: files.livestats.php?id={$_GET['id']}&profile={$_GET['profile']}");
}
exit;

require('application.php');
require('application.bootstrap.php');
$page = new Page('files.statistics.php', 'master.php', array('theme' => $evp->settings->theme, 'version' => $evp->options->project_version));
$page->title(array(pick($evp->settings->site_name, $evp->options->project_name), 'Your Files', 'Statistics'));
$xs->restrictTo(array('groups' => array('Administrators', 'Managers', 'Clients', 'Users')), 'signin.php', array('return' => pass_create()), true);

//$evp->primeFileCache(); // You can potentially come here from the Dashboard so this is important

// We ready for a file?
$id = escape(trim($_GET['id']));
if(empty($id)) {
	echo 'The file you requested could not be found!';
} else {
	// Grab the data
	$file = $evp->getFile($id);

	$file_ref = $file->id;

	// Get all the profiles
	$profiles = $evp->getProfiles($id);
	$profiles_simple = array('' => 'Default Profile');
	if(!empty($profiles)) {
		foreach($profiles as $p) {
			$profiles_simple[$p->id] = $p->name;
		}
	}

	// Profile info?
	$profile = makeSeed($_GET['profile']);
	if($profile == 'default') $profile = '';
	if(!empty($profile)) {
		$file_ref.= '::'.$profile;
	}

	// Let's get the embed code for this file
	$file_settings = $evp->collateFileSettings($file, $profile);

	// And expose
	$page->set(array(
		'profiles' => $profiles,
		'profiles_simple' => $profiles_simple,
		'profile' => $profile,
		'file' => $file,
		'file_settings' => $file_settings,
		'file_ref' => $file_ref
	));
}

// Any special things this page needs?
$page->css('styles/style.page.files.statistics.css');
$page->js('scripts/custom/evp-ties.js');
$page->js('https://www.gstatic.com/charts/loader.js');

// And end!
$page->addEvent('onTemplateMerge', 'onTemplateMerge');
echo $page->parse();
?>
