<?php
require('application.php');
require('application.bootstrap.php');
$page = new Page('list.files.php', 'master.php', array('theme' => $evp->settings->theme, 'version' => $evp->options->project_version));
$page->title(array(pick($evp->settings->site_name, $evp->options->project_name), 'Your Files'));
$xs->restrictTo(array('groups' => array('Administrators', 'Managers', 'Clients', 'Users')), 'signin.php', array('return' => pass_create()), true);

// Update the cached list
if($_GET['refresh_files'] == 1) {
	$evp->primeFileCache();
}

/*
if($evp->settings->use_cloudfront && !empty($evp->settings->cloudfront_distribution)) {
//$d = $evp->s3->remote->getDistribution($evp->settings->cloudfront_distribution);
	$d = $evp->s3->aws->cloudfront->get_distribution_info($evp->settings->cloudfront_distribution, array('Streaming' => ($evp->settings->use_cloudfront_std !== '1')));
	if($d->isOk()) {
		$page->set('distribution', $d->body);
	}
}
*/

// Fix any potentially broken folders
/*
$subfolders = getArray("SELECT `id`, `parent_id` FROM {$evp->options->prefix}folders WHERE `parent_id` IS NOT NULL");
$folders_raw = getArray("SELECT `id` FROM {$evp->options->prefix}folders");
$folders = array();
if(!empty($folders_raw)) $folders = flattenByKey($folders_raw, 'id');

if(!empty($subfolders)) {
	foreach($subfolders as $sf) {
		if(!in_array($sf->parent_id, $folders)) query("UPDATE {$evp->options->prefix}folders SET `parent_id` = NULL WHERE `id` = '{$sf->id}' LIMIT 1");
	}
}
*/

// Fix potentially broken file counters in a very efficient manner
$relations_raw = getArray("SELECT `folder_id`, `file_id` FROM {$evp->options->prefix}folders_relationships");
$files_raw = getArray("SELECT `id` FROM {$evp->options->prefix}files WHERE `parent_id` IS NULL");
$folders = array();
if(!empty($relations_raw)) {
	$folders = array_flip(array_unique(flattenByKey($relations_raw, 'folder_id')));
	foreach($relations_raw as $r) {
		if(!is_array($folders[$r->folder_id])) $folders[$r->folder_id] = array();
		$folders[$r->folder_id][] = $r->file_id;
	}
	
	foreach($folders as $folder_id => $rels) {
		$in = implode(array_wrap($rels, "'"), ',');
		$file_count = getRow("SELECT COUNT(f.id) AS c FROM {$evp->options->prefix}files f WHERE f.id IN({$in})");
		query("UPDATE {$evp->options->prefix}folders SET `file_count` = '{$file_count->c}' WHERE `id` = '{$folder_id}' LIMIT 1");
	}
}

function filesListIterateUserFolder($folder) {
	global $allClientsFolders;
	
	if(!empty($folder->subfolders)) {
		foreach($folder->subfolders as $f) {
			array_push($allClientsFolders, $f->id);
			filesListIterateUserFolder($f);
		}
	}

}

// Get the list of folders
$folders = $evp->getFoldersAsTree(true);

$initial_folder = 0;
if(!empty($_GET['id'])) $initial_folder = trim(strtolower($_GET['id']));

if($isClient) {
	$initial_folder = $xs->userData->assigned_folder_id[0];
	$allClientsFolders = $xs->userData->assigned_folder_id;
	
	foreach($folders as $idx => $folder) {
		if(!in_array($folder->id, $xs->userData->assigned_folder_id)) {
			unset($folders[$idx]);
		} else {
			filesListIterateUserFolder($folder); // Builds a flat list of all folders a client/user has access to
		}
	}
	
	$page->set('allClientsFolders', $allClientsFolders);
}

// And expose
$page->set(array(
	'folders' => $folders,
	'initial_folder' => $initial_folder
));

// Any special things this page needs?
$page->js('scripts/libraries/deviantmenu.js');
$page->js('scripts/libraries/History.js');
$page->css('styles/style.page.list.files.css');
$page->addEvent('onTemplateMerge', 'onTemplateMerge');
echo $page->parse();
?>