<?php
require('application.php');
require('application.bootstrap.php');
$page = new Page('list.playlists.php', 'master.php', array('theme' => $evp->settings->theme, 'version' => $evp->options->project_version));
$page->title(array(pick($evp->settings->site_name, $evp->options->project_name), 'Playlists'));
$xs->restrictTo(array('groups' => array('Administrators', 'Managers')), 'signin.php', array('return' => pass_create()), true);

if(!empty($_POST)) {
	
	if(!empty($_POST['id'])) { // We are editing, so let's delete the existing one
		$evp->deleteMySQLObject('playlists', $_POST['id']);
	}
	
	$obj = new Object(array(
		'id' => $_POST['id'],
		'name' => escape($_POST['name'], true),
		'list_position' => escape($_POST['list_position'], true),
		'files' => json_encode($_POST['files']),
		'labels' => json_encode($_POST['labels']),
		'descriptions' => json_encode($_POST['descriptions'])
	));
	
	$evp->insertMySQLObject('playlists', $obj);
	
	$page->set('newly', true);
	$page->set('newly_id', getInsertId());
	$page->set('newly_name', $obj->name);
}

// Get all playlists
$playlists = $evp->getPlaylists(true);

$page->set(array(
	'playlists' => $playlists
));

$page->js(array(
	'scripts/libraries/deviantmenu.js'
));

$page->addEvent('onTemplateMerge', 'onTemplateMerge');

echo $page->parse();
?>