<?php
require('application.php');
require('application.bootstrap.php');
$page = new Page('list.sitemaps.php', 'master.php', array('theme' => $evp->settings->theme, 'version' => $evp->options->project_version));
$page->title(array(pick($evp->settings->site_name, $evp->options->project_name), 'Sitemaps'));
$xs->restrictTo(array('groups' => array('Administrators', 'Managers')), 'signin.php', array('return' => pass_create()), true);

if(!empty($_POST)) {
	if(!empty($_POST['id'])) { // We are editing, so let's delete the existing one
		$evp->api->sitemaps_delete($_POST['id']);
	}
	
	$data = $_POST['data'];
	$data['files'] = $_POST['files'];
	
	$domain = trim(strtolower(escape($_POST['domain'], true)));
	if(strpos($domain, 'http') !== 0) {
		$domain = "http://{$domain}";
	}
	
	if(substr($domain, -1) !== '/') $domain.='/';
	
	if(!empty($data)) {
		foreach($data as $key => $array) {
			if($key == 'files' || !is_array($array)) continue;
			elseif($key == 'url') {
				foreach($array as $file_ref => &$value) {
					$value = str_replace($domain, '', $value); // Remove any included domains
					if(substr($value, 0, 1) == '/') $value = substr($value, 1); // Remove leading slashes
				}
			}
		}
	}
	
	$obj = new Object(array(
		'id' => $_POST['id'],
		'domain' => $domain,
		'data' => $data
	));
	
	$evp->insertMySQLObject('sitemaps', $obj);
	
	$page->set('newly', true);
	$page->set('newly_id', $obj->id);
	$page->set('newly_domain', $obj->domain);
}

// Get all sitemaps
$sitemaps = $evp->getSitemaps(true);

$page->set(array(
	'sitemaps' => $sitemaps
));

$page->js('scripts/libraries/deviantmenu.js');

$page->addEvent('onTemplateMerge', 'onTemplateMerge');
echo $page->parse();
?>