<?php
require('application.php');
require('application.bootstrap.php');
$page = new Page('list.splittests.php', 'master.php', array('theme' => $evp->settings->theme, 'version' => $evp->options->project_version));
$page->title(array(pick($evp->settings->site_name, $evp->options->project_name), 'Split Tests'));
$xs->restrictTo(array('groups' => array('Administrators', 'Managers')), 'signin.php', array('return' => pass_create()), true);

if(!empty($_POST)) {
	
	if(!empty($_POST['id'])) { // We are editing, so let's delete the existing one
		$evp->deleteMySQLObject('split_tests', $_POST['id']);
	}
	
	$obj = new Object(array(
		'id' => $_POST['id'],
		'name' => escape($_POST['name'], true),
		'date_created' => gmdate('Y-m-d H:i:s'),
		'files' => json_encode($_POST['files'])
	));
	
	if($_POST['use_metric'] == true) {
		$obj->date_ending = gmdate('Y-m-d H:i:s', strtotime($_POST['date_ending']));
		$obj->metric = escape($_POST['metric']);
	}
	
	$evp->insertMySQLObject('split_tests', $obj);
	
	$page->set('newly', true);
	$page->set('newly_id', getInsertId());
	$page->set('newly_name', $obj->name);
}

// Get all split tests
$split_tests = $evp->getSplitTests(true);

$page->set(array(
	'split_tests' => $split_tests
));

$page->js(array(
	'scripts/libraries/datepicker/Locale.en-US.DatePicker.js',
	'scripts/libraries/datepicker/Picker.js',
	'scripts/libraries/datepicker/Picker.Attach.js',
	'scripts/libraries/datepicker/Picker.Date.js',
	'scripts/libraries/datepicker/Picker.Date.Range.js',
	'scripts/libraries/datepicker/Picker.js',
	'scripts/libraries/deviantmenu.js'
));

$page->css('scripts/libraries/datepicker/datepicker.css');

$page->addEvent('onTemplateMerge', 'onTemplateMerge');
echo $page->parse();
?>