<?php
require('application.php');
require('application.bootstrap.php');

// Don't allow for non-Commercial people
if(!$evp->isCommercial()) redirect('admin/dashboard.php');

$page = new Page('list.users.php', 'master.php', array('theme' => $evp->settings->theme, 'version' => $evp->options->project_version));
$page->title(array(pick($evp->settings->site_name, $evp->options->project_name), 'Users'));
$xs->restrictTo(array('groups' => array('Administrators', 'Managers')), 'signin.php', array('return' => pass_create()), true);

// Get the list of folders cos we need it for assignment
$folders = getArray("SELECT f.id AS folder_id, f.name as folder_name, COUNT(DISTINCT r.file_id) AS folder_count FROM {$evp->options->prefix}folders f LEFT JOIN {$evp->options->prefix}folders_relationships r ON f.id = r.folder_id WHERE f.parent_id IS NULL GROUP BY folder_name");
if(!$folders) $folders = array();
$page->set('folders', $folders);

$response = '';

// Are we creating or editing?
if(!empty($_POST)) {
 $username = escape(trim($_POST['username']));
 $password = escape(trim($_POST['password']));
 $group = escape(trim($_POST['role']));
 
 $xs = Registry::retrieve('users');
	
	if(!empty($_POST['id'])) { // We are editing!

		// Does this person exist? If not, we're not editing
		$existing_user = $xs->getUser($_POST['id'], 'id');
		if(!$existing_user) {
			$response = '<p class="error">We cannot identify this user - please try editing again.</p>';
		} else {
			// Make sure the group exists
			$group_data = $xs->getGroup($group, 'name');
			if(!$group_data) {
				$seed = randomStr(15);
				query("INSERT INTO {$config['users']['prefix']}groups (`seed`, `name`) VALUES ('{$seed}', '{$group}')");
				$group_data = $xs->getGroup(getInsertId());
			}
			
			// Save the user himself
			// Are we resetting?
			if(empty($password)) {
				query("UPDATE {$config['users']['prefix']}users SET `username` = '{$username}' WHERE `id` = '{$existing_user->id}' LIMIT 1");
			} else {
				query("UPDATE {$config['users']['prefix']}users SET `username` = '{$username}', `password` = SHA1('{$password}') WHERE `id` = '{$existing_user->id}' LIMIT 1");
			}
			$user_data = $xs->getUser($_POST['id']);
			
			// Do we need to store any meta data such as their folder access?
			if($group == 'Users' || $group == 'Clients') {
				$folder_id = escape(encode($_POST['folder_id']));
				query("DELETE FROM {$config['users']['prefix']}users_data WHERE `key` = 'assigned_folder_id' && `user_id` = '{$user_data->id}'");
				query("INSERT INTO {$config['users']['prefix']}users_data (`user_id`, `key`, `value`) VALUES ('{$user_data->id}', 'assigned_folder_id', '{$folder_id}')");
			}
			
			// Add the relationship
			query("DELETE FROM {$config['users']['prefix']}users_relationships WHERE `user_id` = '{$user_data->id}'");
			query("INSERT INTO {$config['users']['prefix']}users_relationships (`user_id`, `group_id`) VALUES ('{$user_data->id}', '{$group_data->id}')");
			
			// And an alert!
			$response = '<div class="box auto"><div class="wrap"><div class="body">';
			$response.= '<p class="success">Congratulations! This user has been successfully modified. Here is a basic welcome email that you could send them, containing all their details!</p>';
			if(empty($password)) {
				$response.= "<textarea class=\"ui_code ui_clickselect ui_noresize margin-bottom\" style=\"width: 854px; height: 160px; font-size: 14px;\">Hi,\n\nYou have been granted access to {$evp->settings->site_name}!\n\nYou can sign in here: {$config['locations']['absolute']}\nYour username is: {$username}\nYour password has not been changed\n\nThanks,</textarea>";
			} else {
				$response.= "<textarea class=\"ui_code ui_clickselect ui_noresize margin-bottom\" style=\"width: 854px; height: 160px; font-size: 14px;\">Hi,\n\nYou have been granted access to {$evp->settings->site_name}!\n\nYou can sign in here: {$config['locations']['absolute']}\nYour username is: {$username}\nYour password is: {$password}\n\nThanks,</textarea>";
			}
			$response.= '</div></div></div>';
		}

	} else {
		// Does this user already exist? Usernames must be distinct so..
		$existing_user = $xs->getUser($username, 'username');
		if($existing_user) {
			$response = '<p class="error">An account with this username already exists; usernames must be unique! Please try again!</p>';
		} else {
			// Make sure the group exists
			$group_data = $xs->getGroup($group, 'name');
			if(!$group_data) {
				$seed = randomStr(15);
				query("INSERT INTO {$config['users']['prefix']}groups (`seed`, `name`) VALUES ('{$seed}', '{$group}')");
				$group_data = $xs->getGroup(getInsertId());
			}
			
			// Add the user himself
			$seed = randomStr(15);
			query("INSERT INTO {$config['users']['prefix']}users (`seed`, `username`, `password`) VALUES ('{$seed}', '{$username}', SHA1('{$password}'))");
			$user_data = $xs->getUser(getInsertId());
			
			// Do we need to store any meta data such as their folder access?
			if($group == 'Clients' || $group == 'Users') {
				$folder_id = escape(encode($_POST['folder_id']));
				query("INSERT INTO {$config['users']['prefix']}users_data (`user_id`, `key`, `value`) VALUES ('{$user_data->id}', 'assigned_folder_id', '{$folder_id}')");
			}
			
			// Add the relationship
			query("INSERT INTO {$config['users']['prefix']}users_relationships (`user_id`, `group_id`) VALUES ('{$user_data->id}', '{$group_data->id}')");
			
			// And an alert!
			$response = '<div class="box auto"><div class="wrap"><div class="body">';
			$response.= '<p class="success">Congratulations! This user has been successfully created. Here is a basic welcome email that you could send them, containing all their details!</p>';
			$response.= "<textarea class=\"ui_code ui_clickselect ui_noresize margin-bottom\" style=\"width: 854px; height: 160px; font-size: 14px;\">Hi,\n\nYou have been granted access to {$evp->settings->site_name}!\n\nYou can sign in here: {$config['locations']['absolute']}\nYour username is: {$username}\nYour password is: {$password}\n\nThanks,</textarea>";
			$response.= '</div></div></div>';
		}
	}
}

$page->set('response', $response);

// Get the actual list of all available users
$users = getArray("SELECT `id`, `username` FROM {$config['users']['prefix']}users ORDER BY `id` ASC");
// Get the data we need
$afi = getArray("SELECT `user_id`, `key`, `value` FROM {$config['users']['prefix']}users_data WHERE `key` = 'assigned_folder_id'");

foreach($users as $u) {
  $ug = $xs->getGroupsByUser($u->id);
  $u->group = grab($ug, 0);
  
  if(!empty($afi)) {
		foreach($afi as $i) {
			if($i->user_id == $u->id) $u->assigned_folder_id = $i->value;
		}
  }
  
  if($u->group->name == 'Users' || $u->group->name == 'Clients' && !empty($u->assigned_folder_id)) {
		$u->assigned_folder = $evp->getFolder($u->assigned_folder_id);
  } else {
		$u->assigned_folder = new Object(array('folder_id' => 0, 'folder_name' => 'Not applicable'));
  }
}

// Let's build the available counters of how many users can be made
$maxUsers = array(
	'Administrators' => 2,
	'Managers' => 3,
	'Clients' => 30,
	'Users' => 50
);

$availableUsers = array(
	'Administrators' => $maxUsers['Administrators'],
	'Managers' => $maxUsers['Managers'],
	'Clients' => $maxUsers['Clients'],
	'Users' => $maxUsers['Users']
);

if(!empty($users)) {
	foreach($users as $u) {
		$group_name = $u->group->name;
		$availableUsers[$group_name]--;
		if($availableUsers[$group_name] < 0) $availableUsers[$group_name] = 0;
	}
}

// Get the number of machines that this guy's key can be used for
$maxMachines = 5;

$page->set('users', $users);
$page->set('maxUsers', $maxUsers);
$page->set('availableUsers', $availableUsers);
$page->set('maxMachines', $maxMachines);

$page->addEvent('onTemplateMerge', 'onTemplateMerge');
echo $page->parse();
?>