<?php
require('application.php');
require('application.bootstrap.php');
$page = new Page('settings.php', 'master.php', array('theme' => $evp->settings->theme, 'version' => $evp->options->project_version));
$page->title(array(pick($evp->settings->site_name, $evp->options->project_name), 'Settings'));
$xs->restrictTo(array('groups' => array('Administrators')), 'signin.php', array('return' => pass_create()), true);

if($_GET['default_saved'] === 'success') {
	// This means we have done all the steps, so, enable default settings
	query("DELETE FROM {$evp->options->prefix}settings WHERE `name` = 'use_default_settings' LIMIT 1");
	query("INSERT INTO {$evp->options->prefix}settings (`name`, `value`) VALUES ('use_default_settings', '1')");
	$evp->setSettings($evp->options->prefix.'settings');
	$page->set('default_settings_success', true);
}

/*
if($_GET['cloudfront_refresh'] == '1' && $evp->cloudfront) {
	$d = $evp->s3->remote->getDistribution($evp->settings->cloudfront_distribution);
	if($d) {
		$evp->s3->remote->updateDistribution($d);
	}
}
*/

$settings_msg = pick(strip_tags($_GET['settings_msg']), '');
$settings_class = pick(strip_tags($_GET['settings_class']), '');

$page->set(array('settings_msg' => $settings_msg, 'settings_class' => $settings_class));

if(!empty($_POST)) {
	$hash = escape($_POST, true);
	
	// Password resetting?
	if($hash['settings_reset'] == 1 && !empty($hash['settings_reset_currentpassword']) && !empty($hash['settings_reset_newpassword1']) && !empty($hash['settings_reset_newpassword2'])) {
		// Is the current password correct?
		if(sha1(trim($hash['settings_reset_currentpassword'])) == $xs->userData->password) {
			$new_password1 = sha1(trim($hash['settings_reset_newpassword1']));
			$new_password2 = sha1(trim($hash['settings_reset_newpassword2']));
			
			if($new_password1 != $new_password2) {
				$settings_msg = 'Your two new passwords did not match. Please try again.';
				$settings_class = 'error';
			} else {
				query("UPDATE {$xs->options->prefix}users SET `password` = '{$new_password1}' WHERE `id` = '{$xs->userData->id}' LIMIT 1");
				redirect('signout.php', array('pass' => pass_create(url('admin/settings.php', array('settings_msg' => 'Your password has been reset successfully!', 'settings_class' => 'success')))));
			}
			
		} else {
			$settings_msg = 'Your current password was incorrect. Please try entering it again!';
			$settings_class = 'error';
		}
	}
	
	$use_s3_accesskey = ($hash['s3_edit'] == '1' && !empty($hash['s3_accesskey']) ? $hash['s3_accesskey'] : $evp->settings->s3_accesskey);
	$use_s3_secretkey = ($hash['s3_edit'] == '1' && !empty($hash['s3_secretkey']) ? $hash['s3_secretkey'] : $evp->settings->s3_secretkey);
	
	if($hash['s3_edit'] != '1' || (empty($hash['s3_accesskey']) || empty($hash['s3_secretkey']))) { // If we're not intentionally editing, don't modify them!
		unset($hash['s3_accesskey']);
		unset($hash['s3_secretkey']);
	}
	
	unset($hash['s3_edit']);

	// Using password emailing?
	if($hash['disable_password_email'] !== '1') $hash['disable_password_email'] = '0';
	
	// Disable S3?
	if($hash['use_s3'] != '1') $hash['use_s3'] = '0';
	
	// Turbo mode?
	if($hash['turbo'] != '1') $hash['turbo'] = '0';
	
	// Easy client desktop access?
	if($hash['client_desktop_easyaccess_disable'] != '1') $hash['client_desktop_easyaccess_disable'] = '0';
	
	// Disabling mod_rewrite?
	if($hash['mod_rewrite'] != '1') $hash['mod_rewrite'] = '0';
	
	// Disabling advanced stretching?
	if($hash['advanced_options_stretching'] != '1') $hash['advanced_options_stretching'] = '0';
	
	// Disabling the web uploader
	if($hash['enable_webuploader'] != '1') $hash['enable_webuploader'] = '0';
	
	// Disabling the 'powered by..' links
	if($hash['commercial_disablepoweredby'] != '1') $hash['commercial_disablepoweredby'] = '0';
	
	// Disabling the main logo?
	if($hash['commercial_disablelogo'] != '1') $hash['commercial_disablelogo'] = '0';
	
	// Are we disabling the default settings? If so, let's remove 'em
	if($hash['use_default_settings'] != '1') {
		$hash['use_default_settings'] = '0';
		query("DELETE FROM {$evp->options->prefix}files_data WHERE `file_id` = 'default'");
	}
	
	// CloudFront enabled?
	if($hash['use_cloudfront'] == '1') {
		
		// Work out the potential CloudFront mode here and initialise as necessary
		if($hash['use_cloudfront_std'] == '1') {
			$evp->s3 = new EVP_S3($use_s3_accesskey, $use_s3_secretkey, $hash['s3_bucket'], array('type' => 'STD'));
		} else {
			$hash['use_cloudfront_std'] = '0';
			$evp->s3 = new EVP_S3($use_s3_accesskey, $use_s3_secretkey, $hash['s3_bucket'], array('type' => 'RTMP'));
		}
		
		if(empty($hash['cloudfront_distribution'])) { // We need to create a new distribution			
		//$d = $evp->s3->remote->createDistribution($evp->settings->s3_bucket, true, array(), "Created by {$evp->options->project_name}: ".url());
			$d = $evp->s3->aws->cloudfront->create_distribution($evp->settings->s3_bucket, 'evs-'.time(), array('Streaming' => ($hash['use_cloudfront_std'] !== '1')));
			if($d->isOk()) {
				$hash['cloudfront_distribution'] = (string)$d->body->Id;
				$hash['cloudfront_domain'] = (string)$d->body->DomainName;
			} else { // Could not create the dist. - error is triggered - unset use_cloudfront
				$hash['use_cloudfront'] = '0';
			}
		} else { // Distribution exists already, so let's check its information
		//$d = @$evp->s3->remote->getDistribution($hash['cloudfront_distribution']);
			$d = $evp->s3->aws->cloudfront->get_distribution_info($hash['cloudfront_distribution'], array('Streaming' => ($hash['use_cloudfront_std'] !== '1')));
			
			if(!$d->isOk()) {
				$hash['use_cloudfront'] = '0';
				$hash['cloudfront_distribution'] = '';
				$hash['cloudfront_domain'] = '';
			} else {
				$hash['cloudfront_distribution'] = (string)$d->body->Id;
				$hash['cloudfront_domain'] = (string)$d->body->DomainName;
				// And update it, too
			//$evp->s3->remote->updateDistribution($d);
			}
		}
	} else { // It's disabled, so let's just stop using it
		$hash['use_cloudfront'] = '0';
	}
	
	$originally_using_cloudfront = ($evp->settings->use_cloudfront == '1');
	
	// Rewrite settings
	foreach($hash as $name => $value) {
		if(is_array($value)) {
			$value = array_empty($value);
			$value = array_unique($value);
			$value = escape(encode($value), true);
		}
		
		$value = trim($value);
		
		query("DELETE FROM {$evp->options->prefix}settings WHERE `name` = '{$name}' LIMIT 1");
		
		if(strlen($value) > 0) {
			query("INSERT INTO {$evp->options->prefix}settings (`name`, `value`) VALUES ('{$name}', '{$value}')");
		}
	}
	
	if($hash['use_s3'] == '1') { // Obviously, nothing matters if they're not using S3!
		if($originally_using_cloudfront && $hash['use_cloudfront'] == '0') { // They WERE using it but now aren't
			// set to private
			redirect('admin/files.permissions.php', array('direction' => 'private', 'pass' => pass_create()));
		} elseif(!$originally_using_cloudfront && $hash['use_cloudfront'] == '1') { // Weren't but now ARE
			// set to public
			redirect('admin/files.permissions.php', array('direction' => 'public', 'pass' => pass_create(url('admin/settings.php', array('cloudfront_refresh' => '1')))));
		}
	}
	
	if(empty($settings_class)) $settings_class = 'success';
	if(empty($settings_msg)) $settings_msg = 'Your settings have been saved successfully!';
	
	redirect('admin/settings.php', array('settings_msg' => $settings_msg, 'settings_class' => $settings_class));
}

if($evp->settings->use_cloudfront && !empty($evp->settings->cloudfront_distribution)) {
//$d = $evp->s3->remote->getDistribution($evp->settings->cloudfront_distribution);
	$d = $evp->s3->aws->cloudfront->get_distribution_info($evp->settings->cloudfront_distribution, array('Streaming' => ($evp->settings->use_cloudfront_std !== '1')));
	if($d->isOk()) {
		$page->set('distribution', $d->body);
	}
}

$page->addEvent('onTemplateMerge', 'onTemplateMerge');
echo $page->parse();
?>