<?php
require('application.php');
require('application.bootstrap.php');

$page = new Page('sites.videomap.php', 'master.php', array('theme' => $evp->settings->theme, 'version' => $evp->options->project_version));
$page->title(array(pick($evp->settings->site_name, $evp->options->project_name), 'Sites', 'Video map'));
$xs->restrictTo(array('groups' => array('Administrators', 'Managers')), 'signin.php', array('return' => pass_create()), true);

$no_image = url('player/images/no-image.png?v=1', false, true);
$data = array();
$videoStack = array();
$videoData = array();
$tinyVideoData = array();
$export = array();

// First thing's first; let's grab all of the unique sites that we have
$sites = flattenByKey(getArray("SELECT DISTINCT `referrer` FROM {$evp->options->prefix}track_total_completes"), 'referrer');
foreach($sites as $k => $site) if(empty($site)) unset($sites[$k]);

// Now, let's get the videos from each site
foreach($sites as $site) {
//$videos = flattenByKey(getArray("SELECT DISTINCT `file_ref` FROM {$evp->options->prefix}track_total_completes WHERE `referrer` = '{$site}' ORDER BY COUNT(DISTINCT `file_ref`) DESC LIMIT 30"), 'file_ref');
	$videos = flattenByKey(getArray("SELECT `file_ref` FROM {$evp->options->prefix}track_total_completes WHERE `referrer` = '{$site}' GROUP BY `file_ref` ORDER BY COUNT(DISTINCT `file_ref`) DESC LIMIT 30"), 'file_ref');
	$data[$site]['videos'] = $videos;
	$videoStack = $videoStack + $videos;
}

// Now remove duplicates from $videoStack
$videoStack = array_unique($videoStack);

// And iterate videoData, to get their info, and then repopulate it
foreach($videoStack as $file_ref) {
	$video = $evp->getFile($file_ref);
	if(!$video) return;
	$video->thumbnails = array();
	if(!empty($video->thumbnail_count)) {
		for($thumbnail_i = 0; $thumbnail_i <= ($video->thumbnail_count - 1); $thumbnail_i++) {
			$video->thumbnails[] = str_replace('.'.$video->extension, '', $video->raw_location).'-thumbnail-'.$thumbnail_i.'.jpg';
		}
	}
	$videoData[$file_ref]['file'] = $video;
	$videoData[$file_ref]['stats'] = $evp->statistics->getStaticStats($file_ref);
	$videoData[$file_ref]['thumbnail'] = pick($video->thumbnails[0], url('player/images/no-image.png?v=1', false, true));

	$tinyVideoData[$file_ref]['thumbnail'] = $videoData[$file_ref]['thumbnail'];
	$tinyVideoData[$file_ref]['name'] = string_trim(pick($videoData[$file_ref]['file']->name, $videoData[$file_ref]['file']->file_name, base64_decode($file_ref), 'Unknown'), 20);
	$tinyVideoData[$file_ref]['stats'] = $videoData[$file_ref]['stats'];
	$tinyVideoData[$file_ref]['thumbnail_width'] = 71;
	$tinyVideoData[$file_ref]['thumbnail_height'] = 40;
	if($tinyVideoData[$file_ref]['thumbnail_width'] == $no_image) {
		$tinyVideoData[$file_ref]['thumbnail_width'] = 49;
		$tinyVideoData[$file_ref]['thumbnail_height'] = 40;
	}

	$referrers = getArray("SELECT COUNT(`ip`) AS total, `referrer` FROM {$evp->options->prefix}track_total_completes WHERE `file_ref` = '{$file_ref}' GROUP BY `referrer`");
	if(!empty($referrers)) foreach($referrers as $r) if(!empty($r->referrer)) $tinyVideoData[$file_ref]['stats']->referrers[$r->referrer] = $r->total;
}

// And now, let's fill this out as a honking great JSON array
foreach($sites as $site) {
	$export[$site] = array(
		'name' => $site,
		'videos' => $data[$site]['videos']
	);
}

// And let's sort them
function _videomapsort($a, $b) {
	$x = sizeof($a['videos']);
	$y = sizeof($b['videos']);
	if($x == $y) return 0;
	return ($x > $y) ? -1 : 1;
}
usort($export, '_videomapsort');

/* echo debug($tinyVideoData); */

$page->set('sites', $sites);
$page->set('data', $data);
$page->set('videoStack', $videoStack);
$page->set('videoData', $videoData);
$page->set('export', $export);
$page->set('tinyVideoData', $tinyVideoData);
$page->set('no_image', $no_image);

// Custom things here
$page->js('https://www.gstatic.com/charts/loader.js');

$page->addEvent('onTemplateMerge', 'onTemplateMerge');
echo $page->parse();
?>
