<?php
require('application.php');
require('application.bootstrap.php');
$page = new Page('split.statistics.php', 'master.php', array('theme' => $evp->settings->theme, 'version' => $evp->options->project_version));
$page->title(array(pick($evp->settings->site_name, $evp->options->project_name), 'Split Test'));
$xs->restrictTo(array('groups' => array('Administrators', 'Managers')), 'signin.php', array('return' => pass_create()), true);

// Get the split test
$split_test = $evp->getSplitTest($_GET['id']);

if(!$split_test) {
	redirect('admin/list.splittests.php');
}

$split_test->realFiles = array();

foreach($split_test->files as $fid) {
	$file = $evp->getFile($fid);
	$profile = grab(explode('::', $fid, 2), 1);
	$file->stats = $evp->statistics->getStats($fid);
	$social_stats = $evp->getDataKey('stats', $fid, 'files');
	if(!empty($social_stats)) $social_stats = @json_decode($social_stats);
	$file->social_stats = $social_stats;
	$split_test->realFiles[$fid] = $file;
}

$page->set(array(
	'split_test' => $split_test
));

$page->css('styles/style.page.split.statistics.css');
$page->js('https://www.gstatic.com/charts/loader.js');

$page->addEvent('onTemplateMerge', 'onTemplateMerge');
echo $page->parse();
?>
