<?php include($themePath.'/include.notifications.php'); ?>

<?php
// Include the walkthrough for hosted customers!
if($xs->userData->id == 1 && $xs->userData->evs_tour_105 != 1 && $evp->options->hosted == true) {
	include($themePath.'/include.walkthrough.php');
	$xs->insertDataKey('evs_tour_105', 1, $xs->userData->id, 'user');
}
?>

<!-- BUFFER -->

<script type="text/javascript">
/* EVS PHP conversion */
function createDatesArray(days) {
	var output = [];

	var month = date('m');
	var day = date('d');
	var year = date('Y');

	for(i = 1; i <= days; i++) {
		output.push(date('Y-m-d', mktime(0, 0, 0, month, (day - i), year)));
	}

	return output;
}

function secondsToHMS(sec, showHours, padHours) {
  var hours_min_secs = '';
  var hours = parseInt(parseInt(sec) / 3600);
  var hours_min_secs = hours_min_secs + (padHours) ? str_pad(hours, 2, '0', 'STR_PAD_LEFT') + ':' : hours + ':';
  if(showHours != false && hours <= 0) hours_min_secs = '';
  var minutes = parseInt((sec / 60) % 60);
  var hours_min_secs = hours_min_secs + str_pad(minutes, 2, '0', 'STR_PAD_LEFT') + ':';
  var seconds = parseInt(sec % 60);
  var hours_min_secs = hours_min_secs + str_pad(seconds, 2, '0', 'STR_PAD_LEFT');
  return hours_min_secs;
}

function buildChart(chart, data, container, opts) {
	var dims = container.measure(function() {
		return this.getSize();
	});

	var opts = Object.merge({
		'backgroundColor': '#fafafa',
		'width': dims.x,
		'height': dims.y,
		'legend': {
			'position': 'right'
		}
	}, opts || {});

	chart.draw(data, opts);
}

google.charts.load('current', {'packages':['corechart']});
google.charts.setOnLoadCallback(function() {
	// Placeholders
	var placeholder = {
		"progression": {
			"0": 0,
			"1": 0,
			"2": 0,
			"3": 0,
			"4": 0,
			"5": 0,
			"6": 0,
			"7": 0,
			"8": 0,
			"9": 0,
			"10": 0
		},
		"time": {
			"dates": [],
			"months": {
				"January": 0,
				"February": 0,
				"March": 0,
				"April": 0,
				"May": 0,
				"June": 0,
				"July": 0,
				"August": 0,
				"September": 0,
				"October": 0,
				"November": 0,
				"December": 0
			},
			"days": {
				"Monday": 0,
				"Tuesday": 0,
				"Wednesday": 0,
				"Thursday": 0,
				"Friday": 0,
				"Saturday": 0,
				"Sunday": 0
			},
			"hours": {
				"0": 0,
				"1": 0,
				"2": 0,
				"3": 0,
				"4": 0,
				"5": 0,
				"6": 0,
				"7": 0,
				"8": 0,
				"9": 0,
				"10": 0,
				"11": 0,
				"12": 0,
				"13": 0,
				"14": 0,
				"15": 0,
				"16": 0,
				"17": 0,
				"18": 0,
				"19": 0,
				"20": 0,
				"21": 0,
				"22": 0,
				"23": 0,
				"24": 0
			}
		}
	};

	var previous_days = createDatesArray(6);
	placeholder.time.dates[date('Y-m-d')] = 0;
	Object.each(previous_days, function(d) {
		placeholder.time.dates[d] = 0;
	});

	var buildTextualStats = function(response) {
		$$('span.livestat-basic-plays').set('text', response.stats.static.starts || 0);
		$$('span.livestat-basic-completions').set('text', response.stats.static.completes || 0);
		var completionPercentage = 0;
		if(response.stats.static.starts > 0) completionPercentage = ((response.stats.static.completes >= 1) ? Math.ceil((response.stats.static.completes / response.stats.static.starts) * 100) : 0);
		$$('span.livestat-basic-completionpercentage').set('text', completionPercentage+'%');
		$$('span.livestat-basic-totalsales').set('text', response.stats.total_sales || 0);
		$$('span.livestat-basic-totalincome').set('text', '$'+number_format((response.stats.total_income || 0), 2));

		$$('span.livestat-basic-dropoff').set('text', response.average_drop_off_str || 'Unknown');

		// Do the Videolytics graph
		(function() {
			var ve_x = 0;
			var duration = parseFloat((response.file.metadata || {}).duration || 10);
			var secondsAsPixels = (90 / duration);
			ve_x = Math.round(secondsAsPixels * response.average_drop_off);
			if(ve_x >= 84) ve_x = 84;

			$$('.stats-effectiveness-bar-single div').tween('left', ve_x);
			$$('.stats-effectiveness-grid .drop').tween('left', (ve_x > 84 ? 84 : (ve_x - 12)));
		})();
	}

	var buildThisWeek = function(response) {
		if(!response.stats.recent) return;

		var viewDates = {};
		var playDates = {};
		var saleDates = {};

		var container = $('live-chart-thisweek');
		var raw = [['Date', 'Plays', 'Completed plays', 'Sales']];

		Object.each(placeholder.time.dates, function(value, date) {
			viewDates[date] = (response.stats.recent[date] || {}).starts;
			if(!viewDates[date]) viewDates[date] = value;

			playDates[date] = (response.stats.recent[date] || {}).completes;
			if(!playDates[date]) playDates[date] = value;

			saleDates[date] = (response.stats.recent[date] || {}).sales;
			if(!saleDates[date]) saleDates[date] = value;

			viewDates[date] = parseInt(viewDates[date]);
			playDates[date] = parseInt(playDates[date]);
			saleDates[date] = parseInt(saleDates[date]);
		});

		viewDates = ksort(viewDates); // Reverse so that the oldest date is to the left
		playDates = ksort(playDates);
		saleDates = ksort(saleDates);

		var i = 0;

		Object.each(viewDates, function(value, date) {
			var label = date;
			if(i == 6) label = 'Today';
			else if(i == 5) label = 'Yesterday';
			else label = Date.parse(label).format('%e%o of %b');
			raw.push([label, value, playDates[date], saleDates[date]]);
			i++;
		});

		var data = google.visualization.arrayToDataTable(raw);
		var chart = new google.visualization.AreaChart(container);
		buildChart(chart, data, container, {'vAxis': {'viewWindow': {'min': 0}}, 'chartArea': {'width': '75%'}, 'legend': {'position': 'top'}});
	}

	var buildProgression = function(response) {
		if(!response.stats.progression) return;

		var container = $('live-chart-progression');
		var raw = [['Time', 'Viewers engaged']];
		interval = (parseInt((response.file.metadata || {}).duration || 10) / 10); // Interval in seconds

		Object.each(placeholder.progression, function(h, player_time) {
			var label;
			if(player_time == '0') label = 'Start';
			else if(player_time == '10') label = 'Complete';
			else label = secondsToHMS(Math.ceil(interval * player_time));

			raw.push([
				label,
				parseInt(response.stats.progression[player_time] || h)
			]);
		});

		var data = google.visualization.arrayToDataTable(raw);
		chart = new google.visualization.AreaChart(container);
		buildChart(chart, data, container, {'vAxis': {'viewWindow': {'min': 0}}, 'chartArea': {'width': '75%'}, 'legend': {'position': 'none'}});
	}

	if($('dashboard-analytics-folders')) {
		var addFileOpt = function(name, id, el) {
			var n = (name.length >= 45 ? name.substr(0, 40)+'...' : name);
			new Element('option', {
				'value': id,
				'label': n,
				'text': n
			}).inject(el);
		}

		var xhr = new Request.JSON({
			'url': '<?php echo url('api.php'); ?>',
			'onRequest': function() {
				$('dashboard-analytics-files').spin();
			},
			'onSuccess': function(response) {
				$('dashboard-analytics-files').unspin();
				$('dashboard-analytics-files').empty();
				var sel = new Element('select', {'styles': {'width': '118px'}});
				if(response && response.files) {
					Object.each(response.files, function(file, idx) {
						addFileOpt(file.name, file.id, sel);
						Object.each(file.profiles, function(profile) {
							addFileOpt('&nbsp;&raquo;&nbsp;'+profile.name, profile.id, sel);
						});
					});
				}
				sel.inject($('dashboard-analytics-files')).setData('behavior', 'SelectBox');
				new Behavior().apply($('dashboard-analytics-files'));
				var s = $('dashboard-analytics-files').getElement('select').addEvent('change', showStats.pass([{}], $('dashboard-analytics-files').getElement('select')));
				<?php if($account_stats->total_files > 0) : ?>
				s.fireEvent('change');
				<?php endif; ?>
			},
			'onFailure': function() {
				$('dashboard-analytics-files').unspin();
			}
		});

		var stats_xhr = new Request.JSON({
			'url': '<?php echo url('api.php'); ?>',
			'onRequest': function() {
				$('dashboard-select').spin();
			//if($('dashboard-analytics').getStyle('display') == 'block') $$('.dashboard-analytics-graph').spin();
			},
			'onSuccess': function(response) {
				$('dashboard-select').unspin();
			//$$('.dashboard-analytics-graph').unspin();

				var name = response.file.name;
				if(name.length > 50) name = name.substr(0, 50)+'&hellip;';

				if($('dashboard-analytics-more')) $('dashboard-analytics-more').removeEvents('click').addEvent('click', function() { window.url('files.livestats.php?id='+response.file_id+'&profile='+(response.file_profile || '')); });
				if($('dashboard-analytics-title')) $('dashboard-analytics-title').set('html', name);
				buildProgression(response);
				buildThisWeek(response);
				buildTextualStats(response);
			},
			'onFailure': function() {
				$('dashboard-select').unspin();
			//$$('.dashboard-analytics-graph').unspin();
			}
		});

		var showStats = function(event) {
			var file_ref = this.get('value');

			$$('.dashboard-analytics').unspin();

			if(!file_ref) {
			 $$('.dashboard-analytics').spin({'class': 'spinner spinner-nospin', 'message': 'There are no videos in this folder to display stats for! Choose a different folder on the right!'});
				return;
			}



		//$('dashboard-analytics').reveal();
		//$('dashboard-quick-stats').reveal();

			if(typeof event !== 'undefined' && event !== false) {
				stats_xhr.send({
					'method': 'post',
					'data': {
						'username': '<?php echo $xs->userData->username; ?>',
						'password': '<?php echo $xs->userData->password; ?>',
						'method': 'files-livestats',
						'file_id': file_ref
					}
				});
			}
		};

		$('dashboard-analytics-folders').addEvent('change', function() {
			var folder = this.get('value');
			xhr.send({
				'method': 'post',
				'data': {
					'username': '<?php echo $currentUser->username; ?>',
					'password': '<?php echo $currentUser->password; ?>',
					'method': 'files-list',
					'getProfiles': true,
					'folder_id': folder
				}
			});
		});
	}

	(function() {
		var response = {"file": <?php echo json_encode($latest_file); ?>, "stats": <?php echo json_encode($latest_file_stats); ?>};
		buildProgression(response);
		buildThisWeek(response);
	})();


	EVP_Help.setContext({
		'content': '<p>The Dashboard is a great place to get a quick overview of all of the most important statistics for your videos.</p><p>Locate a video in the &quot;Select a video to see stats&quot; section and the stats will update live!</p>',
		'video': 'basic-dashboard.mp4'
	});

	if($('upload-basic-choice')) {
		$('upload-basic-choice').addEvent('click', window.url.pass('upload.php#upload-choice-basic'));
	}

	if($('upload-import-choice')) {
		$('upload-import-choice').addEvent('click', window.url.pass('upload.php#upload-choice-import'));
	}

	if($('upload-advanced-choice')) {
		$('upload-advanced-choice').addEvent('click', window.url.pass('upload.php#upload-choice-advanced'));
	}

});

window.addEvent('load', function() {
	(function() {
		if($('dashboard-analytics-folders')) $('dashboard-analytics-folders').fireEvent('change');

		<?php if($account_stats->total_files == 0) : ?>
		$$('.dashboard-analytics').spin({'class': 'spinner spinner-nospin', 'message': 'Stats will be available after you upload your videos!'});
		(function() {
			var w = $('live-chart-thisweek');
			w.empty();
			new Element('img', {
				'src': '<?php echo url('admin/chart.php', array('width' => '405', 'height' => '220', 'type' => 'date_stats')); ?>&id=demo'
			}).inject(w);
		})();

		(function() {
			var w = $('live-chart-progression');
			w.empty();
			new Element('img', {
				'src': '<?php echo url('admin/chart.php', array('width' => '405', 'height' => '220', 'type' => 'progression')); ?>&id=demo'
			}).inject(w);
		})();
		<?php endif; ?>

	}).delay(500);
});
</script>

<div class="self-clear">
	<div class="align-left margin-right dashboard-main">
		<?php include($themePath.'/include.infuse.php'); ?>
	</div>

	<div class="align-left dashboard-sidebar">
		<div class="box alt ui-stats-pad-small"><div class="wrap self-clear auto">
			<h2>Account stats</h2>
			<div class="stats-box" id="dashboard-account-stats">
				<div class="stats-box-icon stats-box-videos">
					<strong>Total videos</strong>
					<span><?php echo $account_stats->total_files; ?></span>
				</div>
				<div class="stats-box-icon stats-box-sites">
					<strong>Embedded on</strong>
					<span><?php echo $account_stats->total_sites; ?> sites</span>
				</div>
				<div class="stats-box-icon stats-box-folders">
					<strong>Total folders</strong>
					<span><?php echo $account_stats->total_folders; ?></span>
				</div>
				<div class="stats-box-icon stats-box-completions">
					<strong>Total plays</strong>
					<span><?php echo number_format($account_stats->total_starts); ?></span>
				</div>
				<div class="stats-box-icon stats-box-income">
					<strong>Total income</strong>
					<span><?php echo $evp->options->currency_symbol; ?><?php echo formatPrice($account_stats->total_income); ?></span>
				</div>
			</div>
		</div></div>
	</div>

	<?php
	$upload_show_apps = !($evp->settings->client_desktop_easyaccess_disable && $isClient);
	$upload_show_advanced = ($evp->s3 || $evp->local);

	if($upload_show_apps && $upload_show_advanced) :
	?>
		<div class="clear box" id="dashboard-upload"><div class="wrap self-clear auto">
			<div id="dashboard-upload-choice" class="self-clear">
				<?php if($upload_show_apps) : ?>
				<div class="upload-choice-pane" id="upload-basic-choice">
					<img src="<?php echo assets('assets/graphics/upload-basic.png?v=5'); ?>" />
					<center><div data-behavior="Button" data-button-width="140" data-button-type="action_small">Download your apps</></center>
				</div>
				<?php endif; ?>

				<div class="upload-choice-pane" id="upload-import-choice">
					<img src="<?php echo assets('assets/graphics/upload-import.png?v=5'); ?>" />
					<center><div data-behavior="Button" data-button-width="140" data-button-type="action_small">Import from the web</div></center>
				</div>

				<?php if($upload_show_advanced) : ?>
					<div class="upload-choice-pane" id="upload-advanced-choice">
						<img src="<?php echo assets('assets/graphics/upload-advanced.png?v=5'); ?>" />
						<center><div data-behavior="Button" data-button-width="140" data-button-type="action_small">Manually upload videos</div></center>
					</div>
				<?php endif; ?>
			</div>
		</div></div>
	<?php endif; ?>

	<div class="align-left margin-right dashboard-main">
		<?php if(!$isClient) : ?>
			<div id="dashboard-quick-stats">
				<?php if(!empty($latest_file)) : ?>
					<div class="box alt clear ui-stats-pad-small"><div class="wrap self-clear auto dashboard-analytics">
						<?php
						$ve_x = 0;
						if(empty($latest_file->metadata['duration']) || $latest_file->metadata['duration'] == 0) $latest_file->metadata['duration'] = 1;
						$secondsAsPixels = (90 / $latest_file->metadata['duration']);
						$ve_x = round($secondsAsPixels * $latest_average_drop_off);
						if($ve_x >= 84) $ve_x = 84;
						?>
						<h2 style="position:relative;">Quick stats: <span id="dashboard-analytics-title"><?php echo string_trim($latest_file->name, 50); ?></span><input type="button" href="files.livestats.php?id=<?php echo $latest_file_ref; ?>" data-behavior="Button" rel="Click here to get full Analytics for your videos!" data-button-width="120" data-button-type="action_small" id="dashboard-analytics-more" value="Get more stats" /></h2>
						<div class="stats-box">
							<div class="stats-box-icon stats-box-videos">
								<strong>Effectiveness</strong>
								<div class="stats-effectiveness-bar-single">
									<div class="ui-gradient ui-gradient-black" style="left: <?php echo $ve_x; ?>px;"></div>
								</div>
							</div>
							<div class="stats-box-icon stats-box-videos">
								<strong>Drop-off time</strong>
								<span class="livestat livestat-basic-dropoff"><?php echo secondsToHMS($latest_average_drop_off); ?></span>
							</div>
							<div class="stats-box-icon stats-box-completion-percentage">
								<strong>Completion %</strong>
								<span class="livestat livestat-basic-completionpercentage"><?php echo ($latest_file_stats->static->starts > 0 && $latest_file_stats->static->completes > 0 ? ceil(($latest_file_stats->static->completes / $latest_file_stats->static->starts) * 100) : 0); ?>%</span>
							</div>
						</div>

						<div class="stats-box">
							<div class="stats-box-icon stats-box-starts">
								<strong>Starts</strong>
								<span class="livestat livestat-basic-plays"><?php echo number_format($latest_file_stats->static->starts); ?></span>
							</div>
							<div class="stats-box-icon stats-box-completions">
								<strong>Completions</strong>
								<span class="livestat livestat-basic-completions"><?php echo number_format($latest_file_stats->static->completes); ?></span>
							</div>
							<div class="stats-box-icon stats-box-sales">
								<strong>Total sales</strong>
								<span class="livestat livestat-basic-totalsales"><?php echo number_format($latest_file_stats->total_sales); ?></span>
							</div>
						</div>

						<p class="text-align-center margin-bottom" style="margin-top:30px;">The total income from your video is: <span style="color:#4A84CB;">$<?php echo formatPrice($latest_file_stats->total_income); ?></span></p>
					</div></div>
				<?php endif; ?>
			</div>
		<?php endif; ?>

		<div class="clear margin-top"></div>
	</div>

	<div class="align-left dashboard-sidebar">
		<?php if(!$isClient) : ?>
		<div class="box alt clear" id="dashboard-select"><div class="wrap auto">
			<h2>Select a video to see stats</h2>
			<div style="padding:0 10px 10px 13px;overflow:auto;">
				<div class="align-left" style="position:relative;top:6px;"><img src="<?php echo assets('assets/icons-custom/dashboard-folder.png?v=1'); ?>" /></div>
				<div class="align-left margin-left margin-bottom" style="width:220px;">
					<select id="dashboard-analytics-folders" data-behavior="SelectBox" style="width:118px;">
						<?php
						function lf($folder, $depth = 0) {
							echo '<option value="'.$folder->id.'">'.(str_repeat('&nbsp;-&nbsp;', $depth)).$folder->name.'</option>';
							if($folder->id != 0 && !empty($folder->subfolders)) {
								foreach($folder->subfolders as $sf) {
									lf($sf, $depth+1);
								}
							}
						}
						if(!empty($folders_list)) {
							foreach($folders_list as $folder) {
								lf($folder);
							}
						}
						?>
					</select>
				</div>
				<div class="clear"></div>
				<div class="align-left margin-right" style="position:relative;top:6px;"><img src="<?php echo assets('assets/icons-custom/dashboard-video.png?v=1'); ?>" /></div>
				<div class="align-left" id="dashboard-analytics-files" style="width:220px;"></div>
			</div>
			<div class="clear"></div>
		</div></div>
		<?php endif; ?>

		<?php if(!$isClient) : ?>
			<?php if($popular) : ?>
				<div class="box alt" id="dashboard-popular"><div class="wrap auto self-clear">
					<h2 style="font-size:16px;">Your most popular file</h2>
					<p class="text-align-centre"><?php echo $popular->name; ?></p>
					<ul>
						<li><a href="<?php echo url('files.embed.php', array('id' => $popular->id, 'profile' => $profile), false); ?>"><img data-behavior="BetterTip" data-tip-direction="6" data-tip-width="120" data-tip-class="centre" rel="Get your embed code" src="<?php echo assets('assets/icons/large-magnify.png'); ?>" alt="" /></a></li>
						<li><a href="<?php echo url('files.settings.php', array('id' => $popular->id, 'profile' => $profile), false); ?>"><img data-behavior="BetterTip" data-tip-direction="6" data-tip-width="120" data-tip-class="centre" rel="Modify your video settings" src="<?php echo assets('assets/icons/large-wrench.png'); ?>" alt="" /></a></li>
						<li><a href="<?php echo url('files.timeline.php', array('id' => $popular->id, 'profile' => $profile), false); ?>"><img data-behavior="BetterTip" data-tip-direction="6" data-tip-width="120" data-tip-class="centre" rel="Add Events to your video Timeline" src="<?php echo assets('assets/icons/large-timeline.png'); ?>" alt="" /></a></li>
						<li><a href="<?php echo url('files.livestats.php', array('id' => $popular->id, 'profile' => $profile), false); ?>"><img data-behavior="BetterTip" data-tip-direction="6" data-tip-width="120" data-tip-class="centre" rel="View your statistics" src="<?php echo assets('assets/icons/large-stats.png'); ?>" alt="" /></a></li>
						<li style="margin-right:0;"><a href="<?php echo $popular->location; ?>"><img src="<?php echo assets('assets/icons/large-download.png'); ?>" alt="" data-behavior="BetterTip" data-tip-direction="6" data-tip-width="120" data-tip-class="centre" rel="Download your video file" /></a></li>
					</ul>
				</div></div>
			<?php else : ?>
				<div class="box alt" id="dashboard-popular"><div class="wrap auto self-clear">
					<h2 style="font-size:16px;">Your most popular file</h2>
					<?php if($account_stats->total_files > 0) : ?>
						<p class="text-align-centre">Your most popular video cannot be determined yet!</p>
					<?php else : ?>
						<p class="text-align-centre">No videos have been uploaded yet!</p>
					<?php endif; ?>
					<ul>
						<li><a><img data-behavior="BetterTip" data-tip-direction="6" data-tip-width="120" data-tip-class="centre" rel="Get your embed code" src="<?php echo assets('assets/icons/large-magnify.png'); ?>" alt="" /></a></li>
						<li><a><img data-behavior="BetterTip" data-tip-direction="6" data-tip-width="120" data-tip-class="centre" rel="Modify your video settings" src="<?php echo assets('assets/icons/large-wrench.png'); ?>" alt="" /></a></li>
						<li><a><img data-behavior="BetterTip" data-tip-direction="6" data-tip-width="120" data-tip-class="centre" rel="Add Events to your video Timeline" src="<?php echo assets('assets/icons/large-timeline.png'); ?>" alt="" /></a></li>
						<li><a><img data-behavior="BetterTip" data-tip-direction="6" data-tip-width="120" data-tip-class="centre" rel="View your statistics" src="<?php echo assets('assets/icons/large-stats.png'); ?>" alt="" /></a></li>
						<li style="margin-right:0;"><a><img src="<?php echo assets('assets/icons/large-download.png'); ?>" alt="" data-behavior="BetterTip" data-tip-direction="6" data-tip-width="120" data-tip-class="centre" rel="Download your video file" /></a></li>
					</ul>
				</div></div>
			<?php endif; ?>
		<?php endif; ?>
	</div>

</div>

<?php if(!$isClient) : ?>
<div id="dashboard-analytics" class="self-clear" style="position:relative;">
	<div class="box column alt"><div class="wrap auto dashboard-analytics dashboard-analytics-graph">
		<h2>Weekly analytics</h2>
		<div id="live-chart-thisweek" class="live-chart" style="height:230px;"></div>
	</div></div>

	<div class="box alt column"><div class="wrap auto dashboard-analytics dashboard-analytics-graph">
		<h2>Viewer engagement</h2>
		<div id="live-chart-progression" class="live-chart" style="height:230px;"></div>
	</div></div>
</div>
<?php endif; ?>
