<!-- BUFFER -->

<script type="text/javascript">
window.addEvent('domready', function() {
	<?php include($config['locations']['themePath'].'include.attach.php'); ?>
	
	<?php include($config['locations']['themePath'].'include.metadata.php'); ?>
	
	EVP_Help.setContext({
		'content': '<p>A Profile allows you to store different settings and statistics for a single video, without needing to upload it multiple times.</p><p>You can select a Profile from the list of existing ones, or create a new one by clicking the button.</p><p>Profiles are not shared between videos!</p>'
	});
	
	var widget = new WidgetisedArea('<?php echo $page->getWidget('files.livestats'); ?>', {'file_id': '<?php echo $file->id; ?>'}, {
		'animate': <?php echo boolToString(!isset($_GET['profile'])); ?>,
		'spin': $('profile-selector').getElement('.wrap'),
		'update': $('profile-selector'),
		'update-method': 'replace',
		'animation': 'slide',
		'onSuccess': function() {
			if($('breadcrumbs')) $('breadcrumbs').setStyles({'display': 'block'});
		}
	});
	
	var new_profile = new Request.JSON({
		'url': '<?php echo url('admin/xhr.php'); ?>',
		'method': 'post',
		'onRequest': function() {
			$('profile-selector-new').spin({'msg': 'Creating...'});
		},
		'onSuccess': function(response) {
			$('profile-selector-new').unspin();
			var opt = new Element('option', {'value': response.file_ref, 'text': response.profile, 'selected': true});
			$('profile-select').adopt(opt);
			$('profile-selector-options').setStyles({'display': 'block', 'opacity': 0}).fade('in');
		}
	});
	
	var delete_profile = new Request.JSON({
		'url': '<?php echo url('admin/xhr.php'); ?>',
		'method': 'post',
		'onRequest': function() {
			$('profile-selector-delete').spin({'msg': 'Deleting...'});
		},
		'onSuccess': function(response) {
			$('profile-selector-delete').unspin();
		}
	});
	
	var rename_profile = new Request.JSON({
		'url': '<?php echo url('admin/xhr.php'); ?>',
		'method': 'post',
		'onRequest': function() {
			$('profile-selector-rename').spin({'msg': 'Renaming...'});
		},
		'onSuccess': function(response) {
			$('profile-selector-rename').unspin();
		}
	});
	
	var duplicate_profile = new Request.JSON({
		'url': '<?php echo url('admin/xhr.php'); ?>',
		'method': 'post',
		'onRequest': function() {
			$('profile-selector-duplicate').spin({'msg': 'Duplicating...'});
		},
		'onSuccess': function(response) {
			var opt = new Element('option', {'value': response.file_ref, 'text': response.profile, 'selected': true});
			$('profile-selector-options').setStyles({'display': 'block', 'opacity': 0}).fade('in');
			$('profile-select').adopt(opt);
			$('profile-selector-duplicate').unspin();
		},
		'onFailure': function() {
			$('profile-selector-duplicate').unspin();
			StickyWin.alert('Error!', 'Unfortunately this Profile could not be duplicated with that name. Please make sure not to enter a name that already exists on this video.');
		}
	});
	
	$('profile-selector-new').addEvent('click', function() {
		StickyWin.prompt('Create a Profile', 'Please enter a name for this Profile:', function(profile_name) {
			if(!profile_name) return;
			new_profile.send({'method': 'post', 'data': {'method': 'files_profile_new', 'file_id': $('thisFile').retrieve('file_id'), 'profile': profile_name}});
		}, {
			'relativeTo': $('profile-selector-profile')
		});
	});
	
	$('profile-selector-delete').addEvent('click', function() {
		var sel = $('profile-select');
		var el = sel.getElements('option')[sel.selectedIndex];
		var profile = el.get('value');
		var name = el.get('text');
		StickyWin.confirm('Are you sure?', 'Do you really want to delete this Profile? All the settings and statistics will be removed. Any video embedded with this active will stop working!', function() {
			delete_profile.send({'method': 'post', 'data': {'method': 'files_profile_delete', 'file_id': $('thisFile').retrieve('file_id'), 'profile': name}});
			el.kill();
		});
	});
	
	$('profile-selector-rename').addEvent('click', function() {
		var sel = $('profile-select');
		var el = sel.getElements('option')[sel.selectedIndex];
		var profile = el.get('value');
		var name = el.get('text');
		StickyWin.prompt('Rename a Profile', '<span style="color:red;">Warning:</span> If you rename a Profile, any videos using it will need to be re-embedded!', function(profile_name) {
			el.set('text', profile_name);
			el.set('value', $('thisFile').retrieve('file_id')+'::'+profile_name.makeSeed());
			rename_profile.send({'method': 'post', 'data': {'method': 'files_profile_rename', 'file_id': $('thisFile').retrieve('file_id'), 'profile': name, 'new_name': profile_name}});
		}, {'defaultValue': name});
	});
	
	$('profile-selector-duplicate').addEvent('click', function() {
		var sel = $('profile-select');
		var el = sel.getElements('option')[sel.selectedIndex];
		var profile = el.get('value');
		var name = el.get('text');
		StickyWin.prompt('Dupicate a Profile', '<span style="color:red;">Warning:</span> You must not enter a name that conflicts with an existing Profile!', function(profile_name) {
			duplicate_profile.send({'method': 'post', 'data': {'method': 'files_profile_duplicate', 'file_id': $('thisFile').retrieve('file_id'), 'source_profile': profile, 'target_profile': profile_name}});
		}, {'defaultValue': name});
	});
	
	$('profile-select').addEvent('click', function() {
		var profile = this.getElements('option')[this.selectedIndex].get('value');
		if(profile == '') {
			$('profile-selector-options').fade('out');
		} else {
			$('profile-selector-options').setStyles({'display': 'block', 'opacity': 0}).fade('in');
		}
	});
	
	$('profile-selector-options').setStyle('display', 'none'); // Hide by default
	
	$('profile-selector-select').addEvent('click', function() {
		var sel = $('profile-select');
		if(sel.selectedIndex == -1) {
			StickyWin.alert('Profiles', 'Please select a Profile from the list first!');
			return false;
		}
		var profile = sel.getElements('option')[sel.selectedIndex].get('value');
		widget.start({'profile': profile});
	});
	
	<?php if(empty($file->metadata)) : ?>
		$('profile-selector').setStyles({'display': 'block'}).spin({
			'message': 'Gathering your metadata...'
		});
		
		// After 3 seconds, change the message, as the wait is now like 5 seconds
		(function() {
			$('profile-selector').getNext('.spinner').getElement('.spinner-msg').set('text', 'Finalising & saving your metadata...');
		}).delay(5000);
		
		window.evpMetaDataReady = function() {
			$('profile-selector').unspin();
			<?php if(isset($_GET['profile'])) : ?>
			widget.start({'profile': '<?php echo $profile; ?>'});
			<?php endif; ?>
		}
	<?php elseif(isset($_GET['profile'])) : ?>
		widget.start({'profile': '<?php echo $profile; ?>'});
	<?php else : ?>
		if($('breadcrumbs')) $('breadcrumbs').setStyles({'display': 'block'});
		$('profile-selector').setStyles({'display': 'block'});
	<?php endif; ?>
});
</script>

<?php /* This is here for storing all of the settings in a global way. Nice. */ ?>
<div id="thisFile"></div>

<?php /* Breadcrumb navigation here */ ?>
<div class="breadcrumbs" id="breadcrumbs" style="display:none;">
	<div data-behavior="Grid" data-grid-padding="10">
		<div data-column-width="170">
			<a id="ui-breadcrumbs-back" href="<?php echo url('list.files.php', false, false); ?>" data-behavior="Button" data-button-icon="back" data-button-iconpos="left" data-button-width="90">Back</a>
		</div>
		<div data-column-width="580"></div>
		<div data-column-width="150">
			<a id="ui-breadcrumbs-files-embed" href="<?php echo url('files.embed.php', array('id' => $_GET['id'], 'profile' => $_GET['profile']), false); ?>" data-behavior="Button" data-button-icon="forward" data-button-iconpos="right" data-button-width="110">Embed code</a>
		</div>
	</div>
	<div class="clear"></div>
</div>

<div class="box" id="profile-selector"><div class="wrap">
	<div class="box-option" id="profile-selector-profile" style="width:840px;">
		<h2>Select the Profile for the video "<?php echo $file->name; ?>"</h2>
		<p style="text-align:center;">Every video Profile maintains it's own separate statistics. Select or create a Profile below.</p>
		<div style="width:600px;margin:0 auto;">
			<?php echo build_select('profile-select', '', $profiles_simple, '', false, array('style' => 'width:600px;', 'size' => 4)); ?>
			<div class="align-right margin-top">
				<input type="button" data-behavior="Button" data-button-icon="" data-button-width="50" value="Select" id="profile-selector-select" />
			</div>
			<div class="align-right margin-top">
				<input class="align-left margin-right" type="button" data-behavior="Button" data-button-type="action" data-button-icon="plus" data-button-width="110" value="New Profile" id="profile-selector-new" />
			</div>
			<div class="align-left margin-top">
				<input class="align-left margin-right" type="button" data-behavior="Button" data-button-type="action" data-button-icon="grid" data-button-width="90" value="Duplicate" id="profile-selector-duplicate" />
				<div id="profile-selector-options" class="align-left">
					<input class="align-left margin-right" type="button" data-behavior="Button" data-button-type="action" data-button-icon="grid" data-button-width="80" value="Rename" id="profile-selector-rename" />
					<input class="align-left" type="button" data-behavior="Button" data-button-type="action" data-button-icon="delete" data-button-width="80" value="Delete" id="profile-selector-delete" />
				</div>
			</div>
		</div>
	</div>
</div></div>