<!-- BUFFER -->

<div id="storage"></div>

<style type="text/css">
#files tbody tr td { vertical-align: top; padding: 7px 4px 14px 4px; }
</style>

<script type="text/javascript">
window.addEvent('domready', function() {

	EVP_Help.setContext({
		'content': '<p>You can create folders and subfolders on the left, and drag and drop all your videos into them to organise them!</p><p><em>Hint</em>: You can double-click on a File or Folder to rename it!</p>',
		'video': 'basic-files.mp4'
	});

	<?php if($xs->isMemberOf($xs->userData->id, 'Users') || $xs->isMemberOf($xs->userData->id, 'Clients')) : ?>
	// We are a client, so let's store the folders they have access to for later
	$('storage').store('thisUserFolders', <?php echo json_encode($allClientsFolders); ?>);
	<?php endif; ?>

	// Resize depending on the height of the screen
	var screen_height = $(window).getSize().y;
	$$('.tableContainer, .tableContainer tbody.scrollContent, #list_folders > ul').each(function(el) {
		var current = $(el).getSize().y;
		var real = screen_height * 0.2 + current;
		if(real >= 500) $(el).setStyle('height', real);
	});

	$('list_files').addEvent('click:relay(.ui-link-remotelayer)', function() {
		var file_id = this.getParent('tr').getData('file-id');
		StickyWin.prompt('Enter a URL', 'Enter almost any URL below and you\'ll be taken to a page with your video overlaid on the other site! This feature is SUPER rough right now. If the page doesn\'t load up, you cannot do anything about it as the owner has prevented it from being loaded in a frame. Sorry!', function(url) {
			var layer = '<?php echo url('v/'); ?>'+file_id+'/'+base64_encode(url)+'/';
			StickyWin.alert('Done!', 'Looks great. You can share this URL around!<br /><input type="text" value="'+layer+'" style="float:left;margin:10px 10px 0 0;width:178px;" /><div style="float:left;position:relative;top:15px;"><a href="'+layer+'" target="_blank" data-behavior="Button" data-button-type="action_small" data-button-width="40">View</a></div>');
			new Behavior().apply(document.body); // Re-apply!
		});
	});

	// Let's see if this works
	var hovering = [];
	$('list_files').addEvents({
		'mouseenter:relay(tr)': function() {
			var file_id = this.getData('file-id');
			hovering[file_id] = true;
			var tsel = this.getElement('.thumbnail-cycle');
			if(tsel && tsel.retrieve('ThumbnailCycle')) {
				(function() {
					if(hovering[file_id] === true) tsel.retrieve('ThumbnailCycle').start();
				}).delay(600);
			}
		},
		'mouseleave:relay(tr)': function() {
			hovering[this.getData('file-id')] = false;
			var tsel = this.getElement('.thumbnail-cycle');
			if(tsel && tsel.retrieve('ThumbnailCycle')) {
				tsel.retrieve('ThumbnailCycle').stop();
			}
		}
	});

	// Drag/drop of files into folders
	$('list_files').getElement('tbody').addEvent('mousedown:relay(.ui-move)', function(event) {
  event.stop();
  if(event.rightClick) return false;

  var clone_text = [];
  var file_ids = [];
		var shirt = [this.getParent('tr')];
		var checked = $('list_files').getElements('tbody input[type="checkbox"]:checked');

		if(checked.length > 0) {
			checked.each(function(el) {
				var tr = el.getParent('tr');
				shirt.push(tr);
				clone_text.push(tr.getData('file-name'));
				file_ids.push(tr.getData('file-id'));
			});
		} else {
			var tr = this.getParent('tr');
			shirt.push(tr);
			clone_text.push(tr.getData('file-name'));
			file_ids.push(tr.getData('file-id'));
		}

		clone_text = clone_text.join(', ');
		shirt = shirt.unique();
		file_ids = file_ids.unique();

	//$('player-preview-bar').tween('background-color', '#DCEDF2');

  var clone = new Element('div', {
			'class': 'ui-file-clone',
			'html': '<p>'+clone_text+'</p>'
		}).setStyles(shirt[0].getCoordinates()).setStyles({
    'opacity': 0.7,
    'position': 'absolute'
  }).inject(document.body);

  var drag = new Drag.Move(clone, {
			'droppables': $('list_folders').getElements('li[data-folder-id]'),
   'onDrop': function(dragging, cart) {
   	dragging.destroy();
    if (cart != null) {
					// Do the Ajax
					new Request({
						'link': 'ignore',
						'url': '<?php echo url('admin/xhr.php'); ?>',
						'onRequest': function() {
							cart.spin();
						},
						'onSuccess': function() {
							// Remove the original file
							$$(shirt).kill(function() {
								cart.unspin();
							});

							// Animations etc
							cart.highlight('#7389AE', '#E6EDF3');

							// Decrease the counter in the current folder
							var old_counter = $('list_folders').getElement('.current .folder-counter span');
							if(old_counter) {
								old_counter.set('text', parseInt(old_counter.get('text')) - shirt.length);
							}

							// Increase the file counter in the new folder
							var new_counter = $('list_folders').getElement('li[data-folder-id="'+cart.getData('folder-id')+'"] .folder-counter span');
							if(new_counter) {
								new_counter.set('text', parseInt(new_counter.get('text')) + shirt.length);
							}
						}
					}).send({
						'method': 'post',
						'data': {
							'method': 'file_setfolder',
							'file_id': file_ids,
							'folder_id': cart.getData('folder-id')
						}
					});
    } else {
					$('list_folders').getElements('li').setStyle('background-color', '');
				}
			},
   'onEnter': function(dragging, cart) {
				cart.tween('background-color', '#98B5C1');
   },
   'onLeave': function(dragging, cart) {
				cart.tween('background-color', '#E6EDF3');
   },
   'onCancel': function(dragging) {
    dragging.destroy();
   }
  });
  drag.start(event);
 });

	// Refresh the list of files
	var list_files = new Request.JSON({
		'url': '<?php echo url('admin/xhr.php'); ?>',
		'method': 'post',
		'link': 'cancel',
		'onSuccess': function(response) {
			activateFolderLinks();
			$('list_files').unspin();
			var parent = $('list_files').getElement('table tbody');

			var firstTime = false;
			if(parent.match(':empty')) firstTime = true;

			parent.empty();

			var reposition = (Browser.Engine.gecko);

			if(response && response.files.length > 0) {
				for(i = 0; response.files[i]; i++) {
					var obj = response.files[i];

					var display_name = obj.name;
					if(obj.name.length > 50) display_name = display_name.substring(0, Math.min(50,obj.name.length))+'..';//obj.name.wordwrap(58, '<br />', true);

					var html = '<td style="width:15px;"><input type="checkbox" data-id="'+obj.id+'" /></td>';

					// Thumbnail
					html+= '<td>';
					html+= '<div style="position:relative;'+(reposition ? 'top:-10px;' : '')+'">';
					if(obj.hasIntro === true) {
						html+= '<img src="<?php echo assets('assets/icons-custom/thumbnail-intro.png?v=3'); ?>" class="thumbnail-intro" />';
					}
					if(obj.hasOutro === true) {
						html+= '<img src="<?php echo assets('assets/icons-custom/thumbnail-outro.png?v=3'); ?>" class="thumbnail-outro" />';
					}
					if(obj.thumbnail_count && parseInt(obj.thumbnail_count) >= 0) {
						html+= '<div class="ui-move" data-behavior="ThumbnailCycle" data-thumbnailcycle-base="'+obj.location+'" data-thumbnailcycle-length="'+obj.thumbnail_count+'"  data-thumbnailcycle-width="110" data-thumbnailcycle-height="62"></div>';
					} else if(obj.source == 3) {
					//html+= '<div class="thumbnail-cycle" style="overflow:hidden;"><img src="https://img.youtube.com/vi/'+obj.location.split('?')[1].parseQueryString().v+'/0.jpg" style="width:80px;margin-top:-8px;" /></div>';
						html+= '<div class="ui-move" data-behavior="ThumbnailCycle" data-thumbnailcycle-noprefix="true" data-thumbnailcycle-base="https://img.youtube.com/vi/'+obj.location.split('?')[1].parseQueryString().v+'/0.jpg" data-thumbnailcycle-extension="jpg" data-thumbnailcycle-speed="250" data-thumbnailcycle-length="4"  data-thumbnailcycle-width="110" data-thumbnailcycle-height="62"></div>';
					} else {
						var thumb_type = 'local';
						if(obj.source == 2) thumb_type = 's3';
						else if(obj.source == 3) thumb_type = 'youtube';
						else if(obj.source == 4) thumb_type = 'remote';
						html+= '<div class="ui-move" data-behavior="ThumbnailCycle" data-thumbnailcycle-base="<?php echo assets('assets/icons-custom/'); ?>no-thumbnail-'+(thumb_type)+'.png" data-thumbnailcycle-extension="png" data-thumbnailcycle-speed="250" data-thumbnailcycle-length="4"  data-thumbnailcycle-width="110" data-thumbnailcycle-height="62"></div>';
					}
					html+= '</div>';
					html+= '</td>';

					html += '<td><div style="position:relative;width:100%;height:100%;">';
					html += '<a class="inline-rename">'+display_name+'</a>'+(obj.hd == true ? '<img src="<?php echo assets('assets/icons/hd.png'); ?>" alt="HD" class="ui-file-hd" />' : '');
					html += '<div class="rollover">';

					<?php if($xs->isMemberOf($xs->userData->id, 'Users')) : ?>
						html += '<a href="files.metadata.php?id='+obj.id+'&redirect='+encodeURIComponent('admin/files.embed.php?id='+obj.id)+'" class="ui-link-code">Embed</a> | ';
						html += '<a href="'+obj.location+'" target="_blank" class="ui-link-download">Download</a> | ';
						html += '<a href="files.livestats.php?id='+obj.id+'" class="ui-link-stats">Stats</a>';
					<?php else : ?>
						html += '<a href="files.settings.php?id='+obj.id+'" class="ui-link-settings">Settings</a> | ';
						html += '<a href="files.timeline.php?id='+obj.id+'" class="ui-link-timeline">Timeline</a> | ';
						html += '<a href="files.page.php?id='+obj.id+'" class="ui-link-page">Pages</a> | ';
						html += '<a href="files.livestats.php?id='+obj.id+'" class="ui-link-stats">Stats</a> | ';
						html += '<a href="'+obj.location+'" target="_blank" class="ui-link-download">Download</a> | ';
					//html += '<a class="ui-link-remotelayer"">Layer</a> | ';
						html += '<a href="files.metadata.php?id='+obj.id+'&redirect='+encodeURIComponent('admin/files.embed.php?id='+obj.id)+'" class="ui-link-code">Embed</a> | ';
						html += '<a class="ui-link-delete" data-trigger="files-delete" data-files-delete-options="{\'spin\': \'! tr\', \'file_id\': \''+obj.id+'\', \'file_name\': \''+obj.name+'\', \'showConfirm\': true, \'confirmMessage\': \'Do you want to delete {name}?\', \'xhr\': \'<?php echo url('api.php'); ?>\', \'xhr_username\': \'<?php echo $currentUser->username; ?>\', \'xhr_password\': \'<?php echo $currentUser->password; ?>\'}">Delete</a>';
					<?php endif; ?>

					html += '</div></div></td>';
					html += '<td>'+obj.prettyTime+'</td>';
					html += '<td>'+(obj.source == 3 || obj.source == 4 ? '-' : obj.prettySize)+'</td>';
				//html += '<td>'+obj.prettyType+' ('+obj.extension+')</td>';
				//html += '<td>'+obj.prettyType+'</td>';
					html += '<td style="text-align:center;">';
					html += '<a href="'+obj.location+'" target="_blank">';
						if(obj.source == 1) {
							html += '<img src="<?php echo assets('assets/icons-custom/source-local.png?v=1'); ?>" class="ui-source" data-behavior="BetterTip" data-tip-direction="6" data-tip-width="120" data-tip-class="centre" rel="Hosted on your server" />';
						} else if(obj.source == 2 && <?php echo (isset($distribution) && (string)$distribution->Status == 'Deployed' ? 'true' : 'false'); ?>) {
							html += '<img src="<?php echo assets('assets/icons-custom/source-s3.png'); ?>" class="ui-source" data-behavior="BetterTip" data-tip-direction="6" data-tip-width="120" data-tip-class="centre" rel="Hosted on Amazon CloudFront" />';
						} else if(obj.source == 2) {
							html += '<img src="<?php echo assets('assets/icons-custom/source-s3.png'); ?>" class="ui-source" data-behavior="BetterTip" data-tip-direction="6" data-tip-width="120" data-tip-class="centre" rel="Hosted on Amazon S3" />';
						} else if(obj.source == 3) {
							html += '<img src="<?php echo assets('assets/icons-custom/source-youtube.png?v=2'); ?>" class="ui-source" data-behavior="BetterTip" data-tip-direction="6" data-tip-width="120" data-tip-class="centre" rel="Hosted on YouTube" />';
						} else if(obj.source == 4) {
							html += '<img src="<?php echo assets('assets/icons-custom/source-remote.png?v=2'); ?>" class="ui-source" data-behavior="BetterTip" data-tip-direction="6" data-tip-width="120" data-tip-class="centre" rel="Hosted on a remote server" />';
						}
					html += '</a>';
					html += '</td>';

					var tr = new Element('tr', {
						'html': html
					}).setData('file-name', obj.name).setData('file-id', obj.id);

					parent.adopt(tr);
				}
			} else if(typeof response.folder.name == 'undefined' && response.folder == '0') {
				parent.adopt(new Element('tr', {
					'html': '<td colspan="6" class="ui-files-empty">The Uncategorised folder has no files in it! Please select a folder from the list to the left.</td>'
				}));
			} else if(typeof response.folder.name == 'undefined') {
				parent.adopt(new Element('tr', {
					'html': '<td colspan="6" class="ui-files-empty">The folder that you specified cannot be found. Please select another one from the list to the left.</td>'
				}));
			} else {
				parent.adopt(new Element('tr', {
					'html': '<td colspan="6" class="ui-files-empty">There are no files in the \''+response.folder.name+'\' folder!</td>'
				}));
			}

			new Behavior().apply(parent);
		}
	});

	var changeFolder = window.changeFolder = function(folder_id) {
		<?php if($xs->isMemberOf($xs->userData->id, 'Users') || $xs->isMemberOf($xs->userData->id, 'Clients')) : ?>
		// Verify this person has access to this folder id!
		var allowed = $('storage').retrieve('thisUserFolders');
		if(allowed.indexOf(''+folder_id) == -1) return false;
		<?php endif; ?>

		// Yes, they do - carry on!
		var folder_id = folder_id || 0;
		$('storage').store('currentFolder', folder_id);

		var folder_el = $('list_folders').getElements('li.current').removeClass('current');
		var folder_el = $('list_folders').getElement('li[data-folder-id="'+folder_id+'"]');

		if(folder_el) {
			folder_el.addClass('current');
		}

		list_files.send({
			'method': 'post',
			'data': {
				'method': 'list_files',
				'folder': folder_id
			}
		});
	};

	$('list_folders').addEvent('dblclick:relay(.inline-rename)', function() {
		var el = $(this);

		var before = el.get('html').trim();

		el.set('html','');

		if(el.hasClass('textarea')) {
			var input = new Element('textarea', {'class': 'box', 'text': before});
		} else {
			var input = new Element('input', {'class': 'box', 'value': before});
			input.addEvent('keydown', function(e) { if(e.key == 'enter') { this.fireEvent('blur'); } });
		}

		input.inject(el).select();

		// On blur, save
		input.addEvent('blur', function() {
			val = input.get('value').trim();
			el.set('text', val).addClass(val != '' ? '' : 'editable-empty');

			// Save
			new Request({
				'link': 'ignore',
				'url': '<?php echo url('admin/xhr.php'); ?>'
			}).send({
				'method': 'post',
				'data': {
					'method': 'folder_rename',
					'folder_id': el.getParent('li').getData('folder-id'),
					'name': el.get('text')
				}
			});
		});
	});

	$('list_files').addEvent('dblclick:relay(.inline-rename)', function() {
		var el = $(this);

		var before = el.get('text').trim();

		el.set('html','');

		if(el.hasClass('textarea')) {
			var input = new Element('textarea', {'class': 'box', 'text': before});
		} else {
			var input = new Element('input', {'styles': {'width': '300px'}, 'class': 'box', 'value': before});
			input.addEvent('keydown', function(e) { if(e.key == 'enter') { this.fireEvent('blur'); } });
		}

		input.inject(el).select();

		// On blur, save
		input.addEvent('blur', function() {
			val = input.get('value').trim();
			el.set('text', val).addClass(val != '' ? '' : 'editable-empty');

			// Save
			new Request({
				'link': 'ignore',
				'url': '<?php echo url('admin/xhr.php'); ?>'
			}).send({
				'method': 'post',
				'data': {
					'method': 'file_rename',
					'file_id': el.getParent('tr').getData('file-id'),
					'name': el.get('text')
				}
			});
		});
	});

	if($('rename')) {
		$('rename').addEvent('click', function() {
			var selected_files = $('list_files').getElements('tbody input[type="checkbox"]:checked');
			if(selected_files.length == 1) {
				var the_id = $('list_files').getElement('tbody input[type="checkbox"]:checked').getData('id');
				var el = $('list_files').getElement('[data-file-id="'+the_id+'"]');
				if(!el) return false;

				StickyWin.prompt('Enter a new name', 'Please enter the name you would like to use below.', function(new_name) {

					// Set the name
					el.getElement('.inline-rename').set('text', new_name);

					// Save
					new Request({
						'link': 'ignore',
						'url': '<?php echo url('admin/xhr.php'); ?>'
					}).send({
						'method': 'post',
						'data': {
							'method': 'file_rename',
							'file_id': the_id,
							'name': new_name
						}
					});
				}, {'defaultValue': el.getElement('.inline-rename').get('text')});
			} else if(selected_files.length > 1) {
				StickyWin.alert('Just the one!', 'You can only rename one file at a time.<br /><br /><em>Hint!</em> You can rename files quicker by double-clicking on their name in the list!');
			} else {
				StickyWin.alert('Pick a file', 'Please check the box next to a file to rename it.<br /><br /><em>Hint!</em> You can also double-click on the name of a file in the list to rename it even quicker!');
			}
		});
	}

	var deleteFolder = function(folder_id) {

		var folder_el = $('list_folders').getElement('li[data-folder-id="'+folder_id+'"]');

		var xhr = new Request({
			'link': 'ignore',
			'url': '<?php echo url('admin/xhr.php'); ?>',
			'method': 'post',
			'onRequest': function() {
				folder_el.unspin().spin({'msg': 'Deleting...'});
			},
			'onSuccess': function(response) {
				folder_el.unspin();
				changeFolder(0);
			}
		});

		xhr.send({
			'method': 'post',
			'data': {
				'method': 'folder_delete',
				'folder_id': folder_id
			}
		});
	};

	$('list_folders').addEvent('click:relay(.folder-delete)', function(event) {
		if(event) event.stop();
		var folder_id = this.getParent('div').getData('folder-id');
		deleteFolder(folder_id);
	});

	var activateFolderLinks = function() {
		if($('list_folders').retrieve('activatedLinks') === true) return false;

		$('list_folders').store('activatedLinks', true).addEvent('click:relay(li[data-folder-id])', function(event) {
		//if(event) event.stop();
			var li = this;//.getParent('li');
			var folder_id = li.getData('folder-id');

			var shouldClose = true;
			if($(event.target) && ($(event.target).get('tag') == 'input' || $(event.target).get('tag') == 'span')) shouldClose = false;

			var sub = li.getElement('ul:not(:empty)');

			if(sub) {
				if(sub.getStyle('display') == 'none') {
					li.addClass('active');
					li.getElement('.ui-triangle').set('class', 'ui-triangle ui-triangle-down');
					changeFolder(folder_id);
					sub.reveal();
					li.addClass('expanded');
				} else if(shouldClose) {
					li.removeClass('active');
					li.getElement('.ui-triangle').set('class', 'ui-triangle ui-triangle-right');
					sub.dissolve();
					li.removeClass('expanded');
				} else {
					changeFolder(folder_id);
					li.addClass('expanded');
				}
			} else {
				changeFolder(folder_id);
				li.removeClass('expanded');
			}
		});
	}

	$('list_folders').getElements('.folder-name').each(function(el) {
		var li = el.getParent('li');
		var sub = li.getElement('ul');
		if(li && sub && sub.getElement('li')) {
			li.getElement('.ui-triangle').setStyle('cursor', 'pointer');
			sub.dissolve();
		}
	});

	$('list_folders').addEvent('mousedown:relay(li span.folder-drag)', function(event) {
  event.stop();
  if(event.rightClick) return false;

		var shirt = this.getParent('li');

  var clone = new Element('div', {
			'class': 'ui-file-clone',
			'html': '<p>Folder: '+shirt.getElement('.folder-name').get('text')+'</p>'
		}).setStyles(shirt.getCoordinates()).setStyles({
    'opacity': 0.7,
    'position': 'absolute'
  }).inject(document.body);

  var droppables = $('list_folders').getElements('li[data-folder-id]');

  var drag = new Drag.Move(clone, {
			'droppables': droppables,
   'onDrop': function(dragging, cart) {
   	dragging.destroy();
    if (cart != null && cart.getData('folder-id') != shirt.getData('folder-id')) {

	    // Do the Ajax
					new Request({
						'link': 'ignore',
						'url': '<?php echo url('admin/xhr.php'); ?>',
						'onRequest': function() {
							cart.spin();
						},
						'onSuccess': function() {
							// Move this into the correct position
							if(cart.getData('folder-id') == '0') {
								shirt.inject(cart, 'after');
							} else {
								shirt.inject(cart.getElement('ul'), 'bottom'); // Append to list of subfolders
							}

							cart.unspin();

							// Animations etc
							cart.highlight('#7389AE', '#E6EDF3');

							// Decrease the counter in the current folder
							var old_counter = $('list_folders').getElement('.current .subfolder-counter span');
							if(old_counter) {
								old_counter.set('text', parseInt(old_counter.get('text')) - 1);
							}

							// Increase the file counter in the new folder
							var new_counter = $('list_folders').getElement('li[data-folder-id="'+cart.getData('folder-id')+'"] .subfolder-counter span');
							if(new_counter) {
								new_counter.set('text', parseInt(new_counter.get('text')) + 1);
							}

							/*
							var old_tri = $('list_folders').getElement('.current .ui-triangle');
							if(old_tri) {
								if(old_folders.length > 0) {
									//
								} else {
									//
								}
							}
							*/

							var new_tri = $('list_folders').getElement('li[data-folder-id="'+cart.getData('folder-id')+'"] .ui-triangle');
							if(new_tri) {
								new_tri.setStyle('display', 'block').set('class', 'ui-triangle ui-triangle-down');
							}
						}
					}).send({
						'method': 'post',
						'data': {
							'method': 'folder_set_parent',
							'folder_id': shirt.getData('folder-id'),
							'parent_id': cart.getData('folder-id')
						}
					});
    } else {
					$('list_folders').getElements('li').setStyle('background-color', '');
				}
			},
   'onEnter': function(dragging, cart) {
				cart.tween('background-color', '#98B5C1');
   },
   'onLeave': function(dragging, cart) {
				cart.tween('background-color', '#FAFAFA');
   },
   'onCancel': function(dragging) {
    dragging.destroy();
    droppables.css('background-color', '');
   }
  });
  drag.start(event);
 });

	(function() {
		if(!$('folders-create')) return false;
		$('folders-create').addEvent('click', function(event) {
			if(event) event.stop();

			var xhr = new Request.JSON({
				'link': 'ignore',
				'url': '<?php echo url('admin/xhr.php'); ?>',
				'onRequest': function() {
					//
				},
				'onSuccess': function(response) {
					var ul = $('list_folders').getElement('ul');

					// Construct the folder
					var li = new Element('li', {
						'html': '<span class="folder-drag"></span><div class="ui-triangle ui-triangle-right" style="display: none;"></div><span class="folder-check"><input type="checkbox" value="'+response.id+'" /></span><a href="#folder-'+response.id+'" class="folder-name inline-rename">'+response.name+'</a><span class="folder-counter">Files: <span>0</span></span><span class="subfolder-counter">Folders: <span>0</span></span><ul></ul>'
					}).setData('folder-id', response.id);

					if(response.parent_id == 0) {
						ul.adopt(li);
					} else { // Locate the parent li
						var parent_li = ul.getElement('li[data-folder-id="'+response.parent_id+'"] ul');
						if(parent_li) {
							parent_li.adopt(li);
						} else {
							ul.adopt(li);
						}
					}

					// Make sure the arrow on the parent is displayed
					if(response.parent_id > 0) {
						var parent_li = ul.getElement('li[data-folder-id="'+response.parent_id+'"]');
						if(parent_li) {
							parent_li.getElement('.ui-triangle').set('class', 'ui-triangle ui-triangle-down').setStyles({'display': 'block', 'cursor': 'pointer'});
							parent_li.getElement('.subfolder-counter span').set('text', parent_li.getElement('.subfolder-counter span').get('text').toInt() + 1);
						}
					}

					// Add it to the 'move' box
					if($('ui-move-selectbox')) {
						var li = new Element('option', {'value': response.id, 'text': response.name});
						$('ui-move-selectbox').adopt(li);
						var moo = $('ui-move-selectbox').retrieve('mooselecta');
						if(moo) moo._addOption(li, $('ui-move-selector'), false);
					}

					// And switch to it
				//changeFolder(response.id);
				}
			});

			StickyWin.prompt('Create a folder', 'Please enter a name for this new folder.', function(name) {
				xhr.send({
					'method': 'post',
					'data': {
						'method': 'folder_create',
						'name': name,
						'parent_id': $('storage').retrieve('currentFolder') || 0
					}
				});
			});
		});
	})();

	(function() {
		if(!$('folders-delete')) return false;
		var batch_delete = new Request({
			'link': 'ignore',
			'url': '<?php echo url('admin/xhr.php'); ?>',
			'method': 'post',
			'onRequest': function() {
				$('folders-delete').spin();
				$$('#list_folders_head input[type="checkbox"]').set('checked', false);
			},
			'onSuccess': function(response) {
				$$('#list_folders_head input[type="checkbox"]').set('checked', false);
				$('folders-delete').unspin();
				changeFolder(0);//$('storage').retrieve('currentFolder') || 0);
				// Correct the arrows
				$('list_folders').getElement('ul').getChildren('li[data-folder-id]').each(function(root) {
					var subfolders = root.getElements('ul li[data-folder-id]');
					var arrow = root.getElement('.ui-triangle');
					if(subfolders.length == 0 && arrow) arrow.setStyle('display', 'none');
				});
			}
		});

		$('folders-delete').addEvent('click', function() {
			var selected_files = $('list_folders').getElements('input[type="checkbox"]:checked');
			var ids = [];
			if(selected_files.length >= 1) {
				selected_files.each(function(el) {
					ids.push(el.get('value'));
					var li = el.getParent('li');
					if(li.getElement('ul')) { // Are there subfolders here? If so, we need to move them
						li.getElements('> ul li').inject(li, 'before');
					}
					el.getParent('li').destroy();
				});
			}

			if(ids.length >= 1) {
				batch_delete.send({
					'method': 'post',
					'data': {
						'method': 'folders_batch_delete',
						'ids': ids
					}
				});
			}
		});
	})();

	(function() {
		if(!$('batch-delete')) return false;
		var length;

		var batch_delete = new Request({
			'link': 'ignore',
			'url': '<?php echo url('admin/xhr.php'); ?>',
			'method': 'post',
			'onRequest': function() {
				$('batch-delete').spin();
				$$('#list_files .ui-batch-select').set('checked', false);
			},
			'onSuccess': function(response) {
				$$('#list_files .ui-batch-select').set('checked', false);
				$('batch-delete').unspin();
				// Decrease the counter in the current folder
				var old_counter = $('list_folders').getElement('.current .folder-counter span');
				if(old_counter) {
					old_counter.set('text', parseInt(old_counter.get('text')) - length);
				}
				changeFolder($('storage').retrieve('currentFolder') || 0);
			}
		});

		$('batch-delete').addEvent('click', function() {
			var selected_files = $('list_files').getElements('tbody tr input[type="checkbox"]:checked');
			var ids = [];
			if(selected_files.length >= 1) {
				selected_files.each(function(el) {
					ids.push(el.getData('id'));
				});
			}

			if(ids.length >= 1) {
				StickyWin.confirm('Are you sure?', 'Are you sure you want to delete these '+ids.length+' files?', function() {
					length = ids.length;
					batch_delete.send({
						'method': 'post',
						'data': {
							'method': 'files_batch_delete',
							'ids': ids
						}
					});
				});
			}
		});
	})();

	(function() {
		if(!$('move')) return;

		var cart;
		var shirt;
		var file_ids;
		var folder_id;
		var modal;

		var xhr = new Request({
			'link': 'ignore',
			'url': '<?php echo url('admin/xhr.php'); ?>',
			'onRequest': function() {
				cart.spin();
			},
			'onSuccess': function() {
				// Remove the original files
				$$(shirt).kill(function() {
					cart.unspin();
				});

				// Animations etc
				cart.highlight('#7389AE', '#E6EDF3');

				// Decrease the counter in the current folder
				var old_counter = $('list_folders').getElement('.current .folder-counter span');
				if(old_counter) {
					old_counter.set('text', parseInt(old_counter.get('text')) - shirt.length);
				}

				// Increase the file counter in the new folder
				var new_counter = $('list_folders').getElement('li[data-folder-id="'+folder_id+'"] .folder-counter span');
				if(new_counter) {
					new_counter.set('text', parseInt(new_counter.get('text')) + shirt.length);
				}

				modal.hide();
			}
		});

		$('move').addEvent('click', function() {
	  file_ids = [];
			shirt = [];

			$('list_files').getElements('tbody input[type="checkbox"]:checked').each(function(el) {
				var tr = el.getParent('tr');
				shirt.push(tr);
				file_ids.push(tr.getData('file-id'));
			});

			shirt = shirt.unique();
			file_ids = file_ids.unique();

			if(file_ids.length <= 0) {
				StickyWin.alert('Move files', 'Please select at least one file using the checkboxes before trying to move files into a folder!');
				return false;
			}

			var html = '';
			html += '<p>Please select a folder from the list below to move the selected files in to.</p>';
			html += '<select data-behavior="SelectBox" style="width:378px;" id="ui-move-selectbox">';

			// Build the select box
			$$('#list_folders li').each(function(el) {
				html += '<option value="'+el.getData('folder-id')+'">'+el.getElement('.folder-name').get('text')+'</option>';
			});

			html += '</select>';

			var live_content = new Element('div', {'html': html});

			var sw = StickyWin.ui('Move files', live_content, {
				'width': '400px',
				'buttons': [{
					'text': 'Cancel'
				}, {
					'text': 'Move into this folder',
					'properties': {'class': ''},
					'onClick': function() {
						folder_id = sw.getElement('select').get('value');

						cart = $$('#list_folders li[data-folder-id="'+folder_id+'"]');

						xhr.send({
							'method': 'post',
							'data': {
								'method': 'file_setfolder',
								'file_id': file_ids,
								'folder_id': folder_id
							}
						});
					}
				}]
			});

			modal = new StickyWin.Modal({
				'content': sw,
				'destroyOnClose': true,
				'onDisplay': function() {
					new Behavior().apply(this.element);
				}
			});
		});
	})();

	(function() {
		if(!$('apply-profile')) return;
		var xhr = new Request({
			'url': '<?php echo url('admin/xhr.php'); ?>',
			'method': 'post',
			'link': 'chain',
			'onRequest': function() {
				$('apply-profile').spin();
				$('apply-profile-wrapper').spin();
			},
			'onSuccess': function(response) {
				$('apply-profile').unspin();
				$('apply-profile-wrapper').unspin();
				$('list_files').getElements('tbody tr input[type="checkbox"]:checked').set('checked', false).fireEvent('change');
				$('apply-profile-wrapper').dissolve();
			}
		});

		$('apply-profile-wrapper').addEvent('click:relay(a)', function(event) {
			if(event) event.stop();
			var file_ref = $(event.target).getData('file_ref');
			if(!$(event.target).hasClass('back') && file_ref !== 'back') { // Yes, it's a proper link
				$('apply-profile-label').setData('file_ref', file_ref).set('value', $(event.target).getData('label')).fireEvent('change');
				$('apply-profile-wrapper').getElements('.active').removeClass('active');
				$(event.target).addClass('active');
			}
		});

		$('apply-profile-go').addEvent('click', function() {
			if(!$('apply-profile-label').getData('file_ref') || $('apply-profile-label').getData('file_ref').length < 1) {
				StickyWin.alert('Profiles', 'Please choose a valid video to copy the settings from in the selector!');
				return;
			}

			var selected_files = $('list_files').getElements('tbody tr input[type="checkbox"]:checked');
			var selected_folders = $('list_folders').getElements('input[type="checkbox"]:checked');
			var show_alert = false;

			if(selected_files.length >= 1) {
				var ids = [];
				selected_files.each(function(el) {
					ids.push(el.getData('id'));
				});

				if(ids.length >= 1) {
					xhr.send({
						'method': 'post',
						'data': {
							'method': 'files_batch_profile',
							'ids': ids,
							'source': $('apply-profile-label').getData('file_ref')
						}
					});
				} else {
					show_alert = true;
				}
			}

			if(selected_folders.length >= 1) {
				var ids = [];
				selected_folders.each(function(el) {
					ids.push(el.get('value'));
				});

				if(ids.length >= 1) {
					xhr.send({
						'method': 'post',
						'data': {
							'method': 'folders_batch_profile',
							'ids': ids,
							'source': $('apply-profile-label').getData('file_ref')
						}
					});
				} else {
					show_alert = true;
				}
			}

			if(show_alert) StickyWin.alert('Profiles', 'You must select at least one video to apply this Profile to!');
		});

		$('apply-profile').addEvent('click', function() {
			$('apply-profile-wrapper').get('reveal').toggle();
			(function() { new deviantMenu($('apply-profile-select')); }).delay(200);
			(function() {
				new Fx.Scroll(window).toElement($('apply-profile-wrapper'));
			}).delay(500);
		});

		$('apply-profile').addEvent('outerClick', function(event) {
			if(event && event.target && !$('apply-profile-wrapper').contains(event.target)) $('apply-profile-wrapper').get('reveal').dissolve();
		});
	})();

	History.addEvent('change', function(url) {
		var u = new URI(url);
		window.changeFolder((u.parsed.fragment || '').replace('folder-', '') || '<?php echo $initial_folder; ?>');
	});

	// Initial state
	(function() {
		var u = new URI(window.location.href);
		var folder = <?php echo $initial_folder; ?>;
		if(parseInt((u.parsed.fragment || '').replace('folder-', ''))) folder = parseInt((u.parsed.fragment || '').replace('folder-', ''));
		window.changeFolder(folder);
	})();
});
</script>

<div class="table alt clear" id="files"><div class="wrap">
	<h2>Files</h2>
	<div class="align-left" id="list_folders_wrap">
		<div id="list_folders_head">
			<?php if(!$isClient) : ?>
			<input type="checkbox" data-trigger="checkSwitch" data-checkswitch-options="{'targets': '#list_folders input[type=checkbox]'}" />Folder
			<?php endif; ?>
		</div>
		<div id="list_folders">
			<ul>
				<?php
				function listFolders($folder) {
					global $isClient;
					echo '<li data-folder-id="'.$folder->id.'">';
					if($folder->id > 0) {
						echo '<span class="folder-drag"></span>';
						echo '<div class="ui-triangle ui-triangle-right" style="display: '.(empty($folder->subfolders) ? 'none' : 'block').';"></div>';
					}
					if($folder->id > 0 && !$isClient) {
						echo '<span class="folder-check"><input type="checkbox" value="'.$folder->id.'" /></span>';
					}
					echo '<a href="#folder-'.$folder->id.'" class="folder-name '.($folder->id == 0 ? '' : 'inline-rename').'">'.$folder->name.'</a>';
					echo '<span class="folder-counter">Files: <span>'.$folder->file_count.'</span></span>';
					if($folder->id != 0) echo '<span class="subfolder-counter">Folders: <span>'.sizeof($folder->subfolders).'</span></span>';
					if($folder->id !== 0) echo '<ul>';
					if($folder->id !== 0 && !empty($folder->subfolders)) {
						foreach($folder->subfolders as $sub) {
							listFolders($sub);
						}
					}
					if($folder->id !== 0) echo '</ul>';
					echo '</li>';
				}
				foreach($folders as $folder) {
					listFolders($folder);
				}
				?>
			</ul>
		</div>
		<div id="list_folders_foot">
			<?php if(!$isClient) : ?>
			<a class="align-left margin-right" id="folders-create" data-behavior="Button" data-button-type="small" data-button-width="70">New folder</a>
			<a class="align-left" id="folders-delete" data-behavior="Button" data-button-type="small" data-button-width="85">Delete folders</a>
			<?php endif; ?>
		</div>
	</div>
	<div class="align-left" id="list_files_wrap">
		<div id="list_files" class="tableContainer">
			<table data-behavior="HtmlTable" data-htmltable-sortable="false" class="scrollTable">
				<thead class="fixedHeader">
					<tr>
						<th></th>
						<th style="width:110px;"></th>
						<th><span style="position:relative;left:-147px;"><input class="ui-batch-select" type="checkbox" data-trigger="checkSwitch" data-checkswitch-options="{'targets': '#list_files input[type=checkbox][data-id]'}" /><span style="font-size:10px;font-weight:normal;">Select all files</span></span></th>
						<th>Date</th>
						<th>Size</th>
						<th></th>
					</tr>
				</thead>
				<tfoot>
					<tr>
						<td colspan="6"></td>
					</tr>
				</tfoot>
				<tbody class="scrollContent"></tbody>
			</table>
		</div>
		<div id="list_files_foot">
			<?php if(!$xs->isMemberOf($xs->userData->id, 'Users')) : ?>
			<a class="align-left margin-right" id="batch-delete" data-behavior="Button" data-button-type="small" data-button-width="70">Delete</a>
			<?php endif; ?>
			<?php if(!$isClient) : ?>
			<a class="align-right margin-right" href="list.files.php?refresh_files=1" data-behavior="Button" data-button-type="action_small" data-button-width="70">Reload</a>
			<a class="align-left margin-right" id="rename" data-behavior="Button" data-button-type="small" data-button-width="70">Rename</a>
			<a class="align-left margin-right" id="move" data-behavior="Button" data-button-type="small" data-button-width="70">Move</a>
			<a class="align-left" id="apply-profile" data-behavior="Button" data-button-type="small" data-button-width="110">Apply video profile</a>
			<?php endif; ?>
		</div>
	</div>
</div></div>

<?php if(!$isClient) : ?>
<div id="apply-profile-wrapper" style="display:none;"><div class="triangle"></div><div class="styled descend">
	<p>Tick all of the files in the main files list - or an entire folder! - that you'd like to copy a profile to.</p>
	<p>Your visual settings - skin, frame, etc - plus page widgets will be copied onto these from the profile that you select from the list below! Note that Timeline events and chapters will not be copied.</p>
	<input type="hidden" disabled="disabled" id="apply-profile-label" class="margin-bottom" />
	<div style="width:330px;overflow-x:hidden;overflow-y:scroll;height:200px;">
		<div id="apply-profile-select">
		<?php
		function buildDeviantMenu($folders) {
			$evp = Registry::get('EVP');
			$profile_files = Registry::retrieve('profile_files');
			foreach($folders as $folder) {
				$subfolders = array();
				$files = array();
				if(!empty($folder->file_count)) $files = $profile_files[$folder->id];//$evp->getFiles($folder->id);
				if($folder->id !== 0) $subfolders = $folder->subfolders;//$evp->getFolders($folder->id, false);
				echo '<li class="folder">';
				echo "{$folder->name}";
				echo '<ul>';
				if(!empty($subfolders)) {
					buildDeviantMenu($subfolders);
				}
				if(!empty($files)) {
					foreach($files as $file) {
						$profiles = $evp->getProfiles($file->id, false);
						if(empty($profiles)) {
							echo "<li><a class=\"file\" data-label=\"{$file->name}\" data-file_ref=\"{$file->id}\">".string_trim($file->name, 32)."</a></li>";
						} else {
							echo '<li class="trigger_profile">'.string_trim($file->name, 32);
							echo '<ul>';
							echo "<li><a class=\"file\" data-label=\"{$file->name}\" data-file_ref=\"{$file->id}\">Default Profile</a></li>";
							foreach($profiles as $p) {
								echo "<li><a class=\"file-profile\" data-label=\"{$file->name} - {$p->name}\" data-file_ref=\"{$file->id}::{$p->seed}\">".string_trim($p->name, 32)."</a></li>";
							}
							echo '</ul>';
							echo '</li>';
						}
					}
				}
				echo '</ul>';
				echo '</li>';
			}
		}

		$profile_folders = $evp->getFoldersAsTree(true);

		$profile_all_files = getArray("SELECT t.id, t.file_name, t.name, r.folder_id FROM {$evp->options->prefix}files t LEFT JOIN {$evp->options->prefix}folders_relationships r ON (t.id = r.file_id) WHERE t.child_type IS NULL ORDER BY t.time DESC");
		$profile_files = array();
		if(!empty($profile_all_files)) {
			foreach($profile_all_files as $f) {
				$fid = $f->folder_id;
				if(empty($fid)) $fid = 0;
				$profile_files[$fid][] = $f;
			}
		}

		Registry::store('profile_files', $profile_files);

		echo '<ul>';
		if($evp->settings->use_default_settings == '1') {
			echo "<li><a class=\"file\" data-label=\"Default Settings\" data-file_ref=\"default\">Default Settings</a></li>";
		}
		if(!empty($profile_folders)) buildDeviantMenu($profile_folders);
		echo '</ul>';
		?>
		</div>
	</div>
	<input type="button" data-behavior="Button" data-button-type="action" data-button-width="200" id="apply-profile-go" value="Apply this Profile" />
</div></div>
<?php endif; ?>
