<!-- BUFFER -->

<style type="text/css">
#form .deviantMenu-menu-item { width: 331px; }
#form .back { width: 282px; }
.menuList li a { cursor: move; }

#playlist-preview-wrap { min-height: 200px; padding-bottom: 100px; }
#playlist-preview-wrap div { position: relative; background: #eee; border: 1px dashed #999; margin: 0 0 10px 0; padding: 5px; cursor: move; }
#playlist-preview-wrap div .inline-rename-label { font-weight: bold; margin: 0 0 5px 0; }
#playlist-preview-wrap div .inline-rename-description { font-weight: normal; margin: 0 0 5px 0; }
#playlist-preview-wrap .text { clear: both; }
#playlist-preview-wrap label { font-weight: normal; margin: 8px 0 0 3px; }

#playlist-preview { position: relative; }
</style>

<script type="text/javascript">
window.addEvent('domready', function() {

	EVP_Help.setContext({
		'content': '<p>Playlists let you group multiple videos into a single player! The next video in the queue will play automatically after the previous one completes.</p><p>Drag and drop new videos into the playlist from the left. Then you can double click the name and description to customise them in the playlist.</p>',
		'video': 'basic-playlists.mp4'
	});


	var showEmbedCode = function(id, name, el) {
	//$('embed_code').dissolve();
	
		$('form-outer').dissolve();
		
		var xhr = new Request.JSON({
			'url': '<?php echo url('api.php'); ?>',
			'onRequest': function() {
				if($(el)) $(el).spin();
			},
			'onSuccess': function(response) {
				if($(el)) $(el).unspin();
				$('embed_code').getElement('h2').set('text', (name ? 'Embed code: '+name : 'Embed code for this playlist'));
				$('embed_code').getElement('.ui_code').set('value', response.embed_code);
				
				if(response.page_url) {
					$('embed_code').getElement('.ui-has-page').setStyles({'display': 'block'});
					$('ui-page-url').set('value', response.page_url);
				} else {
					$('embed_code').getElement('.ui-has-page').setStyles({'display': 'none'});
					$('ui-page-url').set('value', '');
				}
				
				$('embed_code').reveal();
				
				if(embed_code) {
					$('playlist_preview').reveal();
					var scripts = '';
					var html = response.embed_code.replace(/<script[^>]*>([\s\S]*?)<\/script>/gi, function(all, code) {
						scripts += all;
						return '';
					});
					$('playlist_preview').set('html', '<center>'+html+'</center>');
					var url = scripts.match(/src="(.+?)"/);
					new Asset.javascript(url[1]);
				}
			}
		});
		
		xhr.send({
			'method': 'post',
			'data': {
				'username': '<?php echo $currentUser->username; ?>',
				'password': '<?php echo $currentUser->password; ?>',
				'method': 'playlist-embed-code',
				'id': id
			}
		});
	}
	
	var hideEmbedCode = function() {
		$('embed_code').dissolve();
		$('playlist_preview').empty().dissolve();
	}
	
	$$('.ui-playlist-embed').addEvent('click', function() {
		var data = JSON.decode(this.getParent('tr').get('data'));
		showEmbedCode(data.id, data.name, $('playlists'));
	});
	
	if($('save')) {
		$('save').addEvent('click', function(event) {
			if(event) event.stop();
			var files = $$('#playlist-preview-wrap div[data-file_ref]').length;
			if(files <= 1) {
				StickyWin.alert('Playlists', 'Please select at least 2 files to add to this playlist first!');
			} else {
				$('form').submit();
			}
		});
	}
	
	var updatePreview = function() {
		var mode = $('list_position').get('value');
		var files = $$('#playlist-preview-wrap div[data-file_ref]');
		if(files.length <= 0) {
			$('playlist-preview').dissolve();
			return false;
		}
		
		$('playlist-preview').empty().reveal();
		
		var skin = files[0].getData('skin') || 'minima';
		
		var img = new Element('img', {
			'id': 'playlist-preview-img',
			'src': '<?php echo url('player/assets/jwplayer-5.10/skins/'); ?>'+skin+'/'+skin+'.png',
			'styles': {
				'width': 480,
				'height': 249,
				'position': 'relative'
			}
		}).inject($('playlist-preview'));
		
		var playlist = new Element('div', {
			'id': 'playlist-preview-pl',
			'styles': {
				'background': '#2a2a2a',
				'opacity': 0.8,
				'width': 170,
				'height': 200,
				'position': 'absolute',
				'border': 'none',
				'border-radius': 0
			}
		}).inject($('playlist-preview'));
		
		$('playlist-preview').setStyle('margin-bottom', 10);
		
		switch(mode) {
			case '0':
				playlist.setStyles({'display': 'none'});
				img.setStyles({'width': 480, 'height': 249, 'left': 0});
				break;
			case '1':
				playlist.setStyles({
					'left': 0,
					'top': 0,
					'border-bottom-right-radius': 5,
					'border-right': '2px solid #000',
					'border-bottom': '2px solid #000',
					'box-shadow': '1px 1px 5px rgba(0,0,0,0.5)'
				});
				break;
			case '2':
				playlist.setStyles({
					'right': 0,
					'top': 0,
					'border-bottom-left-radius': 5,
					'border-left': '2px solid #000',
					'border-bottom': '2px solid #000',
					'box-shadow': '1px 1px 5px rgba(0,0,0,0.5)'
				});
				break;
			case '3':
				img.setStyles({'width': 310, 'left': 170});
				playlist.setStyles({'top': 0, 'height': 249, 'left': 0});
				break;
			case '4':
				img.setStyles({'width': 310, 'left': 0});
				playlist.setStyles({'top': 0, 'height': 249, 'left': 310});
				break;
			case '5':
				playlist.setStyles({
					'width': 480,
					'top': 249
				});
				$('playlist-preview').setStyle('margin-bottom', 210);
				break;
		}
		
	}
	
	$('playlist-preview-wrap').addEvent('dblclick:relay(.inline-rename)', function() {
		var el = $(this);
		
		var before = el.get('html').trim();
		
		el.set('html','');
		
		if(el.hasClass('textarea')) {
			var input = new Element('textarea', {'class': 'box', 'text': before});
		} else {
			var input = new Element('input', {'class': 'box', 'value': before});
			input.addEvent('keydown', function(e) { if(e.key == 'enter') { this.fireEvent('blur'); } });
		}
		
		input.inject(el).select();
		
		var type = el.getData('rename');
		
		// On blur, save
		input.addEvent('blur', function() {
			val = input.get('value').trim();
			el.set('text', val).addClass(val != '' ? '' : 'editable-empty');
			el.getParent().getElement('input[name="'+type+'s[]"]').set('value', val);
		});
	});
	
	var sort = new Sortables('#playlist-preview-wrap', {
		'clone': true,
		'revert': true,
		'opacity': 0.7,
		'onStart': function() {
			//
		},
		'onComplete': function() {
			OverText.update();
			updatePreview();
		}
	});
	
	function widgets_build(file_ref) {
		var orig = $('deviantMenu-wrapper').getElement('.file[data-file_ref="'+file_ref+'"]');
		if(!orig) {
			if(typeof console !== 'undefined') console.error('The file '+file_ref+' could not be identified!');
			return false;
		}
		
		var el = new Element('div', {
			'class': 'playlist-file'
		}).setData('file_ref', file_ref).setData('skin', orig.getData('skin'));
		
		new Element('p', {
			'text': orig.getData('label'),
			'class': 'inline-rename inline-rename-label'
		}).setData('rename', 'label').inject(el);
		
		new Element('p', {
			'text': orig.getData('description') || 'Enter a description',
			'class': 'inline-rename inline-rename-description'
		}).setData('rename', 'description').inject(el);
		
		new Element('span', {
			'styles': {
				'cursor': 'pointer',
				'position': 'absolute',
				'right': '5px',
				'top': '6px'
			},
			'events': {
				'click': function() {
					this.getParent('.playlist-file').kill(function() {
						updatePreview();
					});
				}
			},
			'class': 'ui-icon ui-icon-delete'
		}).inject(el);
		
		new Element('input', {
			'type': 'hidden',
			'name': 'files[]',
			'value': file_ref
		}).inject(el);
		
		new Element('input', {
			'type': 'hidden',
			'name': 'labels[]'
		}).inject(el);
		
		new Element('input', {
			'type': 'hidden',
			'name': 'descriptions[]'
		}).inject(el);
		
		return el;
	}
	
	var bind = function() {
		$$('#deviantMenu-wrapper a.file').removeEvents('mousedown').addEvent('mousedown', function(event) {
	  event.stop();
			var shirt = this;
			
			var to_clone = shirt;
			var pos = to_clone.getPosition();
			var clone = to_clone.clone().setStyles({
				'left': pos.x,
				'top': pos.y,
				'width': '178px',
				'opacity': 0.7,
				'position': 'absolute',
				'z-index': 10
			}).inject(document.body);
			
	  var drag = new Drag.Move(clone, {
			'droppables': '#playlist-preview-wrap',
	   'onDrop': function(dragging, cart){
	    if (cart != null) { // It's been dropped in the proper place
						var existing = $$('#playlist-preview-wrap div[data-file_ref="'+dragging.getData('file_ref')+'"]');
						if(existing.length >= 1) {
							if(dragging) dragging.destroy();
							return false;
						}
						
						var widget = widgets_build(dragging.getData('file_ref'));
						widget.inject(cart);
						
						if($$('#playlist-preview-wrap div[data-file_ref]').length == 1) {
							var p = new StickyWin.PointyTip('Label and describe!', 'You can label this video in your playlist, and add a little description, by double-clicking on it\'s name!', {
								'point': 6,
								'relativeTo': $('playlist-preview-wrap').getElement('.playlist-file .inline-rename'),
								'pointyOptions': {
									'width': 150
								}
							});
							(function() {
								p.destroy();
							}).delay(3000);
							
							updatePreview();
						}
						
						sort.addItems(widget);
						new Behavior().apply(cart);
					}
	    dragging.destroy();
	   },
	   'onCancel': function(dragging) {
	    dragging.destroy();
	   }
	  });
	  drag.start(event);
	 });
	}
	
	if($('ui-playlist-create')) {
		$('ui-playlist-create').addEvent('click', function() {
			
			hideEmbedCode();
			
			// Fold up the 'create' window
			if($('form-outer').getStyle('display') == 'block') {
				$('form-inner').dissolve();
			}
			
			$('form-outer').reveal();
			
			new deviantMenu($('files-select'));
			bind();
			
			(function() {
				// Set the title
				$('ui-playlist-title').set('text', 'Create a new playlist');
				
				// Change the text of the button
				$('save').getElement('.moobutton_text').set('text', 'Create this playlist');
				
				// Set the individual data
				try { $('form').getElement('input[name="name"]').set('value', '').focus(); } catch(e) {}
				
				// Inject a hidden ID param
				$('form').getElements('input[name="id"]').set('value', '');
				
				// Remove the old ones
				$('playlist-preview-wrap').empty();
				
				// Update the preview!
				updatePreview();
				
				// And unfold
				(function() {
					$('form-inner').reveal();
				}).delay(500);
			}).delay(500);
		});
	}
	
	$$('.ui-playlist-edit').each(function(el) {
		el.addEvent('click', function() {
			
			hideEmbedCode();
			
			$('playlist-preview-wrap').getElements('.playlist-preview').empty();
			
			var data = JSON.decode(el.getParent('tr').get('data'));
			data.descriptions = el.getParent('tr').retrieve('descriptions');
			data.labels = el.getParent('tr').retrieve('labels');
			
			// Fold up the 'create' window
			if($('form-outer').getStyle('display') == 'block') {
				$('form-inner').dissolve();
			}
			
			$('form-outer').reveal();
			
			new deviantMenu($('files-select'));
			bind();
		
			(function() {
				// Set the title
				$('ui-playlist-title').set('text', (data.name ? 'Edit a playlist: '+data.name : 'Edit this playlist'));
				
				// Change the text of the button
				$('save').getElement('.moobutton_text').set('text', 'Save');
				
				// Set the individual data
				$('form').getElement('input[name="name"]').set('value', stripslashes(data.name));
				
				// Hide previews
				$('playlist-preview-wrap').getElements('[data-file_ref]').destroy();
				
				// This is kinda complicated to trigger the change actually
				if(data.list_position !== null) {
					var opt = $$('#form select[name="list_position"] option[value="'+data.list_position+'"]');
					var opDiv = $('list_position').getNext('.selectaWrapper').getElements('.selectaOption[data-value="'+data.list_position+'"]');
					if(opDiv) {
						$('list_position').retrieve("wrapper").getChildren().removeClass('selectaOptionSelected');
						opDiv.addClass('selectaOptionSelected');
						$('list_position').retrieve("triggerElement").set("html", opDiv.get("text"));
						$('list_position').set("value", opDiv.retrieve("value")).fireEvent("change");
						opt.set('selected', true);
					}
				}
				
				Object.each(data.files, function(file_ref, idx) {
					var widget = widgets_build(file_ref);
					
					if(!data.labels) data.labels = [];
					if(!data.descriptions) data.descriptions = [];
					
					var label = data.labels[idx];
					if(label && label.length >= 1) {
						widget.getElement('.inline-rename-label').set('text', label);
						widget.getElement('input[name="labels[]"]').set('value', label);
					}
					widget.getElement('.inline-rename-description]').set('text', data.descriptions[idx] || 'Enter a description');
					widget.getElement('input[name="descriptions[]"]').set('value', data.descriptions[idx] || '');
					
					widget.inject($('playlist-preview-wrap'));
					sort.addItems(widget);
				});
				
				// Inject a hidden ID param
				$('form').getElements('input[name="id"]').set('value', data.id);
				
				// Update the preview!
				updatePreview();
				
				// And unfold
				(function() { $('form-inner').reveal(); }).delay(500);
			}).delay(500);
		});
	});
	
	$('list_position').addEvent('change', function() {
		updatePreview();
	});
	
	$$('.blank_checkbox').addEvent('click', function() {
		this.set('checked', false);
	});
	
	$('form-outer').addEvent('click:relay(input.file_input)', function(event) {
		this.getParent().getElement('a').fireEvent('click');
	});
	
	$$('#playlist-preview-wrap .ui-icon-delete').addEvent('click', function() {
		var idx = this.get('id').slice(-1);
		var file = $('playlist-preview-'+idx).getElement('div[data-file_ref]');
		if(!file) return false;
		var file_ref = file.getData('file_ref');
		$$('[data-file_ref="'+file_ref+'"]').fireEvent('click', true);
	});
	
	$$('.trigger_profile').addEvent('click', function() {
		new Fx.Scroll(this.getParent('#deviantMenu-wrapper').getParent().getParent(), {'duration': 250}).toTop();
	});
	
	<?php if($newly == true) : ?>
	showEmbedCode('<?php echo $newly_id; ?>', '<?php echo $newly_name; ?>', $('playlists'));
	<?php endif; ?>
	
	<?php if($_GET['show_page_url'] == true && !empty($_GET['id'])) : ?>
	showEmbedCode('<?php echo $_GET['id']; ?>', '', $('playlists'));
	<?php endif; ?>
	
	<?php if(empty($playlists)) : ?>
	new deviantMenu($('files-select'));
	bind();
	<?php endif; ?>
});
</script>

<div class="table alt clear" id="playlists"><div class="wrap">
	<h2>Playlists</h2>
	<table data-behavior="HtmlTable" data-htmltable-sortable="true">
		<thead>
			<tr>
				<th>Name</th>
				<th>Number of files</th>
				<th class="nosort" width="80">&nbsp;</th>
			</tr>
		</thead>
		<tfoot><tr><td colspan="3"><input class="align-right" type="button" data-behavior="Button" data-button-type="small" id="ui-playlist-create" value="New playlist" data-button-width="100" /></td></tr></tfoot>
		<tbody>
			<?php if(empty($playlists)) : ?>
				<tr class="norows"><td colspan="3">You have not created any playlists yet.</td></tr>
			<?php else : ?>
			<?php
			$description_js = '';
			if(!empty($playlists)) {
				foreach($playlists as $i) {
					
					$description_js.= "$('playlist-row-{$i->id}').store('descriptions', ".json_encode($i->descriptions).");\n$('playlist-row-{$i->id}').store('labels', ".json_encode($i->labels).");\n";
					
					echo '<tr id="playlist-row-'.$i->id.'" data="'.escape(json_encode(array('name' => unescape($i->name, true), 'files' => $i->files, 'list_position' => $i->list_position, 'id' => $i->id)), true).'">';
					echo "<td><a class=\"ui-playlist-embed\">".unescape($i->name, true)."</a></td>";
					echo "<td>{$i->file_count}</td>";
					echo '<td>';
					echo "<a class=\"ui-playlist-embed margin-right\" rel=\"Get embed code\"><img src=\"{$themeDir}assets/icons/code.png\" alt=\"Get embed code\" /></a>";
					echo "<a class=\"ui-playlist-edit margin-right\" rel=\"Edit playlist\"><img src=\"{$themeDir}assets/icons/settings.png\" alt=\"Edit playlist\" /></a>";
					echo "<a href=\"pages.builder.php?id={$i->id}&mode=playlist\" class=\"ui-playlist-page margin-right\" rel=\"Build a page\"><img src=\"{$themeDir}assets/icons/page.png\" alt=\"Build a page\" /></a>";
					echo "<a data-trigger=\"api-call\" data-api-call-options=\"{'spin': '! tr', 'name': '".addslashes($i->name)."', 'data': {'method': 'playlists-delete', 'id': '{$i->id}'}, 'showConfirm': true, 'confirmTitle': 'Playlists', 'confirmMessage': 'Are you sure you want to delete this playlist?', 'confirmFailed': 'This playlist could not be deleted.', 'xhr': '".url('api.php')."', 'xhr_username': '".$currentUser->username."', 'xhr_password': '".$currentUser->password."'}\"><img src=\"{$themeDir}assets/icons/delete.png\" alt=\"Delete\" /></a>";
					echo '</td>';
					echo '</tr>';
				}
			}
			?>
			<?php endif; ?>
		</tbody>
	</table>
</div></div>

<?php if(!empty($description_js)) echo "<script type=\"text/javascript\">window.addEvent('domready', function() { {$description_js} });</script>"; ?>

<form id="form" action="list.playlists.php" method="post">
	<input type="hidden" name="id" value="" />
	<div class="box alt" id="form-outer" style="<?php if(!empty($playlists)) echo 'display:none;'; ?>"><div class="wrap auto">
		<h2 id="ui-playlist-title">Create a new playlist</h2>
		<div class="body styled descend" style="padding:10px;" id="form-inner">
			<fieldset>
				<label for="new_name">Enter a name for this playlist</label>
				<input type="text" class="text required maxLength:90 margin-bottom" name="name" id="new_name" style="width:325px;" /><br />
				
				<p class="help">Please note that any Events you have configured will not show up, and the visual options that you have set up for the very first video in the list will be used for all videos! Stats will be attributed to the original videos!</p>
				
				<label>Drag the files you want to be added over to the right</label>
				<div style="padding:10px;background:#fff;border:1px solid #999;margin:10px 0;" id="playlist-container">
					<div style="width:351px;overflow-x:hidden;overflow-y:scroll;height:270px;float:left;">
						<div id="files-select">

						
						<?php						
						function buildDeviantMenu($folders) {
							$evp = Registry::get('EVP');
							$profile_files = Registry::retrieve('profile_files');
							foreach($folders as $folder) {
								$subfolders = array();
								$files = array();
								if(!empty($folder->file_count)) $files = $profile_files[$folder->id];//$evp->getFiles($folder->id);
								if($folder->id !== 0) $subfolders = $folder->subfolders;//$evp->getFolders($folder->id, false);
								echo '<li class="folder">';
								echo "{$folder->name}";
								echo '<ul>';
								if(!empty($subfolders)) {
									buildDeviantMenu($subfolders);
								}
								if(!empty($files)) {
									foreach($files as $file) {
										echo "<li><a class=\"file\" data-skin=\"{$file->options['skin']}\" data-label=\"{$file->name}\" data-file_ref=\"{$file->id}\">".string_trim($file->name, 42)."</a></li>";
									}
								}
								echo '</ul>';
								echo '</li>';
							}
						}
						
						$profile_folders = $evp->getFoldersAsTree(true);
						
						$profile_all_files = getArray("SELECT t.id, t.file_name, t.name, t.source, t.location, r.folder_id FROM {$evp->options->prefix}files t LEFT JOIN {$evp->options->prefix}folders_relationships r ON (t.id = r.file_id) WHERE t.child_type IS NULL ORDER BY t.time DESC");
						$profile_files = array();
						if(!empty($profile_all_files)) {
							foreach($profile_all_files as $f) {
								$fid = $f->folder_id;
								if(empty($fid)) $fid = 0;
								$profile_files[$fid][] = $f;
							}
						}
						
						Registry::store('profile_files', $profile_files);
						
						echo '<ul>';
						if(!empty($profile_folders)) buildDeviantMenu($profile_folders);
						echo '</ul>';
						?>
						</div>
					</div>
					
					<div style="width:475px;float:left;margin-left:10px;">
						<div id="playlist-preview-wrap"></div>
					</div>
					<div class="clear"></div>
				</div>
				
				<div class="align-left" style="width:380px;">
					<label>Where should the list of videos in the playlist show?</label>
					<div class="align-left margin-bottom" style="width:300px;">
						<select data-behavior="SelectBox" id="list_position" name="list_position" style="width:275px;">
							<optgroup label="To the side">
								<option value="3">Next to your video - Left</option>
								<option value="4">Next to your video - Right</option>
							</optgroup>
							<optgroup label="Under">
								<option value="5">Underneath your video</option>
							</optgroup>
							<optgroup label="Other">
								<option value="0">Do not display</option>
							</optgroup>
						</select>
					</div>
				</div>
				
				<div class="align-left" style="width:480px;" id="playlist-preview">
					
					
				</div>
				
				<div class="clear"></div>
				<div class="align-right">
					<input type="button" id="save" data-behavior="Button" data-button-width="200" value="Create this playlist" />
				</div>
			</fieldset>
		</div>
	</div></div>
</form>

<div id="playlist_preview" style="margin-bottom:15px;"></div>

<div class="box alt" id="embed_code" style="display:none;"><div class="wrap auto">
	<h2>Embed code for this playlist</h2>
	<div class="body styled" style="padding:0 10px 10px;">
		<textarea class="ui_code ui_clickselect ui_noresize" style="width:540px;height:100px;margin:0 auto 20px auto;display:block;"></textarea>
		
		<div class="ui-has-page self-clear" style="display:none;">
			<label style="background:url(<?php echo assets('assets/icons-custom/embed-page.png'); ?>) no-repeat 0 0;padding-left:42px;margin-left:15px;">Your playlist's video page</label>
			<input readonly="readonly" type="text" class="align-left margin-right ui_code ui_clickselect" value="" id="ui-page-url" style="width:390px;" />
		</div>
	</div>
</div></div>