<!-- BUFFER -->

<script type="text/javascript">
window.addEvent('domready', function() {

	EVP_Help.setContext({
		'content': '<p>You can create additional Users which get access to your web application.</p><p><strong>Managers</strong> can do everything but change settings.</p><p><strong>Clients</strong> can upload videos using the web or desktop app, and can only access videos you assign them.</p><p><strong>Users</strong> can only view the statistics for the videos you assign them.</p>'
	});


	if($('new_role')) {
		$('new_role').addEvent('change', function() {
			var v = this.get('value');
			var opt = this.getElement('option[value="'+v+'"]');
			var remaining;
			if(opt) remaining = parseInt(opt.getData('remaining'));
			
			
			
			if(v == 'Users' || v == 'Clients') {
				$('folder_assignment').reveal();
			} else {
				$('folder_assignment').dissolve();
			}
		});
	}
	
	if($('save')) {
		$('save').addEvent('click', function(event) {
			if(event) event.stop();
			
			// Check to make sure you can create this user level - if editing, and it's not changed, ignore
			if($('ui-split-title').getData('editing') == 'true' && $('ui-split-title').getData('original-group') == $('new_role').get('value')) {
				// This is fine
				$('form').submit();
			} else {			
				// So is this level valid?
				var opt = $('new_role').getElement('option[value="'+$('new_role').get('value')+'"]');
				var remaining = 0;
				if(opt) remaining = parseInt(opt.getData('remaining'));
				
				if(remaining <= 0) {
					StickyWin.alert('Wait!', 'You cannot make any more '+$('new_role').get('value')+' accounts! Please change to a different role to make this user.');
				} else {
					$('form').submit();
				}
			}
		});
	}
	
	if($('ui-user-create')) {
		$('ui-user-create').addEvent('click', function() {
			
			// Fold up the 'create' window
			if($('form-outer').getStyle('display') == 'block') {
				$('form-inner').dissolve();
			}
			
			$('form-outer').reveal();
			
			(function() {
				// Set the title
				$('ui-split-title').set('text', 'Create a new user').setData('editing', false).setData('original-group', '');
				
				// Change the text of the button
				$('save').getElement('.moobutton_text').set('text', 'Create this user');
				
				// Set the individual data
				try { $('form').getElement('input[name="username"]').set('value', '').focus(); } catch(e) {}
				$('form').getElement('input[name="password"]').set('value', '');
				
			//$('folder_assignment').getElements('input').set('checked', false);
				
				// Inject a hidden ID param
				$('form').getElements('input[name="id"]').set('value', '');
				
				if($('new_role') && $('new_role').retrieve('mooselecta')) {
					$('new_role').retrieve('mooselecta').replaceSelect($('new_role'));
				}
				
				// And unfold
				(function() { $('form-inner').reveal(); }).delay(500);
			}).delay(500);
		});
	}
	
	$$('.ui-user-edit').each(function(el) {
		el.addEvent('click', function() {
			
			var data = JSON.decode(el.getParent('tr').get('data'));
			
			// Fold up the 'create' window
			if($('form-outer').getStyle('display') == 'block') {
				$('form-inner').dissolve();
			}
			
			$('form-outer').reveal();
			
			(function() {
				// Set the title
				$('ui-split-title').set('text', 'Edit a user: '+data.username).setData('editing', true).setData('original-group', data.role);
				
				// Change the text of the button
				$('save').getElement('.moobutton_text').set('text', 'Save');
				
				// Set the individual data
				$('form').getElement('input[name="username"]').set('value', data.username);
				$('form').getElement('input[name="password"]').set('value', '');
				
				// This is kinda complicated to trigger the change actually
				var opt = $$('#form select[name="role"] option[value="'+data.role+'"]');
				var opDiv = $('new_role').getNext('.selectaWrapper').getElements('.selectaOption[data-value="'+data.role+'"]');
				if(opDiv) {
					$('new_role').retrieve("wrapper").getChildren().removeClass('selectaOptionSelected');
					opDiv.addClass('selectaOptionSelected');
					$('new_role').retrieve("triggerElement").set("html", opDiv.get("text"));
					$('new_role').set("value", opDiv.retrieve("value")).fireEvent("change");
					opt.set('selected', true);
				}
				
				$('folder_assignment').getElements('input').set('checked', false);
				Object.each(data.folders, function(folder_id) {
					$$('#folder_assignment input[value="'+folder_id+'"]').set('checked', true);
				});
				
				// Inject a hidden ID param
				$('form').getElements('input[name="id"]').set('value', data.id);
				
				if($('new_role') && $('new_role').retrieve('mooselecta')) {
					$('new_role').retrieve('mooselecta').replaceSelect($('new_role'));
				}
				
				// And unfold
				(function() { $('form-inner').reveal(); }).delay(500);
			}).delay(500);
		});
	});
});
</script>

<?php echo $response; ?>

<div class="table alt clear" id="files"><div class="wrap">
	<h2>Current users</h2>
	<?php if(sizeof($users) > 3) : ?><p class="help"><a style="text-decoration:none;" data-behavior="HelpTrigger" data-helptrigger-pane="support" data-helptrigger-message="I would like to request additional machines for use with the desktop application. I have a total of <?php echo sizeof($users); ?> users in my account right now. \n\nI would like this many extra keys: \nI would like them because: \n\nThanks!,">The desktop software allows you to use your license key and install it by default on up to <?php echo $maxMachines; ?> machines. Some of these can be used for your user accounts as well as yourself. If you require more installations of the desktop software, you can click here and we will review your request and grant you additional licenses on a case-by-case basis.</a></p><?php endif; ?>
	<table data-behavior="HtmlTable" data-htmltable-sortable="true">
		<thead>
			<tr>
				<th>Username</th>
				<th>Role</th>
				<th>Assigned folder</th>
				<th class="nosort" width="60">&nbsp;</th>
			</tr>
		</thead>
		<tfoot><tr><td colspan="4"><input class="align-right" type="button" data-behavior="Button" data-button-type="small" id="ui-user-create" value="New user" data-button-width="100" /></td></tr></tfoot>
		<tbody>
			<?php if(empty($users)) : ?>
				<tr class="norows"><td colspan="4">You have not created any users yet.</td></tr>
			<?php else : ?>
			<?php
			if(!empty($users)) {
				foreach($users as $i) {
					echo '<tr data="'.escape(json_encode(array('id' => $i->id, 'username' => $i->username, 'role' => $i->group->name, 'folders' => json_decode($i->assigned_folder_id))), true).'">';
					echo "<td><a class=\"ui-user-edit\">{$i->username}</a></td>";
					echo "<td>{$i->group->name}</td>";
					echo '<td>';
					if($i->assigned_folder->folder_id > 0 && !empty($i->assigned_folder->folder_name)) {
						echo "<a href=\"list.files.php?folder={$i->assigned_folder->folder_id}\">{$i->assigned_folder->folder_name}</a>";
					} else {
						echo '&nbsp;';
					}
					echo '</td>';
					echo '<td>';
					if($currentUser->groups[0]->name != 'Administrators' && $i->group->name == 'Administrators') {
						//
					} else {
						echo "<a class=\"ui-user-edit margin-right\" rel=\"Edit user\"><img src=\"{$themeDir}assets/icons/settings.png\" alt=\"Edit user\" /></a>";
					}
					
					if($i->id == $currentUser->id || ($currentUser->groups[0]->name != 'Administrators' && $i->group->name == 'Administrators')) {
						//
					} else {
						echo "<a data-trigger=\"users-delete\" data-users-delete-options=\"{'spin': '! tr', 'user_id': '{$i->id}', 'showConfirm': true, 'xhr': '".url('api.php')."', 'xhr_username': '".$currentUser->username."', 'xhr_password': '".$currentUser->password."'}\"><img src=\"{$themeDir}assets/icons/delete.png\" alt=\"Delete\" /></a>";
					}
					echo '</td>';
					echo '</tr>';
				}
			}
			?>
			<?php endif; ?>
		</tbody>
	</table>
</div></div>

<form action="list.users.php" method="post" id="form" autocomplete="off">
	<input type="hidden" name="id" value="" />
	<div id="form-outer" style="display:none;" class="box alt"><div class="wrap auto">
		<h2 id="ui-split-title">Create a new user</h2>
		<div class="body styled descend" style="padding:10px;" id="form-inner">
			<fieldset>
				
				<div class="group margin-bottom align-left" style="margin-right:120px;">
					<label for="new_username">Username/email</label>
					<input type="text" class="text required validate-email maxLength:90" name="username" id="new_username" />
				</div>
				
				<div class="group margin-bottom align-left" style="margin-right:120px;">
					<label for="new_password">Password</label>
					<input type="password" class="text required maxLength:30 minLength:8" name="password" id="new_password">
				</div>
				
				<div class="group margin-bottom align-left" style="width:234px;">
					<label for="new_role">Role</label>
					
					<select data-behavior="SelectBox" style="width:212px;" name="role" id="new_role">
						<?php if($currentUser->groups[0]->name == 'Administrators') : ?>
							<option value="Administrators" data-remaining="<?php echo $availableUsers['Administrators']; ?>">Administrator (<?php echo $availableUsers['Administrators']; ?> remaining)</option>
						<?php endif; ?>
						<option value="Managers" data-remaining="<?php echo $availableUsers['Managers']; ?>">Manager (<?php echo $availableUsers['Managers']; ?> remaining)</option>
						<option value="Clients" data-remaining="<?php echo $availableUsers['Clients']; ?>">Client (<?php echo $availableUsers['Clients']; ?> remaining)</option>
						<option value="Users" data-remaining="<?php echo $availableUsers['Users']; ?>">User (<?php echo $availableUsers['Users']; ?> remaining)</option>
					</select>
				</div>
				
				<div class="clear"></div>
				
				<div id="folder_assignment" style="display:none;" class="clear">
					<?php
					$folders_list = array();
					if(!empty($folders)) {
						echo '<p class="info">Check the boxes next to all of the folders below to grant access to this client. If you need to, you can <a href="list.files.php">create a folder</a> from the Files list.<br /><br />Note that they will be able to view all sub-folders, if any exist.<br /><br /><strong>Important:</strong> Clients cannot create new folders, so you must assign at least one folder to a client before they will be able to perform any actions.</p>';
						
						$folders = array_partition($folders, 4);
						
						foreach($folders as $oidx => $farr) {
							echo '<div class="folder_assignment_column" id="folder_assignment_column_'.$oidx.'">';
							foreach($farr as $idx => $f) {
							echo "<div class=\"folder_assignment_row ".(($idx % 2) ? 'folder_assignment_alt' : '')."\">";
								echo "<label>{$f->folder_name}</label>";
								echo "<input type=\"checkbox\" name=\"folder_id[]\" id=\"folder_{$oidx}_{$idx}\" value=\"{$f->folder_id}\" /><br />";
							echo "</div>";
							}
							echo '</div>';
						}
					
					} else {
						echo "<p class=\"error\">You haven't created any folders yet. Please go to the <a href=\"list.files.php\">Files list</a> and create some from there before you create your clients.</p>";
					}
					?>
				</div>
				
				<div class="clear"></div>
				<div class="align-right">
					<input type="button" id="save" data-behavior="Button" data-button-width="140" value="Create this user" />
				</div>
			</fieldset>
		</div>
	</div></div>
</form>