EvpTieToElement = new Class({
	'Implements': [Options],
	'options': {
		'bind': true
	},
	'initialize': function(el, key, object, options) {
		this.setOptions(options);
		this.el = $(el);
		this.key = key;
		this.object = $(object);
		this.update();
		
		// Bind?
		var klass = this;
		if(this.options.bind && (this.el.get('tag') == 'input' || this.el.get('tag') == 'textarea')) {
			if(klass.el.get('type') == 'checkbox' || klass.el.get('type') == 'radio') { // The radio bit allows radiogroups to work in IE8??
				klass.el.set('checked', klass.get()).fireEvent('change');
			} else if(klass.el.get('type') == 'text' || this.el.get('tag') == 'textarea') {
				var v = klass.get();
				if(typeof v == 'boolean' || typeof v == 'undefined') { // Don't set it if it's a boolean - makes no sense in this context and is probably empty
					//
				} else {
					klass.el.set('value', v);
				}
			} else {
				klass.el.set('value', klass.get());
			}
			klass.el.addEvents({
				'keyup': function(event) {
					klass.set(this.get('value'), false);
				},
				'input': function(event) {
					klass.set(this.get('value'), false);
				},
				'change': function(event) {
					if(klass.el.get('type') == 'checkbox') {
						klass.set(this.get('checked'), false);
					} else {
						klass.set(this.get('value'), false);
					}
				}
			});
		}
	},
	'update': function() {
		this.data = this.object.retrieve('data');
		return this.data;
	},
	'get': function(def) {
	//console.log(this.key, this.data[this.key], typeof this.data[this.key]);
		return this.data[this.key] || def || false;
	},
	'set': function(value, update) {
		if(!this.el) return;
		update = update || (typeof update == 'undefined' ? true : false);
		var data = this.update()[this.key] = value;
		this.el.store('data', data);
		if(update) {
			if(this.el.get('tag') == 'select') {
				var klass = this;
				setTimeout(function() {
					var options = klass.el.getElements('option');
					options.each(function(el, idx) {
						if(el.get('value') == value) {
							var selecta = klass.el.retrieve('mooselecta');
							var selecta_el = klass.el.getNext('.selectaWrapper').getElements('div').filter(function(sel) {
								return (sel.retrieve('value') == value);
							});
							klass.el.selectedIndex = idx;
							klass.el.retrieve("wrapper").getChildren().removeClass(selecta.options.optionClassSelected);
							selecta_el.addClass(selecta.options.optionClassSelected);
							klass.el.retrieve("triggerElement").set("html", el.get("text"));
							selecta_el.set("value", el.retrieve("value")).fireEvent("change");
						}
					});
				}, 500);
			} else if(this.el.get('tag') == 'input' || this.el.get('tag') == 'textarea') {
				this.el.set('value', value);
			} else {
				this.el.set('html', value);
			}
		}
		return this.el;
	}
});

Behavior.addGlobalFilter('EvpTieToElement', {
	setup: function(element, api) {
		var object = api.get('object') || 'thisFile';
		var key = api.get('key') || $(element).get('name');
		
		var tie = new EvpTieToElement(element, key, object);
		
		$(element).store('Tie', tie);
		return tie;
	}
});