window.addEvent('domready', function() {
	if($('toTop')) {
		var backToTop = $('toTop').set('tween', {
			'duration': 200
		});
		backToTop.setStyle('opacity', 0);
		backToTop.addEvent('click', function(event) {
			if(event) event.stop();
			window.scroll(0,0);
		});
		
		var ws = window.getScrollSize().y;
		var ss = new ScrollSpy( {
			'min': 30,
			'max': ws - 30,
			'onLeave': function(pos) {
				backToTop.tween('opacity', 0);
			},
			'onEnter': function() {
				backToTop.tween('opacity', 1);
			}
		});
	}
	
	if((Browser.Engine.webkit == true || Browser.Engine.gecko == true) && $('body')) {
		$('body').setStyle('opacity', 0).store('should-display', true);
	}
	
	if($('body')) {
		$('body').addEvent('click:relay(input.ui_clickselect, textarea.ui_clickselect)', function() {
			this.select();
		});
	}
	
	// On some pages, standard links just don't work
	// This makes no sense, but, here is a fix
	if(Browser.Engine.trident && Browser.Engine.version <= 8) {
		$(document.body).getElements('a[href]:not([data-behavior])').addEvent('click', function(event) {
			if(event) event.stop();
			window.location = this.get('href');
		});
	}
	
	if(!(Browser.Engine.trident && Browser.Engine.version <= 8)) {
		if($('header')) {
			$('header').getElements('li a[href$="signout.php"]').addEvent('click', function(event) {
				if(event) event.stop();
				var pos = this.getPosition($('header-wrap'));
				$('ui-signout').setStyle('left', pos.x - 230).get('reveal').toggle();
			});
		}
	}
	
	if(typeof Behavior != 'undefined') {
		new Behavior().apply(document.body);
		new Delegator().attach(document.body);
	}
});

if(Browser.Engine.webkit == true || Browser.Engine.gecko == true) {
	var disp = function() {
		if($('body').retrieve('should-display') === false) return;
		new Fx.Tween($('body'), {
			'duration': 20,
			'property': 'opacity'
		}).start(1);
		$('body').store('should-display', false);
	}
	
	disp.delay(2000);
	
	window.addEvent('load', disp);
}

var EVP_Help = {
	'data': {},
	'visible': false,
	'section': 'context',
	'init': function(title) {
		var klass = this;
		
		this.element = $('help');
		if(!this.element) return false;
		
		this.sections = $$('#help-context, #help-support, #help-feedback');
		this.sections.setStyles({'display': 'none'});
		$(this.sections[0]).setStyles({'display': 'block'});
		
		this.fx = new Fx.Morph('help', {
			'duration': 'short'
		});
		
		// Set up the triggers
		$('help-button').addEvent('click', this.toggle.bind(this));
		$$('.help-trigger-support').addEvent('click', this.setPane.pass('support', this));
		$$('.help-trigger-feedback').addEvent('click', this.setPane.pass('feedback', this));
		$$('.help-trigger-context').addEvent('click', this.setPane.pass('context', this));
		
		// Let's do the submission
		var xhr = new Request.JSON({
			'url': $('help-wrap').getData('submit-xhr'),
			'onRequest': function() {
				$('help-wrap').spin({'message': 'Submitting...'});
			},
			'onSuccess': function() {
				$('help-wrap').unspin();
				klass.setPane('context');
				StickyWin.alert('Sent!', 'We have submitted your ticket successfully! We will be in touch as quickly as possible.');
			},
			'onFailure': function(obj) {
				var response = JSON.decode(obj.response);
				$('help-wrap').unspin();
				StickyWin.alert('Unable to send', 'We could not submit your ticket, as your web server is unable to send emails, or there is an intermittent problem.<br /><br /><strong>Please <a href="https://webactix.zendesk.com/anonymous_requests/new" target="_blank">submit a ticket here</a></strong>.');
			//window.open('mailto:'+response.to+'?body='+response.ticket);
			}
		});
		
		var submit = function(message, from, page, url, file_ref) {
			xhr.post({
				'method': 'general_sendemail',
				'message': message,
				'from': from,
				'page': page,
				'url': url,
				'file_ref': file_ref
			});
		}
		
		if($('help-support-submit')) {
			$('help-support-submit').addEvent('click', function() {
				var message = $('help-support-message').get('value');
				submit(message, $('help-support-email').get('value'), klass.data.title, window.location.href, ($('thisFile') ? $('thisFile').retrieve('file_ref') : ''));
			});
		}
		
		if($('help-feedback-submit')) {
			$('help-support-submit').addEvent('click', function() {
				var message = $('help-feedback-message').get('value');
				submit(message, $('help-feedback-email').get('value'), klass.data.title, window.location.href, ($('thisFile') ? $('thisFile').retrieve('file_ref') : ''));
			});
		}
		
		this.setTitle(title);
	},
	'setContext': function(obj) {
		if(!this.element) return false;
		var title = this.data.title;
		this.data = obj;
		if(!this.data.title) this.data.title = title; // Keep the title
		
		$('help-context-content').set('html', this.data.content);
		$('help-context-video').empty();
		
		if(this.data.video && !(Browser.Engine.trident && parseInt(Browser.Engine.version) < 8)) {
			var url = 'http://evs-site-assets.s3.amazonaws.com/inline-help/'+this.data.video;
			var video = '<div data-role="evp-video" data-evp-location="'+url+'" style="width:300px;height:169px;"></div>';
			$('help-context-video').set('html', video);
			
			if(typeof EVP3 !== 'undefined') EVP3.attach();
		}
	},
	'setTitle': function(title) {
		if(!this.element) return false;
		if(!title) title = document.title;
		this.data.title = title;
	},
	'setPane': function(name) {
		if(!this.element) return false;
		
		if(this.section == name) return;
		
		this.section = name;
		
		this.sections.each(function(el) {
			if(el.get('id') == 'help-'+name) {
				el.reveal();
			} else {
				el.dissolve();
			}
		});
	},
	'setSupport': function(message) {
		if(!message || typeof message != 'string') return;
		message = message.replace(/\\n/gi, "\n");
		$('help-support-message').set('value', message);
	},
	'show': function() {
		if(!this.element) return false;
		this.visible = true;
		this.fx.start({
			'right': '0px'
		});
	},
	'hide': function() {
		if(!this.element) return false;
		this.visible = false;
		this.fx.start({
			'right': '-321px'
		});
		this.setPane('context');
	},
	'toggle': function() {
		if(!this.element) return false;
		if(this.visible === true) {
			this.hide();
		} else {
			this.show();
		}
	}
}

if(typeof Behavior != 'undefined') {
	Behavior.addGlobalFilter('HelpTrigger', {
		setup: function(element, api) {
			var pane = api.get('pane') || 'context';
			var message = api.get('message') || '';
			
			if(element.get('tag') == 'a') element.set('href', '#');
			
			element.addEvent('click', function(event) {
				if(event) event.stop();
				if(!$('help')) return false;
				
				EVP_Help.setPane(pane);
				EVP_Help.setSupport(message);
				EVP_Help.show();
				
			});
		}
	});
}

var EVP_Chat = {
	'data': {},
	'visible': false,
	'init': function(chats, messages) {
		var klass = this;
		
		this.element = $('chat');
		if(!this.element) return false;
		
		this.convo_open = false;
		this.current_convo = false;
		this.posted_messages = [];
		
		this.fx = new Fx.Morph('chat', {
			'duration': 'short',
			'transition': 'sine:in:out'
		});
		
		this.xhr = new Request.JSON({
			'url': $('chat').getData('api'),
			'link': 'cancel',
			'onSuccess': function(response) {
				var returnedChats = [];
				var shouldBeep = false;
				var toMarkAsRead = false;
				
				if(response.success !== true) {
					//
				} else {					
					Object.each(response.chats, function(chat) {
						returnedChats.push(chat.id);
						var row = klass.addChatToList(chat);
						if(row) {
							row.inject($('chat-list'));
							
							if(klass.visible === true) {
								$('chat').set('tween', {'transition': 'bounce:out'}).tween('left', [-10, 0]);
							} else {
								$('chat').set('tween', {'transition': 'bounce:out'}).tween('left', [-331, -321]);
							}
							
							var convo = klass.addConvoToList(chat);
							if(convo) {
								shouldBeep = true;
								convo.inject($('chat-convo'));
							}
						}
					});
					
					Object.each(response.messages, function(message) {
						var convo = $('chat-convo').getElement('.chat-convo[data-chat-id="'+message.chat_id+'"]');
						if(!convo) return;
						
						var chat_row = $('chat-list').getElement('.chat-row[data-chat-id="'+message.chat_id+'"]');
						var chat = chat_row.retrieve('chat');
						
						var message_wrap = convo.getElement('.chat-message-wrap');
						var msg = klass.formatMessage(message, chat);
						if(msg) {
							msg.inject(message_wrap);
							if(klass.current_convo && message.chat_id == klass.current_convo) { // New message on the active thread - should mark as read right now
								toMarkAsRead = chat;
							}
						}
					});
					
					var convos = $('chat-convo').getElements('.chat-convo');
					convos.each(function(convo) {
						var last_message = convo.getElement('.chat-message:last-child');
						if(last_message) new Fx.Scroll(convo.getElement('.chat-message-wrap')).toElement(last_message);
					});
					
				}
				
				// Handle the removal of closed chats - any chat that exists but isn't in the list of new ones
				var displayedChats = $('chat-list').getElements('.chat-row').map(function(el) {
					return $(el).getData('chat-id');
				});
				
				var toRemove = displayedChats.filter(function(el) {
					return !returnedChats.contains(el);
				}).each(function(chat_id) {
					$('chat-wrap').getElements('.chat-row[data-chat-id="'+chat_id+'"], .chat-convo[data-chat-id="'+chat_id+'"]').kill();
					if(klass.convo_open == true && klass.current_convo == chat_id) { // This window was open! Let's close it offset
						$('chat-convo').dissolve();
						$('chat-wrap').tween('width', '300px');
						$('chat').set('tween', {'transition': 'sine:in:out'}).get('tween').start('width', '357px');
						$('chat-list').getElements('.chat-row.active').removeClass('active');
					}
				});
				
				if(displayedChats.length == 0) {
					$('chat-none').setStyles({'display': 'block'});
				} else {
					$('chat-none').setStyles({'display': 'none'});
				}
				
				// Run any read correction if we have to
				if(toMarkAsRead) {
					klass.xhr_read.post({ // Mark this thread as read
						'method': 'livechat-operator-read',
						'username': $('chat').getData('api-username'),
						'password': $('chat').getData('api-password'),
						'floor': chat.getElement('.chat-message:last-child').getData('message-date'),
						'chat_id': klass.current_convo
					});
					chat.getElements('.chat-message[data-message-read="false"]').setData('message-read', 'true');
				}
				
				// Flash any chats which have unread messages in by doing a search
				var newThings = $('chat-convo').getElements('.chat-message[data-message-read="false"]');
				if(newThings.length >= 1) {
					newThings.each(function(msg) {
						var chat_id = msg.getParent('.chat-convo').getData('chat-id');
						var row = $('chat-list').getElement('.chat-row[data-chat-id="'+chat_id+'"]');
						if(row) row.highlight('#fff', (row.hasClass('active') ? '#B1CEE6' : '#fff'));
					});
					klass.beep();
				}
			}
		});
		
		this.xhr_send = new Request.JSON({
			'url': $('chat').getData('api'),
			'link': 'cancel',
			'onSuccess': function(response) {
				if(response.success !== true) {
					//
				} else {
					var message = klass.formatMessage(response.sent); // Build the HTML
					var convo = $('chat-convo').getElement('.chat-convo[data-chat-id="'+response.sent.chat_id+'"]');
					var message_wrap = convo.getElement('.chat-message-wrap');
					message.inject(message_wrap);
					var last_message = convo.getElement('.chat-message:last-child');
					if(last_message) new Fx.Scroll(convo.getElement('.chat-message-wrap')).toElement(last_message);
					convo.getElement('.chat-message-input').focus();
				}
			}
		});
		
		$('chat-button').addEvent('click', this.toggle.bind(this));
		
		this.xhr_status = new Request.JSON({
			'url': $('chat').getData('api'),
			'link': 'cancel',
			'onSuccess': function(response) {
				//
			}
		});
		
		this.xhr_read = new Request.JSON({
			'url': $('chat').getData('api'),
			'link': 'cancel',
			'onSuccess': function() {
				//
			}
		});
		
		this.xhr_close = new Request.JSON({
			'url': $('chat').getData('api'),
			'link': 'cancel',
			'onSuccess': function(response) {
				//
			}
		});
		
		$('chat-refresh').addEvent('click', function() {
			klass.poll();
		});
		
		$('chat-status').addEvent('change', function(e) {
			var checked = !!this.get('checked');
			if(typeof console != 'undefined') console.info('Your current live chat operator status is '+(checked ? 'online' : 'offline'));
			if(checked) {
				klass.startPolling();
				$('chat-none').unspin();
				if(e !== false) {
					klass.xhr_status.post({
						'method': 'livechat-operator-status',
						'username': $('chat').getData('api-username'),
						'password': $('chat').getData('api-password'),
						'status': 1
					});
				}
			} else {
				klass.stopPolling();
				$('chat-list').empty();
				
				$('chat-convo').dissolve();
				$('chat-wrap').tween('width', '300px');
				$('chat').set('tween', {'transition': 'sine:in:out'}).get('tween').start('width', '357px').chain(function() {
					$('chat-none').setStyles({'display': 'block', 'opacity': 1}).spin({'message': 'You\'re currently offline! Change your status above to see who is chatting!', 'class': 'spinner spinner-nospin'});
				});
				$('chat-list').getElements('.chat-row.active').removeClass('active');
				
				if(e !== false) {
					klass.xhr_status.post({
						'method': 'livechat-operator-status',
						'username': $('chat').getData('api-username'),
						'password': $('chat').getData('api-password'),
						'status': 0
					});
				}
			}
		});
		
		$('chat-status').fireEvent('change', [false]);
		
		$('chat-wrap').addEvent('click:relay(.chat-row)', function() {
			var chat_row = this;
			var chat_id = chat_row.getData('chat-id');
			var convo = $('chat-convo').getElement('.chat-convo[data-chat-id="'+chat_id+'"]');
			klass.current_convo = chat_id;
			
			$('chat-wrap').getElements('.chat-row').removeClass('active');
			this.addClass('active');
			
			var fn = function(last_message) {
				if(!last_message) return false; // nothing has been sent yet
				klass.xhr_read.post({ // Mark this thread as read
					'method': 'livechat-operator-read',
					'username': $('chat').getData('api-username'),
					'password': $('chat').getData('api-password'),
					'floor': last_message.getData('message-date'),
					'chat_id': chat_id
				});
				convo.getElements('.chat-message[data-message-read="false"]').setData('message-read', 'true');
			}
			
			if(klass.convo_open == true) {
				new Fx.Scroll($('chat-convo'), {'duration': 150}).toElement(convo);
				var last_message = convo.getElement('.chat-message:last-child');
				if(last_message) new Fx.Scroll(convo.getElement('.chat-message-wrap')).toElement(last_message);
				convo.getElement('.chat-message-input').focus();
				fn(last_message);
			} else {
				klass.convo_open = true;
				$('chat-wrap').tween('width', '610px');
				$('chat').set('tween', {'transition': 'sine:in:out'}).get('tween').start('width', '667px').chain(function() {
					$('chat-convo').get('reveal').reveal().chain(function() {
						new Fx.Scroll($('chat-convo')).toElement(convo);
						var last_message = convo.getElement('.chat-message:last-child');
						if(last_message) new Fx.Scroll(convo.getElement('.chat-message-wrap')).toElement(last_message);
						convo.getElement('.chat-message-input').focus();
						fn(last_message);
					});
				});
			}
			
			
		});
		
		$('chat-wrap').addEvent('click:relay(.chat-message-close)', function() {
			var chat_convo = this.getParent('.chat-convo');
			var chat_id = chat_convo.getData('chat-id');
			var chat_row = $('chat-list').getElement('.chat-row[data-chat-id="'+chat_id+'"]');
			
			StickyWin.confirm('Are you sure?', 'Do you really want to close this chat now? The client will be told that the chat has been closed by the operator', function() {
			
				klass.xhr_close.post({
						'method': 'livechat-operator-close',
						'username': $('chat').getData('api-username'),
						'password': $('chat').getData('api-password'),
						'chat_id': chat_id
				});
			
				klass.stopPolling();
				
				if(klass.convo_open == true) {
					$('chat-convo').dissolve();
					$('chat-wrap').tween('width', '300px');
					$('chat').set('tween', {'transition': 'sine:in:out'}).get('tween').start('width', '357px')
					$('chat-list').getElements('.chat-row.active').removeClass('active');
				}
				
				chat_convo.destroy();
				chat_row.kill(function() {
					klass.startPolling();
				});
			});
		});
		
		if(Cookie.read('evp_chat_visible') == '1') this.show(true); // Show if it was meant to be open
	},
	'getGravatarHash': function(email) {
		return md5(email.trim().toLowerCase());
	},
	'getGravatarImg': function(email, size) {
		return (window.location.protocol == 'https:' ? 'https://secure.' : 'http://www.')+'gravatar.com/avatar/'+this.getGravatarHash(email)+'?s=20&d=mm';
	},
	'beep': function() {
		var klass = this;
		var beep_url = $('chat').getData('beep-url');
		if(!beep_url) return false;
		
		/*
		var i = setInterval(function() {
			if(typeof soundManager == 'undefined') return;
			clearInterval(i);
			soundManager.onready(function() {
				if(!klass.sound_beep) {
					klass.sound_beep = soundManager.createSound({
						'id': 'beep',
						'url': beep_url
					});
				}
				klass.sound_beep.play();
			});
		}, 10);
		*/
	},
	'addChatToList': function(chat) {
		if($('chat-list').getElement('.chat-row[data-chat-id="'+chat.id+'"]')) return false; // Don't duplicate chats
		
		var row = new Element('div', {
			'class': 'chat-row'
		});
		
		row.store('chat', chat);
		row.setData('chat-id', chat.id);
		
		new Element('div', {
			'class': 'chat-row-avatar'
		}).inject(row).adopt(		
			new Element('img', {
				'src': this.getGravatarImg(chat.client_email, 20),
				'class': 'chat-row-avatar-img'
			})
		);
		
		var wrap = new Element('div', {
			'class': 'chat-row-wrap'
		}).inject(row);
		
		new Element('div', {
			'class': 'chat-row-link',
			'text': chat.client_name+' ('+chat.client_email+')'
		}).inject(wrap);
		
		new Element('div', {
			'class': 'chat-row-meta',
			'text': 'Started: '+chat.date
		}).inject(wrap);
		
		if(chat.client_country && chat.client_country.length == 2) { // Only display if a two-letter country code
			new Element('img', {
				'class': 'chat-row-country',
				'src': 'http://www.geonames.org/flags/x/'+chat.client_country.toLowerCase()+'.gif'
			}).inject(wrap);
		}
		
		new Element('div', {'class': 'clear'}).inject(wrap);
		new Element('div', {'class': 'clear'}).inject(row);
		
		return row;
	},
	'addConvoToList': function(chat) {
		if($('chat-convo').getElement('.chat-convo[data-chat-id="'+chat.id+'"]')) return false; // Don't duplicate convo areas
		
		var klass = this;
		
		var convo = new Element('div', {
			'class': 'chat-convo'
		});
		
		convo.setData('chat-id', chat.id);
		
	 var handleSend = function() {
	 	var msg = input.get('value');
	 	if(msg == '') return;
	 	
	 	input.set('value', '').focus(); // Empty the input
	 	
	 	klass.sendChat(msg, chat.id);
	 };
		
		var message_wrap = new Element('div', {
			'class': 'chat-message-wrap'
		}).inject(convo);
		
		var reply = new Element('div', {
			'class': 'chat-message-reply'
		}).inject(convo);
		
		var input = new Element('input', {
			'type': 'text',
			'class': 'chat-message-input',
			'events': {
				'keyup': function(event) {
					if(event && event.key == 'enter') handleSend();
				}
			}
		}).inject(reply);
		
		new Element('div', {
			'class': 'align-left chat-message-close',
			'text': 'Close'
		}).setData('behavior', 'Button').setData('button-type', 'action_small').setData('button-width', '40').inject(reply);
		
		new Behavior().apply(reply);
		
		return convo;
	},
	'formatMessage': function(data, chat) {
		// data.chat_id, data.date, data.type, data.read, data.body
		if(data.id) if($('chat-convo').getElement('.chat-message[data-message-id="'+data.id+'"]')) return false; // Don't duplicate messages over and over again
		
		var email = (data.type == '0' ? $('chat').getData('api-username') : chat.client_email);
		
		var body = stripslashes(data.body); // handle HTML? handle any commands in here maybe?
		var block_avatar = '<div class="evp-widget-live-chat-message-avatar" style="width: 20px; height: 20px; '+(data.type == '0' ? 'float:right;margin:0 0 5px 5px;' : 'float:left;margin: 0 5px 5px 0;')+'"><img src="'+this.getGravatarImg(email, 20)+'" /></div>';
		var block_body = '<div class="evp-widget-live-chat-message-body" style="">'+body+'</div>';
		
		var message = '<div class="chat-message chat-message-from-'+(data.type == '0' ? 'operator' : 'client')+'" data-message-date="'+data.date+'" data-message-read="'+((data.read == 1 || data.type == '0') ? 'true': 'false')+'" data-message-id="'+data.id+'">';
		
		if(data.type == '1') {
			message += block_avatar;
			message += block_body;
		} else {
			message += block_avatar;
			message += block_body;
		}
		
		message += '</div>';
		
		var el = Elements.from(message);
		
		return el;
	},
	'sendChat': function(body, chat_id) {	
		
		var data = {
			'method': 'livechat-operator-send',
			'username': $('chat').getData('api-username'),
			'password': $('chat').getData('api-password'),
			'chat_id': chat_id,
			'date': new Date(),
			'type': 0,
			'read': 0,
			'body': body
		};
		
		// Send it off to the client
		this.xhr_send.post(data);
	},
	'poll': function() {
		this.xhr.post({
			'method': 'livechat-poll',
			'username': $('chat').getData('api-username'),
			'password': $('chat').getData('api-password')
		});
	},
	'startPolling': function() {
		this.poll();
		this.pollPeriodical = this.poll.periodical(20000, this);
	},
	'stopPolling': function() {
		clearInterval(this.pollPeriodical);
	},
	'show': function(instant) {
		if(!this.element) return false;
		this.visible = true;
		Cookie.write('evp_chat_visible', '1');
		if(instant === true) {
			$('chat').setStyle('left', 0);
			return;
		}
		this.fx.start({
			'left': '0px'
		});
	},
	'hide': function(instant) {
		if(!this.element) return false;
		Cookie.write('evp_chat_visible', '0');
		if(this.convo_open == true) {
			$('chat-convo').dissolve();
			$('chat-wrap').tween('width', '300px');
			$('chat').get('tween').start('width', '357px')
			$('chat-list').getElements('.chat-row.active').removeClass('active');
		}
		this.convo_open = false;
		this.visible = false;
		this.current_convo = false;
		if(instant === true) {
			$('chat').setStyle('left', '-321px');
			return;
		}
		this.fx.start({
			'left': '-321px'
		});
	},
	'toggle': function() {
		if(!this.element) return false;
		if(this.visible === true) {
			this.hide();
		} else {
			this.show();
		}
	}
}

var EVP_Helpers = {
	'initBreadcrumbs': function() {
		var crumbs = $('breadcrumbs').getElements('.breadcrumb');
		crumbs.addEvent('click', function() {
			var file_id = $('thisFile').retrieve('file_id');
			var file_profile = $('thisFile').retrieve('file_profile');
			var url = this.getData('url');
			var go = url+'?id='+file_id;
			if(crumbs.indexOf(this) !== 0) {
				go = go+'&profile='+file_profile;
			}
			window.url(go);
		});
	},
	'setBreadcrumb': function(step, animate) { // Provide the step as literally 1, 2, 3, 4
		if(!$('breadcrumbs')) return false;
		if(step > 4) step = 4;
		
		step--; // Decrease so it's 0-based
		
		var breadcrumbs = $('breadcrumbs').getElements('.breadcrumb');
		var line = $('breadcrumb-line');
		
		var completed = breadcrumbs.filter(function(el, idx) {
			return (idx < step);
		});
		
		if(animate === false) {
			line.setStyles({'width': step * 225});
			breadcrumbs.removeClass('complete').removeClass('current');
			completed.addClass('complete');
			breadcrumbs[step].addClass('current');
		} else {		
			var fx = new Fx.Tween(line);
			fx.start('width', step * 225);
			
			(function() {
				line.highlight('#fff');
				breadcrumbs.removeClass('complete').removeClass('current');
				completed.addClass('complete');
				breadcrumbs[step].addClass('current');
			}).delay(600);
		}
		
	},
	'hex2rgb': function(hex) {
  if(hex[0]=="#") hex=hex.substr(1);
  if(hex.length == 3) {
   var temp = hex; hex = '';
   temp = /^([a-f0-9])([a-f0-9])([a-f0-9])$/i.exec(temp).slice(1);
   for (var i = 0; i < 3; i++) hex += temp[i] + temp[i];
  }
  var triplets = /^([a-f0-9]{2})([a-f0-9]{2})([a-f0-9]{2})$/i.exec(hex).slice(1);
  return {
   red:   parseInt(triplets[0],16),
   green: parseInt(triplets[1],16),
   blue:  parseInt(triplets[2],16)
  }
	},
	'rgb2hex': function(r,g,b) {
  var rgb = [r.toString(16),g.toString(16),b.toString(16)]
  for (var i = 0; i < 3; i++) {
    if (rgb[i].length==1) rgb[i] = rgb[i]+rgb[i];
  }
  if(rgb[0][0]==rgb[0][1] && rgb[1][0]==rgb[1][1] && rgb[2][0]==rgb[2][1]) return ''+rgb[0][0]+rgb[1][0]+rgb[2][0];
  return ''+rgb[0]+rgb[1]+rgb[2];
	},
	'generateGradient': function(startColorStr, endColorStr, percentFade) {						
		if(typeof endColorStr !== 'string') endColorStr = 'ffffff';
		
		var startColor = EVP_Helpers.hex2rgb(startColorStr);
		var endColor = EVP_Helpers.hex2rgb(endColorStr);
		
		var diffRed = endColor.red - startColor.red;
		var diffGreen = endColor.green - startColor.green;
		var diffBlue = endColor.blue - startColor.blue;
		
		diffRed = Math.ceil((diffRed * percentFade) + startColor.red);
		diffGreen = Math.ceil((diffGreen * percentFade) + startColor.green);
		diffBlue = Math.ceil((diffBlue * percentFade) + startColor.blue);
		
	 return EVP_Helpers.rgb2hex(diffRed, diffGreen, diffBlue);
	}
}