var RadioGroup = new Class({
		Implements: [Options, Events],
		options: {
			'onCheck': $empty,
			'width': '100px'
		},
		'initialize': function(el, options) {
			this.setOptions(options);
			this.el = $(el);
			
			this.el.addClass('radio-group-visible');
			
			var id = this.el.get('id') || 'radio-group-'+Number.random(100, 1000);
			
			this.wrapper = new Element('div', {
				'id': id+'-radio-wrapper',
				'class': 'radio-group-wrapper'
			});
			
			this.hidden = new Element('div', {
				'id': this.wrapper.get('id')+'-hidden',
				'class': 'radio-group-hidden',
				'styles': {
					'display': 'none'
				}
			});
			
			this.opts = this.el.getElements('input[type="radio"]');
			this.labels = this.el.getElements('label[for]');
			this.visible = [];
			
			var klass = this;
			
			this.opts.each(function(opt, idx) {
				var div = new Element('div', {
					'class': 'radio-group-option',
					'text': this.labels[idx].get('text'),
					'styles': {
						'width': parseInt(this.options.width)+'px'
					},
					'events': {
						'mouseenter': function() {
							this.addClass('radio-group-option-hover');
						},
						'mouseleave': function() {
							this.removeClass('radio-group-option-hover');
						},
						'click': function() {
							klass.select(opt);
						}
					}
				});
				
				div.setData('name', opt.get('name'));
				div.setData('value', opt.get('value'));
				
				this.el.adopt(div);
				
				this.visible.push(div);
				
				this.hidden.adopt(opt, this.labels[idx]);
				
				if(opt.get('checked')) {
					this.select(opt);
				}
			}, this);
			
			this.wrapper.adopt(this.hidden);
			
			this.wrapper.wraps(this.el);
			
			this.resize.bind(this).delay(500);
		},
		'resize': function() {
			var width = 0;
			this.visible.each(function(el) {
				width += el.measure(function() {
						return this.getSize().x;
				});
			});
			this.wrapper.setStyle('width', width);
		},
		'select': function(reference) {
			if(typeof reference == 'undefined') return;
			var hidden_element = (typeof reference == 'number' ? this.opts[reference] : $(reference));
			var idx = this.opts.indexOf(hidden_element);
			var visible_element = this.visible[idx];
			
			this.visible.each(function(el) {
				$(el).removeClass('radio-group-option-active');
			});
			
			visible_element.addClass('radio-group-option-active');

			hidden_element.set('checked', true).fireEvent('click').fireEvent('change');
			
			this.fireEvent('onCheck', [visible_element, hidden_element, idx]);
		}
	});