<!-- BUFFER -->

<style type="text/css">
.box.alt .body { padding: 10px; }

div.middle-circle { 
	background: -moz-linear-gradient(top, #ececec 0%, #d8d8d8 100%);
	background: -webkit-gradient(linear, left top, left bottom, color-stop(0%,#ececec), color-stop(100%,#d8d8d8));
	background: -webkit-linear-gradient(top, #ececec 0%,#d8d8d8 100%);
	background: -o-linear-gradient(top, #ececec 0%,#d8d8d8 100%);
	background: -ms-linear-gradient(top, #ececec 0%,#d8d8d8 100%);
	filter: progid:DXImageTransform.Microsoft.gradient( startColorstr='#ececec', endColorstr='#d8d8d8',GradientType=0 );
	background: linear-gradient(top, #ececec 0%,#d8d8d8 100%);
}

div.circle { width: 300px; height: 300px; margin: 50px 0 0 110px; }
div.outer-circle { background: transparent; width: 222px; height: 222px; -webkit-border-radius: 161px; -moz-border-radius: 161px; border-radius: 161px; border: 1px solid #aaa; position: absolute; z-index: 800; -webkit-transition: all .2s ease-in-out; -moz-transition: all .2s ease-in-out; -o-transition: all .2s ease-in-out; transition: all .2s ease-in-out; }
div.outer-circle.hover { -moz-transform: scale(1.45); -webkit-transform: scale(1.45); transform: scale(1.45); }
div.middle-circle { width: 222px; height: 222px; -webkit-border-radius: 161px; -moz-border-radius: 161px; border-radius: 161px; background: #ececec; position: absolute; z-index: 900; -webkit-transition: all .2s ease-in-out; -moz-transition: all .2s ease-in-out; -o-transition: all .2s ease-in-out; transition: all .2s ease-in-out; margin: 1px; }
div.middle-circle.hover { -moz-transform: scale(1.4); -webkit-transform: scale(1.4); transform: scale(1.4); }
div.inner-circle { text-shadow: 1px 1px 0 #1D618F; background: #3f96d1; width: 196px; height: 196px; font-size: 11px; color: #fff; text-align: center; font-family: Arial; -webkit-border-radius: 148px; -moz-border-radius: 148px; border-radius: 148px; -webkit-box-shadow: inset 0 1px 1px 0 #575757; -moz-box-shadow: inset 0 1px 1px 0 #575757; box-shadow: inset 0 1px 1px 0 #575757; border-bottom: 1px solid #FFF; position: absolute; z-index: 1000; margin: 14px; }

.circle-content { z-index: 1001; position: absolute; width: 300px; height: 300px; }

.map-list-site-name { display: block; text-align: center; width: 150px; margin: 85px auto 0 auto; font-size: 13px; }
.map-list-site-total {  }

.live-table-referrers tbody { border-left: 1px solid #eee; border-right: 1px solid #eee; }
.google-visualization-table-td { border-left: none; border-right: none; }
</style>

<script type="text/javascript">
Plot = function(stage) {
 this.setDimensions = function(x, y) {
  this.elm.style.width = x + 'px';
  this.elm.style.height = y + 'px';
  this.width = x;
  this.height = y;
 };
 this.position = function(x, y) {
   var xoffset = arguments[2] ? 0 : this.width / 2;
   var yoffset = arguments[2] ? 0 : this.height / 2;
   this.elm.style.left = (x - xoffset) + 'px';
   this.elm.style.top = (y - yoffset) + 'px';
   this.x = x;
   this.y = y;
 };
 this.setBackground = function(col) {
   this.elm.style.background = col;
 };
 this.rotate = function(str) {
  this.elm.style.webkitTransform = this.elm.style.MozTransform = 
  this.elm.style.OTransform = this.elm.style.transform = 
  'rotate(' + str + ')'; 
 };
 this.content = function(content) {
  this.elm.innerHTML = content;
 };
 this.round = function(round) {
  this.elm.style.borderRadius = round ? '50%/50%' : '';
 };
 this.elm = document.createElement('div');
 this.elm.style.position = 'absolute';
 stage.appendChild( this.elm );
};

window.addEvent('domready', function() {
	$$('.circle').each(function(el) {
		el.getElement('.circle-content').setStyle('opacity', 0);
		
		el.addEvents({
			'mouseenter': function() {
				this.getElement('div.outer-circle').addClass('hover');
				this.getElement('div.middle-circle').addClass('hover');
				this.getElement('.circle-content').fade('in');
			},
			'mouseleave': function() {
				this.getElement('div.outer-circle').removeClass('hover');
				this.getElement('div.middle-circle').removeClass('hover');
				this.getElement('.circle-content').fade('out');
			}
		});
	});
	
	$('map-list').getElements('.box.alt').each(function(box) {
		box.getElement('.circle-content').setStyle('opacity', 0);
		box.addEvents({
			'mouseenter': function() {
				this.getElement('div.outer-circle').addClass('hover');
				this.getElement('div.middle-circle').addClass('hover');
				this.getElement('.circle-content').fade('in');
			},
			'mouseleave': function() {
				this.getElement('div.outer-circle').removeClass('hover');
				this.getElement('div.middle-circle').removeClass('hover');
				this.getElement('.circle-content').fade('out');
			}
		});
	});
	
	function buildChart(chart, data, container, opts) {	
		var dims = container.measure(function() {
			return this.getSize();
		});
		
		var opts = Object.merge({
			'vAxis': {
				'viewWindow': {
					'min': 0
				}
			},
			'width': dims.x,
			'height': dims.y,
			'legend': {
				'position': 'right'
			}
		}, opts || {});
		
		chart.draw(data, opts);
	}
	
	var sites = <?php echo json_encode($export); ?>;
	var videoData = <?php echo json_encode($tinyVideoData); ?>;
	var no_image = '<?php echo $no_image; ?>';
	
	Object.each(sites, function(site) {
		var id = 'site-'+base64_encode(site.name);
		var stage = $(id).getElement('.circle-content'),
		 plots = site.videos.length,
		 increase = Math.PI * 2 / plots,
		 angle = 0,
		 x = 0,
		 y = 0;
		 
		// Build the circle
	 Array.each(site.videos, function(video) {
			var vid = videoData[video] || {
				'name': base64_decode(video) || 'Unknown',
				'thumbnail': no_image,
				'thumbnail_width': 40,
				'thumbnail_height': 40
			};
			
			// Check for profiles in the file_ref
			if(video.test('::')) {
				var parts = video.split('::');
				vid.name = base64_decode(parts[0])+': '+parts[1].replace(/\-/g, ' ');
			}
			
			var p = new Plot(stage);
			p.setBackground('url('+vid.thumbnail+')');
			p.elm.style['background-size'] = vid.thumbnail_width+'px '+vid.thumbnail_height+'px';
			p.setDimensions(40, 40);
		 x = 127 * Math.cos(angle) + 110;
		 y = 127 * Math.sin(angle) + 110;
		 p.position(x, y);
		 p.round(true);
		 angle += increase;
		 $(p.elm).setData('behavior', 'BetterTip').setData('tip-direction', (angle >= 4 ? 9 : 3)).setData('tip-width', '100').set('rel', vid.name);
	 });
	
		// Build the chart
		var container = $(id).getElement('.live-table-referrers');
		var raw = [['Video name', 'Completed plays on this site']];
		var shouldDisplay = false;
		Object.each(site.videos, function(video) {
			var vid = videoData[video] || {
				'name': base64_decode(video) || 'Unknown',
				'thumbnail': no_image,
				'thumbnail_width': 40,
				'thumbnail_height': 40,
				'stats': {
					'starts': 0,
					'completes': 0,
					'referrers': {}
				}
			};
			
			// Check for profiles in the file_ref
			if(video.test('::')) {
				var parts = video.split('::');
				vid.name = base64_decode(parts[0])+': '+parts[1].replace(/\-/g, ' ');
			}
			
			shouldDisplay = true;
			raw.push([vid.name, parseInt(vid.stats.referrers[site.name]) || 0]);
		});
		
		if(shouldDisplay) {
			var data = google.visualization.arrayToDataTable(raw);
			
			var tbl = new google.visualization.Table(container);
			buildChart(tbl, data, container, {
				'chartArea': {'width': '430px', 'height': '330px'},
				'width': '430px',
				'height': '330px',
				'page': 'enable',
				'pageSize': 15
			});
		}
		 
	});
	
	new Behavior().apply('map-list');
});
</script>

<div id="map-list">
	<?php foreach($export as $site) : ?>
		<div class="box alt" id="site-<?php echo base64_encode($site['name']); ?>" class="site"><div class="wrap auto">
			<h2><?php echo $site['name']; ?></h2>
			<div class="body self-clear">
				
				<div class="align-left">
					<div class="circle">
						<div class="outer-circle"></div>
						<div class="middle-circle"></div>
						<div class="inner-circle">
							<span class="map-list-site-name"><?php echo $site['name']; ?></span>
							<span class="map-list-site-total">
								<?php
								$size = sizeof($data[$site['name']]['videos']);
								if($size >= 30) echo 'More than ';
								echo $size;
								?> videos
							</span>
						</div>
						<div class="circle-content"></div>
					</div>
				</div>
				<div class="align-left">
					<div class="live-table live-table-referrers"></div>
				</div>
				
			</div>
		</div></div>
	<?php endforeach; ?>
</div>