<!-- BUFFER -->

<script type="text/javascript">
window.addEvent('domready', function() {
	var buildChartSelector = function(wrap) {
		wrap = $(wrap);
		var select = wrap.getElement('select');
		var divs = wrap.getElements('div').setStyle('opacity', 0);
		select.addEvent('change', function() {
			var idx = this.selectedIndex;
			divs.setStyle('display', 'none').setStyle('opacity', 0);
			divs[idx].setStyle('display', 'block').fade('in');
		});
		select.fireEvent('change');
	}

	if($('chart-split')) buildChartSelector('chart-split');
});

function createDatesArray(days) {
	var output = [];

	var month = date('m');
	var day = date('d');
	var year = date('Y');

	for(i = 1; i <= days; i++) {
		output.push(date('Y-m-d', mktime(0, 0, 0, month, (day - i), year)));
	}

	return output;
}

// Make the placeholder
var placeholder = {'time': {'dates':{}}};
var previous_days = createDatesArray(6);
placeholder.time.dates[date('Y-m-d')] = 0;
Object.each(previous_days, function(d) {
	placeholder.time.dates[d] = 0;
});

// 'This week' graph
var buildThisWeek = function(response, container) {

	var viewDates = {};
	var playDates = {};
	var saleDates = {};

	var raw = [['Date', 'Plays', 'Completed plays', 'Sales']];

	Object.each(placeholder.time.dates, function(value, date) {
		viewDates[date] = (response.stats.recent[date] || {}).starts;
		if(!viewDates[date]) viewDates[date] = value;

		playDates[date] = (response.stats.recent[date] || {}).completes;
		if(!playDates[date]) playDates[date] = value;

		saleDates[date] = (response.stats.recent[date] || {}).sales;
		if(!saleDates[date]) saleDates[date] = value;

		viewDates[date] = parseInt(viewDates[date]);
		playDates[date] = parseInt(playDates[date]);
		saleDates[date] = parseInt(saleDates[date]);
	});

	viewDates = ksort(viewDates); // Reverse so that the oldest date is to the left
	playDates = ksort(playDates);
	saleDates = ksort(saleDates);

	var i = 0;

	Object.each(viewDates, function(value, date) {
		var label = date;
		if(i == 6) label = 'Today';
		else if(i == 5) label = 'Yesterday';
		else label = Date.parse(label).format('%e%o of %b');
		raw.push([label, value, playDates[date], saleDates[date]]);
		i++;
	});

	var data = google.visualization.arrayToDataTable(raw);
	var chart = new google.visualization.AreaChart(container);

	var dims = container.measure(function() {
		return this.getSize();
	});

	var opts = Object.merge({
		'vAxis': {'viewWindow': {'min': 0}},
		'backgroundColor': '#fafafa',
		'width': dims.x,
		'height': dims.y,
		'chartArea': {
			'width': '80%'
		},
		'legend': {
			'position': 'top'
		}
	}, opts || {});

	chart.draw(data, opts);
};

</script>

<style type="text/css">
#split_test_stats th { font-size: 14px; line-height: 18px; }
</style>

<?php /* Breadcrumb navigation here */ ?>
<div class="breadcrumbs" id="breadcrumbs">
	<div data-behavior="Grid" data-grid-padding="10">
		<div data-column-width="170">
			<a id="ui-breadcrumbs-back" href="<?php echo url('list.splittests.php', false, false); ?>" data-behavior="Button" data-button-icon="back" data-button-iconpos="left" data-button-width="90">Back</a>
		</div>
	</div>
	<div class="clear"></div>
</div>

<div class="table alt" id="split_test_stats"><div class="wrap auto">
	<h2>Split test statistics: <?php echo $split_test->name; ?></h2>
	<div class="body styled descend" style="padding:10px;">
		<?php if(!empty($split_test->best_file) && $split_test->best_file !== 'NULL') :
		$best_file = $evp->getFile($split_test->best_file);
		?>
		<p class="success">This split test has ended, and is consistently serving this file: <?php echo "<a href=\"".fileLink($split_test->best_file, 'files.embed.php')."\">{$best_file->name}</a>"; ?>.</p>
		<?php endif; ?>
		<p class="info">Below are all of the files included in this split test, and their primary metrics. You can view in-depth statistics as normal by clicking on the icon in each row!</p>
		<table data-behavior="HtmlTable" data-htmltable-sortable="true" class="data-table">
			<tbody>
				<th scope="col" class="name">File name</th>
				<th scope="col" class="int">Views</th>
				<th scope="col" class="int">Plays</th>
				<th scope="col" class="int">Completion %</th>
				<th scope="col" class="int">Sales</th>
				<th scope="col" class="price">Income</th>
				<th scope="col" class="int">Clickthroughs</th>
				<th scope="col" class="int">FB Likes/Shares</th>
				<th scope="col" class="int">Diggs</th>
				<th scope="col" class="int">Twitter Shares</th>
				<th scope="col">&nbsp;</th>
			</tr>
			<?php if(empty($split_test->files)) : ?>
				<tr class="norows"><td colspan="11">You have not got any files in this split test!</td></tr>
			<?php else : ?>
				<?php foreach($split_test->files as $fid) : ?>
				<?php
				$profile = '';
				if(stripos($fid, '::') !== false) $profile = grab(explode('::', $fid, 2), '1');

				$file = $split_test->realFiles[$fid];
				$completionPercentage = 0;
				if($file->stats->static->completes > 0 && $file->stats->static->starts > 0) $completionPercentage = ceil(($file->stats->static->completes / $file->stats->static->starts) * 100);
				?>
				<tr <?php if(!empty($best_file) && $fid == $split_test->best_file) echo 'style="background:#EDFBD8;"';?>>
					<th scope="row"><?php echo "<a href=\"files.embed.php?id={$file->id}&profile={$profile}\">{$file->name}</a>"; ?><?php if($profile !== 'default' && $profile !== '' && !empty($profile)) : ?><span style="display:block;">Profile: <?php echo $profile; ?></span><?php endif; ?></th>
					<td class="int"><?php echo number_format($file->stats->static->starts); ?></td>
					<td class="int"><?php echo number_format($file->stats->static->completes); ?></td>
					<td class="int"><?php echo $completionPercentage; ?>%</td>
					<td class="int"><?php echo number_format($file->stats->total_sales); ?></td>
					<td class="price">$<?php echo formatPrice($file->stats->total_income); ?></td>
					<td class="int"><?php echo number_format($file->social_stats->post_video_redirect); ?></td>
					<td class="int"><?php echo number_format($file->social_stats->facebook_likes); ?></td>
					<td class="int"><?php echo number_format($file->social_stats->diggs); ?></td>
					<td class="int"><?php echo number_format($file->social_stats->twitter_shares); ?></td>
					<td class="int"><?php echo "<a href=\"files.livestats.php?id={$file->id}&profile={$profile}\" class=\"action\" rel=\"View complete statistics\" style=\"margin:0;\"><img src=\"{$themeDir}assets/icons/stats.png\" /></a>"; ?></td>
				</tr>
				<?php endforeach; ?>
			<?php endif; ?>
			</tbody>
		</table>
	</div>
</div></div>

<?php if(!empty($split_test->files)) : ?>
	<?php foreach($split_test->files as $fid) : $file = $split_test->realFiles[$fid]; $chart_div = 'chart-'.$fid; ?>
		<div class="box alt column"><div class="wrap auto">
			<h2><?php echo string_trim($file->name, 40); ?></h2>
			<script type="text/javascript">
			window.addEvent('domready', function() {
				var container = $('<?php echo $chart_div; ?>');
				var stats = {"stats": <?php echo json_encode($file->stats); ?>};

				google.charts.load('current', {'packages':['corechart']});
				google.charts.setOnLoadCallback(function() {
					buildThisWeek(stats, container);
				});
			});
			</script>
			<div class="live-chart" id="<?php echo $chart_div; ?>"></div>
		</div></div>
	<?php endforeach; ?>
<?php endif; ?>
