<!-- BUFFER -->
<script type="text/javascript">
window.addEvent('load', function() {
	var queue = new Request.Queue({
		'onEnd': function() {
			$('complete-wrap').setStyle('visibility', 'visible');
		}
	});
	
	if($('files')) {
		$('files').getElements('tbody tr').each(function(row) {
			var xhr = new Request.JSON({
				'link': '',
				'url': '<?php echo url('api.php', false, true); ?>',
				'onRequest': function() {
					var current = Object.keys(queue.getRunning())[0];
					if(current && $(current)) $(current).spin();
				},
				'onSuccess': function(response) {
					var current = response.request_id;
					if(current && $(current)) $(current).unspin();
					if(response.success !== true) {
						$(current).getElements('.retry').setStyle('visibility', 'visible');
						$(current).morph({'background-color': '#ffecce'});
						$(current).getElements('.status').set('text', 'Failed!');
					} else {
						$(current).morph({'background-color': '#edfbd8'});
						$(current).getElements('.status').set('text', 'Completed successfully.');
					}
				},
				'onFailure': function() {
					var current = Object.keys(queue.getRunning())[0];
					if(current && $(current)) {
						$(current).getElements('.retry').setStyle('visibility', 'visible');
						$(current).morph({'background-color': '#ffecce'});
						$(current).getElements('.status').set('text', 'Failed!');
					}
				}
			});
			
			queue.addRequest(row.get('id'), xhr);
			
			xhr.post({
				'request_id': row.get('id'),
				'method': 's3-copy',
				'folder_id': '<?php echo $folder; ?>',
				'source': '<?php echo $source; ?>',
				'target_name': row.getData('name'),
				'username': '<?php echo $currentUser->username; ?>',
				'password': '<?php echo $currentUser->password; ?>'
			});
			
			row.store('xhr', xhr);
		});
		
		var copy = function(row) {
			if(!row) return;
			row.retrieve('xhr').post({
				'request_id': row.get('id'),
				'method': 's3-copy',
				'folder_id': '<?php echo $folder; ?>',
				'source': '<?php echo $source; ?>',
				'target_name': row.getData('name'),
				'username': '<?php echo $currentUser->username; ?>',
				'password': '<?php echo $currentUser->password; ?>'
			});
		}
		
		$('files').getElements('.retry').addEvent('click', function() {
			var row = this.getParent('tr');
			copy(row);
		});
	}
	
	
});
</script>

<?php if(!empty($message)) echo '<p class="error">'.$message.'</p>'; ?>

<?php if(!empty($files)) : ?>
	<div class="table table-padded alt clear" id="files"><div class="wrap">
		<h2>Copy your video files</h2>
		<table data-behavior="HtmlTable" data-htmltable-sortable="true">
			<thead>
				<tr>
					<th>File name</th>
					<th width="200">Status</th>
					<th width="40">&nbsp;</th>
				</tr>
			</thead>
			<tfoot><tr><td colspan="3"><div id="complete-wrap" style="visibility:hidden;"><a id="complete" class="align-right" href="list.files.php?id=<?php echo $folder; ?>&refresh_files=1" data-behavior="Button" data-button-width="100">View folder</a></div></td></tr></tfoot>
			<tbody>
				<?php
					foreach($files as $idx => $i) {
						echo '<tr id="row-'.mt_rand().'" data-name="'.escape($i->file_name).'">';
						echo '<td>'.$i->file_name.'</td>';
						echo '<td><span class="status">Waiting&hellip;</span></td>';
						echo '<td><a class="retry" style="visibility: hidden;">Retry</a></td>';
						echo '</tr>';
					}
				?>
			</tbody>
		</table>
	</div></div>
<?php endif; ?>

<?php if(!empty($unsupported_files)) : ?>
	<div class="table table-padded alt clear"><div class="wrap">
		<h2>Unsupported files</h2>
		<p class="error">The following files were detected, but are not compatible with <?php echo $evp->options->project_name; ?>. You can use the links next to them to download them to your computer and convert them using our new desktop software!</p>
		<table data-behavior="HtmlTable" data-htmltable-sortable="true">
			<thead>
				<tr>
					<th>File name</th>
					<th width="40">&nbsp;</th>
				</tr>
			</thead>
			<tfoot><tr><td colspan="2"></td></tr></tfoot>
			<tbody>
				<?php
					foreach($unsupported_files as $idx => $i) {
						echo '<tr>';
						echo '<td>'.$i->file_name.'</td>';
						echo '<td><a data-behavior="Button" data-button-type="action_small" data-button-width="100" href="'.$i->download_url.'">Download</a></td>';
						echo '</tr>';
					}
				?>
			</tbody>
		</table>
	</div></div>
<?php endif; ?>