<?php
// Get the potential themes
$page_themes = $evp->getPageThemes();
$page_theme_size = 120 * (sizeof($page_themes));

// Get the potential background images
$background_images = $evp->loadFromDirectory('themes/3.0/assets/backgrounds/');
$size = 120 * (sizeof($background_images) + 1);
?>

<link rel="stylesheet" href="<?php echo url('themes/3.0/styles/style.widgets.css', array('v' => '1')); ?>" />
<link rel="stylesheet" id="page-theme-css" href="<?php echo url('themes/3.0/assets/themes/default/style.css', array('v' => '1')); ?>" />

<script type="text/javascript">
window.addEvent('domready', function() {

	// Page themes
	var selectPageTheme = function(theme_slug) {
		if($(theme_slug)) {
			$(theme_slug).getElement('.selector').addClass('active');
		//$('page-preview-area').setStyle('background-image', $(theme_slug).getElement('.page-theme-selector-preview').getStyle('background-image'));
		}
		var d = $('thisFile').retrieve('data'); d['page-theme'] = theme_slug;
		$('thisFile').store('data', d);
		// Update the CSS
		if($('page-theme-css')) {
			$('page-theme-css').set('href', $(theme_slug).getData('theme-css'));
		}
		
		if($(theme_slug).getData('theme-allowcontentarea') == 'true') {
			if($('page-layout-contentarea')) $('page-layout-contentarea').reveal();
		} else {
			if($('page-layout-contentarea')) $('page-layout-contentarea').dissolve();
		}
		
		if($(theme_slug).getData('theme-allowcustombackground') == 'true') {
			if($('page-layout-backgroundarea')) $('page-layout-backgroundarea').reveal();
		} else {
			if($('page-layout-backgroundarea')) $('page-layout-backgroundarea').dissolve();
		}

		
	}
	
	$('page_themes').addEvent('click:relay(.page-theme-selector-skin)', function() {
		var c = this;
		var skin_name = c.getData('theme-name'), theme_slug = c.getData('theme-slug');
		$('page_themes').getElements('.active').removeClass('active');
		
		selectPageTheme(theme_slug);
	});
	
	selectPageTheme.pass($('thisFile').retrieve('data')['page-theme'] || 'default').delay(250);
	
	if($('page_themes').getElements('.page-theme-selector-skin').length > 7) {
		makeScrollbar($('page_themes').getElement('div'), $('page_themes').getElement('.scrollbar-hor'), $('page_themes').getElement('.scrollbar-hor').getElement('div'), true, false);
	} else {
		$('page_themes').getElement('.scrollbar-hor').destroy();
	}
	
	// Background images	
	var selectBackgroundImage = function(bg_slug) {
		if($(bg_slug)) {
			$(bg_slug).getElement('.selector').addClass('active');
			$('page-preview-area').setStyle('background-image', $(bg_slug).getElement('.background-image-selector-preview').getStyle('background-image'));
		}
		var d = $('thisFile').retrieve('data'); d['page-background-image'] = bg_slug;
		$('thisFile').store('data', d);
	}
	
	$('background_images').addEvent('click:relay(.background-image-selector-skin)', function() {
		var c = this;
		var skin_name = c.getData('skin-name'), bg_slug = c.getData('skin-slug');
		$('background_images').getElements('.active').removeClass('active');
		
		selectBackgroundImage(bg_slug);
	});
	
	selectBackgroundImage.pass($('thisFile').retrieve('data')['page-background-image'] || 'no-image').delay(250);
	
	makeScrollbar($('background_images').getElement('div'), $('background_images').getElement('.scrollbar-hor'), $('background_images').getElement('.scrollbar-hor').getElement('div'), true, false);
	
	$('background-colour').addEvent('change', function() {
		var bg = this.get('value');
		$$('.background-image-selector-skin').setStyle('background-color', bg);
		$('page-preview-area').setStyle('background-color', bg);
	}).set('value', ($('thisFile').retrieve('data')['page-background-colour'] || '#ffffff')).fireEvent.pass('change').delay(500);
});
</script>

<div id="page_themes" class="clear ui-settings-selector margin-bottom">
	<div style="overflow: hidden; width: 837px; height: 130px; margin: 0 0 10px 0;">
		<div style="width:<?php echo $page_theme_size; ?>px;overflow:auto;">
			<?php foreach($page_themes as $theme) : $theme = $evp->getPageTheme($theme->slug); if(!$theme) continue; ?>
			<div class="align-left" style="margin: 10px;">
				<div class="page-theme-selector-skin" data-theme-name="<?php echo $theme->name; ?>" data-theme-css="<?php echo $theme->location.'style.css?v=6-27'; ?>" data-theme-slug="<?php echo $theme->slug; ?>" data-theme-allowcustombackground="<?php echo boolToString($theme->config->allow_custom_background); ?>" data-theme-allowcontentarea="<?php echo boolToString($theme->config->allow_content_area); ?>" id="<?php echo $theme->slug; ?>">
					<div class="selector"></div>
					<img class="page-theme-selector-preview" src="<?php echo $theme->location; ?>preview.png?v=1" />
				</div>
			</div>
			<?php endforeach; ?>
		</div>
	</div>
	<div class="scrollbar-hor"><div class="handle-hor"></div></div>
</div>

<div id="page-layout-backgroundarea">	
	<div id="background_images" class="clear ui-settings-selector margin-right" style="margin: 0 0 10px 0;float:left;width:475px;">
		<div style="overflow: hidden; width: 475px; height: 130px; margin: 0 0 10px 0;">
			<div style="width:<?php echo $size; ?>px;overflow:auto;">
				<div class="align-left" style="margin: 10px;">
					<div class="background-image-selector-skin" data-skin-name="No Image" data-skin-slug="no-image" id="no-image">
						<div class="selector"></div>
						<div class="background-image-selector-preview"></div>
					</div>
				</div>
				<?php foreach($background_images as $image) : ?>
				<div class="align-left" style="margin: 10px;">
					<div class="background-image-selector-skin" data-skin-name="<?php echo $image->name; ?>" data-skin-slug="<?php echo $image->slug; ?>" id="<?php echo $image->slug; ?>">
						<div class="selector"></div>
						<div class="background-image-selector-preview" style="background-image: url(<?php echo $image->location; ?>/background.png);"></div>
					</div>
				</div>
				<?php endforeach; ?>
			</div>
		</div>
		<div class="scrollbar-hor"><div class="handle-hor"></div></div>
	</div>
	<div class="group styled align-left" style="width:200px;">
		<label for="background-colour">Background colour</label>
		<div id="overlay-background-wrap">
			<input data-behavior="ColourPicker EvpTieToElement" type="text" id="background-colour" name="page-background-colour" style="width: 65px;" />
		</div>
	</div>
	
</div>