<?php
// Get the potential skins
$widgets_raw = $evp->getWidgets();
$widgets = array();
$widgetorder = array('share-facebook', 'share-googleplus', 'share-twitter', 'share-digg', 'share-linkedin', 'share-tumblr', 'share-stumbleupon', 'share-reddit', 'share-delicious', 'share-googlebookmarks', 'button-download', 'button-embed', 'button-share-the-love', 'share-email', 'share-sharethis');

foreach($widgets_raw as $w) {
	$key = array_search($w->slug, $widgetorder);
	
	if(in_array($w->slug, array('expiration'))) continue;
	
	if(is_numeric($key)) $widgets[$key] = $w;
	else array_push($widgets, $w);
}

ksort($widgets);

$widgetList = array_chunk($widgets, 4);
?>

<script type="text/javascript">
window.addEvent('domready', function() {
	function widgets_save_order() {
		var data = $('thisFile').retrieve('data');
		data.widgets_order = [];
		data.widgets_row_1 = [];
		data.widgets_row_2 = [];
		$('player-preview-bar').getElements('.widget').each(function(el, order_idx) {
			var widget_idx = el.getData('widget-idx');
			var row_id = el.getParent().get('id').slice(-1); // 1 or 2
			data.widgets_order[order_idx] = widget_idx;
			data['widgets_row_'+row_id][order_idx] = widget_idx;
		});
		$('thisFile').store('data', data);
	}
	
	function widgets_build(widget_slug, idx) {
		if(idx) idx = ''+idx; // Force into a string so it gets saved even if 0
		var orig = $('widget-'+widget_slug);
		if(!orig) {
			if(typeof console !== 'undefined') console.error('The widget '+widget_slug+' could not be identified!');
			return false;
		}
		var el = orig.clone();
		if(idx) el.setData('widget-idx', idx);
		el.set('class', 'widget widget-'+widget_slug);
		
		// Configuration?
		if(el.getData('widget-config-remote')) {
			new Element('div', {'class': 'widget-config ui-icon ui-icon-gear', 'title': 'Configure this widget'}).inject(el, 'top');
		} else {
			//
		}
		
		// Make the delete
		new Element('div', {'class': 'widget-delete ui-icon ui-icon-delete', 'title': 'Remove this widget'}).inject(el, 'bottom');
		
		// Show the config etc on mouseover
		el.addEvents({
			'mouseenter': function() {
				el.getElements('.widget-delete, .widget-config').fade('in');
			},
			'mouseleave': function() {
				el.getElements('.widget-delete, .widget-config').fade('out');
			}
		});
		
		el.getElements('.widget-delete, .widget-config').fade('out');
		
		// Let's add a new item into the widget storage, if it's not already set
		if(!idx && idx !== 0) {
			var data = $('thisFile').retrieve('data');
			var widgets = $('thisFile').retrieve('widgets');
			if(typeof widgets == 'undefined') widgets = [];
			if(typeof data.widgets_order == 'undefined') data.widgets_order = [];
			data.widgets_order = Array.from(data.widgets_order);
			
			// Widget data
			var widget_data = {
				'name': el.getData('widget-name'),
				'slug': el.getData('widget-slug'),
				'data': el.getData('widget-data')
			};
			// Push the data
			var idx = Number.random(1, 9999999);//$('player-preview-bar').getElements('.widget').length + 1;
			widgets[idx] = widget_data;
			// Set the IDX
			widgets[idx].idx = idx;
			// Store this data inside the actual HTML element
			el.setData('widget-idx', idx);
			// And update the data
			$('thisFile').store('data', data);
			$('thisFile').store('widgets', widgets);
			
			// Trigger the config window
			var config_button = el.getElement('.widget-config');
			if(config_button) {
				show_config_panel.bind(config_button).delay(250);
			}
		}
		
		// And return
		return el;
	}
	
	function show_config_panel() {
		// First, close all other widget windows
		$$('.widget-config-panel').dissolve();
		
		// And onwards
		var widget = this.getParent('.widget');
		var config_remote = widget.getData('widget-config-remote');
		var widget_slug = widget.getData('widget-slug');
		var widget_idx = widget.getData('widget-idx');
		
		var config_remote_url = '<?php echo url('admin/xhr.php', array('method' => 'widget_config_load', 'file_ref' => $file_ref)); ?>&widget='+widget_slug+'&widget_idx='+widget.getData('widget-idx');
		
		if(widget.retrieve('widget-config-panel-setup')) {
			widget.retrieve('widget-config-panel').setStyles(widget.getCoordinates()).setStyles({
				'width': widget.getData('widget-config-width')+'px',
				'height': widget.getData('widget-config-height')+'px'
			}).reveal();
		} else {
			// Open up the area
			var panel = new Element('div', {
				'class': 'widget-config-panel',
				'styles': {
					'position': 'absolute'
				}
			}).inject(document.body, 'bottom').setStyles(widget.getCoordinates()).setStyles({
				'width': widget.getData('widget-config-width')+'px',
				'height': widget.getData('widget-config-height')+'px',
				'overflow': (widget.getData('widget-config-overflow') || 'hidden'),
				'margin-left': '-'+(parseInt(widget.getData('widget-config-width')) / 2)+'px',
				'margin-top': '-'+(parseInt(widget.getData('widget-config-height')) + 20)+'px',
			}).setData('original-width', widget.getData('widget-config-width')).setData('original-height', widget.getData('widget-config-height')).setData('originalTop', widget.getCoordinates().top);
			
			var panel_content = new Element('div', {'class': 'widget-config-panel-content'}).inject(panel);
			
			new Element('div', {
				'styles': {
					'width': 0,
					'height': 0,
					'border-color': '#fff transparent transparent transparent',
					'border-style': 'solid',
					'border-width': '15px',
					'position': 'absolute',
					'bottom': '-30px',
					'left': (parseInt(widget.getData('widget-config-width')) / 2)
				}
			}).inject(panel, 'bottom');
			
			// Create the area
			var widgetArea = new WidgetisedArea(config_remote_url, {'file_id': '<?php echo $file->id; ?>', 'profile': '<?php echo $profile; ?>'}, {
				'update': panel_content,
				'update-method': 'update',
				'animation': 'fade'
			});
			
			widgetArea.start();
			
			// Allow closing
			var c = function() {
				this.dissolve();
			}
			
			panel.store('evp-widget-config-close', function(response, close) { // Obj or string of new data
				if(typeof response == 'string') response = JSON.decode(response);
				if(response) {
					var widgets = $('thisFile').retrieve('widgets');
					widgets[widget_idx] = Object.merge({}, widgets[widget_idx], response.data.file_options);
					$('thisFile').store('widgets', widgets);
				}
				if(close === false) return; // Don't close if this is exactly false
				c.bind(panel)();
			});
			
			new Element('div', {'class': 'ui-icon ui-icon-delete'}).addEvent('click', c.bind(panel)).inject(panel, 'bottom');
			
			// Store
			widget.store('widget-config-panel-setup', true);
			widget.store('widget-config-panel', panel);
			widget.store('widget-config-widgetarea', widgetArea);
		}
	}
	
	$('player-preview-bar').addEvent('click:relay(.widget-config)', show_config_panel);
	
	$('player-preview-bar').addEvent('click:relay(.widget-delete)', function() {
		var widget = this.getParent('.widget');
		widget.kill(function() {
			widgets_save_order();
			$$('#player-preview-bar-row2:empty').dissolve();
		});
	});
	
	<?php
	// This part will write the JS to re-create the existing widgets
	$widgets_on_row_2 = (array)$file_settings->options['widgets_row_2'];
	if(!empty($file_settings->widgets) && !empty($file_settings->options['widgets_order'])) {
		foreach($file_settings->options['widgets_order'] as $oidx) {
			if(!empty($file_settings->widgets[$oidx])) {
				$widget = $file_settings->widgets[$oidx];
				$widget['row'] = 1;
				if(in_array($oidx, $widgets_on_row_2)) $widget['row'] = 2;
				?>
				widgets_build('<?php echo $widget['slug']; ?>', <?php echo $oidx; ?>).inject($('player-preview-bar-row<?php echo $widget['row']; ?>'), 'bottom');
				<?php
			}
		}
		echo 'widgets_save_order();';
	}
	?>
	
	var sort = new Sortables('#player-preview-bar > div', {
		'clone': true,
		'revert': true,
		'opacity': 0.7,
		'onStart': function() {
			if($('player-preview-bar').getElements('.widget').length >= 1) { // Only show if one already exists
				$('player-preview-bar-row2').reveal();
			}
		},
		'onComplete': function() {
			(function() {
				// Reset the widget_order key
				widgets_save_order.delay(500); // Delay to make sure the clone has gone. Really?
				$$('#player-preview-bar-row2:empty').dissolve();
			}).delay(500);
		}
	});
	
	$('bar').getElements('.widget-selector-widget').addEvent('mousedown', function(event) {
  event.stop();
		var shirt = this;
		
		var to_clone = shirt;
		var pos = to_clone.getPosition();
		var clone = to_clone.clone().setStyles({
			'left': pos.x,
			'top': pos.y,
			'width': '178px',
			'opacity': 0.7,
			'position': 'absolute',
			'z-index': 10
		}).inject(document.body);
		
  var drag = new Drag.Move(clone, {
		'droppables': '#player-preview-bar > div',
   'onDrop': function(dragging, cart){
    if (cart != null) { // It's been dropped in the proper place
					var existing = $$('#player-preview-bar div.widget[data-widget-slug="'+dragging.getData('widget-slug')+'"]');
					if(existing.length >= 1) {
						if(dragging) dragging.destroy();
						return false;
					}
					
					// Let's see - is this a Pinterest widget but there isn't an image set?
					if(dragging.getData('widget-slug') == 'share-pinterest' && (!$('thisFile').retrieve('data').related_image || $('thisFile').retrieve('data').related_image.length == 0 || $('thisFile').retrieve('data').related_image.indexOf('no-image.png') !== -1)) {
						if(dragging) dragging.destroy();
						StickyWin.alert('Wait!', 'Please make sure you set a related image for this video before you can allow sharing on Pinterest. Set this image from the main Video tab!');
						return false;
					}
					
					var widget = widgets_build(dragging.getData('widget-slug'));
					
					widget.inject(cart);//$('player-preview-bar-row1'));
					
					sort.addItems(widget);
					
					widgets_save_order();
				}
    dragging.destroy();
				(function() {
					$$('#player-preview-bar-row2:empty').dissolve();
				}).delay(500);
   },
   'onEnter': function(dragging, cart) {
   	if($('player-preview-bar').getElements('.widget').length >= 1) {
					$('player-preview-bar-row2').reveal();
				}
   },
   'onLeave': function(dragging, cart) {
				//
   },
   'onCancel': function(dragging) {
    dragging.destroy();
				(function() {
					$$('#player-preview-bar-row2:empty').dissolve();
				}).delay(500);
   }
  });
  drag.start(event);
 });
	
	/*
	$('bar').getElements('.widget-selector-widget').addEvent('click', function() {
		// Does the widget already exist?
		var existing = $$('#player-preview-bar div.widget[data-widget-slug="'+this.getData('widget-slug')+'"]');
		if(existing.length >= 1) return false;
		
		var widget = widgets_build(this.getData('widget-slug'));
		
		widget.inject($('player-preview-bar-row1'));
		
		sort.addItems(widget);
		
		widgets_save_order();
	});
	*/
});
</script>

<script type="text/javascript">
window.addEvent('domready', function() {
	var selectBarStyle = window.evpselectbar = function(name) {
		var slug = 'bar-style-'+name;
		if($(slug)) $(slug).getParent('.grid-column-wrap').addClass('active');
		$('player-preview-bar').set('class', '').addClass(slug);
		$('player-preview').setData('bar-style-slug', slug);
		
		if($(slug)) $('player-preview-bar').setStyle('background-color', $(slug).getElement('.preview').getStyle('background-color'));
		
		var d = $('thisFile').retrieve('data'); d.bar_style = name;
		$('thisFile').store('data', d);
		
		// Do we need to switch to reflections?
		if(typeof d.frame != 'undefined' && d.frame !== 'no-frame' && d.bar_style == 'none') {
			$('tab-shadow').set('html', $('tab-shadow').get('html').replace('Shadow', 'Reflection'));
			$('shadows-container').dissolve();
			$('reflections-container').reveal();
		} else {
			$('tab-shadow').set('html', $('tab-shadow').get('html').replace('Reflection', 'Shadow'));
			$('shadows-container').reveal();
			$('reflections-container').dissolve();
			if($('general-reflection') && $('general-reflection').get('checked') === true) {
				$('general-reflection').retrieve('iPhoneSwitchWrap').fireEvent('click');
			}
		}
	};
	
	$$('.bar-style').addEvent('click', function() {
		var style_name = this.getData('style-name');
		$('bar_styles').getElements('.active').removeClass('active');
		selectBarStyle(style_name);
	});
	
	$('bar_style_custom').addEvents({
		'change': function() {
			$('bar-style-custom').getElement('.preview').setStyle('background-color', this.get('value'));
			$('player-preview-bar').setStyle('background-color', this.get('value'));
		},
		'focus': function() {
			$('bar-style-custom').fireEvent('click');
		}
	});
	
	/*addEvent('change', function() {
		var yes = !!this.get('checked');
		
		if(yes) {
			$('ui-baroptions-wrap').reveal();
			var style = $('thisFile').retrieve('data').bar_style || 'dark';
			if(style == 'none') style = 'dark';
			console.log(style);
			selectBarStyle(style);
		} else {
			$('ui-baroptions-wrap').dissolve();
			selectBarStyle('none');
		}
	});
	*/
	
	(function() {
		$('general-bar_enabled').retrieve('iPhoneCheckbox').addEvents({
			'onEnable': function() {
				$('ui-baroptions-wrap').unspin().reveal();
				var style = $('thisFile').retrieve('data').bar_style || 'dark';
				if(style == 'none' && $('bar_styles').getElement('.active')) style = $('bar_styles').getElement('.active').getElement('[data-style-name]').getData('style-name');
				if(style == 'none') style = 'dark';
				$('bar_styles').getElements('.active').removeClass('active');
				selectBarStyle(style);
			},
			'onDisable': function() {
				if(!(Browser.Engine.trident && Browser.Engine.version <= 8)) {
					$('ui-baroptions-wrap').spin({'class': 'spinner spinner-panels spinner-nospin'});
				} else {
					$('ui-baroptions-wrap').dissolve();
				}
			//$('ui-baroptions-wrap').dissolve();
				selectBarStyle('none');
			}
		});
		
		$('bar_style_custom').fireEvent('change');
		
		if($('thisFile').retrieve('data').bar_style == 'none') {
			$('ui-baroptions-wrap').spin({'class': 'spinner spinner-panels spinner-nospin'});
			selectBarStyle('none');
		} else {
			$('general-bar_enabled').set('checked', false).retrieve('iPhoneSwitchWrap').fireEvent('click');
		}
		
		$('general-bar_enabled').set('checked', !($('thisFile').retrieve('data').bar_style === 'none'));
	}).delay(250);
	
	$('thisFile').retrieve('settingsTabSwapper').addEvent('onActive', function(idx, panel, tab) {
		if(idx !== 3) return false;
		if($('general-bar_enabled').get('checked') === false) {
			if(!(Browser.Engine.trident && Browser.Engine.version <= 8)) {
				$('ui-baroptions-wrap').spin({'fxOptions': {'duration': 0}, 'class': 'spinner spinner-panels spinner-nospin'});
			} else {
				$('ui-baroptions-wrap').dissolve();
			}
		}
	});
});
</script>

<div class="styled" style="margin-bottom:30px;">
	<label>Do you want to display a bar under your <?php echo $file->type; ?>, for powerful, viral sharing buttons?</label>
	<input id="general-bar_enabled" type="checkbox" data-behavior="iPhoneCheckbox" />
</div>
	
<div id="ui-baroptions-wrap">
	<div id="bar">
		<p class="text-align-center">Drag and drop the widgets below to add them to your player bar!</p>
		<div style="margin:0 19px;">
		<?php foreach($widgetList as $partition => $widgets) : ?>
			<div data-behavior="Grid" data-grid-padding="5" style="margin-bottom: 30px;">
				<?php foreach($widgets as $widget) : ?>
				<div data-column-width="200">
					<div class="widget-selector-widget" data-widget-name="<?php echo $widget->name; ?>" data-widget-slug="<?php echo $widget->slug; ?>" data-widget-config-remote="<?php echo $widget->config->configRemote; ?>" data-widget-config-overflow="<?php echo $widget->config->configOverflow; ?>" data-widget-config-width="<?php echo $widget->config->configWidth; ?>" data-widget-config-height="<?php echo $widget->config->configHeight; ?>" id="widget-<?php echo $widget->slug; ?>">
						<div><img src="<?php echo $widget->location; ?>preview.png?v=5" class="widget-selector-preview" style="<?php echo ($widget->slug == 'button-share-the-love' ? 'width:auto;position:relative;left:-127px;' : ''); ?><?php echo ($widget->slug == 'button-poweredby' ? 'width:auto;position:relative;left:-165px;' : ''); ?><?php echo ($widget->slug == 'button-paypal-donate' ? 'width:auto;position:relative;left:-47px;' : ''); ?>" /></div>
						<p><?php echo $widget->name; ?></p>
					</div>
				</div>
				<?php endforeach; ?>
			</div>
		<?php endforeach; ?>
		</div>
	</div>
	
	<div class="clear margin-bottom" id="bar_styles">
		<div data-behavior="Grid" data-grid-padding="20" style="margin-bottom: 30px;">
			<div data-column-width="165">
				<div class="bar-style" id="bar-style-dark" data-style-name="dark">
					<div class="tick"></div>
					<div class="preview" style="background-color:#202020;"></div>
					<span>Dark</span>
				</div>
			</div>
			<div data-column-width="165">
				<div class="bar-style" id="bar-style-light" data-style-name="light">
					<div class="tick"></div>
					<div class="preview" style="background-color:#acacac;"></div>
					<span>Light</span>
			</div>
			</div>
			<div data-column-width="165">
				<div class="bar-style" id="bar-style-blue" data-style-name="blue">
					<div class="tick"></div>
					<div class="preview" style="background-color:#4c86cd;"></div>
					<span>Blue</span>
				</div>
			</div>
			<div data-column-width="165">
				<div class="bar-style" id="bar-style-green" data-style-name="green">
					<div class="tick"></div>
					<div class="preview" style="background-color:#8cad3e;"></div>
					<span>Green</span>
				</div>
			</div>
			<div data-column-width="165">
				<div class="bar-style" id="bar-style-custom" data-style-name="custom"><div class="tick"></div><div class="preview"></div><span>Custom</span></div>
				<div id="bar-style-custom-wrap" class="styled" style="padding:5px 0 0 25px;">
					<input data-behavior="ColourPicker EvpTieToElement" type="text" id="bar_style_custom" name="bar_style_custom" style="width: 57px;" />
				</div>
			</div>
		</div>
		<div class="clear"></div>
	</div>
</div>