<?php
// Get the potential frames
$framelist = array(
	new Object(array(
		'name' => 'No frame',
		'slug' => 'no-frame'
	))
);

$framelist = array_merge($framelist, $evp->getFrames($file_settings->frame));
$size = 190 * sizeof($framelist) - 100;
$frames = array();
$frameorder = array('no-frame', 'iphone', 'ipad', 'imac', 'ninja-bar', 'ninja-ribbon', 'ninja-wood', 'ninja-ornate', 'ninja-tv', 'ninja-chalk', 'ninja-board');// 'ninja-wood', 'ninja-ribbon', 'ninja-bar', 'ninja-tv', 'ninja-ornate', 'ninja-chalk', 'ninja-board');

foreach($framelist as $f) {
	$key = array_search($f->slug, $frameorder);
	if(is_numeric($key)) $frames[$key] = $f;
	else array_push($frames, $f);
}

ksort($frames);

//usort($frames, 'frame_sort');

//$frameList = array_chunk($frames, 4);
?>

<script type="text/javascript">
window.addEvent('domready', function() {
	var selectFrame = window.evpselectframe = function(frame_slug) {
		$('frames').getElements('.active').removeClass('active');
		if($(frame_slug)) $(frame_slug).addClass('active');

		if(!(Browser.Engine.trident && Browser.Engine.version <= 8)) {
			$('player-preview-frame').set('class', '').addClass(frame_slug);
			$('player-preview-skin').setData('frame', frame_slug);
			$('player-preview').setData('frame-slug', frame_slug);
		}
		
		var d = $('thisFile').retrieve('data'); d.frame = frame_slug;
		$('thisFile').store('data', d);
		
		// Do we need to switch to reflections?
		if(d.frame !== 'no-frame' && d.bar_style == 'none') {
			$('tab-shadow').set('html', $('tab-shadow').get('html').replace('Shadow', 'Reflection'));
			$('shadows-container').dissolve();
			$('reflections-container').reveal();
		} else {
			$('tab-shadow').set('html', $('tab-shadow').get('html').replace('Reflection', 'Shadow'));
			$('shadows-container').reveal();
			$('reflections-container').dissolve();
		}
	}
	
	$('frames').addEvent('click:relay(.frame-selector-frame)', function() {
		var c = this;
		var frame_name = c.getData('frame-name'), frame_slug = c.getData('frame-slug');
		
		selectFrame(frame_slug);
	});
	
	selectFrame.pass($('thisFile').retrieve('data').frame || 'no-frame').delay(250);
	
	makeScrollbar($('frames').getElement('div'), $('frames').getElement('.scrollbar-hor'), $('frames').getElement('.scrollbar-hor').getElement('div'), true, false);
});
</script>

<div id="frames-container">
	<div id="frames" class="ui-settings-selector" style="margin: 10px 0 20px 0;">
		<div style="overflow: hidden; width: 836px; height: 140px; margin: 0 0 10px 0;">
			<div style="width:<?php echo $size; ?>px;overflow:auto;">
				<?php foreach($frames as $frame) : ?>
				<div class="frame-selector-wrap">
					<div class="frame-selector-frame" data-frame-name="<?php echo $frame->name; ?>" data-frame-slug="<?php echo $frame->slug; ?>" id="<?php echo $frame->slug; ?>">
						<div></div>
						<?php if($frame->slug !== 'no-frame') : ?>
							<img src="<?php echo $frame->location; ?>preview.png" alt="" width="160" />
						<?php else: ?>
							<img src="<?php echo $config['locations']['themeDir']; ?>assets/icons-custom/no-value.png?v=1" alt="" />
						<?php endif; ?>
					</div>
				</div>
				<?php endforeach; ?>
			</div>
		</div>
		<div class="scrollbar-hor"><div class="handle-hor"></div></div>
	</div>
</div>