<?php
// Get the potential shadows
$shadows = array(
	new Object(array(
		'name' => 'No shadow',
		'slug' => 'no-shadow',
		'location' => url('player/shadows/no-shadow.png?v=2')
	))
);

$shadows = array_merge($shadows, $evp->getShadows($file_settings->shadow));
$size = 280 * sizeof($shadows);

//$shadowList = array_chunk($shadows, 3);
?>

<script type="text/javascript">
window.addEvent('domready', function() {
	var selectShadow = window.evpselectshadow = function(shadow_slug) {
		$('shadows').getElements('.active').removeClass('active');
		if($(shadow_slug)) $(shadow_slug).addClass('active');
		
		if(!(Browser.Engine.trident && Browser.Engine.version <= 8)) {
			$('player-preview-shadow').set('class', '').addClass(shadow_slug);
			$('player-preview').setData('shadow-slug', shadow_slug);
		}
		
		var d = $('thisFile').retrieve('data'); d.shadow = shadow_slug;
		$('thisFile').store('data', d);
	}
	
	$('shadows').addEvent('click:relay(.shadow-selector-shadow)', function() {
		var c = this;
		var shadow_name = c.getData('shadow-name'), shadow_slug = c.getData('shadow-slug');
		
		selectShadow(shadow_slug);
	});
	
	selectShadow.pass($('thisFile').retrieve('data').shadow || 'no-shadow').delay(250);
	
	makeScrollbar($('shadows').getElement('div'), $('shadows').getElement('.scrollbar-hor'), $('shadows').getElement('.scrollbar-hor').getElement('div'), true, false);
	
	if($('general-reflection')) {
		$('general-reflection').addEvent('change', function() {
			var y = this.get('checked');
			var data = $('thisFile').retrieve('data');
			
			var target = $('player-preview-frame');
			
			if(y) {
				target.setStyles({
					'-webkit-box-reflect': 'below 10px -webkit-gradient(linear, 0% 0%, 0% 127%, from(transparent), color-stop(0.7, transparent), to(white))'
				});
			} else {
				target.setStyles({
					'-webkit-box-reflect': ''
				});
			}
		});
	}
});
</script>

<div id="shadows-container">
	
	<div id="shadows" class="ui-settings-selector" style="margin: 10px 0 20px 0;">
		<div style="overflow: hidden; width: 836px; height: 80px; margin: 0 0 10px 0;">
			<div style="width:<?php echo $size; ?>px;overflow:auto;">
				<?php foreach($shadows as $shadow) : ?>
				<div class="align-left" style="margin: 10px;">
					<div class="shadow-selector-shadow" data-shadow-name="<?php echo $shadow->name; ?>" data-shadow-slug="<?php echo $shadow->slug; ?>" id="<?php echo $shadow->slug; ?>">
						<div></div>
						<img src="<?php echo ($shadow->slug == 'no-shadow' ? $shadow->location : $shadow->location.'preview.png?v=2'); ?>" alt="" />
					</div>
				</div>
				<?php endforeach; ?>
			</div>
		</div>
		<div class="scrollbar-hor"><div class="handle-hor"></div></div>
	</div>
</div>

<div id="reflections-container">
	<div id="reflections" class="styled" style="margin-bottom: 20px;">
		<p>In Safari and Google Chrome, you can enable a reflection effect underneath your player. <strong>This is not compatible</strong> with other browsers, who will simply not see it. You can enable or disable this below.</p>
		<div class="setting-group" id="reflection-wrap">
			<label for="general-reflection" style="font-size:14px;">Enable reflection</label>
			<input name="use_reflection" id="general-reflection" type="checkbox" value="true" data-behavior="EvpTieToElement iPhoneCheckbox" />
		</div>
	</div>
</div>