<?php
// Upload stuff
$file_image_seed = makeSeed($file->name).'-chapter-image-';
$upload_url = url('admin/xhr.upload.image.php', array('destination' => (!empty($evp->s3)), 'prefix' => $file_image_seed));
$upload_path = url('assets/videos/');
if(!empty($evp->s3)) {
	$upload_path = "https://{$evp->settings->s3_bucket}.s3.amazonaws.com/";
}
?>

<script type="text/javascript">
var upinit = function($) {
	if(typeof window.chapteruploader != 'undefined' && typeof window.chapteruploader.destroy == 'function') {
		window.chapteruploader.destroy();
		if(typeof console != 'undefined') console.warn('Destroyed old chapter image upload instance.');
	}
	if(typeof console != 'undefined') console.log('Starting chapter image uploader');

	var uploader = window.chapteruploader = new plupload.Uploader({
		'runtimes': 'html5',
		'browse_button': 'chapter-image-uploader-select',
		'container': 'chapter-image',
		'max_file_size': '10mb',
		'file_data_name': 'file',
		'url': '<?php echo $upload_url; ?>',
		'filters': [
			{'title': "Images", 'extensions': "jpg,jpeg,gif,png,JPEG,JPG,GIF,PNG"}
		]
	});

						uploader.bind('Error', function(up, err) {
							if(typeof console != 'undefined') {
								console.error(err.message+' from the chapter image uploader.');
								console.log(err, uploader);
							}

							if(err.message == 'Init error.') {
								window['evp-chapteruploader'] = setTimeout(function() {
									upinit(jQuery);
								}, 200);
							} else {
								if(typeof window['evp-chapterinterval'] != 'undefined') clearInterval(window['evp-chapterinterval']);
								alert(err.message);
								document.id('chapter-image').unspin();
								up.refresh(); // Reposition Flash/Silverlight
							}
						});

						uploader.bind('Init', function() {
							clearInterval(window['evp-splashuploader']);
						});

	/*
	uploader.bind('Error', function(up, err) {
		alert(err.message);
		if(typeof console != 'undefined') console.error(err);
		document.id('chapter-image').unspin();
		up.refresh(); // Reposition Flash/Silverlight
	});

	uploader.bind('Init', function() {
		new Element('div', {'id': 'chapter-uploader-ready'}).inject(document.body);
	});
	*/

	uploader.bind('FilesAdded', function(up, files) {
		document.id('chapter-image').spin({'message': '0%', 'class': 'spinner spinner-nospin spinner-panels'});
		up.refresh(); // Reposition Flash/Silverlight
		(function() { up.start(); }).delay(250);
	});

	uploader.bind('UploadProgress', function(up, file) {
		document.id('chapter-image').getNext('.spinner').getElement('.spinner-msg').set('text', file.percent+'%')
	});

	uploader.bind('FileUploaded', function(up, file) {
		// Get the image
		var amazon_name = '<?php echo $file_image_seed; ?>'+file.name;
		var amazon_location = '<?php echo $upload_path; ?>';

		// Update the preview
		var r = new Date().getTime();
		document.id('chapter-image').getElement('img').set('src', amazon_location+amazon_name+'?v='+r).addEvent('load', function() {
			document.id(this).get('reveal').chain(function() {
				window.chapteruploader.refresh();
			}).reveal();
			document.id('chapter-image-uploader-delete').reveal();
			document.id('chapter-image').unspin();
			document.id('chapter-image-value').set('value', amazon_location+amazon_name+'?v='+r);
		});
	});

	(function() { window.chapteruploader.refresh(); }).delay(750);
};

var restoreChapterArea = function(opt) {
	var options = Object.merge({}, {
		'name': 'My Chapter',
		'description': '',
		'start-string': '00:00',
		'data': {
			'chapter-background-colour': '#000000',
			'chapter-image': ''
		}
	}, opt);

	Object.each(Object.merge({}, options, options.data), function(value, key) {
		var el = $('timeline-content-chapter').getElement('[name="'+key+'"]');
		if(!el) return;

		if(el.get('tag') == 'select') {
			if(value !== null) {
				var opt = el;//$$('#form select[name="metric"] option[value="'+value+'"]');
				var opDiv = el.getNext('.selectaWrapper').getElements('.selectaOption[data-value="'+value+'"]');
				if(opDiv) {
					el.retrieve("wrapper").getChildren().removeClass('selectaOptionSelected');
					opDiv.addClass('selectaOptionSelected');
					el.retrieve("triggerElement").set("html", opDiv.get("text"));
					el.set("value", opDiv.retrieve("value")).fireEvent("change");
					opt.set('selected', true);
				}
			}
			return;
		}

		var type = el.get('type');
		switch(type) {
			case 'radio':
				if(value === true || value === false || value == 'true' || value == 'false') { // Handle booleans differently
					var real_el = el.getParent().getElement('input[value="'+value+'"]');
					if(!real_el) real_el = el.getParent().getElement('input[value="'+(value == true ? 'yes' : 'no')+'"]');
				} else {
					var real_el = el.getParent().getElement('input[value="'+value+'"]');
				}

				var wrap = el.getParent('.radio-group-wrapper').getElement('[data-behavior="RadioGroup"]');
				wrap.retrieve('RadioGroup').select(real_el);
				break;
			case 'checkbox':
				if(el.retrieve('iPhoneSwitchWrap')) {
					el.set('checked', !(value == true)); // Set opposite and fire event to change
					el.retrieve('iPhoneSwitchWrap').fireEvent('click');
				} else {
					el.set('checked', value).fireEvent('change');
					(function() { // We delay here because the transparency selector needs the animation to be complete before changing opacity
						el.fireEvent('change');
					}).delay(750);
				}
				break;
			default:
				el.set('value', value);
				var rain = el.retrieve('ColourPicker');
				if(rain) {
					rain.manualSet(value, 'hex');
				}
				el.fireEvent('change');
				break;
		}

		if(key == 'chapter-image') {
			if(value.length > 0) {
				document.id('chapter-image-uploader-delete').reveal();
				document.id('chapter-image').spin().getElement('img').set('src', value).setStyle('display', 'block').addEvent('load', function() {
					document.id('chapter-image').unspin();
				});
			} else {
				document.id('chapter-image-uploader-delete').dissolve();
				document.id('chapter-image').getElement('img').dissolve();
			}
		}
	});

	$('thisPage').store('current_chapter', options.name);

	// Restore the preview area
	$('timeline-options').get('reveal').dissolve().chain(function() {
		$$('.timeline-content-panel').setStyle('display', 'none');
		$('timeline-content-chapter').setStyle('display', 'block');
		$('timeline-content').reveal();
		$$('#event-area-wrapper, #event-area, #event-area-preview').dissolve();

		(function() {
			upinit(jQuery);

			if(typeof window.chapteruploader != 'undefined') {
				window.chapteruploader.init();
			}
		}).delay(1000);

	});
}

window.addEvent('domready', function() {
	$('timeline-content-chapter').addEvent('onActivate', function() {
		var name_idx = $('timeline').getElements('.ui-timeline-element[data-timeline-type="chapter"]').length + 1;
		$('ui-delete-chapter').setStyle('display', 'none');

		upinit(jQuery);

		restoreChapterArea({
			'name': 'My Chapter '+name_idx,
			'description': '',
			'start-string': '00:00',
			'data': {
				'chapter-background-colour': '#000000',
				'chapter-image': ''
			}
		});
	});

	// Start and duration times
	$('chapter-start-minutes').addEvent('change', function() {
		var m = this.get('value') || 0;
		$('chapter-start-string').set('value', m+':'+$('chapter-start-seconds').get('value'));
	});
	$('chapter-start-seconds').addEvent('change', function() {
		var s = this.get('value') || 0;
		if(parseInt(s) < 10) s = '0'+(parseInt(s));
		$('chapter-start-string').set('value', $('chapter-start-minutes').get('value')+':'+s);
	});
	$('chapter-start-string').addEvent('change', function() {
		var t = this.get('value').split(':');
		if(t[0] == '00') t[0] = 0;
		if(t[1] == '00') t[1] = 0;
		$('chapter-start-minutes').set('value', t[0]);
		$('chapter-start-seconds').set('value', t[1]);
	});

	$('chapter-image-uploader-delete').addEvent('click', function() {
		$('chapter-image-value').set('value', '');
		document.id('chapter-image-uploader-delete').dissolve();
		document.id('chapter-image').getElement('img').dissolve();
		if(typeof window.chapteruploader != 'undefined') {
			(function() {
				window.chapteruploader.refresh();
			}).delay(500);
		}
	});

	// Save this Event
	$('ui-save-chapter').addEvent('click', function() {
		// Do we need to delete an old chapter, because we're editing?
		if($('thisPage').retrieve('current_chapter') && $('thisPage').retrieve('current_chapter') !== $('chapter-name').get('value')) {
			var chapters = $('thisFile').retrieve('chapters') || {};
			chapters = (typeOf(chapters) == 'array' ? {} : chapters);
			delete chapters[$('thisPage').retrieve('current_chapter')];
			delete chapters[$('thisPage').retrieve('current_chapter').makeSeed()]
			// Delete the marker?
			$$('#timeline-marker-'+$('thisPage').retrieve('current_chapter').makeSeed()).kill(function() {
				positionTimelineMarkers();
			});
			$('thisFile').store('chapters', chapters);
		}

		$('thisPage').store('current_chapter', '');

		// Add/update the marker
		var marker = createTimelineMarker($('chapter-name').get('value'), 'chapter', {
			'start-string': $('chapter-start-string').get('value'),
			'description': $('chapter-description').get('value'),
			'data': {
				'chapter-background-colour': $('chapter-background-colour').get('value'),
				'chapter-image': $('chapter-image-value').get('value')
			}
		});

		// Store the data
		var chapters = $('thisFile').retrieve('chapters') || {};
		chapters = (typeOf(chapters) == 'array' ? {} : chapters);
		chapters[$('chapter-name').get('value').makeSeed()] = marker.retrieve('evp-timeline-data');
		$('thisFile').store('chapters', chapters);

		// Return to the original screen
		restoreDefaultArea();
	});

	// Delete a Chapter
	$$('.ui-delete-chapter').addEvent('click', function() {
		var chapters = $('thisFile').retrieve('chapters') || {};
		chapters = (typeOf(chapters) == 'array' ? {} : chapters);
		delete chapters[$('chapter-name').get('value').makeSeed()];
		delete chapters[$('chapter-name').get('value')];
		$('thisFile').store('chapters', chapters);

		$('timeline-marker-'+$('chapter-name').get('value').makeSeed()).kill();

		// Return to the original screen
		restoreDefaultArea();
	});
});
</script>

<div class="content" id="timeline-chapter-content" style="width: 840px;">
	<h2 class="align-left">Create your Chapter</h2>
	<div class="align-right" style="position: relative; top: -10px;"><div data-behavior="Button" data-button-type="action" data-button-width="70" data-button-icon="delete" data-button-iconpos="right" class="ui-delete-chapter" id="ui-delete-chapter">Delete</div></div>
	<div class="options clear styled descend">
		<div class="group align-left margin-right">
			<label for="chapter-name">Name</label>
			<input type="text" id="chapter-name" name="name" style="width: 185px;" />
		</div>

		<div class="group align-left margin-right">
			<label for="chapter-description">Description</label>
			<input type="text" id="chapter-description" name="description" style="width: 380px;" />
		</div>

		<?php /*
		<div class="group align-left margin-right">
			<label for="chapter-start-string" class="text-align-right">When?</label>
			<input type="text" id="chapter-start-string" name="start-string" data-behavior="InputMask" data-meiomask="reverse.timems" style="width: 60px;" />
		</div>
		*/ ?>

		<div class="group align-left margin-right" id="chapter-start-wrap">
			<label for="chapter-start-string">When?<span class="ui-text-tiny">(Min/sec)</span></label>
			<input type="number" id="chapter-start-minutes" style="width:20px;margin:0 5px 0 0;" />:
			<input type="number" id="chapter-start-seconds" style="width:20px;margin:0 0 0 5px;" />
			<input type="hidden" id="chapter-start-string" name="start-string" style="width: 48px;" />
		</div>

		<div class="group align-left">
			<label>Background</label>
			<div id="overlay-background-wrap">
				<input data-behavior="ColourPicker" type="text" id="chapter-background-colour" name="chapter-background-colour" style="width: 70px;" />
			</div>
		</div>

		<div class="group clear">
			<label>Select an image</label>
			<input type="hidden" id="chapter-image-value" name="chapter-image" />
			<div id="chapter-image-wrap">
				<div id="chapter-image" class="">
					<img src="" alt="" />
					<a class="margin-top margin-bottom" id="chapter-image-uploader-select" data-behavior="Button" data-button-type="small" data-button-width="90">Select image</a>
					<div class="ui-icon ui-icon-delete" id="chapter-image-uploader-delete" style="position: absolute; top: 5px; right: 5px; cursor: pointer;"></div>
				</div>
				<div id="chapter-image-uploader">
					<div id="chapter-image-list"></div>
				</div>
			</div>
		</div>

		<div class="clear timeline-content-footer">
			<a class="ui-return" data-behavior="Button" data-button-icon="back" data-button-iconpos="left" data-button-width="110">Go back</a>
			<a id="ui-save-chapter" data-behavior="Button" data-button-icon="forward" data-button-iconpos="right" data-button-width="120">Save Chapter</a>
		</div>

	</div>
</div>
