<?php
// Let's get the arrays of images for our selectors
$gallery_buttons_raw = $evp->loadFromDirectory('player/event-widgets/button/');
$gallery_button = array();
$gallery_buttonorder = array('button-5', 'button-17', 'button-11', 'button-1', 'button-2', 'button-14', 'button-18', 'button-7', 'button-3');

foreach($gallery_buttons_raw as $f) {
	$key = array_search($f->slug, $gallery_buttonorder);
	if(is_numeric($key)) $gallery_button[$key] = $f;
	else array_push($gallery_button, $f);
}

ksort($gallery_button);

$gallery_button_exposed = array();
foreach($gallery_button as $f) $gallery_button_exposed[$f->slug] = $f;

//$paypal_button = $evp->loadFromDirectory('player/event-widgets/paypal/');

// Upload stuff
$file_image_seed = makeSeed($file->name).'-event-widget-';
$upload_url = url('admin/xhr.upload.image.php', array('destination' => (!empty($evp->s3)), 'prefix' => $file_image_seed));
$upload_path = url('assets/videos/');
if(!empty($evp->s3)) {
	$upload_path = "https://{$evp->settings->s3_bucket}.s3.amazonaws.com/";
}
?>

<script type="text/javascript">

$('thisPage').store('button_data', <?php echo json_encode($gallery_button_exposed); ?>);

var restoreEventArea = function(opt) {
	var options = Object.merge({}, {
		'name': 'My Event',
		'start-string': '00:00',
		'duration-string': '00:00',
		'data': {
			/*
			'event-mode': 'internal',
			'event-point': 'start',
			'event-width': '600px', // null
			'event-height': '400px', // null
			'event-type': 'pro',
			'event-scenario': '',
			'overlay-trigger-pause': false,
			'overlay-position': 'bottom',
			'overlay-entrance': 'css3-fadeInDown',
			'overlay-background-opaque': true,
			'overlay-background-colour': '#292929',
			'overlay-remove-after': false,
			'widgets': {}
			*/
			'overlay-trigger-pause': false,
			'overlay-position': 'bottom',
			'event-mode': 'internal',
			'event-point': 'start',
			'event-width': '600px',
			'event-height': '400px',
			'event-type': 'pro',
			'overlay-entrance': 'css3-fadeInDown',
			'overlay-background-colour': '#292929',
			'overlay-translucent': false,
			'overlay-opaque': false,
			'overlay-remove-after': false,
			'overlay-padding': true,
			'widgets': {}
		}
	}, opt);

	Object.each(Object.merge({}, options, options.data), function(value, key) {
		var el = $('timeline-content-event').getElement('[name="'+key+'"]');
		if(!el) return;

		if(el.get('tag') == 'select') {
			if(value !== null) {
				var opt = el;//$$('#form select[name="metric"] option[value="'+value+'"]');
				var opDiv = el.getNext('.selectaWrapper').getElements('.selectaOption[data-value="'+value+'"]');
				if(opDiv) {
					el.retrieve("wrapper").getChildren().removeClass('selectaOptionSelected');
					opDiv.addClass('selectaOptionSelected');
					el.retrieve("triggerElement").set("html", opDiv.get("text"));
					el.set("value", opDiv.retrieve("value")).fireEvent("change");
					opt.set('selected', true);
				}
			}
			return;
		}

		var type = el.get('type');
		switch(type) {
			case 'radio':
				if(value === true || value === false || value == 'true' || value == 'false') { // Handle booleans differently
					var real_el = el.getParent().getElement('input[value="'+value+'"]');
					if(!real_el) real_el = el.getParent().getElement('input[value="'+(value == true ? 'yes' : 'no')+'"]');
				} else {
					var real_el = el.getParent().getElement('input[value="'+value+'"]');
				}

				var wrap = el.getParent('.radio-group-wrapper').getElement('[data-behavior="RadioGroup"]');
				wrap.retrieve('RadioGroup').select(real_el);
				break;
			case 'checkbox':
				if(el.retrieve('iPhoneSwitchWrap')) {
					el.set('checked', !(value == true)); // Set opposite and fire event to change
					el.retrieve('iPhoneSwitchWrap').fireEvent('click');
				} else {
					el.set('checked', value).fireEvent('change');
					(function() { // We delay here because the transparency selector needs the animation to be complete before changing opacity
						el.fireEvent('change');
					}).delay(750);
				}
				break;
			default:
				el.set('value', value);
				var rain = el.retrieve('ColourPicker');
				if(rain) {
					rain.manualSet(value, 'hex');
				}
				el.fireEvent('change');
				break;
		}
	});

	$('thisPage').store('current_event', options.name);

//var resizefn = (options.data['event-mode'] == 'internal' ? sizeInternalEventArea : sizeExternalEventArea);
	var resizefn = ($('event-mode-internal').get('checked') ? sizeInternalEventArea : sizeExternalEventArea);

	var shouldresize = true;

	$('thisFile').retrieve('settingsTabSwapper').show(0);

	if(options.data['event-mode'] == 'internal') {
		$('event-area-resize').dissolve();
		if($('event-area-resize-handle')) $('event-area-resize-handle').setStyle('display', (options.data['overlay-position'] == 'full' ? 'none' : 'block'));
	} else {
		$('event-area-resize').reveal();
		if($('event-area-resize-handle')) $('event-area-resize-handle').setStyle('display', 'block');
	}

	// Make sure the height is proper - internal top/bottoms should be left alone, but internal full should be made the full height
	if(options.data['event-mode'] == 'internal' && options.data['overlay-position'] == 'full') {
		options.data['event-height'] = $('event-area-wrapper').getStyle('height');
	}

	// Restore the preview area
	if($('event-area-outer').getStyle('display') == 'block') {
		(function() {
			if(shouldresize) {
				var resizefn = ($('event-mode-internal').get('checked') ? sizeInternalEventArea : sizeExternalEventArea);

				if($('event-mode-internal').get('checked')) {
					$('event-area-resize').dissolve();
					if($('event-area-resize-handle')) $('event-area-resize-handle').setStyle('display', 'none');
				} else {
					$('event-area-resize').reveal();
					if($('event-area-resize-handle')) $('event-area-resize-handle').setStyle('display', 'block');
				}

				resizefn({'width': options.data['event-width'], 'height': options.data['event-height']}, (options.data['overlay-position'] !== 'full'));
			}
		}).delay(600);
	} else {
		$('timeline-options').get('reveal').dissolve().chain(function() {
			$$('.timeline-content-panel').setStyle('display', 'none');
			$('timeline-content-event').setStyle('display', 'block');
			$('timeline-content').reveal();

			$('thisFile').retrieve('settingsTabSwapper').addEvent('onActive', function(idx, panel, tab) {
				if(idx == 0) return;
				if($('event-area-outer').getStyle('display') == 'block') return;

				$('event-area-outer').get('reveal').reveal().chain(function() {
					var els = $$('#event-area, #event-area-preview, #event-area-wrapper');
					els.set('class', '').setStyles({
						'display': 'block',
						'opacity': 0
					});

					(function() {
						els.setStyle('opacity', 1);
						if($('overlay-background-opaque').get('checked')) els.set('class', 'animated bounceInDown');
						else $('event-area-preview').setStyle('display', 'none');

						if(shouldresize) {
							if($('event-mode-internal').get('checked')) {
								$('event-area-resize').dissolve();
								if($('event-area-resize-handle')) $('event-area-resize-handle').setStyle('display', 'none');
								sizeInternalEventArea({'width': options.data['event-width'], 'height': options.data['event-height']}, (options.data['overlay-position'] !== 'full'));
							} else {
								$('event-area-resize').reveal();
								if($('event-area-resize-handle')) $('event-area-resize-handle').setStyle('display', 'block');
								sizeExternalEventArea({'width': options.data['event-width'], 'height': options.data['event-height']}, (options.data['overlay-position'] !== 'full'));
							}
						}

						(function() {
						//if($('overlay-background-translucent').get('checked') && options.data['event-mode'] == 'internal') $('event-area-preview').fade(0.9);

							if($('overlay-entrance') && $('overlay-entrance').retrieve('mooselecta')) {
								$('overlay-entrance').retrieve('mooselecta').replaceSelect($('overlay-entrance'));
							}
						}).delay(300);

					}).delay(100);
				});
			});

		});
	}

	// Let's handle the widgets by killing the existing ones and appending the current ones
	var existing = $('event-area').getElements('.event-widget');
	var r = function() { // This will do the restoration
		Object.each(options.data.widgets, function(opt, widget_idx) {
			buildEventWidget(opt.widget_type, opt, widget_idx);
		});
	}
	if(existing.length >= 1) existing.kill();
	r();
}

var build_gallery = function(obj, selected) {
	var wrapper = new Element('div', {
		'class': 'ui-event-widget-gallery-wrapper ui-settings-selector'
	});

	var inside = new Element('div', {
		'class': 'ui-event-widget-gallery'
	}).inject(wrapper);

	var scroll = new Element('div', {
		'class': 'ui-event-widget-scroll'
	}).inject(inside);

	var count = 0;

	Object.each(obj, function(data, idx) {
		var el = new Element('div', {
			'class': 'ui-event-widget-gallery-item',
			'name': data.slug,
			'events': {
				'click': function() {
					wrapper.getElements('.ui-event-widget-gallery-item').removeClass('active');
					this.addClass('active');
					wrapper.fireEvent('onGallerySelect', [this.get('name')]);
				}
			}
		});

		var img = new Element('img', {
			'src': data.location+'/button.png',
			'styles': {
				'width': '200px'
			}
		}).inject(el);

		new Element('div').inject(el); // This is for the activation image

		el.inject(scroll);

		if(selected && selected == data.slug) el.fireEvent.pass('click', el).delay(250);

		count++;
	});

	new Element('div', {'class': 'scrollbar-hor'}).adopt(
		new Element('div', {'class': 'handle-hor'})
	).inject(wrapper);

	var slider = makeScrollbar(wrapper.getElement('div'), wrapper.getElement('.scrollbar-hor'), wrapper.getElement('.scrollbar-hor').getElement('div'), true, false);

	scroll.setStyle('width', (count * 220)+'px');

	slider.autosize.delay(250, slider);

	return wrapper;
}

var build_layout_gallery = function(obj, selected) {
	var wrapper = new Element('div', {
		'class': 'ui-event-widget-gallery-wrapper ui-settings-selector ui-scenario-layout-gallery-wrapper'
	});

	var inside = new Element('div', {
		'class': 'ui-event-widget-gallery'
	}).inject(wrapper);

	var scroll = new Element('div', {
		'class': 'ui-event-widget-scroll'
	}).inject(inside);

	var count = 0;

	Object.each(obj, function(data, idx) {
		var el = new Element('div', {
			'class': 'ui-event-widget-gallery-item',
			'name': data.name,
			'events': {
				'click': function() {
					wrapper.getElements('.ui-event-widget-gallery-item').removeClass('active');
					this.addClass('active');
					wrapper.fireEvent('onGallerySelect', [this.get('name')]);
				}
			}
		});

		var img = new Element('img', {
			'src': data.src
		}).inject(el);

		new Element('div').inject(el); // This is for the activation image

		el.inject(scroll);

		if(selected && selected == data.name) el.fireEvent.pass('click', el).delay(250);

		count++;
	});

	new Element('div', {'class': 'scrollbar-hor'}).adopt(
		new Element('div', {'class': 'handle-hor'})
	).inject(wrapper);

	var slider = makeScrollbar(wrapper.getElement('div'), wrapper.getElement('.scrollbar-hor'), wrapper.getElement('.scrollbar-hor').getElement('div'), true, false);

	scroll.setStyle('width', (count * 240)+'px');

	slider.autosize.delay(250, slider);

	return wrapper;
}

var event_widget_config = {
	// Basic text widget
	'text': function(widget, panel, name, options) {
		var idx = widget.getData('widget-idx');

		new Element('label', {'text': 'Enter your text here'}).inject(panel);
		new Element('textarea', {
			'name': idx+'[body]',
			'id': 'text-'+idx,
			'value': stripslashes(options.body || ''),
			'styles': {
				'display': 'block',
				'clear': 'both',
				'width': '885px',
				'height': '120px',
				'font-size': '12px'
			}
		}).inject(panel);

		var event_mode = ($('timeline-content-event').getElement('input[name="event-mode"]:checked') ? $('timeline-content-event').getElement('input[name="event-mode"]:checked').get('value') : 'internal');

		if(event_mode == 'external') {
			var bgc = '#fff';
			var tc = '#000';
			var ts = 'rgba(255,255,255,0.2)';
		} else {
			var bgc = $('overlay-background-colour').get('value');
			var tc = '#fff';
			var ts = 'rgba(0,0,0,0.2)';
		}

		(function($) {
			 var editor = $('#text-'+idx).cleditor({
				'bodyStyle': 'margin:4px; font:medium Arial,Verdana; cursor:text; text-shadow: '+ts+' 1px 1px 0; color: '+tc+'; background: '+bgc+';',
				'width': '855',
				'height': '200',
				'controls': 'bold italic underline strikethrough | link | font size | color | alignleft center alignright',
				'docCSSFile': '<?php echo assets('scripts/libraries/cleditor/editor.css'); ?>'
			 });

		 $(editor[0].doc).bind('keyup mouseup', function() {
		 	editor[0].updateTextArea();
		 	// Update the live preview
		 	window.widgets_build_preview(widget, 'text', idx);
		 });
		})(jQuery);

		panel.setStyle('height', '340px');
	},
	// Just a field to enter some HTML
	'html': function(widget, panel, name, options) {
		var idx = widget.getData('widget-idx');

		new Element('label', {'text': 'Enter your HTML. Remember it will be contained inside the box that you drag above! Any form elements will be overridden and will resume the video - this is great for HTML-based opt-in forms!'}).inject(panel);
		new Element('textarea', {
			'class': 'ui_code ui_noresize ui-monospace margin-bottom',
			'name': idx+'[body]',
			'value': stripslashes(options.body || ''),
			'styles': {
				'width': '840px',
				'height': '120px'
			}
		}).inject(panel);

		panel.setStyle('height', '300px');
	},
	// Build a Twitter, Facebook, opt-in form or password Gateway
	'gateway': function(widget, panel, name, options) {
		var idx = widget.getData('widget-idx');

		new Element('label', {'text': 'Write some text, explaining to your users what they need to do to move on!'}).inject(panel);
		new Element('textarea', {
			'name': idx+'[body]',
			'id': 'text-'+idx,
			'value': stripslashes(options.body || ''),
			'styles': {
				'display': 'block',
				'clear': 'both',
				'width': '885px',
				'height': '120px',
				'font-size': '12px'
			}
		}).inject(panel);

		var bgc = $('overlay-background-colour').get('value');

		(function($) {
			 var editor = $('#text-'+idx).cleditor({
				'bodyStyle': 'margin:4px; font:medium Arial,Verdana; cursor:text; text-shadow: 1px 1px 0 rgba(0,0,0,0.2); color: #fff; background: '+bgc+';',
				'width': '855',
				'height': '200',
				'controls': 'bold italic underline strikethrough | font size | color | alignleft center alignright',
				'docCSSFile': '<?php echo assets('scripts/libraries/cleditor/editor.css'); ?>'
			 });

		 $(editor[0].doc).bind('keyup mouseup', function() {
		 	editor[0].updateTextArea();
		 	// Update the live preview
		 	window.widgets_build_preview(widget, 'gateway', idx);
		 });
		})(jQuery);

		var hidden = new Element('input', {'type': 'hidden', 'name': idx+'[type]', 'value': options.type}).inject(panel);
		new Element('label', {'text': 'Select the type of Gateway'}).inject(panel);
		var type_wrap = new Element('div', {'styles': {'width': '200px', 'float': 'left'}}).inject(panel);
		var type = new Element('select').setData('behavior', 'SelectBox').adopt(
			new Element('option', {'value': 'password', 'text': 'Password', 'selected': (options.type == 'password')}),
			new Element('option', {'value': 'facebook', 'text': 'Facebook', 'selected': (options.type == 'facebook')}),
			new Element('option', {'value': 'twitter', 'text': 'Twitter', 'selected': (options.type == 'twitter')}),
			new Element('option', {'value': 'optin', 'text': 'Opt-in form', 'selected': (options.type == 'optin')})/*,
			new Element('option', {'value': 'age', 'text': 'Age', 'selected': (options.type == 'age')})*/
		).inject(type_wrap);
		new Element('span', {'class': 'info', 'text': 'Control the action your viewers need to take before continuing'}).inject(panel);

		(function() {
			if(type.retrieve('mooselecta')) {
				type.retrieve('mooselecta').replaceSelect(type);
			}
		}).delay(800);


		// Password options
		var wrap_password = new Element('div', {
			'class': 'ui-gateway-content'
		});

		new Element('label', {'text': 'Enter the password they must enter'}).inject(wrap_password);
		var password_pw_one = new Element('input', {'type': 'text', 'name': idx+'[password_pw]', 'value': stripslashes(options.password_pw || '')}).inject(wrap_password);
		new Element('span', {'class': 'info', 'text': 'Case-sensitive - please check carefully!'}).inject(wrap_password);

		// Facebook options
		var wrap_facebook = new Element('div', {
			'class': 'ui-gateway-content'
		});

		new Element('label', {'text': 'Enter the URL to be shared'}).inject(wrap_facebook);
		var facebook_url = new Element('input', {'type': 'text', 'name': idx+'[facebook_url]', 'value': stripslashes(options.facebook_url || '')}).inject(wrap_facebook);
		new Element('span', {'class': 'info', 'text': 'Leave it blank to share whatever URL the video is posted on!'}).inject(wrap_facebook);

		// Twitter options
		var wrap_twitter = new Element('div', {
			'class': 'ui-gateway-content'
		});

		var twitter_update = function() {
			var remaining = (140 - (this.get('value').length));
			twitter_counter.set('text', remaining).setStyle('display', 'none').setStyle('display', 'block');
			if(remaining >= 0) {
				twitter_counter.setStyle('color', 'green');
				this.setStyle('border-color', 'green');
			} else {
				twitter_counter.setStyle('color', 'red');
				this.setStyle('border-color', 'red');
			}
		};

		new Element('label', {'text': 'Enter the tweet you want your users to send'}).inject(wrap_twitter);
		var twitter_counter = new Element('span', {'class': 'ui-gateway-content-twitter-counter'});
		var twitter_tweet = new Element('textarea', {
			'class': 'ui_code ui_noresize ui-monospace margin-bottom',
			'name': idx+'[twitter_tweet]',
			'value': stripslashes(options.twitter_tweet || ''),
			'styles': {
				'width': '780px',
				'height': '55px'
			},
			'events': {
				'keyup': function() {
					twitter_update.bind(this)();
					window.widgets_build_preview(widget, 'gateway', idx);
				}
			}
		}).inject(wrap_twitter);
		twitter_counter.inject(wrap_twitter);

		twitter_update.bind(twitter_tweet)();

		// Opt-in options
		var wrap_optin = new Element('div', {
			'class': 'ui-gateway-content'
		});

		new Element('label', {'text': 'Enter the HTML for your form'}).inject(wrap_optin);
		new Element('textarea', {
			'class': 'ui_code ui_noresize ui-monospace margin-bottom',
			'name': idx+'[optin_form]',
			'value': stripslashes(options.optin_form || ''),
			'styles': {
				'width': '840px',
				'height': '120px'
			}
		}).inject(wrap_optin);
		new Element('p', {'html': 'The form MUST be HTML-based and include a &lt;form&gt; tag. We will override the submit event - if you use a JavaScript-based form, this feature cannot work!'}).inject(wrap_optin);

		/*
		// Age gate options
		var wrap_age = new Element('div', {
			'class': 'ui-gateway-content'
		});

		new Element('label', {'text': 'Select the minimum age your users must be to watch this video'}).inject(wrap_age);
		new Element('select', {'name': idx+'[minimum_age]', 'value': options.minimum_age || '18'}).adopt(
			new Element('option', {'value': '12', 'text': '12'}),
			new Element('option', {'value': '12', 'text': '15'}),
			new Element('option', {'value': '12', 'text': '17'}),
			new Element('option', {'value': '12', 'text': '18'}),
			new Element('option', {'value': '12', 'text': '21'}),
			new Element('option', {'value': '12', 'text': '25'})
		).inject(wrap_age);
		*/

		// Inject them all
	//var wrappers = $$(wrap_password, wrap_facebook, wrap_twitter, wrap_optin, wrap_age);
		var wrappers = $$(wrap_password, wrap_facebook, wrap_twitter, wrap_optin);
		wrappers.inject(panel);

		// Bind the selection event
		type.addEvent('change', function() {
			var t = this.get('value');
			hidden.set('value', t);
			wrappers.setStyle('display', 'none');
			eval('$(wrap_'+t+').setStyle("display", "block");');
			type.getParent('.widget-config-panel').setStyle('height', '620px');
			window.widgets_build_preview(widget, 'gateway', idx);
		});
	},
	'share-twitter': function(widget, panel, name, options) {
		var idx = widget.getData('widget-idx');

		// Twitter options
		var wrap_twitter = new Element('div', {
			'class': 'ui-gateway-content'
		});

		var twitter_update = function() {
			var remaining = (140 - (this.get('value').length));
			twitter_counter.set('text', remaining).setStyle('display', 'none').setStyle('display', 'block');
			if(remaining >= 0) {
				twitter_counter.setStyle('color', 'green');
				this.setStyle('border-color', 'green');
			} else {
				twitter_counter.setStyle('color', 'red');
				this.setStyle('border-color', 'red');
			}
		};

		new Element('label', {'text': 'Enter the tweet you want your users to send'}).inject(wrap_twitter);
		var twitter_counter = new Element('span', {'class': 'ui-gateway-content-twitter-counter'});
		var twitter_tweet = new Element('textarea', {
			'class': 'ui_code ui_noresize ui-monospace margin-bottom',
			'name': idx+'[tweet]',
			'value': stripslashes(options.tweet || ''),
			'styles': {
				'width': '510px',
				'height': '55px'
			},
			'events': {
				'keyup': twitter_update
			}
		}).inject(wrap_twitter);
		twitter_counter.inject(wrap_twitter);

		twitter_update.bind(twitter_tweet)();

		wrap_twitter.inject(panel);
	},
	'share-facebook': function(widget, panel, name, options) {
		var idx = widget.getData('widget-idx');

		// Facebook options
		var wrap_facebook = new Element('div', {
			'class': 'ui-gateway-content'
		});

		new Element('label', {'text': 'Enter the URL to be shared'}).inject(wrap_facebook);
		var facebook_url = new Element('input', {'type': 'text', 'name': idx+'[url]', 'value': stripslashes(options.url || '')}).inject(wrap_facebook);
		new Element('span', {'class': 'info', 'text': 'Leave it blank to share whatever URL the video is posted on!'}).inject(wrap_facebook);

		wrap_facebook.inject(panel);
	},
	// Select a button from a gallery!
	'button': function(widget, panel, name, options) {
		var idx = widget.getData('widget-idx');
		new Element('label', {'text': 'Enter your cart or PayPal payment URL here'}).inject(panel);
		new Element('input', {
			'type': 'text',
			'class': 'margin-bottom',
			'name': idx+'[url]',
			'value': stripslashes(options.url || ''),
			'styles': {
				'width': '547px'
			}
		}).inject(panel);

		/*
		new Element('label', {'text': 'Enter a label for your button'}).inject(panel);
		new Element('input', {
			'type': 'text',
			'class': 'margin-bottom',
			'name': idx+'[action]',
			'value': stripslashes(options.action || 'Add to cart'),
			'styles': {
				'width': '200px'
			}
		}).inject(panel);
		*/

		var input = new Element('input', {
			'type': 'hidden',
			'name': idx+'[button_seed]',
			'value': options.button_seed || ''
		}).inject(panel);

		// Label it
		new Element('label', {'text': 'Select your button'}).inject(panel);

		// Build the gallery
		var gallery = build_gallery(<?php echo encode($gallery_button); ?>, (options.button_seed || 'button-5'));

		gallery.addEvent('onGallerySelect', function(button_seed) {
			input.set('value', button_seed);
			input.getParent('.widget-config-panel').setStyle('height', '350px');
			var preview = window.widgets_build_preview(widget, 'button', idx);

			var width, height;

			if(typeof options.button_seed == 'undefined' || button_seed !== options.button_seed) {

				var button_size = $('thisPage').retrieve('button_data')[button_seed] || {'config':{}};
				width = parseInt(button_size.config.width);
				height = parseInt(button_size.config.height);


			//width = 200;
			//height = 90;
			} else {
				width = parseInt(options.widget_pos_width);
				height = parseInt(options.widget_pos_height);
			}

			options.widget_pos_width = width;
			options.widget_pos_height = height;
			panel.getElement('input[name$="[widget_pos_width]"]').set('value', width);
			panel.getElement('input[name$="[widget_pos_height]"]').set('value', height);

			widget.setStyles({
				'width': width,
				'height': height
			});

			var resize = widget.retrieve('mooresize');
			if(resize) {
				resize.elCoords = preview.getCoordinates();
				resize.origRatio = width / height;
				resize.setRatio(true);
			}

			confineWidget(widget, options, idx);
		});

		gallery.inject(panel);
	},
	// Select a button from a gallery!
	'paypal': function(widget, panel, name, options) {
		var idx = widget.getData('widget-idx');
		new Element('label', {'text': 'Enter your URL here - for example, PayPal provide an \'email\' link which you could use to accept a payment!'}).inject(panel);
		new Element('input', {
			'type': 'text',
			'class': 'margin-bottom',
			'name': idx+'[url]',
			'value': stripslashes(options.url || ''),
			'styles': {'width': '430px'}
		}).inject(panel);

		var input = new Element('input', {
			'type': 'hidden',
			'name': idx+'[button_seed]',
			'value': options.button_seed || ''
		}).inject(panel);

		new Element('span', {'class': 'info', 'text': 'You can enter any full URL in here if you want!'}).inject(panel);

		// Label it
		new Element('label', {'text': 'Create your button by entering your own text in the fields below!'}).inject(panel);

		// Build the live preview bit
		var live = new Element('div', {
			'class': 'ui-event-widget-live-preview ui-event-widget-live-preview-paypal margin-bottom'
		});

		// There are 4 text inputs we need to add
		new Element('input', {
			'type': 'text',
			'class': 'paypal-preview-intro',
			'name': idx+'[button_intro]',
			'value': options.button_intro || ''
		}).inject(live);

		new Element('input', {
			'type': 'text',
			'class': 'paypal-preview-text',
			'name': idx+'[button_text]',
			'value': stripslashes(options.button_text || '')
		}).inject(live);

		new Element('input', {
			'type': 'text',
			'class': 'paypal-preview-tag',
			'name': idx+'[button_tag]',
			'value': options.button_tag || ''
		}).inject(live);

		new Element('input', {
			'type': 'text',
			'class': 'paypal-preview-disclaimer',
			'name': idx+'[button_disclaimer]',
			'value': stripslashes(options.button_disclaimer || '')
		}).inject(live);

		live.inject(panel);

		// Build the gallery
		var gallery = build_gallery(<?php echo encode($paypal_button); ?>, (options.button_seed || 'button-1'));

		gallery.addClass('ui-event-widget-gallery-paypal');

		gallery.addEvent('onGallerySelect', function(button_seed) {
			live.setStyle('background-image', 'url(../player/event-widgets/paypal/'+button_seed+'/button.png)');
			input.set('value', button_seed);
			window.widgets_build_preview(widget, 'paypal', idx);
		});

		live.getElements('input[type="text"]').addEvent('keyup', function() {
			window.widgets_build_preview(widget, 'paypal', idx);
		});

		gallery.inject(panel);
	},
	// Select an image to upload
	'image': function(widget, panel, name, options) {
		var idx = widget.getData('widget-idx');

		var input = new Element('input', {
			'type': 'hidden',
			'name': idx+'[src]',
			'value': options.src || ''
		}).inject(panel);

		var wrapper = new Element('div', {'id': 'image-uploader-'+idx}).inject(panel);

		var right = new Element('div', {'class': 'align-right margin-bottom'}).inject(wrapper);

		new Element('label', {'text': 'Select your image'}).inject(wrapper);
		var button = new Element('div', {
			'text': 'Select an image',
			'id': 'image-uploader-'+idx+'-select'
		}).setData('behavior', 'Button').setData('button-type', 'action').setData('button-width', '130');

		if(typeof options.src == 'undefined' || options.src.length <= 0) right.setStyle('display', 'none');
		else button.set('text', 'Replace this image');

		button.inject(wrapper);

		new Element('label', {'text': 'Set the width for this image (In pixels)'}).inject(panel);
		new Element('input', {
			'type': 'text',
			'class': 'margin-bottom',
			'name': idx+'[width]',
			'value': stripslashes(options.width || '150'),
			'styles': {
				'width': '45px'
			},
			'events': {
				'keyup': function() {
					window.widgets_build_preview(widget, 'image', idx);
				},
				'change': function() {
					window.widgets_build_preview(widget, 'image', idx);
				}
			}
		}).inject(panel);

		new Element('label', {'text': 'Set the height for this image (In pixels)'}).inject(panel);
		new Element('input', {
			'type': 'text',
			'class': 'margin-bottom',
			'name': idx+'[height]',
			'value': stripslashes(options.height || '150'),
			'styles': {
				'width': '45px'
			},
			'events': {
				'keyup': function() {
					window.widgets_build_preview(widget, 'image', idx);
				},
				'change': function() {
					window.widgets_build_preview(widget, 'image', idx);
				}
			}
		}).inject(panel);

		new Element('label', {'text': 'Enter a URL to make this image clickable.'}).inject(panel);
		new Element('input', {
			'type': 'text',
			'class': 'margin-bottom',
			'name': idx+'[href]',
			'value': stripslashes(options.href || ''),
			'styles': {
				'width': '210px'
			}
		}).inject(panel);

		(function($) {
			var uploader = new plupload.Uploader({
				'runtimes': 'html5',
				'browse_button': 'image-uploader-'+idx+'-select',
				'container': 'image-uploader-'+idx,
				'max_file_size': '10mb',
				'file_data_name': 'file',
				'url': '<?php echo $upload_url; ?>',
				'filters': [
					{'title': "Images", 'extensions': "jpg,jpeg,gif,png,JPG,JPEG,GIF,PNG"}
				]
			});

			(function() {
				uploader.init();
			}).delay(750);

			uploader.bind('Init', function() {
				clearInterval(window['evp-image-uploader-'+idx]);
			});

			uploader.bind('FilesAdded', function(up, files) {
				document.id('image-uploader-'+idx).spin({'message': '0%'});
				up.refresh(); // Reposition Flash/Silverlight
				(function() {
					up.start();
				}).delay(500);
			});

			uploader.bind('UploadProgress', function(up, file) {
				document.id('image-uploader-'+idx).getNext('.spinner').getElement('.spinner-msg').set('text', file.percent+'%')
			});

			uploader.bind('Error', function(up, err) {
				if(typeof console != 'undefined') {
					console.error(err.message);
					console.log(err, uploader);
				}

				if(err.message == 'Init error.') {
					window['evp-image-uploader-'+idx] = setTimeout(function() {
						uploader.init();
					}, 200);
				} else {
					alert(err.message);
					document.id('image-uploader-'+idx).unspin();
					up.refresh(); // Reposition Flash/Silverlight
				}
			});

			uploader.bind('FileUploaded', function(up, file) {
				// Get the image
				var amazon_name = '<?php echo $file_image_seed; ?>'+file.name;
				var amazon_location = '<?php echo $upload_path; ?>';

				// Update the preview
				var r = new Date().getTime();
				document.id('image-uploader-'+idx+'-preview').set('src', amazon_location+amazon_name+'?v='+r).addEvent('load', function() {
					document.id('image-uploader-'+idx).unspin();
					window.widgets_build_preview(widget, 'image', idx);
					(function() {
						try {
							var size = document.id('image-uploader-'+idx+'-preview').measure(function() {
								return $(this).getSize();
							});
							img_label.set('text', 'Your image (Native dimensions: '+size.x+'x'+size.y+'px)');
						} catch(e) {}
					}).delay(250);
				});

				// Reveal the right-hand panel
				right.reveal();
				document.id('image-uploader-'+idx+'-select').getElement('.moobutton_text').set('text', 'Replace this image');

				// Update the value
				input.set('value', amazon_location+amazon_name);
			});
		}(jQuery));

		var img_label = new Element('label', {'text': 'Your image'}).inject(right);
		new Element('img', {
			'src': options.src || '<?php echo url('player/images/no-image.png'); ?>',
			'id': 'image-uploader-'+idx+'-preview',
			'styles': {
				'width': 'auto',
				'height': 'auto',
				'max-width': '320px'
			}
		}).inject(right);
	}
};

function widgets_build_preview(el, widget_slug, idx) {

	$(el).getElements('.widget-live-preview').destroy();

	var d = el.retrieve('config-panel').serialize(true);
	var this_widget = d[idx] || {};

	var preview = new Element('div', {'class': 'widget-live-preview'}).inject(el);

	var def = function(str) {
		var bgi = $('timeline-event-option-'+widget_slug).getElement('img').get('src');
		preview.setStyles({
			'background': 'url('+bgi+') no-repeat center center',
			'height': '100%'
		});
		preview.adopt(
			new Element('p', {'class': 'widget-live-preview-explanation', 'text': (str || 'Customise below!')})
		);
	//$('timeline-event-option-'+widget_slug).clone().inject(preview).getElement('span').destroy();
	}

	switch(widget_slug) {
		case 'text':
			if(this_widget.body) {
				var text = html_entity_decode(stripslashes(stripslashes(this_widget.body || ''))); // Double-unescape?? Why??

				var event_mode = ($('timeline-content-event').getElement('input[name="event-mode"]:checked') ? $('timeline-content-event').getElement('input[name="event-mode"]:checked').get('value') : 'internal');

				if(event_mode == 'external') {
					var tc = '#000';
					var ts = 'rgba(255,255,255,0.2)';
				} else {
					var tc = '#fff';
					var ts = 'rgba(0,0,0,0.2)';
				}

				new Element('div', {
					'html': text,
					'styles': {
						'color': tc,
						'text-shadow': ts+' 1px 1px 0'
					}
				}).inject(preview);

			} else {
				def('Enter your text below');
			}
			break;
		case 'share-twitter':
			new Element('div', {
				'styles': {
					'width': '100px',
					'height': '53px',
					'background': 'url(../player/images/twitter-share.png) no-repeat'
				}
			}).inject(preview);
			break;
		case 'share-facebook':
			new Element('div', {
				'styles': {
					'width': '122px',
					'height': '42px',
					'background': 'url(../player/images/facebook-share.png) no-repeat'
				}
			}).inject(preview);
			break;
		case 'paypal':
			var button = new Element('div', {
				'class': 'ui-widget-live-preview-paypal',
				'styles': {
					'width': '300px',
					'height': '218px',
					'background-size': '300px 218px',
					'background': 'url(../player/event-widgets/paypal/'+this_widget.button_seed+'/button.png) no-repeat'
				}
			}).inject(preview);

			new Element('p', {
				'styles': {'position': 'relative', 'top': '28px', 'font-size': '16px'},
				'text': stripslashes(this_widget.button_intro || '')
			}).inject(button);

			new Element('p', {
				'styles': {'position': 'relative', 'top': '59px', 'font-size': '16px'},
				'text': stripslashes(this_widget.button_text || '')
			}).inject(button);

			new Element('p', {
				'styles': {'position': 'relative', 'top': '99px', 'font-size': '16px', 'color': '#0035ce', 'font-weight': 'bold'},
				'text': stripslashes(this_widget.button_tag || '')
			}).inject(button);

			new Element('p', {
				'styles': {'position': 'relative', 'top': '105px', 'font-size': '16px'},
				'text': stripslashes(this_widget.button_disclaimer || '')
			}).inject(button);

			break;
		case 'button':
			if(!this_widget.button_seed) this_widget.button_seed = 'oto-5';
			var i = new Element('img', {
				'src': '../player/event-widgets/button/'+this_widget.button_seed+'/button.png?v=1',
				'styles': {
					'width': '100%',
					'height': 'auto'
				},
				'class': 'ui-widget-live-preview-button'
			}).inject(preview);
			break;
		case 'image':
			if(this_widget.src) {
				new Element('img', {
					'src': this_widget.src,
					'styles': {
						'width': parseInt(this_widget.width),
						'height': parseInt(this_widget.height)
					}
				}).inject(preview);

				el.setStyles({
					'width': parseInt(this_widget.width),// + 22,
					'height': parseInt(this_widget.height)// + 22
				});

				el.retrieve('config-panel').getElement('input[name$="[widget_pos_width]"]').set('value', parseInt(this_widget.width));
				el.retrieve('config-panel').getElement('input[name$="[widget_pos_height]"]').set('value', parseInt(this_widget.height));

			} else {
				def('Upload your image below');
			}
			break;
		case 'gateway':
			if(this_widget.body) {
				var text = html_entity_decode(stripslashes(stripslashes(this_widget.body || ''))); // Double-unescape?? Why??
				var welcome = new Element('div', {'class': 'margin-bottom', 'html': text});
			}

			switch(this_widget.type) {
				case 'password':
					if(welcome) welcome.inject(preview);
					new Element('div', {
						'styles': {
							'clear': 'both',
							'margin': '0 auto',
							'width': '210px',
							'height': '44px',
							'background': 'url(<?php echo assets('assets/timeline/gateway-password.png'); ?>) no-repeat'
						}
					}).inject(preview);
					break;
				case 'facebook':
					if(welcome) welcome.inject(preview);
					new Element('div', {
						'styles': {
							'clear': 'both',
							'margin': '0 auto',
							'width': '142px',
							'height': '62px',
							'border': '1px solid #aaa',
							'box-shadow': '0 1px 1px #aaa',
							'border-radius': '6px',
							'background': 'url(../player/images/facebook-share.png) no-repeat 50% 50% #eee'
						}
					}).inject(preview);
					break;
				case 'twitter':

					var twitter = new Element('div', {
						'styles': {
							'border': '1px solid #aaa',
							'box-shadow': '0 1px 1px #aaa',
							'border-radius': '6px',
							'width': 300,
							'background': '#eee',
							'margin': '0 auto',
							'padding': '10px',
							'position': 'relative'
						}
					});

					new Element('div', {
						'styles': {
							'position': 'absolute',
							'top': '10px',
							'right': '-50px',
							'width': '57px',
							'height': '130px',
							'background': 'url(../player/images/gateway-arrow.png) no-repeat'
						}
					}).inject(twitter);

					var share = new Element('div', {
						'styles': {
							'clear': 'both',
							'margin': '0 auto',
							'width': '76px',
							'height': '28px',
							'float': 'right',
							'background': 'url(../player/images/twitter-gateway.png) no-repeat'
						}
					});

					if(welcome) twitter.adopt(welcome);

					if(this_widget.twitter_tweet) {
						twitter.adopt(new Element('textarea', {
							'styles': {
								'box-shadow': '0 0 5px #fff',
								'font-size': '13px',
								'color': '#000',
								'width': '290px',
								'height': '40px',
								'padding': '3px',
								'margin': '5px 0',
								'border-radius': '4px'
							},
							'disabled': true,
							'value': this_widget.twitter_tweet
						}));
					}

					twitter.adopt(share);

					twitter.adopt(new Element('div', {'class':'clear'}));

					twitter.inject(preview);
					break;
				case 'optin':
					if(welcome) welcome.inject(preview);
					$('timeline-event-option-html').clone().inject(preview).setStyles({
						'margin': '0 auto',
						'clear': 'both'
					}).getElement('span').destroy();
					break;
			}

			break;
		default:
			def();
			break;
	}

	return preview;
}

window.widgets_build_preview = widgets_build_preview; // Expose globally

var sizeInternalEventArea = function(pos, leaveOuter) {
	// Size the main bits
	$$('#event-area-preview, #event-area').setStyles({
		'width': pos.width.toInt(),
		'height': pos.height.toInt()
	});

	$('event-area-wrapper').setStyles({
		'width': pos.width.toInt(),
		'height': $('event-area-wrapper').retrieve('style-height-original')
	});

	// Set the 'top' value as it originally was
	$$('#event-area-preview, #event-area').setStyles({
		'top': $('event-area-preview').retrieve('style-top-original')
	});

	if(leaveOuter !== true) $('event-area-outer').setStyle('height', pos.height.toInt() + 60);
}

var sizeExternalEventArea = function(pos) {
	$('event-area-resize-width').set('value', pos.width.toInt());
	$('event-area-resize-height').set('value', pos.height.toInt());

	// Size the main bits
	$$('#event-area-wrapper, #event-area-preview, #event-area').setStyles({
		'width': pos.width.toInt(),
		'height': pos.height.toInt()
	});

	// Set the 'top' value to 0
	$$('#event-area-wrapper, #event-area').setStyles({
		'top': '0px'
	});

	$('event-area-outer').setStyle('height', '');

	// Make sure that any Gateways inside are knocked down too
	$('event-area-wrapper').getElements('.ui-event-widget-gateway').each(function(el) {
		var widget_pos_width = pos.width.toInt();
		var widget_pos_height = pos.height.toInt();

		el.setStyles({
			'width': widget_pos_width,
			'height': widget_pos_height
		});

	//el.getElement('[name="widget_pos_width"]').set('value', widget_pos_width);
	//el.getElement('[name="widget_pos_height"]').set('value', widget_pos_height);
	});
}

var confineWidget = function(el, options, idx) {
	var move_x = (el.retrieve('config-panel') ? el.retrieve('config-panel').getElement('[name="'+idx+'[widget_pos_x]"]') : '');
	var move_y = (el.retrieve('config-panel') ? el.retrieve('config-panel').getElement('[name="'+idx+'[widget_pos_y]"]') : '');
	var resize_x = (el.retrieve('config-panel') ? el.retrieve('config-panel').getElement('[name="'+idx+'[widget_pos_width]"]') : '');
	var resize_y = (el.retrieve('config-panel') ? el.retrieve('config-panel').getElement('[name="'+idx+'[widget_pos_height]"]') : '');

	var absolute_max_x, absolute_max_y, the_x, the_y, the_width, the_height;

	var update = function() {
		absolute_max_x = $('event-area').getStyle('width').toInt() - 20;
		absolute_max_y = $('event-area').getStyle('height').toInt() - 20;

		the_x = parseInt(options.widget_pos_x) + parseInt(options.widget_pos_width);
		the_y = parseInt(options.widget_pos_y) + parseInt(options.widget_pos_height);

		the_width = parseInt(options.widget_pos_width);
		the_height = parseInt(options.widget_pos_height);
	};

	// Now let's see if the initial width or height is greater than the dimensions
	update();
	var modified_pos = false;

	if(the_width > absolute_max_x) {
		var ratio = (options.widget_pos_width / options.widget_pos_height);
		options.widget_pos_width = absolute_max_x - 2;
		options.widget_pos_height = options.widget_pos_width * ratio;
		update();
		modified_pos = true;
	}

	if(the_height > absolute_max_y) {
		var ratio = (options.widget_pos_width / options.widget_pos_height);
		options.widget_pos_height = absolute_max_y - 2;
		options.widget_pos_width = options.widget_pos_height * ratio;
	 update();
		modified_pos = true;
	}

	if(the_x > absolute_max_x) { // Is it too far to the right?
		options.widget_pos_x = (absolute_max_x - options.widget_pos_width) - 2;
		update();
		modified_pos = true;
	}

	if(the_y > absolute_max_y) { // Is it too far to the bottom?
		options.widget_pos_y = (absolute_max_y - options.widget_pos_height) - 2;
		update();
		modified_pos = true;
	}



	if(the_x - the_width < 0) { // Is it simply too wide?
		options.widget_pos_x = 0;
		update();
		modified_pos = true;
	}

	if(the_y - the_height < 0) { // Is it too high?
		options.widget_pos_y = 0;
		options.widget_pos_height = absolute_max_y - 2;
		update();
		modified_pos = true;
	}

//if(modified_pos) { // We have changed, so we need to reposition everything
		var pos = el.setPosition({'x': options.widget_pos_x, 'y': options.widget_pos_y}).setStyles({'width': options.widget_pos_width, 'height': options.widget_pos_height});
		if(move_x) move_x.set('value', options.widget_pos_x);
		if(move_y) move_y.set('value', options.widget_pos_y);
		if(resize_x) resize_x.set('value', options.widget_pos_width);
		if(resize_y) resize_y.set('value', options.widget_pos_height);
//}
}

var buildEventWidget = function(name, options, widget_idx, is_brand_new) {
	window.retrieve('ui-save-element-tooltip').hide(); // Hide the tooltip that comes up warning about empty events

	if(widget_idx) widget_idx = ''+widget_idx; // Force into a string so it gets saved even if 0

	var options = Object.merge({
		'widget_pos_width': false,
		'widget_pos_height': false,
		'widget_pos_x': false,
		'widget_pos_y': false,
		'readable-name': ($('timeline-event-option-'+name) ? $('timeline-event-option-'+name).getData('readable-name') : '')
	}, options);

	var elClass = (!!$('overlay-padding').get('checked') ? '' : 'no-padding');

	var el = new Element('div', {
		'class': 'event-widget ui-event-widget-'+name.makeSeed()+' '+elClass,
		'id': 'ui-event-widget-'+name.makeSeed()+'-'+Number.random(100, 9999),
		'opacity': 0
	});

	var bg = new Element('div', {
		'class': 'event-widget-filler',
		'styles': {
			'background-color': '#eee',
			'opacity': 0,
			'width': '100%',
			'height': '100%',
			'position': 'absolute',
			'left': 0,
			'top': 0,
			'z-index': '0',
			'border': '1px dotted #000'
		}
	}).inject(el, 'top');

	// Show the ui buttons on mouseover
	// also fade the background colour change
	el.addEvents({
		'mouseenter': function() {
			el.getElements('.ui-icon').fade(0.8);
			bg.fade(0.6);
		},
		'mouseleave': function() {
			el.getElements('.ui-icon').fade(0.4);
			bg.fade(0.2);
		}
	});

	el.getElements('.ui-icon').fade(0.4);

	// Configuration button
	var config = new Element('div', {'class': 'widget-config ui-icon ui-icon-gear', 'title': 'Configure this Widget'}).inject(el, 'bottom');

	// Make the delete
	var del = new Element('div', {'class': 'widget-delete ui-icon ui-icon-delete', 'title': 'Remove this Widget'}).inject(el, 'bottom');

	// Configuration wrapper
	var panel = new Element('div', {'class': 'widget-config-panel styled descend', 'styles': {'display': 'none'}});//.inject(el, 'bottom');

	// Configuration title
	new Element('h2', {'text': 'Set up this widget', 'class': 'margin-bottom'}).inject(panel);

	// Inject
	el.inject($('event-area'));

	// Inject the panel into the bottom area
	panel.inject($('timeline-content'), 'after');
	el.store('config-panel', panel);

	// Push the idx
	var idx = widget_idx || $('event-area').getElements('.event-widget').length + 1;

	// Make it move-able?
	var move_handle = el;//new Element('div', {'class': 'event-widget-move ui-icon ui-icon-grid'}).inject(el);
	var pos = el.setPosition({'x': options.widget_pos_x, 'y': options.widget_pos_y});
	var move_x = new Element('input', {'type': 'hidden', 'name': idx+'[widget_pos_x]', 'value': options.widget_pos_x}).inject(panel); // Hidden
	var move_y = new Element('input', {'type': 'hidden', 'name': idx+'[widget_pos_y]', 'value': options.widget_pos_y}).inject(panel); // Hidden

	if(name !== 'gateway') {
		var move = new Drag.Move(el, {
			'handle': move_handle,
			'container': $('event-area'),
			'checkDroppables': false,
			'onDrop': function(el) {
				var pos = el.getPosition($('event-area'));
				move_x.set('value', pos.x);
				move_y.set('value', pos.y);
			}
		});
	}

	// Make it resizable if it's text or HTML - always set the dimensions for a more proper preview
	// Do we need to set a width/height for this widget?
	if(options.widget_pos_width == false && options.widget_pos_height == false) {
		switch(name) {
			case 'button':
				options.widget_pos_width = 200;
				options.widget_pos_height = 90;
				break;
			case 'paypal':
				options.widget_pos_width = 320;
				options.widget_pos_height = 238;
				break;
			case 'share-twitter':
				options.widget_pos_width = 100;//55;
				options.widget_pos_height = 53;//62;
				break;
			case 'share-facebook':
				options.widget_pos_width = 122;//142;//122;
				options.widget_pos_height = 42;//62;//42;
				break;
			case 'image':
				options.widget_pos_width = 76;//56;
				options.widget_pos_height = 76;//56;
				break;
			case 'gateway':
				el.setPosition({'x': 0, 'y': 0});
				move_x.set('value', 0);
				move_y.set('value', 0);
				options.widget_pos_width = $('event-area').getStyle('width').toInt();// - 4;
				options.widget_pos_height = $('event-area').getStyle('height').toInt();// - 4;
				break;
			case 'text':
				options.widget_pos_width = $('event-area').getStyle('width').toInt() * 0.6;
				options.widget_pos_height = $('event-area').getStyle('width').toInt() * 0.3;
				break;
			default:
				options.widget_pos_width = 150;
				options.widget_pos_height = 76;//50;
				break;
		}
	} else {
		options.widget_pos_width = parseInt(options.widget_pos_width);// + 22;
		options.widget_pos_height = parseInt(options.widget_pos_height);// + 22;
	}

	var resize_width = new Element('input', {'type': 'hidden', 'name': idx+'[widget_pos_width]', 'value': options.widget_pos_width}).inject(panel); // Hidden
	var resize_height = new Element('input', {'type': 'hidden', 'name': idx+'[widget_pos_height]', 'value': options.widget_pos_height}).inject(panel); // Hidden

	el.setStyles({'width': options.widget_pos_width, 'height': options.widget_pos_height});

	if(name == 'text' || name == 'html' || name == 'image') {
		var resize_handle = new Element('div', {'class': 'event-widget-resize ui-icon ui-icon-arrow-se'}).inject(el);

		(function() {
			var max_size_x = $('event-area').getStyle('width').toInt() - 24;
			var max_size_y = $('event-area').getStyle('height').toInt() - 24;

			var resize = new MooResize(el, {
				ratio: false,
				handles: ['corner'],
				handleClass: 'event-widget-resize ui-icon ui-icon-arrow-se',
				handleSize: 18,
				relativeTo: $('event-area'),
				onStart: function(){
					el.addClass('event-widget-active');
				},
				onResize: function(size) {
					var pos = el.getCoordinates($('event-area'));
					resize_width.set('value', (pos.width - 22));
					resize_height.set('value', (pos.height - 22));
					// Is this an image? If so, we need to update the values
					if(name == 'image') {
						panel.getElement('input[name$="[width]"]').set('value', (pos.width - 22)).fireEvent('change');
						panel.getElement('input[name$="[height]"]').set('value', (pos.height - 22)).fireEvent('change');
					}
				},
				onComplete: function(size){
					el.removeClass('event-widget-active');
					var pos = el.getCoordinates($('event-area'));
					resize_width.set('value', (pos.width - 22));
					resize_height.set('value', (pos.height - 22));
					// Is this an image? If so, we need to update the values
					if(name == 'image') {
						panel.getElement('input[name$="[width]"]').set('value', (pos.width - 22)).fireEvent('change');
						panel.getElement('input[name$="[height]"]').set('value', (pos.height - 22)).fireEvent('change');
					}
				},
				minSize: {
					x: 40,
					y: 40
				},
				maxSize: {
					x: function(width, height) {//max_size_x
						var absolute_max_x = $('event-area').getStyle('width').toInt();
						return absolute_max_x - parseInt(move_x.get('value')) - 22;
					},
					y: function(width, height) {//max_size_y
						var absolute_max_y = $('event-area').getStyle('height').toInt();
						return absolute_max_y - parseInt(move_y.get('value')) - 22;
					}
				}
			});

			if(move) {
				move.addEvent('onDrag', function(el) {
					resize.elCoords = resize.el.getCoordinates();//resize.relativeTo);
				});
			}
		}).delay(1500);
	}

	if(name == 'button') {
		var resize_handle = new Element('div', {'class': 'event-widget-resize ui-icon ui-icon-arrow-se'}).inject(el);

		(function() {
			var max_size_x = $('event-area').getStyle('width').toInt() - 24;
			var max_size_y = $('event-area').getStyle('height').toInt() - 24;

			var resize = new MooResize(el, {
				ratio: true,
				handles: ['corner'],
				handleClass: 'event-widget-resize ui-icon ui-icon-arrow-se',
				handleSize: 18,
				relativeTo: $('event-area'),
				onStart: function(){
					el.addClass('event-widget-active');
				},
				onResize: function(size) {
					var pos = el.getCoordinates($('event-area'));
					resize_width.set('value', (pos.width - 22));
					resize_height.set('value', (pos.height - 22));
				},
				onComplete: function(size){
					el.removeClass('event-widget-active');
					var pos = el.getCoordinates($('event-area'));
					resize_width.set('value', (pos.width - 22));
					resize_height.set('value', (pos.height - 22));
				},
				minSize: {
					x: 200,
					y: 90
				},
				maxSize: {
					x: function(width, height) {//max_size_x
						var absolute_max_x = $('event-area').getStyle('width').toInt();
						return absolute_max_x - parseInt(move_x.get('value')) - 22;
					},
					y: function(width, height) {//max_size_y
						var absolute_max_y = $('event-area').getStyle('height').toInt();
						return absolute_max_y - parseInt(move_y.get('value')) - 22;
					}
				}
			});

			// Removed as it has no effect?
		//resize.elCoords.width = parseInt(options.widget_pos_width);
		//resize.elCoords.height = parseInt(options.widget_pos_height);

			if(move) {
				move.addEvent('onDrag', function(el) {
					resize.elCoords = resize.el.getCoordinates();//resize.relativeTo);
				});
			}
		})();//.delay(1500);
	}


	// If this is a brand new one, we need to check the specified widget_pos_x and widget_pos_y plus the size and stop it overflowing
	// Gateway widgets automatically calculate their positioning all the time, so they also don't get confined
	// otherwise it ends up basically halving their positioning
	if(is_brand_new === true && name !== 'gateway') {
		confineWidget(el, options, idx);
	}

	// Let's add a new item into the widget storage, if there's no idx set
	var events = $('thisFile').retrieve('events');
	events = (typeOf(events) == 'array' ? {} : events);

	// Store this data inside the actual HTML element
	el.setData('widget-idx', idx);
	panel.setData('widget-idx', idx);
	el.setData('widget-slug', name);

	// And update the data
	$('thisFile').store('events', events);

	// Finally, the config
	if(typeof event_widget_config[name] == 'function') {
		event_widget_config[name](el, panel, name, options);

		var control_wrap = new Element('div', {
			'styles': {
				'clear': 'both'
				}
			}).inject(panel);

		new Element('input', {
			'type': 'button',
			'value': 'Cancel',
			'class': 'widget-cancel'
		}).setData('behavior', 'Button').setData('button-type', 'null').setData('button-width', '120px').inject(control_wrap);

		new Element('input', {
			'type': 'button',
			'value': 'Save your widget',
			'class': 'widget-save'
		}).setData('behavior', 'Button').setData('button-type', 'action').setData('button-width', '130px').inject(control_wrap);

		new Behavior().apply(panel);
		new Delegator().attach(panel);
	}

	// Hidden identifier for the type
	new Element('input', {'type': 'hidden', 'name': idx+'[widget_type]', 'value': name}).inject(panel);

	// And hidden for the IDX also
	new Element('input', {'type': 'hidden', 'name': idx+'[widget_idx]', 'value': idx}).inject(panel);

	// Aaand fade
	el.fade('in');

	// And trigger the config?
	if(!widget_idx) {
		show_config_panel.bind(config).delay(250);
	}

	// Now we should make an accurate preview of this, depending on what kind of widget it is
	widgets_build_preview(el, name, idx);

	return el;
}

function widgets_create(widget, widget_name) {
	switch(widget_name) {
		case 'gateway':
			var start_time = maskedTimeToSeconds($('event-start-string').get('value'));
			if(start_time == 0) return;
			StickyWin.confirm('Event timing', 'Press \'Ok\' below if you would like to set the time of this Event back to the very beginning.<br /><br />Most commonly, the Gateway widget is used to get your viewers to perform an action before they watch your video!', function() {
				$('event-start-string').set('value', '0:00');
				$('event-start-minutes').set('value', '0');
				$('event-start-seconds').set('value', '0');
			});
			break;
		}
}

function show_config_panel() {
	// First, close all other widget windows
	$$('.widget-config-panel').dissolve();

	// And onwards
	var widget = this.getParent('.event-widget') || this.getParent('.widget-config-panel');

	var panel = $(document.body).getElement('.widget-config-panel[data-widget-idx="'+widget.getData('widget-idx')+'"]');

	if(panel.retrieve('active') == true) {//panel.getStyle('display') == 'block') {
		panel.get('reveal').dissolve();
		$('timeline-content').reveal();
		panel.store('active', false);
	} else {
		panel.get('reveal').reveal();
		$('timeline-content').dissolve();
		panel.store('active', true);
	}

	OverText.update.delay(250); // Reposition any in case they're available
}

window.addEvent('domready', function() {

	// Make the tabs
	var ts = new TabSwapper({
		'tabs': $('options').getElements('ul.tabs li'),
		'sections': $('panels').getElements('> .tab-panel'),
		'smooth': true,
		'rearrangeDOM': false,
		'onActive': function(idx, panel, tab) {
			if(window.retrieve('ui-save-element-tooltip')) window.retrieve('ui-save-element-tooltip').hide(); // Hide the tooltip that comes up warning about empty events

			// IE needs to remake the select boxes or the width is wrong
			// This will break non-IE browsers as the 'change' event gets triggered
			// and every pane view will show the CSS animation - madness
			/*
			if(Browser.Engine.trident && Browser.Engine.version <= 8) {
				if($('general-player_entrance') && $('general-player_entrance').retrieve('mooselecta')) {
					$('general-player_entrance').retrieve('mooselecta').replaceSelect($('general-player_entrance'));
				}
			}
			*/

			if(panel.getData('remote-content') && !panel.retrieve('setup')) {
				var widgetArea = new WidgetisedArea(panel.getData('remote-content'), {'file_id': '<?php echo $file->id; ?>', 'profile': '<?php echo $profile; ?>'}, {
				//'spin': $('panels'),
					'update': panel,
					'update-method': 'update',
					'animation': 'fade'
				});
				panel.store('widgetArea', widgetArea);
				panel.store('setup', true);
				widgetArea.start();
			} else if(panel.getData('remote-content')) {
				panel.retrieve('widgetArea').start();
			}
		}
	});

	$('thisFile').store('settingsTabSwapper', ts);

	$$('.ui-options-next').addEvent('click', function() {
		ts.show(ts.now + 1);
	});

	$$('.ui-options-back').addEvent('click', function() {
		ts.show(ts.now - 1);
	});

	// Reset all of the Event info
	var event_width = $('event-area-wrapper').getStyle('width');
	var event_height = Math.ceil(parseInt($('event-area-wrapper').getStyle('height')) / 3);//$('event-area-wrapper').getStyle('height');
	if($('event-area-resize-width')) $('event-area-resize-width').set('value', event_width.toInt());
	if($('event-area-resize-height')) $('event-area-resize-height').set('value', event_height.toInt());

	$('timeline-content-event').addEvent('onActivate', function() {
		$('ui-delete-event-wrap').setStyle('display', 'none');

		// Check this doesn't exist
		var currentEventNames = Object.keys($('thisFile').retrieve('events') || {});
		var highest = 0;
		currentEventNames.each(function(i, idx) {
			var n = parseInt(i.replace(/[^\d.]/g, ''));
			if(n > highest) highest = n;
		});
		var name_idx = highest + 1;

		restoreEventArea({
			'name': 'My Event '+name_idx,
			'start-string': '00:00',
			'duration-string': '00:00',
			'data': {
				'event-mode': 'internal',
				'event-point': 'start',
				'event-width': event_width,
				'event-height': event_height,
				'event-type': 'pro',
				'event-scenario': '',
				'overlay-trigger-pause': false,
				'overlay-position': 'bottom',
				'overlay-entrance': 'css3-fadeInDown',
				'overlay-background-colour': '#292929',
				'overlay-translucent': true,
				'overlay-opaque': true,
				'overlay-remove-after': false,
				'overlay-padding': true,
				'widgets': {}
			}
		});
	});

	// Start and duration times
	$('event-start-minutes').addEvent('change', function() {
		var m = this.get('value') || 0;
		$('event-start-string').set('value', m+':'+$('event-start-seconds').get('value'));
	});
	$('event-start-seconds').addEvent('change', function() {
		var s = this.get('value') || 0;
		if(parseInt(s) < 10) s = '0'+(parseInt(s));
		$('event-start-string').set('value', $('event-start-minutes').get('value')+':'+s);
	});
	$('event-start-string').addEvent('change', function() {
		var t = this.get('value').split(':');
		$('event-start-minutes').set('value', t[0]);
		$('event-start-seconds').set('value', t[1]);
	});

	// Duration
	$('event-duration-minutes').addEvent('blur', function() {
		var m = this.get('value') || 0;
		$('event-duration-string').set('value', m+':'+$('event-duration-seconds').get('value'));
	});
	$('event-duration-seconds').addEvent('blur', function() {
		var s = this.get('value') || 0;
		if(parseInt(s) < 10) s = '0'+(parseInt(s));
		$('event-duration-string').set('value', $('event-duration-minutes').get('value')+':'+s);
	});
	$('event-duration-string').addEvent('change', function() {
		var t = this.get('value').split(':');
		$('event-duration-minutes').set('value', t[0]);
		$('event-duration-seconds').set('value', t[1]);
	});

	// Remove the duration if 'pause' is on
	if($('overlay-trigger-pause')) {
		$('overlay-trigger-pause').addEvent('change', function() {
			var on = this.get('checked');
			if(on) {
				$('overlay-duration-wrap').dissolve();
			} else {
				$('overlay-duration-wrap').reveal();
			}
		});
	}

	// Configuration of Event Widgets
	$('event-area').addEvent('click:relay(.widget-config)', show_config_panel);

	// Removal of Event Widgets
	$('event-area').addEvent('click:relay(.widget-delete)', function() {
		var widget = this.getParent('.event-widget');
		if(widget.getNext() && widget.getNext().match('.event-widget-resize')) widget.getNext().destroy();
		var event_name = $('event-name').get('value');
		var widget_idx = widget.getData('widget-idx');
		$('body').getElements('.widget-config-panel[data-widget-idx="'+widget_idx+'"]').kill();
		$('timeline-content').reveal();
		widget.kill(function() {
			var events = $('thisFile').retrieve('events');
			events = (typeOf(events) == 'array' ? {} : events);
			if(events[event_name]) events[event_name].data.widgets[widget_idx] = {};
		});
	});

	// Internal saving of Event widgets
	// also affects the cancel button
	$('body').addEvent('click:relay(.widget-save, .widget-cancel)', function() {
		var widx = (this.getParent('.event-widget') || this.getParent('.widget-config-panel')).getData('widget-idx');
		var el = $('event-area').getElement('.event-widget[data-widget-idx="'+widx+'"]');
		var widget_slug = el.getData('widget-slug');
		var idx = el.getData('widget-idx');
		widgets_build_preview(el, widget_slug, idx);
		show_config_panel.bind(this)();
	});

	// Drag and drop your Event widgets!
	$('timeline-event-options').getElements('.timeline-event-option').addEvent('mousedown', function(event) {
  event.stop();
		var shirt = this;

		var to_clone = shirt;
		var pos = to_clone.getPosition();
		var clone = to_clone.clone().addClass('timeline-event-option-dragging').setStyles({
			'left': pos.x,
			'top': pos.y,
			'width': '178px',
			'opacity': 0.7,
			'position': 'absolute',
			'z-index': 10
		}).inject(document.body);

  var drag = new Drag.Move(clone, {
		'droppables': $('event-area'),
   'onDrop': function(dragging, cart){
     var pos = dragging.getPosition(cart); // Position relative to the event area itself
     if (cart != null) { // It's been dropped in the proper place
						// The contents and settings will be amalgamated in restoreEventArea and createTimelineMarker
						// Which means that here, we're just creating the UI
						var event_widget_name = dragging.getData('name');

						// We should only allow a single gateway widget
						if(event_widget_name == 'gateway' && $('event-area').getChildren('div[data-widget-slug="gateway"]').length >= 1) {
							StickyWin.alert('Only the one!', 'You can only add one Gateway to each Event, because the Gateway requires your users to complete an action to move forwards.');
							dragging.destroy();
							return false;
						}

						var widget = buildEventWidget(event_widget_name, {
							'widget_pos_x': pos.x,
							'widget_pos_y': pos.y,
							'readable-name': dragging.getData('readable-name')
						}, false, true); // This final parameter tells it that it's new and the position will be corrected!
						widgets_create(widget, event_widget_name);
     }
     dragging.destroy();
   },
   'onCancel': function(dragging) {
    dragging.destroy();
   }
  });
  drag.start(event);
 });

 // Preview the selected entrance
	$('overlay-entrance').addEvent('change', function() {
		if(arguments.length == 0) return; // This means it's been set automatically
		var el = $$('#event-area-preview, #event-area');

		var o = this.options[this.selectedIndex];
		if(!o) return false;

		var current = $(o).get('value');
		el.setStyle('display', 'block');
		if(current == 'fade') {
			el.setStyle('opacity', 0).fade('in');
		} else {
			el.set('class', '');
			(function() {
				el.set('class', 'animated '+current.substr(5));
			}).delay(100);
			(function() {
				el.set('class', '');
			}).delay(800);
		}
	});

	if($('overlay-entrance-demo') && $('overlay-entrance')) {
		$('overlay-entrance-demo').addEvent('click', function() {
			$('overlay-entrance').fireEvent('change', true);
		});
	}

	$('overlay-background-opaque').addEvent('change', function() {
		var t = !!this.get('checked');
		if(t) {
			$$('#event-area-preview, #overlay-background-wrap-outer, #overlay-position-wrap-outer, #overlay-entrance-wrap-outer').reveal();
		} else {
			if($('overlay_position')) $('overlay_position').getElement('[data-value="full"]').fireEvent('click');
			$$('#event-area-preview, #overlay-background-wrap-outer, #overlay-position-wrap-outer, #overlay-entrance-wrap-outer').dissolve();
		}
	});

 // Change the overlay depending on the selected colour
 $('overlay-background-colour').addEvent('change', function() {
 	var bgc = this.get('value');
 	$('event-area-preview').setStyle('background-color', bgc);

 	// Create the gradient and apply it to the preview
 	if(!Browser.Engine.trident) {
			var gradientEnd = (bgc.substr(0, 1) == '#' ? bgc.substr(1) : bgc);
			var gradientStart = EVP_Helpers.generateGradient(gradientEnd, 'ffffff', 0.2);

			$('event-area-preview').setStyle('background', '-moz-linear-gradient(top,  #'+gradientStart+' 0%, #'+gradientEnd+' 100%)');
			$('event-area-preview').setStyle('background', '-webkit-gradient(linear, left top, left bottom, color-stop(0%,#'+gradientEnd+'), color-stop(100%,#'+gradientEnd+'))');
			$('event-area-preview').setStyle('background', '-webkit-linear-gradient(top,  #'+gradientStart+' 0%,#'+gradientEnd+' 100%)');
			$('event-area-preview').setStyle('background', '-o-linear-gradient(top,  #'+gradientStart+' 0%,#'+gradientEnd+' 100%)');
			$('event-area-preview').setStyle('background', '-ms-linear-gradient(top,  #'+gradientStart+' 0%,#'+gradientEnd+' 100%)');
			$('event-area-preview').setStyle('background', 'linear-gradient(top,  #'+gradientStart+' 0%,#'+gradientEnd+' 100%)');
		}
 });

 $('overlay-background-translucent').addEvent('change', function() {
 	var t = !!this.get('checked');
 	if(t) {
 		$('event-area-preview').setStyle('opacity', 0.9).store('style-opacity-original', 0.9);
 		return;
 	}
 	$('event-area-preview').setStyle('opacity', 1).store('style-opacity-original', 1);
 });

	// Change the size of the area depending on the position chosen
	var third = Math.ceil(parseInt($('event-area-wrapper').getStyle('height')) / 3);
	var overlay_positions = $$('#overlay-position-top, #overlay-position-bottom, #overlay-position-full');
	(function() {
		if(!$('overlay_position')) return false;
		$('overlay_position').retrieve('RadioGroup').addEvent('onCheck', function(visible_element, hidden_element, idx) {
	//overlay_positions.addEvent('click', function() {
			var position = hidden_element.get('value');//this.get('value');

			switch(position) {
				case 'top':
					var pos = {'height': third, 'top': 0, 'bottom': ''};
					break;
				case 'bottom':
					var pos = {'height': third, 'bottom': 0, 'top': ''};
					break;
				case 'full':
					var pos = {'height': $('event-area-wrapper').getStyle('height'), 'top': 0, 'bottom': ''};
					break;
			}

			pos.width = $('event-area-wrapper').getStyle('width');

			$$('#event-area, #event-area-preview').setStyles(pos);

			// Top and bottom should be adjustable
			if(position == 'top' || position == 'bottom') {
			//if($('event-area').retrieve('resizer') && $('event-area-resize-handle')) return false; // Already done!
	 		var handle = $('event-area-resize-handle') || new Element('div', {'id': 'event-area-resize-handle', 'class': 'event-widget-resize ui-icon ui-icon-arrow-se'}).inject($('event-area'));

	 		handle.setStyles({
	 			'display': 'block'
	 		}).inject($('event-area'));

	 		var events = $('thisFile').retrieve('events');
	 		var this_event_name = $('event-name').get('value');
	 		var total_widgets = $('event-area').getChildren('.event-widget');
	 		var event_area_height = $('event-area').getStyle('height').toInt();

	 		total_widgets.each(function(preview) {
		 		var widget_pos_y = preview.getStyle('top').toInt();
		 		var widget_height = preview.getSize().y.toInt();
		 		var widget_y = widget_pos_y + widget_height;

	 			if(widget_y > event_area_height) {
	 				var new_top = widget_pos_y + (widget_pos_y - ($('event-area-wrapper').getStyle('height').toInt() - event_area_height));//widget_pos_y - (widget_pos_y - event_area_height) - widget_height;
	 				if(new_top < 0) new_top = 0;
	 				preview.setStyle('top', new_top);
	 			}
	 		});

	 		if(position == 'bottom') {
	 			handle.setStyles({
	 				'bottom': '',
	 				'top': '-10px'
	 			});
	 		} else {
	 			handle.setStyles({
	 				'top': '',
	 				'bottom': '-10px'
	 			});
	 		}

	 		if($('event-area').retrieve('resizer')) $('event-area').retrieve('resizer').detach();

		 	$('event-area').makeResizable({
		 		'invert': (position == 'bottom'),
		 		'handle': handle,
		 		'modifiers': {
		 			'x': false,
		 			'y': 'height'
		 		},
		 		'limit': {
		 			'y': [60, third]
		 		},
		 		'onDrag': function(el) {
		 			var pos = el.getCoordinates($('event-area-wrapper'));
		 			if(position == 'bottom') {
		 				pos.top = '';
		 				pos.bottom = 0;
		 			} else {
		 				pos.top = 0;
		 				pos.bottom = '';
		 			}
						$$('#event-area, #event-area-preview').setStyles(pos);
		 		}
		 	});

			} else { // Stop resizing
				$('event-area-resize').dissolve();
				if($('event-area-resize-handle')) $('event-area-resize-handle').setStyle('display', 'none');
			}
		});
	}).delay(100);

	if(overlay_positions.length == 0) { // None available? Default to full
		if($('event-area-outer').hasClass('event-area-wrapper-audio')) {
			$$('#event-area, #event-area-preview').setStyles({'height': $('event-area-wrapper').getStyle('height'), 'width': $('event-area-wrapper').getStyle('width'), 'top': $('event-area-wrapper').getStyle('height'), 'bottom': ''});
		} else {
			$$('#event-area, #event-area-preview').setStyles({'height': $('event-area-wrapper').getStyle('height'), 'width': $('event-area-wrapper').getStyle('width'), 'top': 0, 'bottom': ''});
		}
	}

	// This is to allow the Element area to be resizable
	var enableElementResize = function() {
	//if($('event-area').retrieve('resizer') && $('event-area-resize-handle')) return false; // Already done!
 	var handle = $('event-area-resize-handle') || new Element('div', {'id': 'event-area-resize-handle', 'class': 'event-widget-resize ui-icon ui-icon-arrow-se'}).inject($('event-area-wrapper'));

		handle.setStyles({
			'top': '',
			'bottom': '-10px'
		}).inject($('event-area'));

		if($('event-area').retrieve('resizer')) $('event-area').retrieve('resizer').detach();

 	$('event-area').makeResizable({
 		'handle': handle,
 		'modifiers': {
 			'x': 'width',
 			'y': 'height'
 		},
 		'limit': {
 			'x': [100, 900],
 			'y': [100, 1200]
 		},
 		'onDrag': function(el) {
 			var pos = el.getCoordinates($('event-area-wrapper'));
				sizeExternalEventArea(pos);
 		}
 	});

 	if($('event-area-resize-update')) {
 		$('event-area-resize-update').addEvent('click', function() {
 			sizeExternalEventArea({
 				'width': $('event-area-resize-width').get('value').toInt(),
 				'height': $('event-area-resize-height').get('value').toInt()
 			});
 		});
 	}
 }

	// Hide certain options depending on the mode chosen
	$('event-area-wrapper').store('style-background-original', $('event-area-wrapper').getStyle('background-image'));
	$('event-area-preview').store('style-opacity-original', $('event-area-preview').getStyle('opacity'));
	$('event-area-wrapper').store('style-width-original', $('event-area-wrapper').getStyle('width'));
	$('event-area-wrapper').store('style-height-original', $('event-area-wrapper').getStyle('height'));
	$('event-area-preview').store('style-top-original', $('event-area-preview').getStyle('top'));

	var event_modes = $$('#event-mode-internal, #event-mode-external');
	event_modes.addEvent('click', function() {
		var mode = this.get('value');

		var optional_elements = $$('#event-type-wrap-outer, #overlay-background-wrap-outer, #overlay-position-wrap-outer, #overlay-allow-skip-wrap-outer, #overlay-opaque-wrap');
		switch(mode) {
			case 'external':
				optional_elements.disappear();

				$('event-area-wrapper').setStyle('background-image', '');
				$('event-area-preview').fade('out');
				$('event-area').setStyles({
					'border-bottom': 'none',
					'box-shadow': 'none'
				}).addClass('event-area-element');
				$('overlay-entrance-wrap-outer').addClass('clear');

				sizeExternalEventArea({
 				'width': $('event-area-resize-width').get('value').toInt() || 600,
 				'height': $('event-area-resize-height').get('value').toInt() || 400
				});

				enableElementResize.delay(500);

				break;
			default:
				optional_elements.reappear();
				$('event-area-resize').dissolve();
				if($('event-area-resize-handle')) $('event-area-resize-handle').setStyle('display', 'none');
				$('event-area-wrapper').setStyle('background-image', $('event-area-wrapper').retrieve('style-background-original'));
				$('event-area-preview').fade($('event-area-preview').retrieve('style-opacity-original'));
				$('event-area').setStyles({
					'border-bottom': '',
					'box-shadow': ''
				}).removeClass('event-area-element');

				$('event-area-resize').dissolve();
			//if($('event-area-resize-handle')) $('event-area-resize-handle').setStyle('display', (options.data['overlay-position'] == 'full' ? 'none' : 'block'))
				sizeInternalEventArea({
					'width': $('event-area-wrapper').retrieve('style-width-original'),
					'height': $('event-area-wrapper').retrieve('style-height-original')
				});

				$('overlay-entrance-wrap-outer').removeClass('clear');

				break;
		}
	});

	var event_points = $$('#event-point-start, #event-point-during, #event-point-end');
	event_points.addEvent('click', function() {
		var point = this.get('value');
		$('event-point').set('value', point);

		var optional_elements = $$('#event-type-wrap-outer, #overlay-background-wrap-outer, #overlay-position-wrap-outer, #overlay-allow-skip-wrap-outer, #overlay-opaque-wrap');
		switch(point) {
			case 'start':
				$$('#overlay-start-wrap').disappear();
				$$('#overlay-duration-wrap, #overlay-pause-wrap').reappear();
				$('event-start-minutes').set('value', '0').fireEvent('change');
				$('event-start-seconds').set('value', '0').fireEvent('change');
			//$('event-start-string').set('value', '0').fireEvent('change');

				if($('event-mode-external').get('checked')) {
					$$('#overlay-remove-after-wrap').reappear();
				} else {
					$$('#overlay-remove-after-wrap').disappear();
				}
				break;
			case 'end':
				$$('#overlay-start-wrap, #overlay-duration-wrap, #overlay-pause-wrap').disappear();

				/*
				if($('event-mode-external').get('checked')) {
					$$('#overlay-remove-after-wrap').reappear();
				} else {
					$$('#overlay-remove-after-wrap').disappear();
				}
				*/
				$$('#overlay-remove-after-wrap').disappear();

				$('event-start-minutes').set('value', '<?php echo $file_duration_minutes; ?>').fireEvent('change');
				$('event-start-seconds').set('value', '<?php echo $file_duration_seconds; ?>').fireEvent('change');
			//$('event-start-string').set('value', '<?php echo ceil($file->metadata['duration']); ?>');//.fireEvent('change');
				break;
			default:
				$$('#overlay-start-wrap, #overlay-duration-wrap, #overlay-pause-wrap').reappear();

				if($('event-mode-external').get('checked')) {
					$$('#overlay-remove-after-wrap').reappear();
				} else {
					$$('#overlay-remove-after-wrap').disappear();
				}

				break;
		}
	});

 $('overlay-padding').addEvent('change', function() {
 	var t = !!this.get('checked');
 	if(t) {
 		$$('div.event-widget').removeClass('no-padding').tween('padding', 10);
 		return;
 	}
 	$$('div.event-widget').addClass('no-padding').tween('padding', 0);
 });

	// Display a tooltip over the mode selector
	new Tips.Pointy($('event-mode-wrap-outer'), {
		'pointyTipOptions': {
			'point': 9
		}
	});

	// Save this Event
	(function() {
		var t = new StickyWin.PointyTip('', 'To save this Event, please configure at least one widget!', {
			'point': 6,
			'width': 200,
			'relativeTo': $('ui-save-event'),
			'showNow': false,
			'pointyOptions': {
				'closeButton': false
			}
		});

		window.store('ui-save-element-tooltip', t);

		$('ui-save-event').addEvent('click', function() {
			// Make sure there is at least one widget
			var total_widgets = $('event-area').getChildren('.event-widget').length;
			if(total_widgets <= 0) {
				t.position({
					'relativeTo': $('ui-save-event')
				});
				t.show();
				return false;
			}

			t.hide();

			// Let's check for too many events at the same time!
			var existing = $$('[data-evp-timeline-start="'+maskedTimeToSeconds($('event-start-string').get('value'))+'"]');
			if(existing.length >= 4) {
				StickyWin.alert('Too many!', 'You cannot have more than 4 Events starting at the exact same time!');
				return false;
			}

			// Do we need to delete an old chapter, because we're editing?
			if($('thisPage').retrieve('current_event') && $('thisPage').retrieve('current_event') !== $('event-name').get('value')) {
				var events = $('thisFile').retrieve('events') || {};
				events = (typeOf(events) == 'array' ? {} : events);
				delete events[$('thisPage').retrieve('current_event')];
				// Delete the marker?
				$$('#timeline-marker-'+$('thisPage').retrieve('current_event').makeSeed()).kill(function() {
					positionTimelineMarkers();
				});
				$('thisFile').store('events', events);
			}

			// Let's check if we are editing something or not
			if($('timeline-marker-'+$('event-name').get('value').makeSeed())) {
				// We are editing..
			} else { // We are making a new Event, so is it External?
				if($('timeline-content-event').getElement('input[name="event-mode"]:checked').get('value') == 'external') {
					// Great; let's prompt them to add it to their Page
					var pw = $('thisFile').retrieve('page-widgets');
					var modal;

					if(pw && Object.getLength(pw) >= 1) {

						var sw = StickyWin.ui('Add to Page?', new Element('div', {'html': '<p>Do you want to add this External Event to your video page? If you choose not to, you can always add it from the page builder!</p>'}), {
							'width': '400px',
							'buttons': [{
								'text': 'Not right now'
							}, {
								'text': 'Yes; add to my video page',
								'properties': {'class': ''},
								'onClick': function() {
									var d = $('thisFile').retrieve('data');
									var widget_idx = Number.random(1, 5000);
									var new_widget = {
										'align_centre': 'on',
										'element': $('event-name').get('value'),
										'idx': widget_idx,
										'name': 'My Event',
										'slug': 'my-event'
									};
									pw[widget_idx] = new_widget;
									(d.page_widgets_order || []).push(widget_idx);
									$('thisFile').store('page-widgets', pw).store('data', d);

									modal.hide();
								}
							}]
						});

						modal = new StickyWin.Modal({
							'content': sw,
							'destroyOnClose': true,
							'onDisplay': function() {
								new Behavior().apply(this.element);
							}
						});
					}
				}
			}

			$('thisPage').store('current_event', '');

			// Update the object
			var events = $('thisFile').retrieve('events');
			events = (typeOf(events) == 'array' ? {} : events);

			if(overlay_positions.length == 0) {
				var overlay_position = 'full';
			} else {
				var overlay_position = $('timeline-content-event').getElement('input[name="overlay-position"]:checked').get('value');
			}

			if(event_modes.length == 0) {
				var event_mode = 'internal';
			} else {
				var event_mode = $('timeline-content-event').getElement('input[name="event-mode"]:checked').get('value');
			}

			var event_type = $('event-type').get('value');

			var serialized = {};

			$('event-area').getChildren('.event-widget').each(function(obj, internal_idx) {
				var idx = obj.getData('widget-idx');
				var panel = $('body').getElement('.widget-config-panel[data-widget-idx="'+idx+'"]');
				if(!panel) return;
				var s = panel.serialize(true);
				serialized = Object.merge(serialized, s);
			});

			var theData = {
				'overlay-trigger-pause': !!($('timeline-content-event').getElement('input[name="overlay-trigger-pause"]:checked')),
				'overlay-position': overlay_position,
				'event-mode': event_mode,
				'event-point': $('event-point').get('value'),
				'event-width': $('event-area').getStyle('width'), // These are used for Elements or audio files
				'event-height': $('event-area').getStyle('height'),
				'event-type': event_type,
				'overlay-entrance': $('timeline-content-event').getElement('select[name="overlay-entrance"]').get('value'),
				'overlay-background-colour': $('overlay-background-colour').get('value'),
				'overlay-translucent': $('overlay-background-translucent').get('checked'),
				'overlay-opaque': $('overlay-background-opaque').get('checked'),
				'overlay-remove-after': $('overlay-remove-after').get('checked'),
				'overlay-padding': !!$('overlay-padding').get('checked'),
				'widgets': serialized
			};

			// Add/update the marker
			var marker = createTimelineMarker($('event-name').get('value'), 'event', {
				'start-string': $('event-start-string').get('value'),
				'duration-string': $('event-duration-string').get('value'),
				'data': theData
			});

			// Store the data
			events[$('event-name').get('value')] = marker.retrieve('evp-timeline-data');
			$('thisFile').store('events', events);

			// Return to the original screen
			restoreDefaultArea();
		});
	})();

	// Delete an Event
	$('ui-delete-event').addEvent('click', function() {
		var events = $('thisFile').retrieve('events');
		events = (typeOf(events) == 'array' ? {} : events);

		delete events[$('event-name').get('value')];
		$('timeline-marker-'+$('event-name').get('value').makeSeed()).kill();

		$('thisFile').store('events', events);

		// Return to the original screen
		$$('#event-area, #event-area-preview').dissolve();
		$('timeline-content').get('reveal').dissolve().chain(function() {
			$('timeline-options').get('reveal').reveal();
		});
	});
});
</script>

<div id="focus" class="focus-type-<?php echo $file->type; ?>">
	<div class="margin-bottom align-right" id="ui-delete-event-wrap">
		<div data-behavior="Button" data-button-width="150" data-button-type="action" data-button-icon="delete" data-button-iconpos="right" id="ui-delete-event">Delete this Event</div>
	</div>

	<div id="options" class="clear">
		<ul class="tabs">
			<li id="tab-timeline-general"><img src="<?php echo $config['locations']['themeDir']; ?>assets/icons-custom/player-settings.png" alt="" />General</li>
			<li id="tab-timeline-style"><img src="<?php echo $config['locations']['themeDir']; ?>assets/icons-custom/player-settings.png" alt="" />Style</li>
			<li id="tab-timeline-content"><img src="<?php echo $config['locations']['themeDir']; ?>assets/icons-custom/player-settings.png" alt="" />Content</li>
		</ul>
	</div>
	<div id="panels">

		<div class="tab-panel styled descend">
			<h2>When do you want your Event to appear?</h2>
			<div class="group" id="event-mode-wrap-outer" title="Select a position" rel="If you choose to display this on your page, you will need to enter some code on your page!">
				<div class="group">
					<label style="float:left;margin:0 10px 30px 0;line-height:32px;text-align:right;width:285px;">Select where this Event will appear</label>
					<div class="align-left">
						<div data-behavior="RadioGroup" data-radiogroup-tie="false" data-radiogroup-width="150">
							<label for="event-mode-internal">Inside my video</label>
							<input type="radio" id="event-mode-internal" name="event-mode" value="internal" checked="checked"  />
							<label for="event-mode-external">On my web page</label>
							<input type="radio" id="event-mode-external" name="event-mode" value="external" />
						</div>
					</div>
				</div>
			</div>

			<input type="hidden" name="event-type" id="event-type" />

			<div class="group" id="event-point-wrap-outer">
				<div class="group">
					<label style="float:left;margin:0 10px 30px 0;line-height:32px;text-align:right;width:285px;">Select when this Event should happen</label>
					<div class="align-left">
						<div data-behavior="RadioGroup" data-radiogroup-tie="false" data-radiogroup-width="150">
							<label for="event-point-start">Start of this <?php echo $file->type; ?></label>
							<input type="radio" id="event-point-start" name="event-point" value="start" checked="checked"  />
							<label for="event-point-during">During this <?php echo $file->type; ?></label>
							<input type="radio" id="event-point-during" name="event-point" value="during" />
							<label for="event-point-end">End of this <?php echo $file->type; ?></label>
							<input type="radio" id="event-point-end" name="event-point" value="end" />
						</div>
					</div>
				</div>
			</div>

			<input type="hidden" name="event-point" id="event-point" />

			<div class="group clear align-left" id="overlay-name-wrap" style="margin-right:20px;margin-bottom:30px;">
				<label for="event-name">Name</label>
				<input type="text" id="event-name" name="name" style="width: 259px;" />
			</div>

			<div class="group align-left margin-right" id="overlay-start-wrap">
				<label for="event-start-string">Start <span class="ui-text-tiny">(Min/sec)</span></label>
				<input type="number" id="event-start-minutes" style="width:20px;margin:0 5px 0 0;" />:
				<input type="number" id="event-start-seconds" style="width:20px;margin:0 0 0 5px;" />
				<input type="hidden" id="event-start-string" name="start-string" style="width: 48px;" />
			</div>

			<div class="group align-left" id="overlay-duration-wrap" style="margin-right:20px;">
				<label for="event-duration-string">Duration <span class="ui-text-tiny">(Min/sec)</span></label>
				<input type="number" id="event-duration-minutes" style="width:20px;margin:0 5px 0 0;" />:
				<input type="number" id="event-duration-seconds" style="width:20px;margin:0 0 0 5px;" />
				<input type="hidden" id="event-duration-string" name="duration-string" style="width: 48px;" />
			</div>

			<div class="group align-left margin-right" id="overlay-pause-wrap">
				<label>Pause playback?</label>
				<input name="overlay-trigger-pause" id="overlay-trigger-pause" type="checkbox" value="true" data-behavior="iPhoneCheckbox" />
			</div>

			<div class="group align-left margin-right" id="overlay-remove-after-wrap">
				<label>Remove at video end?</label>
				<input name="overlay-remove-after" id="overlay-remove-after" type="checkbox" value="true" data-behavior="iPhoneCheckbox" />
			</div>

			<div class="clear" style="padding-top:10px;"></div>
			<div class="align-left">
				<a class="ui-return" data-behavior="Button" data-button-icon="back" data-button-iconpos="left" data-button-width="70">Cancel</a>
			</div>
			<div class="align-right" style="text-align: center;">
				<a class="ui-options-next" data-behavior="Button" data-button-icon="forward" data-button-iconpos="right" data-button-width="60">Next</a>
			</div>
			<div class="clear"></div>
		</div>

		<div class="tab-panel styled descend">
			<h2>Customise the appearance of this Event</h2>

			<?php
			if($file->type == 'video') :
			//$third = ceil($file_settings->options['height'] / 3);
			//if($third >= 100) : ?>
				<div class="group align-left margin-right" id="overlay-position-wrap-outer" style="">
					<label>Overlay positioning</label>
					<div data-behavior="RadioGroup" data-radiogroup-tie="false" data-radiogroup-width="60" id="overlay_position">
						<label for="overlay-position-bottom">Bottom</label>
						<input type="radio" id="overlay-position-bottom" name="overlay-position" value="bottom" checked="checked" />
						<label for="overlay-position-top">Top</label>
						<input type="radio" id="overlay-position-top" name="overlay-position" value="top" />
						<label for="overlay-position-full">Full</label>
						<input type="radio" id="overlay-position-full" name="overlay-position" value="full" />
					</div>
				</div>
			<?php /*endif;*/ endif; ?>

			<div class="group align-left margin-right" id="overlay-opaque-wrap">
				<label>Background?</label>
				<input name="overlay-opaque" id="overlay-background-opaque" type="checkbox" value="true" data-behavior="iPhoneCheckbox" />
			</div>

			<div class="group align-left margin-right" id="overlay-background-wrap-outer">
				<label>Colour</label>
				<div id="overlay-background-wrap">
					<input data-behavior="ColourPicker" type="text" id="overlay-background-colour" name="overlay-background-colour" style="width: 57px;" />
					<input type="checkbox" name="overlay-translucent" id="overlay-background-translucent" style="margin-left: 5px;" /><span style="margin: 0 17px 0 5px;">Translucent?</span>
				</div>
			</div>

			<div id="overlay-entrance-wrap-outer" class="align-left" style="width:223px;">
				<div class="group align-left" style="width:175px;">
					<label for="overlay-entrance">Event entrance</label>
					<select name="overlay-entrance" id="overlay-entrance" data-selectbox-wrapper-height="80" data-behavior="SelectBox">
						<option value="appear">No effect</option>
						<option value="fade">Fade in</option>
						<option value="css3-rollIn">Roll in</option>
						<option value="css3-fadeInDown">Fade in &amp; down</option>
						<option value="css3-bounceIn">Bounce in</option>
						<option value="css3-rotateIn">Rotate in</option>
						<option value="css3-bounceInLeft">Bounce in from left</option>
						<option value="css3-bounceInRight">Bounce in from right</option>
						<option value="css3-pulse">Pulse</option>
						<option value="css3-flipInX">Flip in horizontally</option>
						<option value="css3-bounceInDown">Bounce in &amp; down</option>
					</select>
				</div>
				<div class="align-left" style="position:relative;top:18px;left:10px;">
					<input type="button" id="overlay-entrance-demo" data-behavior="Button" data-button-width="30" data-button-type="action" data-button-icon="refresh" data-button-iconpos="notext" value="Replay" />
				</div>
			</div>

			<div class="clear group align-left margin-right" id="overlay-padding-wrap">
				<label>Include padding?</label>
				<input name="overlay-padding" id="overlay-padding" type="checkbox" value="true" data-behavior="iPhoneCheckbox" />
			</div>

			<div class="clear" style="padding-top:10px;"></div>
			<div class="align-left">
				<a class="ui-options-back" data-behavior="Button" data-button-icon="back" data-button-iconpos="left" data-button-width="60">Back</a>
			</div>
			<div class="align-right" style="text-align: center;">
				<a class="ui-options-next" data-behavior="Button" data-button-icon="forward" data-button-iconpos="right" data-button-width="60">Next</a>
			</div>
			<div class="clear"></div>
		</div>

		<div class="tab-panel styled descend">
			<div id="timeline-event-options">
				<h2>Drag the widgets into your player area</h2>
				<div id="timeline-event-options-wrapper">
					<div id="timeline-event-options-pro">
						<div class="container">
							<div class="timeline-event-option" id="timeline-event-option-button" data-readable-name="Button" data-name="button"><img src="<?php echo $config['locations']['themeDir']; ?>assets/icons-custom/widget-button.png" alt="" /><span>Button</span></div>
							<div class="timeline-event-option" id="timeline-event-option-text" data-readable-name="Text" data-name="text"><img src="<?php echo $config['locations']['themeDir']; ?>assets/icons-custom/widget-text.png" alt="" /><span>Text</span></div>
							<div class="timeline-event-option" id="timeline-event-option-html" data-readable-name="HTML" data-name="html"><img src="<?php echo $config['locations']['themeDir']; ?>assets/icons-custom/widget-html.png" alt="" /><span>HTML</span></div>
							<div class="timeline-event-option" id="timeline-event-option-gateway" data-readable-name="Gateway" data-name="gateway"><img src="<?php echo $config['locations']['themeDir']; ?>assets/icons-custom/widget-gateway.png" alt="" /><span>Gateway</span></div>
							<div class="timeline-event-option" id="timeline-event-option-share-twitter" data-readable-name="Twitter" data-name="share-twitter"><img src="<?php echo $config['locations']['themeDir']; ?>assets/icons-custom/widget-share-twitter.png" alt="" /><span>Twitter</span></div>
							<div class="timeline-event-option" id="timeline-event-option-share-facebook" data-readable-name="Facebook" data-name="share-facebook"><img src="<?php echo $config['locations']['themeDir']; ?>assets/icons-custom/widget-share-facebook.png" alt="" /><span style="font-size:15px;">Facebook</span></div>
							<?php if($evp->s3 || $evp->local) : ?>
								<div class="timeline-event-option" id="timeline-event-option-image" data-readable-name="Image" data-name="image"><img src="<?php echo $config['locations']['themeDir']; ?>assets/icons-custom/widget-image.png" alt="" /><span>Image</span></div>
							<?php endif; ?>
						</div>
					</div>
				</div>

			</div>
			<div class="clear" style="padding-top:10px;"></div>
			<div class="align-left">
				<a class="ui-options-back" data-behavior="Button" data-button-icon="back" data-button-iconpos="left" data-button-width="60">Back</a>
			</div>
			<div class="align-right" style="text-align: center;">
				<a id="ui-save-event" data-behavior="Button" data-button-icon="forward" data-button-iconpos="right" data-button-width="120">Save Event</a>
			</div>
			<div class="clear"></div>
		</div>

	</div>
</div>
