<?php include('application.php'); include('application.bootstrap.php'); ?>

<?php
// Get the file
$file = $evp->getFile($_GET['file_id']);

$file_ref = $file->id;

// Get the profile
$profile = trim($_GET['profile']);
if(!empty($profile)) {
	$profile = str_replace($file->id.'::', '', $profile);
	$file_ref.= '::'.$profile;
}

// Get the file settings
$file_settings = $evp->collateFileSettings($file, $profile);

// Is it default? If so, it needs an explicit height and duration
if($file->id == 'default') {
	$file_settings->options['height'] = '480';
	$file->metadata['duration'] = '360';
}

$fd = secondsToHMS($file->metadata['duration']);
$fd = explode(':', $fd);

// Support for videos over an hour
if(sizeof($fd) == 3) {
	$file_duration_minutes = intval($fd[1]);
	$file_duration_seconds = intval($fd[2]);
	$file_duration_minutes += intval($fd[0] * 60);
} else {
	$file_duration_minutes = intval($fd[0]);
	$file_duration_seconds = intval($fd[1]);
}

// Work out the average drop-off time
$average_drop_off = $evp->statistics->averageDropOff($file_ref);
if($average_drop_off > 0) {
	$ve_x = 0;
	$secondsAsPixels = (675 / $file->metadata['duration']);
	$ve_x = round($secondsAsPixels * $average_drop_off);
	if($ve_x >= 675) $ve_x = 675;
}

// Now let's do some working out for the 2 deviant menus
$profile_folders = $evp->getFoldersAsTree(true);

$profile_all_files = getArray("SELECT t.id, t.file_name, t.name, t.type, r.folder_id FROM {$evp->options->prefix}files t LEFT JOIN {$evp->options->prefix}folders_relationships r ON (t.id = r.file_id) WHERE t.child_type IS NULL ORDER BY t.time DESC");
$profile_files = array();
if(!empty($profile_all_files)) {
	foreach($profile_all_files as $f) {
		$fid = $f->folder_id;
		if(empty($fid)) $fid = 0;
		$profile_files[$fid][] = $f;
	}
	
	if($xs->isMemberOf($xs->userData->id, 'Clients')) {
		foreach($profile_files as $fidx => $f) {
			if(!in_array($fidx, $xs->userData->assigned_folder_id)) unset($profile_files[$fidx]);
		}
	}
}

Registry::store('profile_files', $profile_files);
?>

<script type="text/javascript">
<?php if($file->id == 'default') : ?>
window.onbeforeunload = function() {
	var msg = '** WARNING **\n\nIf you leave this page now, your default settings will NOT be saved or applied to new videos! Please cancel and continue through all of the steps!';
	return msg;
};
<?php endif; ?>
var maskedTimeToSeconds = function(original_time) {
	var s = original_time.split(':');
	if(s.length == 3) {
		var time = parseFloat(s[0] * 3600) + parseFloat(s[1] * 60) + parseFloat(s[2]);
	} else if(s.length == 2) {
		var time = parseFloat(s[0] * 60) + parseFloat(s[1]);
	} else {
		var time = parseFloat(s[0]);
	}
	
	return time;
}

var secondsToMaskedTime = function(minutes, seconds) {
	if(arguments.length == 1) { // Only provided a seconds value
		var total = minutes;
		var minutes = Math.floor(total / 60);
		var seconds = total - (minutes * 60);
	}
	var sl = (''+seconds).length;
	if(sl == 0) seconds = '00';
	else if(sl == 1) seconds = '0'+seconds;
	return ''+minutes+':'+seconds;
}

var positionTimelineMarkers = function(instant) {
	// Get every marker
	var markers = $$('.ui-timeline-element:not(#ui-timeline-dropoff-marker)');
	
	var regions = [24, 48, 72, 96, 120, 144, 168, 192, 216, 240, 264, 288, 312, 336, 360, 384, 408, 432, 456, 480, 504, 528, 552, 576, 600, 624, 648, 672, 696, 720];// from when it was 720 wide
//var regions = [31, 62, 93, 124, 155, 186, 217, 248, 279, 310, 341, 372, 403, 434, 465, 496, 527, 558, 589, 620];
//var regions = [25, 50, 75, 100, 125, 150, 175, 200, 225, 250, 275, 300, 325, 350, 375, 400, 425, 450, 475, 500, 525, 550, 575, 600, 625, 650, 675];
	
	var array_closest = function(array, num) {
		var difference = Math.abs(num - array[0]);
		var index = 0;
		var max = array.length;
		for(var i = 0; i < max; i++) {
			var tmp = Math.abs(num - array[i]);
			if(difference >= tmp) {
				difference = tmp;
				index = i;
			}
		}
		return index;
	}
	
	// Get their start times
	var start_times = {};
	markers.each(function(el) {
		var marker_data = el.retrieve('evp-timeline-data');
		var index = regions[array_closest(regions, el.getStyle('left').toInt())];//marker_data.start)];//marker_data.start;
		
		start_times[index] = Array.from(start_times[index]);
		start_times[index].push(el);
	});
	
	// Now let's iterate the start times and look for multiples
	Object.each(start_times, function(elements, start) {
		if(elements.length == 1) { // Restore to default positions
			$$(elements).setStyles({
				'height': '50px',
				'top': '-5px'
			}).removeClasses('ui-timeline-element-stack ui-timeline-element-stack-0 ui-timeline-element-stack-1 ui-timeline-element-stack-2 ui-timeline-element-stack-3').addClass('ui-gradient ui-timeline-element');
		} else { // Style for stacking
			$$(elements).each(function(el, idx) {
				el.setStyles({
					'height': 44 / elements.length,
					'top': Math.ceil(50 / elements.length * idx - 5)//(idx * 12) - 5
				}).addClass('ui-gradient ui-timeline-element ui-timeline-element-stack ui-timeline-element-stack-'+idx);
				if(idx == (elements.length - 1)) el.addClass('ui-timeline-element-stack-last');
				else el.removeClass('ui-timeline-element-stack-last');
				if(idx != 0) el.removeClass('ui-timeline-element-stack-0');
			});
		}
		
		(function() {
			$$(elements).each(function(el) {
				if(el.retrieve('tooltip')) el.retrieve('tooltip').position();
			});
		}).delay(250);
	});
	
}

var createTimelineMarker = function(name, type, options, instant) {
	if(!type) type = 'event';
	var type_color;
	
	switch(type) {
		case 'chapter':
			type_color = 'green';
			break;
		case 'survey':
			type_color = 'orange';
			break;
		default:
			type_color = 'blue';
			break;
	}
	
	// Let's normalise the start time into seconds, not 00:02:04 etc
	var start = maskedTimeToSeconds(options['start-string']);
	var end = '';
	
	if(type == 'event') { // Chapters don't have a duration
		var duration = maskedTimeToSeconds(options['duration-string']);
		end = start + duration;
	}
	
	// Does it start after the duration of the video?
	if(start > <?php echo ceil($file->metadata['duration']); ?>) {
		start = <?php echo floor($file->metadata['duration']); ?>;
		options['start'] = start;
		options['start-string'] = secondsToMaskedTime('<?php echo floor($file->metadata['duration']); ?>');
		end = start + duration;
	}
	
	// Removed as this possibly overwrites the duration and resets it to 0 incorrectly
	// Is the end bigger than the length? If so, we'll reduce the duration, not the start
	if(type == 'event') { // Nor do Chapters have an end
		if(end > <?php echo ceil($file->metadata['duration']); ?>) {
			duration = (<?php echo ceil($file->metadata['duration']); ?> - start);
			end = start + duration;
			options['duration-string'] = secondsToMaskedTime(duration);
		}
	}
	
	// How many pixels is 1 second worth here?
	var secondsAsPixels = (720 / <?php echo ceil($file->metadata['duration']); ?>);
	
	// How many seconds is 1 pixel worth?
	var pixelsAsSeconds = (<?php echo ceil($file->metadata['duration']); ?> / 720);
	
	// Which means that..
	var x = Math.round(secondsAsPixels * start);
	
	// Now the marker width
	var marker_width = 10; // This is the default, but Events..
	if(type == 'event') marker_width = 80;

	if(type == 'event') {
		marker_width = secondsAsPixels * duration;
		if(marker_width <= 5) marker_width = 5; // Always be at least 5
	}
	
	// Options?
	var default_obj = {};
	var tip_title = '<span class="ui-event-edit">Edit</span><span class="ui-event-delete">Delete</span>'+name;
	var tip_text = 'Start time: '+options['start-string']+'<br />Duration: '+options['duration-string'];
	
	switch(type) {
		case 'event':
			tip_text = 'Start time: '+options['start-string']+'<br />Duration: '+options['duration-string'];
			default_obj = {
				'name': name,
				'start-string': '00:00',
				'duration-string': '00:00',
				'start': start,
				'duration': duration,
				'end': end,
				'data': {
					'overlay-position': 'bottom',
					'overlay-entrance': 'css3-fadeInUp',
					'overlay-background-colour': '#292929',
					'widgets': {}
				}
			};
			break;
		case 'chapter':
			tip_text = 'Showing at: '+options['start-string'];
			default_obj = {
				'name': name,
				'start-string': '00:00',
				'start': start,
				'data': {
					'chapter-background-colour': '#000000'
				}
			};
			break;
		case 'survey':
			tip_text = 'Showing at: '+options['start-string'];
			default_obj = {
				'name': name,
				'start-string': '00:00',
				'start': start,
				'data': {
					'chapter-background-colour': '#000000'
				}
			};
			break;
	}

	var options = Object.merge(default_obj, options);
	
	if(options.data['overlay-trigger-pause'] === true) {
		tip_text = 'Showing at: '+options['start-string'];
	}
	
	// Build the marker itself
	if($('timeline-marker-'+name.makeSeed())) {
		var newly = false;
		var el = $('timeline-marker-'+name.makeSeed());
		el.morph({
			'left': x,
			'width': marker_width
		});
	} else {
		var newly = true;
		var el = new Element('div', {
			'id': 'timeline-marker-'+name.makeSeed(),
			'class': 'ui-gradient ui-timeline-element ui-gradient-'+type_color,
			'opacity': 0,
			'styles': {
				'left': x,
				'width': marker_width
			}
		});
	}
	
	// Let's store any data
	el.store('evp-timeline-data', options);
	el.store('evp-timeline-name', name);
	
	el.setData('timeline-type', type);
	
	// Z-indexing for markers - Chapters need to be always above any Event ones
	// but otherwise, the smaller the duration, the higher the z-index
	// so small ones are visible over big ones
	if(type == 'chapter' || type == 'survey') el.setStyle('z-index', 1000);
	else el.setStyle('z-index', 1000 - marker_width);
	
	// Inject and fade it in
	if(newly) {
		el.inject($('timeline-line'), 'after');
		if(instant === true) {
		//el.fade('show');
			el.setStyles({
				'opacity': 0.7,
				'display': 'block',
				'visibility': 'visible'
			});
		} else {
			el.fade.pass(0.7, el).delay(750);
		}
	}
	
	if(newly) {
		var t = new StickyWin.PointyTip(tip_title, tip_text, {
			'point': (x > 450 ? 3 : 9),
			'width': 220,
			'relativeTo': el,
			'showNow': false,
			'pointyOptions': {
				'cssClass': 'evp-timeline-tooltip',
				'closeButton': false
			}
		});
		
		el.store('tooltip', t);
		
		var isInTip = false;
		var tipTimer;
		
		$(t.element).addEvents({
			'mouseenter': function() {
				isInTip = true;
			},
			'mouseleave': function() {
				isInTip = false;
				t.hide();
				$$('#timeline .ui-timeline-element').fade(0.7);
			}
		});
		
		el.addEvents({
			'mouseenter': function() {
				$$('#timeline .ui-timeline-element').filter(function(e) {
					return !(e == el);
				}).fade(0.3);
				t.show();
				clearInterval(tipTimer);
			},
			'mouseleave': function() {
				tipTimer = setTimeout(function() {
					if(!isInTip) {
						$$('#timeline .ui-timeline-element').fade(0.7);
						t.hide();
					}
				}, 300);//1000);
			}
		});
		
		// Store the start time in an attribute
		el.setData('evp-timeline-start', options.start);
		
		// This is the hint that floats above each marker when dragging
		var hint = new Element('div', {'class': 'timeline-hint', 'id': 'timeline-hint-'+name.makeSeed(), 'styles': {'opacity': 0}}).inject('timeline', 'bottom');
		
		var drag = new Drag.Move(el, {
			'container': $('timeline'),
			'modifiers': {'x': 'left', 'y': false},
			'onStart': function() {
				t.hide();
				clearInterval(tipTimer);
				el.store('originalLeft', el.getStyle('left').toInt());
				
				var px = el.getStyle('left').toInt(); // How many pixels has it taken up?
				var total = (pixelsAsSeconds * px);
				var d = new Date(0, 0, 0, 0, 0, total);
				var seconds = d.getSeconds();
				var minutes = d.getMinutes();
				
				if(d.getHours() > 0) minutes += d.getHours() * 60;
				
				var time = secondsToMaskedTime(minutes, seconds);
				
				hint.set('text', time).setStyle('left', px).fade('in');
			},
			'onDrag': function() {
				t.hide();
				clearInterval(tipTimer);
				
				var px = el.getStyle('left').toInt(); // How many pixels has it taken up?
				var total = (pixelsAsSeconds * px);
				var d = new Date(0, 0, 0, 0, 0, total);
				var seconds = d.getSeconds();
				var minutes = d.getMinutes();
				
				if(d.getHours() > 0) minutes += d.getHours() * 60;
				
				var time = secondsToMaskedTime(minutes, seconds);
				
				hint.set('text', time).setStyle('left', px).fade('in');
			},
			'onDrop': function() {
				$$('.timeline-hint').fade('out');
				
				var px = el.getStyle('left').toInt();//(675 * (percentage / 100)); // How many pixels has it taken up?
				var total = (pixelsAsSeconds * px);
				var d = new Date(0, 0, 0, 0, 0, total);
				var seconds = d.getSeconds();
				var minutes = d.getMinutes();
				
				var timeline_data = el.retrieve('evp-timeline-data');
				
				// Now we should see if there are any others with this same start time
				var existing = $$('[data-evp-timeline-start="'+total+'"]');
				if(existing.length >= 4 && existing.indexOf(el) == -1) {
					StickyWin.alert('Too many!', 'You cannot have more than 4 Events starting at the exact same time!');
					el.tween('left', el.retrieve('originalLeft'));
					return;
				}
				
				// Let's update the marker's data
				timeline_data['start-string'] = secondsToMaskedTime(minutes, seconds);
				timeline_data.start = maskedTimeToSeconds(timeline_data['start-string']);
				el.store('evp-timeline-data', timeline_data);
				
				// Update the actual storage
				var storage = $('thisFile').retrieve(type+'s'); // events or chapters
				storage[timeline_data.name].start = timeline_data.start;
				storage[timeline_data.name]['start-string'] = timeline_data['start-string'];
				$('thisFile').store(type+'s', storage);
				
				// Update the main tooltip
				if(type == 'chapter' || type == 'survey' || timeline_data.data['overlay-trigger-pause'] === true) {
					tip_text = 'Showing at: '+timeline_data['start-string'];
				} else {
					tip_text = 'Start time: '+timeline_data['start-string']+'<br />Duration: '+timeline_data['duration-string'];
				}
				el.retrieve('tooltip').setContent(tip_title, tip_text);
				el.retrieve('tooltip').hide();
				el.store('tip_title', tip_title);
				el.store('tip_text', tip_text);
				
				// Store the start time as a data attribute
				el.setData('evp-timeline-start', timeline_data.start);
				
				// Re-position!
				positionTimelineMarkers();
			}
		});
		
		el.setStyles({'cursor': 'pointer'});

		// Let's make the Edit links work
		if(type == 'event') {
			$(t.element).addEvent('click:relay(.ui-event-edit)', function() {
				$('ui-delete-event-wrap').setStyle('display', 'block');
				restoreEventArea(el.retrieve('evp-timeline-data'));
			});
		} else if(type == 'chapter') {
			$(t.element).addEvent('click:relay(.ui-event-edit)', function() {
				$('ui-delete-chapter').setStyle('display', 'block');
				restoreChapterArea(el.retrieve('evp-timeline-data'));
			});
		} else if(type == 'survey') {
			$(t.element).addEvent('click:relay(.ui-event-edit)', function() {
				$('ui-delete-survey').setStyle('display', 'block');
				restoreSurveyArea(el.retrieve('evp-timeline-data'));
			});
		}
		
		// Let's make the Delete links work
		$(t.element).addEvent('click:relay(.ui-event-delete)', function() {
			var timeline_data = el.retrieve('evp-timeline-data');
			StickyWin.confirm('Are you sure?', 'Are you sure you want to delete \''+timeline_data.name+'\' (The '+type+') from your timeline?', function() {
				// Remove this from the storage
					var storage = $('thisFile').retrieve(type+'s'); // events or chapters
					delete storage[timeline_data.name];
					delete storage[timeline_data.name.makeSeed()]; // This will catch chapters, which are stored on a seed of the name
					$('thisFile').store(type+'s', storage);
				
				// Remove the marker
				el.kill(function() {
					positionTimelineMarkers();
				});
				
				// Make sure the area turns to the original screen
				restoreDefaultArea();
			});
		});
	} else { // Update the main tooltip
		var timeline_data = el.retrieve('evp-timeline-data');
		if(type == 'chapter' || timeline_data.data['overlay-trigger-pause'] === true) {
			tip_text = 'Showing at: '+timeline_data['start-string'];
		} else {
			tip_text = 'Start time: '+timeline_data['start-string']+'<br />Duration: '+timeline_data['duration-string'];
		}
		el.store('tip_title', tip_title);
		el.store('tip_text', tip_text);
		el.retrieve('tooltip').setContent(tip_title, tip_text);
		el.retrieve('tooltip').hide();
		
		(function() {
			$$('.ui-timeline-element:not(#ui-timeline-dropoff-marker)').each(function(el) {
				if(el.retrieve('tooltip')) el.retrieve('tooltip').position();
			});
		}).delay(500);
	}
	
	// Return
	return el;
}

var restoreDefaultArea = function() {
	$$('#event-area-resize, #event-area-outer, #event-area-wrapper, #event-area, #event-area-preview').dissolve();
	if(Browser.Engine.trident && Browser.Engine.version <= 8) {
		$('timeline-content').setStyle('display', 'none');
		$('timeline-options').setStyle('display', 'block');
	} else {
		$('timeline-content').get('reveal').dissolve().chain(function() {
			$('timeline-options').get('reveal').reveal();
		});
	}
	
	$('thisPage').store('current_chapter', '');
	$('thisPage').store('current_event', '');
	$('thisPage').store('current_survey', '');
	
	// Let's just reposition, just in case
	positionTimelineMarkers();
}

window.addEvent('domready', function() {
	<?php include($config['locations']['themePath'].'include.attach.php'); ?>
	
	EVP_Help.setContext({
		'content': '<p>The Timeline is a powerful tool you can use to customise how and when Events appear on your video, or on your web page.</p><p>Create a new Event, choose when it should be displayed, customise it\'s visual style, and then drag and drop from the available widgets onto the area.</p><p>Each widget can be modified to look how you want it to and resized and moved around.</p>',
		'video': 'basic-timeline.mp4'
	});

	
	<?php if($file->id == 'default') : ?>
	if($('breadcrumbs')) $('breadcrumbs').setStyle('display', 'none');
	<?php endif; ?>
	
	EVP_Helpers.setBreadcrumb(3);
	
	if($('event-area-wrapper')) {
		$('event-area-wrapper').onselectstart = function() { return false; }
	}
	
	var xhr = new Request({
		'url': '<?php echo url('admin/xhr.php'); ?>',
		'method': 'post',
		'onRequest': function() {
			$('ui-save').spin({'msg': 'Saving...'});
		},
		'onSuccess': function(responseText, responseXML) {
			var file_id = $('thisFile').retrieve('file_id'), file_profile = $('thisFile').retrieve('file_profile');
			$('ui-save').unspin();
			<?php if($file->id == 'default') : ?>
			if($('thisFile').retrieve('data').video_page_disabled === true) {
				window.url('<?php echo url('admin/settings.php'); ?>?default_saved=success&id='+(file_id)+'&profile='+(file_profile));
				return false;
			} else {
				window.url('<?php echo url('admin/files.page.php'); ?>?default_saved=success&id='+(file_id)+'&profile='+(file_profile));
				return false;
			}
			<?php endif; ?>
			window.url(window.retrieve('nextUrl') || '<?php echo url('admin/files.'.($file->id == 'default' ? 'page' : 'embed').'.php'); ?>?id='+(file_id)+'&profile='+(file_profile));
		},
		'onFailure': function() {
			$('ui-save').unspin();
		}
	});
	
	$('thisFile').store('save', xhr);
	
	if($('ui-save')) {
		$('ui-save').addEvent('click', function(event) {
			window.onbeforeunload = null;
			if(event) event.stop();
			
			// And finally, post it
			$('thisFile').retrieve('save').send({
				'method': 'post',
				'data': {
					'method': 'file_setdata',
					'file_ref': $('thisFile').retrieve('file_ref'),
					'data': {
						'options': $('thisFile').retrieve('data'), // For intro video & redirect
						'events': $('thisFile').retrieve('events'),
						'chapters': $('thisFile').retrieve('chapters'),
						'surveys': $('thisFile').retrieve('surveys'),
						'page_widgets': $('thisFile').retrieve('page-widgets') // So that we can prompt to add External Events to the Pages
					},
					'relevant': ['options', 'events', 'chapters', 'surveys', 'page_widgets']
				}
			});
		});
		
		if($('breadcrumb-link-embed')) {
			$('breadcrumb-link-embed').removeEvents('click').addEvent('click', function(event) {
				if(event) event.stop();
				var file_id = $('thisFile').retrieve('file_id'), file_profile = $('thisFile').retrieve('file_profile');
				window.store('nextUrl', '<?php echo url('admin/files.'.($file->id == 'default' ? 'page' : 'embed').'.php'); ?>?id='+(file_id)+'&profile='+(file_profile));
				$('ui-save').fireEvent('click');
			});
		}
		
		if($('breadcrumb-link-settings')) {
			$('breadcrumb-link-settings').removeEvents('click').addEvent('click', function(event) {
				if(event) event.stop();
				var file_id = $('thisFile').retrieve('file_id'), file_profile = $('thisFile').retrieve('file_profile');
				window.store('nextUrl', '<?php echo url('admin/files.settings.php'); ?>?id='+(file_id)+'&profile='+(file_profile));
				$('ui-save').fireEvent('click');
			});
		}
	}
	
	$$('.ui-return').addEvent('click', function(event) {
		if(event) event.stop();
		restoreDefaultArea();
	});
	
	// Let's do the intro videos
	if($('timeline-line-intro')) {
		$('timeline-wrap').addEvents({
			'mouseenter': function() {
				$('timeline-line-intro-delete').fade('in');
			},
			'mouseleave': function() {
				$('timeline-line-intro-delete').fade('out');
			}
		});
		
		$('timeline-line-intro-delete').addEvent('click', function() {
			$('timeline-intro-wrapper').dissolve();
			$('intro_video_label').set('value', '').fireEvent('change');
			$('intro_video').set('value', '').fireEvent('change');
			$$('#timeline-intro-select .active').removeClass('active');
			$('timeline-line-intro').setStyle('background-position', '0 0');
		}).setStyle('opacity', 0);
		
		(function() {
			// Let's set the label and activation if we have a saved value
			var data = $('thisFile').retrieve('data');
			if(data.intro_video) {
				var el = $('timeline-intro-select').getElements('[data-file_ref="'+data.intro_video+'"]');
				if(el) {
					$('intro_video_label').set('value', el.getData('label')).fireEvent('change');
					el.addClass('active');
					$('timeline-line-intro').setStyle('background-position', '0 -39px');
				}
			}
		}).delay(250);
		
		$('timeline-line-intro').addEvent('click', function() {
			$('timeline-intro-wrapper').get('reveal').toggle();
			
			if($('timeline-intro-select').retrieve('deviantMenu')) $('timeline-intro-select').retrieve('deviantMenu').detach();
			if($('timeline-outro-select').retrieve('deviantMenu')) $('timeline-outro-select').retrieve('deviantMenu').detach();
			
			if($('timeline-intro-select').retrieve('deviantMenu')) {
				$('timeline-intro-select').retrieve('deviantMenu').init();
			} else {
				new deviantMenu($('timeline-intro-select'));
			}
		});
		
		$('ui-intro-save').addEvent('click', function() {
			if($('timeline-intro-select').retrieve('deviantMenu')) $('timeline-intro-select').retrieve('deviantMenu').detach();
			if($('timeline-outro-select').retrieve('deviantMenu')) $('timeline-outro-select').retrieve('deviantMenu').detach();
			
			$('timeline-intro-wrapper').dissolve();
		});
		
		$('timeline-intro-wrapper').addEvent('click:relay(a)', function(event) {
			if(event) event.stop();
			var file_ref = $(event.target).getData('file_ref');
			if(file_ref !== 'back') { // Yes, it's a proper link
				$('intro_video').set('value', file_ref).fireEvent('change');
				$('intro_video_label').set('value', $(event.target).getData('label')).fireEvent('change');
				$('timeline-intro-wrapper').getElements('.active').removeClass('active');
				$(event.target).addClass('active');
				$('timeline-line-intro').setStyle('background-position', '0 -39px');
			}
		});
		
		$('timeline-line-intro').addEvent('outerClick', function(event) {
			if(event && event.target && !$('timeline-intro-wrapper').contains(event.target)) $('timeline-intro-wrapper').get('reveal').dissolve();
		});
		
		(function() {
			$('timeline-intro-wrapper').setStyle('display', 'none');
		})();
	}
	
	// Let's do the outro videos
	if($('timeline-line-outro')) {
		$('timeline-wrap').addEvents({
			'mouseenter': function() {
				$('timeline-line-outro-delete').fade('in');
			},
			'mouseleave': function() {
				$('timeline-line-outro-delete').fade('out');
			}
		});
		
		$('timeline-line-outro-delete').addEvent('click', function() {
			$('timeline-outro-wrapper').dissolve();
			$('outro_video_label').set('value', '').fireEvent('change');
			$('outro_video').set('value', '').fireEvent('change');
			$$('#timeline-outro-select .active').removeClass('active');
			$('timeline-line-outro').setStyle('background-position', '0 0');
		}).setStyle('opacity', 0);
		
		(function() {
			// Let's set the label and activation if we have a saved value
			var data = $('thisFile').retrieve('data');
			if(data.outro_video) {
				var el = $('timeline-outro-select').getElements('[data-file_ref="'+data.outro_video+'"]');
				if(el) {
					$('outro_video_label').set('value', el.getData('label')).fireEvent('change');
					el.addClass('active');
					$('timeline-line-outro').setStyle('background-position', '0 -39px');
				}
			}
		}).delay(250);
		
		$('timeline-line-outro').addEvent('click', function() {
			$('timeline-outro-wrapper').get('reveal').toggle();
			
			if($('timeline-intro-select').retrieve('deviantMenu')) $('timeline-intro-select').retrieve('deviantMenu').detach();
			if($('timeline-outro-select').retrieve('deviantMenu')) $('timeline-outro-select').retrieve('deviantMenu').detach();
			
			if($('timeline-outro-select').retrieve('deviantMenu')) {
				$('timeline-outro-select').retrieve('deviantMenu').init();
			} else {
				new deviantMenu($('timeline-outro-select'));
			}
		});
		
		$('ui-outro-save').addEvent('click', function() {
			if($('timeline-intro-select').retrieve('deviantMenu')) $('timeline-intro-select').retrieve('deviantMenu').detach();
			if($('timeline-outro-select').retrieve('deviantMenu')) $('timeline-outro-select').retrieve('deviantMenu').detach();
			
			$('timeline-outro-wrapper').dissolve();
		});
		
		$('timeline-outro-wrapper').addEvent('click:relay(a)', function(event) {
			if(event) event.stop();
			var file_ref = $(event.target).getData('file_ref');
			if(file_ref !== 'back') { // Yes, it's a proper link
				$('outro_video').set('value', file_ref).fireEvent('change');
				$('outro_video_label').set('value', $(event.target).getData('label')).fireEvent('change');
				$('timeline-outro-wrapper').getElements('.active').removeClass('active');
				$(event.target).addClass('active');
				$('timeline-line-outro').setStyle('background-position', '0 -39px');
			}
		});
		
		$('timeline-line-outro').addEvent('outerClick', function(event) {
			if(event && event.target && !$('timeline-outro-wrapper').contains(event.target)) $('timeline-outro-wrapper').get('reveal').dissolve();
		});
		
		(function() {
			$('timeline-outro-wrapper').setStyle('display', 'none');
		})();
	}
	
	// Let's do the video redirection
	if($('timeline-line-redirect')) {
		$('ui-redirect').addEvents({
			'change': function() {
				var val = this.get('value');
				if(!val) {
					$('timeline-line-redirect').setStyle('background-position', '0 0');
				} else {
					$('timeline-line-redirect').setStyle('background-position', '0 -39px');
				}
			},
			'keydown': function() {
				if(event.key == 'enter') {
					this.fireEvent('change');
					$('timeline-redirect-wrapper').dissolve();
				}
			}
		});
		
		$('timeline-wrap').addEvents({
			'mouseenter': function() {
				$('timeline-line-redirect-delete').fade('in');
			},
			'mouseleave': function() {
				$('timeline-line-redirect-delete').fade('out');
			}
		});
		
		$('timeline-line-redirect-delete').addEvent('click', function() {
			$('ui-redirect').set('value', '').fireEvent('change');
			$('timeline-redirect-wrapper').dissolve();
		}).setStyle('opacity', 0);
		
		(function() {
			$('ui-redirect').fireEvent('change');
		}).delay(250);
		
		$('timeline-line-redirect').addEvent('click', function() {
			$('timeline-redirect-wrapper').get('reveal').toggle();
		});
		
		$('ui-redirect-save').addEvent('click', function() {
			$('timeline-redirect-wrapper').dissolve();
		});
		
		$('timeline-line-redirect').addEvent('outerClick', function(event) {
			if(event && event.target && !$('timeline-redirect-wrapper').contains(event.target)) $('timeline-redirect-wrapper').get('reveal').dissolve();
		});
	}
	
	$$('#timeline-create-event, #timeline-create-chapter, #timeline-create-survey').addEvent('click', function() {
		var id = this.get('id').replace('timeline-create-', '');
		if($('timeline-content-'+id)) {			
			$('timeline-content-'+id).setStyle('display', 'block').fireEvent('onActivate');
		}
	});

//$('timeline-content').setStyle('display', 'none');
	$$('#event-area, #event-area-preview, #timeline-content').setStyle('display', 'none');
	
	// Let's restore the Events that exists already
	(function() {
		var events = $('thisFile').retrieve('events');
		Object.each(events, function(options, name) {
			createTimelineMarker(name, 'event', options, true);
		});
	})();
	
	// Let's restore the Chapers
	(function() {
		var chapters = $('thisFile').retrieve('chapters');
		Object.each(chapters, function(options, name) {
			createTimelineMarker(options.name, 'chapter', options, true);
		});
	})();
	
	// Let's restore the Surveys
	(function() {
		var surveys = $('thisFile').retrieve('surveys');
		Object.each(surveys, function(options, name) {
			createTimelineMarker(options.name, 'survey', options, true);
		});
	})();
	
	// Stack the markers if necessary
	positionTimelineMarkers();
	
	// Is there a drop-off marker?
	if($('ui-timeline-dropoff-marker')) {
		$('ui-timeline-dropoff-marker').store('tip:title', 'Average drop-off time').store('tip:text', '<?php echo secondsToHMS($average_drop_off); ?>');
		
		new Tips.Pointy($('ui-timeline-dropoff-marker'), {
			'pointyTipOptions': {
				'point': 11
			}
		});
	}
});
</script>

<h1><img src="<?php echo $config['locations']['themeDir']; ?>assets/icons/timeline-large.png" alt="" />Video timeline</h1>

<div id="timeline-wrap">
	
	<div class="ui-icon ui-icon-delete" id="timeline-line-intro-delete"></div>
	<div id="timeline-line-intro" data-behavior="PointyTip" data-tip-direction="8" title="Add an Intro Video" rel="Click here to add an Intro Video to this video. This will play before your main video, and is great for repeated content, such as adverts or introductions!">Intro</div>
	<div id="timeline-ui-start">0:00</div>
	<div id="timeline">
		<div id="timeline-line">
			<div id="timeline-inner"></div>
		</div>
		<?php if(!empty($ve_x)) echo '<div id="ui-timeline-dropoff-marker" class="ui-gradient ui-timeline-element ui-gradient-red" style="left: '.$ve_x.'px;" title="Average drop-off time: '.secondsToHMS($average_drop_off).'"></div>'; ?>
		<div class="clear"></div>
	</div>
	<div id="timeline-ui-end"><?php echo secondsToHMS($file->metadata['duration']); ?></div>
	<div id="timeline-line-outro" data-behavior="PointyTip" data-tip-direction="2" title="Add an Outro Video" rel="Click here to add an Outro Video to this video. This will play after your main video, and is great for repeated content, such as adverts or closing statements!">Outro</div>
	<div id="timeline-line-redirect" data-behavior="PointyTip" data-tip-direction="2" title="Add a redirect" rel="Click here to redirect your users to a website after your video has finished playing. This can be used to take them straight to purchase your products or read more!">Redirect</div>
	<div class="ui-icon ui-icon-delete" id="timeline-line-redirect-delete"></div>
	<div class="ui-icon ui-icon-delete" id="timeline-line-outro-delete"></div>
	
	<div id="timeline-key">
		<ul>
			<li><div class="ui-gradient ui-gradient-blue"></div><span>= Event</span></li>
			<li><div class="ui-gradient ui-gradient-green"></div><span>= Chapter</span></li>
			<li><div class="ui-gradient ui-gradient-orange"></div><span>= Survey</span></li>
			<li><div class="ui-gradient ui-gradient-red"></div><span>= Avg. drop-off</span></li>
		</ul>
	</div>
	
	<div id="timeline-intro-wrapper"><div class="triangle"></div><div class="styled descend">
		<p>Select a <?php echo $file->type; ?> to play before this one!</p>
		<label for="ui-intro">Select a <?php echo $file->type; ?></label>
		<input type="hidden" id="intro_video" name="intro_video" data-behavior="EvpTieToElement" />
		<input type="text" disabled="disabled" id="intro_video_label" class="margin-bottom" style="width: 260px; background: #fff; border: none; box-shadow: none;" />
		
		<div style="width:280px;overflow-x:hidden;overflow-y:scroll;height:300px;">
			<div data-behavior="" id="timeline-intro-select">
			<?php
			function buildDeviantMenu_intro($folders, $type) {
				global $evp;
				$profile_files = Registry::retrieve('profile_files');
				foreach($folders as $folder) {
					$subfolders = array();
					$files = array();
					if(!empty($folder->file_count)) $files = $profile_files[$folder->id];//$evp->getFiles($folder->id);
					if($folder->id !== 0) $subfolders = $folder->subfolders;
					echo '<li class="folder">';
					echo "{$folder->name}";
					echo '<ul>';
					if(!empty($subfolders)) {
						buildDeviantMenu_intro($subfolders, $type);
					}
					if(!empty($files)) {
						foreach($files as $tf) {
							if($tf->type == $type){
								echo "<li><a class=\"file\" data-label=\"{$tf->name}\" data-file_ref=\"{$tf->id}\">".string_trim($tf->name, 42)."</a></li>";
							}
						}
					}
					echo '</ul>';
					echo '</li>';
				}
			}
			echo '<ul>';
			if(!empty($profile_folders)) buildDeviantMenu_intro($profile_folders, $file->type);
			echo '</ul>';
			?>
			</div>
		</div>
		
		<input class="align-right" type="button" data-behavior="Button" data-button-type="small" data-button-width="70" id="ui-intro-save" value="Save" />
	</div></div>
	
	<div id="timeline-outro-wrapper"><div class="triangle"></div><div class="styled descend">
		<p>Select a <?php echo $file->type; ?> to play after this one!</p>
		<label for="ui-outro">Select a <?php echo $file->type; ?></label>
		<input type="hidden" id="outro_video" name="outro_video" data-behavior="EvpTieToElement" />
		<input type="text" disabled="disabled" id="outro_video_label" class="margin-bottom" style="width: 260px; background: #fff; border: none; box-shadow: none;" />
		
		<div style="width:280px;overflow-x:hidden;overflow-y:scroll;height:300px;">
			<div data-behavior="" id="timeline-outro-select">
			<?php
			function buildDeviantMenu_outro($folders, $type) {
				global $evp;
				$profile_files = Registry::retrieve('profile_files');
				foreach($folders as $folder) {
					$subfolders = array();
					$files = array();
					if(!empty($folder->file_count)) $files = $profile_files[$folder->id];//$evp->getFiles($folder->id);
					if($folder->id !== 0) $subfolders = $folder->subfolders;//$evp->getFolders($folder->id, false);
					echo '<li class="folder">';
					echo "{$folder->name}";
					echo '<ul>';
					if(!empty($subfolders)) {
						buildDeviantMenu_outro($subfolders, $type);
					}
					if(!empty($files)) {
						foreach($files as $tf) {
							if($tf->type == $type){
								echo "<li><a class=\"file\" data-label=\"{$tf->name}\" data-file_ref=\"{$tf->id}\">".string_trim($tf->name, 42)."</a></li>";
							}
						}
					}
					echo '</ul>';
					echo '</li>';
				}
			}
			echo '<ul>';
			if(!empty($profile_folders)) buildDeviantMenu_outro($profile_folders, $file->type);
			echo '</ul>';
			?>
			</div>
		</div>
		
		<input class="align-right" type="button" data-behavior="Button" data-button-type="small" data-button-width="70" id="ui-outro-save" value="Save" />
	</div></div>
	
	<div id="timeline-redirect-wrapper"><div class="triangle"></div><div class="styled descend">
		<p>Redirect your viewers to another page right after your video. Just enter the URL here!</p>
		<label for="ui-redirect">URL</label>
		<input type="text" class="margin-bottom" id="ui-redirect" name="post-video-redirect" data-behavior="EvpTieToElement" style="width: 160px;" />
		<input class="align-right" type="button" data-behavior="Button" data-button-type="small" data-button-width="70" id="ui-redirect-save" value="Save" />
	</div></div>
	
</div>

<?php
$classes = array('clear');
if($file->type == 'audio' && !($file_settings->options['related_image_mode'] == 'splash' && !empty($file_settings->options['related_image']))) $classes[] = 'event-area-wrapper-audio';

$area_width = $file_settings->options['width'];
$area_height = ($file->type == 'audio' ? $file_settings->options['skin_data']['skin_height'] : $file_settings->options['height']);

// If it's an audio file with cover art, the height should be set like this
if($file->type == 'audio' && $file_settings->options['related_image_mode'] == 'splash' && !empty($file_settings->options['related_image']) && !empty($file_settings->options['splash_height'])) {
	$area_height = $file_settings->options['splash_height'] - 20; // Splash height, minus skin height, minus padding
}
?>
<div id="event-area-resize">
	<p>Adjust the size of the Event area, which must fit inside your page</p>
	<input type="number" id="event-area-resize-width" min="100" max="900" />
	<input type="number" id="event-area-resize-height" min="100" max="1200" />
	<input type="button" id="event-area-resize-update" data-behavior="Button" data-button-type="action_small" data-button-width="60" data-button-type="action" value="Update" />
</div>
<div class="<?php echo implode(' ', $classes); ?>" id="event-area-outer" unselectable="on">
	<div id="event-area-wrapper" style="display:none;width:<?php echo $area_width; ?>px;height:<?php echo $area_height; ?>px;background-position:center,center;background-repeat:no-repeat;background-image:url(../player/assets/jwplayer-5.10/skins/<?php echo pick($file_settings->options['skin'], 'minima'); ?>/display/playIcon.png), url(../player/assets/jwplayer-5.10/skins/<?php echo pick($file_settings->options['skin'], 'minima'); ?>/display/background.png);">
		<div id="event-area-preview"></div>
		<div id="event-area"></div>
	</div>
</div>

<div class="clear box position-relative"><div class="wrap self-clear">
	<div id="timeline-content">
		
		<div id="timeline-content-event" class="timeline-content-panel"><div class="wrap" style="padding:0;">
			<?php include(getWidgetInclude('files.timeline.event')); ?>
		</div></div>
		
		<div id="timeline-content-chapter" class="timeline-content-panel"><div class="wrap">
			<?php include(getWidgetInclude('files.timeline.chapter')); ?>
		</div></div>
		
		<div id="timeline-content-survey" class="timeline-content-panel"><div class="wrap">
			<?php include(getWidgetInclude('files.timeline.survey')); ?>
		</div></div>
		
	</div>
	<div id="timeline-options" class="self-clear">
		<div class="box-option" id="timeline-create-event">
			<h3>Events</h3>
			<div class="option"><img src="<?php echo assets('assets/icons-custom/events.png'); ?>" /></div>
			<p>Create timed Events over your video</p>
			<a data-behavior="Button" data-button-width="150">Add Event</a>
		</div>
		<div class="box-option" id="timeline-create-chapter">
			<h3>Chapters</h3>
			<div class="option"><img src="<?php echo assets('assets/icons-custom/chapters.png'); ?>" /></div>
			<p>Skip to important points in your video</p>
			<a data-behavior="Button" data-button-width="150">Add Chapter</a>
		</div>
		<div class="box-option" id="timeline-create-survey">
			<h3>Surveys</h3>
			<div class="option"><img src="<?php echo assets('assets/icons-custom/surveys.png'); ?>" /></div>
			<p>Discover more about your viewers</p>
			<a data-behavior="Button" data-button-width="150">Add Survey</a>
		</div>
		<div class="clear align-right">
			<a id="ui-save" data-behavior="Button" data-button-width="120" data-button-icon="forward" data-button-iconpos="right"><?php echo ($file->id == 'default' ? 'Save' : 'Embed code'); ?></a>
		</div>
	</div>
</div></div>