<script type="text/javascript">

// Create a new answer
var createAnswer = function(answer, block) {
	var row = Elements.from('<div class="survey-answer-block"><div class="survey-answer-data"><label>Answer: <span class="survey-answer-delete">Delete</span></label><input type="text" class="survey-answer-data-answer margin-bottom" name="questions[][answers][]" /></div></div>');
	if(answer && answer.length >= 1) {
		row.getElement('input.survey-answer-data-answer').set('value', answer);
	}
	var idx = block.getElements('.survey-answer-block').length + 1, vidx = idx - 1;
	row.getElement('label').set('html', 'Answer #'+idx+' <span class="survey-answer-delete">Delete</span>');
	row.getElement('input.survey-answer-data-answer').set('name', 'questions[][answers]['+vidx+']');
	block.adopt(row);
};

// Create a new question
var createQuestion = function(question, answers) {
	var row = $(Elements.from('<div class="survey-question-block"><div class="survey-question-delete"><span class="ui-icon ui-icon-delete"></span></div><div class="survey-question-data"><label>Question:</label><input type="text" class="survey-question-data-question margin-bottom" name="questions[][name]" /></div><div class="survey-question-answers-wrap"></div><a class="ui-survey-answer-add" data-behavior="Button" data-button-width="150" data-button-type="action_small">Add a new answer (1 of 4)</a></div>')[0]);
	
	row.inject($('survey-questions-wrap'));
	if(question && question.length >= 1) {
		row.getElement('input.survey-question-data-question').set('value', question);
	}
	
	if(answers && answers.length >= 1) {
		Array.each(answers, function(answer, idx) {
			createAnswer(answer, row.getElement('.survey-question-answers-wrap'));
		});
	} else {
		createAnswer('', row.getElement('.survey-question-answers-wrap')); // Default
	}
	
	new Behavior().apply($('survey-questions-wrap'));
	
	var abtn = row.getElement('.ui-survey-answer-add'), al = 0;
	if(abtn) {
		al = (answers ? answers.length : 1);
		abtn.getElement('.moobutton_text').set('text', 'Add a new answer ('+(al + 1)+' of 4)');
		if(al >= 3) abtn.setStyle('visibility', 'hidden');
		else abtn.setStyle('visibility', 'visible');
	}
};

var restoreSurveyArea = function(opt) {
	var options = Object.merge({}, {
		'name': 'My Survey',
		'description': '',
		'start-string': '00:00',
		'data': {
			'survey-trigger-pause': false,
			'survey-act-gateway': false,
			'questions': [],
			'answers': []
		}
	}, opt);
	
	$('survey-questions-wrap').empty(); // Clear out anything old
	
	Object.each(Object.merge({}, options, options.data), function(value, key) {
		var el = $('timeline-content-survey').getElement('[name="'+key+'"]');
		if(!el) return;
		
		if(el.get('tag') == 'select') {
			if(value !== null) {
				var opt = el;//$$('#form select[name="metric"] option[value="'+value+'"]');
				var opDiv = el.getNext('.selectaWrapper').getElements('.selectaOption[data-value="'+value+'"]');
				if(opDiv) {
					el.retrieve("wrapper").getChildren().removeClass('selectaOptionSelected');
					opDiv.addClass('selectaOptionSelected');
					el.retrieve("triggerElement").set("html", opDiv.get("text"));
					el.set("value", opDiv.retrieve("value")).fireEvent("change");
					opt.set('selected', true);
				}
			}
			return;
		}
		
		var type = el.get('type');
		switch(type) {
			case 'radio':
				if(value === true || value === false || value == 'true' || value == 'false') { // Handle booleans differently
					var real_el = el.getParent().getElement('input[value="'+value+'"]');
					if(!real_el) real_el = el.getParent().getElement('input[value="'+(value == true ? 'yes' : 'no')+'"]');
				} else {
					var real_el = el.getParent().getElement('input[value="'+value+'"]');
				}
				
				var wrap = el.getParent('.radio-group-wrapper').getElement('[data-behavior="RadioGroup"]');
				wrap.retrieve('RadioGroup').select(real_el);
				break;
			case 'checkbox':
				if(el.retrieve('iPhoneSwitchWrap')) {
					el.set('checked', !(value == true)); // Set opposite and fire event to change
					el.retrieve('iPhoneSwitchWrap').fireEvent('click');
				} else {
					el.set('checked', value).fireEvent('change');
					(function() { // We delay here because the transparency selector needs the animation to be complete before changing opacity
						el.fireEvent('change');
					}).delay(750);
				}
				break;
			default:
				el.set('value', value);
				var rain = el.retrieve('ColourPicker');
				if(rain) {
					rain.manualSet(value, 'hex');
				}
				el.fireEvent('change');
				break;
		}
	});
	
	$('thisPage').store('current_survey', options.name);
	
	// Restore the questions and answers
	Array.each(options.data.questions, function(q, idx) {
		createQuestion(q, options.data.answers[idx]);
	});
	
	if($('survey-questions-wrap').match(':empty')) createQuestion();
	
	// Restore the preview area
	$('timeline-options').get('reveal').dissolve().chain(function() {
		$$('.timeline-content-panel').setStyle('display', 'none');
		$('timeline-content-survey').setStyle('display', 'block');
		$('timeline-content').reveal();
		$$('#event-area-wrapper, #event-area, #event-area-preview').dissolve();
	});
}

window.addEvent('domready', function() {
	$('timeline-content-survey').addEvent('onActivate', function() {
		var name_idx = $('timeline').getElements('.ui-timeline-element[data-timeline-type="survey"]').length + 1;
		$('ui-delete-survey').setStyle('display', 'none');
		
		restoreSurveyArea({
			'name': 'My Survey '+name_idx,
			'description': 'Please answers the questions below!',
			'start-string': '00:00',
			'data': {
				'survey-trigger-pause': false,
				'survey-act-gateway': false,
				'questions': [],
				'answers': []
			}
		});
	});
	
	// Start and duration times
	$('survey-start-minutes').addEvent('change', function() {
		var m = this.get('value') || 0;
		$('survey-start-string').set('value', m+':'+$('survey-start-seconds').get('value'));
	});
	$('survey-start-seconds').addEvent('change', function() {
		var s = this.get('value') || 0;
		if(parseInt(s) < 10) s = '0'+(parseInt(s));
		$('survey-start-string').set('value', $('survey-start-minutes').get('value')+':'+s);
	});
	$('survey-start-string').addEvent('change', function() {
		var t = this.get('value').split(':');
	//if(t[0] == '00') t[0] = 0;
	//if(t[1] == '00') t[1] = 0;
		$('survey-start-minutes').set('value', t[0]);
		$('survey-start-seconds').set('value', t[1]);
	});
	
	$('ui-survey-question-add').addEvent('click', function() {
		var count = $('survey-questions-wrap').getElements('.survey-question-block').length;
		if(count < 6) {
			createQuestion(); // With no data, to make a new one
			try {
				$('survey-questions-wrap').getElements('input.survey-question-data-question').pop().focus();
			} catch(e) {}
		} else {
			StickyWin.alert('Hold on!', 'You can only create a maximum of 6 questions per survey!');
		}
	});
	
	// Bind answer events
	$('survey-questions-wrap').addEvent('click:relay(.ui-survey-answer-add)', function() {
		var block = this.getParent('.survey-question-block').getElement('.survey-question-answers-wrap');
		var count = block.getElements('.survey-answer-block').length || 0;
		this.getElement('.moobutton_text').set('text', 'Add a new answer ('+(count + 2)+' of 4)');
		if(count >= 3) this.setStyle('visibility', 'hidden');
		else this.setStyle('visibility', 'visible');
		if(count <= 3) {
			createAnswer('', block); // New answer block
			try {
				block.getElements('input.survey-answer-data-answer').pop().focus();
			} catch(e) {}
		} else {
			StickyWin.alert('Hold on!', 'You can only create a maximum of 4 answers per question!');
		}
	});
	
	$('survey-questions-wrap').addEvent('click:relay(.survey-question-delete)', function() {
		var k = this;
		StickyWin.confirm('Are you sure?', 'Do you really want to remove this question from the survey?', function() {
			var question = k.getParent('.survey-question-block');
			question.kill();
		});
	});
	
	$('survey-questions-wrap').addEvent('click:relay(.survey-answer-delete)', function() {
		var k = this;
		var question = this.getParent('.survey-question-block').getElement('input.survey-question-data-question').get('value').trim();
		StickyWin.confirm('Are you sure?', 'Do you really want to remove this answer from the question "'+question+'"?', function() {
			var answer = k.getParent('.survey-answer-block'), questionBlock = answer.getParent('.survey-question-block');
			answer.kill(function() {
				var count = questionBlock.getElements('.survey-answer-block').length || 0;
				questionBlock.getElement('.ui-survey-answer-add .moobutton_text').set('text', 'Add a new answer ('+(count + 1)+' of 4)');
				if(count >= 4) questionBlock.getElement('.ui-survey-answer-add').setStyle('visibility', 'hidden');
				else questionBlock.getElement('.ui-survey-answer-add').setStyle('visibility', 'visible');
			});
		});
	});
	
	// Save this Event
	$('ui-save-survey').addEvent('click', function() {
		// Do we need to delete an old survey, because we're editing?
		if($('thisPage').retrieve('current_survey') && $('thisPage').retrieve('current_survey') !== $('survey-name').get('value')) {
			var surveys = $('thisFile').retrieve('surveys') || {};
			surveys = (typeOf(surveys) == 'array' ? {} : surveys);
			delete surveys[$('thisPage').retrieve('current_survey')];
			delete surveys[$('thisPage').retrieve('current_survey').makeSeed()]
			// Delete the marker?
			$$('#timeline-marker-'+$('thisPage').retrieve('current_survey').makeSeed()).kill(function() {
				positionTimelineMarkers();
			});
			$('thisFile').store('surveys', surveys);
		}
		
		$('thisPage').store('current_survey', '');
		
		// Add/update the marker
		var marker = createTimelineMarker($('survey-name').get('value'), 'survey', {
			'start-string': $('survey-start-string').get('value'),
			'description': $('survey-description').get('value'),
			'data': {
				'survey-trigger-pause': !!($('survey-trigger-pause').match(':checked')),
				'survey-act-gateway': !!($('survey-act-gateway').match(':checked')),
				'questions': $('survey-questions').getElements('input.survey-question-data-question').get('value'),
				'answers': $('survey-questions').getElements('.survey-question-answers-wrap').map(function(q) { return q.getElements('.survey-answer-data-answer').get('value'); })
			}
		});
		
		// Store the data
		var surveys = $('thisFile').retrieve('surveys') || {};
		surveys = (typeOf(surveys) == 'array' ? {} : surveys);
		surveys[$('survey-name').get('value')] = marker.retrieve('evp-timeline-data');
		$('thisFile').store('surveys', surveys);
		
		// Return to the original screen
		restoreDefaultArea();
	});
	
	// Delete a Survey
	$$('.ui-delete-survey').addEvent('click', function() {
		var surveys = $('thisFile').retrieve('surveys') || {};
		surveys = (typeOf(surveys) == 'array' ? {} : surveys);
		delete surveys[$('survey-name').get('value').makeSeed()];
		delete surveys[$('survey-name').get('value')];
		$('thisFile').store('surveys', surveys);
		
		$('timeline-marker-'+$('survey-name').get('value').makeSeed()).kill();
		
		// Return to the original screen
		restoreDefaultArea();
	});
});
</script>

<div class="content" id="timeline-survey-content" style="width: 840px;">
	<h2 class="align-left">Create your Survey</h2>
	<div class="align-right" style="position: relative; top: -10px;"><div data-behavior="Button" data-button-type="action" data-button-width="70" data-button-icon="delete" data-button-iconpos="right" class="ui-delete-survey" id="ui-delete-survey">Delete</div></div>
	<div class="options clear styled descend">
		
		<h6>Enter some info about this survey</h6>
		<div id="survey-details">
			<div class="group descend margin-bottom">
				<label for="survey-name">Enter a simple name for your survey (Just for your reference)</label>
				<input type="text" id="survey-name" name="name" style="width: 380px;" />
			</div>
			
			<div class="group descend margin-bottom">
				<label for="survey-description">Enter some welcome text to display above the survey, explaining what to do.</label>
				<input type="text" id="survey-description" name="description" style="width: 380px;" />
			</div>
			
			<div class="group margin-bottom" id="survey-start-wrap">
				<label for="survey-start-string">When should this survey appear? <span class="ui-text-tiny">(Min/sec)</span></label>
				<input type="number" id="survey-start-minutes" style="width:20px;margin:0 5px 0 0;" />:
				<input type="number" id="survey-start-seconds" style="width:20px;margin:0 0 0 5px;" />
				<input type="hidden" id="survey-start-string" name="start-string" style="width: 48px;" />
			</div>
			
			<div class="group descend margin-bottom">
				<label>Pause video playback when the survey shows up?</label>
				<input name="survey-trigger-pause" id="survey-trigger-pause" type="checkbox" value="true" data-behavior="iPhoneCheckbox" />
			</div>
			
			<div class="group descend margin-bottom">
				<label>Prevent users from watching the rest of the video until they complete the survey?</label>
				<input name="survey-act-gateway" id="survey-act-gateway" type="checkbox" value="true" data-behavior="iPhoneCheckbox" />
			</div>
		</div>
		
		<h6>Now configure your questions and answers</h6>
		<div id="survey-questions">
			<div id="survey-questions-wrap"></div>
			<a id="ui-survey-question-add" data-behavior="Button" data-button-icon="plus" data-button-iconpos="left" data-button-width="160" data-button-type="action">Add a new question</a>
		</div>
		
		<div class="clear timeline-content-footer">
			<a class="ui-return" data-behavior="Button" data-button-icon="back" data-button-iconpos="left" data-button-width="110">Go back</a>
			<a id="ui-save-survey" data-behavior="Button" data-button-icon="forward" data-button-iconpos="right" data-button-width="120">Save Survey</a>
		</div>
		
	</div>
</div>