<?php
require('application.php');
require('application.bootstrap.php');
$page = new Page('upload.copy.php', 'master.php', array('theme' => $evp->settings->theme, 'version' => $evp->options->project_version));
$page->title(array(pick($evp->settings->site_name, $evp->options->project_name), 'Upload', 'Copy from another S3 bucket'));
$xs->restrictTo(array('groups' => array('Administrators')), 'signin.php', array('return' => pass_create()), true);

$source = trim($_GET['bucket']);
$target = $evp->settings->s3_bucket;

$target_folder = (empty($_GET['target_folder']) ? $source : escape(urldecode($_GET['target_folder'])));

$tmp_s3 = new EVP_S3($evp->settings->s3_accesskey, $evp->settings->s3_secretkey, $source);

$message = '';
$unsupported_files = array();

$bucket_headers = $tmp_s3->aws->s3->get_bucket_headers($source);

if(!$bucket_headers->isOK()) {
	$message = 'This bucket either does not exist or does not appear to belong to the same S3 account as '.$evp->options->project_name.' is using! You cannot copy across two S3 accounts.';
} else {
	$all_files = $tmp_s3->loadFiles();
	$files = array();
	if(!empty($all_files)) {
		foreach($all_files as $data) {
			$extension = getExtension($data['name']);
		//if(!in_array($extension, $tmp_s3->options->supported_files)) {
				$file = new Object(array(
					'name' => $data['name'],
					'file_name' => $data['name'],
					'extension' => $extension,
					'location' => url("http://{$source}.s3.amazonaws.com/{$data['name']}")
				));

				$uri = $file->file_name;
				$download_url = 'http://'.$evp->settings->s3_bucket.'.s3.amazonaws.com/'.$uri;

				if($evp->settings->use_cloudfront != '1') {
					$uri.= '?response-content-disposition=attachment;filename='.urlencode($file->file_name);
					$expires = time() + 3600;
					$uri = str_replace('%2F', '/', $uri);
					$download_url = sprintf('http://%s/%s&AWSAccessKeyId=%s&Expires=%u&Signature=%s', $source.'.s3.amazonaws.com', $uri, $evp->settings->s3_accesskey, $expires, urlencode(S3_STD::__getHash("GET\n\n\n{$expires}\n/{$source}/{$uri}")));
				}

				$file->download_url = $download_url;

				if(in_array($extension, array('wmv', 'mov', 'avi'))) $unsupported_files[] = $file;
				else if(in_array($extension, array('mp4', 'm4v', 'flv'))) $files[] = $file;
			}
	//}
	}
}

if(empty($message) && empty($unsupported_files) && empty($files)) {
	$message = 'There are no files available to copy from this bucket!';
}

if(empty($message)) {
	$bucket_name_string = $target_folder;
	if($_GET['append_bucket'] == 'true') $bucket_name_string = "{$bucket_name_string}: {$source}";
	$folder = $evp->api->folders_create($target_folder);
}

$page->set('message', $message);
$page->set('files', $files);
$page->set('unsupported_files', $unsupported_files);
$page->set('source', $source);
$page->set('folder', $folder);

$page->addEvent('onTemplateMerge', 'onTemplateMerge');
echo $page->parse();
?>
