<?php
require('application.php');
$config = Registry::retrieve('config');
$config['xs']['noTrackerUpdate'] = true;
Registry::store('config', $config);
require('application.bootstrap.php');

include($config['paths']['base'].'/libraries/api.php');

$api = new API(array('sendContentType' => true));

if(empty($_REQUEST['method'])) $method = 'general-unknown';
else $method = trim(strtolower($_REQUEST['method']));

$responseType = $_REQUEST['responseType'];
if(!empty($responseType)) $api->setResponseType($responseType);

function api_authenticate_failed() {
	global $api, $evp, $config;
	$apiData = array(
		'success' => false,
		'message' => "Your username and password don't seem to be correct.\n\nPlease try going here to your web app to sign in: {$config['locations']['absolute']}\nEnter your username (which is an email address and NOT your members area username) and your password.\n\nIf this works but you still see this error, please contact us with all your details!\n\nNote: You can reset your password from that page if you need have lost it!"
	//'message' => 'Your request could not be authenticated; please check your '.$evp->options->project_name.' username and password and try again! Please make absolutely sure you are not entering your members area username into this box. Your username should be your email address! This is what you entered during the setup process of the web application.'
	);
	$api->setResponseData($apiData)->respond();
}

// Handle each method call
switch($method) {
	case 'public-upgrade':
		$script = basename($_REQUEST['script']);

		if(file_exists($config['paths']['base'].'/install/assets/'.$script.'.php')) {
			include($config['paths']['base'].'/install/assets/'.$script.'.php');
		} else {
			$apiData = array(
				'success' => false,
				'message' => 'The upgrade script does not exist.'
			);
		}

		$api->setResponseData($apiData)->respond();

		break;
	case 'public-status-operator':
		$return = 0;
		$operator_id = (empty($_REQUEST['operator_id']) || $_REQUEST['operator_id'] == 'false' ? false : escape($_REQUEST['operator_id'], true));

		$floor = gmdate('Y-m-d H:i:s', gmstrtotime('-10 minutes'));

		if(empty($operator_id)) {
			$gids = flattenByKey(getArray("SELECT `id` FROM {$evp->options->prefix}groups WHERE `name` = 'Administrators' || `name` = 'Managers'"), 'id');
			$operators = getArray("SELECT t.user_id, u.username FROM {$evp->options->prefix}users_relationships g, {$evp->options->prefix}users u, {$evp->options->prefix}users_tracker t WHERE g.group_id IN(".implode($gids, ',').") && t.lastActivity >= '{$floor}' && g.user_id = t.user_id && u.id = t.user_id");
			if(!empty($operators)) {
				$offliners = getArray("SELECT t.user_id FROM {$evp->options->prefix}users_tracker t, {$evp->options->prefix}users_tracker_data d WHERE t.id = d.tracker_id && d.key = 'appear_offline' && d.value = '1'");
				if(!empty($offliners)) {
					$offliners = flattenByKey($offliners, 'user_id');
					foreach($operators as $op) {
						if(!in_array($op->user_id, $offliners)) {
							$return = $op;
							continue; // Break out of this
						}
					}
				} else {
					$return = $operators[0]; // This guy is online
				}
			}
		} else {
			$isOnline = getRow("SELECT t.user_id, u.username  FROM {$evp->options->prefix}users_tracker t, {$evp->options->prefix}users u WHERE t.lastActivity >= '{$floor}' && t.user_id = '{$operator_id}' && u.id = '{$operator_id}'");
			$off = getRow("SELECT t.user_id FROM {$evp->options->prefix}users_tracker t, {$evp->options->prefix}users_tracker_data d WHERE t.user_id = '{$operator_id}' && t.id = d.tracker_id && d.key = 'appear_offline' && d.value = '1'");
			if(!empty($isOnline) && empty($off)) $return = $isOnline; // This specific guy is online!
		}

		if(!empty($return)) {
			$apiData = array(
				'success' => true,
				'operator_id' => $return->user_id,
				'operator_email' => $return->username
			);
		} else {
			$apiData = array(
				'success' => false
			);
		}

		$api->setResponseData($apiData)->respond();

		break;
	case 'public-livechat-init':
		$uuid = escape($_REQUEST['uuid'], true);
		$file_ref = escape($_REQUEST['file_ref'], true);
		$client_name = escape($_REQUEST['client_name'], true);
		$client_email = escape($_REQUEST['client_email'], true);
		$operator_id = escape($_REQUEST['operator_id'], true);
		$client_country = 'Unknown';
		$referrer = getRemoteIP();//$_REQUEST['HTTP_REFERRER'];
		$now = gmdate('Y-m-d H:i:s');

		$ip = $_SERVER['REMOTE_ADDR'];
		$ipdata = $evp->statistics->getUserData($ip);
		if(!empty($ipdata) && !empty($ipdata->country_code)) $client_country = $ipdata->country_code;

		$chat = getRow("SELECT `id`, `operator_id`, `file_ref`, `date`, `uuid`, `client_name`, `client_email`, `client_country`, `url`, `status` FROM {$evp->options->prefix}chats WHERE `uuid` = '{$uuid}' && `file_ref` = '{$file_ref}' && `status` != '2' ORDER BY `date` DESC");

		if(!$chat) {
			query("INSERT INTO {$evp->options->prefix}chats (`operator_id`, `file_ref`, `date`, `uuid`, `client_name`, `client_email`, `client_country`, `url`, `status`) VALUES ('{$operator_id}', '{$file_ref}', '{$now}', '{$uuid}', '{$client_name}', '{$client_email}', '{$client_country}', '{$referrer}', '0')");
			$newly_chat = getInsertId();
			$chat = getRow("SELECT `id`, `operator_id`, `file_ref`, `date`, `uuid`, `client_name`, `client_email`, `client_country`, `url`, `status` FROM {$evp->options->prefix}chats WHERE `id` = '{$newly_chat}'");
		}

		if(!empty($chat)) {
			$chat->operator_email = grab(getRow("SELECT `username` FROM {$evp->options->prefix}users WHERE `id` = '{$chat->operator_id}'"), 'username');
			$apiData = array(
				'success' => true,
				'chat' => $chat
			);
		} else {
			$apiData = array(
				'success' => false
			);
		}

		$api->setResponseData($apiData)->respond();

		break;
	case 'public-livechat-close':
		$uuid = escape($_REQUEST['uuid'], true);
		$file_ref = escape($_REQUEST['file_ref'], true);
		$chat_id = escape($_REQUEST['chat_id'], true);

		$now = gmdate('Y-m-d H:i:s');

		$chat = getRow("UPDATE {$evp->options->prefix}chats SET `status` = '2' WHERE `id` = '{$chat_id}' && `uuid` = '{$uuid}' && `file_ref` = '{$file_ref}' LIMIT 1");

		$apiData = array(
			'success' => true
		);

		$api->setResponseData($apiData)->respond();

		break;
	case 'public-livechat-send':
		$uuid = escape($_REQUEST['uuid'], true);
		$file_ref = escape($_REQUEST['file_ref'], true);
		$type = 1;//($_REQUEST['type'] == 1 ? 1 : 0);
		$body = escape($_REQUEST['body'], true);

		$chat = getRow("SELECT `id`, `operator_id`, `file_ref`, `date`, `uuid`, `client_name`, `client_email`, `client_country`, `url`, `status` FROM {$evp->options->prefix}chats WHERE `uuid` = '{$uuid}' && `file_ref` = '{$file_ref}' && `status` != '2'");

		if(!$chat) {
			//
		} else {
			$now = gmdate('Y-m-d H:i:s');
			$yes = query("INSERT INTO {$evp->options->prefix}chats_msgs (`chat_id`, `date`, `type`, `read`, `body`) VALUES ('{$chat->id}', '{$now}', '{$type}', '0', '{$body}')");
			$message_id = getInsertId();

			// Set the status to awaiting operator
			query("UPDATE {$evp->options->prefix}chats SET `status` = '0' WHERE `id` = '{$chat->id}' LIMIT 1");

			// Return success
			$apiData = array(
				'success' => ($yes),
				'message_id' => $message_id
			);
		}

		$api->setResponseData($apiData)->respond();

		break;
	case 'public-livechat-poll':
		$uuid = escape($_REQUEST['uuid'], true);
		$chat_id = escape($_REQUEST['chat_id'], true);
		$file_ref = escape($_REQUEST['file_ref'], true);

		$chat = getRow("SELECT `id`, `operator_id`, `file_ref`, `date`, `uuid`, `client_name`, `client_email`, `client_country`, `url`, `status` FROM {$evp->options->prefix}chats WHERE `id` = '{$chat_id}' && `uuid` = '{$uuid}' && `file_ref` = '{$file_ref}'");

		if(!$chat) { // No chat found.. not sure what to do!
			//
		} elseif($chat->status == '2') { // The chat has been closed!
			$apiData = array(
				'success' => false,
				'status' => $chat->status
			);
		} else {
			$messages = getArray("SELECT `id`, `chat_id`, `date`, `type`, `read`, `body` FROM {$evp->options->prefix}chats_msgs WHERE `chat_id` = '{$chat->id}'");

			// Mark all the operators messages as read, as they've come through successfully
			query("UPDATE {$evp->options->prefix}chats_msgs SET `read` = '1' WHERE `chat_id` = '{$chat->id}' && `type` = '0'");

			// Return success
			$apiData = array(
				'success' => true,
				'messages' => $messages
			);
		}

		$api->setResponseData($apiData)->respond();
		break;
	case 'livechat-poll':
		$user = $evp->api->authenticate($_REQUEST['username'], $_REQUEST['password']);
		if($user) {

			$operator_id = $user->id; // This could be changed later to allow cross-polling for other operators' chats

			// First, let's do some pruning here
			$evp->api->live_chat_prune();

			$chats = getArray("SELECT `id`, `operator_id`, `file_ref`, `date`, `uuid`, `client_name`, `client_email`, `client_country`, `url`, `status` FROM {$evp->options->prefix}chats WHERE `operator_id` = '{$operator_id}' && `status` != '2'");
			if(empty($chats)) {
				$apiData = array(
					'success' => false,
					'message' => 'No active chats.'
				);
			} else {
				$chat_ids = flattenByKey($chats, 'id');
				$messages = getArray("SELECT `id`, `chat_id`, `date`, `type`, `read`, `body` FROM {$evp->options->prefix}chats_msgs WHERE `chat_id` IN(".implode($chat_ids, ',').")");

				$apiData = array(
					'success' => true,
					'chats' => $chats,
					'messages' => $messages
				);
			}

			// Respond!
			$api->setResponseData($apiData)->respond();
		} else {
			api_authenticate_failed();
		}
		break;
	case 'livechat-operator-send':
		$user = $evp->api->authenticate($_REQUEST['username'], $_REQUEST['password']);
		if($user) {

			$operator_id = $user->id; // This could be changed later to allow cross-polling for other operators' chats
			$chat_id = escape($_REQUEST['chat_id'], true);
			$body = escape($_REQUEST['body'], true);

			$chat = getRow("SELECT `id`, `operator_id`, `file_ref`, `date`, `uuid`, `client_name`, `client_email`, `client_country`, `url`, `status` FROM {$evp->options->prefix}chats WHERE `id` = '{$chat_id}'");

			if(!$chat) {
				//
			} else {
				$now = gmdate('Y-m-d H:i:s');
				$yes = query("INSERT INTO {$evp->options->prefix}chats_msgs (`chat_id`, `date`, `type`, `read`, `body`) VALUES ('{$chat->id}', '{$now}', '{$type}', '0', '{$body}')");
				$message_id = getInsertId();

				// Update the tracker to keep the admin alive
				query("UPDATE {$evp->options->prefix}users_tracker SET `lastActivity` = '{$now}' WHERE `user_id` = '{$operator_id}'");

				// Set the status to awaiting client
				query("UPDATE {$evp->options->prefix}chats SET `status` = '1' WHERE `id` = '{$chat->id}' LIMIT 1");

				$sent = (object)$_POST;
				$sent->id = $message_id;

				// Return success
				$apiData = array(
					'success' => ($yes),
					'message_id' => $message_id,
					'sent' => $sent
				);
			}

			// Respond!
			$api->setResponseData($apiData)->respond();
		} else {
			api_authenticate_failed();
		}
		break;
	case 'livechat-operator-read':
		$user = $evp->api->authenticate($_REQUEST['username'], $_REQUEST['password']);
		if($user) {
			$chat_id = escape($_REQUEST['chat_id'], true);
			$floor = escape($_REQUEST['floor'], true); // Do a string comparison on the dates; should work!

			$now = gmdate('Y-m-d H:i:s');

			query("UPDATE {$evp->options->prefix}chats_msgs SET `read` = '1' WHERE `chat_id` = '{$chat_id}' && `type` = '1' && `date` <= '{$floor}'");

			$apiData = array(
				'success' => true
			);

			$api->setResponseData($apiData)->respond();
		} else {
			api_authenticate_failed();
		}
		break;
	case 'livechat-operator-close':
		$user = $evp->api->authenticate($_REQUEST['username'], $_REQUEST['password']);
		if($user) {
			$chat_id = escape($_REQUEST['chat_id'], true);

			$now = gmdate('Y-m-d H:i:s');

			query("UPDATE {$evp->options->prefix}chats SET `status` = '2' WHERE `id` = '{$chat_id}' LIMIT 1");

			$apiData = array(
				'success' => true
			);

			$api->setResponseData($apiData)->respond();
		} else {
			api_authenticate_failed();
		}
		break;
	case 'livechat-operator-status':
		$user = $evp->api->authenticate($_REQUEST['username'], $_REQUEST['password']);
		if($user) {

			$operator_id = $user->id; // This could be changed later to allow cross-polling for other operators' chats
			$status = ($_REQUEST['status'] == '0' ? 0 : 1);

			$tracker_id = grab(getRow("SELECT `id` FROM {$evp->options->prefix}users_tracker WHERE `user_id` = '{$operator_id}'"), 'id');

			if($status == 1) {
				query("DELETE FROM {$evp->options->prefix}users_tracker_data WHERE `tracker_id` = '{$tracker_id}' && `key` = 'appear_offline'");
			} else {
				query("INSERT INTO {$evp->options->prefix}users_tracker_data (`tracker_id`, `key`, `value`) VALUES ('{$tracker_id}', 'appear_offline', 1)");
			}

			// Return success
			$apiData = array(
				'success' => true,
				'status' => $status,
				'status-string' => ($status == 0 ? 'offline' : 'online')
			);

			// Respond!
			$api->setResponseData($apiData)->respond();
		} else {
			api_authenticate_failed();
		}
		break;
	case 'public-like':
		$reference = escape($_REQUEST['reference'], true);
		$name = escape($_REQUEST['name'], true);
		$email = escape($_REQUEST['email'], true);
		$type = 'file';
		switch($_REQUEST['type']) {
			case 'comment': $type = 'comment'; break;
			case 'file': $type = 'file'; break;
			case 'chat': $type = 'chat'; break;
		}

		$date = gmdate('Y-m-d H:i:s');

		if(empty($email) || empty($reference)) {
			$apiData = array(
				'success' => false,
				'message' => 'The values you provided are not valid for a like.'
			);
		} else {

			$item = false;
			$isValid = false;

			if($type == 'file') {
				$item = $evp->getFile($reference);
				if($item) $isValid = true;
			} elseif($type == 'comment') {
				$item = true;
				$isValid = (is_numeric($reference));
			}

			if(!$item || !$isValid) {
				$apiData = array(
					'success' => false,
					'message' => 'The reference you specified cannot be identified correctly.'
				);
			} else {
			//$existing = getRow("SELECT `date` FROM {$evp->options->prefix}likes WHERE `type` = '{$type}' && `reference` = '{$reference}'");
			//if(empty($existing)) {
					$yes = query("INSERT INTO {$evp->options->prefix}likes (`type`, `reference`, `name`, `email`, `date`) VALUES ('{$type}', '{$reference}', '{$name}', '{$email}', '{$date}')");
			//}

				// Return success
				$apiData = array(
					'success' => ($yes)
				);
			}
		}

		$api->setResponseData($apiData)->respond();

		break;
	case 'public-unlike':
		$reference = escape($_REQUEST['reference'], true);
		$name = escape($_REQUEST['name'], true);
		$email = escape($_REQUEST['email'], true);
		$type = 'file';
		switch($_REQUEST['type']) {
			case 'comment': $type = 'comment'; break;
			case 'file': $type = 'file'; break;
			case 'chat': $type = 'chat'; break;
		}

		if(empty($email) || empty($reference)) {
			$apiData = array(
				'success' => false,
				'message' => 'The values you provided are not valid for a like.'
			);
		} else {

			$item = false;
			$isValid = false;

			if($type == 'file') {
				$item = $evp->getFile($reference);
				if($item) $isValid = true;
			} elseif($type == 'comment') {
				$item = true;
				$isValid = (is_numeric($reference));
			}

			if(!$item || !$isValid) {
				$apiData = array('success' => false, 'message' => 'The reference you specified cannot be identified correctly.');
			} else {
				query("DELETE FROM {$evp->options->prefix}likes WHERE `type` = '{$type}' && `reference` = '{$reference}' && `name` = '{$name}' && `email` = '{$email}'");
				$apiData = array('success' => true);
			}
		}

		$api->setResponseData($apiData)->respond();

		break;
	case 'public-comments-send':
		$file_ref = escape($_REQUEST['file_ref'], true);
		$body = escape($_REQUEST['body'], true);
		$name = escape($_REQUEST['name'], true);
		$email = escape($_REQUEST['email'], true);
		$parent_id = escape($_REQUEST['parent_id'], true);

		$isOperator = 0;
		$allUsers = flattenByKey(getArray("SELECT `username` FROM {$evp->options->prefix}users"), 'username');
		if(in_array($email, $allUsers)) $isOperator = 1;

		if((!empty($parent_id) && !is_numeric($parent_id)) || empty($email) || empty($name) || empty($body)) {
			$apiData = array(
				'success' => false,
				'message' => 'The values you provided are not correct.'
			);
		} else {
			$file = $evp->getFile($file_ref);

			if(!$file) {
				$apiData = array(
					'success' => false,
					'message' => 'The file you specified cannot be identified.'
				);
			} else {
				$now = gmdate('Y-m-d H:i:s');
				if(empty($parent_id)) {
					$yes = query("INSERT INTO {$evp->options->prefix}comments (`file_ref`, `isOperator`, `date`, `name`, `email`, `body`) VALUES ('{$file_ref}', '{$isOperator}', '{$now}', '{$name}', '{$email}', '{$body}')");
				} else {
					$yes = query("INSERT INTO {$evp->options->prefix}comments (`parent_id`, `file_ref`, `isOperator`, `date`, `name`, `email`, `body`) VALUES ('{$parent_id}', '{$file_ref}', '{$isOperator}', '{$now}', '{$name}', '{$email}', '{$body}')");
				}
				$comment_id = getInsertId();

				// Return success
				$apiData = array(
					'success' => ($yes),
					'isOperator' => $isOperator,
					'comment_id' => $comment_id
				);
			}
		}

		$api->setResponseData($apiData)->respond();

		break;
	case 'public-comments-poll':
		$file_ref = escape($_REQUEST['file_ref'], true);
		$file = $evp->getFile($file_ref);

		if(!$file) {
			$apiData = array(
				'success' => false,
				'message' => 'The file you specified cannot be identified.'
			);
		} else {
			$comments_raw = getArray("SELECT `id`, `parent_id`, `isOperator`, `date`, `name`, `email`, `body` FROM {$evp->options->prefix}comments WHERE `file_ref` = '{$file_ref}' ORDER BY `date` DESC");
			$comments = array();

			if(!empty($comments_raw)) {
				foreach($comments_raw as $c) $comments[$c->id] = $c;

				$comment_ids = implode(flattenByKey($comments, 'id'), ',');
				if(!empty($comment_ids)) {
					$likes = getArray("SELECT `reference`, `name`, `email`, UNIX_TIMESTAMP(date) AS date FROM {$evp->options->prefix}likes WHERE `type` = 'comment' && `reference` IN({$comment_ids})");

					if(!empty($likes)) {
						foreach($likes as $l) {
							if(!empty($comments[$l->reference])) {
								if(!is_array($comments[$l->reference]->likes)) $comments[$l->reference]->likes = array();
								$comments[$l->reference]->likes[] = $l;
							}
						}
					}
				}
			}

			// Return success
			$apiData = array(
				'success' => true,
				'comments' => $comments
			);
		}
		$api->setResponseData($apiData)->respond();
		break;
	case 'comments-delete':
		$user = $evp->api->authenticate($_REQUEST['username'], $_REQUEST['password']);
		if($user) {
			$comment_ids = escape($_REQUEST['ids'], true); // This is now a full array of all comment IDs to delete

			$comment = getRow("SELECT `id` FROM {$evp->options->prefix}comments WHERE `id` = '{$comment_id}'");

			query("DELETE FROM {$evp->options->prefix}comments WHERE `id` IN('".implode($comment_ids, ',')."')");

			// Return success
			$apiData = array(
				'success' => true
			);

			// Respond!
			$api->setResponseData($apiData)->respond();
		} else {
			api_authenticate_failed();
		}
		break;
	case 'public-metadata-save':
		$file_id = $_REQUEST['file_id'];
		$file = $evp->getFile($file_id);

		if(!$file) {
			$evp->primeFileCache(array('source' => 's3', 'file_name' => base64_decode($file_id))); // Update the cache as it doesn't exist
			$file = $evp->getFile($file_id);
		}

		if(!$file) { // No file, even after cache refresh
			$apiData = array(
				'success' => false,
				'message' => 'The file you specified cannot be identified.'
			);
		} else {
			if($file->source == '3') { // If it's a YouTube video
				$metadata = $evp->api->files_metadata_remote_youtube($_REQUEST['file_id']);
			} else {
				$metadata = new Object(escape($_REQUEST['metadata']));
			}

			$ssn = ssn_encode(array('metadata' => $metadata));
			foreach($ssn as $k => $v) $evp->insertDataKey($k, $v, $file_id, 'file');

			$evp->updateFileCache(); // Just make sure those values are saved

			$apiData = array(
				'success' => true,
				'metadata' => $metadata,
				'message' => 'Saved your metadata successfully.'
			);
		}

		$api->setResponseData($apiData)->respond();
		break;
	case 'public-survey-submit':
		$file_ref = $_REQUEST['file_ref'];
		$file = $evp->getFile($file_ref);

		if(!$file) {
			$apiData = array(
				'success' => false,
				'message' => 'The file you specified cannot be identified.'
			);
		} else {
			$now = gmdate('Y-m-d H:i:s');
			$uuid = escape($_REQUEST['uuid'], true);
			$survey_name = escape($_REQUEST['survey_name'], true);

			$existing = getRow("SELECT `date` FROM {$evp->options->prefix}surveys WHERE `file_ref` = '{$file_ref}' && `uuid` = '{$uuid}' && `survey_name` = '{$survey_name}'");

			if(empty($_REQUEST['answers'])) {
				$apiData = array(
					'success' => false,
					'message' => 'You did not provide any answers!'
				);
			} else if(!empty($existing)) {
				$apiData = array(
					'success' => false,
					'message' => 'You have already answered this survey!'
				);
			} else {
				foreach($_REQUEST['answers'] as $qidx => $aidx) {
					if(!is_numeric($qidx) || !is_numeric($aidx)) continue;
					query("INSERT INTO {$evp->options->prefix}surveys (`file_ref`, `uuid`, `date`, `survey_name`, `question_idx`, `answer_idx`) VALUES ('{$file_ref}', '{$uuid}', '{$now}', '{$survey_name}', '{$qidx}', '{$aidx}')");
				}

				$apiData = array(
					'success' => true
				);
			}
		}

		$api->setResponseData($apiData)->respond();
		break;
	case 'public-statistics-track':
		$file_ref = $_REQUEST['file_ref'];
		$file = $evp->getFile($file_ref);

		if(!$file) {
			$apiData = array(
				'success' => false,
				'message' => 'The file you specified cannot be identified.'
			);
		} else {
			$user = new Object(array(
				'ip' => getRemoteIP(),
				'country_code' => 'Unknown',
				'country_name' => 'Unknown'
			));

			if(isset($evp->statistics)) {
				$user = $evp->statistics->getUserData(getRemoteIP());
			}

			if(substr($_REQUEST['mode'], 0, 6) == 'stats.') {
				$stats = $evp->getDataKey('stats', $file_ref, 'file');
				if(!empty($stats)) $stats = @json_decode($stats);

				$mode = escape(substr($_REQUEST['mode'], 6), true);

				$stats = merge(new Object(array(
					$mode => $stats->{$mode} + 1
				)), $stats);

				$evp->insertDataKey('stats', $stats, $file_ref, 'file');

			} elseif(in_array($_REQUEST['mode'], array(
				'start', 'complete', 'progress' // Add all the available stat types here!
			))) {
				$referrer = urldecode($_REQUEST['referrer']);
				if(!empty($referrer)) $referrer = base64_decode($referrer);
				$mode = strtolower(escape($_REQUEST['mode']));
				$time = escape($_REQUEST['time'], true);
				$uuid = escape($_REQUEST['uuid'], true);
				$platform = escape(strtolower($_REQUEST['platform']), true);
				if(isset($evp->statistics)) {
					$evp->statistics->track($mode, $time, $file_ref, $user, $referrer, $uuid, $platform);
				}
			}

			$apiData = array(
				'success' => true
			);
		}

		$api->setResponseData($apiData)->respond();
		break;
	case 'public-statistics-conversion-insert':
		$file_ref = $_REQUEST['file_ref'];
		$file = $evp->getFile($file_ref);

		// This is cryptic because it's public!
		$conversion_data = json_decode(base64_decode(trim($_REQUEST['c'])));

		if(!$file) {
			$apiData = array(
				'success' => false,
				'message' => 'The file you specified cannot be identified.'
			);
		} elseif(empty($conversion_data)) {
			$apiData = array(
				'success' => false,
				'message' => 'The conversion information you specified was invalid.'
			);
		} else {
			$user = $evp->statistics->getUserData(getRemoteIP());

			// Extract the conversion information
			$product_name = trim($conversion_data->n);
			$product_price = floatval(string_float($conversion_data->p));
			$isUpsell = !(empty($conversion_data->u));

			if(!$isUpsell) {
				$apiData = array(
					'success' => false,
					'message' => 'The conversion insert method was called for an invalid upsell.'
				);
			} else {
				// Has this person reached at least a 'progress' of 3, OR a completion? (To allow for skipping)
				// within the past 3 hours?
				// Unfortunately we must use IP instead of UUID
				$now = gmdate('Y-m-d H:i:s');
				$window_start = gmstrtotime('-3 hours');
				$userCompletion = getRow("SELECT `ip` FROM {$evp->options->prefix}track_total_completes WHERE `file_ref` = '{$file_ref}' && `ip` = '{$user->ip}' && `time` >= '{$window_start}' LIMIT 1");
				if(!$userCompletion) {
					$userProgress = grab(getRow("SELECT MAX(`player_time`) AS progress FROM {$evp->options->prefix}track_progression WHERE `file_ref` = '{$file_ref}' && `ip` = '{$user->ip}' && `time` >= '{$window_start}' LIMIT 1"), 'progress');
				}

				if((!$userCompletion && !$userProgress) || (!$userCompletion && $userProgress <= 2)) {
					$apiData = array(
						'success' => false,
						'message' => 'The user specified has not completed enough of the video to prepare a conversion.'
					);
				} else { // It's ready!
					// Does the conversion exist already?
					// (For upsells which will already exist, of course, so we should make sure there are no duplicates)
					$conversion = getRow("SELECT `date` FROM {$evp->options->prefix}conversions WHERE `file_id` = '{$file_ref}' && `ip` = '{$user->ip}' && `converted` = '0' && `date` >= '{$window_start}'");

					if(!$conversion && $isUpsell) { // Insert a conversion entry for later!
						query("INSERT INTO {$evp->options->prefix}conversions (`file_id`, `converted`, `date`, `name`, `price`, `upsell`, `ip`, `country`, `region`, `city`) VALUES ('{$file_ref}', '0', '{$now}', '{$product_name}', '{$product_price}', '1', '{$user->ip}', '{$user->country_name}', '{$user->region_name}', '{$user->city}')");
					}

					$apiData = array(
						'success' => true,
						'product_name' => $product_name,
						'product_price' => $product_price,
						'isUpsell' => $isUpsell
					);
				}
			}
		}

		$api->setResponseData($apiData)->respond();
		break;
	case 'public-statistics-convert':
		$file_ref = $_REQUEST['file_ref'];
		$file = $evp->getFile($file_ref);

		// This is cryptic because it's public!
		$conversion_data = json_decode(base64_decode(trim($_REQUEST['c'])));

		if(!$file) {
			$apiData = array(
				'success' => false,
				'message' => 'The file you specified cannot be identified.'
			);
		} elseif(empty($conversion_data)) {
			$apiData = array(
				'success' => false,
				'message' => 'The conversion information you specified was invalid.'
			);
		} else {
			$user = $evp->statistics->getUserData(getRemoteIP());

			// Extract the conversion information
			$product_name = trim($conversion_data->n);
			$product_price = floatval(string_float($conversion_data->p));
			$isUpsell = !(empty($conversion_data->u));

			// Has this person reached at least a 'progress' of 3, OR a completion? (To allow for skipping)
			// within the past 3 hours?
			// Unfortunately we must use IP instead of UUID
			$now = gmdate('Y-m-d H:i:s');
			$window_start = gmdate('Y-m-d H:i:s', gmstrtotime('-3 hours'));
			$userCompletion = getRow("SELECT `ip` FROM {$evp->options->prefix}track_total_completes WHERE `file_ref` = '{$file_ref}' && `ip` = '{$user->ip}' && `time` >= '{$window_start}' LIMIT 1");
			if(!$userCompletion) {
				$userProgress = grab(getRow("SELECT MAX(`player_time`) AS progress FROM {$evp->options->prefix}track_progression WHERE `file_ref` = '{$file_ref}' && `ip` = '{$user->ip}' && `time` >= '{$window_start}' LIMIT 1"), 'progress');
			}

			// Does the main conversion exist already?
			// (This only returns main conversion entries, not upsells, which are marked in a few lines)
			$conversion = getRow("SELECT `date`, `converted` FROM {$evp->options->prefix}conversions WHERE `file_id` = '{$file_ref}' && `upsell` = '0' && `ip` = '{$user->ip}' && `date` >= '{$window_start}'");

			if((!$userCompletion && !$userProgress) || (!$userCompletion && $userProgress < 2) || ($conversion && $conversion->converted == 1)) {
				$apiData = array(
					'success' => false,
					'message' => ($userCompletion ? 'The user has already performed a conversion for this product and will not be counted twice.' : 'The user specified has not completed enough of the video to complete a conversion.')
				);
			} else { // It's ready!

				if(!$conversion && !$isUpsell) { // Insert a conversion and, might as well mark it as converted here too
					query("INSERT INTO {$evp->options->prefix}conversions (`file_id`, `converted`, `date`, `name`, `price`, `upsell`, `ip`, `country`, `region`, `city`) VALUES ('{$file_ref}', '1', '{$now}', '{$product_name}', '{$product_price}', '0', '{$user->ip}', '{$user->country_name}', '{$user->region_name}', '{$user->city}')");
				}

				// Mark all the appropriate conversions as converted - including previously inserted upsells
				query("UPDATE {$evp->options->prefix}conversions SET `converted` = '1' WHERE `file_id` = '{$file_ref}' && `ip` = '{$user->ip}' && `converted` = '0' && `date` >= '{$window_start}'");

				$apiData = array(
					'success' => true,
					'product_name' => $product_name,
					'product_price' => $product_price,
					'isUpsell' => $isUpsell
				);
			}
		}

		$api->setResponseData($apiData)->respond();
		break;
	case 'public-load-widget': // Response type here is always HTML
		$file_ref = $_REQUEST['file_ref'];
		$file = $evp->getFile($file_ref);

		if(!$file) {
			return false;
		}

		$profile = explode('::', $file_ref, 2);
		if(!empty($profile) && !empty($profile[1])) $profile = $profile[1];
		else $profile = '';

		if(!empty($_REQUEST['profile'])) {
			$file_ref.= "::{$_REQUEST['profile']}";
			$profile = $_REQUEST['profile'];
		}

		$file_settings = $evp->collateFileSettings($file, $profile);

		$event_name = makeReadable(grab(explode('::', $_REQUEST['widget_ref'], 2), 0));
		$widget_idx = grab(explode('::', $_REQUEST['widget_ref'], 2), 1);

		if(empty($file_settings->events)) return false;

		$theKey = false;
		foreach($file_settings->events as $k => $v) {
			if(strtolower($k) == strtolower($event_name)) {
				$theKey = $k;
			}
		}

		if(empty($theKey)) return false;

		if(empty($file_settings->events[$theKey]['data']['widgets'][$widget_idx])) return false;

		$showDoctype = (stripos($file_settings->events[$theKey]['data']['widgets'][$widget_idx]['body'], '<!DOCTYPE') === false);

		$formCode = $file_settings->events[$theKey]['data']['widgets'][$widget_idx]['body'];

		$formCode = str_ireplace(array('target="_blank"', 'target="_self"', 'target="_parent"', 'target="_top"'), '', $formCode);

		if($showDoctype) echo '<!DOCTYPE html><html><head><title></title></head><body>';

		echo '<div id="evp-widget-subiframe-'.$_REQUEST['widget_ref'].'">';
		echo $formCode;
		echo '</div>';

		if($showDoctype) echo '</body></html>';

		break;
	case 'public-file-images':
	case 'public-file-metadata':
		$apiData = array();

		if(!empty($_REQUEST['page_url'])) {
			$urlquery = parse_url(urldecode($_REQUEST['page_url']), PHP_URL_QUERY);
			if(empty($urlquery)) {
				$urldata = explode('/', trim(urldecode($_REQUEST['page_url']), '/'));
				$url_pageseed = array_pop($urldata);
				if(stripos($url_pageseed, '?') !== false) $url_pageseed = array_pop($urldata); // Do it again if any parameters in there
				// Now, let's look up the file_ref via the page seed
				$located_file = getRow("SELECT `file_id` FROM {$evp->options->prefix}files_data WHERE `key` = 'data[page_seed]' && `value`= '{$url_pageseed}'");
				$file_ref = $located_file->file_id;
			} else {
				parse_str($urlquery, $urldata);
				$file_ref = $urldata['file_ref'];
			}
			$parts = explode('::', $file_ref, 2);
			$file_id = $parts[0];
			$profile = $parts[1];
		} else {
			$file_ref = $_REQUEST['file_ref'];
			$profile = explode('::', $file_ref, 2);
			if(!empty($profile) && !empty($profile[1])) $profile = $profile[1];
			else $profile = '';

			if(!empty($_REQUEST['profile'])) {
				$file_ref.= "::{$_REQUEST['profile']}";
				$profile = $_REQUEST['profile'];
			}
		}

		$file = $evp->getFile($file_ref);

		if(!$file) {
			$apiData = array(
				'success' => false,
				'message' => 'The file you are trying to identify could not be found.'
			);
		} else {
			$file_settings = $evp->collateFileSettings($file, $profile);

			$secure = false;
			if($file_settings->options['security_enabled'] == true) {
				$secure = true;
			}

			$skin = pick($file_settings->options['skin'], 'minima');
			$related_image = url("player/assets/jwplayer-5.10/skins/{$skin}/{$skin}.png");
			$related_image_width = 540;
			$related_image_height = 280;
			if(!empty($file_settings->options['related_image']) && $file_settings->options['related_image'] != url('player/images/no-image.png?v=1', false, true)) {
				$related_image = $file_settings->options['related_image'];
				if(!empty($file_settings->options['splash_width'])) $related_image_width = intval($file_settings->options['splash_width']);
				if(!empty($file_settings->options['splash_height'])) $related_image_height = intval($file_settings->options['splash_height']);
			}

			$apiData['success'] = true;
			$apiData['splash'] = $related_image;
			$apiData['splash_width'] = $related_image_width;
			$apiData['splash_height'] = $related_image_height;
			$apiData['duration'] = $file->metadata['duration'];
			$apiData['duration-string'] = secondsToHMS($file->metadata['duration']);
			$apiData['video_width'] = pick($file_settings->options['width']);
			$apiData['video_height'] = pick($file_settings->options['height']);

			if(!$secure) {
				$apiData['content_loc'] = ($file->source == 2 ? $evp->s3->getUrl($file->file_name, 315569260) : $file->location);
				$apiData['player_loc'] = $evp->videoEmbedCode($file, 'sd', false, false, 'url');
			}

			// Are there thumbnails we could expose?
			$apiData['thumbnails'] = array();
			if(!empty($file->thumbnail_count) && !$secure) {
				for($thumbnail_i = 0; $thumbnail_i <= ($file->thumbnail_count - 1); $thumbnail_i++) {
					$thumb = str_replace('.'.$file->extension, '', $file->raw_location).'-thumbnail-'.$thumbnail_i.'.jpg';
					if($config['locations']['protocol'] == 'https') $thumb = str_replace('http://', 'https://', $thumb); // SSL support
					$apiData['thumbnails'][] = $thumb;
					if($thumbnail_i == 0) $apiData['thumbnail'] = $thumb;
				}
			}
		}

		$api->setResponseData($apiData)->respond();
		break;
	case 'user-authenticate':
		if($user = $evp->api->authenticate($_REQUEST['username'], $_REQUEST['password'])) {
			$apiData = array(
				'success' => true,
				'username' => $user->username,
				'project_location' => trim(url(), '/'),
				'api_location' => url('api.php'),
				'api_version' => $evp->options->project_version,
				'data' => $user
			);
		} else {
			$apiData = array(
				'success' => false,
				'message' => 'Invalid username or password provided.'
			);
		}
		$api->setResponseData($apiData)->respond();
		break;
	case 'ui-enable-webuploader':
		if($user = $evp->api->authenticate($_REQUEST['username'], $_REQUEST['password'])) {

			$evp->updateSetting('enable_webuploader', '1');

			$apiData = array(
				'success' => true,
				'message' => 'Enabled the web-based uploader successfully.'
			);
		} else {
			$apiData = array(
				'success' => false,
				'message' => 'Cannot authenciate this request.'
			);
		}
		$api->setResponseData($apiData)->respond();
		break;
	case 'ui-disable-webuploader':
		if($user = $evp->api->authenticate($_REQUEST['username'], $_REQUEST['password'])) {

			$evp->updateSetting('enable_webuploader', '0');

			$apiData = array(
				'success' => true,
				'message' => 'Disabled the web-based uploader successfully.'
			);
		} else {
			$apiData = array(
				'success' => false,
				'message' => 'Cannot authenciate this request.'
			);
		}
		$api->setResponseData($apiData)->respond();
		break;
	case 's3-list-buckets':
		$user = $evp->api->authenticate($_REQUEST['username'], $_REQUEST['password']);
		if($user) {
			if(!$evp->s3) {
				$apiData = array(
					'success' => false,
					'message' => 'Your account is not configured to use Amazon S3.'
				);
			} else {

				// Buckets
			//$buckets = $evp->s3->remote->listBuckets(false);
				$raw = $evp->s3->aws->s3->list_buckets();
				$buckets = array();

				foreach($raw->body->Buckets->Bucket as $b) {
					$buckets[] = (string)$b->Name;
				}

				// Response
				$apiData = array(
					'success' => true,
					'buckets' => $buckets
				);
			}

			// Respond!
			$api->setResponseData($apiData)->respond();
		} else {
			api_authenticate_failed();
		}
		break;
	case 'integrate-details':
		$user = $evp->api->authenticate($_REQUEST['username'], $_REQUEST['password']);
		if($user) {
			$apiData = array(
				'success' => true,
				'version' => $evp->options->project_version,
				'api_location' => url('api.php'),
				'project_location' => trim(url(), '/'),
				'site_name' => $evp->settings->site_name,
				'mod_rewrite' => $evp->mod_rewrite,
				'oembed_support' => true,
				'coverphoto_support' => true,
				'using_s3' => false,
				'using_cloudfront' => false
			);

			if($evp->s3) {
				$apiData['using_s3'] = true;
				$apiData['s3_accesskey'] = $evp->settings->s3_accesskey;
				$apiData['s3_secretkey'] = $evp->settings->s3_secretkey;
				$apiData['s3_bucket'] = $evp->settings->s3_bucket;

				if(!empty($evp->settings->s3_bucket_endpoint)) $apiData['s3_bucket_endpoint'] = $evp->settings->s3_bucket_endpoint;
			}

			if($evp->cloudfront) {
				$apiData['using_cloudfront'] = true;
				$apiData['cf_distribution'] = $evp->settings->cloudfront_distribution;
				$apiData['cf_domain'] = $evp->settings->cloudfront_domain;
			}

			if($evp->local) {
				$apiData['using_local'] = true;
				$apiData['hosting_local'] = true;
				$apiData['hosting_local_path'] = $config['paths']['base'].'/assets/videos/';
			}

			$api->setResponseData($apiData)->respond();
		} else {
			api_authenticate_failed();
		}
		break;
	case 's3-copy':
		$user = $evp->api->authenticate($_REQUEST['username'], $_REQUEST['password']);
		if($user) {
			if(!$evp->s3) {
				$apiData = array(
					'success' => false,
					'message' => 'Your account is not configured to use Amazon S3.'
				);
			} else {

				$target_name = trim($_REQUEST['target_name']);
				$source = trim($_REQUEST['source']);
				$folder_id = trim($_REQUEST['folder_id']);

				if($evp->cloudfront) {
					$perm = AmazonS3::ACL_PUBLIC;
				} else {
					$perm = AmazonS3::ACL_PRIVATE;
				}

			//if($evp->s3->remote->copyObject($source, $target_name, $evp->settings->s3_bucket, $target_name, $perm)) {
				$copied = $evp->s3->aws->s3->copy_object(array('bucket' => $source, 'filename' => $target_name), array('bucket' => $evp->settings->s3_bucket, 'filename' => $target_name), array('acl' => $perm));

				if($copied->isOK()) {
					// Insert into the folder
					if(!empty($folder_id)) {
						$file_id = base64_encode($target_name);
						query("INSERT INTO {$evp->options->prefix}folders_relationships (`folder_id`, `file_id`) VALUES ('{$folder_id}', '{$file_id}')");
						query("UPDATE {$evp->options->prefix}folders SET `file_count` = `file_count` + 1 WHERE `id` = '{$folder_id}' LIMIT 1");
					}

					$apiData = array(
						'success' => true,
						'file_id' => $file_id,
						'request_id' => $_REQUEST['request_id'] // This is only used for highlighting - not by this bit itself
					);
				} else {
					$apiData = array(
						'success' => false,
						'request_id' => $_REQUEST['request_id']
					);
				}
			}

			// Respond!
			$api->setResponseData($apiData)->respond();
		} else {
			api_authenticate_failed();
		}
		break;
	case 's3-set-acl':
		$user = $evp->api->authenticate($_REQUEST['username'], $_REQUEST['password']);
		if($user) {
			if(!$evp->s3) {
				$apiData = array(
					'success' => false,
					'message' => 'Your account is not configured to use Amazon S3.'
				);
			} else {

				$target_name = trim($_REQUEST['target_name']);
				$direction = trim($_REQUEST['set']);
				if($direction == 'public') {
					$perm = 'READ';//S3_STD::ACL_PUBLIC_READ;
				} else {
					$perm = 'FULL_CONTROL';//S3_STD::ACL_PRIVATE;
				}

				/*
				$acp = $evp->s3->remote->getAccessControlPolicy($evp->settings->s3_bucket, $target_name);

				if($perm == 'READ') {
					$acp['acl'][] = array(
						'type' => 'Group',
						'uri' => 'http://acs.amazonaws.com/groups/global/AllUsers',
						'permission' => $perm
					);
				} else {
					foreach($acp['acl'] as $idx => $details) {
						if($details['uri'] == 'http://acs.amazonaws.com/groups/global/AllUsers') unset($acp['acl'][$idx]);
					}
				}

				$correctly_set = $evp->s3->remote->setAccessControlPolicy($evp->settings->s3_bucket, $target_name, $acp);
				*/

				if($perm == 'READ') {
					$acp = AmazonS3::ACL_PUBLIC;
				} else {
					$acp = AmazonS3::ACL_AUTH_READ;
				}

				try {
					$response = $evp->s3->aws->s3->set_object_acl($evp->settings->s3_bucket, $target_name, $acp);
				} catch(Exception $e) {
					//
				}

				$correctly_set = $response->isOK();

				if($correctly_set) {

					$apiData = array(
						'success' => true,
						'request_id' => $_REQUEST['request_id'] // This is only used for highlighting - not by this bit itself
					);
				} else {
					$apiData = array(
						'success' => false,
						'request_id' => $_REQUEST['request_id']
					);
				}
			}

			// Respond!
			$api->setResponseData($apiData)->respond();
		} else {
			api_authenticate_failed();
		}
		break;
	case 's3-set-contentdisposition':
		$user = $evp->api->authenticate($_REQUEST['username'], $_REQUEST['password']);
		if($user) {
			if(!$evp->s3) {
				$apiData = array(
					'success' => false,
					'message' => 'Your account is not configured to use Amazon S3.'
				);
			} else {

				$target_name = trim(str_replace(';', '-', $_REQUEST['target_name']));

				try {
					$response = $evp->s3->aws->s3->update_object($evp->settings->s3_bucket, $target_name, array(
						'headers' => array(
							'Content-Disposition' => 'attachment; filename='.$target_name
						)
					));
				} catch(Exception $e) {
					//
				}

				$correctly_set = $response->isOK();

				if($correctly_set) {

					$apiData = array(
						'success' => true,
						'target_name' => $target_name,
						'request_id' => $_REQUEST['request_id'] // This is only used for highlighting - not by this bit itself
					);
				} else {
					$apiData = array(
						'success' => false,
						'request_id' => $_REQUEST['request_id']
					);
				}
			}

			// Respond!
			$api->setResponseData($apiData)->respond();
		} else {
			api_authenticate_failed();
		}
		break;
	case 'files-available-name':
		$user = $evp->api->authenticate($_REQUEST['username'], $_REQUEST['password']);
		if($user) {
			// Ok let's do this
		//$evp->primeFileCache();
			$existing_files = flattenByKey(getArray("SELECT `file_name` FROM {$evp->options->prefix}files WHERE `source` != '3' && `parent_id` IS NULL"), 'file_name');
			if(empty($existing_files)) $existing_files = array();

			$original_base_name = escape(urldecode($_REQUEST['base_name']));
			$base_name = $original_base_name;
			$ext = getExtension($base_name);

			// Let's truncate base_name here, to stop crazy problems uploading big file names
			if(strlen($base_name) >= 50) {
				$base_name = substr($base_name, 0, 50).'.'.$ext;
			}

			$file_name = $base_name;

			$name = str_replace('.'.$ext, '', $base_name);
			$x = 1;

			while(in_array($file_name, $existing_files) !== false) { // Do we need to rename the file
				$file_name = $name.'-'.$x.'.'.$ext;
				$x++;
			}

			$apiData = array(
				'success' => true,
				'original_file_name' => $original_base_name,
				'base_name' => $base_name,
				'file_name' => $file_name
			);

			// Respond!
			$api->setResponseData($apiData)->respond();
		} else {
			api_authenticate_failed();
		}
		break;
	case 'files-list-complete': // Returns a tree-structure of files and folders
		$user = $evp->api->authenticate($_REQUEST['username'], $_REQUEST['password']);
		if($user) {
			$evp->primeFileCache();

			$getProfiles = ($_REQUEST['getProfiles'] == true);

			// Get the folder tree
			$folders = $evp->getFoldersAsTree(true);

			// Now we'll grab the files in each one
			function evp_api_private_filesmap(&$folder) {
				global $evp, $evp_api, $getProfiles;
				$these = $evp->getFiles($folder->id);
				if(!empty($these)) {
					foreach($these as &$f) {
						unset($f->options, $f->page_widgets, $f->plugins, $f->widgets, $f->events, $f->chapters);
						if($getProfiles) {
							$f->profiles = $evp->getProfiles($f->id);
						}
					}
				}
				$folder->files = $these;
				if(!empty($folder->subfolders)) {
					foreach($folder->subfolders as $sf) {
						evp_api_private_filesmap($sf);
					}
				}
			}

			if(!empty($folders)) {
				foreach($folders as $f) {
					evp_api_private_filesmap($f);
				}
			}

			// Response
			$apiData = array(
				'success' => true,
				'version' => '3.0',
				'folders' => $folders,
				'folders_count' => sizeof($folders)
			);

			// Respond!
			$api->setResponseData($apiData)->respond();
		} else {
			api_authenticate_failed();
		}
		break;
	case 'files-list':
		$user = $evp->api->authenticate($_REQUEST['username'], $_REQUEST['password']);
		if($user) {
		//$evp->primeFileCache();

			// Is it a client? If so, let's restrict to only their folders
			if($user->isClient) {
				$initial_folder = $user->assigned_folder_id[0];
				$allClientsFolders = $user->assigned_folder_id;
			}

			if($_REQUEST['folder_id']) $folder = escape($_REQUEST['folder_id'], true);
			elseif($user->isClient) $folder = $initial_folder;

			if($user->isClient && !in_array($folder, $allClientsFolders)) {
				$apiData = array(
					'success' => false,
					'message' => 'You do not have permissions to view the requested folder!',
					'folder_id' => $folder
				);
			} else {
				$files = $evp->getFiles($folder);

				if($folder) $folder = $evp->getFolder($folder);

				$getProfiles = ($_REQUEST['getProfiles'] == true);

				// Remove some unnecessary info about files
				if(!empty($files)) {
					foreach($files as &$file) {
						unset($file->options, $file->events, $file->chapters, $file->page_widgets, $file->stats, $file->widgets, $file->data);
						if($getProfiles) {
							$file->profiles = $evp->getProfiles($file->id);
						}
					}
				}

				// Include the list of folders
				$folders = $evp->getFolders();

				// If we're a client, trim to remove non-accessible folders
				if($user->isClient) {
					foreach($folders as $idx => $folder) {
						if(!in_array($folder->id, $allClientsFolders)) {
							unset($folders[$idx]);
						}
					}
				}

				$total_files = grab(getRow("SELECT COUNT(`id`) AS total FROM {$evp->options->prefix}files WHERE `parent_id` IS NULL"), 'total');
				$total_in_folders = grab(getRow("SELECT SUM(`file_count`) AS total FROM {$evp->options->prefix}folders"), 'total');
				$uncatfiles = $total_files - $total_in_folders;

				// Response
				$apiData = array(
					'success' => true,
					'version' => '3.0',
					'isClient' => $user->isClient,
					'files' => $files,
					'folder' => $folder,
					'folders' => $folders,
					'files_count' => sizeof($files),
					'folders_count' => sizeof($folders),
					'uncategorised_files' => $uncatfiles
				);
			}

			// Respond!
			$api->setResponseData($apiData)->respond();
		} else {
			api_authenticate_failed();
		}
		break;
	case 'files-list-folders':
		$user = $evp->api->authenticate($_REQUEST['username'], $_REQUEST['password']);
		if($user) {
			$parent = 0;
			if(!empty($_REQUEST['parent']) && is_numeric($_REQUEST['parent'])) $parent = escape($_REQUEST['parent'], true);
			$folders = $evp->getFolders($parent);

			$apiData = array(
				'success' => true,
				'folders' => $folders
			);

			// Respond!
			$api->setResponseData($apiData)->respond();
		} else {
			api_authenticate_failed();
		}
		break;
	case 'files-associate-folder':
		$user = $evp->api->authenticate($_REQUEST['username'], $_REQUEST['password']);
		if($user) {

			$folder_id = escape($_REQUEST['folder_id']);
			$file_ref = escape($_REQUEST['file_ref']); // No profiles as it's global

			// Does the folder exist?
			$folder = $evp->getFolder($folder_id);
			if(!$folder && $folder_id != 0) {
				$apiData = array(
					'success' => false,
					'message' => 'This folder does not exist.'
				);
				$api->setResponseData($apiData)->respond();
			} else {
				$modifiedFolders = array();

				$id = escape($file_ref, true);
				$folder_id = escape($folder_id, true);

				$modified = getRow("SELECT `folder_id` FROM {$evp->options->prefix}folders_relationships WHERE `file_id` = '{$id}'");
				if(!empty($modified)) $modifiedFolders[] = $modified->folder_id;
				query("DELETE FROM {$evp->options->prefix}folders_relationships WHERE `file_id` = '{$id}'");

				if(!empty($folder_id)) {
					query("INSERT INTO {$evp->options->prefix}folders_relationships (`file_id`, `folder_id`) VALUES ('{$id}', '{$folder_id}')");
				}

				$modifiedFolders = array_unique($modifiedFolders);

				foreach($modifiedFolders as $f) query("UPDATE {$evp->options->prefix}folders SET `file_count` = `file_count` - 1 WHERE `id` = '{$f}' LIMIT 1");

				query("UPDATE {$evp->options->prefix}folders SET `file_count` = `file_count` + 1 WHERE `id` = '{$folder_id}' LIMIT 1");

				$apiData = array(
					'success' => true,
					'message' => 'This file has been associated with this folder successfully.'
				);

				// Respond!
				$api->setResponseData($apiData)->respond();
			}
		} else {
			api_authenticate_failed();
		}
		break;
	case 'folders-new':
		$user = $evp->api->authenticate($_REQUEST['username'], $_REQUEST['password']);
		if($user) {
			$name = escape($_REQUEST['name']);
			$parent_id = 0;
			if(!empty($_REQUEST['parent_id']) && is_numeric($_REQUEST['parent_id'])) $parent_id = escape($_REQUEST['parent_id']);

			$id = $evp->api->folders_create($name, $parent_id);

			if($id) {
				$apiData = array(
					'success' => true,
					'message' => 'This folder has been created successfully.',
					'name' => $name,
					'id' => $id,
					'parent_id' => $parent_id
				);
			} else {
				$apiData = array(
					'success' => false,
					'message' => 'This folder could not be created.'
				);
			}

			// Respond!
			$api->setResponseData($apiData)->respond();
		} else {
			api_authenticate_failed();
		}
		break;
	case 'files-delete-statistics':
		$user = $evp->api->authenticate($_REQUEST['username'], $_REQUEST['password']);
		if($user) {

			$file_ref = $_REQUEST['file_ref'];

			$file = $evp->getFile($file_ref);

			if($file) {
				query("DELETE FROM {$evp->options->prefix}track_progression WHERE `file_ref` = '{$file_ref}'");
				query("DELETE FROM {$evp->options->prefix}track_static WHERE `file_ref` = '{$file_ref}'");
				query("DELETE FROM {$evp->options->prefix}track_total_completes WHERE `file_ref` = '{$file_ref}'");
				query("DELETE FROM {$evp->options->prefix}track_total_starts WHERE `file_ref` = '{$file_ref}'");
				query("DELETE FROM {$evp->options->prefix}track_unique_completes WHERE `file_ref` = '{$file_ref}'");
				query("DELETE FROM {$evp->options->prefix}track_unique_starts WHERE `file_ref` = '{$file_ref}'");
				query("DELETE FROM {$evp->options->prefix}conversions WHERE `file_id` = '{$file_ref}'");
				query("DELETE FROM {$evp->options->prefix}files_data WHERE `file_id` = '{$file_ref}' && `key` = 'social_stats'");
				query("DELETE FROM {$evp->options->prefix}files_data WHERE `file_id` = '{$file_ref}' && `key` = 'stats'");

				$apiData = array(
					'success' => true,
					'message' => 'Your statistics have been deleted successfully.'
				);
			} else {
				$apiData = array(
					'success' => false,
					'message' => 'This file could not be identified.'
				);
			}

			// Respond!
			$api->setResponseData($apiData)->respond();
		} else {
			api_authenticate_failed();
		}
		break;
	case 'files-livestats':
		$user = $evp->api->authenticate($_REQUEST['username'], $_REQUEST['password']);
		if($user) {

			$file_ref = $_REQUEST['file_id'];
			$profile = explode('::', $file_ref, 2);
			if(!empty($profile) && !empty($profile[1])) $profile = $profile[1];
			else $profile = '';

			if(!empty($_REQUEST['profile'])) {
				$file_ref.= "::{$_REQUEST['profile']}";
				$profile = $_REQUEST['profile'];
			}

			$file = $evp->getFile($file_ref);

			// Get the file statistics
			$stats = $evp->statistics->getStats($file_ref);
		//$stats->conversions = $evp->statistics->getConversions($file_ref, $floor);
		//$progression = $evp->statistics->getProgressionData($file_ref, false, false, $floor);

			// Work out the average drop-off time
			$average_drop_off = $evp->statistics->averageDropOff($file_ref);

			// And the settings, for the skin preview
			$file_settings = $evp->collateFileSettings($file, $profile);
			if(empty($file_settings->options['skin'])) $file_settings->options['skin'] = 'minima';

			// And now let's grab the stats object
			$social_stats = $evp->getDataKey('stats', $file_ref, 'files');
			if(!empty($social_stats)) $social_stats = @json_decode($social_stats);

			// Right, that's everything so let's respond
			$apiData = array(
				'success' => true,
				'file_id' => $file->id,
				'file_profile' => $profile,
				'file_ref' => $file_ref,
				'stats' => $stats,
				'social_stats' => $social_stats,
				'average_drop_off' => $average_drop_off,
				'average_drop_off_str' => secondsToHMS($average_drop_off),
				'progression' => $progression
			);

			$apiData['md5'] = md5(print_r($apiData, true)); // This will only change if the stats do!

			// Build phrases from this collection
		//$apiData['phrases'] = $evp->statistics->getPhrases($file_ref, $apiData);

			// Let's get the most recent viewer
		//$apiData['mostRecentStart'] = $evp->statistics->getMostRecentStart($file_ref);
			$apiData['mostRecentComplete'] = $evp->statistics->getMostRecentComplete($file_ref);

			// Let's grab live data
		//$apiData['livedata'] = $evp->statistics->getLiveData($file_ref, $apiData, $_REQUEST['livedata']);

			$apiData['file'] = $file;
			$apiData['file_settings'] = $file_settings;

			/*
			$config = Registry::retrieve('config');
			$database = Registry::retrieve('database');
			file_put_contents($config['paths']['base'].'/assets/cache/log.txt', implode($database->getQueries(), "\n"));
			*/

			// Respond!
			$api->setResponseData($apiData)->respond();
		} else {
			api_authenticate_failed();
		}
		break;
	case 'files-embed-code':
	case 'files-embedcode': // compat with 2.x
		$user = $evp->api->authenticate($_REQUEST['username'], $_REQUEST['password']);
		if($user) {
		//$evp->primeFileCache();

			$file_ref = $_REQUEST['file_id'];
			if(!empty($_REQUEST['profile'])) $file_ref.= "::{$_REQUEST['profile']}";

			$file = $evp->getFile($file_ref);
			if(!$file) {
				$evp->primeFileCache(array('source' => 's3', 'file_name' => base64_decode($_REQUEST['file_id']))); // Update the cache as it doesn't exist
				$file = $evp->getFile($file_ref);
			}
			$file_settings = $evp->collateFileSettings($file, $profile);

			$embed_code = $evp->api->files_embed_code($_REQUEST['file_id'], $_REQUEST['profile']);

			if($file) {
				// Response
				$apiData = array(
					'success' => true,
					'page_url' => $file->page_url,
					'embed_code' => $embed_code
				);
			} else {
				// Response
				$apiData = array(
					'success' => false,
					'file_ref' => base64_decode($_REQUEST['file_id']),
					'otherRequestInfo' => $_REQUEST,
					'message' => "{$evp->options->project_name} cannot locate the file you are trying to utilise. This usually means that something went wrong during the upload.\n\nPlease re-try uploading the video with a different name.\n\nThe file you uploaded was called \"".base64_decode($_REQUEST['file_id'])."\""
				);
			}

			// Respond!
			$api->setResponseData($apiData)->respond();
		} else {
			api_authenticate_failed();
		}
		break;
	case 'files-associate-thumbnails':
		$user = $evp->api->authenticate($_REQUEST['username'], $_REQUEST['password']);
		if($user) {

			$file_ref = escape($_REQUEST['file_id']); // No profiles as it's global

			$file = $evp->getFile($file_ref);
			if(!$file) {
				$evp->primeFileCache(array('source' => 's3', 'file_name' => $file_ref)); // Update the cache as it doesn't exist
				$file = $evp->getFile($file_ref);
			}

			// If this is a user, we need to perform a move into a new folder called [user names]'s Videos
			// This must be created if it doesn't exist
			// It's not ideal to do it in here, but it will work and possibly we will look at adding a specific call later
			// to declare, in the EVS app, 'Oh I have uploaded this file'
			if($user->group->name == 'Users' || $user->group->name == 'Clients') {
				$folder_username = grab(explode('@', $user->username, 2), 0);
				if(empty($folder_username)) $folder_username = $user->username;
				$folder_username = ucwords($folder_username)."'s Videos";
				$folder = $evp->getMySQLObject($folder_username, 'folders', 'name', false);
				if(!$folder) {
					$folder_id = $evp->api->folders_create($folder_username, false);
					$folder = $evp->getMySQLObject($folder_id, 'folders', 'id', false);
				}
				// Let's always associate that with this user, just in case
				if($folder) {
					$current_folders = $user->assigned_folder_id;
					array_push($current_folders, $folder->id);
					query("DELETE FROM {$evp->options->prefix}users_data WHERE `user_id` = '{$user->id}' && `key` = 'assigned_folder_id'");
					query("INSERT INTO {$evp->options->prefix}users_data (`user_id`, `key`, `value`) VALUES ('{$user->id}', 'assigned_folder_id', '".json_encode($current_folders)."')");

					// Now let's put this file in the folder
					query("DELETE FROM {$evp->options->prefix}folders_relationships WHERE `file_id` = '{$file_ref}'");
					query("INSERT INTO {$evp->options->prefix}folders_relationships (`file_id`, `folder_id`) VALUES ('{$file_ref}', '{$folder->id}')");

					// And update the static folder counter
					query("UPDATE {$evp->options->prefix}folders SET `file_count` = `file_count` + 1 WHERE `id` = '{$folder->id}'");
				}
			}

			$number_of_thumbnails = string_numbers($_REQUEST['thumbnail_count']);

			if($file && !empty($number_of_thumbnails)) {

				$evp->insertDataKey('thumbnail_count', $number_of_thumbnails, $file_ref, 'file');

				$hasModified = false;

				// Let's now check to see if there's a related image - if not, set the first thumbnail as it
				if((empty($file->options['related_image']) || $file->options['related_image'] == url('player/images/no-image.png?v=1', false, true)) && !empty($number_of_thumbnails)) {
					$thumbnail = str_replace('.'.$file->extension, '', $file->raw_location).'-thumbnail-0.jpg';
					$file->options['related_image'] = $thumbnail;
					$file->options['splash_width'] = 250;
					$file->options['splash_height'] = 141;
				}

				if($hasModified) $evp->api->files_setdata($file->id, array('options' => $file->options), array('options'));

				// Response
				$apiData = array(
					'success' => true
				);
			} else {
				// Response
				$apiData = array(
					'success' => false,
					'message' => 'The file you chose could not be identified or the number of thumbnails was not valid.'
				);
			}

			// Respond!
			$api->setResponseData($apiData)->respond();
		} else {
			api_authenticate_failed();
		}
		break;
	case 'files-associate-coverphoto':
		$user = $evp->api->authenticate($_REQUEST['username'], $_REQUEST['password']);
		if($user) {

			$file_ref = escape($_REQUEST['file_id']); // No profiles as it's global

			$file = $evp->getFile($file_ref);
			if(!$file) {
				$evp->primeFileCache(array('source' => 's3', 'file_name' => $file_ref)); // Update the cache as it doesn't exist
				$file = $evp->getFile($file_ref);
			}

			if($file) {

				$coverlocation = str_replace('.'.$file->extension, '', $file->raw_location).'-coverphoto.jpg'; // Never hard-coded anywhere

				$evp->insertDataKey('coverphoto', true, $file_ref, 'file');

				// Let's now check to see if there's a related image - if not, or it's just the thumbnail, let's set this as it
				/*
				if((empty($file->options['related_image']) || $file->options['related_image'] == url('player/images/no-image.png?v=1', false, true))) {
					$thumbnail = str_replace('.'.$file->extension, '', $file->raw_location).'-thumbnail-0.jpg';
					$file->options['related_image'] = $thumbnail;
					$file->options['splash_width'] = 250;
					$file->options['splash_height'] = 141;
				}
				*/

				if($hasModified) $evp->api->files_setdata($file->id, array('options' => $file->options), array('options'));

				// Response
				$apiData = array(
					'success' => true
				);
			} else {
				// Response
				$apiData = array(
					'success' => false,
					'message' => 'The file you chose could not be identified.'
				);
			}

			// Respond!
			$api->setResponseData($apiData)->respond();
		} else {
			api_authenticate_failed();
		}
		break;
	case 'files-associate-child': // This one assumes the child is an already-uploaded video
		$user = $evp->api->authenticate($_REQUEST['username'], $_REQUEST['password']);
		if($user) {

			$file_ref = escape($_REQUEST['file_id']); // No profiles as it's global
			$now = gmtime();
			$child_ref = escape($_REQUEST['child_id']);
			$child_type = trim(escape($_REQUEST['type'], true));

			$file = $evp->getFile($file_ref);
			$child = $evp->getFile($child_id);

			if(!$file) {
				$api->setResponseData(array('success' => false, 'message' => 'The main file you specified cannot be identified.'))->respond();
				return;
			}

			if(!$child) {
				$api->setResponseData(array('success' => false, 'message' => 'The child file you specified cannot be identified.'))->respond();
				return;
			}

			$yes = query("UPDATE {$evp->options->prefix}files SET `parent_id` = '{$file_id}' && `child_type` = '{$child_type}' WHERE `id` = '{$child_ref}'");

			if(!$yes) { // Why would this ever fail?
				$apiData = array(
					'success' => false,
					'message' => 'The child you have specified does not appear to be uploaded properly.'
				);
			} else {
				$apiData = array(
					'success' => true,
					'message' => 'The child video has been associated with the parent successfully.'
				);
			}

			// Respond!
			$api->setResponseData($apiData)->respond();
		} else {
			api_authenticate_failed();
		}
		break;
	case 'files-append-child':
		$user = $evp->api->authenticate($_REQUEST['username'], $_REQUEST['password']);
		if($user) {

			$file_ref = escape($_REQUEST['file_id']); // No profiles as it's global
			$now = gmtime();
			$child_file_name = escape(trim($_REQUEST['child_name']));
			$child_extension = getExtension($child_file_name);
			$child_name = str_replace('.'.$child_extension, '', $child_file_name);
			$child_location = 'http://'.$evp->settings->s3_bucket.'.s3.amazonaws.com/'.$child_file_name;
			$child_ref = base64_encode($child_file_name);
			$child_type = trim(escape($_REQUEST['type'], true));

			// Let's assume that if this API call is made, it's always accurate
			// So as such, let's insert the bare minimum
			$yes = query("INSERT INTO {$evp->options->prefix}files (`id`, `parent_id`, `child_type`, `file_name`, `name`, `location`, `time`, `extension`, `type`, `source`) VALUES ('{$child_ref}', '{$file_ref}', '{$child_type}', '{$child_file_name}', '{$child_name}', '{$child_location}', '{$now}', '{$child_extension}', 'video', '2')");

			if(!$yes) { // Why would this ever fail?
				$apiData = array(
					'success' => false,
					'message' => 'The child you have specified does not appear to be uploaded properly.'
				);
			} else {
				query("INSERT INTO {$evp->options->prefix}files_data (`file_id`, `key`, `value`) VALUES ('{$child_ref}', 'data[page_seed]', '{$child_name}')");
				$apiData = array(
					'success' => true,
					'message' => 'The child video has been associated with the parent successfully.'
				);
			}

			/*
			$evp->primeFileCache(); // This should enter the child into the files list - we will move it in a sec

			$this_child = getRow("SELECT * FROM {$evp->options->prefix}files WHERE `id` = '{$child_ref}'");
			if(!$this_child) { // Failed upload?
				$apiData = array(
					'success' => false,
					'message' => 'The child you have specified does not appear to be uploaded properly.'
				);
			} else {
				query("UPDATE {$evp->options->prefix}files SET `parent_id` = '{$file_ref}', `child_type` = '{$child_type}' WHERE `id` = '{$child_ref}' LIMIT 1");
				$apiData = array(
					'success' => true,
					'message' => 'The child video has been associated with the parent successfully.'
				);
			}
			*/

			// Respond!
			$api->setResponseData($apiData)->respond();
		} else {
			api_authenticate_failed();
		}
		break;
	case 'files-new-remote':
		$user = $evp->api->authenticate($_REQUEST['username'], $_REQUEST['password']);
		if($user) {
			// Folder?
			$folder_id = 0;
			if(!empty($_REQUEST['folder_id']) && is_numeric($_REQUEST['folder_id'])) $folder_id = escape($_REQUEST['folder_id'], true);
			if($folder_id > 0) $folder = $evp->getFolder($folder_id);

			// Let's do the actual import
			$url = trim($_REQUEST['url']);
			if(empty($url)) $api->setResponseData(array('success' => false, 'message' => 'You did not specify a URL to import!'))->respond();

			$file = $evp->api->files_import($url);

			if($file) {

				/*
				if($file->source == '3') { // If it's a YouTube video
					$metadata = $evp->api->files_metadata_remote_youtube($file->id);
				} else {
					$metadata = new Object(escape($_REQUEST['metadata']));
				}
				*/

				$metadata = new Object(escape($_REQUEST['metadata']));

				if(!empty($metadata)) {
					$ssn = ssn_encode(array('metadata' => $metadata));
					foreach($ssn as $k => $v) $evp->insertDataKey($k, $v, $file->id, 'file');
				}

				// Place it in the folder they specified?
				if(!empty($folder)) {
					query("INSERT INTO {$evp->options->prefix}folders_relationships (`file_id`, `folder_id`) VALUES ('{$file->id}', '{$folder_id}')");
					query("UPDATE {$evp->options->prefix}folders SET `file_count` = `file_count` + 1 WHERE `id` = '{$folder_id}' LIMIT 1");
				}

				// Response
				$apiData = array(
					'success' => true,
					'file' => $file
				);
			} else {
				// Response
				$apiData = array(
					'success' => false,
					'message' => 'The file you chose could not be imported.'
				);
			}

			// Respond!
			$api->setResponseData($apiData)->respond();
		} else {
			api_authenticate_failed();
		}
		break;
	case 'files-delete':
		$user = $evp->api->authenticate($_REQUEST['username'], $_REQUEST['password']);
		if($user) {
			if(empty($_REQUEST['profile'])) { // Delete a file
				$yes = $evp->api->files_delete($_REQUEST['file_id']);
				if($yes) {
					$apiData = array(
						'success' => true,
						'file_id' => $_REQUEST['file_id'],
						'message' => 'This file has been deleted successfully.'
					);
				} else {
					$apiData = array(
						'success' => false,
						'message' => 'This file could not be deleted.'
					);
				}
				$api->setResponseData($apiData)->respond();
			} else { // Delete a profile
				//
			}
		} else {
			api_authenticate_failed();
		}
		break;
	case 'files-stats-remote-youtube':
		$user = $evp->api->authenticate($_REQUEST['username'], $_REQUEST['password']);
		if($user) {
			$yes = $evp->api->files_stats_remote_youtube($_REQUEST['file_id']);
			if($yes) {
				$apiData = array(
					'success' => true,
					'file_id' => $_REQUEST['file_id'],
					'stats' => $yes,
					'message' => 'Returned your YouTube stats successfully.'
				);
			} else {
				$apiData = array(
					'success' => false,
					'message' => 'This file could not be identified, or there is no data.'
				);
			}
			$api->setResponseData($apiData)->respond();
		} else {
			api_authenticate_failed();
		}
		break;
	case 'files-download-page':
		$user = $evp->api->authenticate($_REQUEST['username'], $_REQUEST['password']);
		if($user) {

			$file_ref = $_REQUEST['file_id'];
			if(!empty($_REQUEST['profile'])) $file_ref.= "::{$_REQUEST['profile']}";

			$file = $evp->getFile($file_ref);
			if($file) {
				$zip_files = array();

				// Ok let's scrape the URL for this page
				$request = new Request_Curl(array('url' => url()));
				$page = $request->send(array('seed' => $file->data['page_seed']));

				$zip = new ZipArchive();
				$zip_name = gmdate('Y-m-d-H-i-s').'-'.makeSeed(base64_decode($file_ref)).'.zip';
				$zip_path = $config['paths']['base'].'/assets/cache/'.$zip_name;
				if($zip->open($zip_path, ZIPARCHIVE::CREATE)) {
					$zip->addFromString('index.html', $page);
					$zip->close();

					header("Content-type: application/zip;\n");
					header("Content-Length: ".filesize($zip_path).";\n");
					header("Content-Disposition: attachment; filename=\"{$file->name} page.zip\";\n\n");
					readfile($zip_path);
					unlink($zip_path);
				}

			} else {
				// Response
				$apiData = array(
					'success' => false,
					'message' => 'The file you chose could not be identified.'
				);
			}

			// Respond!
			$api->setResponseData($apiData)->respond();
		} else {
			api_authenticate_failed();
		}
		break;
	case 'users-delete':
		$yes = $evp->api->users_delete($_REQUEST['user_id']);
		if($yes) {
			$apiData = array(
				'success' => true,
				'user_id' => $_REQUEST['user_id'],
				'message' => 'This user has been deleted successfully.'
			);
		} else {
			$apiData = array(
				'success' => false,
				'message' => 'This user could not be deleted.'
			);
		}
		$api->setResponseData($apiData)->respond();
		break;
	case 'split-delete':
		$yes = $evp->api->split_delete($_REQUEST['id']);
		if($yes) {
			$apiData = array(
				'success' => true,
				'id' => $_REQUEST['id'],
				'message' => 'This split test has been deleted successfully.'
			);
		} else {
			$apiData = array(
				'success' => false,
				'message' => 'This split test could not be deleted.'
			);
		}
		$api->setResponseData($apiData)->respond();
		break;
	case 'split-list':
		$splittests = $evp->getSplitTests();

		$apiData = array(
			'success' => true,
			'splittests' => $splittests
		);

		$api->setResponseData($apiData)->respond();
		break;
	case 'split-embed-code':
		$user = $evp->api->authenticate($_REQUEST['username'], $_REQUEST['password']);
		if($user) {
		//$evp->primeFileCache();

			$id = escape($_REQUEST['id'], true);
			$split = $evp->getSplitTest($id);

			$embed_code = $evp->api->split_embed_code($id);

			$page_url = false;
			if(!empty($split->data['page_seed'])) $page_url = $evp->mod_rewrite ? url($split->data['page_seed'].'/', false) : url('/', array('seed' => $split->data['page_seed']));

			if($split) {
				// Response
				$apiData = array(
					'success' => true,
					'embed_code' => $embed_code,
					'page_url' => $page_url
				);
			} else {
				// Response
				$apiData = array(
					'success' => false,
					'message' => 'The split test you chose could not be identified.'
				);
			}

			// Respond!
			$api->setResponseData($apiData)->respond();
		} else {
			api_authenticate_failed();
		}
		break;
	case 'sitemaps-delete':
		$yes = $evp->api->sitemaps_delete($_REQUEST['id']);
		if($yes) {
			$apiData = array(
				'success' => true,
				'id' => $_REQUEST['id'],
				'message' => 'This sitemap has been deleted successfully.'
			);
		} else {
			$apiData = array(
				'success' => false,
				'message' => 'This sitemap could not be deleted.'
			);
		}
		$api->setResponseData($apiData)->respond();
		break;
	case 'sitemaps-xml':
		$user = $evp->api->authenticate($_REQUEST['username'], $_REQUEST['password']);
		if($user) {

			$sitemap_id = $_REQUEST['id'];

			$sitemap = $evp->getSitemap($sitemap_id);

			$embed_code = $evp->api->sitemaps_xml($sitemap_id);

			if($sitemap) {
				// Response
				$apiData = array(
					'success' => true,
					'sitemap' => $sitemap,
					'xml' => $embed_code
				);
			} else {
				// Response
				$apiData = array(
					'success' => false,
					'message' => 'The sitemap you chose could not be identified.'
				);
			}

			// Respond!
			$api->setResponseData($apiData)->respond();
		} else {
			api_authenticate_failed();
		}
		break;
	case 'playlists-delete':
		$user = $evp->api->authenticate($_REQUEST['username'], $_REQUEST['password']);
		if($user) {
			$yes = $evp->api->playlists_delete($_REQUEST['id']);
			if($yes) {
				$apiData = array(
					'success' => true,
					'id' => $_REQUEST['id'],
					'message' => 'This playlist has been deleted successfully.'
				);
			} else {
				$apiData = array(
					'success' => false,
					'message' => 'This playlist could not be deleted.'
				);
			}
			$api->setResponseData($apiData)->respond();
		} else {
			api_authenticate_failed();
		}
		break;
	case 'playlist-list':
		$playlists = $evp->getPlaylists();

		$apiData = array(
			'success' => true,
			'playlists' => $playlists
		);

		$api->setResponseData($apiData)->respond();
		break;
	case 'playlist-embed-code':
		$user = $evp->api->authenticate($_REQUEST['username'], $_REQUEST['password']);
		if($user) {

			$id = escape($_REQUEST['id'], true);
			$playlist = $evp->getPlaylist($id, false);

			$embed_code = $evp->api->playlist_embed_code($id);

			$page_url = false;
			if(!empty($playlist->data['page_seed'])) $page_url = $evp->mod_rewrite ? url($playlist->data['page_seed'].'/', false) : url('/', array('seed' => $playlist->data['page_seed']));

			if($playlist) {
				// Response
				$apiData = array(
					'success' => true,
					'embed_code' => $embed_code,
					'page_url' => $page_url
				);
			} else {
				// Response
				$apiData = array(
					'success' => false,
					'message' => 'The playlist you chose could not be identified.'
				);
			}

			// Respond!
			$api->setResponseData($apiData)->respond();
		} else {
			api_authenticate_failed();
		}
		break;
	case 'general-unknown':
	default:
		$api->setResponseData(array(
			'success' => false,
			'message' => 'Invalid API method provided.'
		))->respond();
		break;
}
?>
