<?php
/**
 * Return a debugged string
 * Wraps the print_r output in a 'pre' html tag
 * <code>
 * echo debug('hello', array('test', 'la'));
 * </code>
 * @param mixed $x.. All arguments passed will be print_r-d
 */
function debug() {
	$str = '<pre>';
	$args = func_get_args();
	if(!empty($args)) {
		foreach($args as $arg) {
			$str.= print_r($arg, true);
			$str.= "\n\n";
		}
	}
	$str.= '</pre>';
	return $str;
}

/**
 * Return a dumped string
 * Wraps the var_dump output in a 'pre' html tag
 * <code>
 * echo dump('hello', array('test', 'la'));
 * </code>
 * @param mixed $x.. All arguments passed will be var_dumped
 */
function dump() {
	$str = '<pre>';
	$args = func_get_args();
	if(!empty($args)) {
		ob_start();
		foreach($args as $arg) {
			echo var_dump($arg);
			echo "\n\n";
		}
		$str.= ob_get_clean();
	}
	$str.= '</pre>';
	return $str;
}
?>