<?php
/**
 * A wrapper for date()
 * <code>
 * echo "It is currently ".formatDate('long');
 * echo formatDate(strtotime('-1 week'), 'long');
 * </code>
 * <b>One argument</b>
 * @param string $format 'short', 'int', 'timestamp', 'date', 'long'
 * <b>Two arguments</b>
 * @param int Timestamp, or anything accepted by strtotime
 * @param string $format 'short', 'int', 'timestamp', 'date', 'long'
 * @return string
 */
function formatDate() {
	$args = func_num_args();
	if($args == 2) {
		$stamp = func_get_arg(0);
		$format = func_get_arg(1);
	} else {
		$stamp = time();
		$format = func_get_arg(0);
	}
	if(!is_numeric($stamp)) $stamp = strtotime($stamp);
	if($format == 'short') return date('d M y H:i', $stamp);
	elseif($format == 'int') return date('d m y H:i:s', $stamp);
	elseif($format == 'timestamp') return date('U', $stamp);
	elseif($format == 'date') return date('d\/m\/Y', $stamp);
	elseif($format == 'long') return date('l jS \o\f F Y', $stamp);
	return formatDate();
}

function formatPrice($price = false, $clean = false) {
	if(!$price) $price = 0;
	// Better cleanup the price in case this happens multiple times on the same number
	$price = str_replace(',', '', $price);
	$price = number_format($price, 2);
	if(!$clean) return $price;
	$price = trim(str_replace(array(',', ' '), '', $price));
	return $price;
}
?>