<?php
/**
 * @todo Document this function
 */
function makeSeed($title) {
	if(function_exists('iconv')) {
		$seed = iconv('UTF-8', 'ASCII//TRANSLIT', $title);
	} else {
		$seed = $title;
	}
	$seed = unescape($seed, true);
	$seed = str_replace('&amp;', 'and', $seed);
	$seed = preg_replace('/[^a-zA-Z0-9-\s]/', '', $seed);
	$seed = trim(preg_replace('/\s+/', ' ', $seed));
	$seed = str_replace(' ', '-', strtolower($seed));
	$seed = trim(preg_replace('/\-+/', '-', $seed));
	if(strlen($seed) > 250) $seed = substr($seed, 0, 250);
	return trim($seed, '-');
}

/**
 * @todo Document this function
 */
function makeReadable($seed) {
	$title = unescape($seed, true);
	$title = str_replace('-', ' ', $title);
	$title = ucwords($title);
	return trim($title);
}

/**
 * @todo Document this function
 */
function compare_version($a, $b) {
	$a = explode('.', rtrim($a, '.0'));
	$b = explode('.', rtrim($b, '.0'));
	foreach ($a as $depth => $aVal) {
		if(isset($b[$depth])) {
			if ($aVal > $b[$depth]) return 1;
			else if ($aVal < $b[$depth]) return -1;
		} else {
			return 1;
		}
	} 
	return (count($a) < count($b)) ? -1 : 0; 
}

/**
 * Packs HTML form-style key/values into an element
 * <code>
 * $data = array(
 *  'something[element][whatever]' => 'some value!'
 * );
 * $page = array();
 * parseData($data, $page);
 * echo debug($page); // Will have that inside it
 * </code>
 * @param array $data
 * @param array|Object|object $element The element to parse data into
 * @return $element
 */
function parseData($data, &$element) {
	foreach($data as $key => $value) {
		$short = before('[', $key);
		if(!$short) { // This is just a static key, not an array-based one!
			if($value === 'true') {
				$value = true;
			} elseif($value === 'false') {
				$value = false;
			} elseif(is_numeric($value)) {
				$value = (int)$value;
			} elseif($decode = decode(unescape($value, true))) {
				$value = $decode;
				if(!is_array($value) || is_object($value)) {
					$value = unescape($value, true);
				}
			}
			// And assign
			if(is_array($element)) $element[$key] = $value;
			elseif(is_object($element)) $element->{$key} = $value;
		} else {
			$key = str_replace(array('[', ']'), array("['", "']"), $key);
			$value = addslashes($value);
			$out = eval("\${$key} = \"{$value}\"; return \${$short};");
			if(!empty($out) && is_array($out)) {
				foreach($out as &$v) {
					if($dec = decode($v)) $v = $dec;
					elseif(is_numeric($v)) $v = (int)$v;
					elseif($v == 'true') $v = true;
					elseif($v == 'false') $v = false;
				}
			}
			if(is_array($element)) {
				$element[$short] = $out;
			} elseif(is_object($element)) {
				$element->{$short} = $out;
			}
		}
	}
	/*
	// This is to correct and remove any extraneous data keys from []-based keys from the element
	foreach($data as $k => $v) {
		$short = before('[', $k);
		if($short) {
			if(is_array($element)) unset($element[$short][$k], $element[$short]->{$k});
			elseif(is_object($element)) unset($element->{$short}->{$k}, $element->{$short}[$k]);
		}
	}
	*/
	return $element;
}

/**
 * Removes offensive words from a string
 * <code>
 * echo swearfilter("You're a shitbag"); // Returns "You're a ***bag"
 * </code>
 * @param string $string
 * @return string $string The string with offensive words stripped out
 */
function swearfilter($string) {
	$filter = array(
		'shit',
		'fuck',
		'cunt',
		'twat',
		'bitch',
		'nigger'
	);
	$censors = array();
	foreach($filter as $word) $censors[] = str_repeat('*', strlen($word));
	return str_replace($filter, $censors, $string);
}

/**
 * Removes a standard amount of HTML from a string
 * <code>
 * echo codefilter("<div><strong>Hi!</strong></div>"); // Returns "<strong>Hi!</strong>"
 * </code>
 * @param string $string
 * @return string $string The string with HTML and such stripped out
 */
function codefilter($string) {
	return trim(strip_tags($string, '<strong><b><i><em><br><img><a><p><ul><ol><li><del><ul><sub><sup>'));
}
?>