<?php
/**
 * strtotime wrapper which returns relative to GMT
 * @see http://php.net/strtotime
 * @return int
 */
function gmstrtotime($string) {
	return strtotime($string.' UTC');
}

/**
 * Returns the previous $days as an array
 * @return array
 */
function createDatesArray($days) {
	$output = array();
	
	$month = date("m");
	$day = date("d");
	$year = date("Y");

	for($i = 1; $i <= $days; $i++) {
		$output[] = date('Y-m-d', mktime(0,0,0, $month, ($day - $i), $year));
	}

	return $output;
}

/**
 * Returns the current time in GMT
 * @return int
 */
function gmtime() {
	return gmdate('U');
}

/**
 * @todo Document this function
 */
function format_age($age) {
	$timet = 3600 * 24;
	$days = floor($age / $timet);
	$hours = floor($age / 3600);
	$minutes = floor($age / 60);
	$seconds = $age;
	if($days == 1) $age = "{$days} day ago";
	elseif($days > 1) $age = "{$days} days ago";
	elseif($hours > 0) $age ="{$hours} hr".(($hours > 1) ? 's' : '').' ago';
	elseif ($minutes > 0) $age = "{$minutes} min".(($minutes > 1) ? 's' : '').' ago';
	else $age = "{$seconds} sec".(($seconds > 1) ? 's' : '').' ago';
	return $age;
}

/**
 * @todo Document this function
 */
function secondsToHMS($sec, $showHours = false, $padHours = false) {
  $hours_min_secs = '';
  $hours = intval(intval($sec) / 3600); 
  $hours_min_secs .= ($padHours) ? str_pad($hours, 2, '0', STR_PAD_LEFT). ':' : $hours. ':';
  if($showHours == false && $hours <= 0) $hours_min_secs = '';
  $minutes = intval(($sec / 60) % 60); 
  $hours_min_secs .= str_pad($minutes, 2, '0', STR_PAD_LEFT). ':';
  $seconds = intval($sec % 60); 
  $hours_min_secs .= str_pad($seconds, 2, '0', STR_PAD_LEFT);
  return $hours_min_secs;
}
?>