<?php
if(empty($_GET['seed']) && empty($_GET['id'])) {
	header("Location: signin.php");
	exit;
}

// Expressly disable caching of this page
header("Expires: Mon, 26 Jul 1997 05:00:00 GMT");
header("Last-Modified: " . gmdate("D, d M Y H:i:s") . " GMT");
header("Cache-Control: no-store, no-cache, must-revalidate");
header("Cache-Control: post-check=0, pre-check=0", false);
header("Pragma: no-cache");

$mode = (!empty($_GET['mode']) && $_GET['mode'] == 'iframe' ? 'iframe' : 'standard');

require('application.php');
require('application.bootstrap.php');
$page = new Page(($mode == 'iframe' ? 'page-iframe.php' : 'page.php'), ($mode == 'iframe' ? 'master-iframe.php' : 'master.php'), array('theme' => $evp->settings->theme));
$page->title(array($evp->settings->site_name));

// Let's get the file relating to this
if($mode == 'iframe') {
	$file_ref = trim(pick($_GET['seed'], $_GET['id']), '/');
	if(!empty($_GET['profile'])) $file_ref.= '::'.$_GET['profile'];
} else {
	$page_seed = makeSeed(escape(trim($_GET['seed'], '/'), true));
	$file_ref = grab(getRow("SELECT `file_id` FROM {$config['evp']['prefix']}files_data WHERE `key` = 'data[page_seed]' && `value` = '{$page_seed}'"), 'file_id');
	if(empty($file_ref)) {
		$file_ref = escape($_GET['seed'], true); // Default to the file ID?
	}
}

$source_mode = 'video';
if(substr($file_ref, 0, 8) == 'playlist') {
	$source_mode = 'playlist';
	$file_ref = substr($file_ref, 10);
	$file_id = $file_ref;
	$file = $evp->getPlaylist($file_ref);
} elseif(substr($file_ref, 0, 9) == 'splittest') {
	$source_mode = 'splittest';
	$file_ref = substr($file_ref, 11);
	$file_id = $file_ref;
	$file = $evp->getSplitTest($file_ref);
}

if($source_mode == 'video') {
	$parts = explode('::', $file_ref, 2);
	$file_id = $parts[0];
	$profile = $parts[1];

	// We should check to see if the page is explicitly disabled
	$isPageDisabled = getRow("SELECT `file_id` FROM {$evp->options->prefix}files_data WHERE `file_id` = '{$file_id}' && `key` = 'options[video_page_disabled]' && (`value` = 'true' || `value` = '1')");
	if($isPageDisabled && $mode != 'iframe') {
		$file_ref = ''; // Disable the page if it's set
	}

	if(!empty($file_ref)) $file = $evp->getFile($file_ref);
}

// Do we have a file?
if(empty($file_ref) || empty($file)) {
	//
} else {

	if($source_mode == 'video') {
		// The metadata MUST be set before this works properly!
		// So let's redirect them to the page to set it first off
		if(empty($file->metadata)) redirect('admin/files.metadata.php', array('id' => $file->id, 'redirect' => currentUrl()));

		$file_settings = $evp->collateFileSettings($file, $profile);
		$file_ref = $file->id;
		if(!empty($profile)) $file_ref.= "::{$profile}";

		$page->set(array(
			'file_ref' => $file_ref,
			'file_id' => $file_id
		));
	} elseif($source_mode == 'playlist') {
		$file_settings = $file;
	} elseif($source_mode == 'splittest') {
		$file_settings = $file;
	}

	// Do we need to add in page widgets?
	$w = (array)$file_settings->page_widgets;
	if(empty($file_settings->options['page_widgets_order']) || empty($w)) {
		$file_settings->options['page_widgets_order'] = array('0' => '0', '1' => '1');
		$file_settings->page_widgets = array(
			array(
				'idx' => '0',
				'slug' => 'title',
				'name' => 'Title',
				'text' => makeReadable($file->data['page_seed'])
			),
			array(
				'idx' => '1',
				'slug' => 'my-video',
				'name' => 'My Video'
			)
		);
	}

	$page->set(array(
		'file' => $file,
		'file_settings' => $file_settings,
		'page_seed' => $page_seed
	));

	$setting_og = true; // Default to yes
	if($file_settings->options['page-sharing-facebook'] == 'page' || $_GET['og'] === '0') $setting_og = false;
	if($_GET['og'] === '1') $setting_og = true;

	if(!empty($file_settings->options['page-seo-title'])) {
		$page->title($file_settings->options['page-seo-title']);
		$page->meta('og:title', $file_settings->options['page-seo-title']);
	}

	if(!empty($file_settings->options['page-seo-keywords'])) {
		$page->meta('keywords', $file_settings->options['page-seo-keywords']);
	}

	if(!empty($file_settings->options['page-seo-description'])) {
		$page->meta('description', $file_settings->options['page-seo-description']);
		$page->meta('og:description', $file_settings->options['page-seo-description']);
	}

	if(!empty($evp->settings->facebook_app_id)) {
		$page->meta('fb:app_id', $evp->settings->facebook_app_id);
	}

	$skin = pick($file_settings->options['skin'], 'minima');
	$related_image = url("player/assets/jwplayer-5.10/skins/{$skin}/{$skin}.png");
	if(!empty($file_settings->options['related_image']) && $file_settings->options['related_image'] != url('player/images/no-image.png?v=1', false, true)) $related_image = $file_settings->options['related_image'];

	$page->meta('og:image', $related_image);

	if($setting_og) {
		$page->meta('og:video:width', $file_settings->options['width']);
		$page->meta('og:video:height', $file_settings->options['height']);
		$page->meta('og:video:type', 'application/x-shockwave-flash');

		$cposition = 'over';
		if($file_settings->options['player_controls'] == 'hide') $cposition = 'hide';

		$location = $file->location;
		if($evp->s3 && $file->source == '2') $location = $evp->s3->getUrl($file->file_name, 315569260);

		if($source_mode == 'video') {
			$page->meta('og:type', 'video');
			$page->meta('og:video', $evp->videoEmbedCode($file, 'sd', $profile, false, 'url'));
		}
	} else {
		$page->meta('og:type', 'article');
	}

	$page->meta('og:site_name', $evp->settings->site_name);
	$page->meta('og:url', trim(currentUrl(), '/'));

	$page->meta('SKYPE_TOOLBAR', 'SKYPE_TOOLBAR_PARSER_COMPATIBLE'); // Remove the Skype plugin

	if($mode == 'iframe') {
		$customArgs = array();
		if(!empty($_GET['settings'])) $customArgs = array_merge($customArgs, $_GET['settings']);
		$page->set(array(
			'embed_code' => $evp->videoEmbedCode($file, 'sd', $profile, false, 'js', $customArgs)
		));
	}

	if($mode == 'standard') {
		if(empty($file_settings->options['page-background-image']) || $file_settings->options['page-background-image'] == 'no-image') $file_settings->options['page-background-image'] = '';
		if(empty($file_settings->options['page-background-colour'])) $file_settings->options['page-background-colour'] = '#ffffff';

		// Include depending on the theme
		$theme_name = pick($file_settings->options['page-theme'], 'default');
		$theme = $evp->getPageTheme($theme_name);

		// Load this theme's CSS file
		$page->css('assets/themes/'.$theme_name.'/style.css');

		$page->set('theme', $theme);
		$page->set('theme_name', $theme_name);
	}
}

// Special things for this page
$page->addEvent('onTemplateMerge', 'onTemplateMerge');

function onTemplateMergeCreatedPage($event, $master, $template, $page) {
	$config = Registry::retrieve('config');
	$xs = Registry::retrieve('users');

	unset($page->javascripts[0], $page->javascripts[1]); // Remove Moo and global.js
}

$page->addEvent('onTemplateMerge', 'onTemplateMergeCreatedPage');
echo $page->parse();
?>
