<?php
require('application.php');
require('application.bootstrap.php');
$page = new Page('info.php', 'master.php', array('theme' => '3.0'));
$page->title(array($evp->settings->site_name));

if(empty($_GET['code'])) $code = 'general-unknown';
else $code = trim(strtolower($_GET['code']));

$type = 'error';
$button_url = url('admin/');
$html = '';
$button_text = 'Go back';

$page->js(url('admin/themes/3.0/scripts/libraries/moobutton.js'));

ob_start();

switch($code) {
	case 's3-defaultbucket':
		$type = 'error';
		$msg = "Your Amazon S3 bucket could not be created.";// Please click the link below to return to {$evp->options->project_name}.";// and check that your Amazon S3 Secret Key and Access Keys are valid.";
		if(!empty($_GET['reason'])) {
			$msg.= "<br /><br />{$_GET['reason']}<br /><br />";
		} else {
			$msg.= "<br /><br />Check that your Amazon S3 Secret Key and Access Keys are valid.<br /><br />";
		}
		$msg.= "Click the button below to return to {$evp->options->project_name}.";
		break;
	case 'upgrade':
		$script = basename($_GET['script']);
		if(file_exists($config['paths']['base'].'/install/assets/'.$script.'.php')) {
			$type = 'success';
			$button_url = '';
			$msg = 'Welcome! We\'ve detected that this version of '.$evp->options->project_name.' requires some database upgrades. We\'re ready to do these automatically for you now.<br /><br />It is <strong>absolutely vital</strong> that your MySQL user \''.$config['database']['username'].'\' has ALTER, DROP and EMPTY privileges on your database \''.$config['database']['database'].'\'.<br /><br />If you are good to go, please click the button below to get started!';
			$html = '<script type="text/javascript">window.addEvent(\'load\', function() {';
			$html.= "var xhr = new Request.JSON({";
			$html.= "'url': '".url('api.php')."',";
			$html.= "'onRequest': function() { $('info-button').fade(0.6); },";
			$html.= "'onFailure': function() { alert('The upgrade failed! Please try again; if it fails again, please contact our support desk!'); $('info-button').fade(1); },";
			$html.= "'onSuccess': function() { alert('Your installation has been upgraded successfully! Click okay to continue to your web dashboard.'); window.location = 'index.php'; },";
			$html.= "});";
			$html.= "$('info-button').addEvent('click', function() {";
			$html.= "xhr.send({";
			$html.= "'method':'post',";
			$html.= "'data': {";
			$html.= "'method': 'public-upgrade',";
			$html.= "'script': '".$script."'";
			$html.= "}";
			$html.= "});";
			$html.= '});';
			$html.= '});</script>';
			$button_text = 'Start!';
		} else {
			$type = 'error';
			$msg = 'The upgrade script specified cannot be found. This should never happen - please perform an upgrade to make sure your files are not missing!';
		}
		break;
	case 'upgrade-error':
		$type = 'error';
		$button_url = url('admin/dashboard.php');
		$msg = "There was an error upgrading your {$evp->options->project_name} assets. Please wait a few seconds and try again to complete this process.";
		break;
	case 'hosted-install':
		$type = 'info';
		$button_url = url('admin/dashboard.php');
		$msg = 'Your hosted installation has been successfully completed. Please click the button above to sign in to your account.';
		break;
	case 'debug':
		$type = 'info';
		$button_url = url('admin/dashboard.php');
		echo "<p class=\"info\">You are using {$evp->options->project_name} version {$evp->options->project_version}.</p>";
		if($evp->options->commercial == true) echo "<p class=\"info\">You <strong>are</strong> using the Commercial License.</p>";
		if($evp->options->hosted == true) echo "<p class=\"info\">You <strong>are</strong> using the hosted solution.</p>";
		
		if($evp->options->hosted !== true) {
			echo "<p class=\"info\">Your PHP version is: ".phpversion().". This MUST be at least 5.2.x. Please speak to your hosting company if you need to get PHP5 installed on your web server.</p>";
			
			if(ini_get('register_globals')) {
				echo "<p class=\"error\">It looks like PHP's register_globals setting is ON. Please set this to OFF as it may cause problems with signing in and using EVP properly.</p>";
			}
			
			if(!function_exists('curl_init')) {
				echo "<p class=\"error\">IMPORTANT: Your server does not appear to have cURL installed. You must contact your web hosting company to get cURL installed, as this is required.</p>";
			}
			
			if(!is_writable('assets/cache/')) {
				echo "<p class=\"error\">It looks like the /assets/cache/ directory of EVP is not writeable by the server. This will cause problems - please CHMOD to 755 or 777.</p>";
			}
			
			if(!is_writable('assets/videos/')) {
				echo "<p class=\"error\">It looks like the /assets/videos/ directory of EVP is not writeable by the server. This will cause problems - please CHMOD to 755 or 777.</p>";
			}
		
			if(!is_writable('assets/uploads/')) {
				echo "<p class=\"error\">It looks like the /assets/uploads/ directory of EVP is not writeable by the server. This may cause problems - please CHMOD to 755 or 777.</p>";
			}
			
			if(file_exists('.htaccess')) {
				echo "<p class=\"info\">If you're having trouble and perhaps receiving a blank page when signing in, please try renaming your .htaccess file to something else, so that it does not get used.</p>";
			}
		}
		
		$msg = 'Thanks,';
		break;
	case 'php-info':
		if($evp->options->hosted !== true) {
			$username = trim($_GET['username']);
			if(empty($username)) $msg = 'This username is invalid.';
			$username = escape($username, true);
			$isUser = getRow("SELECT `id` FROM {$evp->options->prefix}users WHERE `username` = '{$username}'");
			if(!$isUser) {
				$msg = 'This username is invalid.';
			} else {
				ob_start();
				phpinfo();
				$msg = ob_get_clean();
				echo $msg;
				exit;
			}
		} else {
			echo '<p class="info">You are using our hosted service! There is no debug information available here!</p>';
		}
		break;
	default:
		$type = 'error';
		$msg = "An unknown error occurred. Please contact our support desk, detailing what exactly happened when you encountered this error.";
		break;
}

$output = ob_get_clean();

$page->set('output', $output);
$page->set('button_url', $button_url);
$page->set('button_text', $button_text);
$page->set('msg', $msg);
$page->set('type', $type);
$page->set('url', $evp->options->project_website);
$page->set('html', $html);

// Special things for this page
$page->addEvent('onTemplateMerge', 'onTemplateMerge');
$page->js($config['locations']['protocol'].'://ajax.googleapis.com/ajax/libs/mootools/1.4.1/mootools-yui-compressed.js', array('position' => 'start'));
echo $page->parse();
?>