<?php
session_start(); // Start a session

// Load up the config
$config = array();

// Some path configuration
$config['paths'] = array();
$config['paths']['base'] = realpath('../');
$config['paths']['folder_base'] = realpath('.');
$config['paths']['script'] = realpath($_SERVER['SCRIPT_FILENAME']);

$config['locations']['script'] = (isset($_SERVER['HTTPS']) && $_SERVER['HTTPS'] == 'on' ? 'https://' : 'http://').$_SERVER['SERVER_NAME'].(!empty($_SERVER['SERVER_PORT']) && $_SERVER['SERVER_PORT'] != '80' ? ':'.$_SERVER['SERVER_PORT'] : '').$_SERVER['SCRIPT_NAME'];
$config['locations']['relative'] = str_replace(array('install/index.php', 'install/success.php', 'install/', $_SERVER['SERVER_NAME'], 'http://'), '', $config['locations']['script']);
$config['locations']['absolute'] = str_replace(array('install/index.php', 'install/success.php', 'install/'), '', $config['locations']['script']);

// Now we have the paths, so we need to include things
require($config['paths']['base'].'/libraries/base.php');
require($config['paths']['base'].'/libraries/registry.php');
require($config['paths']['base'].'/helpers/general.php');
require($config['paths']['base'].'/helpers/files.php');
require($config['paths']['base'].'/helpers/natives.php');
require($config['paths']['base'].'/helpers/string.php');
require($config['paths']['base'].'/libraries/database.php');

// Manually load our libraries
require($config['paths']['base'].'/libraries/ajax.php');
require($config['paths']['base'].'/libraries/email.phpmailer.php');
require($config['paths']['base'].'/libraries/email.pop3.php');
require($config['paths']['base'].'/libraries/email.smtp.php');
require($config['paths']['base'].'/libraries/email.wrapper.php');
require($config['paths']['base'].'/libraries/eternity.php');
require($config['paths']['base'].'/libraries/mysql.php');
require($config['paths']['base'].'/libraries/page.php');
require($config['paths']['base'].'/libraries/project.php');
require($config['paths']['base'].'/libraries/request.php');
require($config['paths']['base'].'/libraries/s3.php');
require($config['paths']['base'].'/libraries/session.php');
require($config['paths']['base'].'/libraries/template.php');
require($config['paths']['base'].'/libraries/uploader.php');
require($config['paths']['base'].'/libraries/usermanager.php');
require($config['paths']['base'].'/libraries/validator.php');
//require($config['paths']['base'].'/libraries/webactix_geo.php');
//require($config['paths']['base'].'/libraries/webactix_validate.php');
//require($config['paths']['base'].'/libraries/zip.php');

// Manually load helpers
require($config['paths']['base'].'/helpers/debug.php');
require($config['paths']['base'].'/helpers/environment.php');
require($config['paths']['base'].'/helpers/html.php');
require($config['paths']['base'].'/helpers/misc.php');
require($config['paths']['base'].'/helpers/time.php');

// Manually load project files
require($config['paths']['base'].'/project/evp.php');
require($config['paths']['base'].'/project/evp.api.php');
require($config['paths']['base'].'/project/evp.stats.php');

Registry::store('config', $config); // Write to the Registry

// Add some extra location data
$config['locations']['script'] = 'http://'.$_SERVER['SERVER_NAME'].$_SERVER['SCRIPT_NAME'];
$config['locations']['folder_name'] = '';
$config['locations']['folder_relative'] = '/';
$config['locations']['folder_absolute'] = trim(url($config['locations']['absolute'].$config['locations']['folder_name'].'/'), '/');
if(substr($config['locations']['folder_absolute'], -1) != '/') $config['locations']['folder_absolute'] = $config['locations']['folder_absolute'].'/';

Registry::store('config', $config); // And save the updates

if(isset($config['database'])) {
  Registry::store('database', new Database($config['database']['type']));
  if($config['database']['autoconnect'] == true) {
		Registry::retrieve('database')->connect($config['database']);
  }
}

if(isset($config['users'])) {
  Registry::store('users', new UserManager($config['users']));
	$xs = Registry::retrieve('users');
}
?>