<?php
$config['paths'] = array();
$config['paths']['base'] = realpath('../../');
$config['paths']['folder_base'] = realpath('.');

// Now we have the paths, so we need to include things
require($config['paths']['base'].'/libraries/base.php');
require($config['paths']['base'].'/libraries/registry.php');
require($config['paths']['base'].'/helpers/general.php');
require($config['paths']['base'].'/helpers/files.php');
require($config['paths']['base'].'/helpers/natives.php');
require($config['paths']['base'].'/helpers/string.php');
require($config['paths']['base'].'/libraries/database.php');

// Manually load helpers
require($config['paths']['base'].'/helpers/debug.php');
require($config['paths']['base'].'/helpers/environment.php');
require($config['paths']['base'].'/helpers/html.php');
require($config['paths']['base'].'/helpers/misc.php');
require($config['paths']['base'].'/helpers/time.php');

// Other required libraries
require($config['paths']['base'].'/libraries/mysql.php');
require($config['paths']['base'].'/libraries/project.php');

// Manually load project files
require($config['paths']['base'].'/project/evp.php');
require($config['paths']['base'].'/project/evp.api.php');
require($config['paths']['base'].'/project/evp.stats.php');

// Include the main config
require($config['paths']['base'].'/config.php');

// If this is a hosted service, overwrite some config with custom values
// specific to each subdomain
if(EVP::$defaults['hosted'] === true) {
	$correct_location = false;
	$domain = $_SERVER['SERVER_NAME'];
	if(stripos($domain, 'www.') !== false) $domain = str_replace('www.', '', $domain);
	if(stripos($domain, '.evsuite.com') !== false) {
		$domain = explode('.', $domain);
		$subdomain = $domain[0];
	} else {
		$correct_location = true;
		$domain = basename($domain);
		// Let's grab the alias folder, which exposes the $subdomain variable!
		$alias_folder = $config['paths']['base'].'/../aliases/'.$domain;
		if(is_dir($alias_folder)) require($alias_folder.'/config.php');
	}
	if($subdomain) {
		$subdomain_path = $config['paths']['base'].'/../configurations/'.$subdomain;
		if(!empty($subdomain) && is_dir($subdomain_path)) {
			require($subdomain_path.'/config.php');
			$config['paths']['subdomain'] = $subdomain_path;
			$config['locations']['subdomain'] = $subdomain;
			if(empty($config['locations']['absolute'])) { // If this hasn't been overridden per-subdomain, set
				$config['locations']['absolute'] = "http://{$subdomain}.evsuite.com/";
			}
			
			if($correct_location === true) { // This will be set if using a domain alias
				$config['locations']['absolute'] = "http://{$domain}/";
			}
			
		} else {
			die('An invalid subdomain ('.$subdomain.') was provided to this hosted version of '.EVP::$defaults['project_name']);
		}
	} else {
		die('The account you are looking for could not be identified.');
	}
}

if(isset($config['database'])) {
	Registry::store('database', new Database($config['database']['type']));
	if($config['database']['autoconnect'] == true) {
		Registry::retrieve('database')->connect($config['database']);
	}
}

// -------------------------------------

$qs = array('files', 'files_data', 'folders_relationships', 'groups_data', 'likes', 'ratings', 'settings', 'sitemaps_data', 'surveys', 'track', 'track_progression', 'track_total_starts', 'track_total_completes', 'track_unique_starts', 'track_unique_completes');

foreach($qs as $q) {
	query("ALTER TABLE `{$config['evp']['prefix']}{$q}` ADD `idx` INT(10) UNSIGNED NOT NULL AUTO_INCREMENT PRIMARY KEY FIRST;");
}

echo json_encode(array('success' => true, 'message' => 'Applied indexes appropriately.'));
?>