<?php
require('application.php');
require('application.bootstrap.php');
$page = new Page('index.php', 'master.php', array('theme' => '3.0'));
$page->title(array(EVP::$defaults['project_name'], 'Install'));

function multiple_query($sql_statements) {
	$arr_sql = preg_split('/;[\n\r]+/', $sql_statements);
	reset($arr_sql);
	$arr_success = array();
	$arr_failure = array();
	$db = Registry::retrieve('database');
	while(list($k,$v) = each($arr_sql)) {
		if(trim($v) != '') {
			$db->query($v);
		}
	}
}

clearstatcache();

if(EVP::$defaults['hosted'] == true) {
	$eternity->push('The hosted version does not require installation, only setup. If you have been provided with a subdomain, you have already set up your account.', 'error');
}

// First, check if config.php is writeable
$chmod_error = true;
if(!is_writable('../config.php')) {
	if(!@chmod('../config.php', 0777) || !@chmod('../config.php', 0755)) {
		$chmod_error = true;
		$eternity->push('Please ensure the file "config.php" in the root '.EVP::$defaults['project_name'].' directory is writeable by PHP. We have tried to do this automatically, however, not all servers allow it. Please CHMOD the file to 777 using FTP.', 'error');
	}
}

if(!is_writable('../assets/cache/')) {
	if(!@chmod('../assets/cache/', 0777) || !@chmod('../assets/cache/', 0755)) {
		$chmod_error = true;
		$eternity->push('Please ensure the "cache" directory in the "assets" directory is writeable by PHP. We have tried to do this automatically, however, not all servers allow it. Please CHMOD the folder to 777 using FTP.', 'error');
	}
}

if(!is_writable('../assets/uploads/')) {
	if(!@chmod('../assets/uploads/', 0777) || !@chmod('../assets/uploads/', 0755)) {
		$chmod_error = true;
		$eternity->push('Please ensure the "uploads" directory in the "assets" directory is writeable by PHP. We have tried to do this automatically, however, not all servers allow it. Please CHMOD the folder to 777 using FTP.', 'error');
	}
}

if(!is_writable('../assets/videos/')) {
	if(!@chmod('../assets/videos/', 0777) || !@chmod('../assets/videos/', 0755)) {
		$chmod_error = true;
		$eternity->push('Please ensure the "videos" directory in the "assets" directory is writeable by PHP. We have tried to do this automatically, however, not all servers allow it. Please CHMOD the folder to 777 using FTP.', 'error');
	}
}

if(!function_exists('curl_init')) {
	$eternity->push('IMPORTANT: Your server does not appear to have cURL installed. You must contact your web hosting company to get cURL installed, as this is required.', 'error');
}

if(ini_get('register_globals')) {
	$eternity->push('IMPORTANT: You need to contact your web hosting company and ensure that the PHP setting register_globals is set to OFF. This is a security hazard and will also almost definitely cause problems with your software.', 'notice');
}

// Already been installed?
@include('../config.php');
$success = false;
if(!empty($config['database'])) {
	$mysql = new MySQL();
	$success = $mysql->connect($config['database']);
	if($success !== false) {
		$eternity->push(EVP::$defaults['project_name'].' has already been configured. Running this script again will overwrite your configuration and reset your database. If this is what you want, please delete the config file and try again.', 'error');
	} else {
		$eternity->push('You have attempted to install '.EVP::$defaults['project_name'].' already, but your database cannot be connected to. Running this script again will overwrite your configuration.', 'notice');
	}
}

// Set up the values, at least
if(empty($_POST)) {
	$current = currentUrl();
	$relative = str_replace(array('install/index.php', 'install/', $_SERVER['SERVER_NAME'], 'http://', 'https://', 'www.'), '', $current);
	$absolute = str_replace(array('install/index.php', 'install/'), '', $current);
	$data = new Object(array(
		'database' => array(
			'host' => 'localhost',
			'username' => 'root',
			'password' => '',
			'name' => 'evp',
		),
		'evp' => array(
			'prefix' => 'evp_'
		),
		'locations' => array(
			'relative' => $relative,
			'absolute' => $absolute
		),
		'misc' => array(
			'email' => '',
			'password' => '',
			's3_accesskey' => '',
			's3_secretkey' => '',
			'cf_enable' => ''
		)
	));
	if($success !== false) {
		$data = merge($config, $data);
		$data->database['name'] = $data->database['database'];
	}
} else {
	$data = $_POST;
	// Correct relative and absolute
	if(substr($data['locations']['relative'], -1, 1) != '/') $data['locations']['relative'].= '/';
	if(substr($data['locations']['absolute'], -1, 1) != '/') $data['locations']['absolute'].= '/';
	// Move on
	$data['users']['prefix'] = $data['evp']['prefix'];
	$misc = $data['misc'];
	unset($data['misc']);
	$config_str = "<?php\nerror_reporting(E_ALL ^ E_NOTICE ^ E_USER_NOTICE);\n\$config_import = ";
	$config_str.= var_export($data, true);
	$config_str.= ";\n\$config = array_merge((array)\$config, \$config_import);\n?>";
	file_put_contents('../config.php', $config_str);
	// Now establish the connection
	Registry::store('database', new Database($data['database']['type']));
	Registry::retrieve('database')->connect($data['database']);
	// Get any SQL we need to run
	$files = getFiles($config['paths']['install_assets']);
	if(!empty($files)) {
		foreach($files as $file) {
			if(getExtension($file) == 'sql') {
				// Load it up
				$sql = file_get_contents($file);
				$sql = str_replace('{$prefix}', $data['evp']['prefix'], $sql);
				multiple_query($sql);
			}
		}
		foreach($files as $file) {
			if(getExtension($file) == 'php' && substr(basename($file), 0, 7) != 'upgrade') {
				include($file);
			}
		}
	}
	$data['misc'] = $misc;
	redirect('success.php', $misc, false);
}

$page->set('data', new Object($data));


$page->js('../../admin/themes/3.0/scripts/libraries/moobutton.js');
$page->js('../../admin/themes/3.0/scripts/custom/mootools-behaviors.js');
$page->css('../../admin/themes/3.0/styles/style.components.css');
$page->css('../../install/themes/3.0/style.css');

$page->addEvent('onTemplateMerge', 'onTemplateMerge');

echo $page->parse();
?>