<?php
$errors = Registry::get('Eternity')->retrieve('errors');
if(empty($errors)) : ?>
<script type="text/javascript">
window.addEvent('domready', function() {
	var tabs = $$('#install_options li');
	var sections = $$('#install_wrap div.tab');
	var clickers = $$('#install_fakeclickers span');
	
	var swap = new TabSwapper({
		'selectedClass': 'on',
		'deselectedClass': 'off',
		'tabs': tabs,
		'sections': sections,
		'clickers': clickers,
		'smooth': true,
		'smoothSize': false
	});
	
	tabs.addEvent('click', function(e) {
		var n = tabs.indexOf(this);
		var p = n - 1;
		if(p >= 0 && tabs[p].retrieve('complete') == true || n < swap.now) {
			swap.show(n);
		}
	});
	
	var completeStep = function(current) {
		tabs[current].store('complete', true);
		swap.show(current + 1);
		$('step_'+(current + 1)).getElement('.moobutton').unspin();
	}
	
	var createValidators = function(step, fn) {
		var step = $(step);
		var moobutton = $(step).getElement('.moobutton');
		new FormValidator.Tips($(step), {
			'onFormValidate': function(passed, form, event) {
				if(event) event.stop();
				if(passed) {
					var p = ($type(fn) == 'function') ? fn(step, moobutton) : true;
					if(p !== false) {
						completeStep(swap.now);
					}
				} else {
					moobutton.unspin();
				}
			},
			'pointyTipOptions': {'point': 'down'},
			'errorPrefix': '',
			'ignoreHidden': true
		});
		moobutton.addEvent('click', function() {
			this.spin();
			$(step).retrieve('validator').validate();
		});
	}
	
	// Each individual step
	createValidators('step_1');
	
	createValidators('step_2', function(step) {
		// Get the necessary video
		var host = $(step).getElement('input[type="radio"]:checked').get('value');
		$('step_3').getElement('.video').getChildren('div').setStyle('display', 'none');
		$('step_3').getElement('.video div#video_'+host).setStyle('display', 'block');
	});
	
	createValidators('step_3', function(step, moobutton) {
		// Test the database info
		var xhr = new Request({
			'url': '<?php echo $config['locations']['absolute']; ?>install/ajax.php?AjaxRequest=ajax',
			'method': 'post',
			'onSuccess': function(response) {
				completeStep(swap.now);
			},
			'onFailure': function(response) {
				moobutton.unspin();
				StickyWin.alert('Error with your database', response.responseText);
			}
		});
		
		var data = new Hash();
		$(step).getElements('input').each(function(el) {
			data.set(el.get('name'), el.get('value'));
		});
		xhr.post({'method': 'test_database', 'config': JSON.encode(data)});
		
		return false;
	});
	
	createValidators('step_4', function(step, moobutton) {
		// Test the database info
		var xhr = new Request({
			'url': '<?php echo $config['locations']['absolute']; ?>install/ajax.php?AjaxRequest=ajax',
			'method': 'post',
			'async': false,
			'onSuccess': function(response) {
				new Element('input', {
					'type': 'hidden',
					'name': 'evp[default_bucket]',
					'value': response
				}).inject($(step), 'bottom');
				completeStep(swap.now);
			},
			'onFailure': function(response) {
				moobutton.unspin();
				StickyWin.alert('Amazon error', response.responseText);
			}
		});
		
		var data = new Hash();
		$(step).getElements('input').each(function(el) {
			data.set(el.get('name'), el.get('value'));
		});
		if($('cloudfront_enable')) data.set('misc[cf_enable]', ($('cloudfront_enable').get('checked') ? '1' : '0'));
		xhr.post({'method': 'test_s3', 'config': JSON.encode(data)});
		
		return false;

	});
	
	createValidators('step_5', function() {
		var elements = $$('input[type="text"].text, input[type="password"], textarea, input[type="checkbox"]:checked, input[type="radio"]:checked, input[type="hidden"], input[type="file"], select');
		elements.inject($('form'), 'bottom');
		return true;
	});
	
	createValidators('step_6', function(step, moobutton) {
		moobutton.spin({
			'msg': '<?php echo EVP::$defaults['project_name']; ?> is being installed! Please wait...'
		});
		(function() {
			$('form').submit();
		}).delay(1000);
		return false;
	});
});
</script>
<?php endif; ?>
<!-- BUFFER -->
<?php
$errors = Registry::get('Eternity')->retrieve('errors');
if(!empty($errors)) {
	foreach($errors as $i) {
		echo "<p class=\"error\">{$i}</p>";
	}
}
$notices = Registry::get('Eternity')->retrieve('notices');
if(!empty($notices)) {
	foreach($notices as $i) {
		echo "<p class=\"notice\">{$i}</p>";
	}
}
?>
<?php if(empty($errors)) : ?>
<div id="install_wrap" class="tabSwapper">
	<div id="install_fakeclickers" style="display: none;"><span></span><span></span><span></span><span></span><span></span><span></span></div>
	<ul id="install_options" class="tabSwapperTabs">
		<li>Welcome</li>
		<li>Your web site</li>
		<li>Your database</li>
		<li>Your Amazon keys</li>
		<li>Your user details</li>
		<li>Congratulations</li>
	</ul>
	
	<div class="tab box" id="step_1"><div class="wrap">
		<h2>Welcome to <?php echo EVP::$defaults['project_name']; ?></h2>
		<div class="body styled">
			<p>Thanks very much for purchasing <?php echo EVP::$defaults['project_name']; if(EVP::$defaults['commercial'] == true) echo ', and the Commercial License'; ?>!</p>
			<!--<p>The first step is to enter your Members Area username and password below to Authenticate this copy of the software.</p>-->
			<center><p class="button" data-behavior="Button" data-button-width="100">Next</p></center>
		</div>
	</div></div>
	
	<div class="tab box" id="step_2"><div class="wrap">
		<h2>Please select your hosting company &amp; domain information</h2>
		<div class="body styled">
			
			<p class="step" style="margin-top:0;">The two URLs below should almost always be correct - please make sure that they match your website.</p>
			
			<div>
				<label for="locations_absolute">Absolute URL</label>
				<input type="text" name="locations[absolute]" id="locations_absolute" class="text required validate-url" value="<?php echo $data->locations->absolute; ?>" /><span class="info">Example: <strong>http://www.mysite.com/evp/</strong></span>
			</div>
			
			<div>
				<label for="locations_relative">Relative URL</label>
				<input type="text" name="locations[relative]" id="locations_relative" class="text required" value="<?php echo $data->locations->relative; ?>" /><span class="info">Example: http://www.mysite.com<strong>/evp/</strong></span>
			</div>

			<p class="step">Please tick your hosting company below. If yours isn't listed, please choose 'Any other cPanel host'.</p>
			<div class="host_wrap clear">
				<label for="host_hostgator">HostGator</label><input type="radio" name="host" id="host_hostgator" value="hostgator" /><br />
				<label for="host_godaddy">GoDaddy</label><input type="radio" name="host" id="host_godaddy" value="godaddy" /><br />
				<label for="host_bluehost">BlueHost</label><input type="radio" name="host" id="host_bluehost" value="bluehost" /><br />
				<label for="host_generic">Any other cPanel host</label><input type="radio" name="host" id="host_generic" value="generic" checked="checked" /><br />
			</div>
			
			<center><p class="button" data-behavior="Button" data-button-width="100">Next</p></center>
		</div>
	</div></div>
	
	<div class="tab box" id="step_3"><div class="wrap">
		<h2>Please enter your database information</h2>
		<div class="body">
		
			<div class="fields styled">
				<input type="hidden" name="database[autoconnect]" value="true" />
				<input type="hidden" name="database[type]" value="MySQL" />
				
				<div>
				<label for="database_host">Database host</label>
				<input type="text" name="database[host]" id="database_host" class="text required maxLength:50" value="<?php echo $data->database->host; ?>" />
				</div>
				
				<div>
				<label for="database_username">Database username</label>
				<input type="text" name="database[username]" id="database_username" class="text required maxLength:50" value="<?php echo $data->database->username; ?>" />
				</div>
				
				<div>
				<label for="database_password">Database password</label>
				<input type="password" name="database[password]" id="database_password" class="text required maxLength:50" value="<?php echo $data->database->password; ?>" />
				</div>
				
				<div>
				<label for="database_name">Database name</label>
				<input type="text" name="database[database]" id="database_name" class="text required maxLength:50" value="<?php echo $data->database->name; ?>" />
				</div>
				
				<div>
				<label for="database_prefix">Table prefix</label>
				<input type="text" name="evp[prefix]" id="database_prefix" class="text required maxLength:50" value="<?php echo $data->evp->prefix; ?>" />
				</div>
				
				<div class="clear"></div>
			</div>
			
			<div class="video">
				<div id="video_hostgator" style="display: none;"></div>
				<div id="video_godaddy" style="display: none;"></div>
				<div id="video_bluehost" style="display: none;"></div>
				<div id="video_generic" style="display: none;"></div>
			</div>
			
			<center><p class="button" data-behavior="Button" data-button-width="100">Next</p></center>
			
		</div>
	</div></div>
	
	<div class="tab box" id="step_4"><div class="wrap">
		<h2>Please enter your Amazon keys (If you don't have an account, don't enter anything!)</h2>
		<div class="body styled">
		
				<p class="step">If you have an Amazon AWS account and wish to use Amazon S3 to host your videos, please enter your details below.</p>
				
				<div>
					<label for="s3_accesskey">Access Key ID</label>
					<input type="text" name="misc[s3_accesskey]" id="s3_accesskey" class="text" value="<?php echo $data->misc->s3_accesskey; ?>" />
				</div>
				
				<div>
					<label for="s3_secretkey">Secret Access Key</label>
					<input type="text" name="misc[s3_secretkey]" id="s3_secretkey" class="text" value="<?php echo $data->misc->s3_secretkey; ?>" />
				</div>
				
				<?php if(false&&extension_loaded('openssl')) : ?>
				<p class="step">If you have already signed up with Amazon CloudFront and would like to use RTMP streaming for your videos, please check the box below.</p>
				<label for="cloudfront_enable">Enable CloudFront</label><input type="checkbox" name="misc[cf_enable]" value="1" id="cloudfront_enable" class="checkbox" <?php if($data->misc->cf_enable == '1') echo 'checked="checked"'; ?> /><br />
				<?php endif; ?>
				<div class="clear"></div>
			
			<center><p class="button" data-behavior="Button" data-button-width="100">Next</p></center>
			
		</div>
	</div></div>
	
	<div class="tab box" id="step_5"><div class="wrap">
		<h2>Please enter your user details</h2>
		<div class="body styled">
			<p class="step">Please do not forget these, because you'll need them every time you sign in to <?php echo EVP::$defaults['project_name']; ?>!</p>
			
			<div>
				<label for="misc_email">Email address</label>
				<input type="text" name="misc[email]" id="misc_email" class="text required validate-email" value="<?php echo $data->misc->email; ?>" />
			</div>
			
			<div>
				<label for="misc_password">Admin password</label>
				<input type="password" name="misc[password]" id="misc_password" class="text required minLength:8 maxLength:50" value="<?php echo $data->misc->password; ?>" />
			</div>
			
			<center><p class="button" data-behavior="Button" data-button-width="100">Next</p></center>
			
		</div>
	</div></div>
	
	<div class="tab box " id="step_6"><div class="wrap">
		<h2>Congratulations!</h2>
		<div class="body">
			<form action="index.php" method="post" class="" autocomplete="off" id="form" style="display:none;"><fieldset></fieldset></form>
			<p class="step"><?php echo EVP::$defaults['project_name']; ?> is ready to be installed! Just click the button below to save all of your data and go to the sign in page!</p>
			
			<center><p class="button" data-behavior="Button" data-button-width="100">Finish</p></center>
			
		</div>
	</div></div>
	
</div>
<?php endif; ?>