<?php
class Email extends Base {
	public $options = array(
		'useSMTP' => false,
		'from' => ''
	);
	
	public function initialise($options) {
		$this->setOptions($options);
		$this->mailer = new PHPMailer();
		if($this->options->useSMTP) {
			$this->mailer->IsSMTP();
			$this->mailer->SMTPAuth = true;
			$this->mailer->Host = $this->options->host;
			$this->mailer->Port = $this->options->port;
			$this->mailer->SMTPSecure = $this->options->security;
			$this->mailer->Username = $this->options->username;
			$this->mailer->Password = $this->options->password;
			$this->mailer->SMTPDebug = 1;
		}
		if($this->options->from) {
			$this->mailer->AddReplyTo($this->options->from);
			$this->mailer->SetFrom($this->options->from);
		}
	}
	
	public function send($to, $subject, $message) {
		$body = eregi_replace("[\]", '', $message);
		$this->mailer->AltBody = strip_tags($body);
		$this->mailer->MsgHTML($body);
		$this->mailer->Subject = $subject;
		$this->mailer->AddAddress($to[1], $to[0]);
		$yes = $this->mailer->Send();
		if($yes) {
			$this->fireEvent('onSuccess', array($to, $subject, $message));
		} else {
			$this->fireEvent('onFailure', array($to, $subject, $message));
		}
		return $yes;
	}
}

function sendEmail($to, $from, $subject, $message) {
	$mail = Registry::retrieve('email');
	if(!$mail instanceof Email) {
		$mail = createEmail($from);
	}
	return @$mail->send($to, $subject, $message);
}

function createEmail($from) {
	$config = Registry::retrieve('config');
	$options = array(
		'from' => $from
	);
	if(!empty($config['smtp'])) {
		$options['useSMTP'] = true;
		$options['host'] = $config['smtp']['host'];
		$options['port'] = $config['smtp']['port'];
		$options['security'] = $config['smtp']['security'];
		$options['username'] = $config['smtp']['username'];
		$options['password'] = $config['smtp']['password'];
	}
	$mail = new Email($options);
	Registry::store('email', $mail);
	return $mail;
}
?>