<?php
if(function_exists('mysqli_connect')) {
	require($config['paths']['base'].'/libraries/mysqli.php');
} else {

	/**
	 * MySQL database abstraction layer
	 * @author Marc Fowler <marc.fowler@defraction.net>
	 * @version 0.1
	 * @package Eternity
	 */
	class MySQL extends Base implements DatabaseInterface {
		/**
		 * Initialise the database connection
		 * Throws a fatal exception if the connection fails
		 * @param string $hostname
		 * @param string $username
		 * @param string $password
		 * @param string $database
		 */
		public function initialise() {
			return $this;
		}

		public function connect($config) {
			$this->config = $config;
			extract($config);
			if(false){//$persistent == 'true') { // Disabled persistent connections
				$this->connection = @mysql_pconnect($host, $username, $password);
			} else {
				$this->connection = @mysql_connect($host, $username, $password);
			}

			if(!$this->connection) {
				$this->fireEvent('onConnectFailed', array($config));
				return false;
			}
			$this->fireEvent('onConnect', array($this->connection, $config));
			if(!empty($database)) {
				$select = $this->selectDatabase($database);
				if(!$select) return false;
			}
			return true;
		}

		public function selectDatabase($database) {
			$select = @mysql_select_db($database, $this->connection);
			if(!$select) {
				$this->fireEvent('onSelectFailed', array($this->config));
				return false;
			}
			$this->fireEvent('onSelectDatabase', $database);
			return true;
		}

		/**
		 * Run the passed database query
		 * <code>
		 * query("UPDATE somewhere SET `something` = 'Some value' WHERE id = '5'");
		 * </code>
		 * @param string $query
		 * @return resource
		 */

		public function query($query, $continueOnError = false) {
			$result = mysql_query($query, $this->connection);
			$this->queries[] = $query;
			if($result === false && $continueOnError === false) die("Query: {$query}<br />Error: ".mysql_error());
			return $result;
		}

		/**
		 * Get the latest query
		 * <code>
		 * getLastQuery();
		 * </code>
		 * @return string
		 */

		public function getLastQuery() {
		  $queries = $this->queries;
		  return $queries[sizeof($this->queries) - 1];
		}

		/**
		 * Get an array of all queries
		 * <code>
		 * getQueries();
		 * </code>
		 * @return array
		 */

		public function getQueries() {
		  return $this->queries;
		}

		/**
		 * Get the ID generated from an AUTO_INCREMEMENT column by the previous INSERT query
		 * @return int
		 */

		public function getInsertId() {
			$result = mysql_insert_id($this->connection);
			return $result;
		}

		/**
		 * Return a single row from the passed query
		 * <code>
		 * $result = getRow("SELECT `something` FROM `somewhere` LIMIT 1");
		 * </code>
		 * @param string $query
		 * @return Object An Object of the returned data
		 */

		public function getRow($query, $objType = false) {
			$result = $this->query($query);
		//$type = pick($objType, 'Object');
			$data = mysql_fetch_object($result);//, $type);
			mysql_free_result($result);
			$this->fireEvent('onGetRow', array($query, $data));
			return $data; // Chaining this object
		}

		/**
		 * Return a group of rows from the passed query
		 * <code>
		 * $results = getArray("SELECT `something` FROM `somewhere` ORDER BY `id` DESC");
		 * </code>
		 * @param string $query
		 * @return array An array of Objects
		 */

		public function getArray($query, $objType = false) {
			$result = $this->query($query);
		//$type = pick($objType, 'Object');
			$data = array();
			while($row = mysql_fetch_object($result)) $data[] = $row;//, $type)) $data[] = $row;
			mysql_free_result($result);
			$this->fireEvent('onGetArray', array($query, $data));
			return $data; // Returned as an array of objects ($data[0]->someField)
		}

		/**
		 * Close the current connection
		 * @return MySQL
		 */

		public function close() {
			if(isset($this->connection)) {
				$this->fireEvent('onClose');
				@mysql_close($this->connection);
			}
			return $this;
		}
	}
}
