<?php
class Session extends Singleton {
	/**
	 * Saves a value in the Session storage
	 * Used as a wrapper for the $_SESSION superglobal and some related functions
	 * @param string $key
	 * @param mixed $value
	 * @return The $value
	 */
	 
	public function store($key, $value) {
		$storage = &$_SESSION;
		$storage[$key] = $value;
		return $value;
	}
	
	/**
	 * Return a key from the Session storage
	 * @param string $key
	 * @param mixed $default If the key isn't found, return this instead
	 */
	
	public function retrieve($key, $default = false) {
		$storage = &$_SESSION;
		if(array_key_exists($key, $storage)) return $storage[$key];
		return $default;
	}
	
	/**
	 * Empty the Session
	 * @return This Session
	 */
	
	public function clean() {
		$_SESSION = array();
		return self::fetch();
	}
	
	public function regenerate($delete = false) {
		return session_regenerate_id($delete);
	}
	
	public function getId() {
		return session_id();
	}
}
?>