<?php
class UserManager extends Base {
	var $defaults = "{getUserData:true, getRelationshipData:false, getGroupData:false, prefix:'eternity_', sessionExpiry:'43200', cookieExpiry:'172800', cookieName:'EternityCookie'}";
	var $userData = array();
	public function initialise($options) {
		$this->setOptions($options, $this->defaults);
		$this->guestData = new Object(array(
			'id' => '0',
			'username' => 'Guest',
			'password' => ''
		));
	//$this->checkCurrent();
	}
	
	protected function register($data) {
		$this->userData = $data;
		$_SESSION['userData'] = (array)$data;
		return $this;
	}
	
	public function isGuest() {
		return (bool)($this->guestData == $this->userData);
	}
	
	// Deprecated!
	public function restrict($obj) {
		if(!is_object($obj)) $obj = decode($obj);
		$allow = false;
		if(isset($obj->groups) && !empty($this->userData->groups)) {
			$restricted = splat(explode(', ', $obj->groups));
			foreach((array)$this->userData->groups as $group) {
				if(in_array($group->name, $restricted)) $allow = true;
			}
		}
		if(isset($obj->users)) {
			$restricted = splat(explode(', ', $obj->users));
			if(in_array($this->userData->username, $restricted)) $allow = true;
		}
		if(isset($obj->uids)) {
			$restricted = splat(explode(', ', $obj->uids));
			if(in_array($this->userData->id, $restricted)) $allow = true;
		}
		return (bool)$allow;
	}
	
	public function restrictTo($obj, $failedUrl = false, $urlData = false, $urlResolve = true) {
		$allow = false;
		$obj = (object)$obj;
		if(!empty($obj->groups) && !empty($this->userData->groups)) {
			foreach($this->userData->groups as $g) {
				if(in_array($g->name, $obj->groups)) $allow = true;
			}
		}
		if(isset($obj->users)) {
			$restricted = splat(explode(', ', $obj->users));
			if(in_array($this->userData->username, $restricted)) $allow = true;
		}
		if(isset($obj->uids)) {
			$restricted = splat(explode(', ', $obj->uids));
			if(in_array($this->userData->id, $restricted)) $allow = true;
		}
		if($failedUrl && $allow === false) {
			redirect($failedUrl, $urlData, $urlResolve);
		}
		return $allow;
	}
	
	public function checkCurrent() {
	//$ip = getRemoteIP();
		// Do they have session info?
	//if(is_object($_SESSION['userData']) && $_SESSION['userData']->keysExist(array('id', 'username')) && $tracker = $this->getTracker($_SESSION['userData']->id)) {	
		if(isset($_SESSION['userData']) && is_array($_SESSION['userData']) && array_keys_exist($_SESSION['userData'], array('id', 'username')) && $tracker = $this->getTracker($_SESSION['userData']['id'])) {
	//if($tracker->ip == $ip && $tracker->sessionId == session_id() && ($tracker->lastActivity - time()) < $this->options->sessionExpiry) {
		if($tracker->sessionId == session_id() && ($tracker->lastActivity - time()) < $this->options->sessionExpiry) {
				return $this->registerActivity($_SESSION['userData']['id']);
			}
		} elseif(isset($_COOKIE[$this->options->cookieName])) { // Do they have a valid cookie?
			$cookie = escape($_COOKIE[$this->options->cookieName]);
			$now = escape(gmdate('Y-m-d H:i:s'));
		//$ip = escape($ip);
		//$xsData = getRow("SELECT `user_id` FROM {$this->options->prefix}users_tracker WHERE `id` = '{$cookie}' && ip = '{$ip}' && (`lastActivity` - '{$now}') < '{$this->options->cookieExpiry}'");
			$xsData = getRow("SELECT `user_id` FROM {$this->options->prefix}users_tracker WHERE `id` = '{$cookie}' && (`lastActivity` - '{$now}') < '{$this->options->cookieExpiry}'");
			if($xsData) return $this->registerActivity($xsData->uid);
		}
		return $this->register($this->guestData);
	}
	
	public function getTracker($user_id) {
		$user_id = escape($user_id);
		if(!is_numeric($user_id)) return false;
		$tracker = getRow("SELECT `id`, `user_id`, `useCookie`, `sessionId`, `ip`, `lastActivity` FROM {$this->options->prefix}users_tracker WHERE `user_id` = '{$user_id}'");
		if(!$tracker) return false;
		
		$data = getArray("SELECT `key`, `value` FROM {$this->options->prefix}users_tracker_data WHERE `tracker_id` = '{$tracker->id}'");
		
		if(!empty($data)) {
			$vars = array();
			foreach($data as $d) {
				$vars[$d->key] = $d->value;
			}
			parseData($vars, $tracker);
		}
		
		$this->fireEvent('onGetTracker', $tracker);
		return $tracker;
	}
	
	public function getUser($value, $type = 'id') {
		$value = escape($value);
		if($type == 'id' && !is_numeric($value)) return false;
		$user = getRow("SELECT `id`, `seed`, `username`, `password` FROM {$this->options->prefix}users WHERE `{$type}` = '{$value}'");
		if(!$user) return false;
		if($this->options->getUserData !== false) {
		  $data = getArray("SELECT `key`, `value` FROM {$this->options->prefix}users_data WHERE `user_id` = '{$user->id}'");
		  if(!empty($data)) {
			  $vars = array();
			  foreach($data as $d) {
				  $vars[$d->key] = $d->value;
			  }
			  parseData($vars, $user);
		  }
		}
		$user->groups = $this->getGroupsByUser($user->id);
		$this->fireEvent('onGetUser', $user);
		return $user;
	}
	
	public function getGroup($value, $type = 'id') {
		$value = escape($value);
		if($type == 'id' && !is_numeric($value)) return false;
		$group = getRow("SELECT `id`, `seed`, `name` FROM {$this->options->prefix}groups WHERE `{$type}` = '{$value}'");
		if(!$group) return false;
		if($this->options->getGroupData !== false) {
		  $data = getArray("SELECT `key`, `value` FROM {$this->options->prefix}groups_data WHERE `group_id` = '{$group->id}'");
		  if(!empty($data)) {
			  $vars = array();
			  foreach($data as $d) {
				  $vars[$d->key] = $d->value;
			  }
			  parseData($vars, $group);
		  }
		}
		$this->fireEvent('onGetGroup', $group);
		return $group;
	}
	
	public function getGroupsByUser($user_id) {
		$user_id = escape($user_id);
		$groups = array();
		$rels = getArray("SELECT `id`, `user_id`, `group_id` FROM {$this->options->prefix}users_relationships WHERE `user_id` = '{$user_id}'");
		if(!$rels) return false;
		foreach($rels as $rel) {
			if(!$group = $this->getGroup($rel->group_id, 'id')) continue;
			if($this->options->getRelationshipData !== false) {
			  $data = getArray("SELECT `key`, `value` FROM {$this->options->prefix}users_relationships_data WHERE `rel_id` = '{$rel->id}'");
			}
			$group->relationship = new Object($rel);
			if($data) foreach($data as $d) $group->relationship->{$d->key} = $d->value; // Overwrite keys
			$groups[] = $group;
		}
		return $groups;
	}
	
	public function isMemberOf($user_id, $group_id) {
		$user_id = escape($user_id);
		$group_id = escape($group_id);
		if(!is_numeric($group_id)) { // Gotta locate it by name
			$allGroups = getArray("SELECT `id`, `name` FROM {$this->options->prefix}groups");
			$gid = false;
			foreach($allGroups as $g) {
				if($g->name == $group_id) $gid = $g->id;
			}
			if($gid) {
				$isMember = getRow("SELECT `id` FROM {$this->options->prefix}users_relationships WHERE `user_id` = '{$user_id}' && `group_id` = '{$gid}'");
			} else {
				$isMember = false;
			}
		} else {
			$isMember = getRow("SELECT `id` FROM {$this->options->prefix}users_relationships WHERE `user_id` = '{$user_id}' && `group_id` = '{$group_id}'");
		}
		return (bool)$isMember;
	}

	protected function registerActivity($user_id) {
		$user = $this->getUser($user_id);
		// This seems to SLOOOOW the site down - lots of queries; is that it??
		$user->tracker = $this->getTracker($user_id);
	//return $this->register($user);
		
		
	//$ip = escape(getRemoteIP());
	//$sessionId = escape(session_id());
		$now = escape(gmdate('Y-m-d H:i:s'));
		query("UPDATE {$this->options->prefix}users_tracker SET `lastActivity` = '{$now}' WHERE `id` = '{$user->tracker->id}'");
		/*
		$tracker = $this->getTracker($user_id);
		$this->fireEvent('onRegister', array($user, $tracker));
		if($tracker) {
			$user->tracker = $tracker;
			return $this->register($user);
		}
		return $this->register($this->guestData);
		*/
		
		return $this->register($user);
	}
	
	public function signIn($username, $password, $useCookie = false) {
		$username = escape($username);
		$password = escape($password);
		$useCookie = ($useCookie) ? '1' : '0';
		$user = getRow("SELECT `id` FROM {$this->options->prefix}users WHERE `username` = '{$username}' && `password` = SHA1('{$password}')");
		if(!$user) return false;
		$user = $this->getUser($user->id);
		$ip = escape(getRemoteIP());
		$sessionId = escape(session_id());
		$now = escape(gmdate('Y-m-d H:i:s'));
		query("DELETE FROM {$this->options->prefix}users_tracker WHERE `sessionId` = '{$sessionId}' || `user_id` = '{$user->id}'");
	//query("INSERT INTO {$this->options->prefix}users_tracker(`user_id`, `useCookie`, `sessionId`, `lastActivity`) VALUES ('{$user->id}', '{$useCookie}', '{$sessionId}', '{$now}')");
		query("INSERT INTO {$this->options->prefix}users_tracker(`user_id`, `useCookie`, `sessionId`, `ip`, `lastActivity`) VALUES ('{$user->id}', '{$useCookie}', '{$sessionId}', '{$ip}', '{$now}')");
		$this->registerActivity($user->id);
		$this->fireEvent('onSignIn', array($user));
		return true;
	}
	
	public function signOut() {
		if(!empty($this->userData)) {
			$trackers = getArray("SELECT `id` FROM {$this->options->prefix}users_tracker WHERE `user_id` = '{$this->userData->id}'");
			if(!empty($trackers)) {
				query("DELETE FROM {$this->options->prefix}users_tracker WHERE `user_id` = '{$this->userData->id}'");
				query("DELETE FROM {$this->options->prefix}users_tracker_data WHERE `tracker_id` IN(".implode(flattenByKey($trackers, 'id'), ',').")");
			}
		}
		$this->register($this->guestData);
		return $this;
	}
	
	public function isCorrectPassword($user_id, $password) {
		$user_id = escape($user_id);
		$password = escape($password);
		$user = getRow("SELECT `id` FROM {$this->options->prefix}users WHERE `id` = '{$user_id}' && `password` = SHA1('{$password}')");
		if($user) return true;
		return false;
	}
	
	public function becomeOldUser($user_id) {
		$user_id = escape($user_id);
		query("DELETE FROM {$this->options->prefix}users_data WHERE `user_id` = '{$user_id}' && `key` = 'new_user'");
		return true;
	}
}
?>