<?php
// Expressly disable caching of this page
header("Expires: Mon, 26 Jul 1997 05:00:00 GMT");
header("Last-Modified: " . gmdate("D, d M Y H:i:s") . " GMT");
header("Cache-Control: no-store, no-cache, must-revalidate");
header("Cache-Control: post-check=0, pre-check=0", false);
header("Pragma: no-cache");

require('application.php');
require('application.bootstrap.php');
include($config['paths']['base'].'/libraries/api.php');

$currentUrl = currentUrl();

// Let's get the file relating to this
$file_ref = trim(urldecode($_GET['file_ref']), '/');
if(empty($file_ref)) {
	$urlquery = parse_url(urldecode($_GET['url']), PHP_URL_QUERY);
	if(empty($urlquery) || stripos($urlquery, 'responsive=1') !== false) {
		$urldata = explode('/', trim(urldecode($_GET['url']), '/'));
		$url_pageseed = array_pop($urldata);
		if(stripos($url_pageseed, '?') !== false) $url_pageseed = array_pop($urldata); // Do it again if any parameters in there
		// Now, let's look up the file_ref via the page seed
		$located_file = getRow("SELECT `file_id` FROM {$evp->options->prefix}files_data WHERE `key` = 'data[page_seed]' && `value`= '{$url_pageseed}'");
		$file_ref = $located_file->file_id;
	} else {
		parse_str($urlquery, $urldata);
		$file_ref = $urldata['file_ref'];
	}
}

$parts = explode('::', $file_ref, 2);
$file_id = $parts[0];
$profile = $parts[1];

// We should check to see if the page is explicitly disabled
$isPageDisabled = getRow("SELECT `file_id` FROM {$evp->options->prefix}files_data WHERE `file_id` = '{$file_id}' && `key` = 'options[video_page_disabled]' && (`value` = 'true' || `value` = '1')");
if($isPageDisabled && $mode != 'iframe') {
	$file_ref = ''; // Disable the page if it's set
}

// Fire up the API
$api = new API(array('xmlRoot' => 'oembed'));
$api->sendContentType(true);
$responseType = $_REQUEST['format'];
if(!empty($_GET['callback'])) $responseType = 'jsonp';
if(!empty($responseType)) $api->setResponseType($responseType);

if(!empty($file_ref)) $file = $evp->getFile($file_ref);

// The metadata MUST be set before this works properly!
// So let's redirect them to the page to set it first off
if(empty($file->metadata)) redirect('admin/files.metadata.php', array('id' => $file->id, 'redirect' => currentUrl()));

// Do we have a file?
if(empty($file_ref) || empty($file)) {
	$apiData = array('message' => 'failed.');
} else {
	$file_settings = $evp->collateFileSettings($file, $profile);
	$file_ref = $file->id;
	if(!empty($profile)) $file_ref.= "::{$profile}";

	$video_width = pick($_GET['width'], $file_settings->options['width']);
	$video_height = pick($_GET['height'], $file_settings->options['height']);

	$skin = pick($file_settings->options['skin'], 'minima');
	$related_image = url("player/assets/jwplayer-5.10/skins/{$skin}/{$skin}.png");
	$related_image_width = 540;
	$related_image_height = 280;
	if(!empty($file_settings->options['related_image']) && $file_settings->options['related_image'] != url('player/images/no-image.png?v=1', false, true)) {
		$related_image = $file_settings->options['related_image'];
		if(!empty($file_settings->options['splash_width'])) $related_image_width = intval($file_settings->options['splash_width']);
		if(!empty($file_settings->options['splash_height'])) $related_image_height = intval($file_settings->options['splash_height']);
	}

	$embed_mode = 'js';
	$embed_args = array('width' => $video_width, 'height' => $video_height);
	$embed_urls = array();

	// Do we want a responsive video? This is pretty hack-y but it will work!
	if(stripos($currentUrl, 'responsive=1') || stripos($_GET['url'], 'responsive=1') !== false) {
		$embed_mode = 'responsive';
		if(stripos($currentUrl, 'responsiveOnlyMobile=1') !== false || stripos($_GET['url'], 'responsiveOnlyMobile=1') !== false) $embed_urls['responsiveOnlyMobile'] = true;
	}

	$embed_code = $evp->videoEmbedCode($file, 'sd', $profile, false, $embed_mode, $embed_args, $embed_urls);

	if($responseType == 'json' || $responseType == 'jsonp') {
		$embed_code = $embed_code;//htmlentities($embed_code);//str_replace(array('<', '>'), array('\u003C', '\u003E'), $embed_code);
	} elseif($responseType == 'xml') {
		$embed_code = htmlentities($embed_code);
	}

	$apiData = array(
		'html' => $embed_code,
		'title' => pick($file_settings->options['page-seo-title'], '&nbsp;'),
		'description' => pick($file_settings->options['page-seo-description'], '&nbsp;'),
		'thumbnail_url' => $related_image,
		'thumbnail_width' => $related_image_width,
		'thumbnail_height' => $related_image_height,
		'type' => 'video',
		'provider_name' => $evp->settings->site_name,
		'provider_url' => url(),
		'width' => $video_width,
		'height' => $video_height,
		'duration' => $file->metadata['duration'],
		'version' => '1.0'
	);

	if($_GET['master_oembed'] === '1') {
		$apiData['direct_link'] = ($file->source == 2 ? $evp->s3->getUrl($file->file_name, 315569260) : $file->location);
	}
}

$api->setResponseData($apiData)->respond();
?>
