<?php
$totally_disable_caching = false;

// Let's load up EVP
require('application.php');
require('application.bootstrap.php');

if($evp->options->debug == true) $totally_disable_caching = true;

// If this is the hosted version and we're not trying to compile, redirect 'em
if(!$totally_disable_caching && $evp->options->hosted === true && $_GET['method'] !== 'compile' && $evp->s3 && !empty($evp->settings->s3_bucket)) {
	header('HTTP/1.1 301 Moved Permanently');
	header("Location: {$config['locations']['protocol']}://{$evp->settings->s3_bucket}.s3.amazonaws.com/player/assets.lightning.js?v={$evp->options->project_version}");
	exit;
}

if(!ob_start('ob_gzhandler')) ob_start();

header("Content-Type: application/x-javascript");
header("Expires: Mon, 26 Jul 2050 05:00:00 GMT");

// Does the cached version exist already?
$cache_id = 'evp-assets-lightning-'.$evp->options->project_version;
$cached = $config['paths']['base'].'/assets/cache/'.($cache_id).'.js';
if(!$totally_disable_caching && file_exists($cached)) {
	echo file_get_contents($cached);
	return;
}

$database = Registry::retrieve('database');
if($database) $database->close();

ob_start();

// Include polyfills
include('assets/lightning-1.0/assets/polyfill-console.js');
include('assets/lightning-1.0/assets/polyfill-bind.js');
include('assets/lightning-1.0/assets/merge.js');
?>

var EVS = window.EVS;
if(!EVS) {
	
	<?php include('assets/lightning-1.0/assets/qevent.js'); ?>
	
	<?php include('assets/lightning-1.0/evs.js'); ?>
	
	(function() {
		<?php include('assets/lightning-1.0/assets/jsonp.js'); echo "\n"; ?>
		EVS.JSONP = JSONP;
	})();

	(function() {
		<?php include('assets/lightning-1.0/assets/bonzo.js'); echo "\n"; ?>
	}).bind(EVS)();
	
	EVS.$ = EVS.bonzo;
	EVS.Event = QEvent;
	delete EVS.bonzo;
	
	(function($, $E) {
		<?php include('assets/lightning-1.0/assets/pass.js'); ?>
		<?php include('assets/lightning-1.0/assets/base64.js'); ?>
		<?php include('assets/lightning-1.0/load.php'); ?>
		EVS.Lightning = Lightning;
		EVS.getLightningPlayer = getLightningPlayer;
	})(EVS.$, EVS.Event);
}
<?php
// Store in the cache
$assetsToCache = ob_get_clean();
@file_put_contents($cached, $assetsToCache);
echo $assetsToCache;
?>