<?php
$totally_disable_caching = false;

// Let's load up EVP
require('application.php');
require('application.bootstrap.php');

if($evp->options->debug == true) $totally_disable_caching = true;

// If this is the hosted version and we're not trying to compile, redirect 'em
if(!$totally_disable_caching && $evp->options->hosted === true && $_GET['method'] !== 'compile' && $evp->s3 && !empty($evp->settings->s3_bucket)) {
	header('HTTP/1.1 301 Moved Permanently');
	header("Location: {$config['locations']['protocol']}://{$evp->settings->s3_bucket}.s3.amazonaws.com/player/assets.js?v={$evp->options->project_version}");
	exit;
}

if(!ob_start('ob_gzhandler')) ob_start();

header("Content-Type: application/x-javascript");
header("Expires: Mon, 26 Jul 2050 05:00:00 GMT");

// Does the cached version exist already?
$cache_id = 'evp-assets-'.$evp->options->project_version;
$cached = $config['paths']['base'].'/assets/cache/'.($cache_id).'.js';
if(!$totally_disable_caching && file_exists($cached)) {
	echo file_get_contents($cached);
	return;
}

$database = Registry::retrieve('database');
if($database) $database->close();

ob_start();
// Now let's include our required libraries
include('assets/jquery-1.6.2.js');
include('assets/jquery.ui.js');
include('assets/jquery.class.js');
include('assets/jquery.timeago.js');
include('assets/jquery.cookie.js');
include('assets/jquery.imageload.js');
include('assets/jquery.json.js');
include('assets/jquery.base64.js');
include('assets/jquery.md5.js');
include('assets/jquery.transit.js');
include('assets/jquery.colour.js');
include('assets/jquery.box-shadow.js');
include('assets/jquery.tinycarousel.js');
include('assets/colorbox-1.3.18/jquery.colorbox.js');
?>
(function($) {

	<?php
	/*
	// Load SoundManager here, so it's namespaced!
	include('assets/soundmanager2/script/soundmanager2-nodebug-jsmin.js');
	$.soundManager = soundManager;
	*/
	
	// Load PHPJS - in here because that namespaces it into this function! :)
	include('assets/phpjs.js');
	
	// Load the main EVP file
	require('evp.js');
	
	// Now we need to include a loader file which loads up the assets
	// We support JWP and a custom YouTube player right now; these could be modified or expanded upon
	
	require('assets/jwplayer-5.10/load.php');
	require('assets/youtube/load.php');

	// Very finally, let's close our anonymous function
	// This also namespaces jQuery as $ inside that, and returns the global $ to its rightful owner
	?>
})(jQuery.noConflict(true));
<?php
// Store in the cache
$assetsToCache = ob_get_clean();
@file_put_contents($cached, $assetsToCache);
echo $assetsToCache;
?>