var EVS = window.EVS = {
	'settings': {},
	'files': {},
	'helpers': {
		'cached': {},
		'injectStylesheet': function(href) {
			var head = document.getElementsByTagName('head')[0];
			var link = document.createElement('link');
			link.href = href;
			link.type = 'text/css';
			link.rel = 'stylesheet';
			head.appendChild(link);
		},
		'isHTML5': function() {
			if(typeof this.cached.isHTML5 != 'undefined') return this.cached.isHTML5;
			
			var flashInstalled = false;
			if(window.ActiveXObject) {
		  var control = null;
		  try {
		   control = new ActiveXObject('ShockwaveFlash.ShockwaveFlash');
		  } catch (e) {}
		  if(control) flashInstalled = true;
		 } else if (navigator.plugins && navigator.plugins.length) {
				for (n = 0; n < navigator.plugins.length; n++) {
					if (navigator.plugins[n].name.indexOf('Shockwave Flash') != -1) {
						flashInstalled = true;
						break;
					}
				}
			}
			
			if(flashInstalled && EVS.helpers.isAndroid()) flashInstalled = false; // Don't allow HTML5 for Android
			
			this.cached.isHTML5 = !flashInstalled;
			
			return !flashInstalled;
		},
		'isIE': function() {
			return ('isIE' in this.cached ? this.cached.isIE : this.cached.isIE = /msie/i.test(navigator.userAgent));
		},
		'isiPhone': function() {
			return ('isiPhone' in this.cached ? this.cached.isiPhone : this.cached.isiPhone = /iPhone/i.test(navigator.userAgent));
		},
		'matchUA': function(str) {
			return str.test(navigator.userAgent.toLowerCase());
		},
		'isOldiPhone': function() {
			if('isOldiPhone' in this.cached) return this.cached.isOldiPhone;
			
			var ret = false;
			
			if(navigator.userAgent.match(/iPhone/i)) { // Is it an iPhone?
				var bench = function(){
					var time,
					init = new Date(),
					iterations = 10000;
					while (iterations--) {
						Math.sqrt(iterations*Math.random());
					}
					time = new Date() - init;
					return time;
				}
				
				var speed = bench();
				if(speed == 1) ret = false; // This is way too quick to be a 3gs
				else if(speed >= 4) ret = true; // 3gs takes 3+ (Tested)
			}
			
			ret = false;
			
			this.cached.isOldiPhone = ret;
			
			return ret;
		},
		'isiPad': function() {
			return ('isiPad' in this.cached ? this.cached.isiPad : this.cached.isiPad = /iPad/i.test(navigator.userAgent));
		},
		'isiPod': function() {
			return ('isiPod' in this.cached ? this.cached.isiPod : this.cached.isiPod = /iPod/i.test(navigator.userAgent));
		},
		'isAndroid': function() {
			return ('isAndroid' in this.cached ? this.cached.isAndroid : this.cached.isAndroid = /android/i.test(navigator.userAgent));
		},
		'isBlackberry': function() {
			return ('isBlackberry' in this.cached ? this.cached.isBlackberry : this.cached.isBlackberry = /blackberry/i.test(navigator.userAgent));
		},
		'isMobileOS': function() {
			return ('isMobileOS' in this.cached ? this.cached.isMobileOS : this.cached.isMobileOS = (this.isAndroid() || this.isiPhone() || this.isiPad() || this.isiPod() || this.isBlackberry()));
		},
		'isDesktopOS': function() {
			return ('isDesktopOS' in this.cached ? this.cached.isDesktopOS : this.cached.isDesktopOS = !this.isMobileOS());
		},
		'getPlatform': function() {
			var platform = 'desktop';
			
			if(this.isiPhone() || this.isiPad() || this.isiPod()) {
				if(this.isOldiPhone()) platform = 'ios-legacy';
				else platform = 'ios';
			} else if(this.isAndroid()) {
				platform = 'android';
			} else if(this.isBlackberry()) {
				platform = 'blackberry';
			} else {
				if(this.isIE()) platform += '-msie';
				else if(this.matchUA(/webkit/)) platform += '-webkit';
				else if(this.matchUA(/opera/)) platform += '-opera';
				else if(this.matchUA(/firefox/)) platform += '-firefox';
			}
			
			return platform;
		}
	}
};