/***************************************************
/* Lightning Player - v1.0 - Copyright WebActix 2013+
*/

var players = {}, player_apis = {};

function registerLightningPlayer(player_id, api) {
	players[player_id] = api;
}

function getLightningPlayer(player_id) {
	return players[player_id] || {};
}

var convertEventResponse = function(event, response) {
	var args = Object.deepMerge({}, response);
	return args;
}

function Lightning(file_ref, container_id) {
	var klass = this;
	this.file = EVS.files[file_ref];
	var player_id = this.player_id = 'evs-lightning-'+Math.random().toString(36).substring(7);
	this.elements = {};
	
	EVS.helpers.injectStylesheet(EVS.settings.location+'/player/assets/lightning-1.0/lightning.css');
	
	// Set the file location, and switch to the child video if we need to
	var file_location = this.file.config.encoded_location;
	if(EVS.helpers.isMobileOS() && !EVS.helpers.isiPad() && typeof this.file.children['480x360'] != 'undefined') file_location = this.file.children['480x360'].encoded_location;
	file_location = Base64.decode(file_location);
	
	// Get the splash image and thumbnail
	var splash_location = '', thumbnail_location = '';
	if(typeof this.file.thumbnails != 'undefined' && typeof this.file.thumbnails[0] != 'undefined') {
		thumbnail_location = this.file.thumbnails[0];
	//splash_location = thumbnail_location;
	}
	if(this.file.options.related_image_mode == 'splash') splash_location = this.file.options.related_image;
	
	this.init = function() {
		// Size the wrapper
		$(this.elements['container_element']).css({
			'width': this.file.options.width,
			'height': this.file.options.height,
			'position': 'relative'
		});
		
		// Insert the video wrapper
		this.elements['video_wrap'] = document.createElement('div');
		$(this.elements['video_wrap']).addClass('evs-lightning-video-wrap').appendTo(this.elements['container_element']);
	};
	
	this.track = function(mode, extra_data) {
		if(this.file.options.disable_stat_tracking == true) {
			return this;
		}
		
		if(!extra_data) extra_data = {};
		
		var data = Object.deepMerge({
			'method': 'public-statistics-track',
			'responseType': 'jsonp',
			'file_ref': this.file.file_ref,
			'mode': mode
		}, extra_data);
		
		EVS.JSONP.get(EVS.settings.api_location, data);
		
		return this;
	};
	
	this.splash = function(splashClick, straightInject) {
	//if(splash_location.length > 0 && !EVS.helpers.isMobileOS()) {
		if(splash_location.length > 0) {
			var splash_wrap = klass.elements['splash_wrap'] = document.createElement('div'), splash_img = klass.elements['splash_img'] = document.createElement('img'), splash_play_bg = klass.elements['splash_play_bg'] = document.createElement('div'), splash_play = klass.elements['splash_play'] = document.createElement('div');
			
			$(splash_wrap).addClass('evs-lightning-video-splash-wrap').css({
				'width': klass.file.options.width,
				'height': klass.file.options.height
			});
			
			$(splash_img).addClass('evs-lightning-video-splash-img').css({
				'width': klass.file.options.width,
				'height': klass.file.options.height,
				'display': 'block'
			}).attr({'src': splash_location});
			
			$(splash_play_bg).addClass('evs-lightning-video-splash-play-bg').css({
				'width': klass.file.options.width,
				'height': klass.file.options.height,
				'background-image': (klass.file.options.related_image_play == true ? 'url('+EVS.settings.location+'/player/assets/jwplayer-5.10/skins/modieus/display/background.png)' : '')
			});
			
			$(splash_play).addClass('evs-lightning-video-splash-play').css({
				'width': klass.file.options.width,
				'height': klass.file.options.height,
				'background-image': (klass.file.options.related_image_play == true ? 'url('+EVS.settings.location+'/player/assets/jwplayer-5.10/skins/modieus/display/playIcon.png)' : '')
			});
			
			$(splash_img).appendTo(splash_wrap);
			$(splash_play).appendTo(splash_play_bg);
			$(splash_play_bg).appendTo(splash_wrap);
			$(splash_wrap).appendTo(klass.elements['container_element']);
			
			splashClick();
			
		} else {
			straightInject();
		}
	};
	
	this.setReady = function() {
		klass.api._ready = true;
		klass.api._player = klass.elements['video_element'];
	};
	
	this.embed = {
		'html5': function() {
			var video = klass.elements['video_element'] = document.createElement('video');
			$(video).addClass('evs-lightning-video');
			video.id = player_id;
			
			var attr = {
				'width': klass.file.options.width,
				'height': klass.file.options.height,
				'preload': 'none',
				'controls': 'controls',
				'x-webkit-airplay': 'allow',
			//'poster': 'data:image/gif;base64,R0lGODlhAQABAIAAAP///wAAACH5BAEAAAAALAAAAAABAAEAAAICRAEAOw==', // This breaks iOS's display of the CSS background
				'src': file_location
			};
			
			if(thumbnail_location.length > 0) $(video).css({'background-image': 'url('+thumbnail_location+')'});
			
			$(video).attr(attr);
			
			klass.splash(function() {
				$E.add(klass.elements['splash_wrap'], 'click', function() {
					$(klass.elements['splash_wrap']).detach();
					$(video).appendTo(klass.elements['video_wrap']);
					klass.setReady();
					video.load();
					video.play();
				});
			}, function() {
				klass.setReady();
				$(video).appendTo(klass.elements['video_wrap']);
			});
		},
		'flash': function() {
			var swf_location = EVS.settings.location+'/player/assets/jwplayer-5.10/player.swf';
			
			function appendAttribute(object, name, value) {
				var param = document.createElement('param');
				param.setAttribute('name', name);
				param.setAttribute('value', value);
				object.appendChild(param);
			};
			
			function jsonToFlashvars(json) {
				var flashvars = json.netstreambasepath ? '' : 'netstreambasepath=' + encodeURIComponent(window.location.href.split("#")[0]) + '&';
				for (var key in json) {
					if (typeof(json[key]) == "object") {
						flashvars += key + '=' + encodeURIComponent("[[JSON]]"+jwplayer.utils.strings.jsonToString(json[key])) + '&';
					} else {
						flashvars += key + '=' + encodeURIComponent(json[key]) + '&';
					}
				}
				return flashvars.substring(0, flashvars.length - 1);
			};
			
			var flashvars = {
				'file': file_location,
				'autostart': klass.file.options.autoPlay || klass.file.options.auto_play || false,
				'stretching': 'fill',
				'playlist.position': 'none',
				'controlbar.position': 'over',
				'abouttext': 'EasyVideoSuite',
				'aboutlink': 'http://easyvideosuite.com/',
				'skin': EVS.settings.location+'/player/assets/jwplayer-5.10/skins/'+klass.file.options.skin+'/'+klass.file.options.skin+'.xml'
			};
			
			if(thumbnail_location.length > 0) flashvars.image = thumbnail_location;
	
			var flashPlayer;
			if(EVS.helpers.isIE()) {
				var html = '<object classid="clsid:D27CDB6E-AE6D-11cf-96B8-444553540000" bgcolor="#000000" width="100%" height="100%" id="'+player_id+'" name="'+player_id+'" tabindex=0">';
				html += '<param name="movie" value="'+swf_location+'">';
				html += '<param name="allowfullscreen" value="true">';
				html += '<param name="allowscriptaccess" value="always">';
				html += '<param name="seamlesstabbing" value="true">';
				html += '<param name="wmode" value="transparent">';
				html += '<param name="flashvars" value="'+jsonToFlashvars(flashvars)+'">';
				html += '</object>';
		
				$(klass.elements['video_wrap']).html(html);
								
				flashPlayer = document.getElementById(player_id);
			} else {
				var obj = document.createElement('object');
				obj.setAttribute('type', 'application/x-shockwave-flash');
				obj.setAttribute('data', swf_location);
				obj.setAttribute('width', "100%");
				obj.setAttribute('height', "100%");
				obj.setAttribute('bgcolor', '#000000');
				obj.setAttribute('id', player_id);
				obj.setAttribute('name', player_id);
				obj.setAttribute('tabindex', 0);
				appendAttribute(obj, 'allowfullscreen', 'true');
				appendAttribute(obj, 'allowscriptaccess', 'always');
				appendAttribute(obj, 'seamlesstabbing', 'true');
				appendAttribute(obj, 'wmode', 'transparent');
				appendAttribute(obj, 'flashvars', jsonToFlashvars(flashvars));
				$(obj).appendTo(klass.elements['video_wrap']);
				flashPlayer = obj;
			}
			
			klass.elements['video_element'] = flashPlayer;
			
			var addedReady = false;
			setTimeout(function() {
				if(addedReady) return;
				try {
					flashPlayer.jwAddEventListener('jwplayerReady', 'function() { EVS.getLightningPlayer("'+player_id+'").setReady(); }');
					addedReady = true;
				} catch(e) {
					setTimeout(arguments.callee, 10);
				}
			}, 10);
			
			klass.splash(function() {
				$E.add(klass.elements['splash_wrap'], 'click', function() {
					$(klass.elements['splash_wrap']).detach();
					if(typeof flashPlayer.jwPlay !== 'undefined') {
						flashPlayer.jwPlay();
					} else {
						setTimeout(function() {
							flashPlayer.jwPlay();
						}, 250);
					}
				});
			}, function() {
				// Do nothing, as it's already injected
			});
		}
	};
	
	this.apis = {
		'flash': {
			'_player': undefined,
			'_ready': false,
			'_events': {},
			'_eventMap': {
				'complete': 'jwplayerMediaComplete',
				'metadata': 'jwplayerMediaMeta' // This fires 3 times, with different information inside!
			},
			'_customEvents': {
				'onStart': function() {
					var hasFired = false;
					var args = Array.prototype.slice.call(arguments, 0), k = this;
					this.addEvent('onPlay', function(a) {
						if(a.oldState == 'BUFFERING' && !hasFired) {
							args[1].call(k);
							hasFired = true;
						}
					});
				}
			},
			'_states': {},
			'_stateMap': {
				'play': 'PLAYING',
				'pause': 'PAUSED',
				'buffer': 'BUFFERING',
				'idle': 'IDLE'
			},
			'init': function() {
				//
			},
			'addEvent': function(event, fn) {
				var isState = (event.substr(0, 2) == 'on');
				
				if(isState) { // Bind to a state change, if it's not inside the event map (mapping 'state'-similar events to real Flash events)
					var inEventMap = this._eventMap[event.substr(2).toLowerCase()];
					if(inEventMap) {
						this.addEvent(inEventMap, fn);
					} else {
						if(!this._states[event]) this._states[event] = [];
						this._states[event].push(fn);
						var wantedState = this._stateMap[event.substr(2).toLowerCase()];
						var k = this;
						this.addEvent('jwplayerPlayerState', function(args) {
							var newstate = args.newstate, oldstate = args.oldstate;
							if(newstate == wantedState) {
								for (var l = 0; l < k._states[event].length; l++) {
									if (typeof k._states[event][l] == 'function') {
										k._states[event][l].call(k, {'oldState': oldstate, 'newState': newstate});
									}
								}
							}
						});
					}
				} else { // Listen for an event thrown by the player itself
					if(!this._events[event]) this._events[event] = [];
					this._events[event].push(fn);
					var s = 'EVS.getLightningPlayer("'+player_id+'").api.fireEvent("'+event+'", dat);';
					try {
						this._player.jwAddEventListener(event, 'function(dat) { '+s+' }');
					} catch(e) { console.error(e, s); }
				}
				return klass;
			},
			'removeEvent': function() {
				//
			},
			'onCuepoint': function(time, callback) {
				var exec = false;
				var r = function() { exec = false; };
				this.addEvent('ended', r);
				this.addEvent('jwplayerMediaSeek', r);
				this.addEvent('jwplayerMediaTime', function(event) {
					var second = Math.floor(event.position);
					if(second == time && exec === false) { // Only fire it once!
						exec = true;
						callback(second);
					}
				});
			},
			'fireEvent': function(event) {
				var args = Array.prototype.slice.call(arguments, 0);
				if(this._events[event]) {
					var args = convertEventResponse(event, arguments[1]);
					for (var l = 0; l < this._events[event].length; l++) {
						if (typeof this._events[event][l] == 'function') {
							this._events[event][l].call(this, args);
						}
					}
				}
				return klass;
			},
			'play': function() {
				this._player.jwPlay();
				return klass;
			},
			'pause': function() {
				this._player.jwPause();
				return klass;
			},
			'stop': function() {
				this._player.jwStop();
				return klass;
			},
			'seek': function(position) {
				this._player.jwSeek(position);
				return klass;
			},
			'getDuration': function() {
				return this._player.jwGetDuration();
			},
			'getPosition': function() {
				return this._player.jwGetPosition();
			}
		},
		'html5': {
			'_player': undefined,
			'_ready': false,
			'_events': {},
			'_eventMap': {
				'complete': 'ended'
			},
			'_customEvents': {
				'onStart': function() {
					var hasFired = false;
					var args = Array.prototype.slice.call(arguments, 0), k = this;
					this.addEvent('onPlay', function(a) {
						if(!hasFired) {
							args[1].call(k);
							hasFired = true;
						}
					});
				}
			},
			'_states': {},
			'_stateMap': {},
			'init': function() {
				//
			},
			'addEvent': function(event, fn) {
				var k = this;
				
				var isState = (event.substr(0, 2) == 'on');
				
				if(isState) { // Bind to a state change, if it's not inside the event map (mapping 'state'-similar events to real Flash events)
					var inEventMap = this._eventMap[event.substr(2).toLowerCase()];
					if(inEventMap) {
						this.addEvent(inEventMap, fn);
					} else {
						var wantedEvent = event.substr(2).toLowerCase();
						$E.add(k._player, wantedEvent, fn);
					}
				} else {
					if(!this._events[event]) this._events[event] = [];
					this._events[event].push(fn);
					$E.add(k._player, event, fn);
				}
			},
			'removeEvent': function() {
				//
			},
			'onCuepoint': function(time, callback) {
				var exec = false;
				var r = function() { exec = false; };
				this.addEvent('ended', r);
				this.addEvent('timeupdate', function(event) {
					var second = Math.floor(klass.api.getPosition());
					if(second >= time && second <= time + 0.3 && exec === false) { // Only fire it once!
						exec = true;
						callback(second);
					}
				});
			},
			'play': function() {
				this._player.play();
				return this;
			},
			'pause': function() {
				this._player.pause();
				return this;
			},
			'stop': function() {
				this._player.pause();
				var src = this._player.getAttribute('src'), k = this;
				this._player.removeAttribute('src');
				setTimeout(function() {
					k._player.setAttribute('src', src);
				}, 50);
			},
			'seek': function(position) {
				this._player.currentTime = position;
				this.play();
				return this;
			},
			'getDuration': function() {
				return parseInt(this._player.duration || 0);
			},
			'getPosition': function() {
				return parseInt(this._player.currentTime || 0);
			}
		}
	};
	
	this.addEvent = function(event, fn) {
		if(klass.api._ready === false) {
			setTimeout(pass(arguments.callee, arguments), 50);
			return;
		}
		if(klass.api._customEvents[event]) {
			klass.api._customEvents[event].call(klass.api, event, fn);
		} else {
			klass.api.addEvent(event, fn);
		}
		return this; 
	};
	
	this.removeEvent = function(event, fn) {
		//
	};
	
	this.fireEvent = function() {
		//
	};
	
	this.onCuepoint = function(time, callback) { // Don't forget time is a single-second, not ms
		if(klass.api._ready === false) {
			setTimeout(pass(arguments.callee, arguments), 50);
			return;
		}

		klass.api.onCuepoint(time, callback);
		
		return this;
	};
	
	this.initialiseTracking = function() {
		this.addEvent('onStart', function() {
			klass.track('start', {'uuid': EVS.settings.uuid, 'platform': EVS.helpers.getPlatform()});
		});
		
		this.addEvent('onComplete', function() {
			klass.track('complete', {'uuid': EVS.settings.uuid, 'time': klass.api.getPosition(), 'referrer': Base64.encode(window.location.href)});
		});
		
		if(this.file.config.trackProgression) {
			var duration = Math.ceil(this.file.metadata.duration);
			var interval = Math.floor(duration / 10); // Let's fire a maximum of X intervals, so when should they happen?
			var counter = 1;
			
			if(interval < 1) return; // Don't track if there is no interval!
			
			for(var x = interval; x < duration; x += interval) {
			
				var fn = function(current_time) {
					klass.track('progress', {'uuid': EVS.settings.uuid, 'time': counter, 'player_time': current_time});
					counter++;
				};
				
				this.onCuepoint(x, fn);
			}
		}
	};
	
	if(EVS.helpers.isHTML5()) {
		this.api = this.apis.html5;
	} else {
		this.api = this.apis.flash;
	}
	
	registerLightningPlayer(player_id, this); // Register this player now it's ready
	this.api.init.call(this.api);
	
	this.addEvent('onMetadata', function(response) {
		if(response.metadata.status) return;
		if(klass.file.metadata) return;
		
		var meta = {
			'nativeWidth': response.metadata.width || 640,
			'nativeHeight': response.metadata.height || 360,
			'duration': response.metadata.duration || klass.getDuration(),
			'codec': {
				'framerate': response.metadata.videoframerate,
				'codec': response.metadata.videocodecid,
				'audioChannels': response.metadata.audiochannels,
				'audioCodec': response.metadata.audiocodecid,
				'audioSampleRate': response.metadata.audiosamplerate
			}
		};
		
		klass.file.metadata = meta;
		
		EVS.JSONP.get(EVS.settings.api_location, {'method': 'public-metadata-save', 'file_id': klass.file.file_id, 'responseType': 'jsonp', 'metadata': meta});
	});
	
	this.initialiseTracking();
	
	$E.add(window, 'domready', function() {
		klass.elements['container_element'] = document.getElementById(container_id);
		if(!klass.elements['container_element']) {
			console.error('The container you have chosen is not available.');
			return;
		}
		
		klass.init();
		
		if(EVS.helpers.isHTML5()) {
			klass.embed.html5();
		} else {
			klass.embed.flash();
		}
	});
}