EVP3.players.extend('EVP3.players.youtube', {
	'parseURL': function(name, url) {
	  name = name.replace(/[\[]/, "\\\[").replace(/[\]]/, "\\\]");
	  var regexS = "[\\?&]" + name + "=([^&#]*)";
	  var regex = new RegExp(regexS);
	  var results = regex.exec(url);
	  if(results == null) return '';
	  else return decodeURIComponent(results[1].replace(/\+/g, ' '));
	},
	'embed': function() {
		var player_api = this;
		var klass = this;

		this.cuepoints = this.cuepoints || [];

		var loc = this.player_location;
		var file = this.file;

		var config = this.getConfig();

		var videoID = this.parseURL('v', this.file.config.location || base64_decode(this.file.config.encoded_location));

		var hasMetaData = !(file.metadata == false);

		if(hasMetaData) {
			setTimeout(function() {
				player_api.evp.fireEvent('onMetaData', [player_api.file.metadata, false]);
			}, 500);
		}

		var control_position = 'over';
		if(this.file.options.player_controls == 'hide') control_position = 'none';
		if(this.file.config.type == 'audio' || EVP.helpers.isMobileOS() || EVP.helpers.isAndroid()) control_position = 'bottom';
		if(this.file.options.player_controls == 'fauxlive') control_position = 'none';

		var icons = true;
		if(this.file.config.type == 'audio' && this.file.options.related_image_mode == 'splash' && this.file.options.related_image_play == false) icons = false;

		var saveMetaData = function(k) {
			if(!hasMetaData) {
				setTimeout(function() {
					var meta = {
						'nativeWidth': 640,
						'nativeHeight': 360,
						'duration': k.getDuration()
					};
					// Fire off a JSONP request
					$.ajax({
						'url': EVP3.settings.api_location,
						'dataType': 'jsonp',
						'data': {'method': 'public-metadata-save', 'responseType': 'jsonp', 'file_id': file.file_id, 'metadata': meta},
						'complete': function() {
							// Fire an event
							player_api.file.metadata = meta;
							player_api.evp.fireEvent('onMetaData', [meta, true]);
						}
					});
				}, 200); // You have to wait so long for audio files with busted metadata
				hasMetaData = true;
			}
		};

		if(typeof this.file.options.watermark !== 'undefined' && this.file.options.watermark.indexOf('/player/images/no-image.png') !== -1) this.file.options.watermark_enabled = false; // Don't show the placeholder

		var readyFired = player_api.evp.readyFired = false;
		var player;

		$.getScript('https://www.youtube.com/iframe_api');

		var v = $('#'+player_api.container_id+'-video').attr('id', player_api.container_id+'-video_wrapper').empty();//.css({'position': 'relative'});

		if(!EVP.helpers.isMobileOS()) v.css({'position': 'relative'});

		$('<div id="'+klass.container_id+'-video"></div>').appendTo(v);

		var skinUrl = EVP3.settings.location+'/player/assets/jwplayer-5.10/skins/evs-m-1';

		var cover = $('<div id="'+klass.container_id+'-video-cover"></div>').css({
			'position': 'absolute',
			'top': 0,
			'left': 0,
			'width': '100%',
			'height': '100%',
			'cursor': 'pointer'
		}).appendTo(v);

		if(!EVP.helpers.isMobileOS()) cover.css({'background': 'url('+skinUrl+'/display/playIcon.png) no-repeat center center'});

		var controlIcon = $('<div id="'+klass.container_id+'-control-icon"></div>').css({
			'width': 21,
			'height': 28,
			'background': 'url('+skinUrl+'/controlbar/playButton.png)',
			'position': 'absolute',
			'bottom': 0,
			'left': 13,
			'cursor': 'pointer'
		}).hover(function() {
			var currentState = $(this).data('currentState') || 'pause';
			var b = 'pauseButtonOver';
			if(currentState == 'pause') {
				b = 'playButtonOver';
			}
			$(this).css({
				'background-image': 'url('+skinUrl+'/controlbar/'+b+'.png)'
			});
		}, function() {
			var currentState = $(this).data('currentState') || 'pause';
			var b = 'pauseButton';
			if(currentState == 'pause') {
				b = 'playButton';
			}
			$(this).css({
				'background-image': 'url('+skinUrl+'/controlbar/'+b+'.png)'
			});
		}).click(function() {
			player_api.api.toggle();
		});

		var scrubber_wrap = $('<div id="'+klass.container_id+'-scrubber_wrap"></div>').css({
			'width': parseInt(config.player_width),// - 20,
			'height': '28px',
			'background': 'url('+skinUrl+'/controlbar/background.png) repeat-x',
			'position': 'absolute',
			'bottom': 0,
			'left': 0,
			'cursor': 'pointer',
			'display': (control_position == 'over' ? 'block' : 'none')
		});

		var scrubber = $('<div id="'+klass.container_id+'-scrubber"></div>').css({
			'width': parseInt(config.player_width) - 2 - 70 - 50, // Minus the play icon and times
			'height': '10px',
			'background': 'url('+skinUrl+'/controlbar/timeSliderBuffer.png) repeat-x',
			'background-size': 'cover',
			'position': 'absolute',
			'cursor': 'pointer',
			'top': 9,
			'left': 45
		});

		var scrubberInner = $('<div id="'+klass.container_id+'-scrubber-inner"></div>').css({
			'width': 0,
			'height': '10px',
			'background': 'url('+skinUrl+'/controlbar/timeSliderProgress.png) repeat-x',
			'position': 'absolute',
			'background-size': 'cover',
			'cursor': 'pointer',
			'top': 0,
			'left': 0
		});

		var timeSlider = $('<div id="'+klass.container_id+'-time-slider"></div>').css({
			'width': 17,
			'height': 17,
			'background': 'url('+skinUrl+'/controlbar/timeSliderThumb.png)',
			'position': 'absolute',
			'top': -3
		});

		var scrubber_time_total = $('<span id="'+klass.container_id+'-scrubber-time-total"></span>').css({
			'color': '#fff',
			'font-size': 10,
			'float': 'right',
			'cursor': 'pointer',
			'margin': '8px 13px 0 0'
		});

		var scrubber_time_now = $('<span id="'+klass.container_id+'-scrubber-time-now">0:00</span>').css({
			'color': '#fff',
			'font-size': 10,
			'margin-right': 2,
			'margin-top': 8,
			'cursor': 'pointer',
			'float': 'right'
		});

		this.addEvent('play', function() {
			controlIcon.css({'background-image': 'url('+skinUrl+'/controlbar/pauseButton.png)'}).data('currentState', 'play');

			cover.css({'background': 'none'});
		});

		this.addEvent('pause', function() {
			controlIcon.css({'background-image': 'url('+skinUrl+'/controlbar/playButton.png)'}).data('currentState', 'pause');

			cover.css({'background': 'url('+skinUrl+'/display/playIcon.png) no-repeat center center'});
		});

		if(!EVP.helpers.isMobileOS()) {
			v.append(
				scrubber_wrap.append(
					controlIcon,
					scrubber.append(
						scrubberInner.append(
							timeSlider
						)
					),
					scrubber_time_total,
					scrubber_time_now
				)
			);

			if(control_position == 'over') {
				v.hover(function() {
					scrubber_wrap.fadeIn();
				}, function() {
					var s = klass.getState();
					if(s != 'paused' && s != '') scrubber_wrap.fadeOut();
				});
			}
		}

		var existingYTFunctions = {};
		if(typeof onYouTubePlayerAPIReady == 'function') existingYTFunctions['onYouTubePlayerAPIReady'] = onYouTubePlayerAPIReady;

		window.onYouTubePlayerAPIReady = function() {
			if(typeof existingYTFunctions['onYouTubePlayerAPIReady'] == 'function') existingYTFunctions['onYouTubePlayerAPIReady']();

			var currentTime = 0;
			var secondsAsPixels;
			var pixelsAsSeconds;
			var previousStatus = -1;
			var timer;

			cover.click(function() {
				if(previousStatus !== 1) player_api.api.start();
				else player_api.api.pause();
			});

			if(EVP.helpers.isMobileOS()) {
				cover.remove();

				$('#'+player_api.container_id+'-video').css({'position': 'relative'});

				player = player_api.player = new YT.Player(player_api.container_id+'-video', {
					'videoId': videoID,
					'width': config.player_width,
					'height': config.player_height,
					'playerVars': {
						'cc_load_policy': 0,
						'rel': 0,
						'enablejsapi': 1,
						'iv_load_policy': 3,
						'wmode': 'opaque',
						'disablekb': 1,
						'modestbranding': 1,
						'showinfo': 0,
						'showsearch': 0,
						'startSeconds': 0
					},
					'events': {
						'onReady': function(event) {
						//event.target.cueVideoById(videoID, 10, 'medium');
						},
						'onStateChange': function(event) {
							//
						}
					}
				});
			} else {
				player = player_api.player = new YT.Player(player_api.container_id+'-video', {
					'videoId': videoID,
					'width': config.player_width,
					'height': config.player_height,
					'playerVars': {
						'autoplay': (config.auto_play ? 1 : 0),
						'cc_load_policy': 0,
						'controls': 0,
						'rel': 0,
						'enablejsapi': 1,
						'iv_load_policy': 3,
						'wmode': 'opaque',
						'disablekb': 1,
					//'hd': 1,
						'modestbranding': 1,
						'showinfo': 0,
						'showsearch': 0,
						'start': config.delayed_start
					},
					'events': {
						'onReady': function(event) {
							var readyFired = player_api.evp.readyFired;
							if(!readyFired) player_api.evp.fireEvent('onPlayerReady');
							readyFired = player_api.evp.readyFired = player_api.evp.isPlayerReady = true;
							saveMetaData(player);

							// Now let's build the scrubber
							var duration = Math.ceil(player.getDuration());
							scrubber_time_total.text('- '+EVP.helpers.secondsToMaskedTime(duration));

							// Now let's locate our secondsAsPixels value
							secondsAsPixels = parseFloat(scrubber.width() / duration);
							pixelsAsSeconds = parseFloat(duration / scrubber.width());

							// Now we should implement skipping, via the scrubber
							scrubber.click(function(event) {
								var parentOffset = scrubber.offset();
								var clickX = event.pageX - parentOffset.left;
								var x = pixelsAsSeconds * clickX;
								scrubberInner.css({'width': secondsAsPixels * x});
								timeSlider.css({'left': secondsAsPixels * x});
								player_api.api.seek(x);
								setTimeout(function() { player_api.api.start(); }, 100);
							});
						},
						'onStateChange': function(event) {
							if(!timer) {
								if(event.data == 1) {
									var update = function() {
										currentTime = Math.ceil(player.getCurrentTime());
										$.each(klass.cuepoints, function(idx, cp) { // Let's check for cuepoints that must be fired
											if(cp.time == currentTime && cp.exec !== true) {
												cp.exec = true;
												cp.callback();
											}
										});

										// Is the time 0? We should track a 'start' event
										if(currentTime == 1) {
											var platform = EVP.helpers.getPlatform();
											klass.evp.track('start', {'uuid': EVP3.settings.uuid, 'platform': platform});
										}

										// Is the time the

										// Now let's update the current time on the scrubber
										scrubber_time_now.text(EVP.helpers.secondsToMaskedTime(currentTime));

										// And update the scrubber progress
										scrubberInner.css({'width': secondsAsPixels * currentTime});
										timeSlider.css({'left': secondsAsPixels * currentTime});
									};
									timer = setInterval(update, 500);
									update();
								}
							}

							// Has it ended? Track that event
							if(event.data == 0) {
								var endTime = Math.ceil(player.getCurrentTime());
								klass.evp.track('complete', {'uuid': EVP3.settings.uuid, 'time': endTime, 'referrer': $.base64Encode(window.location.href)});
							}

							previousStatus = event.data;
							klass.current_state = event.data;
						},
						'onError': function() {
							//
						}
					}
				});
			}
		}

		var isAPIReady = function(func, args) {
			var k = player_api.api;
			if(typeof player == 'undefined') {
				setTimeout(function() { k[func].apply(k, args); }, 10);
				return false;
			}
			return true;
		}

		player_api.api = {
			'play': function(start) {
				if(start === false) player_api.api.pause();
				else player_api.api.start();
			},
			'start': function() {
				if(!isAPIReady('start', arguments)) return;
				player.playVideo();
			},
			'pause': function() {
				if(!isAPIReady('pause', arguments)) return;
				player.pauseVideo();
			},
			'toggle': function() {
				if(!isAPIReady('toggle', arguments)) return;
				var s = player.getPlayerState();
				if(s == 1) player_api.api.pause();
				else player_api.api.start();
			},
			'stop': function() {
				if(!isAPIReady('stop', arguments)) return;
				player.stopVideo();
			},
			'seek': function(time) {
				if(!isAPIReady('seek', arguments)) return;
				player.seekTo(time, true);
			},
			'onBuffer': function(callback) {
				if(!isAPIReady('onBuffer', arguments)) return;
				player.addEventListener('onStateChange', function(event) {
					if(event.data == YT.PlayerState.BUFFERING) callback();
				});
			},
			'onPlay': function(callback) {
				if(!isAPIReady('onPlay', arguments)) return;
				player.addEventListener('onStateChange', function(event) {
					if(event.data == YT.PlayerState.PLAYING) callback();
				});
			},
			'onIdle': function(callback) { // Idle here is taken as completed!
				if(!isAPIReady('onIdle', arguments)) return;
				player.addEventListener('onStateChange', function(event) {
					if(event.data == 0) callback();
				});
			},
			'onPause': function(callback) {
				if(!isAPIReady('onPause', arguments)) return;
				player.addEventListener('onStateChange', function(event) {
					if(event.data == YT.PlayerState.PAUSED) callback();
				});
			},
			'onComplete': function(callback) {
				if(!isAPIReady('onComplete', arguments)) return;
				player.addEventListener('onStateChange', function(event) {
					if(event.data == 0) callback();
				});
			}
		};
	},
	'getConfig': function() {
		var conf = this._super();
		if(conf.related_image_mode == 'lightbox') conf.auto_play = false;
		return conf;
	},
	'addEvent': function(event, callback) {
		var klass = this;

		var checkForState = function(shouldBe) {
			var b = this, args = arguments;
			if(typeof klass.player == 'undefined') {
				setTimeout(function() { checkForState.apply(b, args); }, 10);
				return false;
			}

			klass.player.addEventListener('onStateChange', function(event) {
				if(event.data == shouldBe) callback();
			});

			return true;
		};

		switch(event) {
			case 'complete':
				checkForState(0);
				break;
			case 'play':
				checkForState(1);
				break;
			case 'pause':
				checkForState(2);
				break;
			default:
				this.player.addEventListener(event, callback);
				break;
		}
	},
	'getState': function() { // Standardised way of grabbing the current state
		var state = this.current_state;
		var ret = '';

		if(state == YT.PlayerState.PLAYING) ret = 'playing';
		else if(state == YT.PlayerState.PAUSED) ret = 'paused';
		else if(state == YT.PlayerState.BUFFERING) ret = 'buffering';

		return ret;
	},
	'onSeek': function() { // This isn't supported by the YouTube player!! @todo Workaround!
		//
	},
	'onCuepoint': function(time, callback) { // Brilliant. Don't forget time is a single-second, not ms
		var klass = this;

		if(typeof this.player == 'undefined') {
			setTimeout(function() { klass.onCuepoint(time, callback); }, 10);
			return false;
		}

		time = Math.floor(time);

		this.cuepoints = this.cuepoints || [];
		this.cuepoints.push({'time': time, 'callback': callback});

		// This callback will be handled in the main, onStateChange event above
	}
});
