Array.prototype.remove = function(element) {
	for (var i = 0; i < this.length; i++) {
		if (this[i] == element) this.splice(i,1);
	}
};

var EVP3 = window.EVP3;
if(!EVP3) {

	var EVP3 = window.EVP3 = {
		'playerAPIs': {},
		'settings': {},
		'files': {},
		'containerRetries': {},
		'attach': function() {
			var instances = [];
			var files = $('[data-role="evp-video"]:not([data-evp-id])'); // This detects old playlist code with incorrect roles accidentally
			$.each(files, function(idx, el) {
				// Get the options
				var opt = $(el).data('evp');
				if(typeof opt !== 'object') opt = {};

				// Overwrite some
				opt.location = opt.location || $(el).data('evp-location');
				opt.width = opt.width || $(el).data('evp-width') || $(el).width();
				opt.height = opt.height || $(el).data('evp-height') || $(el).height();

				// Disable stat tracking
				opt.disable_stat_tracking = true;

				// Give the element an ID
				var id = $(el).attr('id') || 'evp-standalone-'+(Math.floor(Math.random() * 999999999));
				$(el).attr('id', id);

				// Make the file reference
				var file_ref = $(el).data('evp-file-id') || id;

				// Insert the file reference
				EVP3.files[file_ref] = {
					'config': {
						'location': opt.location,
						'type': (opt.location && opt.location.slice(-3) == 'mp3' ? 'audio' : 'video'),
						'prettySource': opt.prettySource
					},
					'embed_code': '',
					'events': {},
					'file_id': file_ref,
					'file_ref': file_ref,
					'metadata': false,
					'plugins': {},
					'widgets': [],
					'options': opt
				};

				// Initialise EVP!
				EVP3.files[file_ref].evp = new EVP(id, file_ref);
				instances.push(EVP3.files[file_ref].evp);
			});
			return instances;
		},
		'grabFromElement': function(ref_el, file_ref) { // Return the EVP instance from an Element, by parent or explicitly
			if(typeof file_ref == 'undefined') { // Let's manually guess it
				if($(ref_el).parent('.evp-element')) { // It's an Element, so let's extract the ID from that!
					var parent = $(ref_el).parent('.evp-element');
					if(parent.length >= 1) {
						file_ref = parent.attr('id').split('-')[2];
					}
				} else {
					var parent = $ref_el.parent('[data-evp-id]');
					if(parent.length >= 1) {
						file_ref = parent.data('evp-id');
					}
				}
				if(!file_ref) return EVP.log('Could not track stats for an Element as the referring video ID cannot be found.', ref_el, 'error');

				return EVP3.files[file_ref].evp;
			}
		}
	};

	$.Class.extend('EVP', {
		'log': function(message, data, type) {
			if(typeof type == 'undefined') type = 'error';
			if(typeof console !== 'undefined' && typeof console[type] !== 'undefined') {
				console[type](message, data);
			}
			return EVP3;
		},
		'helpers': {
			'debounce': function (func, threshold, execAsap) {

    var timeout;

    return function debounced () {
        var obj = this, args = arguments;
        function delayed () {
            if (!execAsap)
                func.apply(obj, args);
            timeout = null;
        };

        if (timeout)
            clearTimeout(timeout);
        else if (execAsap)
            func.apply(obj, args);

        timeout = setTimeout(delayed, threshold || 100);
    };

},
			'injectStylesheet': function(href) {
				var head = $('head');
				var inject = function(url) {
					var existing = head.find('link[href="'+url+'"]');
					if(existing.length > 0) return existing;
					var el = $('<link type="text/css" rel="stylesheet" href="'+url+'" />');
					head.append(el);
					return el;
				}
				if(typeof href == 'string') return inject(href);
				else $.each(href, function(idx, url) { inject(url); });
			},
			'supportsCSSGradients': function() {
				var mElem = document.createElement('modern'), mStyle = mElem.style;

				try {
					mStyle.backgroundImage = 'linear-gradient(left top, #9f9, white)';
					mStyle.backgroundImage = '-o-linear-gradient(left top, #9f9, white)';
					mStyle.backgroundImage = '-moz-linear-gradient(left top, #9f9, white)';
					mStyle.backgroundImage = '-webkit-linear-gradient(left top, #9f9, white)';
					mStyle.backgroundImage = '-ms-linear-gradient(left top, #9f9, white)';
					mStyle.backgroundImage = '-webkit-gradient(linear, left top, right bottom, from(#9f9), to(white))';
				} catch(e) {}

				return (mStyle.backgroundImage.indexOf('gradient') !== -1);
			},
			'supportsCSSAnimations': function() {
				var b = document.body || document.documentElement;
				var s = b.style;
				var p = 'transition';
				if(typeof s[p] == 'string') { return true; }
				v = ['Moz', 'Webkit', 'Khtml', 'O', 'ms'],
				p = p.charAt(0).toUpperCase() + p.substr(1);
				for(var i=0; i<v.length; i++) {
				  if(typeof s[v[i] + p] == 'string') { return true; }
				}
				return false;
			},
			'isHTML5': function() {
				return true;
			// 	var flashInstalled = false;
			// 	if(window.ActiveXObject) {
			//   var control = null;
			//   try {
			//    control = new ActiveXObject('ShockwaveFlash.ShockwaveFlash');
			//   } catch (e) {
			//   	// Do nothing if there's an error
			//   }
			//   if(control) flashInstalled = true;
			//  } else if (navigator.plugins && navigator.plugins.length) {
			// 		for (n = 0; n < navigator.plugins.length; n++) {
			// 			if (navigator.plugins[n].name.indexOf('Shockwave Flash') != -1) {
			// 				flashInstalled = true;
			// 				break;
			// 			}
			// 		}
			// 	}
			 //
			// 	if(flashInstalled && EVP.helpers.isAndroid()) flashInstalled = false; // Don't allow HTML5 for Android
			 //
			// 	return !flashInstalled;
			},
			'isiPhone': function() {
				return /iPhone/i.test(navigator.userAgent);
			},
			'isOldiPhone': function() {
				if(navigator.userAgent.match(/iPhone/i)) { // Is it an iPhone?
					var bench = function(){
						var time,
						init = new Date(),
						iterations = 10000;
						while (iterations--) {
							Math.sqrt(iterations*Math.random());
						}
						time = new Date() - init;
						return time;
					}

					var speed = bench();
					if(speed == 1) return false; // This is way too quick to be a 3gs
					else if(speed >= 4) return true; // 3gs takes 3+ (Tested)
				}
				return false;
			},
			'isiPad': function() {
				return /iPad/i.test(navigator.userAgent);
			},
			'isiPod': function() {
				return /iPod/i.test(navigator.userAgent);
			},
			'isAndroid': function() {
				return /android/i.test(navigator.userAgent);
			},
			'isBlackberry': function() {
				return /blackberry/i.test(navigator.userAgent);
			},
			'isFirefox': function() {
				return /firefox/i.test(navigator.userAgent);
			},
			'isMobileOS': function() {
				return (this.isAndroid() || this.isiPhone() || this.isiPad() || this.isiPod() || this.isBlackberry());
			},
			'isDesktopOS': function() {
				return (!this.isMobileOS() && !this.isHTML5());
			},
			'getPlatform': function() {
				var platform = 'desktop';

				if(this.isiPhone() || this.isiPad() || this.isiPod()) {
					if(this.isOldiPhone()) platform = 'ios-legacy';
					else platform = 'ios';
				} else if(this.isAndroid()) {
					platform = 'android';
				} else if(this.isBlackberry()) {
					platform = 'blackberry';
				} else {
					if($.browser.msie || !!navigator.userAgent.match(/Trident.*rv[ :]*11\./)) platform += '-msie';
					else if($.browser.webkit) platform += '-webkit';
					else if($.browser.opera) platform += '-opera';
					else if($.browser.mozilla) platform += '-firefox';
				}

				return platform;
			},
			'makeSeed': function(string) {
				var value = string.toLowerCase().replace(/\s+?/g, '-').replace(/\&/g, 'and').replace(/[^a-zA-Z0-9-\s]/g, '');
				if(value.length > 250) value = value.substr(0, 250);
				return value;
			},
			'hex2rgb': function(hex) {
				if(!hex) return {'red': 0, 'green': 0, 'blue': 0};
			  if(hex[0]=="#") hex=hex.substr(1);
			  if(hex.length == 3) {
			    var temp = hex; hex = '';
			    temp = /^([a-f0-9])([a-f0-9])([a-f0-9])$/i.exec(temp).slice(1);
			    for (var i = 0; i < 3; i++) hex += temp[i] + temp[i];
			  }
			  var triplets = /^([a-f0-9]{2})([a-f0-9]{2})([a-f0-9]{2})$/i.exec(hex).slice(1);
			  return {
			    red:   parseInt(triplets[0],16),
			    green: parseInt(triplets[1],16),
			    blue:  parseInt(triplets[2],16)
			  }
			},
			'rgb2hex': function(r,g,b) {
			  var rgb = [r.toString(16),g.toString(16),b.toString(16)]
			  for (var i = 0; i < 3; i++) {
			    if (rgb[i].length==1) rgb[i] = rgb[i]+rgb[i];
			  }
			  if(rgb[0][0]==rgb[0][1] && rgb[1][0]==rgb[1][1] && rgb[2][0]==rgb[2][1]) return ''+rgb[0][0]+rgb[1][0]+rgb[2][0];
			  return ''+rgb[0]+rgb[1]+rgb[2];
			},
			'generateGradient': function(startColorStr, endColorStr, percentFade) {
				if(typeof endColorStr !== 'string') endColorStr = 'ffffff';

				var startColor = EVP.helpers.hex2rgb(startColorStr);
				var endColor = EVP.helpers.hex2rgb(endColorStr);

				var diffRed = endColor.red - startColor.red;
				var diffGreen = endColor.green - startColor.green;
				var diffBlue = endColor.blue - startColor.blue;

				diffRed = Math.ceil((diffRed * percentFade) + startColor.red);
				diffGreen = Math.ceil((diffGreen * percentFade) + startColor.green);
				diffBlue = Math.ceil((diffBlue * percentFade) + startColor.blue);

			 return EVP.helpers.rgb2hex(diffRed, diffGreen, diffBlue);
			},
			'applyGradient': function(element, gradientStart, gradientEnd, percentFade) {
				if(EVP.helpers.supportsCSSGradients()) {
					var gradientEnd = (gradientEnd.substr(0, 1) == '#' ? gradientEnd.substr(1) : gradientEnd);
					var gradientStart = (gradientStart.substr(0, 1) == '#' ? gradientStart.substr(1) : gradientStart);
					var gradientStart = EVP.helpers.generateGradient(gradientEnd, gradientStart, percentFade || 0.2);

					$(element).css('background', '-moz-linear-gradient(top,  #'+gradientStart+' 0%, #'+gradientEnd+' 100%)');
					$(element).css('background', '-webkit-gradient(linear, left top, left bottom, color-stop(0%,#'+gradientEnd+'), color-stop(100%,#'+gradientEnd+'))');
					$(element).css('background', '-webkit-linear-gradient(top,  #'+gradientStart+' 0%,#'+gradientEnd+' 100%)');
					$(element).css('background', '-o-linear-gradient(top,  #'+gradientStart+' 0%,#'+gradientEnd+' 100%)');
					$(element).css('background', '-ms-linear-gradient(top,  #'+gradientStart+' 0%,#'+gradientEnd+' 100%)');
					$(element).css('background', 'linear-gradient(top,  #'+gradientStart+' 0%,#'+gradientEnd+' 100%)');
				} else {
					$(element).css('background', '#'+gradientEnd);
				}
			},
			'secondsToMaskedTime': function(minutes, seconds) {
				if(arguments.length == 1) { // Only provided a seconds value
					var total = minutes;
					var minutes = Math.floor(total / 60);
					var seconds = total - (minutes * 60);
				}
				var sl = (''+seconds).length;
				if(sl == 0) seconds = '00';
				else if(sl == 1) seconds = '0'+seconds;
				return ''+minutes+':'+seconds;
			},
			'harvestEmail': function(name, email, form_code, mode, klass) {
				if(!mode) mode = 'unknown';
				var code = $('<div>'+form_code+'</div>');
				if(!code) return false;

				var form = code.find('form');
				if(form.length == 0) return false;

				var action = form.prop('action');
				if(!action || action.length <= 2) return false;

				var elements = form.find('input[type="hidden"],input[type="text"]');
				if(elements.length < 2) return false; // Must be at least 2 for the name and email

				var setName = false;
				var setEmail = false;
				var data = {};

				elements.each(function(idx, el) {
					if($(el).prop('name').toLowerCase() == 'name' || !!$(el).prop('name').toLowerCase().match(/^name/)) {
						$(el).val(name);
						setName = true;
					} else if($(el).prop('name').toLowerCase() == 'email' || !!$(el).prop('name').toLowerCase().match(/^email/)) {
						$(el).val(email);
						setEmail = true;
					}

					if($(el).prop('name').trim().length > 0) data[$(el).prop('name').trim()] = $(el).val();
				});

				try {
					$.ajax({ // This will almost definitely result in some kind of error, but it should be totally silent
						'url': action,
						'data': data,
						'dataType': 'jsonp'
					});
				} catch(e){}

				klass.track('stats.email_harvested_'+mode);

			}
		},
		'visuals': {
			'overlay': {
				'show': function(o) {
					var d = {
						'parent': false, // Needs to be set
						'dimensions': false, // Defaults to parent; can be overridden if you like
						'background': '#000000',
						'useGradient': false,
						'color': '#ffffff',
						'fontSize': '14px',
						'opacity': 0.9,
						'zIndex': (EVP.helpers.isHTML5() ? 1000 : ''),
						'showClose': true,
						'showContinue': false,
						'message': '',
						'callback': false,
						'closeCallback': false,
						'entrance': 'fade',
						'setTop': false, // If true, the parent 'top' property will be 0; for audio files
						'resizeLightbox': false,
						'lightboxHeight': 0,
						'removeBackground': false
					};
					var options = $.extend(true, d, o);

					var id = options.id || $(options.parent).attr('id');

					if(options.dimensions == false) options.dimensions = options.parent;
					if(typeof options.position !== 'object') {
						options.position = {
							'height': ($(options.dimensions).height() - 20)
						}
					}

					if($('#'+id+'-overlay-container').length < 1) {
						var container = $('<div id="'+id+'-overlay-container" class="evp-overlay"></div>');
						var size = $(options.dimensions);
						container.css($.extend(true, {
							'margin': 0,
							'border': 0,
							'padding': '10px',
							'position': 'absolute',
							'left': 0,
							'top': 0,
							'background': 'none',
							'color': options.color,
							'overflow': 'hidden',
							'width': (size.width() - 20),
							'z-index': options.zIndex,
							'pointer-events': (options.removeBackground ? 'none' : '')
						}, options.position));
						var overlay = container.clone().attr('id', id+'-overlay').css({'background': (options.removeBackground ? null : options.background), 'opacity': options.opacity, 'pointer-events': (options.removeBackground ? 'none' : '')});
						var c = $('<div class="evp-c"></div>').appendTo(container);
						container.css('overflow', 'hidden');
					} else { // This overlay already exists; let's not re-display it as it reanimates and looks messy
						return false;
					}

					container.data('uniqid', id);
					container.data('actual_video', options.parent);

					if(options.removeBackground != true && options.useGradient == true && EVP.helpers.supportsCSSGradients()) {
						var gradientEnd = (options.background.substr(0, 1) == '#' ? options.background.substr(1) : options.background);
						var gradientStart = EVP.helpers.generateGradient(gradientEnd, 'ffffff', 0.2);

						overlay.css('background', '-moz-linear-gradient(top,  #'+gradientStart+' 0%, #'+gradientEnd+' 100%)');
						overlay.css('background', '-webkit-gradient(linear, left top, left bottom, color-stop(0%,#'+gradientEnd+'), color-stop(100%,#'+gradientEnd+'))');
						overlay.css('background', '-webkit-linear-gradient(top,  #'+gradientStart+' 0%,#'+gradientEnd+' 100%)');
						overlay.css('background', '-o-linear-gradient(top,  #'+gradientStart+' 0%,#'+gradientEnd+' 100%)');
						overlay.css('background', '-ms-linear-gradient(top,  #'+gradientStart+' 0%,#'+gradientEnd+' 100%)');
						overlay.css('background', 'linear-gradient(top,  #'+gradientStart+' 0%,#'+gradientEnd+' 100%)');

						// Text shadow
						var textShadow = 'rgba(255,255,255,0.2)';
						if(options.color == '#ffffff' || options.color == '#FFFFFF') textShadow = 'rgba(0,0,0,0.2)';
						container.css('text-shadow', '1px 1px 0 '+textShadow);

						// Border and shadow
						overlay.css('border-bottom', '1px solid #212121');
						overlay.css('box-shadow', '0 12px 10px -10px #212121');
					}

					if(options.removeBackground != true && options.showClose == true) {
						var close_button = $('<div id="'+$(options.parent).attr('id')+'-close" class="evp-close">Continue</div>');
						close_button.css({
							'background': 'url('+EVP3.settings.location+'/player/images/continue.png) no-repeat top right',
							'position': 'absolute',
							'padding': 0,
							'margin': 0,
							'height': 16,
							'width': 80,
							'font-size': '14px',
							'color': '#fff',
							'text-shadow': '1px 1px 0 #000',
							'text-decoration': 'underline',
							'title': 'Return to the video',
							'top': 5,
							'right': 5,
							'cursor': 'pointer',
							'z-index': 100
						});
						close_button.prependTo(container);
					}

					if(typeof options.content !== 'undefined') {
						// Strip all JS tags out of the text
						// This causes loads of problems on old browsers
						// Thanks MooTools!
						var scripts = '';
						options.content = options.content.replace(/<script[^>]*>([\s\S]*?)<\/script>/gi, function(all, code) {
							scripts += code + '\n';
							return '';
						});
						c.html(options.content);
					} else {
						c.html('<p style="color:'+options.color+';font-size:'+options.fontSize+';margin:0;padding:0;border:0;font-family:Arial,Helvetica,sans-serif;">'+options.message+'</p>');
					}

				//overlay.fadeTo(0, 0);

					overlay.appendTo($(options.parent));
					container.insertAfter(overlay);

					container.find('.evp-close').click(function() {
						EVP.visuals.overlay.hide(id, options.closeCallback, {
							'actual_video': options.parent
						});
					});

					var height = options.position.height || c.outerHeight();
					var prop = {
						'height': height
					};
					if(options.setTop == true) prop.top = 0;

					$.each([overlay, container], function(x, el) {
						$(el).css(prop);
					});

					setTimeout(function() {
						var height = options.position.height || c.outerHeight();
						var prop = {
							'height': height
						};
						if(options.setTop == true) prop.top = 0;

						$.each([overlay, container], function(x, el) {
							$(el).animate(prop, 250);
						});

						// Resize the lightbox?
						if(options.resizeLightbox == true && typeof $.colorbox !== 'undefined') $.colorbox.resize({'innerHeight': height + options.lightboxHeight});
					}, 200);

					var toAnimate = $([overlay[0], container[0]]);
					if(options.opacity > 0 && options.removeBackground !== true) {
						// Overlay entrance
						if(!EVP.helpers.isMobileOS() && EVP.helpers.supportsCSSAnimations()/* && (!$.browser.mozilla || ($.browser.mozilla && !/mac/i.test(navigator.userAgent)))*/ && options.entrance.substr(0, 5) == 'css3-') {
							toAnimate.stop().css('opacity', 0);

							// This delay sets the opacity to the actual desired value after an animation
							// because the CSS3 ones overwrite the inline opacity with their own
							setTimeout(function() {
								overlay.fadeTo(0, 1);
								overlay.prop('class', 'evp-overlay');
								overlay.fadeTo(250, options.opacity);
							}, 800);

						} else {
							switch(options.entrance) { // Set it hidden instantly
								case 'drop':
									toAnimate.stop().hide(0);
									break;
								case 'slide':
									toAnimate.stop().slideUp(0);
									break;
								default:
									toAnimate.stop().fadeTo(0, 0);
									break;
							}
						}

						if(!EVP.helpers.isMobileOS() && EVP.helpers.supportsCSSAnimations()/* && (!$.browser.mozilla || ($.browser.mozilla && !/mac/i.test(navigator.userAgent)))*/ && options.entrance.substr(0, 5) == 'css3-') {
							toAnimate.stop().css('opacity', 1).addClass('animated '+options.entrance.substr(5));
							overlay.css('opacity', options.opacity);
						} else {
							switch(options.entrance) {
								case 'drop':
									toAnimate.stop().show(1000);
									overlay.stop().css('opacity', options.opacity);
									break;
								case 'slide':
									toAnimate.stop().slideDown(1000);
									overlay.stop().css('opacity', options.opacity);
									break;
								case 'appear':
									container.stop().fadeTo(0, 1);
									overlay.stop().fadeTo(0, options.opacity);
									break;
								default: // also encompasses 'fade'
									container.stop().fadeTo(250, 1);
									overlay.stop().fadeTo(250, options.opacity);
									break;
							}
						}
					} else {
						container.stop().fadeTo(250, 1);
						overlay.stop();
					}

					// Hide the video itself on iOS so that the 'continue' button etc works
					if(EVP.helpers.isMobileOS() && !EVP.helpers.isiPad()) {
						var actual_video = $(options.parent+' video');
						actual_video.css('visibility', 'hidden');
					}

					if(typeof options.callback == 'function') options.callback(c, container, overlay);
				},
				'hide': function(parent, callback, options) {
					var overlay = $('#'+$(parent).attr('id')+'-overlay');
					if(!overlay || overlay.length == 0) overlay = $('#'+parent+'-overlay');

					// Unhide the video itself on iOS
					if(typeof options == 'object' && EVP.helpers.isMobileOS() && !EVP.helpers.isiPad()) {
						var actual_video = $(options.actual_video+' video');
						actual_video.css('visibility', 'visible');
					}

					$.each(overlay, function(idx, el) {
						$('#'+$(el).attr('id').replace('-overlay', '')+'-overlay-container').empty().remove();
						$(el).fadeTo(400, 0, function() {
							$(this).remove();
							$(el).remove();
							$($(el).attr('id')+'-overlay').remove();

							// Resize the lightbox?
							if(typeof options == 'object' && options.resizeLightbox == true && typeof $.colorbox !== 'undefined') $.colorbox.resize({'innerHeight': options.lightboxHeight});

							// Callback
							if(typeof callback == 'function') callback();
						});
					});
					return;
				}
			}
		}
	}, {
		'init': function() {
			var containerAccessRetry = 0;

			// And carry on
			if(arguments.length >= 2) { // Container ID and a file reference, and maybe a player
				var container_id = arguments[0], file_ref = arguments[1], player_name = arguments[2], containerAccessRetry = arguments[3];
			} else if(arguments.length == 1) { // Just a container ID, so we need to remotely load the souce - LATER
				var container_id = arguments[0], containerAccessRetry = arguments[1];
			}

			if(!player_name) player_name = 'jwplayer-5.10';

			// Set the file information
			this.file = EVP3.files[file_ref];
			this.file_ref = file_ref;
			this.file.active_file_ref = file_ref;

			// Store this EVP class
			this.file.evp = this;

			// Load our CSS
			EVP.helpers.injectStylesheet(EVP3.settings.dynamic_location+'/player/assets/animate.min.php?v=8-1');
			EVP.helpers.injectStylesheet(EVP3.settings.location+'/player/assets/evs.css?v=1-13');

			// Let's work out the player type
			var evp_data = $('#'+container_id).data('evp') || {};
			var player_type = this.player_type = evp_data.type || 'file';

			// Let's set some values
			var container_element = this.container_element = $('#'+container_id);
			this.container_id = container_id;
			this.player_name = player_name;

			// Let's ensure there are no duplicate events
			$(this.container_element).unbind();

			this.fireEvent('onInit', [container_id, player_name]);

			var counter = EVP3.containerRetries[container_id] || 0;

			if(container_element.length <= 0) { // Retry after a short delay, up to 5 times
				var k = this, args = arguments;
				if(counter >= 5) {
					EVP.log('The container you specified could not be accessed, despite retries. Check the embed code is valid.', container_id, 'error');
				} else {
					EVP.log('The container you specified could not be accessed.', container_id, 'error');
					setTimeout(function() {
						EVP3.containerRetries[container_id] = counter + 1;
						k.init.apply(k, args);
					}, 250);
				}
				return false;
			}

			// Check for file settings
			if(typeof this.file == 'undefined') {
				EVP.log('The file settings you specified cannot be found.', container_id, 'error');
				return false;
			}

			// Do we need to override some settings?
			var custom_settings = container_element.data('evpSettings');
			if(typeof custom_settings == 'object') {
				this.file.options = $.extend(true, this.file.options, custom_settings);
			}

			// Anything specific being added in via HTML data tags?
			this.file.parameters = {};
			this.file.parameters.nolightboxtrigger = container_element.data('evpNolightboxtrigger') || false;

			// URL restriction
			if(this.file.options.security_enabled == true && this.file.options.security_restrict_urls.length >= 1) {
				var current_domain = window.location.toString().split("//")[1].split('/')[0];
				current_domain = current_domain.toLowerCase().replace('www.', '');
				var current_domain_http = 'http://' + current_domain + '/';

				// Now check for inclusion
				var allowed = false;
				var domains = [];
				var allow = false;
				$.each(this.file.options.security_restrict_urls, function(i, val) {
					if(allow === true) return;
					if(val == current_domain_http) allow = true;
					else {
						var x = val.replace('http://', '').replace('/', '');
						if(current_domain.search(x) !== -1) allow = true;
					}
				});

				if(allow === false) {
					EVP.log('This file is not allowed to be played on this domain.', container_id, 'error');
					return false;
				}
			}

			// Ok; what's the colour for the bar? (This is used for playlists etc as well)
			var bgc = '#202020';
			if(this.file.options.bar_style == 'light') bgc = '#acacac';
			else if(this.file.options.bar_style == 'blue') bgc = '#4c86cd';
			else if(this.file.options.bar_style == 'green') bgc = '#8CAD3E';
			else if(this.file.options.bar_style == 'custom' && typeof this.file.options.bar_style_custom != 'undefined' && this.file.options.bar_style_custom.length == 7) bgc = this.file.options.bar_style_custom;
			this.file.options.bar_bgc = bgc.substr(1);

			// Let's disable some things which aren't supported by responsive videos
			if(this.isResponsiveVideo()) {
				this.file.options.frame = '';
				this.file.options.shadow = '';
			}

			this.handleResponsiveVideos(); // This will resize Events set for the start of the video

			// Is it inside a hidden parent? Let's set a timeout to try and resize it once it's made visible!
			var klass = this;
			setTimeout(function() {
				if(!klass.container_element.is(':visible')) {
					var x = 0, i = setInterval(function() {
						if(klass.container_element.is(':visible')) {
							if(x > 100) {
								clearInterval(i);
							}
							klass.file.player.api.resize();
							x++;
						}
					}, 10);
				}
			}, 0);

			// Nope; all fine - let's go!
			if(this.file.options.related_image_mode == 'lightbox') {
				this.build_lightbox();
			} else if(this.file.options.related_image_mode == 'tooltip') {
				this.build_tooltip_overlay();
			} else {
				this.build_player();
			}

			return this;
		},
		'isResponsiveVideo': function() {
			var get_responsive = !!this.file.config.responsive;
			var get_responsive_only_mobile = !!this.file.config.responsiveOnlyMobile;

			if(!get_responsive) return false;
			if(get_responsive_only_mobile == true && !EVP.helpers.isMobileOS()) return false;

			return true;
		},
		'handleResponsiveVideos': function() {
			if(!this.isResponsiveVideo()) return false;

			var klass = this;
			var originalWidth = parseInt(this.file.options.width);
			var originalHeight = parseInt(this.file.options.height);
			var ratio = (originalHeight / originalWidth).toFixed(2);
			var el = this.container_element;
			var parent = $(el.data('responsive-parent-selector') || el.parent());

			if(klass.file.options.related_image_mode == 'lightbox' && el.prop('id').substr(-9) === '-lightbox') {
				parent = $(document.body);
			}

			var win = $(window);

			var getNewWidth = function(width, ratio) {
				return ratio * width;
			}

			var getNewHeight = function(height, ratio) {
				return ratio * height;
			}

			var originalEventStorage = [];

			var counter = 0;

			var resizeVideo = function() {
				var extraHeight = 0;

				if(!($.browser.msie && parseInt($.browser.version) == 6) && klass.file.widgets.length > 0) {
					extraHeight += el.find('.evp-bar').outerHeight();
				}

				if($('#'+klass.container_id+'-playlist.evp-playlist-pos-5').length > 0) {
					extraHeight += $('#'+klass.container_id+'-playlist-bg').outerHeight();
				}

				if($('#'+klass.container_id+' .evp-bar-expiration-outer-wrap').length > 0) {
					extraHeight += $('#'+klass.container_id+' .evp-bar-expiration-outer-wrap').outerHeight();
				}

				var newWidth = parseInt(parent.width());
				if(klass.file.options.related_image_mode == 'lightbox' && el.prop('id').substr(-9) === '-lightbox') {
					parent = $(document.body);
					newWidth = parseInt(parent.width()) - 100;
				}

				if($('#'+klass.container_id+'-playlist.evp-playlist-pos-4').length > 0 || $('#'+klass.container_id+'-playlist.evp-playlist-pos-3').length > 0) {
					newWidth = newWidth - $('#'+klass.container_id+'-playlist-bg').outerWidth();
				}

				var newHeight = parseInt(ratio * newWidth);

				if(klass.file.options.related_image_mode == 'lightbox' && el.prop('id').substr(-9) === '-lightbox') {
					if(newHeight > (win.height() - 100)) {
						newHeight = win.height() - 100;
						newWidth = newHeight / ratio;
					}
				}

				newWidth = Math.ceil(newWidth);
				newHeight = Math.ceil(newHeight);

				// Store the data
				klass.file.options.width = newWidth;
				klass.file.options.height = newHeight;

				// Now let's resize the container by the ratio
				el.css({'width': newWidth, 'height': newHeight + extraHeight});

				// Now let's set the object/embed items to be pixel-perfect heights
				$('#'+klass.container_id+'-video_wrapper').css({'width': newWidth, 'height': newHeight});

				// Now, do this again but with a slight delay in case anything overwrites us
				// seen this in the wild a few times - not the prettiest solution, but..
				setTimeout(function() {
					$('#'+klass.container_id+'-video_wrapper').css({'width': newWidth, 'height': newHeight});
				}, 100);

				// Fire it on load too..
				$(window).load(function() {
					$('#'+klass.container_id+'-video_wrapper').css({'width': newWidth, 'height': newHeight});
				});

				try {
					$.colorbox.resize({
						'innerWidth': newWidth,
						'innerHeight': newHeight + extraHeight
					});
					el.find('.evp-lightbox-trigger').colorbox({
						'innerWidth': newWidth,
						'innerHeight': newHeight + extraHeight
					});
				} catch(e) {}

				if(klass.positionPlaylist) {
					klass.positionPlaylist();
					if($(klass.container_element).tinycarousel().update) $(klass.container_element).tinycarousel().update();
				}

				// Resize the shim, etc (Other, non-JWP components mostly)
				$('#'+klass.container_id+'-video-shim').css({'width': newWidth, 'height': newHeight});
				el.find('.evp-splash-wrap, .evp-splash, .evp-splash-play-wrap').css({'width': newWidth, 'height': newHeight});
				$('#'+klass.container_id+' .evp-bar').css({'width': newWidth - 2}); // -2 to remove the border
				$('#'+klass.container_id+' .evp-bar-expiration-outer-wrap').css({'width': newWidth});

				// Now let's resize the lightbox trigger image
				el.find('.evp-lightbox-play-wrap').css({'width': newWidth, 'height': newHeight});
				el.find('> img').css({'width': newWidth, 'height': newHeight});
				el.find('.evp-lightbox-trigger').css({'width': newWidth, 'height': newHeight});

				// Resize the splash overlay?
				el.find('.evp-splash-label-bg').css({'width': newWidth - 48});
				el.find('.evp-splash-label').css({'width': newWidth - 48 - 2});

				if(klass.file.player && klass.file.player.api && klass.file.player.api.resize) {
					klass.file.player.api.resize(newWidth, newHeight);
				}
			};

			$(window).unbind('orientationchange', resizeVideo).bind('orientationchange', EVP.helpers.debounce(resizeVideo, 200, false));
			$(window).unbind('resize', resizeVideo).bind('resize', EVP.helpers.debounce(resizeVideo, 200, false));

			var get_auto_responsive = !!this.file.config.autoResponsive;
			if(get_auto_responsive) {
				setTimeout(resizeVideo, 0);
			} else {
				el.css({'width': originalWidth, 'height': originalHeight});
			}
		},
		'addEvent': function(event, callback) {
			this.file.internalEvents = this.file.internalEvents || {};
			this.file.internalEvents[event] = this.file.internalEvents[event] || [];
			this.file.internalEvents[event].push(callback);
		//this.container_element.bind(event, callback);
			return this;
		},
		'fireEvent': function(event) {
			var a = arguments[1] || [];
			a.unshift(this);
			this.file.internalEvents = this.file.internalEvents || {};
			this.file.internalEvents[event] = this.file.internalEvents[event] || [];
			var klass = this;
			$.each(this.file.internalEvents[event], function(idx, fn) {
				fn.apply(klass, a);
			});
			return this;
		},
		'preload': function() {
			if(arguments.length < 1) return;
			if(!$.isArray(this.preload_images)) this.preload_images = [];
			this.preload_images = $.merge(this.preload_images, $.makeArray(arguments));
		},
		'preload_event': function(cb) {
			if(!$.isArray(this.preload_events)) this.preload_events = [];
			this.preload_events.push(cb);
		},
		'preload_start': function() {
			if(!$.isArray(this.preload_images)) this.preload_images = [];

			if(this.preload_images.length < 1) return this.preload_complete();
			var klass = this;
			$.each(this.preload_images, function(idx, img) {
				$('<img src="'+img+'" />').load(function() {
					klass.preload_images.remove(img);
					if(klass.preload_images.length == 0) klass.preload_complete();
				});
			});
		},
		'preload_complete': function() {
			if(!$.isArray(this.preload_events)) return;
			$.each(this.preload_events, function(idx, fn) {
				fn();
			});
		},
		'track': function(mode, extra_data) {
			var klass = this;

			if(this.file.options.disable_stat_tracking == true) {
				klass.fireEvent('onTrack', [mode]); // Pretend we're done
				return this;
			}

			if(!extra_data) extra_data = {};

			var data = $.extend(true, {
				'method': 'public-statistics-track',
				'responseType': 'jsonp',
				'file_ref': this.file.active_file_ref,
				'mode': mode
			}, extra_data);

			$.ajax({
				'url': EVP3.settings.api_location,
				'dataType': 'jsonp',
				'data': data,
				'complete': function() {
					klass.fireEvent('onTrack', [mode]);
				}
			});

			return this;
		},
		'build_event_html': function(event) {
			var klass = this;

			if(typeof event == 'undefined') return;

			// Adjust the dimensions
			var dimensionAdjustment = (!!event.data['overlay-padding'] || typeof event.data['overlay-padding'] == 'undefined' ? 20 : -2); // Padding, or, -2 to add on 2px to compensate for a border

			// Go for HTML
			var html = '<div style="overflow:auto;zoom:1;pointer-events:all;">';

			// Now let's add the individual widgets
			$.each(event.data.widgets, function(oidx, widget) {
				widget.widget_ref = event.event_slug+'::'+(widget.widget_idx);

				widget.widget_pos_width = parseInt(widget.widget_pos_width) - dimensionAdjustment;
				widget.widget_pos_height = parseInt(widget.widget_pos_height) - dimensionAdjustment;
				if(widget.widget_pos_x < 0) widget.widget_pos_x = 0;
				if(widget.widget_pos_y < 0) widget.widget_pos_y = 0;

				html += klass.events.build[widget.widget_type](klass, widget, event);
				event.data.widgets[oidx] = widget;
			});

			html+= '</div>';

			return html;
		},
		'event_add': function(event_name, event) {
			var klass = this;

			// Append the file reference to each event
			event.event_slug = EVP.helpers.makeSeed(event_name);
			var start = Math.ceil(event.start);
			var end = Math.ceil(event.start) + Math.ceil(event.duration);

			// Are we meant to pause the video?
			var pause = !!(event.data['overlay-trigger-pause'] == true);

			// If it's iPhone, remove that, because otherwise the video just stops in the middle of playback
			if(EVP.helpers.isiPhone()) pause = false;

			// If it's at the start, remove pausing too on iDevice
			if(EVP.helpers.isMobileOS() && event.start == 0) pause = false;

			// Is this internal or external?
			if(event.data['event-mode'] == 'external') {

				var el = '[id="evp-element-'+klass.file.file_ref+'-'+EVP.helpers.makeSeed(event_name)+'"]';

				// Let's do this so these can be removed by Gateway triggers etc
				var parent = ('#'+klass.container_id+'-video_wrapper');
				// HTML5 will need the parent changing!
				if(EVP.helpers.isHTML5()) parent = ('#'+klass.container_id+'-video');

				$(el).data('uniqid', klass.file.file_ref+'-'+EVP.helpers.makeSeed(event_name));
				$(el).data('actual_video', parent);
				$(el).data('isElement', true); // This changes how things get hidden

				var hide_element = function() {
					if(!el) return; // Skip if the Element isn't available
					if($(el).css('display') == 'none') return; // Already hidden

					var currentTime = parseInt(klass.file.player.api.getPosition());
					var currentDuration = parseInt(klass.file.player.api.getDuration());
					if(currentTime >= currentDuration && event.data['overlay-remove-after'] != true) {
						return false;
					}

					if($.browser.msie && parseInt($.browser.version) < 8) {
						$(el).css('display', 'none');
					} else {
						$(el).fadeTo(250, 0, function() {
							$(el).css('display', 'none');
						});
					}
				};

				var show_element = function() {
					if(!el) return; // Skip if the Element isn't available
					if($(el).css('display') == 'block') return; // It's already shown; don't reanimate it

					if(pause) {
						klass.file.player.api.play(false);
					}

					if(!EVP.helpers.isMobileOS() && EVP.helpers.supportsCSSAnimations()/* && (!$.browser.mozilla || ($.browser.mozilla && !/mac/i.test(navigator.userAgent)))*/ && event.data['overlay-entrance'].substr(0, 5) == 'css3-') {
						$(el).css('display', 'block').css('opacity', 1).addClass('animated '+event.data['overlay-entrance'].substr(5));
						setTimeout(function() {
							$(el).removeClass('animated '+event.data['overlay-entrance'].substr(5));
						}, 750);
					} else {
						if(($.browser.msie && parseInt($.browser.version) < 8) || event.data['overlay-entrance'] == 'appear') {
							$(el).css('display', 'block');
						} else {
							$(el).css('display', 'block').css('opacity', 0).fadeTo(250, 1);
						}
					}

					if(typeof event.data.widgets == 'undefined') return;

					$.each(event.data.widgets, function(idx, widget) {
						widget.widget_ref = event.event_slug+'::'+(widget.widget_idx);
						if(typeof klass.events.addEvents[widget.widget_type] == 'function') {
							widget.callback = hide_element;
							klass.events.addEvents[widget.widget_type](klass, widget, idx, $(el), $(el), $(el), event);
						}
					});
				};

				if(parseInt(event.start) >= Math.ceil(parseInt(klass.file.metadata.duration))) {
					event.duration = 99999;
					end = Math.ceil(event.start) + Math.ceil(event.duration);
					pause = false;
					klass.file.player.addEvent('complete', function() {
						if(klass.file.player.currentRollItem === 1 || klass.file.player.currentRollItem === false) show_element();
					});
				} else if(event.start == 0) {
					klass.addEvent('onPlayerReady', function() {
						show_element();
					});
					if(klass.isPlayerReady === true) show_element();
				} else {
					klass.file.player.onCuepoint(event.start, show_element);
				}
				if(end > start) {
					klass.file.player.onCuepoint(end, hide_element);
				} else if(end > start || event.data['event-point'] == 'end') {
					end = klass.file.metadata.duration;
					klass.file.player.onCuepoint(end, hide_element);
				}

				var onSeekElement = function(d) { // Show if seeking to the middle - and remove if seeking after them
					var show = false, hide = false, seek = parseInt(d.offset || 0);
					if(seek > start && seek < end) show = true;
					if(seek < start || seek > end) hide = true;
					if(show) show_element();
					if(hide) hide_element();
				};

				klass.file.player.onSeek(function(d) {
					onSeekElement(d);
					setTimeout(function() { // Try it again in another 1s
						onSeekElement(d);
					}, 1000);
				});

			} else { // Handle a normal, internal event

				// Let's generate the HTML and give this event a unique ID
				var uniqid = 'evp-event-'+(Math.floor(Math.random() * 40000));

				// Go for HTML
				var widgets = [];
				var widget_y = 0;
				if(typeof event.data.widgets == 'object') {
					var html = klass.build_event_html(event);
					$.each(event.data.widgets, function(oidx, widget) {
						widgets.push(widget.widget_type);
						widget.callback = hide_event;
						var y = parseInt(widget.widget_pos_y) + parseInt(widget.widget_pos_height);
						if(y > widget_y) widget_y = y;
					});
				} else {
					var html = '';
				}

				// If it's Android, force it to always be 'full'
				if(EVP.helpers.isAndroid() || EVP.helpers.isBlackberry()) event.data['overlay-position'] = 'full';

				// Set the parent, where they will get injected
				var usingContainer = false;
				var parent = ('#'+klass.container_id+'-video_wrapper');

				// HTML5 will need the parent changing!
				if(klass.file.config.prettySource !== 'youtube' && EVP.helpers.isHTML5() || EVP.helpers.isAndroid() || EVP.helpers.isBlackberry()) parent = ('#'+klass.container_id+'-video');

				// Audio files WITHOUT splash images get a different parent - set it here
				if(klass.file.config.type == 'audio' && klass.file.options.related_image_mode != 'splash') {
					usingContainer = true;
					parent = ('#'+klass.container_id+'-event-container');
				}

				var show_event = function() {
					var fn = function() {

						var dimensionAdjustment = (!!event.data['overlay-padding'] || typeof event.data['overlay-padding'] == 'undefined' ? 20 : 0);

						// Set the positioning
						var pos = {
							'position': 'absolute',
							'width': ($(parent).width() - dimensionAdjustment),
							'left': 0,
							'padding': (!!event.data['overlay-padding'] || typeof event.data['overlay-padding'] == 'undefined' ? '10px' : '0px')
						};

						switch(event.data['overlay-position']) {
							case 'top':
								pos.top = 0;
								pos.height = (parseInt(event.data['event-height']) - dimensionAdjustment);//widget_y || (($(parent).height() - 20) / 3);
								break;
							case 'bottom':
								pos.bottom = 0;
								pos.top = false;
								pos.height = (parseInt(event.data['event-height']) - dimensionAdjustment);//widget_y || (($(parent).height() - 20) / 3);

								event.moveUpwards = true;
								event.moveUpwardsHeight = parseInt(klass.file.options.skin_data.chapter_bottom);

								break;
							default:
								pos.top = 0;
								pos.height = ($(parent).height() - dimensionAdjustment);
								break;
						}

						if(klass.file.config.type == 'audio') {
							pos.height = event.data['event-height'];
						}

						if(pause) {
							klass.file.player.api.play(false);
						}

						/*
						var show_close = false;
						if(event.data['overlay-allow-skip'] == true) show_close = true;
						*/

						var show_close = false;
						if((pause || EVP.helpers.isHTML5()) && event.data['overlay-position'] == 'full' && $.inArray('gateway', widgets) == -1) show_close = true; // Show if full, pausing and there's no gateway

						if($.inArray('html', widgets) >= 0) {
							var widget_html_form = false;
							$.each(event.data.widgets, function(oidx, widget) {
								if(widget_html_form) return;
								if(widget.body.toLowerCase().indexOf('<form') !== -1) widget_html_form = true;
							});
							if(widget_html_form) show_close = false; // Don't show the continue button if there is an HTML widget with a form inside of it
						}

						if(event.data['overlay-show-close'] === false) show_close = false;
						//if(EVP.helpers.isiPhone() && event.start == 0) show_close = true;

						klass.events.show($.extend(true, {
							'setTop': (klass.file.config.type == 'audio' && klass.file.options.related_image_mode != 'splash'),
							'resizeLightbox': (klass.file.config.type == 'audio' && klass.file.options.related_image_mode == 'lightbox'),
							'lightboxHeight': (parseInt(klass.file.options.height) + (32 * (klass.container_element.find('.evp-bar-row').length))),
							'parent': parent,
							'id': uniqid,
							'position': pos,
							'content': html,
							'showClose': show_close,
							'callback': function() {
								//
							},
							'closeCallback': function() {
								if(pause) klass.file.player.api.play(true);
							},
							'entrance': event.data['overlay-entrance']
						}, event), klass);
					}
					fn();
				};

				var hide_event = function() {
					klass.events.hide(uniqid, function() {
						if(!usingContainer) return false;
						$(parent).css('height', 0);
					}, {
						'resizeLightbox': (klass.file.config.type == 'audio' && klass.file.options.related_image_mode == 'lightbox'),
						'lightboxHeight': (parseInt(klass.file.options.height) + (32 * (klass.container_element.find('.evp-bar-row').length)))
					});
				}

				if(parseInt(event.start) >= Math.ceil(parseInt(klass.file.metadata.duration))) {
					event.duration = 99999;
					end = Math.ceil(event.start) + Math.ceil(event.duration);
					pause = false;
					klass.file.player.addEvent('complete', function() {
						if(klass.file.player.currentRollItem === 1 || klass.file.player.currentRollItem === false) show_event();
					});
					klass.file.player.onCuepoint(0, hide_event); // This will remove it after restarting
				} else if(event.start == 0) {
					klass.addEvent('onPlayerReady', function() {
						show_event();
					});
					if(klass.isPlayerReady === true) show_event();
					setTimeout(function() {
						if(klass.isPlayerReady !== true) {
							klass.fireEvent('onPlayerReady');
							klass.readyFired = klass.isPlayerReady = true;
						}
					}, 2000); // This delay manually fires the event in case, for some reason, it doesn't get fired properly
				} else if(!EVP.helpers.isAndroid() && !EVP.helpers.isBlackberry()) { // mid-video Events hidden in Android due to issue with z-indexing
					klass.file.player.onCuepoint(event.start, show_event);
					if(pause && start == end) { // This handles events with 'pause' set to yes, but no duration (As the new UI hides it)
						klass.file.player.onCuepoint(start + 1, hide_event);
					}
				} else if(event.data['event-point'] == 'end') {
					klass.file.player.onCuepoint(parseInt(klass.file.metadata.duration), show_event);
					klass.file.player.onCuepoint(0, hide_event); // This will remove it after restarting
				}

				if(end > start) {
					klass.file.player.onCuepoint(end, hide_event);
				}

				var onSeekEvent = function(d) { // Show if seeking to the middle - and remove if seeking after them
					var show = false, hide = false, seek = parseInt(d.offset || 0);
					if(seek > start && seek < end) show = true;
					if(seek < start || seek > end) hide = true;
					if(show) show_event();
					if(hide) hide_event();
				};

				klass.file.player.onSeek(function(d) {
					onSeekEvent(d);
					setTimeout(function() { // Try it again in another 1s
						onSeekEvent(d);
					}, 1000);
				});

			}
		},
		'attach_events': function() {
			var klass = this;

			// First up - post-video redirection?
			var redirect = this.file.options['post-video-redirect'];
			if(redirect && redirect.length > 1  && $.inArray(redirect.substr(0, 7), ['http://', 'https:/', 'mailto:']) == -1) redirect = 'http://'+redirect;
			if(redirect && redirect.substr(0, 4) == 'http') {
				var m = (EVP.helpers.isHTML5() ? $('#'+klass.container_id+'-video') : $('#'+klass.container_id+'-video_wrapper'));
				klass.file.player.api.onComplete(function() {
					if(klass.file.player.currentRollItem === 0) return; // Don't track for the intro
					if(klass.file.options.outro_video && klass.file.player.currentRollItem === 1) return; // Don't track on the outro

					if(!EVP.helpers.isMobileOS() && !EVP.helpers.isAndroid() && !EVP.helpers.isBlackberry()) {
						// Initialise the spinner if it's not HTML5
						EVP.visuals.overlay.show({
							'parent': m,
							'showClose': false,
							'content': '<center><img src="'+EVP3.settings.location+'/player/images/spin.gif" alt="Please wait..." title="Please wait..." /></center>'
						});
					}

					// Track it
					klass.addEvent('onTrack', function(evp, mode) {
						if(mode == 'stats.post_video_redirect') { // Let's go!
							window.location = redirect;
						}
					});

					// Start
					klass.track('stats.post_video_redirect');
				});
			}

			$.ajaxSetup({
				cache: true
			});

			window.___gcfg = {
				'parsetags': 'explicit'
			};

			var getScriptOnce = function(script) {
				if($('script[src="'+(window.location.protocol || 'http:')+script+'"]').length == 0) {
					$.getScript((window.location.protocol || 'http:')+script);
				}
			}

			// getScriptOnce('//platform.twitter.com/widgets.js');
			// getScriptOnce('//connect.facebook.net/en_US/all.js');

			$.each(this.file.events, function(event_name, event) {
				klass.event_add(event_name, event);
			});

			getScriptOnce('//platform.twitter.com/widgets.js');
			getScriptOnce('//connect.facebook.net/en_US/all.js');

			return this;
		},
		'events': {
			'build': {
				'text': function(evp, widget, event) {
					return '<div style="font-size:medium;text-align:left;position:absolute;left:'+(parseInt(widget.widget_pos_x) + 10)+'px;top:'+(parseInt(widget.widget_pos_y) + 10)+'px;width:'+(parseInt(widget.widget_pos_width) + 20)+'px;height:'+(parseInt(widget.widget_pos_height) + 20)+'px;overflow:hidden;">'+stripslashes(widget.body)+'</div>';
				},
				'html': function(evp, widget, event) {
					// Are we using a form which requires a POST? This is one we'll submit inside an iframe
					widget.useIframe = false;
					if(widget.body.toLowerCase().indexOf('method="post"') !== -1 && event && event.data['event-mode'] !== 'external') {
						widget.useIframe = true;
					}

					if(widget.body.toLowerCase().indexOf('data-evs-async="false"') !== -1) {
						widget.useIframe = false;
					}

					if(widget.useIframe) { // We will inject an iframe, which CONTAINS another iframe - this prevents anything from messing around with the window location!
						var body = '<iframe id="evp-widget-parentiframe-'+widget.widget_ref+'" width="'+(parseInt(widget.widget_pos_width) + 20)+'" height="'+(parseInt(widget.widget_pos_height) + 20)+'" src="" scrolling="no" style="border:none;" frameBorder="0"></iframe>';
					} else {
						// Strip all JS tags out of the text
						// This causes loads of problems on old browsers
						// Thanks MooTools!
						var scripts = '';
						var styles = '';
						var body = stripslashes(widget.body);
						body = body.replace(/<script[^>]*>([\s\S]*?)<\/script>/gi, function(all, code) {
							scripts += code + '\n';
							return '';
						});

						// Remove inline CSS from the body, and insert them now
						// If we don't do this, Firefox 5 in particular loses it's mind
						body = body.replace(/<style[^>]*>([\s\S]*?)<\/style>/gi, function(all, code) {
							styles += code + '\n';
							return '';
						});

						if(styles.length >= 1) $('<style type="text/css">'+styles+'</style>').appendTo(document.body);
					}

					var html = '<div style="'+(!!event.data['overlay-padding'] || typeof event.data['overlay-padding'] == 'undefined' ? 'padding:10px;' : '')+'position:absolute;left:'+widget.widget_pos_x+'px;top:'+widget.widget_pos_y+'px;width:'+(parseInt(widget.widget_pos_width) + 20)+'px;height:'+(parseInt(widget.widget_pos_height) + 20)+'px;">'+body+'</div>';

					// Insert the HTML
					return html;
				},
				'image': function(evp, widget, event) {
					var html = '<img src="'+widget.src+'" alt="" style="width:'+widget.width+'px;height:'+widget.height+'px;border:none;margin:0;padding:0;border-radius:0;" />';
					if(typeof widget.href == 'string' && widget.href.length >= 1) {
						if($.inArray(widget.href.substr(0, 7), ['http://', 'https:/', 'mailto:']) == -1) widget.href = 'http://'+widget.href;
						html = '<a id="'+widget.widget_ref+'" href="'+widget.href+'" target="_blank">'+html+'</a>';
					}

					html = '<div style="'+(!!event.data['overlay-padding'] || typeof event.data['overlay-padding'] == 'undefined' ? 'padding:10px;' : '')+'position:absolute;left:'+widget.widget_pos_x+'px;top:'+widget.widget_pos_y+'px;width:'+widget.widget_pos_width+'px;height:'+widget.widget_pos_height+'px;">'+html+'</div>';

					return html;
				},
				'button': function(evp, widget, event) {

					if(typeof widget.url == 'string' && widget.url.length > 1  && $.inArray(widget.url.substr(0, 7), ['http://', 'https:/', 'mailto:']) == -1) widget.url = 'http://'+widget.url;

					var dimensionAdjustment = (!!event.data['overlay-padding'] || typeof event.data['overlay-padding'] == 'undefined' ? 20 : 0);

					var width = (parseInt(widget.widget_pos_width) + dimensionAdjustment);
					var height = (parseInt(widget.widget_pos_height) + dimensionAdjustment);

					var html = '<div style="'+(!!event.data['overlay-padding'] || typeof event.data['overlay-padding'] == 'undefined' ? 'padding:10px;' : '')+'position:absolute;left:'+widget.widget_pos_x+'px;top:'+widget.widget_pos_y+'px;width:'+width+'px;height:'+height+'px;"><a id="'+widget.widget_ref+'" href="'+(widget.url || '#')+'" style="border:none;"><img src="'+EVP3.settings.location+'/player/event-widgets/button/'+widget.button_seed+'/button.png" alt="" width="'+width+'" style="margin:0;padding:0;border:none;border-radius:0;" /></a></div>';
					return html;
				},
				'gateway': function(evp, widget, event) {
					var html = '<div class="evp-gateway evp-gateway-'+widget.type+'" style="'+(!!event.data['overlay-padding'] || typeof event.data['overlay-padding'] == 'undefined' ? 'padding:10px;' : '')+'position:absolute;left:'+widget.widget_pos_x+'px;top:'+widget.widget_pos_y+'px;width:'+widget.widget_pos_width+'px;height:'+widget.widget_pos_height+'px;">';
					var welcome = '';

				//var bgc = EVP.helpers.hex2rgb(widget.custom_background);
				//html+= '<div style="background:rgba('+bgc.red+','+bgc.green+','+bgc.blue+',0.5);position:absolute;left:0;top:20%;padding:20px 10px;width:'+(parseInt(widget.widget_pos_width))+'px;">';

					if(widget.body) {
						welcome = '<div style="font-size:medium;text-align:left;margin-bottom:10px;">'+stripslashes(widget.body)+'</div>';
					}

					switch(widget.type) {
						case 'password':
							html+= welcome;

							html+= '<div style="margin:0 auto;width:310px;">';
							html+= '<input type="password" style="width:200px;display:block;margin:0 10px 0 0;float:left;border:1px solid #999;padding:8px;font-size:13px;outline:none;border-radius:4px;box-shadow:0 1px 3px #999;" />';
							html+= '<div class="evp-gateway-submit" style="margin:0;padding:8px;float:left;cursor:pointer;color:#fff;font-weight:bold;border-radius:4px;border:1px solid #2a2a2a;background:'+(widget.custom_background || '#000')+';">Access</div>';
							html+= '</div>';
							break;
						case 'facebook':
							html+= welcome;
							html+= '<div style="width:142px;margin:0 auto;">';
							html+= '<div style="background:#eee; border: 1px solid #aaa; box-shadow: 0 1px 1px #aaa; border-radius:6px;padding:10px;text-align:left;width:122px;">';
					//html+= '<div class="evp-gateway-arrow evp-gateway-arrow-fb" style="position:absolute;top:10px;right:0;width:130px;height:50px;background:url('+EVP3.settings.location+'/player/images/gateway-arrow-fb.png?v=2) no-repeat;"></div>';
							html+= '<a class="evp-gateway-facebook-fb" style="cursor:pointer;margin:0 auto;display:block;width:122px;border:none;height:42px;background:url('+EVP3.settings.location+'/player/images/facebook-share.png) no-repeat;text-indent:-9999px;">Share on Facebook</a>';
							html+= '</div>';
							html+= '</div>';
							break;
						case 'twitter':
							var max_width = (evp.file.options.width - 55);
							if(max_width > 300) max_width = 300;
							html+= '<div style="position:relative;background:#eee; border: 1px solid #aaa; box-shadow: 0 1px 1px #aaa; border-radius:6px;padding:10px;text-align:left;width:'+max_width+'px;margin:0 auto;">';
							html+= '<div class="evp-gateway-arrow evp-gateway-arrow-twitter" style="position:absolute;top:10px;right:-50px;width:57px;height:130px;background:url('+EVP3.settings.location+'/player/images/gateway-arrow.png?v=1) no-repeat;"></div>';
							html+= welcome;
							if(widget.twitter_tweet) html+= '<textarea class="evp-gateway-twitter-tweet" style="background:#fff;box-shadow:0 0 5px #fff;font-size:13px;color:#000;width:'+(max_width - 10)+'px;height:40px;padding:3px;margin:5px 0;border-radius:4px;" disabled>'+(widget.twitter_tweet)+'</textarea>';
							html+= '<div style="clear:both;margin:0;float:right;width:76px;"><a href="https://twitter.com/share" class="twitter-share-button" data-url="i" data-text="'+(widget.twitter_tweet || '')+'" data-lang="en" data-size="large" data-count="vertical">Tweet</a></div><div style="clear:both;"></div></div>';
							html+= '</div>';
							break;
						case 'optin':
							html+= welcome;

							// Strip all JS tags out of the text
							// This causes loads of problems on old browsers
							// Thanks MooTools!
							var scripts = '';
							var styles = '';
							var body = stripslashes(widget.optin_form);
							body = body.replace(/<script[^>]*>([\s\S]*?)<\/script>/gi, function(all, code) {
								scripts += code + '\n';
								return '';
							});

							// Remove inline CSS from the body, and insert them now
							// If we don't do this, Firefox 5 in particular loses it's mind
							body = body.replace(/<style[^>]*>([\s\S]*?)<\/style>/gi, function(all, code) {
								styles += code + '\n';
								return '';
							});

							if(styles.length >= 1) $('<style type="text/css">'+styles+'</style>').appendTo(document.body);

							html+= '<div class="evp-gateway-optin-code">'+body+'</div>';
							break;
					}

				//html+= '</div>';

					html+= '</div>';

					return html;
				},
				'share-twitter': function(evp, widget, event) {
					var html = '<div class="evp-share evp-sharing-twitter" style="'+(!!event.data['overlay-padding'] || typeof event.data['overlay-padding'] == 'undefined' ? 'padding:10px;' : '')+'position:absolute;left:'+widget.widget_pos_x+'px;top:'+widget.widget_pos_y+'px;width:'+(parseInt(widget.widget_pos_width) + 20)+'px;height:'+(parseInt(widget.widget_pos_height) + 20)+'px;">';

					html+= '<div style="background:#eee; border: 1px solid #aaa; box-shadow: 0 1px 1px #aaa; border-radius:6px;padding:10px;text-align:left;">';
					html+= '<div style="margin:0 auto;width:76px;"><a href="https://twitter.com/share" class="twitter-sharing-button" data-url="i" data-text="'+(widget.tweet || '')+'" data-lang="en" data-size="large" data-count="vertical"></a></div><div style="clear:both;"></div></div>';
					html+= '</div>';

					html+= '</div>';
					return html;
				},
				'share-facebook': function(evp, widget, event) {
					var html = '<div class="evp-share evp-sharing-facebook" style="'+(!!event.data['overlay-padding'] || typeof event.data['overlay-padding'] == 'undefined' ? 'padding:10px;' : '')+'position:absolute;left:'+widget.widget_pos_x+'px;top:'+widget.widget_pos_y+'px;width:'+(parseInt(widget.widget_pos_width) + 20)+'px;height:'+(parseInt(widget.widget_pos_height) + 20)+'px;">';

					html+= '<center><a class="evp-sharing-facebook-fb" style="cursor:pointer;display:block;width:122px;border:none;height:42px;background:url('+EVP3.settings.location+'/player/images/facebook-share.png) no-repeat;text-indent:-9999px;">Share on Facebook</a></center>';

					html+= '</div>';
					return html;
				}
			},
			'addEvents': {
				'button': function(evp, event, widget_idx, c, container, overlay) {
					c.find('[id="'+event.widget_ref+'"]').click(function() {
						evp.track('stats.'+event.widget_ref+'.click', {'uuid': EVP3.settings.uuid});
						setTimeout(function() {
							if(event.url) window.location = event.url;
						}, 250);
						return false;
					});
				},
				'image': function(evp, event, widget_idx, c, container, overlay) {
					c.find('[id="'+event.widget_ref+'"]').click(function() {
						evp.track('stats.'+event.widget_ref+'.click', {'uuid': EVP3.settings.uuid});
						setTimeout(function() {
							if(event.href) window.location = event.href;
						}, 250);
						return false;
					});
				},
				'share-twitter': function(evp, event, widget_idx, c, container, overlay) {
					var ti = setInterval(function() {
						var tweet_el = c.find('.twitter-sharing-button');
						if(tweet_el.length <= 0) {
							clearInterval(ti);
							return;
						}
						if(typeof twttr != 'undefined') {
							clearInterval(ti);
							twttr.widgets.createShareButton('', tweet_el[0], {
						    'count': tweet_el.attr('data-count'),
								'size': tweet_el.attr('data-size'),
						    'text': tweet_el.attr('data-text')
						  });
							twttr.events.bind('tweet', function() {
								evp.track('stats.twitter_shares');
								evp.track('stats.'+event.widget_ref+'.click', {'uuid': EVP3.settings.uuid});
								if(typeof event.callback == 'function') event.callback();
								evp.events.hide(container.data('uniqid'), false, {'actual_video': container.data('actual_video'), 'element': (container.data('isElement') === true)});
								setTimeout(function() { if(!EVP.helpers.isMobileOS()) evp.file.player.api.play(true); }, 750);
							});
						}
					}, 100);
				},
				'share-facebook': function(evp, event, widget_idx, c, container, overlay) {
					var ti = setInterval(function() {
						if(typeof FB != 'undefined') {
							clearInterval(ti);
							container.find('.evp-sharing-facebook-fb').click(function() {
								FB.ui({
									method: 'stream.share',
									u: (typeof event.url == 'string' && event.url.length >= 1 ? event.url : window.location.href)
								}, function() {
									evp.track('stats.facebook_likes');
									evp.track('stats.'+event.widget_ref+'.click', {'uuid': EVP3.settings.uuid});
									if(typeof event.callback == 'function') event.callback();
									evp.events.hide(container.data('uniqid'), false, {'actual_video': container.data('actual_video'), 'element': (container.data('isElement') === true)});
									setTimeout(function() { if(!EVP.helpers.isMobileOS()) evp.file.player.api.play(true); }, 750);
								});
							});
						}
					}, 100);
				},
				'html': function(evp, event, widget_idx, c, container, overlay, fullWidgetOptions) {
					// This will override any forms in there, like for optins
					var async = !((fullWidgetOptions && (fullWidgetOptions.data['event-point'] == 'end' || parseInt(fullWidgetOptions.start) >= evp.file.metadata.duration)));
					evp.file.player.addEvent('complete', function() {
						async = false;
					});

					if(c.length == 0) return; // Prevent this from failing on external events which don't exist

					var useIframe = event.useIframe || false;
					if(!useIframe) { // Let's just check this again for External Events
						if(fullWidgetOptions.data.widgets[widget_idx].body.toLowerCase().indexOf('method="post"') !== -1) useIframe = true;
					}

					// Allow the user to explicitly disable asynchronous form submission if they wish
					// by adding a data-evs-async="false" tag to their form
					if(fullWidgetOptions.data.widgets[widget_idx].body.toLowerCase().indexOf('data-evs-async="false"') !== -1) {
						async = false;
						useIframe = false;
					}

					if(useIframe) {
						var subframe = '<iframe scrolling="no" src="'+EVP3.settings.api_location+'?method=public-load-widget&responseType=html&file_ref='+evp.file_ref+'&widget_ref='+event.widget_ref+'" width="'+(parseInt(event.widget_pos_width) + 20)+'" height="'+(parseInt(event.widget_pos_height) + 20)+'" style="border:none;" frameBorder="0"></iframe>';
						var mainiFrame = c.find('iframe')[0], mainiFrameDoc = mainiFrame.contentDocument || mainiFrame.contentWindow.document;

						mainiFrameDoc.open();
						mainiFrameDoc.write('<style type="text/css">html,body,iframe{margin:0;padding:0;border:none;}</style>'+subframe);
						mainiFrameDoc.close();

					//$(mainIframeDoc.body).append('<style type="text/css">html,body,iframe{margin:0;padding:0;border:none;}</style>'+subframe);

						var iframe = c.find('iframe').contents().find('iframe'), iframeChanged = false, iframeIdx = 0;

						iframe.load(function() { // This will allow for 1 load event to fire, but no more; this lets us resume the video after success! (1st is the about:blank window)
							if(iframeIdx > 0) iframeChanged = true;
							iframeIdx++;

							if(iframeChanged) {
								// Close and resume the video
								if(typeof event.callback == 'function') event.callback();
								evp.events.hide(container.data('uniqid'), false, {'actual_video': container.data('actual_video'), 'element': (container.data('isElement') === true)});
								setTimeout(function() { if(!EVP.helpers.isMobileOS()) evp.file.player.api.play(true); }, 750);
							}
						});
						return;
					}

					c.find('form').each(function(idx, form) {
						$(form).submit(function(evt) {
							if(async === false) {
								// nothing; carry on as normal
							} else {
								if(evt && evt.preventDefault) evt.preventDefault();

								var data = $(this).serialize();

								try { // try/catch because it will return an error, technically
									$.ajax({
										'data': data,
										'url': $(this).attr('action'),
										'dataType': 'jsonp',
										'crossDomain': true,
										'type': 'get',
										'async': true
									});
								} catch(e) {}

								// Close and resume the video
								if(typeof event.callback == 'function') event.callback();
								evp.events.hide(container.data('uniqid'), false, {'actual_video': container.data('actual_video'), 'element': (container.data('isElement') === true)});
								setTimeout(function() { if(!EVP.helpers.isMobileOS()) evp.file.player.api.play(true); }, 750);
							}
						});
					});
				},
				'gateway': function(evp, event, widget_idx, c, container, overlay, fullWidgetOptions) {
					switch(event.type) {
						case 'password':
							var input = c.find('input[type="password"]');

							var eval_password = function() {
								$(this).css('border-color', 'red');
								var left = container.find('.evp-gateway-left');
								var right = container.find('.evp-gateway-right');

								if($(this).val() == event.password_pw) {
									$(this).css('border-color', 'green');
									if(typeof event.callback == 'function') event.callback();
									evp.track('stats.'+event.widget_ref+'.interaction', {'uuid': EVP3.settings.uuid});
									evp.events.hide(container.data('uniqid'), false, {'duration': 0, 'actual_video': container.data('actual_video'), 'element': (container.data('isElement') === true)});
									setTimeout(function() { evp.file.player.api.play(true); }, 750);
								} else {
									$(this).css('border-color', 'red');
								}
							};

							input.keypress(function(evt) {
								if(evt.keyCode != '13') return;
								$.proxy(eval_password, this)(); // To fix IE6 not supporting bind
							//eval_password.bind(this)();
							});

							input.blur(eval_password);

							c.find('.evp-gateway-submit').click($.proxy(eval_password, input));

							break;
						case 'facebook':
							var ti = setInterval(function() {
								if(typeof FB != 'undefined') {
									clearInterval(ti);
									var c = function() {
										evp.track('stats.facebook_shares');
										evp.track('stats.'+event.widget_ref+'.interaction', {'uuid': EVP3.settings.uuid});
										if(typeof event.callback == 'function') event.callback();
										evp.events.hide(container.data('uniqid'), false, {'actual_video': container.data('actual_video'), 'element': (container.data('isElement') === true)});
										setTimeout(function() { if(!EVP.helpers.isMobileOS()) evp.file.player.api.play(true); }, 750);
									};

									container.find('.evp-gateway-facebook-fb').click(function() {
										var runCb = true;
										if(EVP.helpers.isHTML5()) { // iOS doesn't run the callback all the time, so run it now
											c();
											runCb = false;
										}

										FB.ui({
											method: 'stream.share',
											u: (typeof event.facebook_url == 'string' && event.facebook_url.length >= 1 ? event.facebook_url : window.location.href)
										}, (runCb ? c : function(){}));
									});
								}
							}, 100);
							break;
						case 'twitter':
							var ti = setInterval(function() {
								if(typeof twttr != 'undefined') {
									clearInterval(ti);
									twttr.widgets.load();

									var c = function() {
										setTimeout(function() {
											evp.track('stats.twitter_shares');
											evp.track('stats.'+event.widget_ref+'.interaction', {'uuid': EVP3.settings.uuid});
											if(typeof event.callback == 'function') event.callback();
											evp.events.hide(container.data('uniqid'), false, {'actual_video': container.data('actual_video'), 'element': (container.data('isElement') === true)});
											setTimeout(function() { if(!EVP.helpers.isMobileOS()) evp.file.player.api.play(true); }, 750);
										}, 500);
									};

									if(EVP.helpers.isHTML5()) { // The 'tweet' event doesn't get fired by iOS properly; do it here and don't duplicate it
										twttr.events.bind('click', c);
									} else {
										twttr.events.bind('tweet', c);
									}
								}
							}, 100);
							break;
						case 'optin':
							var form = c.find('.evp-gateway-optin-code form');

							// Only do this if it's at the end of the video
							if(fullWidgetOptions && (fullWidgetOptions.data['event-point'] == 'end' || parseInt(fullWidgetOptions.start) >= evp.file.metadata.duration)) {
								return false;
							}

							form.submit(function(evt) {
								if(evt && evt.preventDefault) evt.preventDefault();
								try { // try/catch because it will return an error, technically
									$.ajax({
										'data': $(this).serialize(),
										'url': $(this).attr('action'),
										'dataType': 'jsonp',
										'crossDomain': true,
										'type': 'get',
										'async': true
									});
								} catch(e) {}
								if(typeof event.callback == 'function') event.callback();
								evp.events.hide(container.data('uniqid'), false, {'actual_video': container.data('actual_video'), 'element': (container.data('isElement') === true)});
								setTimeout(function() { if(!EVP.helpers.isMobileOS()) evp.file.player.api.play(true); }, 750);
							});

							break;
					}

				}
			},
			'show': function(options, evp) {
				var klass = this;

				var opacity = (options.data['overlay-translucent'] == true ? 0.9 : 1);

				EVP.visuals.overlay.show($.extend(true, options, {
					'background': options.data['overlay-background-colour'],
					'removeBackground': (options.data['overlay-opaque'] != true),
					'useGradient': true,
					'opacity': opacity,
					'callback': function(c, container, overlay) {
						if(typeof options.data.widgets == 'undefined') return;
						$.each(options.data.widgets, function(idx, widget) {
							if(typeof klass.addEvents[widget.widget_type] == 'function') klass.addEvents[widget.widget_type](evp, widget, idx, c, container, overlay, options);
						});
					}
				}));
			},
			'hide': function(element, callback, options) {
				if(options.element === true) {
					var el = $('[id="evp-element-'+element+'"]');
					if(!el || el.length == 0) return; // Skip if the Element isn't available
					if($(el).css('display') == 'none') return; // Already hidden
					if($.browser.msie && parseInt($.browser.version) < 8) {
						$(el).css('display', 'none');
					} else {
						$(el).fadeTo(250, 0, function() {
							$(el).css('display', 'none');
						});
					}
				} else {
					EVP.visuals.overlay.hide(element, callback, options);
				}
			}
		},
		'surveys': {
			'attach': function(klass) {
				var surveys = klass.file.surveys;
				if(!surveys || surveys.length == 0) return;

				// Let's insert the area where the surveys themselves will go
				klass.survey_wrap = $('<div class="evp-survey-wrap"></div>');
				if($('#'+klass.container_id+' .evp-bar-expiration-outer-wrap').length >= 1) {
					klass.survey_wrap.insertAfter($('#'+klass.container_id+' .evp-bar-expiration-outer-wrap'));
				} else if(EVP.helpers.isHTML5()) {
					klass.survey_wrap.insertAfter('#'+klass.container_id+'-video');
				} else {
					klass.survey_wrap.insertAfter('#'+klass.container_id+'-video_wrapper');
				}

				// Bind some delegated events now
				klass.survey_wrap.delegate('.evp-survey-answer-block', 'click', function() {
					var blocks = $(this).parents('li').find('.evp-survey-answer-block').removeClass('evp-survey-answer-block-choice');
					$(this).addClass('evp-survey-answer-block-choice');
				});

				klass.survey_wrap.delegate('.evp-survey-submit', 'click', function() {
					var survey_id = $(this).parents('.evp-survey-outer').prop('id');
					var survey = false;

					$.each(surveys, function(idx, s) {
						if(s.id == survey_id) survey = s;
					});

					if(!survey) return; // Should never happen!

					// Let's check that every question is answered
					var answered = $(this).parents('.evp-survey-outer').find('.evp-survey-answer-block-choice').length;
					if(answered < survey.data.questions.length) {
						alert('Please choose an answer for every question, and then try to submit again.\n\nYou have missed '+(survey.data.questions.length - answered)+' of the questions!');
						return false;
					}

					klass.surveys.submit(survey, klass);
				});

				// Let's actually create the events to trigger the surveys
				$.each(surveys, function(survey_name, survey) {
					var hasCompletedSurvey = ($.cookie('evp_surv_'+klass.file.active_file_ref+'_'+survey.name) == 'true');

					if(hasCompletedSurvey) return; // Don't show it multiple times

					survey.id = 'evp-survey-id-'+(Math.floor(Math.random() * 999999999));
					survey.html = klass.surveys.build(survey, klass);

					var show = function() {
						klass.surveys.show(survey, klass);
					};

					if(parseInt(survey.start) >= Math.ceil(parseInt(klass.file.metadata.duration))) {
						klass.file.player.addEvent('complete', function() {
							if(klass.file.player.currentRollItem === 1 || klass.file.player.currentRollItem === false) show();
						});
					} else if(survey.start == 0) {
						klass.addEvent('onPlayerReady', function() {
							show();
						});
						if(klass.isPlayerReady === true) show();
						setTimeout(function() {
							if(klass.isPlayerReady !== true) {
								klass.fireEvent('onPlayerReady');
								klass.readyFired = klass.isPlayerReady = true;
							}
						}, 2000); // This delay manually fires the event in case, for some reason, it doesn't get fired properly
					} else {
						klass.file.player.onCuepoint(survey.start, show);
					}

					var onSeekEvent = function(d) { // Show if seeking to the middle
						var show = false, seek = parseInt(d.offset || 0);
						if(seek > start) show = true;
						if(show) show();
					};

					klass.file.player.onSeek(function(d) {
						onSeekEvent(d);
						setTimeout(function() { // Try it again in another 1s
							onSeekEvent(d);
						}, 1000);
					});
				});
			},
			'build': function(survey, klass) {
				var html = '';
				html += '<div class="evp-survey-outer" id="'+survey.id+'"><div class="evp-survey-inner">';

				// Intro
				html += '<div class="evp-survey-intro"><p>'+survey.description+'</p></div>';

				// Block
				html += '<ol class="evp-survey">';

				// Questions & answers
				$.each(survey.data.questions, function(idx, question) {
					var answers = survey.data.answers[idx];

					html += '<li class="evp-survey-question-block" data-question-idx="'+idx+'">';
						html += '<div class="evp-survey-question">';
						html += '<p>'+question+'</p>';
						html += '</div>';

						$.each(answers, function(aidx, answer) {
							html += '<div class="evp-survey-answer-block" data-question-idx="'+idx+'" data-answer-idx="'+aidx+'">';
							html += '<div class="evp-survey-answer">';
							html += '<p>'+answer+'</p>';
							html +=' </div>';
							html += '</div>';
						});

					html += '<div style="clear:both;"></div></li>';
				});

				// Close block
				html += '</ol>';

				// Submit button
				html += '<div class="evp-survey-submit"><p>Submit</p></div>';

				html += '</div></div>';
				return html;
			},
			'show': function(survey, klass) {
				// Is it already there?
				if($('#'+survey.id).length >= 1) return;

				// Inject it
				$(survey.html).appendTo(klass.survey_wrap);

				klass.survey_wrap.css({'height': 'auto', 'z-index': 301, 'position': 'relative'});

				// Animate entrance
				$('#'+survey.id).slideDown(250);

				// Pause the video?
				if(!!survey.data['survey-trigger-pause'] == true || !!survey.data['survey-act-gateway'] == true && typeof klass.file.player != 'undefined') {
					klass.file.player.api.pause(true);
				}

				// Inject a protector over the top of the video?
				if(!!survey.data['survey-act-gateway'] == true) {
					klass.video_shim.css({
						'opacity': 0,
						'cursor': 'not-allowed',
						'z-index': 2
					}).animate({'opacity': 0.5}, 500);
				}
			},
			'hide': function(survey, klass) {
				// Is it showing?
				if($('#'+survey.id).length <= 0) return;

				// Remove it
				$('#'+survey.id).slideUp(250, function() {
					$('#'+survey.id).empty().remove();
					if(klass.survey_wrap.is(':empty')) klass.survey_wrap.css({'height': 0});
				});

				// Resume the video?
				if(!!survey.data['survey-trigger-pause'] == true || !!survey.data['survey-act-gateway'] == true && typeof klass.file.player != 'undefined') {
					klass.file.player.api.play(true);
				}

				// Re-enable the video?
				klass.video_shim.animate({'opacity': 0}, 250, function() {
					klass.video_shim.css({
						'opacity': 1,
						'cursor': 'default',
						'z-index': ''
					});
				});
			},
			'submit': function(survey, klass) {
				var data = {
					'method': 'public-survey-submit',
					'uuid': EVP3.settings.uuid,
					'responseType': 'jsonp',
					'file_ref': klass.file.active_file_ref,
					'survey_name': survey.name,
					'answers': {}
				};

				// Collate the data into data.answers
				$('#'+survey.id+' .evp-survey-answer-block-choice').each(function(i, a) {
					var aidx = $(a).data('answer-idx'), qidx = $(a).data('question-idx');
					data.answers[qidx] = aidx;
				});

				$.ajax({
					'url': EVP3.settings.api_location,
					'dataType': 'jsonp',
					'data': data,
					'complete': function() {
						klass.surveys.hide(survey, klass);
						var exp = new Date();
						exp.setHours(exp.getHours() + 4500);
						$.cookie('evp_surv_'+klass.file.active_file_ref+'_'+survey.name, 'true', {'expires': exp});
					}
				});
			}
		},
		'build_tooltip_overlay': function() {
			var new_id = this.container_element.prop('id')+'-tooltip';

			// Set the dimensions etc
			$(this.container_element).css({
				'position': 'relative',
				'text-align': 'left',
				'direction': 'ltr'
			});

			var klass = this;
			var container = this.container_element;

			var tooltip_trigger = this.tooltip_trigger = $('<div class="evp-tooltip-trigger" href="#'+new_id+'"></div>').css({
				'position': 'absolute',
				'top': 0,
				'left': 0,
				'width': 0,
				'height': 0,
				'cursor': 'pointer'
			}).appendTo(this.container_element);

			var tooltip_image = this.tooltip_image = $('<img src="'+this.file.options.related_image+'" alt="" />').css({
				'cursor': 'pointer',
				'border': 'none',
				'margin': 0,
				'padding': 0,
				'border-radius': 0
			});

			var tooltip_container = this.tooltip_container = $('<div class="evp-tooltip-container"></div>').css({
				'background': '#000',
				'width': this.file.options.width,
				'height': this.file.options.height,
				'position': 'absolute',
				'top': 0,
				'left': 0,
				'padding': 5,
				'border-radius': 3,
				'z-index': 305, // Make sure it goes above everything else EVS-related
				'display': 'none'
			}).appendTo(document.body);

			var tooltip_tip = this.tooltip_tip = $('<div class="evp-tooltip-tip"></div>').css({
				'width': 0,
				'height': 0,
				'border-left': '10px solid transparent',
				'border-right': '10px solid transparent',
				'border-bottom': '10px solid #000',
				'position': 'absolute',
				'top': -10,
				'left': (parseInt(this.file.options.width) / 2) - 5
			}).appendTo(tooltip_container);

			tooltip_image.prependTo(this.container_element);

			// Let's duplicate the container and rename it
			this.container_id = new_id;
			this.container_element_initial = this.container_element;
			this.container_element = this.container_element.clone().empty().prependTo(tooltip_container).prop('id', new_id);

			if(klass.file.options.related_image_play == true) {
				klass.preload(EVP3.settings.location+'/player/assets/'+klass.player_name+'/skins/'+klass.file.options.skin+'/display/background.png', EVP3.settings.location+'/player/assets/'+klass.player_name+'/skins/'+klass.file.options.skin+'/display/playIcon.png');
			}

			// Do we already know the dimensions of the image, which was set during upload?
			if(typeof this.file.options.splash_width !== 'undefined' && typeof this.file.options.splash_height !== 'undefined') {
				$([tooltip_image, tooltip_trigger[0], klass.container_element_initial[0]]).css({'width': this.file.options.splash_width, 'height': this.file.options.splash_height});
			}

			// Add the load event
			tooltip_image.load(function() {
				var img = this;

				// Inject the play icon?
				setTimeout(function() {
					var img_width = $(img).width();
					var img_height = $(img).height();

					// Position the container
					var offset = $(img).offset();
					tooltip_container.css({
						'top': offset.top + img_height + 10,
						'left': offset.left - (parseInt(img_width) / 2)
					});

					// Explicitly set the widths for img, trigger div and the initial wrapper too
					$([img, tooltip_trigger[0], klass.container_element_initial[0]]).css({'width': img_width, 'height': img_height});

					// This makes no kind of sense whatsoever
					// but IE requires an image set on this element, and that this element exists
					// With the element but without the image? Doesn't work.
					// Lovely.
					var bg_img = 'url('+EVP3.settings.location+'/player/images/transparent.png)';
					if(klass.file.options.related_image_play == true) {
						bg_img = 'url('+EVP3.settings.location+'/player/assets/'+klass.player_name+'/skins/'+klass.file.options.skin+'/display/playIcon.png), url('+EVP3.settings.location+'/player/assets/'+klass.player_name+'/skins/'+klass.file.options.skin+'/display/background.png)';
					}

					var play_wrap = $('<div class="evp-tooltip-play-wrap"></div>').css({
						'text-align': 'center',
						'position': 'absolute',
						'top': 0,
						'left': 0,
						'width': img_width,
						'height': img_height,
						'background-image': bg_img,
						'background-position': 'center, center',
						'background-repeat': 'no-repeat'
					});

					play_wrap.prependTo(container);
				}, 500);
			});

			// Now let's actually build the video into that invisible container
			this.build_player();

			// Add the events
			var isInside = false;

			tooltip_container.hover(function() {
				isInside = true;
			}, function() {
				isInside = false;
				if(typeof klass.file.player !== 'undefined' && (klass.file.player.getState() == 'playing' || klass.file.player.getState() == 'buffering')) isInside = true;
				setTimeout(function() { if(!isInside) klass.tooltip_container.fadeOut(); }, 500);
			});

			tooltip_trigger.click(function() {
				klass.tooltip_container.fadeIn();
				isInside = true;
			}).hover(function() {
				klass.tooltip_container.fadeIn();
				isInside = true;
			}, function() {
				isInside = false;
				if(typeof klass.file.player !== 'undefined' && (klass.file.player.getState() == 'playing' || klass.file.player.getState() == 'buffering')) isInside = true;
				setTimeout(function() { if(!isInside) klass.tooltip_container.fadeOut(); }, 500);
			});
		},
		'build_lightbox': function() {
			var new_id = this.container_element.prop('id')+'-lightbox';

			// Set the dimensions etc
			$(this.container_element).css({
				'position': 'relative',
				'text-align': 'left',
				'direction': 'ltr'
			});

			var klass = this;
			var container = this.container_element;

			var lightbox_trigger = this.lightbox_trigger = $('<div class="evp-lightbox-trigger" href="#'+new_id+'"></div>').css({
				'position': 'absolute',
				'top': 0,
				'left': 0,
				'width': 0,
				'height': 0,
				'cursor': 'pointer'
			}).appendTo(this.container_element);

			var lightbox_image = this.lightbox_image = $('<img src="'+this.file.options.related_image+'" alt="" />').css({
				'cursor': 'pointer',
				'border': 'none',
				'margin': 0,
				'padding': 0,
				'border-radius': 0
			});

			lightbox_image.prependTo(this.container_element);

			// Let's duplicate the container and rename it
			this.container_id = new_id;
			this.container_element_initial = this.container_element;
			this.container_element = this.container_element.clone().empty().appendTo(
				$('<div style="display:none;"></div>').appendTo(document.body)
			).prop('id', new_id);

			if(klass.file.options.related_image_play == true) {
				klass.preload(EVP3.settings.location+'/player/assets/'+klass.player_name+'/skins/'+klass.file.options.skin+'/display/background.png', EVP3.settings.location+'/player/assets/'+klass.player_name+'/skins/'+klass.file.options.skin+'/display/playIcon.png');
			}

			// Do we already know the dimensions of the image, which was set during upload?
			if(typeof this.file.options.splash_width !== 'undefined' && parseInt(this.file.options.splash_width) > 0 && typeof this.file.options.splash_height !== 'undefined' && parseInt(this.file.options.splash_height) > 0) {
				$([lightbox_image, lightbox_trigger[0], klass.container_element_initial[0]]).css({'width': this.file.options.splash_width, 'height': this.file.options.splash_height});
			}

			// Add the load event
			lightbox_image.load(function() {
				var img = this;
				// Inject the play icon?
				setTimeout(function() {
					$.colorbox.init();
					var img_width = $(img).width();
					var img_height = $(img).height();

					// Explicitly set the widths for img, trigger div and the initial wrapper too
					$([img, lightbox_trigger[0], klass.container_element_initial[0]]).css({'width': img_width, 'height': img_height});

					// This makes no kind of sense whatsoever
					// but IE requires an image set on this element, and that this element exists
					// With the element but without the image? Doesn't work.
					// Lovely.
					var bg_img = 'url('+EVP3.settings.location+'/player/images/transparent.png)';
					var bg_pos = 'center, center';
					if(klass.file.options.related_image_play == true) {
						bg_img = 'url('+EVP3.settings.location+'/player/assets/'+klass.player_name+'/skins/'+klass.file.options.skin+'/display/playIcon.png), url('+EVP3.settings.location+'/player/assets/'+klass.player_name+'/skins/'+klass.file.options.skin+'/display/background.png)';
						if(($.browser.msie && parseInt($.browser.version) <= 7)) {
							bg_img = 'url('+EVP3.settings.location+'/player/assets/'+klass.player_name+'/skins/'+klass.file.options.skin+'/display/playIcon.png)';
							bg_pos = 'center';
						}
					}

					var play_wrap = $('<div class="evp-lightbox-play-wrap"></div>').css({
						'text-align': 'center',
						'position': 'absolute',
						'top': 0,
						'left': 0,
						'width': img_width,
						'height': img_height,
						'background-image': bg_img,
						'background-position': bg_pos,
						'background-repeat': 'no-repeat'
					});

					play_wrap.prependTo(container);

					if(klass.file.options.auto_trigger == 1 || klass.file.options.auto_trigger == true) {
						lightbox_trigger.trigger('click');
					}
				}, 500);
			});

			// If we aren't explicitly loading up a lightbox image, let's totally hide that initial container
			if(this.file.parameters.nolightboxtrigger == true) this.container_element_initial.css('display', 'none');

			// Now let's actually build the video into that invisible container
			this.build_player();

			// Do we need to up it for the bar too?
			var bar_height = 32 * (this.container_element.find('.evp-bar-row'));
			lightbox_trigger.colorbox({
				'fixed': true,
				'inline': true,
				'scrolling': false,
				'transition': 'fade',
				'initialWidth': 100,
				'initialHeight': 100,
				'innerWidth': parseInt(this.file.options.width),
				'innerHeight': parseInt(this.file.options.height) + bar_height,
				'onLoad': function() {
					if(klass.file.options.auto_play && !EVP.helpers.isMobileOS() && (klass.file.options.player_lightsout !== 'on' && klass.file.options.player_lightsout !== true)) {
						var x = 0, i = setInterval(function() {
							if($('#'+klass.container_id).height() > 0) {
								klass.file.player.api.play();
								if(klass.file.player.api.getState() === 'PLAYING') {
									clearInterval(i);
								}
							}
							x++;
							if(x > 200) clearInterval(i);
						}, 10);
					}
				},
				'onClosed': function() {
					try {
						klass.file.player.api.stop(); // This fixes Firefox 20+ from continuing to play inside the lightbox
					} catch(e) {}
				}
			});

			// This allows you to make <a href="#evp-xxxxx">Click me</a> links which will trigger the lightbox! They can be anything!
			$(document.body).delegate('[href="#'+this.container_element_initial.prop('id')+'"]', 'click', function() {
				lightbox_trigger.trigger('click');
				return false;
			});
		},
		'build_player': function() {
			var klass = this;

			// Let's remove some things which aren't applicable to audio files here
			if(this.file.config.type == 'audio') {
				this.file.options.frame = false;
			}

			// Confirm that an image is actually used
			if(this.file.options.related_image_mode == 'splash' && this.file.options.related_image.indexOf(EVP3.settings.location+'/player/images/no-image.png') !== -1) {
				this.file.options.related_image_mode = 'none';
			}

			// Build the video wrapper
			var video_element = this.video_element = $('<div id="'+this.container_id+'-video"></div>');

			// Build the shim
			var video_shim = this.video_shim = $('<div id="'+this.container_id+'-video-shim"></div>');

			this.container_element.append(video_shim, video_element);

			// Set the dimensions etc
			$(this.container_element).css({
				'position': 'relative',
				'text-align': 'left',
				'direction': 'ltr',
				'width': this.file.options.width,
				'clear': 'both'
			});

			if(!(this.file.options.related_image_mode == 'lightbox' || typeof this.file.options.frame == 'undefined' || this.file.options.frame == '' || typeof this.file.frame == 'undefined')) {
				// Let's enforce the minimum dimensions for frames
				if(parseInt(this.file.frame.config.minimum_width) > 0) if(parseInt(this.file.options.width) < parseInt(this.file.frame.config.minimum_width)) this.file.options.width = parseInt(this.file.frame.config.minimum_width);
				if(parseInt(this.file.frame.config.minimum_height) > 0) if(parseInt(this.file.options.height) < parseInt(this.file.frame.config.minimum_height)) this.file.options.height = parseInt(this.file.frame.config.minimum_height);
				video_shim.css({
					'top': parseInt(this.file.frame.config.video_indent_top),
					'left': parseInt(this.file.frame.config.video_indent_left)
				});
			}

			// Apply the sizing to this video element, so that it fills the container
			video_shim.css({
				'width': this.file.options.width,
				'height': (this.file.config.type == 'audio' ? parseInt(this.file.options.skin_height || 32) : this.file.options.height),
				'position': 'absolute'
			});

			if(this.file.options.related_image_mode == 'splash') {
				var klass = this;

				this.addEvent('onSplashBuilt', function(evp, splash, splash_wrap) {
					$(splash_wrap).click(function() {
						if(EVP.helpers.isMobileOS()) {
							$(this).remove();
							var play = true;
							$.each(klass.file.events, function(evt_name, evt) { // Is there an Event at the start?
								if(evt.start == 0 && play == true && evt.data && evt.data['overlay-trigger-pause'] == true) play = false;
							});
							if(typeof EVP3.plugins['password-protect'] != 'undefined') play = false;
							if(play) klass.file.player.api.play(true);
						} else {
							$(this).fadeOut(500);
							var play = true;
							$.each(klass.file.events, function(evt_name, evt) { // Is there an Event at the start?
								if(evt.start == 0 && play == true && evt.data && evt.data['overlay-trigger-pause'] == true) play = false;
							});
							if(typeof EVP3.plugins['password-protect'] != 'undefined') play = false;
							if(play) klass.file.player.api.play(true);
						}
						if(play) klass.fireEvent('onSplashClicked');
					});
				});

				this.build_splash();
			}

			this['build_'+this.player_type]();

			this.build_frame();

			// If this is a playlist, we should add the pane in the appropriate place
			if(this.file.playlist) {

				// Remove the overlaid options
				if(this.file.playlist_position == 1) this.file.playlist_position = '3';
				else if(this.file.playlist_position == 2)  this.file.playlist_position = '4';

				var shouldShowHide = false;
				var playlistHeight = (this.file.playlist_position == '5' ? 165 : parseInt(this.file.options.height));
				if(playlistHeight > 340) playlistHeight = 340;

				var areScrollbarsInvisible = !(/mac/gi.test(navigator.userAgent) && /webkit/gi.test(navigator.userAgent));//!(/mac/gi.test(navigator.userAgent));

				this.playlist_bg = $('<div id="'+this.container_id+'-playlist-bg" class="evp-playlist-bg evp-playlist-bg-pos-'+this.file.playlist_position+'"></div>').css({
					'width': (areScrollbarsInvisible ? 185 : 170),
					'height': this.file.options.height - 2 - parseInt(this.file.options.skin_data.chapter_bottom),
					'position': 'absolute',
					'top': 0,
					'z-index': 301,
				//'z-index': 2,
					'background': '#000',//'#2a2a2a',
					'opacity': 0.8,
					'border': 'none',
					'border-radius': 0
				}).appendTo(this.container_element);

				this.playlist = $('<div id="'+this.container_id+'-playlist" class="evp-playlist evp-playlist-pos-'+this.file.playlist_position+'"></div>').css({
					'width': (areScrollbarsInvisible ? 181 : 166),
					'height': this.file.options.height - 2 - parseInt(this.file.options.skin_data.chapter_bottom),
					'position': 'absolute',
					'top': 0,
					'z-index': 301,
				//'z-index': 2,
					'border': 'none',
					'margin': '2px 2px 0 2px'
				});

				this.playlist.css({
					'overflow-x': 'hidden',
					'overflow-y': 'scroll'
				});

				this.playlist_inner = $('<div id="'+this.container_id+'-playlist-inner" class="evp-playlist-inner"></div>').appendTo(this.playlist);

				this.playlist_control_prev = $('<div id="'+this.container_id+'-playlist-control-prev" class="evp-playlist-control-prev"></div>').css({
					'display': 'none',
					'cursor': 'pointer',
					'width': 0,
					'height': 0,
					'border-top': '8px solid transparent',
					'border-bottom': '8px solid transparent',
					'border-right': '8px solid #fff',
					'position': 'absolute',
					'left': 15,
					'top': ((playlistHeight - 15) / 2) - 4,
					'opacity': 0.3
				}).appendTo(this.playlist_bg);

				this.playlist_control_next = $('<div id="'+this.container_id+'-playlist-control-next" class="evp-playlist-control-next"></div>').css({
					'display': 'none',
					'cursor': 'pointer',
					'width': 0,
					'height': 0,
					'border-top': '8px solid transparent',
					'border-bottom': '8px solid transparent',
					'border-left': '8px solid #fff',
					'position': 'absolute',
					'right': 15,
					'top': ((playlistHeight - 15) / 2) - 4,
					'opacity': 0.3
				}).appendTo(this.playlist_bg);

				var the_width = parseInt(klass.file.options.width) + klass.playlist_bg.width() + 2;

				klass.positionPlaylist = function() {
					the_width = parseInt(klass.file.options.width) + klass.playlist_bg.width() + 2;

					switch(klass.file.playlist_position) {
						case '0': // None
							klass.playlist_bg.css({'display': 'none'});
							klass.playlist.css({'display': 'none'});
							break;

						case '3': // Next to, left
							shouldShowHide = false;

							if($('#'+klass.container_id+'-playlist-padder').length == 0) $('#'+klass.container_id+'-video'+(EVP.helpers.isHTML5() ? '' : '_wrapper')).wrap($('<div id="'+klass.container_id+'-playlist-padder"></div>').css({
								'background': '#000',
								'padding': '2px 0 2px 2px',
								'margin-left': (areScrollbarsInvisible ? 183 : 168)
							}));

							klass.container_element.find('.evp-splash-wrap').css({'margin-left': (areScrollbarsInvisible ? 183 : 168)}); // Move splash if needed
							klass.container_element.css({'width': the_width});
							$('#'+klass.container_id+'-video-shim').css({'left': 2, 'top': 2});

							klass.playlist_bg.css({'left': 0, 'opacity': 1, 'height': parseInt(klass.file.options.height || 240) + 4});
							klass.playlist.css({'left': 0, 'height': parseInt(klass.file.options.height || 240)});
							break;

						case '4': // Next to, right
							shouldShowHide = false;

							if($('#'+klass.container_id+'-playlist-padder').length == 0) $('#'+klass.container_id+'-video'+(EVP.helpers.isHTML5() ? '' : '_wrapper')).wrap($('<div id="'+klass.container_id+'-playlist-padder"></div>').css({
								'background': '#000',
								'padding': '2px 0 2px 2px'
							}));

							klass.container_element.css({'width': the_width});
							$('#'+klass.container_id+'-video-shim').css({'left': 2, 'top': 2});

							klass.playlist_bg.css({'right': 0, 'opacity': 1, 'height': parseInt(klass.file.options.height || 240) + 4});
							klass.playlist.css({'right': 0, 'height': parseInt(klass.file.options.height || 240)});
							break;

						case '5': // Under
							shouldShowHide = false;

							klass.playlist.css({
								'overflow-x': 'hidden',
								'overflow-y': 'hidden',
								'margin': '15px 2px 0 2px',
								'top': parseInt(klass.file.options.height),
								'left': 40,
								'height': playlistHeight - 4 - 15,
								'width': parseInt(klass.file.options.width) - 4 - 40 - 40
							});

							klass.playlist_inner.css({
								'width': '10000px',
								'position': 'absolute',
								'top': 0,
								'left': 0
							});

							klass.playlist_bg.css({
								'position': 'relative',
								'opacity': 1,
								'box-shadow': 'none',
								'border-right': 'none',
								'width': klass.file.options.width,
								'height': playlistHeight
							});

							klass.playlist_control_prev.css({
								'display': 'block'
							});

							klass.playlist_control_next.css({
								'display': 'block'
							});

							break;
					}
				}

				klass.positionPlaylist();
				var playlistPosInt = setInterval(klass.positionPlaylist, 100);
				setTimeout(function() {
					clearInterval(playlistPosInt);
				}, 3000);

				var isMouseIn = true;
				var pli_img_width = (klass.file.playlist_position == '5' ? 100 : 159);//120);

				var showPlaylist = function() {
					if(!shouldShowHide) return;
					klass.playlist_bg.stop().animate({'opacity': 0.8, 'width': 200}, 200, function() {
						klass.playlist.stop().animate({'opacity': 1}, 100);
					});
				}

				var hidePlaylist = function() {
					if(!shouldShowHide) return;
					klass.playlist.stop().animate({'opacity': 0}, 100, function() {
						klass.playlist_bg.stop().animate({'opacity': 0, 'width': 0}, 200);
					});
				};

				this.file.player.api.onPause(function() {
					showPlaylist();
				});

				this.file.player.api.onPlaylistItem(function(d) {
					var idx = d.index;
					klass.file.active_file_ref = klass.file.playlist[idx].id;

					var others = klass.container_element.find('.evp-playlist-item:not([data-plidx="'+idx+'"])');
					var el = klass.container_element.find('.evp-playlist-item[data-plidx="'+idx+'"]');

					others.removeClass('evp-playlist-active');
					others.find('.evp-playlist-item-label').animate({'color': '#fff'});
					others.find('.evp-playlist-item-marker').animate({'opacity': 0});
					el.find('.evp-playlist-item-body').animate({'background-color': 'rgba(0,0,0,0.4)'}, 100);
					el.addClass('evp-playlist-active');
					el.find('.evp-playlist-item-label').animate({'color': '#00ADEF'});
					el.find('.evp-playlist-item-body').animate({'background-color': 'rgba(0,0,0,0.9)'}, 100);
					el.find('.evp-playlist-item-marker').animate({'opacity': 1});

					showPlaylist();
					setTimeout(function() {
						if(!isMouseIn) hidePlaylist();
					}, 2000);
				});

				// Show and hide this thing
				this.container_element.hover(function() {
					isMouseIn = true;
					showPlaylist();
				}, function() {
					isMouseIn = false;
					hidePlaylist();
				});

				// Let's build the direct links
				$.each(this.file.playlist, function(idx, pli) {
					var el = $('<div id="'+klass.container_id+'-playlist-item-'+pli.id+'" data-plidx="'+idx+'" class="evp-playlist-item"></div>').css({
						'color': '#000',
						'font-size': (klass.file.playlist_position == 5 ? 14 : 12),
						'font-family': 'Arial,Helvetica,sans-serif',
						'padding': 4,
						'margin': 0,
						'cursor': 'pointer',
						'position': 'relative',
						'overflow': 'auto',
						'background': '#F2F2F2',
						'margin': '0 0 2px 0'
					}).hover(function() {
						if(!$(this).hasClass('evp-playlist-active')) {
						//$(this).stop().animate({'color': '#fff', 'background-color': '#434343'}, 150);
							$(this).find('.evp-playlist-item-label').stop().animate({'color': '#00ADEF'});
							$(this).find('.evp-playlist-item-body').stop().animate({'background-color': 'rgba(0,0,0,0.9)'}, 150);
						}
					}, function() {
						if(!$(this).hasClass('evp-playlist-active')) {
						//$(this).stop().animate({'color': '#fff', 'background-color': '#f2f2f2'}, 150);
							$(this).find('.evp-playlist-item-label').stop().animate({'color': '#fff'});
							$(this).find('.evp-playlist-item-body').stop().animate({'background-color': 'rgba(0,0,0,0.4)'}, 150);
						}
					}).click(function() {

						// Remove the splash image?
						var splash = $(klass.container_element).find('.evp-splash-wrap');
						if(splash.length >= 1) {
							if(EVP.helpers.isAndroid() || EVP.helpers.isBlackberry()) $(klass.container_element).find('#'+klass.container_id+'-video_wrapper').css('visibility', 'visible');
							splash.fadeOut(500, function() {
								klass.file.player.api.play(true);
							});
						}

						// And play this item!
						klass.file.player.api.playlistItem(idx);
					});

					if(klass.file.playlist_position == 5) {
						el.css({
							'width': pli_img_width,
						//'float': 'left',
							'display': 'inline-block',
							'vertical-align': 'bottom',
							'margin': '0 5px 0 0'
						//'padding': 8
						});
					}

					// Add the related image
					var im = $('<div class="evp-playlist-item-image"></div>').css({
						'width': pli_img_width,
						'min-height': (!!pli.related_image ? '56px' : ''),
						'height': 'auto',
						'margin': '0'//'0 8px 0 0'
					}).appendTo(el);
					if(!!pli.related_image) im.append($('<img class="evp-playlist-item-img" src="'+pli.related_image+'" alt="" />').css({
						'padding': 0,
						'margin': 0,
						'border': 'none',
						'background': 'none',
						'width': pli_img_width
					}));

					// Now the main body
					var body = $('<div class="evp-playlist-item-body"></div>').css({
						'width': pli_img_width - 10,//parseInt(klass.playlist.width()) - 17, // img width doesn't include the margin
						'background': 'rgba(0,0,0,0.5)',
						'padding': 5,
						'position': (!!pli.related_image ? 'absolute' : ''),
						'bottom': 6,
						'left': 4,
						'line-height': 'normal'
					});

					if(klass.file.playlist_position == 5) { // If it's under, restrict the sizes
						body.css({
							'max-height': 96,
							'overflow': 'hidden'
						});
					}

					// Add the label
					$('<div class="evp-playlist-item-label">'+pli.label+'</div>').css({
						'font-weight': 'bold',
						'color': '#fff',
						'margin': '0 0 5px 0'
					}).appendTo(body);

					// Add the description?
					if(pli.description) {
						if(klass.file.playlist_position != '5') pli.description = (pli.description.length >= 70 ? pli.description.substr(0, 70)+'..' : pli.description);
						$('<div class="evp-playlist-item-description">'+pli.description+'</div>').css({
							'font-weight': 'normal',
							'color': '#fff'
						}).appendTo(body);
					}

					body.appendTo(el);

					// Add the duration?
					if(pli.duration) {
						var dur = $('<div class="evp-playlist-item-meta">'+pli.duration+'</div>').css({
							'font-weight': 'bold',
							'font-size': 9,
							'position': 'absolute',
							'padding': 2,
							'border-radius': 4,
							'background': '#2a2a2a',
							'color': '#fff'
						}).appendTo(el);

						if(klass.file.playlist_position != 5) {
							dur.css({'left': pli_img_width - 23, 'top': 4});
						} else {
							dur.css({'top': 5, 'right': 5, 'border-top-right-radius': 0, 'border-bottom-right-radius': 0, 'border-top-left-radius': 0});
						}
					}

					// Add the marker and reflection?
					if(klass.file.playlist_position == 5) {
						el.css({
							'overflow': 'visible',
							'-webkit-box-reflect': 'below 2px -webkit-gradient(linear, left top, left bottom, from(transparent), color-stop(0.7, transparent), to(rgba(255,255,255,0.4)))'
						});

						$('<div class="evp-playlist-item-marker"></div>').css({
							'position': 'absolute',
							'opacity': 0,
							'top': 0,
							'left': (pli_img_width / 2) - 4,
							'width': 0,
							'height': 0,
							'border-left': '8px solid transparent',
							'border-right': '8px solid transparent',
							'border-top': '8px solid #000'
						}).appendTo(el);
					}

				//$('<div style="clear:both;"></div>').appendTo(el);

					el.appendTo(klass.playlist_inner);
				});

				// Add the controls events?
				var totalItems = this.file.playlist.length - 1;
				var currentItem = 0;

				if(klass.file.playlist_position == 5) {
					klass.playlist_control_prev.hover(function() {
						$(this).stop().animate({'opacity': 0.8});
					}, function() {
						$(this).stop().animate({'opacity': 0.4});
					});

					klass.playlist_control_next.hover(function() {
						$(this).stop().animate({'opacity': 0.8});
					}, function() {
						$(this).stop().animate({'opacity': 0.4});
					});
				}

				this.playlist.appendTo(this.container_element);

				if(klass.file.playlist_position == 5) {
					var carouselToDisplay = 5;
					carouselToDisplay = Math.floor((parseInt(this.playlist.width()) / pli_img_width));
					$(klass.container_element).tinycarousel({'display': carouselToDisplay});
				}
			}

			this.build_expiration_bar();
			this.build_bar();
			this.build_shadow();

			// If it's an audio player without a splash, we should inject a special element for the Events
			if(this.file.config.type == 'audio' && this.file.options.related_image_mode != 'splash') {
				$('<div id="'+this.container_id+'-event-container"></div>').css({
					'width': this.file.options.width,
					'height': 0, // Initially it's hidden
					'position': 'absolute',
					'top': parseInt(this.file.options.skin_height || 32),
					'left': 0
				}).appendTo(this.container_element);
			}

			this.fireEvent('onBuilt');

			this.attach_events();
			this.fireEvent('onEventsAttached');

			setTimeout(function() { // Delay this, because otherwise, the 'lights out' feature breaks surveys.. odd one..
				klass.surveys.attach(klass);
				klass.fireEvent('onSurveysAttached');
			}, 100);

			klass.addEvent('onPlayerReady', function() {
				// If it's faux-live controls, let's add the image right now
				if(klass.file.options.player_controls == 'fauxlive') {
					var live = klass.fauxlive = $('<div id="'+klass.container_id+'-fauxlive">Streaming</div>').css({
						'background': 'url('+EVP3.settings.location+'/player/images/streaming.gif?v=1) no-repeat 0 0',
						'color': 'red',
						'width': '110px',
						'padding': '0 0 0 20px',
						'height': '17px',
						'line-height': '17px',
						'font-size': '11px',
						'z-index': 2,
						'position': 'absolute',
						'left': '10px',
						'bottom': '25px',
						'cursor': 'default',
						'opacity': 0
					}).appendTo($('#'+klass.container_id+'-video'+(EVP.helpers.isHTML5() && klass.file.config.prettySource != 'youtube' ? '' : '_wrapper')));

					var livebar = klass.fauxlivebar = $('<div id="'+klass.container_id+'-fauxlive-bar"></div>').css({
						'background': 'url('+EVP3.settings.location+'/player/images/fauxlivebar.png) repeat-x 0 0',
						'width': klass.file.options.width,
						'height': '15px',
						'z-index': 2,
						'border-top': '2px solid #000',
						'position': 'absolute',
						'left': 0,
						'bottom': 0,
						'cursor': 'default',
						'opacity': 0
					}).appendTo($('#'+klass.container_id+'-video'+(EVP.helpers.isHTML5() && klass.file.config.prettySource != 'youtube' ? '' : '_wrapper')));

					// This will endlessly animate the background position so it looks like it's scrolling
					var startLiveBar = function() {
						if(livebar.data('livebaranim')) return false; // Don't double up
						var bgp = 0;
						livebar.data('livebaranim', setInterval(function() {
							bgp = bgp + 3;
							livebar.stop().animate({
								'opacity': 0.8
							}, 100);
							if(!($.browser.msie && parseInt($.browser.version) <= 8)) {
								livebar.css({'background-position': ''+bgp+'px'});
							}
						}, 100));
						live.animate({'opacity': 0.5}, 250);
					}

					var stopLiveBar = function() {
						var anim = livebar.data('livebaranim');
						if(anim) clearInterval(anim);
						livebar.data('livebaranim', false);
						livebar.animate({
							'opacity': 0
						}, 250);
						live.animate({'opacity': 0}, 250);
					}

					klass.file.player.api.onBuffer(function() {
						startLiveBar();
					});

					klass.file.player.api.onPlay(function() {
						startLiveBar();
					});

					klass.file.player.api.onIdle(function() {
						stopLiveBar();
					});

					klass.file.player.api.onPause(function() {
						stopLiveBar();
					});
				}

				klass.build_plugins();
			});

			// Player entrance
			var klass = this;

			(function() {
				if(klass.file.options.related_image_mode !== 'lightbox' && klass.file.options.related_image_mode !== 'tooltip' && typeof klass.file.options.player_entrance !== 'undefined') {
					var el = $(klass.container_element);

					if(!EVP.helpers.isMobileOS() && EVP.helpers.supportsCSSAnimations()/* && (!$.browser.mozilla || ($.browser.mozilla && !/mac/i.test(navigator.userAgent)))*/ && klass.file.options.player_entrance.substr(0, 5) == 'css3-') {
					//el.stop().css('opacity', 0).find('object').css('visibility', 'hidden');
						el.stop().fadeTo(0, 0);//.find('object').css('visibility', 'hidden');
					} else if(!$.browser.msie || ($.browser.msie && parseInt($.browser.version) >= 9)) {
						switch(klass.file.options.player_entrance) { // Set it hidden instantly
							case 'drop':
								el.stop().hide(0);
								break;
							case 'slide':
								el.stop().slideUp(0);
								break;
							default:
								el.stop().fadeTo(0, 0);
								break;
						}
					}

					klass.preload_event(function() { // Load 'er up once all the images are done
						if(!EVP.helpers.isMobileOS() && EVP.helpers.supportsCSSAnimations()/* && (!$.browser.mozilla || ($.browser.mozilla && !/mac/i.test(navigator.userAgent)))*/ && klass.file.options.player_entrance.substr(0, 5) == 'css3-') {
							el.stop().addClass('animated '+klass.file.options.player_entrance.substr(5));
							el.fadeIn();
							setTimeout(function() {
							//el.css('opacity', 1);
								el.removeClass('animated '+klass.file.options.player_entrance.substr(5)).css('opacity', 1);
							//el.find('object').css('visibility', 'visible');
							}, 1200);
						} else if(!$.browser.msie || ($.browser.msie && parseInt($.browser.version) >= 9)) {
							switch(klass.file.options.player_entrance) {
								case 'drop':
									el.stop().show(750);
									break;
								case 'slide':
									el.stop().slideDown(750);
									break;
								default:
									el.stop().fadeTo(250, 1);
									break;
							}
						}
					});
				}
			})();

			// Start preloading
			this.preload_start();
		},
		'build_plugins': function() {
			if(this.file.plugins.length <= 0) return;
			// Let's build the plugins
			// These can do ANYTHING and are the last things initialised
			var klass = this;
			$.each(this.file.plugins, function(plugin_idx, plugin) {
				new EVP3.plugins[plugin.slug](klass, klass.file, plugin, plugin.file_options);
			});
		},
		'build_frame': function() {
			if(this.file.options.related_image_mode == 'lightbox' || typeof this.file.options.frame == 'undefined' || this.file.options.frame == '' || typeof this.file.frame == 'undefined') return; // Make sure a frame is selected

			var styling = this.file.frame.config.styling;

			var klass = this;

			// Let's work out some dimensions
			var frame_width = parseInt(this.file.options.width) + parseInt(styling['bottom-left'].width) + parseInt(styling['bottom-right'].width);
			var frame_height = parseInt(this.file.options.height) + parseInt(styling['top'].height) + parseInt(styling['bottom'].height);

			var display_width = (typeof this.file.frame.config.width_addition != 'undefined' ? parseInt(this.file.options.width) + parseInt(this.file.frame.config.width_addition) : frame_width);
			var display_height = (typeof this.file.frame.config.height_addition != 'undefined' ? parseInt(this.file.options.height) + parseInt(this.file.frame.config.height_addition) : frame_height);

			/*
			if(this.isResponsiveVideo()) { // If we are responsive, we need to re-set the video dimensions here actually, because they're wrong

				var originalWidth = parseInt(this.file.options.width);
				var originalHeight = parseInt(this.file.options.height);
				var ratio = originalHeight / originalWidth;
				var el = this.container_element;

				var newWidth = parseInt(this.file.options.width);// - parseInt(styling['bottom-left'].width);
				var newHeight = parseInt(ratio * newWidth);

				// Store the data
				klass.file.options.width = newWidth;
				klass.file.options.height = newHeight;

				// Resize the shim, etc (Other, non-JWP components mostly)
				$('#'+klass.container_id+'-video-shim, #'+klass.container_id+'-video_wrapper').css({'width': newWidth, 'height': newHeight});
			}
			*/

			// Style the frame
			var frame = ($(klass.container_element).find('.evp-frame')[0] || $('<div class="evp-frame"></div>'))
			frame = $(frame);
			frame.css({
				'position': 'relative',
				'width': display_width+'px',
				'height': display_height+'px'
			});

			// Overwrite the height of the element itself
			setTimeout(function() {
				var el = $(klass.container_element);
				var bar = el.find('.evp-bar');

				if(bar.length > 0) {
					display_height += (bar.outerHeight() + parseInt(klass.file.frame.config.gap_until_bar) - parseInt(bar.css('top')) + 20);
				}

				if(el.find('.evp-shadow').length >= 1) {
					display_height += parseInt(el.find('.evp-shadow').height());
				}

				if(klass.file.options.use_reflection == true && klass.file.widgets.length == 0 && !EVP.helpers.isAndroid() && !EVP.helpers.isBlackberry()) {
					display_height += parseInt(klass.file.frame.config.reflection_height || 40);
				}

				el.css({
					'width': display_width+'px',
					'height': display_height+'px'
				});
			}, 50);

			// Let's create the elements first of all
			var top = ($(klass.container_element).find('.evp-frame-top')[0] || $('<div class="evp-frame-top"></div>'));
			var top_left = ($(klass.container_element).find('.evp-frame-top-left')[0] || $('<div class="evp-frame-top-left"></div>'));
			var top_centre = ($(klass.container_element).find('.evp-frame-top-centre')[0] || $('<div class="evp-frame-top-centre"></div>'));
			var top_right = ($(klass.container_element).find('.evp-frame-top-right')[0] || $('<div class="evp-frame-top-right"></div>'));

			var bottom = ($(klass.container_element).find('.evp-frame-bottom')[0] || $('<div class="evp-frame-bottom"></div>'));
			var bottom_left = ($(klass.container_element).find('.evp-frame-bottom-left')[0] || $('<div class="evp-frame-bottom-left"></div>'));
			var bottom_centre = ($(klass.container_element).find('.evp-frame-bottom-centre')[0] || $('<div class="evp-frame-bottom-centre"></div>'));
			var bottom_right = ($(klass.container_element).find('.evp-frame-bottom-right')[0] || $('<div class="evp-frame-bottom-right"></div>'));

			var ui_top = ($(klass.container_element).find('.evp-frame-ui-top')[0] || $('<div class="evp-frame-ui-top"></div>'));
			var ui_right = ($(klass.container_element).find('.evp-frame-ui-right')[0] || $('<div class="evp-frame-ui-right"></div>'));
			var ui_bottom = ($(klass.container_element).find('.evp-frame-ui-bottom')[0] || $('<div class="evp-frame-ui-bottom"></div>'));
			var ui_left = ($(klass.container_element).find('.evp-frame-ui-left')[0] || $('<div class="evp-frame-ui-left"></div>'));

			// Let's create the build function to apply the appropriate styling
			var klass = this;
			var style = function(element, seed) {
				var css = styling[seed];
				if(!css) return;
				var style = $.extend(true, {}, css);

				if(seed == 'top') {
					style['width'] = frame_width;
				}

				if(seed == 'bottom') {
					style['width'] = frame_width;
				}

				if(style['-evp-auto-width']) {
					style['width'] = parseInt(frame_width);
				}

				if(style['-evp-auto-height']) {
					style['height'] = parseInt(frame_height);
				}

				if(style['-evp-width-decrease']) style['width'] = parseInt(style['width']) - parseInt(style['-evp-width-decrease']);
				if(style['-evp-height-decrease']) style['height'] = parseInt(style['height']) - parseInt(style['-evp-height-decrease']);

				if(style['-evp-position'] == 'centre') {
					style['position'] = 'relative';
					style['left'] = '50%';
					style['margin-left'] = '-'+(parseInt(style['width']) / 2)+'px';
				}

				if(style['background-image']) {
					klass.preload(klass.file.frame.location+style['background-image']);
					style['background-image'] = 'url('+klass.file.frame.location+style['background-image']+')';
				}

				$(element).css(style);
			};

			// Let's run the elements through that
			style(top, 'top');
			style(top_left, 'top-left');
			style(top_centre, 'top-centre');
			style(top_right, 'top-right');

			style(bottom, 'bottom');
			style(bottom_left, 'bottom-left');
			style(bottom_centre, 'bottom-centre');
			style(bottom_right, 'bottom-right');

			style(ui_top, 'ui-top');
			style(ui_right, 'ui-right');
			style(ui_bottom, 'ui-bottom');
			style(ui_left, 'ui-left');

			if(this.file.options.use_reflection == true && this.file.widgets.length == 0 && !EVP.helpers.isAndroid() && !EVP.helpers.isBlackberry()) {
				bottom.css({
					'-webkit-box-reflect': 'below 5px -webkit-gradient(linear, left top, left bottom, from(transparent), color-stop(0.5, transparent), to(white))'
				});
			}

			// Inject them into the right structure
			$(frame).append(
				$(top).append(top_left, top_centre, top_right),
				$(bottom).append(bottom_left, bottom_centre, bottom_right),
				ui_top, ui_right, ui_bottom, ui_left
			);

			// Now we should shift over the player by the certain widths
			var frame_timer;
			var frame_timer_x = 0;
			var frame_shift = function() {
				var the_video = $('#'+klass.container_id+'-video_wrapper');
				if(EVP.helpers.isHTML5()) the_video = $('#'+klass.container_id+'-video');
				if(the_video.length >= 1) {
					if(frame_timer_x > 100) clearInterval(frame_timer); // We run 4 times because HTML5-mode is different

					the_video.css({
						'position': 'absolute',
						'top': parseInt(klass.file.frame.config.video_indent_top),
						'left': parseInt(klass.file.frame.config.video_indent_left),
						'width': parseInt(klass.file.options.width),
						'height': parseInt(klass.file.options.height)
					});

					$('#'+klass.container_id+' .evp-splash-wrap').css({
						'top': parseInt(klass.file.frame.config.video_indent_top),
						'left': parseInt(klass.file.frame.config.video_indent_left),
						'z-index': 3
						//z-index': 302
					});

					frame_timer_x++;
				}
			};
			frame_timer = setInterval(frame_shift, 10);

			// And inject them around the player
			this.container_element.prepend(frame);

			setTimeout(function() {
				klass.fireEvent('onFrameBuilt', [frame]);
			}, 100);

			klass.file.player.addEvent('ready', frame_shift);

			// Monitor for fullscreen and reposition after that
			klass.addEvent('onFullscreen', function(e, isfull) {
				if(!isfull) frame_shift();
			});
		},
		'build_expiration_bar': function() {
			var klass = this;
			if(($.browser.msie && parseInt($.browser.version) == 6) || this.file.options.use_expiration != true) return;
			var bgc = '#'+this.file.options.bar_bgc;

			this.preload(EVP3.settings.location+'/player/images/bar_overlay.png');

			var bar = $('<div class="evp-bar evp-bar-expiration-outer-wrap"></div>').css({
				'width': parseInt($('#'+this.container_id).width()),
				'padding': 0,
				'text-align': 'left',
				'direction': 'ltr',
				'position': 'relative',
				'color': '#fff'
			}).data('noResponsiveHeight', true);

			var bar_inner = $('<div class="evp-bar-inner evp-bar-expiration-inner-wrap"></div>').css({
				'padding': 5
			}).appendTo(bar);

			$('<div></div>').css({'clear': 'both'}).appendTo(bar_inner);

			var countdown = $('<div class="evp-bar-expiration"> <div class="evp-bar-expiration-wrap evp-bar-expiration-days-wrap"><div class="evp-bar-expiration-inner"> <div class="evp-bar-expiration-counter evp-bar-expiration-days-counter"> <span class="evp-bar-expiration-digit-left evp-bar-expiration-digit-days-left">0</span> <span class="evp-bar-expiration-digit-right evp-bar-expiration-digit-days-right">0</span> </div> <div class="evp-bar-expiration-label evp-bar-expiration-days-label">Days</div> </div></div> <div class="evp-bar-expiration-wrap evp-bar-expiration-hours-wrap"><div class="evp-bar-expiration-inner"> <div class="evp-bar-expiration-counter evp-bar-expiration-hours-counter"> <span class="evp-bar-expiration-digit-left evp-bar-expiration-digit-hours-left">0</span> <span class="evp-bar-expiration-digit-right evp-bar-expiration-digit-hours-right">0</span> </div> <div class="evp-bar-expiration-label evp-bar-expiration-hours-label">Hrs</div> </div></div> <div class="evp-bar-expiration-wrap evp-bar-expiration-minutes-wrap"><div class="evp-bar-expiration-inner"> <div class="evp-bar-expiration-counter evp-bar-expiration-minutes-counter"> <span class="evp-bar-expiration-digit-left evp-bar-expiration-digit-minutes-left">0</span> <span class="evp-bar-expiration-digit-right evp-bar-expiration-digit-minutes-right">0</span> </div> <div class="evp-bar-expiration-label evp-bar-expiration-minutes-label">Mins</div> </div></div> <div class="evp-bar-expiration-wrap evp-bar-expiration-seconds-wrap"><div class="evp-bar-expiration-inner"> <div class="evp-bar-expiration-counter evp-bar-expiration-seconds-counter"> <span class="evp-bar-expiration-digit-left evp-bar-expiration-digit-seconds-left">0</span> <span class="evp-bar-expiration-digit-right evp-bar-expiration-digit-seconds-right">0</span> </div> <div class="evp-bar-expiration-label evp-bar-expiration-seconds-label">Secs</div> </div></div> </div>');
			countdown.prependTo(bar_inner);

			this.file.player.expiration_bar_element = bar;

			// Now let's run the actual counter
			var expire_gmt = parseInt(this.file.options.expiration_date_gmt);
			var secondsInDay = 24 * 60 * 60,
			    secondsInHour = 60 * 60,
			    secondsInMinute = 60;

			var expire = function() {
				var parent = ('#'+klass.container_id+'-video_wrapper');
				if(EVP.helpers.isHTML5()) parent = ('#'+klass.container_id+'-video');

				var event_width = parseInt(klass.file.options.width) - 20;//($(parent).width() - 10);
				var event_height = parseInt(klass.file.options.height) - 20;//($(parent).height() - 10);

				var event = {
					'duration': 0,
					'duration-string': '00:00',
					'end': 0,
					'event_slug': 'evp-internal-expiration',
					'name': 'EVP Internal Expiration',
					'start': 0,
					'start-string': '00:00',
					'data': {
						'event-mode': 'internal',
						'event-type': 'pro',
						'overlay-background-colour': klass.file.options.expiration_background,
						'overlay-entrance': 'fade',
						'overlay-opaque': true,
						'overlay-position': 'full',
						'overlay-translucent': false,
						'overlay-trigger-pause': true,
						'overlay-show-close': false,
						'widgets': {
							'0': {
								'widget_idx': 1,
								'widget_pos_height': event_height,
								'widget_pos_width': event_width,
								'widget_pos_x': 0,
								'widget_pos_y': 0,
								'widget_ref': '',
								'widget_type': 'text',
								'body': '<div style="font-size:18px;margin-top:50px;"><center>'+klass.file.options.expiration_body+'</center></div>'
							}
						}
					}
				};

				klass.file.events['EVP Internal Expiration'] = event; // This adds to the stack so splashes can detect it
				klass.event_add('EVP Internal Expiration', event);

				setTimeout(function() {
					if(EVP.helpers.isDesktopOS()) {
						$('#'+klass.container_id+'-video').remove();
					}
				}, 500);
			};

			var update = function(type, value) {
				var block = countdown.find('.evp-bar-expiration-'+type+'-counter'),
				    left = block.find('.evp-bar-expiration-digit-left'),
				    right = block.find('.evp-bar-expiration-digit-right');

				var charLeft = Math.floor(value / 10) % 10, charRight = value % 10;
				var oldLeft = left.text(), oldRight = right.text();

				if(charLeft != oldLeft) {
					left.text(charLeft).fadeTo(250, 0.8).fadeTo(100, 1);
				}

				if(charRight != oldRight) {
					right.text(charRight).fadeTo(250, 0.8).fadeTo(100, 1);
				}
			};

			var tick = function() {
				var expire_now = Math.ceil(new Date().getTime() / 1000);

				if(expire_now >= expire_gmt) {
					update('days', '0');
					update('hours', '0');
					update('minutes', '0');
					update('seconds', '0');
					expire();
					return false;
				}

				var totalDiff = expire_gmt - expire_now, diff = totalDiff;

				var days = Math.floor(diff / secondsInDay);
				diff -= days * secondsInDay;

				var hours = Math.floor(diff / secondsInHour);
				diff -= hours * secondsInHour;

				var minutes = Math.floor(diff / secondsInMinute);
				diff -= minutes * secondsInMinute;

				var seconds = diff;

				update('days', ''+days);
				update('hours', ''+hours);
				update('minutes', ''+minutes);
				update('seconds', ''+seconds);

				setTimeout(tick, 1000);
			};

			tick();

			// If we have a frame, let's move this guy around
			if(this.file.options.related_image_mode !== 'lightbox' && typeof this.file.options.frame != 'undefined' && this.file.options.frame != '' && typeof this.file.frame != 'undefined') {
				bar.css({
					'left': parseInt(this.file.frame.config.video_indent_left),
					'top': parseInt(this.file.frame.config.gap_until_bar)
				});
			}

			// And append
			$(this.container_element).append(bar);
		},
		'build_bar': function() {
			if(($.browser.msie && parseInt($.browser.version) == 6) || this.file.widgets.length == 0) return;

			var bgc = '#'+this.file.options.bar_bgc;

			this.preload(EVP3.settings.location+'/player/images/bar_overlay.png');

			var bar = $('<div class="evp-bar"></div>').css({
				'width': parseInt($('#'+this.container_id).width()) - 2,
				'padding': 0,
				'background-color': bgc,
				'text-align': 'left',
				'direction': 'ltr',
				'clear': 'left',
				'position': 'relative'/*,
				'z-index': 300*/
			}).data('noResponsiveHeight', true);

			var bar_inner = $('<div class="evp-bar-inner"></div>').css({
				'background-image': 'url('+EVP3.settings.location+'/player/images/bar_overlay.png)',
				'background-repeat': 'repeat-x',
				'background-position': '50%',
				'padding': 5
			}).appendTo(bar);

			// Sexy gradient?
			var gradientEnd = bgc.substr(1);
			var gradientStart = EVP.helpers.generateGradient(gradientEnd, 'ffffff', 0.4);

			if(EVP.helpers.supportsCSSGradients()) {
				bar.css('background-image', '-moz-linear-gradient(top,  #'+gradientStart+' 0%, #'+gradientEnd+' 100%)');
				bar.css('background-image', '-webkit-gradient(linear, left top, left bottom, color-stop(0%,#'+gradientEnd+'), color-stop(100%,#'+gradientEnd+'))');
				bar.css('background-image', '-webkit-linear-gradient(top,  #'+gradientStart+' 0%,#'+gradientEnd+' 100%)');
				bar.css('background-image', '-o-linear-gradient(top,  #'+gradientStart+' 0%,#'+gradientEnd+' 100%)');
				bar.css('background-image', '-ms-linear-gradient(top,  #'+gradientStart+' 0%,#'+gradientEnd+' 100%)');
				bar.css('background-image', 'linear-gradient(top,  #'+gradientStart+' 0%,#'+gradientEnd+' 100%)');
			}

			// Outlines for the bar
			var border = EVP.helpers.generateGradient(gradientEnd, 'ffffff', 0.2);
			bar.css({'border': '1px solid #'+border});
			if(!(this.file.options.related_image_mode !== 'lightbox' && typeof this.file.options.frame != 'undefined' && this.file.options.frame != '' && typeof this.file.frame != 'undefined')) bar.css({'border-top': 'none'}); // Only show a top border if there is a frame

			// And the rows in the bar
			var bar_row_1 = this.file.player.bar_row_1 = $('<div class="evp-bar-row evp-bar-row-1"></div>').css({
				'min-height': '32px',
				'margin': '0 0 5px 0',
				'clear': 'both'
			}).appendTo(bar_inner);

			var bar_row_2 = this.file.player.bar_row_2 = $('<div class="evp-bar-row evp-bar-row-2"></div>').css({
				'min-height': '32px',
				'clear': 'both'
			}).appendTo(bar_inner);

			$('<div></div>').css({'clear': 'both'}).appendTo(bar_inner);

			this.file.player.bar_element = bar;

			var klass = this;

			// Let's build the widgets
			$.each(this.file.widgets, function(widget_idx, widget) {
				new EVP3.widgets[widget.slug](klass, klass.file, widget, widget.file_options, widget.row);
			});

			// Do we need to remove one of the rows?
			if(bar_row_1.children('.evp-widget').length <= 0) bar_row_1.remove();
			if(bar_row_2.children('.evp-widget').length <= 0) bar_row_2.remove();

			// Let's apply effects
			bar.find('.evp-widget').css({
				'opacity': 0.8,
				'margin': '0 5px 0 0'
			}).hover(function() {
				$(this).fadeTo(250, 1);
			}, function() {
				$(this).fadeTo(250, 0.8);
			});

			// If we have a frame, let's move this guy around
			if(this.file.options.related_image_mode !== 'lightbox' && typeof this.file.options.frame != 'undefined' && this.file.options.frame != '' && typeof this.file.frame != 'undefined') {
				bar.css({
					'left': parseInt(this.file.frame.config.video_indent_left),
						'top': parseInt(this.file.frame.config.gap_until_bar)
				//'top': parseInt(this.file.frame.config.video_indent_top) + parseInt(this.file.frame.config.gap_until_bar)
				});
			}

			// And append
			$(this.container_element).append(bar);

			this.fireEvent('onBarBuilt', [bar]);
		},
		'build_shadow': function() {
			var klass = this;
			if(($.browser.msie && parseInt($.browser.version) == 6) || this.file.options.related_image_mode == 'lightbox' || typeof this.file.options.shadow == 'undefined' || this.file.options.shadow == '' || this.file.options.shadow == 'no-shadow' || (this.file.widgets.length == 0 && !(typeof this.file.options.frame == 'undefined' || this.file.options.frame == '' || typeof this.file.frame == 'undefined'))) return;

			var shadow_height = 110;
			switch(this.file.options.shadow) {
				case 'shadow-01':
					shadow_height = 81;
					break;
				case 'shadow-02':
					shadow_height = 63;
					break;
				case 'shadow-06':
					shadow_height = 52;
					break;
				case 'shadow-07':
					shadow_height = 120;
					break;
				case 'shadow-08':
					shadow_height = 82;
					break;
				case 'shadow-09':
					shadow_height = 94;
					break;
				case 'shadow-10':
					shadow_height = 82;
					break;
			}

			var total_width = parseInt($('#'+this.container_id).width()) + (92 * 2); // Shadows are 92px wider than the main video
			var shadow = $('<div class="evp-shadow"><div class="evp-shadow-bottom-left"></div><div class="evp-shadow-bottom-middle"></div><div class="evp-shadow-bottom-right"></div>').css({
				'overflow': 'auto',
				'margin-left': '-92px',
				'top': '-29px',
				'width': total_width,
				'z-index': -1,
				'position': 'relative'
			}).data('noResponsiveHeight', true).data('noResponsiveBottom', true);

			shadow.find('div[class^="evp-shadow-"]').css({ // Style all of them
				'float': 'left',
				'background-repeat': 'none',
				'background-position': 'top left',
				'height': shadow_height
			}).data('noResponsiveHeight', true).data('noResponsiveBottom', true);

			// Work out the dimensions
			var shadow_left_width = 500;
			var shadow_right_width = 500;
			var shadow_middle_width = 0;
			var available_width = (total_width - shadow_left_width - shadow_right_width);
			if(available_width >= 0) {
				shadow_middle_width = available_width;
			} else { // It's a negative number
				shadow_left_width = shadow_left_width + (available_width / 2);
				shadow_right_width = shadow_right_width + (available_width / 2);
				shadow_middle_width = 0;
			}

			// Override individually
			var shadow_bottom_left = shadow.find('.evp-shadow-bottom-left').css({
				'width': shadow_left_width,
				'background-image': 'url('+EVP3.settings.location+'/player/shadows/'+this.file.options.shadow+'/bottom-left.png)'
			});
			var shadow_bottom_middle = shadow.find('.evp-shadow-bottom-middle').css({
				'width': shadow_middle_width,
				'background-repeat': 'repeat-x',
				'background-image': 'url('+EVP3.settings.location+'/player/shadows/'+this.file.options.shadow+'/bottom-middle.png)'
			});
			var shadow_bottom_right = shadow.find('.evp-shadow-bottom-right').css({
				'width': shadow_right_width,
				'background-image': 'url('+EVP3.settings.location+'/player/shadows/'+this.file.options.shadow+'/bottom-right.png)',
				'background-position': 'top right'
			});

			this.preload(EVP3.settings.location+'/player/shadows/'+this.file.options.shadow+'/bottom-left.png', EVP3.settings.location+'/player/shadows/'+this.file.options.shadow+'/bottom-middle.png', EVP3.settings.location+'/player/shadows/'+this.file.options.shadow+'/bottom-right.png');

			// If we have a frame, let's move this guy around too!
			if(typeof this.file.options.frame != 'undefined' && this.file.options.frame != '' && typeof this.file.frame != 'undefined') {
				shadow.css({
					'margin-left': -92 + parseInt(this.file.frame.config.video_indent_left),
					'top': 0
//			'bottom': parseInt(this.file.frame.config.gap_until_bar) + 42
				});
			}

			// And append
			$(this.container_element).append(shadow);

			$(this.container_element).css({
				'margin-bottom': '-29px'
			});

			this.fireEvent('onShadowBuilt', [shadow]);
		},
		'build_splash': function() {
			if(this.file.config.type == 'audio' && this.file.options.related_image_mode == 'splash' && typeof this.file.options.splash_width != 'undefined' && typeof this.file.options.splash_height != 'undefined') return;
			if(this.file.options.related_image_mode !== 'splash') return;
			if(this.file.options.related_image.indexOf(EVP3.settings.location+'/player/images/no-image.png') !== -1) return false; // Don't show the placeholder

			var splash_wrap = $('<div class="evp-splash-wrap"></div>').css({
				'cursor': 'pointer',
				'position': 'absolute',
				'top': 0,
				'left': 0,
				'width': this.file.options.width,
				'height': this.file.options.height,
				'max-width': 'none',
			//'z-index': 302,
				'text-align': 'center'
			});

			this.preload(this.file.options.related_image);

			var splash = $('<img src="'+this.file.options.related_image+'" class="evp-splash" />').css({
				'width': this.file.options.width,
				'height': this.file.options.height,
				'border': 'none',
				'margin': 0,
				'padding': 0,
				'border-radius': 0
			});

			splash.appendTo(splash_wrap);

			if(this.file.options.related_image_play == true) {
			//this.preload(EVP3.settings.location+'/player/assets/jwplayer-5.10/skins/'+this.file.options.skin+'/display/background.png', EVP3.settings.location+'/player/assets/jwplayer-5.10/skins/'+this.file.options.skin+'/display/playIcon.png');

				var play_wrap = $('<div class="evp-splash-play-wrap"></div>').css({
					'text-align': 'center',
					'position': 'absolute',
					'top': 0,
					'left': 0,
					'width': this.file.options.width,
					'height': this.file.options.height,
					'background-image': 'url('+EVP3.settings.location+'/player/assets/jwplayer-5.10/skins/'+this.file.options.skin+'/display/playIcon.png)',
					'background-position': 'center',
					'background-repeat': 'no-repeat'
				});

				if(!($.browser.msie && parseInt($.browser.version) <= 7)) {
					play_wrap.css({
						'background-image': 'url('+EVP3.settings.location+'/player/assets/jwplayer-5.10/skins/'+this.file.options.skin+'/display/playIcon.png), url('+EVP3.settings.location+'/player/assets/jwplayer-5.10/skins/'+this.file.options.skin+'/display/background.png)',
						'background-position': 'center, center'
					});
				}

				/*
				this.preload_event(function() {
					var play = play_wrap.find('.evp-splash-play');
					play.css({
						'position': 'absolute',
						'top': '50%',
						'margin-top': '-'+($(play).height() / 2)+'px',
						'left': '50%',
						'margin-left': '-'+($(play).width() / 2)+'px'
					});

					var play_bg = play_wrap.find('.evp-splash-play-background');

					play_wrap.css({
						'width': $(play_wrap).width(),
						'height': $(play_wrap).height(),
						'left': '50%',
						'margin-left': '-'+($(play_wrap).width() / 2)+'px',
						'top': '50%',
						'margin-top': '-'+($(play_wrap).height() / 2)+'px'
					});
				});
				*/

				play_wrap.appendTo(splash_wrap);
			}

			if(this.file.options.related_image_label) {
				var label_bg = $('<div class="evp-splash-label-bg"></div>').css({
					'color': '#fff',
					'font-size': 13,
					'padding': 5,
					'background': '#000',
					'position': 'absolute',
					'bottom': 10,
					'left': 0,
					'width': parseInt(this.file.options.width) - 48,
					'height': 27,
					'z-index': 3,
					'margin': '0 20px',
					'opacity': 0.4,
					'border-radius': 4,
					'box-shadow': '0 2px 2px #000'
				}).data('noResponsiveHeight', true);

				var label = $('<div class="evp-splash-label">'+this.file.options.related_image_label+'</div>').css({
					'color': '#fff',
					'font-size': 13,
					'padding': 5,
					'position': 'absolute',
					'bottom': 10,
					'left': 0,
					'width': parseInt(this.file.options.width) - 50,
					'height': 25,
					'line-height': '25px',
					'font-weight': 'bold',
					'text-shadow': '1px 1px 0 #2a2a2a',
					'z-index': 4,
					'margin': '0 20px',
					'border-radius': 4,
					'border': '1px solid #000',
					'cursor': 'pointer',
					'text-align': 'left',
					'overflow': 'hidden'
				}).data('noResponsiveHeight', true);

				$(splash_wrap).append(label_bg, label);

			}

			$(this.container_element).append(splash_wrap);

			this.fireEvent('onSplashBuilt', [splash, splash_wrap, this.file.options.related_image]);
		},
		'build_file': function() {
			var player_name = this.player_name.split('-')[0]; // Normalise it into jwplayer instead of jwplayer-xxx
			var ext;
			if(typeof this.file.config.location == 'string') ext = this.file.config.location.slice(-3);
			if(typeof this.file.config.encoded_location == 'string') ext = base64_decode(this.file.config.encoded_location).slice(-3);
			if(!ext) {
				EVP.log('The extension of the requested video could not be found. Is the file deleted?', this.file, 'error');
				return false;
			}

			if($.inArray(ext, ['avi', 'mov', 'wmv', 'wma']) !== -1) { // Switch everything unsupported by Flash to a hashed embed method
				player_name = 'legacy';
			}

			if(player_name == 'youtube' && ($.browser.msie && parseInt($.browser.version) <= 7)) player_name = 'jwplayer'; // Stop IE6 and 7 getting the custom YT player

			var player = this.file.player = new EVP3.players[player_name](this.container_element, this.video_element, this.file, this);
		//$('#'+this.container_id+'-video_wrapper').css('background', '#000');
			return this;
		}
	});

	$.Class.extend('EVP3.players', {}, {
		'init': function(container_element, video_element, file, evp) {
			this.container_element = $(container_element);
			this.container_id = this.container_element.attr('id');
			this.video_element = $(video_element);
			this.evp = evp;

			this.file = file;

			this.player_location = EVP3.settings.location+'/player/assets/jwplayer-5.10';

			this.embed();
		},
		'embed': function(){}, // This needs to physically insert the player, by preparing and calling flowplayer(), jwplayer() etc
		'getAPI': function() { // This returns the player API, so the function jwplayer/flowplayer/whatever
			return EVP3.playerAPIs[this.Class.shortName];
		},
		'getConfig': function() { // This returns basic stuff like the file location
			var config = {
				'http_location': (this.file.config.encoded_location ? base64_decode(this.file.config.encoded_location) : this.file.config.location),
				'rtmp_location': this.file.config.rtmp_location,
				'rtmp_domain': this.file.config.rtmp_domain,
				'player_width': this.file.options.width || 500,
				'player_height': this.file.options.height || 240,
				'player_skin': this.file.options.skin || 'minima',
				'related_image': this.file.options.related_image,
				'related_image_mode': this.file.options.related_image_mode || false,
				'volume': this.file.options.volume,
				'source': this.file.config.source,
				'prettySource': this.file.config.prettySource,
				'type': this.file.config.type
			};

			// Is the height automatic, or this is an audio file? If so we have to replace it
			if(config.player_height == 'auto' || this.file.config.type == 'audio') {
				config.player_height = this.file.options.skin_height || 32;
				if(this.file.options.related_image_mode == 'splash' && typeof this.file.options.splash_width != 'undefined' && typeof this.file.options.splash_height != 'undefined') {
					config.player_height = parseInt(this.file.options.splash_height);// + parseInt(this.file.options.skin_height); // Prevents the image being truncated by the height of the skin
					config.player_image = this.file.options.related_image;
				}
			}

			if(typeof config.volume == 'undefined') config.volume = 100;

			// Delayed start?
			if((config.rtmp_location && !EVP.helpers.isHTML5()) || config.prettySource == 'youtube') {
				var delay = parseInt(this.file.options.delayedstart_minutes || 0) * 60 + (parseInt(this.file.options.delayedstart_seconds || 0));
				config.delayed_start = delay;
			}

			// Autoplay and autobuffering
			config.auto_play = this.file.options.auto_play || false;
			config.auto_buffer = this.file.options.auto_buffer || false;

			// Only fix playback with splashes when it's not audio; audio uses as artwork
			if(config.related_image_mode == 'splash' && this.file.config.type == 'video') {
				config.auto_play = false;
				config.auto_buffer = false;
			}

			// If it's iOS, auto-play
			if(EVP.helpers.isMobileOS()) {
				config.auto_play = false;
			}

			// Cookied autoplay
			if(config.auto_play && this.file.options.cookied_auto_play == true) {
				if($.cookie('evp_cap_'+this.file.file_ref) == 'true') {
					config.auto_play = false;
				}

				// Now set the cookie so that next time it doesn't auto play
				var exp = new Date();
				exp.setHours(exp.getHours() + 4500);
				$.cookie('evp_cap_'+this.file.file_ref, 'true', {'expires': exp});
			}

			// And return
			return config;
		}
	});

	$.Class.extend('EVP3.widgets', {}, {
		'getConfig': function() {
			return {};
		}
	});

	$.Class.extend('EVP3.plugins', {}, {
		'getConfig': function() {
			return {};
		}
	});

	// Legacy embed method
	EVP3.players.extend('EVP3.players.legacy', {
		'embed': function() {
			var config = this.getConfig();

			var html = '<object id="'+this.container_id+'-mediaPlayer" width="'+config.player_width+'" height="'+config.player_height+'" classid="CLSID:22d6f312-b0f6-11d0-94ab-0080c74c7e95" codebase="http://activex.microsoft.com/activex/controls/mplayer/en/nsmp2inf.cab#Version=5,1,52,701" standby="Loading Microsoft Windows Media Player components..." type="application/x-oleobject">';
			html+= '<param name="fileName" value="'+config.http_location+'" />';
			html+= '<param name="animationatStart" value="true" />';
			html+= '<param name="transparentatStart" value="true" />';
			html+= '<param name="autoStart" value="false" />';
			html+= '<param name="showControls" value="true" />';
			html+= '<param name="loop" value="false" />';
			html+= '<embed type="application/x-mplayer2" pluginspage="http://microsoft.com/windows/mediaplayer/en/download/" id="'+this.container_id+'-mediaPlayer" name="'+this.container_id+'-mediaPlayer" displaysize="4" autosize="-1" bgcolor="darkblue" showcontrols="true" showtracker="-1" showdisplay="0" showstatusbar="-1" videoborder3d="-1" width="'+config.player_width+'" height="'+config.player_height+'" src="'+config.http_location+'" autostart="false" designtimesp="5311" loop="false"></embed>';
			html+= '</object>';

			var klass = this;

			setTimeout(function() {
				$('#'+klass.container_id+'-video').html(html);
			}, 1000);
		}
	});
}

EVP3.query = $;
