<?php
if(!ob_start('ob_gzhandler')) ob_start();

header("Content-Type: application/x-javascript; charset=utf-8");
header("Expires: Mon, 26 Jul 1997 05:00:00 GMT");
header("Last-Modified: " . gmdate("D, d M Y H:i:s") . " GMT");
header("Cache-Control: no-store, no-cache, must-revalidate");
header("Cache-Control: post-check=0, pre-check=0", false);
header("Pragma: no-cache");

$disable_asset_caching = false;
$cache_enabled = false;

$synchronous = true;
$noInit = false;
$jsGlobal = 'EVP3'; // This references the global object we'll attach settings etc to
$jsAssetId = 'evp3-assets'; // What is the HTML ID tag of the asset file?

$lightning = false;
$lightning = (isset($_GET['lightning']) && $_GET['lightning'] == true);
if($lightning && !empty($_GET['responsive'])) $_GET['autoResponsive'] = true;

$trueLightning = false;

if($trueLightning) {
	$jsGlobal = 'EVS';
	$jsAssetId = 'evs-lightning-assets';
}

if(isset($_GET['noInit']) && ($_GET['noInit'] === 'true' || $_GET['noInit'] == '1')) $noInit = true;

if(isset($_GET['synchronous']) && ($_GET['synchronous'] === 'false' || $_GET['synchronous'] == '0')) $synchronous = false;

// Let's load up EVP
require('application.php');
require('application.bootstrap.php');

$uuid = session_id();

if($evp->options->debug == true) $disable_asset_caching = true;

function correctFileLocation(&$file, &$conf) {
	$evp = Registry::get('EVP');
	$config = Registry::retrieve('config');

	// Are we using CloudFront RTMP and the file is from s3?
	if($evp->settings->use_cloudfront && $evp->settings->use_cloudfront_std != 1 && $file->source == 2) {
		$conf['rtmp_location'] = $file->file_name;
		$conf['rtmp_domain'] = $evp->settings->cloudfront_domain;
	}

	// Are we using CloudFront STD, and the file is from S3?
	if($evp->settings->use_cloudfront && $evp->settings->use_cloudfront_std == 1 && $file->source == 2) {
		$conf['location'] = $config['locations']['protocol'].'://'.$evp->settings->cloudfront_domain.'/'.$file->file_name;
	}

	if($config['locations']['protocol'] == 'https') $conf['location'] = str_replace('http://', 'https://', $conf['location']); // SSL support

	$conf['encoded_location'] = base64_encode($conf['location']);
	unset($conf['location']);
}

function buildChildEntries($get_file_id) {
	$evp = Registry::get('EVP');
	$config = Registry::retrieve('config');
	// Do we have any child files?
	$children = array();
	$children_raw = getArray("SELECT `id`, `child_type` FROM {$evp->options->prefix}files WHERE `parent_id` = '{$get_file_id}'");
	if(!empty($children_raw)) {
		foreach($children_raw as $child) {
			$type = $child->child_type;
			$child = $evp->getFile($child->id, false);
			if($child) {
				if($config['locations']['protocol'] == 'https') $child->location = str_replace('http://', 'https://', $child->location); // SSL support
				$child->encoded_location = base64_encode($child->location);
				unset($child->location, $child->id, $child->parent_id, $child->name, $child->size, $child->time, $child->type, $child->source, $child->prettyTime, $child->prettyType, $child->prettySize, $child->prettySource, $child->page_url, $child->profile, $child->hd, $child->file_name, $child->raw_location);
				$children[$type] = $child;
			}
		}
	}
	return $children;
}

$dynamic_asset_location = trim(url(), '/');
$asset_location = ($evp->options->hosted == true && $evp->settings->use_s3 && !empty($evp->settings->s3_bucket) ? $config['locations']['protocol'].'://'.$evp->settings->s3_bucket.'.s3.amazonaws.com' : trim(url(), '/'));

$standalone = false;
$split_test = false;
$playlist = false;
$get_file_id = $_GET['id'];
$get_file_profile = $_GET['profile'];

$get_file_id = escape($get_file_id, true);
$get_file_profile = escape($get_file_profile, true);

if(!empty($_GET['id']) && !is_numeric($_GET['id']) && substr($_GET['id'], 0, 9) === 'playlist-') { // Is it a playlist?!
	$playlist_id = escape(str_replace('playlist-', '', makeSeed($_GET['id'])), true);
	if(is_numeric($playlist_id)) {
		$playlist = $evp->getPlaylist($playlist_id);
		if($playlist) {
			$get_file_id = $playlist->files[0];
		}
	}
} elseif(!empty($_GET['id']) && is_numeric($_GET['id'])) { // Is this a split test? (If the id is set but is entirely numeric)
	$split_test = true;
	$cache_enabled = false; // Disable caching for split tests
	$split = $evp->getSplitTest($_GET['id']);
	$get_file_id = false;

	// Do we already have the specific file to save?
	if(!empty($split->best_file) && $split->best_file !== 'NULL') {
		$get_file_id = $split->best_file;
	}

	// No? Then has it reached the end date?
	if(!$get_file_id && !empty($split->date_ending) && !empty($split->metric)) {
		$now = gmstrtotime('00:00');
		$end = gmdate('U', $split->date_ending);

		if($now >= $end) { // We need to pick and then save the appropriate file
			$tmp_top = false;
			$tmp_top_ref = false;
			$metric_label = ($split->metric == 'views' ? 'starts' : 'completes');
			foreach($split->files as $f) {
				$tmp_file = $evp->getFile($f);
				if($tmp_file) {
					// So what metrics do we need for $f?
					if(in_array($split->metric, array('views', 'completions'))) { // Get primary stats
						$tmp_stats = $evp->statistics->getStats($f);
						if(!empty($tmp_stats->static->{$metric_label}) && $tmp_stats->static->{$metric_label} > $tmp_top) {
							$tmp_top = $tmp_stats->static->{$metric_label};
							$tmp_top_ref = $f;
						}
					} else if($split->metric == 'sales') {
						$tmp_sales = getRow("SELECT COUNT(`id`) AS sales FROM {$evp->options->prefix}conversions WHERE `file_id` = '{$f}' && `converted` = '1' GROUP BY `file_id` ORDER BY sales DESC");
						if(!empty($tmp_sales) && !empty($tmp_sales->sales) && $tmp_sales->sales > $tmp_top) {
							$tmp_top = $tmp_sales->sales;
							$tmp_top_ref = $f;
						}
					} else if($split->metric == 'income') {
						$tmp_income = getRow("SELECT SUM(price) AS income FROM {$evp->options->prefix}conversions WHERE `file_id` = '{$f}' && `converted` = '1' GROUP BY `file_id` ORDER BY income DESC");
						if(!empty($tmp_income) && !empty($tmp_income->income) && $tmp_income->income > $tmp_top) {
							$tmp_top = $tmp_income->income;
							$tmp_top_ref = $f;
						}
					} else { // Get social stats
						$tmp_social_stats = $evp->getDataKey('stats', $f, 'files');
						if(!empty($tmp_social_stats)) $tmp_social_stats = @json_decode($tmp_social_stats);
						if(!empty($tmp_social_stats->{$split->metric}) && $tmp_social_stats->{$split->metric} > $tmp_top) {
							$tmp_top = $tmp_social_stats->{$split->metric};
							$tmp_top_ref = $f;
						}
					}
				}
			}

			if($tmp_top) { // We have one, so let's save
				query("UPDATE {$evp->options->prefix}split_tests SET `best_file` = '{$tmp_top_ref}' WHERE `id` = '{$split->id}' LIMIT 1");
				$get_file_id = $tmp_top_ref;
				if(strpos($get_file_id, '::')) {
					$get_file_profile = grab(explode('::', $get_file_id, 2), 1);
					$get_file_id = str_replace('::'.$get_file_profile, '', $get_file_id);
				} else {
					$get_file_profile = '';
				}
			}
		}
	}

	/*
	// No? Then let's select a random file
	if(!$get_file_id) {
		shuffle($split->files);
		$get_file_id = $split->files[0];
		if(strpos($get_file_id, '::')) {
			$get_file_profile = grab(explode('::', $get_file_id, 2), 1);
			$get_file_id = str_replace('::'.$get_file_profile, '', $get_file_id);
		} else {
			$get_file_profile = '';
		}
	}
	*/

	// Not reached the end date, so let's pick the file with the least views
	// this will average them out over time
	if(!$get_file_id) {
		$split_views = array();
		foreach($split->files as $f) {
			$tmp_file = $evp->getFile($f);
			if(!$tmp_file) continue;

			$tmp_file_stats = $evp->statistics->getStaticStats($f);
			$split_views[$f] = intval($tmp_file_stats->starts);
		}

		asort($split_views);

		list($get_file_id) = array_keys($split_views);

		if(strpos($get_file_id, '::')) {
			$get_file_profile = grab(explode('::', $get_file_id, 2), 1);
			$get_file_id = str_replace('::'.$get_file_profile, '', $get_file_id);
		} else {
			$get_file_profile = '';
		}
	}

	// No? Then let's select a random file
	// Just a fallback in case the above one fails (i.e. they all have 0 views)
	if(!$get_file_id) {
		shuffle($split->files);
		$get_file_id = $split->files[0];
		if(strpos($get_file_id, '::')) {
			$get_file_profile = grab(explode('::', $get_file_id, 2), 1);
			$get_file_id = str_replace('::'.$get_file_profile, '', $get_file_id);
		} else {
			$get_file_profile = '';
		}
	}

}

$get_file_ref = $get_file_id.(empty($get_file_profile) ? '' : '::'.$get_file_profile);

// Let's set up the caching stuff
$cache_file = 'cache.'.(empty($get_file_ref) ? 'evp-'.$evp->options->project_version : str_replace('::', '_', $get_file_ref)).'.js';
$cache_path = $config['paths']['cacheDir'].'/'.$cache_file;

// Does a cached file exist?
if($cache_enabled && file_exists($cache_path)) {
	$onAssetsLoaded = file_get_contents($cache_path);

	// Get environment settings
	$container_id = trim($_GET['container']);
	$file_id = $get_file_id;
	$profile = trim($get_file_profile);
	$file_ref = $file_id.(empty($profile) ? '' : '::'.$profile);

	if(empty($file_id)) $standalone = true;

} else {
	// So, is this a standalone player or a proper file
	if(empty($_GET['id'])) {
		$standalone = true;
		$file = new Object();
		$file_settings = new Object();
		$container_id = '';
		$profile = '';
		$file_ref = '';
	} else {
		$file = $evp->getFile($get_file_id);

		// Get environment settings
		$container_id = trim($_GET['container']);
		$file_id = $file->id;
		$profile = trim($get_file_profile);
		$file_ref = $file_id.(empty($profile) ? '' : '::'.$profile);

		// Collate the file settings
		$file_settings = $evp->collateFileSettings($file, $profile);

		// Let's include the embed code, just in case (Embed widget?)
		if($split_test) {
			$embed_code = $evp->splitEmbedCode($split, $_GET['container']);
		} elseif($playlist) {
			$embed_code = $evp->playlistEmbedCode($playlist, $_GET['container']);
		} else {
			$embed_code = $evp->videoEmbedCode($file, 'sd', $profile, $_GET['container']);
		}
		$file_settings->embed_code = $embed_code;

		// Get the download link, just in case (Download button?)
		$file_settings->encoded_download_url = base64_encode($evp->getFileDownloadURL($file));

		// Let's modify some stuff if this is a playlist
		if($playlist) {
			$file_settings->options['related_image_mode'] = ($file_settings->options['related_image_mode'] == 'lightbox' ? '' : $file_settings->options['related_image_mode']);
			$file_settings->options['frame'] = 'no-frame';
			unset($file_settings->options['delayedstart_minutes'], $file_settings->options['delayedstart_seconds']);
			unset($file_settings->options['intro_video'], $file_settings->options['intro_video_location']);

			// Attach the main label
			$file->label = (empty($playlist->labels[0]) ? $file->name : $playlist->labels[0]);

			// Now let's get all the other files in this playlist
			if(!empty($playlist->files)) {
				foreach($playlist->files as $fidx => $fid) {
					$f = $evp->getFile($fid);
					$settings = $evp->collateFileSettings($f);

					$obj = new stdClass;
					$obj->id = $fid;
					$obj->raw_location = $f->raw_location;
					$obj->location = $f->location;
					$obj->source = $f->source;
					$obj->related_image = ($settings->options['related_image_mode'] == 'splash' ? $settings->options['related_image'] : '');
					$obj->duration = (empty($f->metadata['duration']) ? '' : secondsToHMS($f->metadata['duration']));
					$obj->raw_duration = (empty($f->metadata['duration']) ? 0 : $f->metadata['duration']);

					// Child videos?
					$obj->children = buildChildEntries($obj->id);

					// SSL support for playlist related images & raw locations
					if($config['locations']['protocol'] == 'https') {
						$obj->raw_location = str_replace('http://', 'https://', $obj->raw_location);
						$obj->related_image = str_replace('http://', 'https://', $obj->related_image);
					}

					$c = array();
					correctFileLocation($obj, $c);
					if(!empty($c['rtmp_location'])) $obj->rtmp_location = $c['rtmp_location'];
					if(!empty($c['rtmp_domain'])) $obj->rtmp_domain = $c['rtmp_domain'];

					$obj->label = (empty($playlist->labels[$fidx]) ? $f->name : $playlist->labels[$fidx]);
					$obj->description = ((empty($playlist->descriptions[$fidx]) || $playlist->descriptions[$fidx] == 'Enter a description') ? '' : $playlist->descriptions[$fidx]);

					$pl[] = $obj;
				}
			}

			// Attach the files in the playlist to the object
			$file_settings->playlist = $pl;

			// And attach the positioning
			$file_settings->playlist_position = $playlist->list_position;
		}

		// Do we need to make this a lightbox?
		if($file_settings->options['related_image_mode'] == 'lightbox') {
			$lightbox = true;
			$lightbox_style = $file_settings->options['lightbox_style'];
			if(empty($lightbox_style)) $lightbox_style = 'style-1';
		}

		correctFileLocation($file, $file_settings->config);

		// Serve the skin height
		$file_settings->options['skin_height'] = $evp->options->skins[$file_settings->options['skin']]['skin_height'];

		// And expose the player type
		$file_settings->config['type'] = $file->type;

		$trackProgression = false;
		/*
		if(false) { // @todo REINSTATE THIS, but work out how to do it without this poxy query running every time
			$trackProgression = true;
			if(getRow("SELECT `uuid` FROM {$evp->options->prefix}track_progression WHERE `uuid` = '{$uuid}' && `file_ref` = '{$get_file_ref}'")) {
				$trackProgression = false;
			}
		}
		*/
		$file_settings->config['trackProgression'] = $trackProgression;

		// Let's expose any responsive video parameters
		$file_settings->config['responsive'] = $_GET['responsive'];
		$file_settings->config['autoResponsive'] = $_GET['autoResponsive'];
		$file_settings->config['responsiveOnlyMobile'] = $_GET['responsiveOnlyMobile'];

		// Expose the child videos
		$file_settings->children = buildChildEntries($get_file_id);

		// Are there thumbnails we could expose?
		$file_settings->thumbnails = array();
		if(!empty($file->thumbnail_count)) {
			for($thumbnail_i = 0; $thumbnail_i <= ($file->thumbnail_count - 1); $thumbnail_i++) {
				$thumb = str_replace('.'.$file->extension, '', $file->raw_location).'-thumbnail-'.$thumbnail_i.'.jpg';
				if($config['locations']['protocol'] == 'https') $thumb = str_replace('http://', 'https://', $thumb); // SSL support
				$file_settings->thumbnails[] = $thumb;
			}
		}

		// Is there a cover photo we can expose?
		$file_settings->coverphoto = false;
		if(!empty($file->coverphoto) && $file->coverphoto != false) $file_settings->coverphoto = str_replace('.'.$file->extension, '', $file->raw_location).'-coverphoto.jpg';
	}

ob_start();

// Identify the intro video, if we need to, and set it's location
if(!empty($file_settings->options['intro_video'])) {
	$intro = $evp->getFile($file_settings->options['intro_video']);
	if(!$intro) {
		$file_settings->options['intro_video'] = false;
	} else {
		$intro_config = array('location' => $intro->location);
		correctFileLocation($intro, $intro_config);
		$file_settings->options['intro_video_config'] = $intro_config;

		// BEGIN LEGACY

		$file_settings->options['intro_video_location'] = $intro->location;
		if($config['locations']['protocol'] == 'https') $file_settings->options['intro_video_location'] = str_replace('http://', 'https://', $file_settings->options['intro_video_location']); // SSL support
		$file_settings->options['intro_video_encoded_location'] = base64_encode($file_settings->options['intro_video_location']);
		unset($file_settings->options['intro_video_location']);

		// END LEGACY

		$file_settings->options['intro_video_children'] = buildChildEntries($intro->id);
	}
}

// Identify the outro video, if we need to, and set it's location
if(!empty($file_settings->options['outro_video'])) {
	$outro = $evp->getFile($file_settings->options['outro_video']);
	if(!$outro) {
		$file_settings->options['outro_video'] = false;
	} else {
		$outro_config = array('location' => $outro->location);
		correctFileLocation($outro, $outro_config);
		$file_settings->options['outro_video_config'] = $outro_config;

		// BEGIN LEGACY
		$file_settings->options['outro_video_location'] = $outro->location;
		if($config['locations']['protocol'] == 'https') $file_settings->options['outro_video_location'] = str_replace('http://', 'https://', $file_settings->options['outro_video_location']); // SSL support
		$file_settings->options['outro_video_encoded_location'] = base64_encode($file_settings->options['outro_video_location']);
		unset($file_settings->options['outro_video_location']);

		// END LEGACY

		$file_settings->options['outro_video_children'] = buildChildEntries($outro->id);
	}
}

// Are we using player expiration?
if(!empty($file_settings->options['use_expiration'])) {
	$expire_gmt = trim($file_settings->options['expiration_date_gmt']);
	$expire_now = gmtime();
	if($expire_now >= $expire_gmt) {
		$file_settings->options['expiration_expired'] = true;
		$file_settings->options['auto_play'] = false;
	}
	/*
	if(!is_array($file_settings->widgets)) $file_settings->widgets = array();
	if(!is_array($file_settings->options['widgets_order'])) $file_settings->options['widgets_order'] = array();
	if(empty($file_settings->options['bar_style']) || $file_settings->options['bar_style'] == 'none') $file_settings->options['bar_style'] = 'dark';
	$exp_idx = rand(10, 999);
	$file_settings->widgets[$exp_idx] = array(
		'idx' => $exp_idx,
		'name' => 'Expiration',
		'slug' => 'expiration'
	);
	array_unshift($file_settings->options['widgets_order'], $exp_idx);
	*/
}

$player = 'jwplayer-5.10';
if($file->source == 3 && !($outro || $intro) && !$playlist) $player = 'youtube';
?>
(function($) {
<?php
	// Widgets
	$widgets = array();
	$widgets_on_row_2 = (array)$file_settings->options['widgets_row_2'];
	if($file_settings->options['bar_style'] !== 'none' && !empty($file_settings->options['widgets_order']) && !empty($file_settings->widgets)) {
		foreach($file_settings->options['widgets_order'] as $order => $oidx) {
			$widget = $evp->getWidget($file_settings->widgets[$oidx]['slug'], $file, $oidx);
			if($widget) {
				$widget_idx = $order;

				if(!empty($widget->config->configPrepare)) {
					include_once($widget->path.'/'.$widget->config->configPrepare);
				}

				$widget->row = 1;
				if(in_array($oidx, $widgets_on_row_2)) $widget->row = 2;

				$widgets[$widget_idx] = $widget;
			}
		}
	}
	$file_settings->widgets = $widgets;

	// Plugins
	$plugins = array();
	$file_settings->plugins = array('effectiveness'); // Default plugins
	if(!empty($file_settings->chapters)) $file_settings->plugins[] = 'chapters';
	if($file_settings->options['mouseover-facebook'] == true) $file_settings->plugins[] = 'mouseover-facebook';
	if($file_settings->options['mouseover-twitter'] == true) $file_settings->plugins[] = 'mouseover-twitter';
	if($file_settings->options['mouseover-googleplus'] == true) $file_settings->plugins[] = 'mouseover-googleplus';
	if($file_settings->options['use_passwordprotect'] == true) $file_settings->plugins[] = 'password-protect';
	if($file_settings->options['play_viewport'] == true) $file_settings->plugins[] = 'viewport';
	if($file_settings->options['expiration_expired'] == true) $file_settings->plugins[] = 'expiration';

	if(!empty($file_settings->plugins)) {
		foreach($file_settings->plugins as $pidx => $plugin_slug) {
			$plugin = $evp->getPlugin($plugin_slug, $file);
			if($plugin) {

				if(!empty($plugin->config->configPrepare)) {
					include_once($plugin->path.'/'.$plugin->config->configPrepare);
				}

				$plugins[] = $plugin;
			}
		}
	}
	$file_settings->plugins = $plugins;

	// Frame
	if(!empty($file_settings->options['frame'])) {
		$frame = $evp->getFrame($file_settings->options['frame']);
		if($frame) {
			$frame->location = $asset_location.'/player/frames/'.$frame->slug.'/';
			$file_settings->frame = $frame;
		}
	}
	echo "\n";
?>
})(EVP3.query);

<?php
// Let's wrap all of that into a load event of the assets file
$onAssetsLoaded = ob_get_clean();

$jsFileInfo = '';
if(!$standalone) $jsFileInfo = $jsGlobal.'.files[\''.$file_ref.'\'] = '.json_encode($file_settings).';';

} // That's the end of the if bracket which sets $onAssetsLoaded

// Let's begin the init wrapper now
ob_start();
?>

<?php
// Now initialise the player if it's not standalone, not a lightbox, and we're not in 2.x compatibility mode
if(!$standalone && !$lightbox) { ?>
	<?php echo ($synchronous ? '' : 'EVP3.query(document).ready(function() {'); ?>
		<?php if(!$noInit) : ?>new EVP('<?php echo $container_id; ?>', '<?php echo $file_ref; ?>', '<?php echo $player; ?>');<?php endif; ?>
	<?php echo ($synchronous ? '' : '});'); ?>
<?php
} else if($lightbox) { ?>
	<?php echo 'EVP3.query(document).ready(function($) {'; ?>
		jQuery = EVP3.query; // For the ColorBox plugin
		if(EVP3.settings.lightbox_stylesheet !== true) { // Prevents duplicate loading of styles
			$('<link rel="stylesheet" href="<?php echo url('player/assets/colorbox-1.3.18/'.$lightbox_style.'/colorbox.css?v=8-7'); ?>" />').appendTo(document.body);
			EVP3.settings.lightbox_stylesheet = true;
		}
		new EVP('<?php echo $container_id; ?>', '<?php echo $file_ref; ?>', '<?php echo $player; ?>');
	<?php echo '});'; ?>
<?php } else { ?>
<?php echo ($synchronous ? '' : 'EVP3.query(document).ready(function() {'); ?>
	EVP3.attach();
<?php echo ($synchronous ? '' : '});'); ?>
<?php } ?>

<?php
// And put THAT in the init variable!
$init = ob_get_clean();

if($cache_enabled) {
	file_put_contents($cache_path, $onAssetsLoaded);
}

// Now let's locate our assets file
$assets_url = url('player/assets.php', array('v' => $evp->options->project_version));
if(!$disable_asset_caching && $evp->options->hosted === true && $evp->s3 && !empty($evp->settings->s3_bucket)) {
	$assets_url = "{$config['locations']['protocol']}://{$evp->settings->s3_bucket}.s3.amazonaws.com/player/assets.js?v={$evp->options->project_version}";
}

// Are we using the Lightning Mode? If so, change the assets file
if($trueLightning) {
	$assets_url = url('player/assets.lightning.php', array('v' => $evp->options->project_version));
	// Disabled until we actually deploy the Lightning player
	/*
	if(!$disable_asset_caching && $evp->options->hosted === true && $evp->s3 && !empty($evp->settings->s3_bucket)) {
		$assets_url = "{$config['locations']['protocol']}://{$evp->settings->s3_bucket}.s3.amazonaws.com/player/assets.lightning.js?v={$evp->options->project_version}";
	}
	*/

	$init = '';
	if(!$standalone && !$noInit) $init = 'new EVS.Lightning(\''.$file_ref.'\', \''.$container_id.'\');';
}

$database = Registry::retrieve('database');
if($database) $database->close();
?>

(function() {
	var load = function(url, callback){
		if(document.getElementById('<?php echo $jsAssetId; ?>')) {
			// Let's wait till it's loaded
			var i = setInterval(function() {
				if(typeof <?php echo $jsGlobal; ?> == 'undefined') return;
				clearInterval(i);
				callback();
			}, 5);
			return;
		}
		var script = document.createElement('script');
		script.id = '<?php echo $jsAssetId; ?>';
		script.type = 'text/javascript';
		if(script.readyState){
			script.onreadystatechange = function() {
				if(script.readyState == 'loaded' || script.readyState == 'complete') {
					script.onreadystatechange = null;
					callback();
				}
			};
		} else {
			script.onload = function() { callback(); };
		}
		script.src = url;
		document.getElementsByTagName('head')[0].appendChild(script);
	};

	var createCSSSelector = function(selector, style) {
		try {
			var sheet = document.createElement('style');
			sheet.type = 'text/css';
			sheet.innerHTML = selector+'{'+style+'}';
			(document.head || document.getElementsByTagName('head')[0]).appendChild(sheet);
		} catch(e) {}
	};

	createCSSSelector('[data-role="evp-video"] .fluid-width-video-wrapper, [data-role="evp-playlist"] .fluid-width-video-wrapper, [data-role="evp-splittest"] .fluid-width-video-wrapper', 'padding: 0 !important; width: auto !important; position: static !important;');

	load('<?php echo $assets_url; ?>', function() {
		<?php if(!$trueLightning) echo $onAssetsLoaded; ?>
		<?php echo $jsFileInfo; ?>
		<?php echo $jsGlobal; ?>.settings.uuid = '<?php echo $uuid; ?>';
		<?php echo $jsGlobal; ?>.settings.location = '<?php echo $asset_location; ?>';
		<?php echo $jsGlobal; ?>.settings.dynamic_location = '<?php echo $dynamic_asset_location; ?>';
		<?php echo $jsGlobal; ?>.settings.api_location = '<?php echo url('api.php'); ?>';
		<?php echo $jsGlobal; ?>.settings.affiliate_url = '<?php echo $evp->options->project_affiliate_website; ?>';

		<?php echo $init; ?>
		if(typeof window.evpAssetsReady == 'function') window.evpAssetsReady();
	});
})();
