<?php
// This file can access $file, $file_settings and $plugin
// You can assign things to $plugin if you need to
// File-specific stuff goes in $plugin->file_options

?>

function stripslashes (str) {
	return (str + '').replace(/\\(.?)/g, function (s, n1) {
		switch (n1) {
		case '\\':
			return '\\';
		case '0':
			return '\u0000';
		case '':
			return '';
		default:
			return n1;
		}
	});
}

EVP3.players.extend('EVP3.plugins.<?php echo $plugin->slug; ?>', {
	'init': function(evp, file, plugin, file_options) {
		this.evp = evp;
		this.plugin = plugin;
		this.file = file;
		this.file_options = file_options;
		var klass = this;

		if($.browser.msie && parseInt($.browser.version) == 6) return false; // Disabled for IE6

		this.chapters = this.file.chapters;

		setTimeout(function() {
			var pli = klass.file.player.currentRollItem;
			if(pli === 0) { // We are playing an intro video right now; let's show on the change event
				klass.file.player.addEvent('playlistItem', function(pl) {
					if(pl.index == 1) klass.create();
				});
			} else { // Else, just make as usual
				klass.create();
			}

			// No matter what, remove them on the outro
			setInterval(function() {
				if(klass.file.player.currentRollItem == 2) klass.remove();
			}, 500);
		}, 500);
	},
	'remove': function() {
		var wrap = $('#'+this.evp.container_id+'-video'+(EVP.helpers.isHTML5() ? '' : '_wrapper')).find('.evp-chapters-wrap');
		wrap.fadeOut(1000, function() {
			wrap.remove();
		});
	},
	'create': function() {
		var duration = Math.ceil(this.file.metadata.duration);
		var klass = this;

		var video_el = $('#'+this.evp.container_id+'-video_wrapper');
		if(EVP.helpers.isHTML5()) video_el = $('#'+this.evp.container_id+'-video');

		// This line causes them to be out of line when using frames, so.. remove it
		var vltop = 0;//(video_el.css('top') == 'auto' ? 0 : parseInt(video_el.css('top')));

		var wrapper = $('<div class="evp-chapters-wrap"></div>').css({
			'position': 'absolute',
			'left': parseInt(this.file.options.skin_data.chapter_left),
			'top': (vltop + parseInt(video_el.css('height')) - (parseInt(this.file.options.skin_data.chapter_bottom))),
			'width': (parseInt(video_el.css('width')) - (parseInt(this.file.options.skin_data.chapter_left)) - (parseInt(this.file.options.skin_data.chapter_right))),
			'height': '10px',
			'z-index': 301
		});

		var second_width = parseInt(wrapper.css('width')) / duration;

		var player = this.file.player.api;

		$.each(this.chapters, function(n, chapter) {
			if(!chapter.data) chapter.data = {};

			var l = Math.round(second_width * chapter.start); // This is the X offset in pixels
			var chapter_card = klass.build(stripslashes(chapter.name || ''), stripslashes(chapter.description || ''), stripslashes(chapter.data['chapter-image'] || ''), chapter.start, chapter['start-string']);

			chapter_card.css({
				'background-color': chapter.data['chapter-background-colour'],
				'position': 'absolute',
				'padding': 4,
				'line-height': '15px',
				'border-radius': '4px',
				'left': (l - 45),
				'background': chapter.data['chapter-background-colour'],
				'color': '#fff',
				'display': 'none'
			});

			var chapter_card_title = chapter_card.children('span.evp-chapter-card-title').css({'font-weight': 'bold', 'margin': '0 5px 0 0', 'font-size': '13px'});
			var chapter_card_duration = chapter_card.children('span.evp-chapter-card-duration').css({'font-style': 'italic', 'font-size': '10px'});
			var chapter_card_description = chapter_card.children('span.evp-chapter-card-description').css({'display': 'block', 'font-size': '13px'});
			var chapter_card_image = chapter_card.children('img.evp-chapter-card-image').css({'display': 'block', 'text-align': 'left', 'margin': '0 5px 0 0', 'max-width': 150, 'float': 'left'});

			var chapter_card_arrow = $(chapter_card).children('.evp-chapter-arrow-down').css({
				'width': 0,
				'height': 0,
				'border-left': '5px solid transparent',
				'border-right': '5px solid transparent',
				'border-top': '5px solid '+chapter.data['chapter-background-colour'],
				'position': 'absolute',
				'bottom': '-5px',
				'left': '45px'
			});

			chapter_card_arrow.fadeTo(0, 0);

			chapter_card.appendTo(wrapper);

			var el = $('<div class="evp-chapter"></div>').css({
				'position': 'absolute',
				'left': (l - 3),
				'top': 0,
				'width': 0,
				'height': 0,
				'border-left': '9px solid transparent',
				'border-right': '9px solid transparent',
				'border-top': '9px solid '+chapter.data['chapter-background-colour'],
				'border-left-width': '9px',
				'border-right-width': '9px',
				'border-top-width': '9px',
				'cursor': 'pointer',
				'opacity': 0.6,
				'title': stripslashes(chapter.name)
			}).click(function() {
				player.play(true).seek(chapter.start);
				$(this).stop().animate({'top': '-5px'}, 250);
			});

			var toAnim = [el[0]];//, chapter_card[0]];
			$(toAnim).hover(function() {
				$(el[0]).stop().animate({'border-left-width': '15px', 'border-right-width': '15px', 'border-top-width': '15px', 'margin-left': '-7px', 'opacity': 0.9}, 250);
				$(chapter_card).fadeTo(350, 0.9);
				$(chapter_card_arrow).fadeTo(350, 0.9);
			}, function() {
				$(el[0]).stop().animate({'border-left-width': '9px', 'border-right-width': '9px', 'border-top-width': '9px', 'margin-left': 0, 'opacity': 0.6}, 250);
				$(chapter_card).fadeTo(350, 0, function() {
					$(this).css('display', 'none');
				});
				$(chapter_card_arrow).fadeTo(350, 0);
			});

			el.appendTo(wrapper);

			// Correct the positions now they're inserted
			var ac = function() {
				$(chapter_card).css({'top': '-'+($(chapter_card).outerHeight() + 15)+'px'});
			};

			setInterval(ac, 250);
		});

		wrapper.appendTo($('#'+this.evp.container_id+'-video'+(EVP.helpers.isHTML5() ? '' : '_wrapper')));
	},
	'build': function(name, description, image, start, start_string) {
		var el = $('<div class="evp-chapter-marker">'+((image.length > 0 ? '<img class="evp-chapter-card-image" src="'+image+'" />' : ''))+'<span class="evp-chapter-card-title">'+name+'</span><span class="evp-chapter-card-duration">'+start_string+'</span>'+((description.length > 0 ? '<span class="evp-chapter-card-description">'+description+'</span>' : ''))+'<div class="evp-chapter-arrow-down"></div></div>');
		return el;
	}
});
