<?php
// This file can access $file, $file_settings and $plugin
// You can assign things to $plugin if you need to
// File-specific stuff goes in $plugin->file_options
?>

EVP3.players.extend('EVP3.plugins.<?php echo $plugin->slug; ?>', {
	'init': function(evp, file, plugin, file_options) {
		this.evp = evp;
		this.plugin = plugin;
		this.file = file;
		this.file_options = file_options;
		var klass = this;
		setTimeout(function() {
			klass.create();
		}, 500);
	},
	'create': function() {
		var klass = this;
		var parent = ('#'+this.evp.container_id+'-video_wrapper');
		if(EVP.helpers.isHTML5()) parent = ('#'+this.evp.container_id+'-video');
		if(this.evp.file.config.type == 'audio' && this.evp.file.options.related_image_mode != 'splash') {
			parent = ('#'+this.evp.container_id+'-event-container');
		}
		
		var event_width = parseInt(this.file.options.width) - 20;//($(parent).width() - 10);
		var event_height = parseInt(this.file.options.height) - 20;//($(parent).height() - 10);
	
		var event = {
			'duration': 0,
			'duration-string': '00:00',
			'end': 0,
			'event_slug': 'evp-internal-expiration',
			'name': 'EVP Internal Expiration',
			'start': 0,
			'start-string': '00:00',
			'data': {
				'event-mode': 'internal',
				'event-type': 'pro',
				'overlay-background-colour': this.file.options.expiration_background,
				'overlay-entrance': 'fade',
				'overlay-opaque': true,
				'overlay-position': 'full',
				'overlay-translucent': false,
				'overlay-trigger-pause': true,
				'overlay-show-close': false,
				'widgets': {
					'0': {
						'widget_idx': 1,
						'widget_pos_height': event_height,
						'widget_pos_width': event_width,
						'widget_pos_x': 0,
						'widget_pos_y': 0,
						'widget_ref': '',
						'widget_type': 'text',
						'body': '<div style="font-size:18px;margin-top:50px;"><center>'+this.file.options.expiration_body+'</center></div>'
					}
				}
			}
		};
		
		this.file.events['EVP Internal Expiration'] = event; // This adds to the stack so splashes can detect it
		
		this.evp.event_add('EVP Internal Expiration', event);
		
		setTimeout(function() {
			if(EVP.helpers.isDesktopOS()) {
				$('#'+klass.evp.container_id+'-video').remove();
			}
		}, 500);
	}
});