<?php
// This file can access $file, $file_settings and $plugin
// You can assign things to $plugin if you need to
// File-specific stuff goes in $plugin->file_options

?>
EVP3.players.extend('EVP3.plugins.<?php echo $plugin->slug; ?>', {
	'init': function(evp, file, plugin, file_options) {
		this.evp = evp;
		this.plugin = plugin;
		this.file = file;
		this.file_options = file_options;

		if(EVP.helpers.isHTML5() || ($.browser.msie && $.browser.version <= 8)) return false; // not supported on iOS

		// Load the G+1 script
		<?php /*
		if(typeof window.gapi == 'undefined' || typeof window.gapi.plusone == 'undefined') {
			$('<script type="text/javascript" src="https://apis.google.com/js/plusone.js"></script>').appendTo(document.body);
		}
		*/ ?>

		var klass = this;
		setTimeout(function() {
			klass.build();
		}, 500);
	},
	'build': function() {
		var klass = this;

		var x_offset = 10;
		var y_offset = 0;

		if(this.evp.container_element.find('#evp-plugin-mouseover-facebook').length >= 1) {
			x_offset += 45;
			y_offset += 55;
		}
		if(this.evp.container_element.find('#evp-plugin-mouseover-twitter').length >= 1) {
			x_offset += 45;
			y_offset += 55;
		}

		var isAudio = !!(this.file.config.type == 'audio' && this.file.options.related_image_mode !== 'splash');
		var video_wrapper = $('#'+this.evp.container_id+'-video_wrapper');
		if(EVP.helpers.isHTML5()) video_wrapper = $('#'+this.evp.container_id+'-video');

		var element = $('<div class="evp-plugin evp-plugin-<?php echo $plugin->slug; ?> evp-plugin-mouseover" id="evp-plugin-<?php echo $plugin->slug; ?>"><span style="padding-left:45px;" title="Share on Google +">Share this <?php echo $file->type; ?></span></div>');

		element.css({
			'float': 'left',
			'background': '#121212',
			'width': 38,
			'height': 32,
			'padding': '5px 5px 0 5px',
			'border-radius': '4px',
			'border': '1px solid #6E6E6E',
			'color': '#fff',
			'font-size': '15px',
			'font-family': 'Arial,Helvetica,sans-serif',
			'line-height': '30px',
			'text-align': 'left',
			'direction': 'ltr',
			'overflow': 'hidden',
			'opacity': 0,
			'position': 'absolute',
			'top': x_offset,
			'left': 10,
			'z-index': 10,
			'cursor': 'pointer'
		});

		if(isAudio) {
			var bar_height = (this.file.player.bar_element ? parseInt($(this.file.player.bar_element).height()) : 0);
			element.css({
				'top': ($(video_wrapper).height() + 10 + bar_height),
				'left': y_offset
			});
		}

		var gel = $('<div><g:plusone count="false" annotation="none" href="'+window.location.href+'"></g:plusone></div>').css({
			'position': 'absolute',
			'width': 38,
			'height': 24,
			'left': 5,
			'top': 5
		});
		gel.prependTo(element);

		video_wrapper.hover(function() {
			$(element).fadeTo(250, 1);
		}, function() {
			$(element).fadeTo(250, 0);
		});

		if(!$.browser.msie && !isAudio) {
			element.hover(function() {
				$(element).css('z-index', 11);
				$(element).stop(true, true).animate({'width': '155px', 'opacity': 1});
			}, function() {
				$(element).css('z-index', 10);
				$(element).stop(true, true).animate({'width': '38px', 'opacity': 1});
			});
		}

		element.appendTo(video_wrapper);

	//if(typeof gapi !== 'undefined') gapi.plusone.go();
	}
});
