<?php
// This file can access $file, $file_settings and $plugin
// You can assign things to $plugin if you need to
// File-specific stuff goes in $plugin->file_options

?>

/*!
* $ Bullseye v1.0
* http://pixeltango.com
*
* Copyright 2010, Mickel Andersson
* Dual licensed under the MIT or GPL Version 2 licenses.
*
* Date: Fri Aug 31 19:09:11 2010 +0100
*/
$.fn.bullseye = function (settings, viewport) {
    settings = $.extend({
        offsetTop: 0,
        offsetHeight: 0,
        extendDown: false
    }, settings);

    var isFocusedKey = 'is-focused';

    return this.each(function () {
        var
            $element = $(this),
            $viewport = $(viewport == null ? window : viewport);

        var magic = function () {
            var 
                elementWidth = $element.outerWidth(),
                elementHeight = $element.outerHeight() + settings.offsetHeight,
                viewportWidth = $viewport.width(),
                viewportHeight = $viewport.height(),

                scrollTop = $viewport.scrollTop(),
                scrollLeft = $viewport.scrollLeft(),
                scrollRight = scrollLeft + elementWidth,
                scrollBottom = scrollTop + viewportHeight,

                x1 = $element.offset().left,
                x2 = x1 + elementWidth,
				y1 = $element.offset().top + settings.offsetTop,
				y2 = $element.offset().top + elementHeight;
			//y2 = y1 + elementHeight;

            // Element is inside the viewport
            var insideViewport = function () {
                if (!isFocused($element)) {
                    setFocused($element);

                    $element.trigger('enterviewport');
                }
            }

            // Element is outside the viewport
            var outsideViewport = function () {
                if (isFocused($element)) {
                    clearFocused($element);

                    $element.trigger('leaveviewport');
                }
            }

            // Evaluate if the target is inside the viewport
            if (
                (scrollBottom < y1 || (settings.extendDown ? false : scrollTop > y2)) ||
                (scrollRight < x1 || scrollRight > x2)
            )
                outsideViewport();
            else
                insideViewport();
        };

        $viewport
            .scroll(magic)
            .resize(magic);

        magic();
    });

    function isFocused($element) {
        return $element.data(isFocusedKey);
    }

    function setFocused($element) {
        $element.data(isFocusedKey, true);
    }

    function clearFocused($element) {
        $element.data(isFocusedKey, false);
    }
};

EVP3.players.extend('EVP3.plugins.<?php echo $plugin->slug; ?>', {
	'init': function(evp, file, plugin, file_options) {
	
		if(EVP.helpers.isMobileOS()) return; // Don't run on mobile devices!
		
		this.evp = evp;
		this.plugin = plugin;
		this.file = file;
		this.file_options = file_options;
		var klass = this;
		
		if(this.file.options.related_image_mode == 'splash' && !EVP.helpers.isMobileOS()) {
			klass.evp.addEvent('onSplashClicked', function() {
				klass.bind();
			});
		} else {
			setTimeout(function() {
				klass.bind();
			}, 500);
		}
	},
	'bind': function() {
		var klass = this;
		$(klass.evp.container_element).bind('enterviewport', function() {
			klass.file.player.api.play(true);
		}).bind('leaveviewport', function() {
			klass.file.player.api.pause(true);
		}).bullseye({
			'offsetTop': (parseInt(klass.file.options.height) / 2)
		});
	}
});