<?php
// This file can access $file, $file_settings and $widget
// You can assign things to $widget if you need to
// File-specific stuff goes in $widget->file_options

?>
EVP3.players.extend('EVP3.widgets.<?php echo $widget->slug; ?>', {
	'init': function(evp, file, widget, file_options, row) {
		this.evp = evp;
		this.row = row;
		this.widget = widget;
		this.file = file;
		this.file_options = file_options;
		this.build();
	},
	'build': function() {
		var klass = this;
		
		var element = $('<div class="evp-widget evp-widget-<?php echo $widget->slug; ?>" id="evp-widget-<?php echo $widget->slug; ?>-<?php echo $widget_idx; ?>"></div>');
		
		element.css({
			'float': 'left',
			'background': 'url('+EVP3.settings.location+'/player/widgets/<?php echo $widget->slug; ?>/embed.png?v=1)',
			'width': 80,
			'height': 32,
			'cursor': 'pointer'
		});
		
		element.click(function() {
			klass.event();
			return false;
		});
		
		element.appendTo(this.file.player['bar_row_'+this.row]);
	},
	'event': function() {
		var message = '<div style="position:relative;width: '+(this.file.options.width * 0.8)+'px; margin: 0 auto;">';
		message += '<textarea style="resize:none;border: 2px solid #000; padding: 10px; box-shadow: inset 0 0 10px #000; background: #fff; color: #000; text-shadow: none; display: block;width: '+((this.file.options.width - 24) * 0.8)+'px; height: '+(this.file.options.height > 180 ? '180px' : this.file.options.height+'px')+'; font-size: 13px;">'+this.file.embed_code+'</textarea>';
		message += '<div class="evp-close" style="cursor:pointer;position:absolute;right:6px;bottom:10px;width:91px;height:30px;background:url('+EVP3.settings.location+'/player/widgets/<?php echo $widget->slug; ?>/continue.png?v=1) no-repeat;"></div>';
		message += '</div>';
		
		var klass = this.evp;
		
		// Set the parent, where they will get injected
		var parent = ('#'+klass.container_id+'-video_wrapper');
		
		// HTML5 will need the parent changing!
		if(EVP.helpers.isHTML5()) parent = ('#'+klass.container_id+'-video');
		
		var pos;
		
		if(klass.file.config.type == 'audio') {
			pos = {'height': 130};
			
			if(klass.file.options.related_image_mode != 'splash') { // Audio files WITHOUT splash images get a different parent - set it here
				parent = ('#'+klass.container_id+'-event-container');
			} else {
				pos.height = $(parent).height();
			}
		}
		
		if($(parent).find('.evp-overlay').length >= 1) return false; // Don't duplicate it on multiple clicks!
	
		EVP.visuals.overlay.show({
			'setTop': (klass.file.config.type == 'audio' && klass.file.options.related_image_mode != 'splash'),
			'resizeLightbox': (klass.file.config.type == 'audio' && klass.file.options.related_image_mode == 'lightbox'),
			'lightboxHeight': (parseInt(klass.file.options.height) + (32 * (klass.container_element.find('.evp-bar-row').length))),
			'parent': parent,
			'position': pos,
			'message': message,
			'showContinue': false,
			'showClose': false,
			'useGradient': true,
			'zIndex': 100,
			'callback': function(c, o) {
				o.find('textarea').click(function() {
					this.select();
				});
			}
		});
	}
});