<?php
// This file can access $file, $file_settings and $widget
// You can assign things to $widget if you need to
// File-specific stuff goes in $widget->file_options

?>
(function() {
	function stripslashes(str) {
		return (str + '').replace(/\\(.?)/g, function (s, n1) {
		 switch (n1) {
		 case '\\':
		     return '\\';
		 case '0':
		     return '\u0000';
		 case '':
		     return '';
		 default:
		     return n1;
		 }
		});
	}
		
	EVP3.players.extend('EVP3.widgets.<?php echo $widget->slug; ?>', {
		'init': function(evp, file, widget, file_options, row) {
			this.evp = evp;
			this.row = row;
			this.widget = widget;
			this.file = file;
			this.file_options = file_options;
			this.build();
		},
		'build': function() {
			var klass = this;
			
			this.element = $('<div class="evp-widget evp-widget-<?php echo $widget->slug; ?>" id="evp-widget-<?php echo $widget->slug; ?>-<?php echo $widget_idx; ?>"></div>');
			
			this.pane = $('<div id="'+this.evp.container_id+'-donation-pane"></div>').css({
				'width': 200,
				'clear': 'both',
				'display': 'none',
				'border-radius': 3,
				'position': 'absolute'
			}).appendTo(this.evp.file.player.bar_element);
			
			EVP.helpers.applyGradient(this.pane, '#000000', (this.file.options.bar_bgc || '202020'), 0.2);
	
			this.pane_inner = $('<div id="'+this.evp.container_id+'-donation-pane-inner"></div>').css({
				'opacity': 0,
				'position': 'relative'
			}).appendTo(this.pane);
			
			this.pane_intro = $('<p>'+stripslashes(this.file_options.intro || '')+'</p>').css({
				'color': '#fff',
				'font-size': 12,
				'margin': '0 0 5px 0',
				'display': ((this.file_options.intro || '').length >= 0 ? 'block' : 'none')
			}).appendTo(this.pane_inner);
			
			this.pane_input = $('<input type="text" id="'+this.evp.container_id+'-donation-pane-input" value="'+(this.file_options.item_suggested || '1.00')+'" />').css({
				'background': '#fff',
				'border': '1px solid #202020',
				'color': '#202020',
				'font-size': 12,
				'outline': 'none',
				'width': 40,
				'text-align': 'center',
				'padding': 4,
				'margin': '0 5px 0 0',
				'float': 'left'
			}).click(function() {
				this.select();
			}).keydown(function(event) { // Prevent non-numbers being entered
				var isNumber = (event.keyCode >= 48 && event.keyCode <= 57);
				var isDelete = (event.keyCode == 8 || event.keyCode == 46);
				var isFullStop = (event.keyCode == 190);
				if(!(isNumber || isDelete || isFullStop)) event.preventDefault();
			}).appendTo(this.pane_inner);
			
			this.pane_submit = $('<div id="'+this.evp.container_id+'-donation-pane-submit"></div>').css({
				'background': 'url('+EVP3.settings.location+'/player/widgets/<?php echo $widget->slug; ?>/submit.png?v=1)',
				'width': 49,
				'height': 25,
				'cursor': 'pointer',
				'float': 'left'
			}).click(function() {
				klass.event();
			}).appendTo(this.pane_inner);
			
			$('<div style="clear:both;"></div>').appendTo(this.pane_inner);
			
			this.pane_arrow = $('<div id="'+this.evp.container_id+'-donation-pane-arrow"></div>').css({
				'position': 'absolute',
				'top': '-10px',
				'left': 10,
				'width': 0,
				'height': 0,
				'border-left': '10px solid transparent',
				'border-right': '10px solid transparent',
				'border-bottom': '10px solid #'+EVP.helpers.generateGradient((this.file.options.bar_bgc || '202020'), '000000', 0.2)
			}).appendTo(this.pane);
			
			this.element.css({
				'float': 'left',
				'background': 'url('+EVP3.settings.location+'/player/widgets/<?php echo $widget->slug; ?>/donate.png?v=1)',
				'width': 80,
				'height': 32,
				'cursor': 'pointer'
			});
			
			this.element.click(function() {
				klass.clickButton();
				return false;
			});
			
			this.element.appendTo(this.file.player['bar_row_'+this.row]);
		},
		'clickButton': function() {
			if(this.visible === true) {
				this.closePane();
			} else {
				var pos = this.element.position();
				this.pane.css({
					'left': pos.left,
					'top': pos.top + 45
				});
				this.openPane();
			}
		},
		'openPane': function() {
			var klass = this;
		
			this.pane.css({'display': 'block'}).animate({'opacity': 1}, 200, function() {
				klass.pane_inner.animate({'opacity': 1, 'margin': 5});
			});
			
			this.visible = true;
		},
		'closePane': function() {
			var klass = this;
			
			this.pane_inner.css({'display': 'block'}).animate({'opacity': 0, 'margin': 0}, 100, function() {
				klass.pane.animate({'display': 'none'}, 100, function() {
					klass.pane.css({'display': 'none'});
				});
			});
			
			this.visible = false;
		},
		'event': function() {
			
			var amount = parseFloat(this.pane_input.val());
			if(amount <= 0) return false;
			
			var url = 'https://www.paypal.com/cgi-bin/webscr?';
			var args = {
				'cmd': '_xclick',
				'business': this.file_options.paypal_email,
				'item_name': this.file_options.item_name || '<?php echo $evp->options->project_name; ?> Donation',
				'amount': amount,
				'currency_code': (this.file_options.paypal_currency || 'USD'),
				'button_subtype': 'services',
				'no_note': 1,
				'no_shipping': 1,
				'bn': 'EVS_BuyNow_Donation_US'
			};
			
			if(this.file_options.paypal_return) {
				if(this.file_options.paypal_return.substring(0, 4) != 'http') this.file_options.paypal_return = 'http://'+this.file_options.paypal_return;
				args.return = this.file_options.paypal_return; // Allow a return URL
			}
			
			url += $.param(args);
			
			var w = window.open(url);
		}
	});
})();