<?php
// This file can access $file, $file_settings and $widget
// You can assign things to $widget if you need to
// File-specific stuff goes in $widget->file_options

$commentsEnabled = ($widget->file_options['enabled'] == true || !isset($widget->file_options['enabled']));
$autoOpen = ($widget->file_options['autoOpen'] == true);
$height = pick($widget->file_options['height'], '7');
$harvestEmails = ($widget->file_options['harvestEmails'] == true);
$harvestCode = $widget->file_options['harvestCode'];
?>

(function() {
	function stripslashes(str) {
		return (str + '').replace(/\\(.?)/g, function (s, n1) {
		 switch (n1) {
		 case '\\':
		     return '\\';
		 case '0':
		     return '\u0000';
		 case '':
		     return '';
		 default:
		     return n1;
		 }
		});
	}
	
	EVP3.players.extend('EVP3.widgets.<?php echo $widget->slug; ?>', {
		'init': function(evp, file, widget, file_options, row) {
			this.evp = evp;
			this.row = row;
			this.widget = widget;
			this.file = file;
			this.file_options = file_options;
			
			this.enabled = <?php echo boolToString($commentsEnabled); ?>;
			this.can_comment = false;
			this.autoOpen = <?php echo boolToString($autoOpen); ?>;
			this.height = (60 * <?php echo $height; ?>);
			this.harvestEmails = <?php echo boolToString($harvestEmails); ?>;
			this.harvestCode = '<?php echo addslashes(string_whitespace(html_entity_decode($harvestCode))); ?>';
			
			this.reply_to = false;
			this.client_email = '';
			this.client_name = '';
			if($.cookie('evs_client_email') && $.cookie('evs_client_email').length > 0) this.client_email = $.cookie('evs_client_email');
			if($.cookie('evs_client_name') && $.cookie('evs_client_name').length > 0) this.client_name = $.cookie('evs_client_name');
			
			var loggedInUser = '<?php echo $xs->userData->username; ?>';
			if(loggedInUser && loggedInUser.length >= 1 && loggedInUser != 'Guest') this.client_email = loggedInUser;
			
			if(this.client_email.length > 0 && this.client_name.length > 0 && this.enabled) this.can_comment = true;
			
			this.prepare();
			this.button();
			if(this.autoOpen) {
				setTimeout(function() {
					klass.originalContainerHeight = parseInt(klass.evp.container_element.css('height'));
					klass.openPane();
				}, 1000);
			} else {
				this.poll();
			}
			
			this.newest_comment = false; // This will be used to control scrolling
			
			var klass = this;
		},
		'getGravatarHash': function(email) {
			return $.md5($.trim(email).toLowerCase());
		},
		'getGravatarImg': function(email, size) {
			var s = size || '20';
			return (window.location.protocol == 'https:' ? 'https://secure.' : 'http://www.')+'gravatar.com/avatar/'+this.getGravatarHash(email)+'?s='+s+'&d=mm';
		},
		'prepare': function() {
			var klass = this;
			
			this.pane = $('<div id="'+this.evp.container_id+'-comment-pane"></div>').css({
				'height': 0, // Initially it's hidden
				'width': this.evp.file.options.width - 2,
				'clear': 'both',
				'display': 'none'
			}).appendTo(this.evp.file.player.bar_element);
			
			this.pane_inner = $('<div id="'+this.evp.container_id+'-comment-pane-inner"></div>').css({
				'opacity': 0,
				'position': 'relative'
			}).appendTo(this.pane);
			
			this.comment_box = $('<div id="'+this.evp.container_id+'-comment-box"></div>').css({
				'position': 'relative'
			}).appendTo(this.pane_inner);
			
			this.list = $('<div id="'+this.evp.container_id+'-comment-list"></div>').css({
				'overflow-x': 'hidden',
				'overflow-y': 'scroll',
				'border': '2px solid #000',
				'padding': '10px',
				'box-shadow': 'inset 0 0 10px #000',
				'background': '#fff',
				'background-position': 'center center',
				'background-repeat': 'no-repeat',
				'height': klass.height
			}).appendTo(this.pane_inner);
			
			// Let's make the box which accepts their name and email address
			this.comment_gate = $('<div id="'+this.evp.container_id+'-comment-gate"></div>').css({
				'color': '#fff',
				'font-size': '13px',
				'width': this.evp.file.options.width - 22,
				'margin': '0px auto 10px auto',
				'padding': '5px',
				'text-align': 'center',
				'text-shadow': '1px 1px 2px #000'
			}).append(
				$('<input type="text" id="'+this.evp.container_id+'-comment-gate-input-name" value="'+(this.client_name || 'Your name')+'" />').css({
					'border': '2px solid #276591',
					'padding': '10px',
					'box-shadow': 'inset 0 0 10px #4D9DD6',
					'background': '#fff',
					'outline': 'none',
					'width': '150px',
					'margin': '0 0 0 10px'
				}).focus(function() {
					if($(this).val() == 'Your name') $(this).val('');
				}).blur(function() {
					if($(this).val() == '') $(this).val('Your name');
				}).keyup(function(e) {
					if(e && e.keyCode == 13) {
						var name = $(this).val();
						var email = $('#'+klass.evp.container_id+'-comment-gate-input-email').val();
						if(email.length > 0 && email.indexOf('@') !== -1 && /\./.test(email) !== false && name.length >= 1 && name != 'Your name' && email != 'Your email') {
							acceptDetails(name, email);
						}
					}
				}),
				$('<input type="text" id="'+this.evp.container_id+'-comment-gate-input-email" value="'+(this.client_email || 'Your email')+'" />').css({
					'border': '2px solid #276591',
					'padding': '10px',
					'box-shadow': 'inset 0 0 10px #4D9DD6',
					'background': '#fff',
					'outline': 'none',
					'width': '150px',
					'margin': '0 0 0 10px'
				}).focus(function() {
					if($(this).val() == 'Your email') $(this).val('');
				}).blur(function() {
					if($(this).val() == '') $(this).val('Your email');
				}).keyup(function(e) {
					if(e && e.keyCode == 13) {
						var email = $(this).val();
						var name = $('#'+klass.evp.container_id+'-comment-gate-input-name').val();
						if(email.length > 0 && email.indexOf('@') !== -1 && /\./.test(email) !== false && name.length >= 1 && name != 'Your name' && email != 'Your email') {
							acceptDetails(name, email);
						}
					}
				})
			).appendTo(this.comment_box);
			
			// Let's make the reply box, which might be shown
			this.reply_box = $('<div id="'+this.evp.container_id+'-comment-reply-box"><span style="font-weight:bold;font-size:13px;margin:0 0 5px 35px;display:block;">In response to <span class="evp-widget-comments-inresponse"></span>: </span></div>').css({
				'position': 'relative',
				'background': '#2E2E2E',
				'color': '#fefefe',
				'font-size': '12px',
			//'opacity': 0.9,
				'display': 'none',
				'border-radius': '4px',
				'padding': '3px',
				'border': '2px solid #000',
				'overflow': 'auto',
				'margin': '0 0 10px 0'
			}).append($('<div id="'+this.evp.container_id+'-comment-reply-box-close" style="width:16px;height:16px;position:absolute;top:5px;right:5px;background:url('+EVP3.settings.location+'/player/images/cross.png) no-repeat center center rgba(0, 0, 0, 0.6);padding:4px;border-radius:10px;cursor:pointer;"></div>').click(function() {
				klass.reply_box.css({'display': 'none'});
				setTimeout(function() {
					klass.list.animate({
						'height': klass.height//340
					}, 100);
				}, 20);
				
				klass.reply_to = false;
			})).appendTo(this.comment_box);
			
			this.reply_box_avatar = $('<div id="'+this.evp.container_id+'-comment-reply-box-avatar"></div>').css({
				'float': 'left',
				'margin': '0 5px 0 0'
			}).appendTo(this.reply_box);
			
			this.reply_box_message = $('<div id="'+this.evp.container_id+'-comment-reply-box-message"></div>').css({
				'padding-right': '35px'
			}).appendTo(this.reply_box);
			
			var submit = function() {
				var email = $('#'+klass.evp.container_id+'-comment-gate-input-email').val();
				var name = $('#'+klass.evp.container_id+'-comment-gate-input-name').val();
				if(email.length > 0 && email.indexOf('@') !== -1 && /\./.test(email) !== false && name.length >= 1 && name != 'Your name' && email != 'Your email') {
					acceptDetails(name, email);
				}
				
				var val = klass.input.val().trim();
				if(val.length >= 1 && klass.can_comment == true && val != 'Enter your comment here..') {
					klass.post(val, klass.reply_to);
					klass.input.val('').focus();
				} else {
					var input_name = $('#'+klass.evp.container_id+'-comment-gate-input-name');
					var input_email = $('#'+klass.evp.container_id+'-comment-gate-input-email');
					
					if(val.length < 0 || val == 'Enter your comment here..') klass.input.animate({'box-shadow': 'inset 0 0 10px #E01B6A'}, 250).animate({'box-shadow': 'inset 0 0 10px #000'}, 250).focus();
					if(input_email.val().length < 0 || input_email.val().indexOf('@') == -1 || input_email.val() == 'Your email') input_email.animate({'box-shadow': 'inset 0 0 10px #E01B6A'}, 250).animate({'box-shadow': 'inset 0 0 10px #4D9DD6'}, 250).focus();
					if(input_name.val().length < 0 || input_name.val() == 'Your name') input_name.animate({'box-shadow': 'inset 0 0 10px #E01B6A'}, 250).animate({'box-shadow': 'inset 0 0 10px #4D9DD6'}, 250).focus();
				}
			}
			
			// Make the input for the comment
			this.input = $('<input type="text" id="'+this.evp.container_id+'-comment-input" value="Enter your comment here.." />').css({
				'border': '2px solid #000',
				'padding': '15px 102px 15px 45px',
				'box-shadow': 'inset 0 0 10px #000',
				'background': '#fff',
				'font-size': '11px',
				'background-repeat': 'no-repeat',
				'background-position': '7px 7px',
				'outline': 'none',
				'margin': '0 0 10px 0',
				'width': this.evp.file.options.width - 71 - 92
			}).focus(function() {
				if($(this).val() == 'Enter your comment here..') $(this).val('');
			}).blur(function() {
				if($(this).val() == '') $(this).val('Enter your comment here..');
			}).keyup(function(e) {
				if(e && e.keyCode == 13) submit();
			}).appendTo(this.comment_box);
			
			this.input_send = $('<div id="'+this.evp.container_id+'-comment-send">Post comment</div>').css({
				'width': '80px',
				'height': '15px',
				'padding': 5,
				'line-height': '15px',
				'position': 'absolute',
				'right': 2,
				'bottom': 12,
				'text-align': 'center',
				'background': '#'+klass.evp.file.options.bar_bgc,
				'color': '#fff',
				'font-size': 12,
				'border-top-left-radius': 4,
				'border-left': '2px solid #000',
				'border-top': '2px solid #000',
				'cursor': 'pointer'
			}).click(function() {
				submit();
			}).appendTo(this.comment_box);
			
			var acceptDetails = function(name, email, focus) {
				if(focus === true) {
					klass.comment_gate.css({'display': 'none'});
					klass.input.focus();
					klass.input.animate({'opacity': 0.7}, 200).animate({'opacity': 1}, 400).delay(200).animate({'opacity': 0.7}, 200).animate({'opacity': 1}, 400);
				} else {
					klass.comment_gate.slideUp();
					klass.list.animate({
						'height': klass.height
					}, 100);
				}
				klass.input.css({
					'background-image': 'url('+klass.getGravatarImg(email, 30)+')'
				});
				klass.client_email = email;
				klass.client_name = name;
				if(klass.enabled == true) klass.can_comment = true;
				klass.list.find('.evp-widget-comments-reply').css('display', 'inline');
				klass.list.find('.evp-widget-comments-like').css('display', 'inline');
				
				if(focus != true && klass.harvestEmails === true && klass.hasHarvested !== true) {
					EVP.helpers.harvestEmail(name, email, klass.harvestCode, 'comments', klass.evp);
					klass.hasHarvested = true;
				}
				
				$.cookie('evs_client_email', email);
				$.cookie('evs_client_name', name);
			}
			
			// Now, do we have a name and email? If so, hide the gate
			if(this.enabled && this.client_name.length > 0 && this.client_email.length > 0 && this.client_email.indexOf('@') !== -1 && /\./.test(this.client_email) !== false) {
				acceptDetails(this.client_name, this.client_email, true);
			} else { // No email, so let's reduce the height of the list
				this.list.css({'height': klass.height - 60});
			}
			
			if(!this.enabled) {
				this.comment_gate.css({'display': 'none'});
				this.list.css({'height': klass.height + 55});//'395px'});
			}
			
			// Make the reply links work
			this.list.delegate('.evp-widget-comments-reply', 'click', function() {
				klass.reply_box.css({'display': 'block'});
				setTimeout(function() {
					var height = klass.reply_box.height() + 20;
					klass.list.animate({
						'height': klass.height - height //340 - height
					}, 100);
				}, 20);
				
				klass.input.focus();
				
				var p = $(this).parents('.evp-widget-comments-message');
				var email = p.data('email');
				var body = p.data('body');
				var parent_id = p.data('comment-id');
				klass.reply_box.find('.evp-widget-comments-inresponse').text(p.data('name'));
				klass.reply_box_avatar.empty().append($('<img />').prop('src', klass.getGravatarImg(email, 30)));
				klass.reply_box_message.text(stripslashes(body));
				klass.reply_to = parent_id;
			});
			
			// Make like links works
			this.list.delegate('.evp-widget-comments-like', 'click', function() {
				var p = $(this).parents('.evp-widget-comments-message');
				var comment_id = p.data('comment-id');
				var link = $(this);
				
				var mode = 'like';
				
				// Switch between like and unlike
				if($(this).hasClass('evp-widget-comments-unlike')) {
					mode = 'unlike';
				}
				
				$.ajax({
					'url': EVP3.settings.api_location,
					'data': {
						'responseType': 'jsonp',
						'method': 'public-'+mode,
						'reference': comment_id,
						'type': 'comment',
						'name': klass.client_name,
						'email': klass.client_email
					},
					'dataType': 'jsonp',
					'success': function(response) {
						if(mode == 'like') {
							link.text('Unlike').addClass('evp-widget-comments-unlike');
							var el = $('<img src="'+klass.getGravatarImg(klass.client_email, 20)+'" title="'+klass.client_name+'" data-like-email="'+klass.client_email+'" style="margin:0 5px 0 0;float:left;" />');
							el.appendTo(p.find('.evp-widget-comments-likes'));
						} else {
							link.text('Like').removeClass('evp-widget-comments-unlike');
							p.find('.evp-widget-comments-likes img[data-like-email="'+klass.client_email+'"]').remove();
						}
					}
				});
			});
		},
		'button': function() {
			var klass = this;
			
			var element = this.element = $('<div class="evp-widget evp-widget-<?php echo $widget->slug; ?>" id="evp-widget-<?php echo $widget->slug; ?>-<?php echo $widget_idx; ?>"></div>');
			
			element.css({
				'float': 'left',
				'background': 'url('+EVP3.settings.location+'/player/widgets/<?php echo $widget->slug; ?>/button.png?v=9-1)',
				'background-position': '0px 0px',
				'width': 120,
				'height': 32,
				'cursor': 'pointer',
				'position': 'relative'
			});
			
			var span = this.element_span = $('<span>Loading</span>').css({
				'color': '#fff',
				'position': 'absolute',
				'left': 25, // This gets changed in the updateButton function below!
				'top': 11,
				'width': 22,
				'text-align': 'center',
				'font-size': 13,
				'font-weight': 'bold',
				'text-shadow': '0 0 2px #000'
			});
			
			var span_label = this.element_span_label = $('<span>Comments</span>').css({
				'color': '#fff',
				'position': 'absolute',
				'left': 26,
				'top': 11,
				'width': 80,
				'display': 'none',
				'font-size': 13,
				'text-shadow': '0 0 2px #000'
			});
			
			element.append(span, span_label);
			
			element.click(function() {
				klass.clickButton();
			});
			
			element.appendTo(this.file.player['bar_row_'+this.row]);
		},
		'pulseButton': function() {
			this.element.stop().animate({'opacity': 0.7}, 200).animate({'opacity': 1}, 200).delay(100).animate({'opacity': 0.7}, 200).animate({'opacity': 0.8}, 200);
		},
		'updateButton': function(total) {
			this.element_span_label.css({'display': 'block'});
			this.element_span.css({'left': 4}).text(total);
		},
		'activateSending': function() {
			//
		},
		'deactivateSending': function() {
			//
		},
		'poll': function() {
			var klass = this;
			$.ajax({
				'url': EVP3.settings.api_location,
				'data': {
					'responseType': 'jsonp',
					'method': 'public-comments-poll',
					'file_ref': '<?php echo $file_ref; ?>'
				},
				'dataType': 'jsonp',
				'success': function(response) {
					if(!response || !response.success) return false; // It failed for some reason, so silently ignore
					var w = klass.list;
					var included = [];
					
					$.each(response.comments, function(idx, msg) {
						included.push(msg.id);
						
						var message = klass.formatComment(msg);
						
						if(!message) { // check for extra likes to add
							var m = klass.list.find('.evp-widget-comments-message[data-comment-id="'+msg.id+'"]');
							if(msg.likes) {
								$.each(msg.likes, function(idx, like) {
									if(m.find('.evp-widget-comments-likes img[data-like-email="'+like.email+'"]').length >= 1) return false;
									var i = $('<img src="'+klass.getGravatarImg(like.email, 20)+'" title="'+like.name+'" style="margin:0 5px 0 0;float:left;" data-like-email="'+like.email+'" />');
									i.appendTo(m.find('.evp-widget-comments-likes'));
								});
							}
						} else {
							var m = $(message);
							if(msg.parent_id) {
								var i = setInterval(function() {
									var parent = klass.list.find('.evp-widget-comments-message[data-comment-id="'+msg.parent_id+'"]');
									if(parent.length == 0) return false;
									clearInterval(i);
									
									var locateParents = function(id) {
										var count = 0;
										var fn = function(id) {
											var parent = klass.list.find('.evp-widget-comments-message[data-comment-id="'+id+'"]');
											count++;
											if(parent.data('parent-id')) {
												fn(parent.data('parent-id'));
											}
										}
										fn(id);
										return count;
									}
									
									var parents = 1;
									if(parent.data('parent-id')) parents += locateParents(parent.data('parent-id'));
									
									var indent = 15 * parents;
									m.css('padding', '5px 0 5px '+indent+'px');
									m.insertAfter(parent);
								}, 5);
							} else {
								m.appendTo(w);
							}
							
							m.data('email', msg.email);
							m.data('name', msg.name);
							m.data('body', msg.body);
							m.data('comment-id', msg.id);
							
						}
					});
					
					setTimeout(function() {
						var allComments = klass.list.find('.evp-widget-comments-message');
						if(allComments.length >= 1) {
							$.each(allComments, function(idx, co) {
								if($.inArray(''+$(co).data('comment-id'), included) == -1) { // Caste it to a string
									$(co).fadeOut(function() { $(this).remove(); });
								}
							});
						}
					
						var m = w.find('.evp-widget-comments-message:first-child');
						if(m.length > 0) {
							klass.list.css('background-image', '');
							
							if(m.data('comment-id') !== klass.newest_comment) { // Only scroll if it's a different comment to before
								w.animate({
									'scrollTop': m.offset().top - w.offset().top + w.scrollTop()
								}, 250);
							}
							
							klass.newest_comment = m.data('comment-id');
							
						} else {
							klass.list.css('background-image', 'url('+EVP3.settings.location+'/player/widgets/<?php echo $widget->slug; ?>/no-comments.png)');
						}
						
						klass.updateButton(w.find('.evp-widget-comments-message').length);
						
					}, 500);
				}
			});
		},
		'clickButton': function() {
			if(this.visible === true) {
				this.closePane();
			} else {
				this.openPane();
			}
		},
		'openPane': function() {
			var klass = this;
			
			this.evp.container_element.css('height', '');
		
			this.polling = setInterval(function() {
				klass.poll();
			}, 30000);
			klass.poll();
		
			this.pane.css({'display': 'block'}).animate({'height': klass.height + 85}, 200, function() {//'425px'}, 200, function() {
				klass.pane_inner.css('display', 'block').animate({'opacity': 1, 'margin-top': 0, 'margin-right': 5, 'margin-bottom': 5, 'margin-left': 5});
			});
			
			if(klass.evp.file.options.related_image_mode == 'lightbox') {
				var lbheight = 15 + 425 + (parseInt(klass.evp.file.options.height) + (32 * (klass.evp.container_element.find('.evp-bar-row').length)));
				if(typeof $.colorbox !== 'undefined') $.colorbox.resize({'innerHeight': lbheight});
			}
			
			this.visible = true;
		},
		'closePane': function() {
			var klass = this;
			
			if(klass.polling) clearInterval(klass.polling);
			
			this.pane_inner.animate({'opacity': 0, 'margin': 0}, 100, function() {
				klass.pane_inner.css('display', 'none');
				klass.pane.animate({'height': 0, 'display': 'none'}, 100);
			});
			
			if(klass.evp.file.options.related_image_mode == 'lightbox') {
				var lbheight = 15 + (parseInt(klass.evp.file.options.height) + (32 * (klass.evp.container_element.find('.evp-bar-row').length)));
				if(typeof $.colorbox !== 'undefined') $.colorbox.resize({'innerHeight': lbheight});
			}
			
			if(klass.originalContainerHeight > 0) {
				setTimeout(function() {
					klass.evp.container_element.css({'height': klass.originalContainerHeight});
				}, 180);
			}
			
			this.visible = false;
		},
		'post': function(body, parent_id) {
			var klass = this;
					
			var data = {
				'parent_id': parent_id || '',
				'file_ref': '<?php echo $file_ref; ?>',
				'date': new Date(),
				'name': this.client_name || '',
				'email': this.client_email || '',
				'body': body
			};
			
			// Send it off to the operator
			$.ajax({
				'url': EVP3.settings.api_location,
				'data': {
					'responseType': 'jsonp',
					'method': 'public-comments-send',
					'file_ref': '<?php echo $file_ref; ?>',
					'email': data.email,
					'name': data.name,
					'body': data.body,
					'parent_id': data.parent_id
				},
				'dataType': 'jsonp',
				'success': function(response) {
					klass.list.css('background-image', '');
					
					EVP.log('Sent comment to EVS', '', 'info');
					data.id = response.comment_id;
					data.isOperator = response.isOperator;
					
					klass.newest_comment = data.id;
					
					var message = klass.formatComment(data); // Build the HTML
					if(!message) return false;
					EVP.log('Adding comment to stack', '', 'info');
					var w = klass.list;
	
					var m = $(message);
				
					if(data.parent_id) {
						var i = setInterval(function() {
							var parent = klass.list.find('.evp-widget-comments-message[data-comment-id="'+data.parent_id+'"]');
							if(parent.length == 0) return false;
							clearInterval(i);
							
							var locateParents = function(id) {
								var count = 0;
								var fn = function(id) {
									var parent = klass.list.find('.evp-widget-comments-message[data-comment-id="'+id+'"]');
									count++;
									if(parent.data('parent-id')) {
										fn(parent.data('parent-id'));
									}
								}
								fn(id);
								return count;
							}
							
							var parents = 1;
							if(parent.data('parent-id')) parents += locateParents(parent.data('parent-id'));
							
							var indent = 15 * parents;
							m.css('padding', '5px 0 5px '+indent+'px');
							m.insertAfter(parent);
						}, 5);
					} else {
						m.prependTo(w);
					}
	
					m.data('email', data.email);
					m.data('body', data.body);
					m.data('comment-id', data.id);
					
					var sc = m.offset().top - w.offset().top + w.scrollTop();
					
					w.animate({
						'scrollTop': sc
					}, 250);
					
					klass.updateButton(w.find('.evp-widget-comments-message').length);
				}
			});
			
		},
		'formatComment': function(data) {
			var klass = this;
			// data.parent_id, data.date, data.type, data.read, data.body
	
			if(data.id && this.list.find('.evp-widget-comments-message[data-comment-id="'+data.id+'"]').length >= 1) return false; // Don't duplicate
			
			var date_str = $.timeago(data.date);
			
			var mode = 'like';
			if(data.likes) {
				$.each(data.likes, function(idx, like) {
					if(like.email == klass.client_email) mode = 'unlike';
				});
			}
			
			var body = stripslashes(data.body); // handle HTML? handle any commands in here maybe?
			var block_name = '<div class="evp-widget-comments-message-name" style="color:#000;font-size:14px;font-weight:bold;margin:0 0 5px 0;"><a href="mailto:'+data.email+'" style="padding:0;margin:0;border:none;text-decoration:none;color:#'+(data.isOperator == 1 ? 'FF002B' : '000')+';background:none;">'+data.name+'</a></div>';
			var block_date = '<div class="evp-widget-comments-message-date" style="float:right;font-size:10px;color:#999;">'+date_str+'</div>';
			var block_avatar = '<div class="evp-widget-comments-message-avatar" style="width: 40px; height: 40px; float:left; margin: 0 10px 5px 0;"><img src="'+this.getGravatarImg(data.email, 40)+'" style="border-radius:5px;" /></div>';
			var block_body = '<div class="evp-widget-comments-message-body" style="color:#000;font-size:14px;">'+body+'</div>';
			
			var block_meta = '<div class="evp-widget-comments-meta" style="margin:10px 0 0 0;cursor:default;padding:0 5px 5px 5px;color:#999;font-size:11px;clear:both;">';
				block_meta += (!this.enabled ? '' : '<span class="evp-widget-comments-reply" style="margin:4px 0 0 0;cursor:pointer;color:#276591;float:right;display:'+(this.can_comment ? 'inline' : 'none')+';">Reply</span>');
				block_meta += '<span class="evp-widget-comments-like '+(mode == 'like' ? '' : 'evp-widget-comments-unlike')+'" style="cursor:pointer;margin:4px 5px 0 0;color:#276591;float:right;display:'+(this.can_comment && this.enabled ? 'inline' : 'none')+';">'+(mode == 'like' ? 'Like' : 'Unlike')+'</span>';
				block_meta += '<div class="evp-widget-comments-likes-wrap" style="height:20px;overflow:hidden;position:relative;"><div class="evp-widget-comments-likes" style="position:absolute;top:0;right:0;">';
				if(data.likes) {
					$.each(data.likes, function(idx, like) {
						block_meta += '<img src="'+klass.getGravatarImg(like.email, 20)+'" title="'+like.name+'" style="margin:0 5px 0 0;float:left;" data-like-email="'+like.email+'" />';
					});
				}
				block_meta += '</div></div>';
			block_meta += '</div>';
			
			var block_div = '<div class="evp-widget-comments-divide" style="margin:0 0 0 50px;height:1px;background:#eee;clear:both;position:relative;top:5px;"></div>';
			
			var message = '<div class="evp-widget-comments-message" style="overflow:auto; padding: 10px 0 10px 0;" '+(data.parent_id ? 'data-parent-id="'+data.parent_id+'"' : '')+' data-comment-id="'+data.id+'">';
			
			message += block_avatar;
			message += block_date;
			message += block_name;
			message += block_body;
			message += block_meta;
			message += block_div;
			
			message += '</div>';
			
			return message;
		}
	});
})();