<?php
// This file can access $file, $file_settings and $widget
// You can assign things to $widget if you need to
// File-specific stuff goes in $widget->file_options
?>
if ( !Date.prototype.toISOString ) {
  ( function() {

    function pad(number) {
      var r = String(number);
      if ( r.length === 1 ) {
        r = '0' + r;
      }
      return r;
    }

    Date.prototype.toISOString = function() {
      return this.getUTCFullYear()
        + '-' + pad( this.getUTCMonth() + 1 )
        + '-' + pad( this.getUTCDate() )
        + 'T' + pad( this.getUTCHours() )
        + ':' + pad( this.getUTCMinutes() )
        + ':' + pad( this.getUTCSeconds() )
        + '.' + String( (this.getUTCMilliseconds()/1000).toFixed(3) ).slice( 2, 5 )
        + 'Z';
    };

  }() );
}

EVP3.players.extend('EVP3.widgets.<?php echo $widget->slug; ?>', {
	'init': function(evp, file, widget, file_options, row) {
		this.evp = evp;
		this.row = row;
		this.widget = widget;
		this.file = file;
		this.file_options = file_options;
		this.build();
	},
	'build': function() {
		var klass = this;
		
		var element = this.element = $('<div class="evp-widget evp-widget-<?php echo $widget->slug; ?>" id="evp-widget-<?php echo $widget->slug; ?>-<?php echo $widget_idx; ?>"></div>');
		
		element.css({
			'float': 'right',
			'background': 'url('+EVP3.settings.location+'/player/widgets/<?php echo $widget->slug; ?>/button.png?v=3) 0 0',
			'width': 140,
			'height': 27,
			'cursor': 'default',
			'padding': '5px 0 0 0',
			'font-size': '11px',
			'text-align': 'center',
			'color': '#fff'
		});
		
		$.timeago.settings.allowFuture = true;
		$.timeago.settings.strings = {
        prefixAgo: null,
        prefixFromNow: '',
        suffixAgo: "ago",
        suffixFromNow: null,
       //seconds: "less than a minute",
       	seconds: "%d seconds",
        minute: "about a minute",
        minutes: "%d minutes",
        hour: "about an hour",
        hours: "about %d hours",
        day: "a day",
        days: "%d days",
        month: "about a month",
        months: "%d months",
        year: "about a year",
        years: "%d years",
        wordSeparator: " ",
        numbers: []
      };
		
		klass.countdown();
		setInterval(function() {
			klass.countdown();
		}, 1000);
		
		element.appendTo(this.file.player['bar_row_'+this.row]);
	},
	'countdown': function() {
		var klass = this;
		var expire_gmt = parseInt(this.file.options.expiration_date_gmt);
		var expire_now = Math.ceil(new Date().getTime() / 1000);
		
		if(expire_now >= expire_gmt) {
			this.element.css({'font-size': '11px', 'background-position': '0 -64px'}).text('This video is no longer available.');
			if(!this.file.options.expiration_expired) {
				klass.expire();
			}
			this.file.options.expiration_expired = true;
			return;
		}
		
		var date = new Date(expire_gmt * 1000);
		var date_iso = date.toISOString();
		
		this.element.html('This video will expire in<br /><span style="font-weight:bold;">'+$.timeago(date_iso)+'</span>');
		
		if((expire_gmt - expire_now) <= 15) {
			this.element.css({'background-position': '0 -32px'});
		}
	},
	'expire': function() {
		var klass = this;
		var parent = ('#'+this.evp.container_id+'-video_wrapper');
		if(EVP.helpers.isHTML5()) parent = ('#'+this.evp.container_id+'-video');
		if(this.evp.file.config.type == 'audio' && this.evp.file.options.related_image_mode != 'splash') {
			parent = ('#'+this.evp.container_id+'-event-container');
		}
		
		var event_width = parseInt(this.file.options.width) - 20;//($(parent).width() - 10);
		var event_height = parseInt(this.file.options.height) - 20;//($(parent).height() - 10);
	
		var event = {
			'duration': 0,
			'duration-string': '00:00',
			'end': 0,
			'event_slug': 'evp-internal-expiration',
			'name': 'EVP Internal Expiration',
			'start': 0,
			'start-string': '00:00',
			'data': {
				'event-mode': 'internal',
				'event-type': 'pro',
				'overlay-background-colour': this.file.options.expiration_background,
				'overlay-entrance': 'fade',
				'overlay-opaque': true,
				'overlay-position': 'full',
				'overlay-translucent': false,
				'overlay-trigger-pause': true,
				'overlay-show-close': false,
				'widgets': {
					'0': {
						'widget_idx': 1,
						'widget_pos_height': event_height,
						'widget_pos_width': event_width,
						'widget_pos_x': 0,
						'widget_pos_y': 0,
						'widget_ref': '',
						'widget_type': 'text',
						'body': '<div style="font-size:18px;margin-top:50px;"><center>'+this.file.options.expiration_body+'</center></div>'
					}
				}
			}
		};
		
		this.file.events['EVP Internal Expiration'] = event; // This adds to the stack so splashes can detect it
		
		this.evp.event_add('EVP Internal Expiration', event);
		
		setTimeout(function() {
			if(EVP.helpers.isDesktopOS()) {
				$('#'+klass.evp.container_id+'-video').remove();
			}
		}, 500);
	}
});