<?php
// This file can access $file, $file_settings and $widget
// You can assign things to $widget if you need to
// File-specific stuff goes in $widget->file_options

$uuid = escape(session_id(), true);

// Has this person already rated it?
$alreadyRated = false;
if(getRow("SELECT `uuid` FROM {$evp->options->prefix}ratings WHERE `uuid` = '{$uuid}' && `file_ref` = '{$file_ref}'")) $alreadyRated = true;

// What is the current rating?
$rating = $evp->statistics->getFeedbackRating($file_ref);
?>
EVP3.players.extend('EVP3.widgets.<?php echo $widget->slug; ?>', {
	'init': function(evp, file, widget, file_options, row) {
		this.evp = evp;
		this.row = row;
		this.widget = widget;
		this.file = file;
		this.file_options = file_options;
		this.build();
	},
	'deactivate': function(rating) {
		this.element.css({
			'cursor': 'default'
		}).data('rated', true);
		this.element.find('.evp-widget-feedback-item').unbind();
		this.element.find('.evp-widget-feedback-item-'+rating).css('background-position', '0px 0px');
		this.element.find('.evp-widget-feedback-item-'+rating).prevAll('div').css('background-position', '0px 0px');
	},
	'build': function() {
		var klass = this;
		
		var element = this.element = $('<div class="evp-widget evp-widget-<?php echo $widget->slug; ?>" id="evp-widget-<?php echo $widget->slug; ?>-<?php echo $widget_idx; ?>"></div>');
		
		element.css({
			'float': 'left',
			'background': 'url('+EVP3.settings.location+'/player/widgets/<?php echo $widget->slug; ?>/button.png?v=2)',
			'width': 130,
			'height': 26,
			'cursor': 'default',
			'padding': '6px 0 0 10px'
		});
		
		var n = $('<div class="evp-widget-feedback-item evp-widget-feedback-item-1">1</div><div class="evp-widget-feedback-item evp-widget-feedback-item-2">2</div><div class="evp-widget-feedback-item evp-widget-feedback-item-3">3</div><div class="evp-widget-feedback-item evp-widget-feedback-item-4">4</div><div class="evp-widget-feedback-item evp-widget-feedback-item-5">5</div>');
		
		n.css({
			'float': 'left',
			'margin': '0 5px 0 0',
			'cursor': 'default',
			'color': '#fff',
			'font-weight': 'bold',
			'text-align': 'center',
			'line-height': '20px',
			'width': '20px',
			'height': '20px',
			'background': 'url('+EVP3.settings.location+'/player/widgets/<?php echo $widget->slug; ?>/star.png?v=2) no-repeat 0 -40px',
			'font-size': '11px',
			'text-indent': '-99999px'
		});
		
		<?php if(!$alreadyRated) : ?>
		n.hover(function() {
			if(element.data('rated') == true) return false;
			$(this).css('background-position', '0px -20px');
			$(this).prevAll('div').css('background-position', '0px -20px');
		}, function() {
			if(element.data('rated') == true) return false;
			$(this).css('background-position', '0px -40px');
		});
		
		n.css('cursor', 'pointer');
	
		element.hover(function() {
			if(element.data('rated') == true) return false;
			element.find('.evp-widget-feedback-item').css('background-position', '0px -40px');
		}, function() {
			if(element.data('rated') == true) return false;
			element.find('.evp-widget-feedback-item').css('background-position', '0px -40px');
		});
		<?php endif; ?>
		
		n.appendTo(element);
		
		<?php if(!empty($rating)) : ?>
		// Restore the current rating
		element.find('.evp-widget-feedback-item-<?php echo $rating; ?>').css('background-position', '0px 0px');
		element.find('.evp-widget-feedback-item-<?php echo $rating; ?>').prevAll('div').css('background-position', '0px 0px');
		<?php endif; ?>
		
		n.click(function() {
			var rating = $(this).text();
			klass.event(rating);
		});
		
		element.appendTo(this.file.player['bar_row_'+this.row]);
	},
	'event': function(rating) {
		<?php if($alreadyRated) echo 'return false;'; ?>
		
		var klass = this;
		
		klass.element.data('rated', true);
		
		$.ajax('<?php echo url('player/widgets/feedback/rate.php'); ?>', {
			'complete': function() {
				klass.deactivate(rating);
			},
			'data': {'uuid': '<?php echo $uuid; ?>', 'rating': rating, 'file_ref': '<?php echo $file_ref; ?>'},
			'dataType': 'jsonp'
		});
	}
});