<?php
require('application.php');
require('application.bootstrap.php');

if(!$evp->options->audioSupport) die('Audio support is not enabled.');

$folder_ref = strip_tags($_GET['folder']);
if(is_numeric($folder_ref)) {
	$folder = $evp->getFolder($folder_ref);
} else {
	$folder_readable = escape(makeReadable($folder_ref), true);
	$folder_id = grab(getRow("SELECT `id` FROM {$evp->options->prefix}folders WHERE `name` = '{$folder_readable}'"), 'id');
	if(!empty($folder_id)) $folder = $evp->getFolder($folder_id);
}

if(!$folder) die('This folder could not be identified.');

// Get all the files
$allFiles = $evp->getFiles($folder->id);

if(empty($allFiles)) die('This podcast is completely empty.');

foreach($allFiles as $file) if($file->type == 'audio') $files[] = $file;

if(empty($files)) die('There are no valid audio files to display.');

//die(dump($files));

$main_description = 'A podcast from '.$evp->settings->site_name;
$main_image = '';
$main_keywords = '';

$i = 1;
$max = sizeof($files);
foreach($files as $idx => $file) {
	if($file->options['set_public'] != true) $evp->s3->aws->s3->set_object_acl($evp->settings->s3_bucket, $file->file_name, AmazonS3::ACL_PUBLIC);
	$evp->insertDataKey('options[set_public]', 'true', $file->file_id, 'file');
	
	if($i === $max && !empty($file->options['page-seo-description'])) $main_description = $file->options['page-seo-description'];
	if($i === $max && !empty($file->options['related_image'])) $main_image = $file->options['related_image'];
	if($i === $max && !empty($file->options['page-seo-keywords'])) $main_keywords = $file->options['page-seo-keywords'];
	
	$i++;
}

// Output an XML file
header('Content-type: text/xml');

echo '<?xml version="1.0" encoding="UTF-8"?>';
echo '<rss xmlns:itunes="http://www.itunes.com/dtds/podcast-1.0.dtd" version="2.0">';
echo '<channel>';
echo '<title>'.htmlentities($folder->name).'</title>';
echo '<description>'.htmlentities($main_description).'</description>';
echo '<link>'.$config['locations']['absolute'].'</link>';
echo '<copyright>'.('Copyright '.date('Y').'+').'</copyright>';
echo '<language>en-US</language>';
echo '<ttl>1440</ttl>'; // Lowest is 1440; 1 day

echo '<image>';
echo '<title>'.htmlentities($folder->name).'</title>';
echo '<url>'.$main_image.'</url>';
echo '<link>'.$config['locations']['absolute'].'</link>';
echo '</image>';

// Anything iTunes-specific
echo '<itunes:explicit>No</itunes:explicit>';
echo '<itunes:image href="'.$main_image.'" />';
echo '<itunes:category text="Business"><itunes:category text="Management &amp; Marketing"/></itunes:category>';
echo '<itunes:keywords>'.htmlentities($main_keywords).'</itunes:keywords>';

// This is the real fancy part
foreach($files as $file) {
	$location = $file->location;
	if($evp->s3 && $file->source == '2') $location = 'http://'.$evp->settings->s3_bucket.'.s3.amazonaws.com/'.rawurlencode($file->file_name);//$file->raw_location;
	echo '<item>';
	 echo '<title>'.htmlentities(pick($file->options['page-seo-title'], $file->name)).'</title>';
	 echo '<link>'.$file->page_url.'</link>';
	 echo '<description>'.htmlentities($file->options['page-seo-description']).'</description>';
	 echo '<enclosure url="'.$location.'" length="'.$file->size.'" type="audio/x-m4a"/>';
	 echo '<pubDate>'.gmdate('r', $file->time).'</pubDate>';
	 echo '<itunes:keywords>'.htmlentities(pick($file->options['page-seo-keywords'], $main_keywords)).'</itunes:keywords>';
	echo '</item>';
}

// And close the feed
echo '</channel>';
echo '</rss>';

?>
