<?php
include($config['paths']['base'].'/external/aws-sdk/sdk.class.php'); // Require the AWS SDK right now

class EVP extends Project {
	public static $defaults = array(
		'debug' => false,
		'audioSupport' => false,
		'supported_video_files' => array('mp4', 'm4v', 'flv'),
		'supported_audio_files' => array(),
		'project_name' => 'EasyVideoSuite',
		'project_version' => '1.4',
		'project_website' => 'http://easyvideosuite.com/',
		'project_affiliate_website' => 'http://%s.webactix.hop.clickbank.net/',
		'project_infuse' => 'https://easyvideosuite.com/infuse/',
		'player' => 'jwplayer-5.10',
		'skins' => array(
			'beelden' => array(
				'skin_height' => '30',
				'skin_audio_preview_extra' => '32',
				'chapter_bottom' => '55',
				'chapter_left' => '115',
				'chapter_right' => '167'
			),
			'bekle' => array(
				'skin_height' => '58',
				'chapter_bottom' => '55',
				'chapter_left' => '92',
				'chapter_right' => '90'
			),
			'chrome' => array(
				'skin_height' => '37',
				'chapter_bottom' => '55',
				'chapter_left' => '114',
				'chapter_right' => '180'
			),
			'facebook' => array(
				'skin_height' => '38',
				'chapter_bottom' => '50',
				'chapter_left' => '88',
				'chapter_right' => '158'
			),
			'fs40' => array(
				'skin_height' => '46',
				'skin_audio_preview_extra' => '18',
				'chapter_bottom' => '70',
				'chapter_left' => '117',
				'chapter_right' => '170'
			),
			'glow' => array(
				'skin_height' => '28',//'30',
				'chapter_bottom' => '45',
				'chapter_left' => '74',
				'chapter_right' => '94'
			),
			'grungetape' => array(
				'skin_height' => '64',
				'chapter_bottom' => '70',
				'chapter_left' => '117',
				'chapter_right' => '147'
			),
			'iskin' => array(
				'skin_height' => '30',
				'chapter_bottom' => '45',
				'chapter_left' => '101',
				'chapter_right' => '153'
			),
			'modieus' => array(
				'skin_height' => '31',
				'chapter_bottom' => '45',
				'chapter_left' => '69',
				'chapter_right' => '133'
			),
			'newtubedark' => array(
				'skin_height' => '29',
				'chapter_bottom' => '45',
				'chapter_left' => '232',
				'chapter_right' => '88'
			),
			'norden' => array(
				'skin_height' => '33',
				'chapter_bottom' => '49',
				'chapter_left' => '146',
				'chapter_right' => '187'
			),
			'playcasso' => array(
				'skin_height' => '60',
				'chapter_bottom' => '70',
				'chapter_left' => '90',
				'chapter_right' => '161'
			),
			'snel' => array(
				'skin_height' => '32',
				'chapter_bottom' => '45',
				'chapter_left' => '72',
				'chapter_right' => '163'
			),
			'stijl' => array(
				'skin_height' => '41',//'42',
				'chapter_bottom' => '55',
				'chapter_left' => '40',
				'chapter_right' => '73'
			),
			'unlimblue' => array(
				'skin_height' => '33',
				'chapter_bottom' => '45',
				'chapter_left' => '87',
				'chapter_right' => '164'
			),
			'whotube' => array(
				'skin_height' => '26',
				'skin_audio_preview_extra' => '18',
				'chapter_bottom' => '50',
				'chapter_left' => '111',
				'chapter_right' => '133'
			),
			'minima' => array(
				'skin_height' => '26',
				'skin_audio_preview_extra' => '18',
				'chapter_bottom' => '50',
				'chapter_left' => '39',
				'chapter_right' => '39'
			),
			'lulu' => array(
				'skin_height' => '26',
				'skin_audio_preview_extra' => '18',
				'chapter_bottom' => '50',
				'chapter_left' => '85',
				'chapter_right' => '184'
			),



			'evs' => array(
				'skin_height' => '33',
				'chapter_bottom' => '50',
				'chapter_left' => '78',
				'chapter_right' => '114'
			),
			'evs2' => array(
				'skin_height' => '38',
				'chapter_bottom' => '50',
				'chapter_left' => '88',
				'chapter_right' => '158'
			),
			'evs3' => array(
				'skin_height' => '57',
				'chapter_bottom' => '50',
				'chapter_left' => '88',
				'chapter_right' => '74'
			),
			'evs4' => array(
				'skin_height' => '28',
				'chapter_bottom' => '50',
				'chapter_left' => '48',
				'chapter_right' => '249'
			),
			'evs5' => array(
				'skin_height' => '38',
				'chapter_bottom' => '50',
				'chapter_left' => '88',
				'chapter_right' => '158'
			),
			'evs6' => array(
				'skin_height' => '57',
				'chapter_bottom' => '50',
				'chapter_left' => '71',
				'chapter_right' => '84'
			),
			'evs7' => array(
				'skin_height' => '63',
				'chapter_bottom' => '50',
				'chapter_left' => '88',
				'chapter_right' => '158'
			),
			'evs8' => array(
				'skin_height' => '40',
				'chapter_bottom' => '50',
				'chapter_left' => '97',
				'chapter_right' => '228'
			),
			'evs-m-1' => array(
				'skin_height' => '28',
				'chapter_bottom' => '50',
				'chapter_left' => '48',
				'chapter_right' => '249'
			),
		)
	);

	public function initialise($options = false) {
		$this->defaults = self::$defaults; // Due to us using a static var, we have to localise it too - for install etc
		$this->setOptions($options);
		$this->setSettings($this->options->prefix.'settings');

		if(empty($this->settings->currency)) query("INSERT INTO {$this->options->prefix}settings (`name`, `value`) VALUES ('currency', 'USD')");
		$this->options->currency_symbol = currencyCodeToSymbol($this->settings->currency);

		// Do we have audio support for this build?
		if($this->options->audioSupport === true) {
			$this->options->supported_audio_files = array('mp3', 'm4a');
			EVP_S3::$defaults['audioSupport'] = true;
			EVP_Local::$defaults['audioSupport'] = true;
		}

		// Config
		$config = Registry::retrieve('config');
		$config['misc']['theme'] = $this->settings->theme;
		$config['paths']['cacheDir'] = $config['paths']['base'].'/assets/cache';
		Registry::store('config', $config);

		// API
		if(class_exists('EVP_API')) {
			$this->api = new EVP_API();
		}

		// Stats
		if(class_exists('EVP_Statistics')) {
			$this->statistics = new EVP_Statistics(array('prefix' => $this->options->prefix));
		}

		// Make the affiliate website link
		if(!empty($this->settings->cb_affiliate_id)) {
			$this->options->project_affiliate_website = sprintf($this->options->project_affiliate_website, $this->settings->cb_affiliate_id);
		} else {
			$this->options->project_affiliate_website = $this->options->project_website;
		}

		if($this->settings->mod_rewrite == '0') $this->mod_rewrite = false;
		else $this->mod_rewrite = true;

		if($this->options->hosted == true) $this->mod_rewrite = true; // It's always on for hosted, of course

		// Local hosting?
		if($this->options->hosted !== true) { // Allows us to restrict later if we must
			$this->local = new EVP_Local();
		}

		// Do we have S3 info?
		if($this->settings->use_s3 && !empty($this->settings->s3_accesskey) && !empty($this->settings->s3_secretkey)) {
			$cloudfront_type = 'STD';
			if($this->settings->use_cloudfront == '1' && $this->settings->use_cloudfront_std != '1' && !empty($this->settings->cloudfront_distribution)) $cloudfront_type = 'RTMP';
			$this->s3 = new EVP_S3($this->settings->s3_accesskey, $this->settings->s3_secretkey, $this->settings->s3_bucket, array('type' => $cloudfront_type));

			if($this->settings->use_cloudfront == '1' && !empty($this->settings->cloudfront_distribution)) {
				$this->cloudfront = $this->s3;
			}

			if(empty($this->s3->bucket)) {
				$bucket = $this->s3->createBucket();
				if($bucket['success'] === true) {
					$this->updateSetting('s3_bucket', $bucket['bucket']);
					$this->s3->bucket = $bucket['bucket'];
				} else { // Their bucket couldn't be created. Let's remove their S3 info, and then take them to the error page
					$this->updateSetting('s3_secretkey', '');
					$this->updateSetting('s3_accesskey', '');
					$this->updateSetting('use_s3', '0');
					redirect('info.php', array('code' => 's3-defaultbucket', 'reason' => $bucket['reason']));//?code=s3-defaultbucket&message=');
				}
			}
		}

		// Let's perform some upgrades if we need it!
		if($this->options->hosted !== true) {
			if($this->settings->upgrade_evs1_1_survey != 1) { // Need to add the survey table
				$is_upgrade_page = false;
				if(stripos(currentUrl(), 'info.php') || stripos(currentUrl(), 'api.php')) $is_upgrade_page = true;

				if(!$is_upgrade_page) {
					redirect('info.php', array('code' => 'upgrade', 'script' => 'upgrade-1.1'));
				}
			}
		}
	}

	public function isCommercial() {
		return ($this->options->commercial === true);
	}

	public function getSplitTests($verifyFiles = false) {
		$split_tests = $this->getMySQLObjectGroup('split_tests', false, 'id', 'date_created', 'desc', false);
		if(empty($split_tests)) return false;
		foreach($split_tests as &$test) {
			$test->date_created = strtotime($test->date_created);
			if(!empty($test->date_ending)) $test->date_ending = strtotime($test->date_ending);
			$test->files = decode($test->files);
			if($verifyFiles === true && is_array($test->files) && !empty($test->files)) {
				foreach($test->files as $idx => $f) {
					if(!$this->getFile($f)) unset($test->files[$idx]);
				}
			}
			$test->file_count = sizeof($test->files);
		}
		return $split_tests;
	}

	public function getSplitTest($id, $verifyFiles = false) {
		$test = $this->getMySQLObject($id, 'split_tests', 'id', false);
		if(!$test) return false;
		$test->date_created = strtotime($test->date_created);
		if(!empty($test->date_ending)) $test->date_ending = strtotime($test->date_ending);
		$test->files = decode($test->files);
		if($verifyFiles === true && is_array($test->files) && !empty($test->files)) {
			foreach($test->files as $idx => $f) {
				if(!$this->getFile($f)) unset($test->files[$idx]);
			}
		}
		$test->file_count = sizeof($test->files);

		// Get the data for this split test
		$d = $this->getDataKey('*', 'splittest::'.$test->id, 'file');
		$test->options = $d->options;
		$test->page_widgets = $d->page_widgets;
		$test->data = $d->data;

		$test->source_mode = 'splittest';

		return $test;
	}

	public function splitEmbedCode($split, $container_id = false, $mode = 'js', $custom_settings = false) {
		if(!is_object($split)) $split = $this->getSplitTest($split);
		if(!$split) return false;

		if(empty($container_id)) $container_id = 'evp-'.randomStr();

		$custom_settings = ($custom_settings == false ? '' : $custom_settings);
		if(is_string($custom_settings)) $custom_settings = decode($custom_settings);
		if(!empty($custom_settings)) $custom_settings = json_encode($custom_settings);

		$code = '';

		switch($mode) {
			default:
				$args = array_empty(array('container' => $container_id));
				$url = $this->mod_rewrite ? url('player/'.$split->id.'/', $args) : url('player/', array_merge(array('id' => $split->id), $args));

				$code.= '<script type="text/javascript" src="'.$url.'"></script>';
				$code.= '<div id="'.$container_id.'" data-role="evp-splittest"'.(empty($custom_settings) ? '' : ' data-evp-settings=\''.$custom_settings.'\'').'></div>';
				break;
		}

		return $code;
	}

	public function getPlaylists($verifyFiles = false) {
		$playlists = $this->getMySQLObjectGroup('playlists', false, 'id', 'id', 'desc', false);
		if(empty($playlists)) return false;
		foreach($playlists as &$playlist) {
			$playlist->files = decode($playlist->files);
			$playlist->labels = decode($playlist->labels);
			$playlist->descriptions = decode($playlist->descriptions);
			if($verifyFiles === true && is_array($playlist->files) && !empty($playlist->files)) {
				foreach($playlist->files as $idx => $f) {
					if(!$this->getFile($f)) {
						unset($playlist->files[$idx]);
						unset($playlist->labels[$idx]);
						unset($playlist->descriptions[$idx]);
					}
				}
			}
			$playlist->file_count = sizeof($playlist->files);
		}
		return $playlists;
	}

	public function getPlaylist($id, $verifyFiles = false) {
		$playlist = $this->getMySQLObject($id, 'playlists', 'id', false);
		if(!$playlist) return false;
		$playlist->files = decode($playlist->files);
		$playlist->labels = decode($playlist->labels);
		$playlist->descriptions = decode($playlist->descriptions);
		if($verifyFiles === true && is_array($playlist->files) && !empty($playlist->files)) {
			foreach($playlist->files as $idx => $f) {
				if(!$this->getFile($f)) {
					unset($playlist->files[$idx]);
					unset($playlist->labels[$idx]);
					unset($playlist->descriptions[$idx]);
				}
			}
		}
		$playlist->file_count = sizeof($playlist->files);

		// Get the data for this playlist
		$d = $this->getDataKey('*', 'playlist::'.$playlist->id, 'file');
		$playlist->options = $d->options;
		$playlist->page_widgets = $d->page_widgets;
		$playlist->data = $d->data;

		$playlist->source_mode = 'playlist';

		return $playlist;
	}

	public function playlistEmbedCode($playlist, $container_id = false, $mode = 'js', $custom_settings = false) {
		if(!is_object($playlist)) $playlist = $this->getPlaylist($playlist);
		if(!$playlist) return false;

		if(empty($container_id)) $container_id = 'evp-'.randomStr();

		$custom_settings = ($custom_settings == false ? '' : $custom_settings);
		if(is_string($custom_settings)) $custom_settings = decode($custom_settings);
		if(!empty($custom_settings)) $custom_settings = json_encode($custom_settings);

		$code = '';

		switch($mode) {
			default:
				$args = array_empty(array('container' => $container_id));
				$url = $this->mod_rewrite ? url('player/playlist-'.$playlist->id.'/', $args) : url('player/', array_merge(array('id' => 'playlist-'.$playlist->id), $args));

				$code.= '<script type="text/javascript" src="'.$url.'"></script>';
				$code.= '<div id="'.$container_id.'" data-role="evp-playlist"'.(empty($custom_settings) ? '' : ' data-evp-settings=\''.$custom_settings.'\'').'></div>';
				break;
		}

		return $code;
	}

	public function primeFileCache($file_details = false) { // This loads all files from all sources and primes them, or, primes a specific file from S3
		$localfiles = array();
		$s3files = array();

		if(empty($file_details)) {
			if($this->local) $localfiles = $this->local->getFiles();
			if($this->s3) $s3files = $this->s3->getFiles();

			$files = array_merge((array)$localfiles, (array)$s3files);
		} else {
			if($file_details['source'] == 's3') {
				$file = $this->s3->loadFile($file_details['file_name']);

				if(!$file) {
					return $this->primeFileCache(); // Fall-back in case that fails for some reason
				}

				$files = $this->s3->getFiles(array($file));

			} else { // Look for local file
				//
			}
		}

		$this->iterateFilesToCache($files);

		return $this;
	}

	public function updateFileCache() { // This ONLY does existing values
		$files = getArray("SELECT `id`, `parent_id`, `child_type`, `file_name`, `name`, `location`, `size`, `time`, `extension`, `type`, `source` FROM {$this->options->prefix}files WHERE `parent_id` IS NULL");

		$this->iterateFilesToCache($files, false);

		return $this;
	}

	public function iterateFilesToCache($files, $insertFileObj = true) {
		if(empty($files)) return false;

		$default = false;

		foreach($files as $file) {
			$currentFile = $this->getFile($file->id);
			if(!$currentFile || empty($currentFile->data['page_seed'])) {
				// Do we need to get the default settings?
				if(!$default) {
					// There are files, so let's grab the default settings
					$default = $this->getFile('default');
					unset($default->metadata, $default->id);
				}

				// Let's copy over the default settings
				$options = new Object();
				$options->options = $default->options;
				$options->events = $default->events;
				$options->chapters = $default->chapters;
				$options->surveys = $default->surveys;
				$options->widgets = $default->widgets;
				$options->plugins = $default->plugins;
				$options->page_widgets = $default->page_widgets;

				// And then override anything, such as the page seed (Obviously unique)
				$l = strlen($file->extension);
				$page_seed = makeSeed(substr($file->file_name, 0, -$l));
				$file->data['page_seed'] = $page_seed;

				// Now let's check to see if there's any metadata
				$existing_data = $this->getDataKey('*', $file->id, 'file');

				// If the width has a value, and the height is set to be automatic.. make sure that happens here
				if(!empty($existing_data) && !empty($options->options['width']) && $options->options['preserveAspectRatio'] == true && !empty($existing_data->metadata) && !empty($existing_data->metadata['nativeWidth']) && !empty($existing_data->metadata['nativeHeight'])) {
					$original_width = $existing_data->metadata['nativeWidth'];
					$ratio = ($options->options['width'] / $original_width);
					$height = ceil($existing_data->metadata['nativeHeight'] * $ratio);
					$options->options['height'] = (string)$height;
				}

				// And insert!
				if($insertFileObj === true) $this->insertMySQLObject('files', $file);

				// And insert the options
				$this->api->files_setdata($file->id, $options);
			}
		}

		return $files;
	}

	public function getFiles($folder_id = false) {
		if(!empty($folder_id) || $folder_id == 0) {
			$files = $this->getMySQLObjectGroup('files', array('table' => 'folders_relationships', 'column' => 'folder_id', 'value' => $folder_id, 'match_column' => 'file_id'), 'id', 'time');
		} else {
			$files = $this->getMySQLObjectGroup('files', false, 'id', 'time');
		}
		if(!empty($files)) {
			foreach($files as $idx => $file) {

				if(!empty($file->parent_id)) unset($files[$idx]); // Remove any child videos; they must be processed by getMySQLObjectGroup unfortunately

				$file->page_url = $this->mod_rewrite ? url($file->data['page_seed'].'/', false) : url('/', array('seed' => $file->data['page_seed']));
				$file->prettyTime = gmdate('d/m/y', $file->time);
				$file->prettySize = formatRawSize($file->size);
				$file->prettyType = ucfirst($file->type);
				$file->prettySource = 'local';
				if($file->source == 2) $file->prettySource = 's3';
				elseif($file->source == 3) $file->prettySource = 'youtube';
				elseif($file->source == 4) $file->prettySource = 'remote';

				// Is it HD?
				$file->hd = false;
				if(!empty($file->metadata) && $file->metadata['nativeWidth'] >= 720) $file->hd = true;

				// Is there an intro on the default profile?
				$file->hasIntro = false;
				if(!empty($file->options['intro_video'])) $file->hasIntro = true;

				// Is there an outro on the default profile?
				$file->hasOutro = false;
				if(!empty($file->options['outro_video'])) $file->hasOutro = true;

				// Expose secure URLs instead of the raw ones, if needed
				$file->raw_location = $file->location;
				if($this->s3 && $file->source == '2') $file->location = $this->s3->getUrl($file->file_name);
			}
		}
	 return $files;
	}

	public function getFile($ref, $getData = true) {
		$parts = explode('::', $ref, 2);
		$id = $parts[0];
		$profile = $parts[1];

		if($id == 'default') { // Return literally the blank, default profile
			$file = new Object(array(
				'id' => 'default',
				'type' => 'video'
			));
			$file->metadata = array(
				'_blank' => ''
			);
			$file->events = $this->getProfileOptions('default', '', 'events');
			$file->chapters = $this->getProfileOptions('default', '', 'chapters');
			$file->surveys = $this->getProfileOptions('default', '', 'surveys');
			$file->options = $this->getProfileOptions('default', '', 'options');
			$file->widgets = $this->getProfileOptions('default', '', 'widgets');
			$file->plugins = $this->getProfileOptions('default', '', 'plugins');
			$file->page_widgets = $this->getProfileOptions('default', '', 'page_widgets');

			return $file;
		}

		$file = $this->getMySQLObject($id, 'files', 'id', $getData);

		if(!empty($file)) {
			$file->prettyTime = gmdate('d/m/y', $file->time);
			$file->prettySize = formatRawSize($file->size);
			$file->prettyType = ucfirst($file->type);
			$file->prettySource = 'local';
			if($file->source == 2) $file->prettySource = 's3';
			elseif($file->source == 3) $file->prettySource = 'youtube';
			elseif($file->source == 4) $file->prettySource = 'remote';

			// Is it HD?
			$file->hd = false;
			if(!empty($file->metadata) && $file->metadata['nativeWidth'] >= 720) $file->hd = true;

			// Is there an intro on the default profile?
			$file->hasIntro = false;
			if(!empty($file->options['intro_video'])) $file->hasIntro = true;

			// Expose secure URLs instead of the raw ones, if needed
			$file->raw_location = $file->location;
			if($this->s3 && $file->source == '2') $file->location = $this->s3->getUrl($file->file_name);

			$file->profile = $profile;

			// Get the correct page_seed for profiles too
			if(!empty($profile)) {
				$orig_page_seed = $file->data['page_seed'];
				$file->data['page_seed'] = grab(getRow("SELECT `value` FROM {$this->options->prefix}files_data WHERE `key` = 'data[page_seed]' && `file_id` = '{$ref}'"), 'value');
				if(empty($file->data['page_seed'])) {
					$file->data['page_seed'] = $orig_page_seed.'-'.$profile;
				}
			}

			$file->page_url = $this->mod_rewrite ? url($file->data['page_seed'].'/', false) : url('/', array('seed' => $file->data['page_seed']));
		}

	 return $file;
	}

	public function getFileDownloadURL($file) {
		$download_url = $file->location;
		$using_cf = false;
		if($file && $file->source == '2') {
			$uri = $file->file_name;
			$download_url = 'http://'.$this->settings->s3_bucket.'.s3.amazonaws.com/'.$uri;
			if($this->settings->use_cloudfront != '1') {
				$download_url = $this->s3->aws->s3->get_object_url($this->settings->s3_bucket, $file->file_name, '1 hour', array(
					'response' => array(
						'content-disposition' => 'attachment;filename='.urlencode($file->file_name)
					)
				));
			} else {
				$using_cf = true;
			}
		}
		return $download_url;
	}

	public function getProfiles($id, $includeDefault = false, $simpleArray = false) {
		$profiles = array();
		if($includeDefault === true) $profiles[] = array('name' => 'default', 'id' => $id);
		$pf = getArray("SELECT DISTINCT `file_id` FROM {$this->options->prefix}files_data WHERE `file_id` LIKE '{$id}::%'");
		if(empty($pf)) return $profiles;
		foreach($pf as $p) {
			if($simpleArray == true) { // if true, just return an array with the seed in
				$profiles[] = trim(str_replace($id.'::', '', $p->file_id));
			} else {
				$profiles[] = new Object(array(
					'name' => makeReadable(trim(str_replace($id.'::', '', $p->file_id))),
					'seed' => trim(str_replace($id.'::', '', $p->file_id)),
					'id' => $p->file_id
				));
			}
		}
		return $profiles;
	}

	public function getProfile($id, $profile) {
		$pf = getRow("SELECT `file_id` FROM {$this->options->prefix}files_data WHERE `file_id` = '{$id}::{$profile}'");
		if(!$pf) return false;
		$profile = new Object(array(
			'name' => makeReadable(trim(str_replace($id.'::', '', $pf->file_id))),
			'seed' => trim(str_replace($id.'::', '', $pf->file_id)),
			'id' => $pf->file_id
		));
		return $profile;
	}

	public function getProfileOptions($file_id, $profile = '', $type = 'options') { // Type can also be plugins or widgets
		$file_ref = $file_id;
		if(!empty($profile)) $file_ref.= "::{$profile}";
		$data = $this->getDataKey('*', $file_ref, 'file');
		if(empty($data)) return false;
		return $data->{$type};
	}

	public function getFolders($parent = false, $getChildren = false) {
		$parent_match = false;
		if(is_numeric($parent)) {
			$parent_match = array('table' => 'folders', 'column' => 'parent_id', 'value' => $parent, 'match_column' => 'id');
		}
		$folders = $this->getMySQLObjectGroup('folders', $parent_match, 'id', 'name', 'asc', false);
		if($getChildren === true && !empty($folders)) {
			foreach($folders as &$f) {
				$f->subfolders = $this->getFolders($f->id, true);
			}
		}
	 return $folders;
	}

	public function getFoldersAsTree($getUncategorised = false) {
		$folders = array();

		if($getUncategorised == true) {
			$total_files = grab(getRow("SELECT COUNT(`id`) AS total FROM {$this->options->prefix}files WHERE `parent_id` IS NULL"), 'total');
			$total_in_folders = grab(getRow("SELECT SUM(`file_count`) AS total FROM {$this->options->prefix}folders"), 'total');

			$folders[] = new Object(array(
				'id' => 0,
				'name' => 'Uncategorised',
				'file_count' => $total_files - $total_in_folders
			));
		}

		$tf = $this->getFolders(0); // Get the root folders

		$folders = array_merge($folders, $tf);

		if(!empty($folders)) {
			foreach($folders as &$f) {
				$f->subfolders = $this->getFolders($f->id, true);
				if($f->file_count < 0) $f->file_count = 0;
			}
		}

		return $folders;
	}

	public function getFolder($id) {
	  return $this->getMySQLObject($id, 'folders', 'id', false);
	}

	public function getSitemaps($getChildren = false) {
		$parent_match = false;
		if(is_numeric($parent)) {
			$parent_match = array('table' => 'folders', 'column' => 'parent_id', 'value' => $parent, 'match_column' => 'id');
		}
		$sitemaps = $this->getMySQLObjectGroup('sitemaps', $parent_match, 'id', 'id', 'desc');
		if($getChildren == true && !empty($sitemaps)) {
			foreach($sitemaps as &$sitemap) {
				if(!empty($sitemap->data['files'])) {
					$sitemap->contents = array();
					foreach($sitemap->data['files'] as $file_ref) {
						$sitemap->contents[$file_ref] = new Object(array(
							'url' => unescape($sitemap->data['url']->{$file_ref}),
							'title' => unescape($sitemap->data['title']->{$file_ref}, true),
							'description' => unescape($sitemap->data['description']->{$file_ref}, true)
						));
					}
				}
			}
		}
	  return $sitemaps;
	}

	public function getSitemap($id) {
		$sitemap = $this->getMySQLObject($id, 'sitemaps', 'id');

		if(!empty($sitemap->data['files'])) {
			$sitemap->contents = array();
			foreach($sitemap->data['files'] as $file_ref) {
				$sitemap->contents[$file_ref] = new Object(array(
					'url' => unescape($sitemap->data['url']->{$file_ref}),
					'title' => unescape($sitemap->data['title']->{$file_ref}, true),
					'description' => unescape($sitemap->data['description']->{$file_ref}, true)
				));
			}
		}

	  return $sitemap;
	}

	public function getThumbnailUrl($file, $idx = 0) {
		return str_replace('.'.$file->extension, '', $file->raw_location).'-thumbnail-'.$idx.'.jpg';
	}

	public function collateFileSettings($file, $profile = '') {
		if(!empty($profile) && $profile !== 'default') {
			$file->events = $this->getProfileOptions($file->id, $profile, 'events');
			$file->chapters = $this->getProfileOptions($file->id, $profile, 'chapters');
			$file->surveys = $this->getProfileOptions($file->id, $profile, 'surveys');
			$file->options = $this->getProfileOptions($file->id, $profile, 'options');
			$file->widgets = $this->getProfileOptions($file->id, $profile, 'widgets');
			$file->plugins = $this->getProfileOptions($file->id, $profile, 'plugins');
			$file->page_widgets = $this->getProfileOptions($file->id, $profile, 'page_widgets');
		}

		$settings = (object)array(
			'options' => $file->options,
			'events' => $file->events,
			'chapters' => $file->chapters,
			'surveys' => $file->surveys,
			'widgets' => $file->widgets,
			'page_widgets' => $file->page_widgets,
			'plugins' => $file->plugins,
			'metadata' => $file->metadata,
			'config' => array(
				'source' => $file->source,
				'prettySource' => $file->prettySource,
				'location' => $file->location
			),
			'file_ref' => (empty($profile) ? $file->id : $file->id.'::'.$profile),
			'file_id' => $file->id
		);

		if(empty($settings->options)) $settings->options = array();
		if(empty($settings->widgets)) $settings->widgets = array();
		if(empty($settings->plugins)) $settings->plugins = array();
		if(empty($settings->events)) $settings->events = array();
		if(empty($settings->chapters)) $settings->chapters = array();
		if(empty($settings->surveys)) $settings->surveys = array();
		if(empty($settings->page_widgets)) $settings->page_widgets = array();
		if(empty($settings->metadata)) $settings->metadata = false;

		$settings->options = $settings->options;
		$settings->events = $settings->events;
		$settings->chapters = $settings->chapters;
		$settings->surveys = $settings->surveys;
		$settings->page_widgets = $settings->page_widgets;
		$settings->plugins = $settings->plugins;
		$settings->widgets = $settings->widgets;

		$skin_to_use = pick($settings->options['skin'], 'minima');
		$thumbnail = str_replace('.'.$file->extension, '', $file->raw_location).'-thumbnail-0.jpg';

		$settings->options['skin_data'] = $this->options->skins[$skin_to_use];
		$settings->options['skin'] = $skin_to_use;

		// For audio files
		if($file->type == 'audio') {
			if(empty($settings->options['width'])) $settings->options['width'] = 640;
			if(empty($settings->options['height'])) $settings->options['height'] = 64;
		}

	//if(empty($settings->options['width'])) $settings->options['width'] = 640;
	//if(empty($settings->options['height'])) $settings->options['height'] = 360;
		if(empty($settings->options['bar_style'])) $settings->options['bar_style'] = 'none';
		if(empty($settings->options['related_image']) && !empty($file->thumbnail_count)) {
			$settings->options['related_image'] = $thumbnail;
			$settings->options['splash_width'] = 250;
			$settings->options['splash_height'] = 141;
		}
		if(empty($settings->options['related_image'])) $settings->options['related_image'] = url('player/images/no-image.png?v=1', false, true);
		if(empty($settings->options['watermark'])) $settings->options['watermark'] = url('player/images/no-image.png?v=1', false, true);

		// If there is no height set, and there is metadata, set the height automatically
		if(!empty($settings->options['width']) && $settings->options['preserveAspectRatio'] == true && !empty($file->metadata) && !empty($file->metadata['nativeWidth'])) {
			$ratio = $settings->options['width'] / $file->metadata['nativeWidth'];
			$height = ceil($file->metadata['nativeHeight'] * $ratio);
			$settings->options['height'] = $height;
		}

		// Ok, what if there is no default? We should apply the native dimensions
		if(empty($settings->options['width']) && empty($settings->options['height']) && !empty($file->metadata) && !empty($file->metadata['nativeWidth']) && !empty($file->metadata['nativeHeight'])) {
			$settings->options['width'] = $file->metadata['nativeWidth'];
			$settings->options['height'] = $file->metadata['nativeHeight'];
		}

		// If there is no metadata, just set a default size
		if(empty($settings->options['width'])) $settings->options['width'] = 640;
		if(empty($settings->options['height'])) $settings->options['height'] = 360;

		// SSL support for related images and watermarks
		$config = Registry::retrieve('config');
		if($config['locations']['protocol'] == 'https') {
			$settings->options['related_image'] = str_replace('http://', 'https://', $settings->options['related_image']);
			$settings->options['watermark'] = str_replace('http://', 'https://', $settings->options['watermark']);
		}

		return $settings;
	}

	public function salesTrackingImage($file_ref, $product_name, $product_price, $isUpsell = false, $mode = 'convert') {
		$cd = array('n' => $product_name, 'p' => $product_price);
		if($isUpsell === true) $cd['u'] = 1;
		return "<img src=\"".url('api.php', array(
			'file_ref' => $file_ref,
			'method' => 'public-statistics-'.$mode,
			'c' => base64_encode(json_encode($cd)), // Cryptic because it's public
			'responseType' => 'blank-image'
		))."\" width=\"1\" height=\"1\" style=\"visibility:hidden;\" />";
	}

	public function buildElementCode($elements, $file_ref) {
		if(empty($elements)) return false;

		$code = array();

		foreach($elements as $name => $opt) {
			if($opt['data']['event-mode'] != 'external') continue;
			$code[$name] = "<div id=\"evp-element-{$file_ref}-".makeSeed($opt['name'])."\" class=\"evp-element\" style=\"display:none;\">{$opt['code']}</div>";
		}

		return $code;
	}

	public function videoEmbedCode($file, $definition = 'sd', $profile = 'default', $container_id = false, $mode = 'js', $custom_settings = false, $custom_url_args = array()) {
		if(!is_object($file)) $file = $this->getFile($file);
		if(!$file) return false;

		if(empty($container_id)) $container_id = 'evp-'.randomStr();

		$custom_settings = ($custom_settings == false ? '' : $custom_settings);
		if(is_string($custom_settings)) $custom_settings = decode($custom_settings);
		if(!empty($custom_settings)) $custom_settings = json_encode($custom_settings);

		$code = '';

		switch($mode) {
			case 'iframe':
				$file_settings = $this->collateFileSettings($file, $profile);
				$url = $this->videoEmbedURL($file, $definition, $profile, $container_id, $mode, $custom_settings);
				$code.= '<iframe src="'.$url.'" width="'.($file_settings->options['width'] + 20).'" height="'.($file_settings->options['height'] + 20).'" frameborder="0" allowfullscreen></iframe>';
				break;
			case 'url':
				$config = Registry::retrieve('config');
				$file_settings = $this->collateFileSettings($file, $profile);

				$location = ($file->source == 2 ? $this->s3->getUrl($file->file_name, 315569260) : $file->location);

				$code = url("{$config['locations']['absolute']}player/assets/jwplayer-5.10/player.swf", array(
					'file' => $location,
					'autostart' => true,//$file_settings->options['auto_play'],
					'stretching' => 'fill',
					'playlist.position' => 'none',
					'controlbar.position' => 'over',
				//'logo.file' => url('/player/images/player-logo.png'),
				//'logo.link' => 'http://easyvideosuite.com/',
				//'logo.margin' => 10,
					'abouttext' => 'EasyVideoSuite',
					'aboutlink' => $this->options->project_affiliate_website,//'http://easyvideosuite.com/',
					'skin' => url("player/assets/jwplayer-5.10/skins/{$file_settings->options['skin']}/{$file_settings->options['skin']}.xml")
				));
				break;
			case 'object':
				$file_settings = $this->collateFileSettings($file, $profile);

				if($this->s3 && $file->source == '2') $file->location = $this->s3->getUrl($file->file_name, 315569260);

				$cposition = 'over';
				if($file_settings->options['player_controls'] == 'hide') $cposition = 'hide';

				$flash_options = array(
					'file' => $file->location,
					'autostart' => $file_settings->options['auto_play'],
					'stretching' => 'fill',
					'playlist.position' => 'none',
					'controlbar.position' => $cposition,
					'abouttext' => 'EasyVideoSuite',
					'aboutlink' => $this->options->project_affiliate_website,//'http://easyvideosuite.com/',
					'skin' => url("player/assets/jwplayer-5.10/skins/{$file_settings->options['skin']}/{$file_settings->options['skin']}.xml")
				);

				if(!empty($file_settings->options['related_image']) && $file_settings->options['related_image_mode'] == 'splash') {
					$flash_options['image'] = $file_settings->options['related_image'];
				}

				$flashvars = http_build_query($flash_options);

				$code.= "<object id=\"{$container_id}\" width=\"{$file_settings->options['width']}\" height=\"{$file_settings->options['height']}\" data=\"".url('player/assets/jwplayer-5.10/player.swf')."\" type=\"application/x-shockwave-flash\" wmode=\"transparent\">";
				$code.= "<param name=\"flashvars\" value=\"".$flashvars."\" />";
				$code.= "<param name=\"movie\" value=\"".url('player/assets/jwplayer-5.10/player.swf')."\" />";
				$code.= "<param name=\"wmode\" value=\"transparent\" />";
				$code.= "</object>";
				break;
			case 'responsive':
				$custom_url_args = array_merge(array('responsive' => 1, 'autoResponsive' => 1), (array)$custom_url_args);
				$code.= '<script type="text/javascript" src="'.$this->videoEmbedURL($file, $definition, $profile, $container_id, $mode, false, $custom_url_args).'"></script>';
				$code.= '<div id="'.$container_id.'" data-role="evp-video" data-evp-id="'.$file->id.'"'.(empty($custom_settings) ? '' : ' data-evp-settings=\''.$custom_settings.'\'').'></div>';
				break;
			default:
				$code.= '<script type="text/javascript" src="'.$this->videoEmbedURL($file, $definition, $profile, $container_id, $mode, false, $custom_url_args).'"></script>';
				$code.= '<div id="'.$container_id.'" data-role="evp-video" data-evp-id="'.$file->id.'"'.(empty($custom_settings) ? '' : ' data-evp-settings=\''.$custom_settings.'\'').'></div>';
				break;
		}

		return $code;
	}

	public function videoEmbedURL($file, $definition = 'sd', $profile = 'default', $container_id = false, $mode = 'js', $custom_settings = false, $custom_url_args = array()) {
		if(!is_object($file)) $file = $this->getFile($file);
		if(!$file) return false;

		if(empty($container_id)) $container_id = 'evp-'.randomStr();

		$custom_settings = ($custom_settings == false ? '' : $custom_settings);
		if(is_string($custom_settings)) $custom_settings = decode($custom_settings);
		if(!empty($custom_settings)) $custom_settings = json_encode($custom_settings);

		switch($mode) {
			case 'iframe':
				$args = array_empty(array('profile' => $profile, 'mode' => 'iframe'));
				$url = $this->mod_rewrite ? url($file->id.'/', $args) : url('/', array_merge(array('seed' => $file->id), $args));
				if(!empty($custom_settings)) {
					$url.= '&settings='.$custom_settings;
				}
				break;
			default:
				$args = array_empty(array_merge($custom_url_args, array('profile' => $profile, 'container' => $container_id)));
				$url = $this->mod_rewrite ? url('player/'.$file->id.'/', $args) : url('player/', array_merge(array('id' => $file->id), $args));
				break;
		}

		return $url;
	}

	public function loadFromDirectory() { // Requires at least the directory name, like plugins/widgets/etc
		$args = func_get_args();
		$directory = array_shift($args);
		$config = Registry::retrieve('config');
		$resource_type = singular(ucfirst(camelcase(str_replace('-', ' ', (basename($directory.'/'))))));
		$resources = getDirectories($config['paths']['base'].'/'.$directory.'/', false);
		if(empty($resources)) return false;
		$resourceList = array();
		foreach($resources as $resource) {
			$name = basename($resource);
			$call = "get{$resource_type}";
			$arguments = $args;
			array_unshift($arguments, $name);
			if(!method_exists($this, $call)) {
				$call = 'genericGet';
				array_push($arguments, $directory);
			}
			$resource = call_user_func_array(array($this, $call), $arguments);
			$resourceList[] = $resource;
		}
		sort($resourceList);
		$resourceList = array_reverse($resourceList);
		return $resourceList;
	}

	public function genericGet($name, $directory) { // Directory is sent to this one only
		$config = Registry::retrieve('config');

		$obj = new Object(array(
			'name' => makeReadable($name),
			'slug' => makeSeed($name),
			'path' => $config['paths']['base'].'/'.$directory.$name,
			'location' => $config['locations']['absolute'].$directory.$name,
		));

		if(file_exists($obj->path.'/config.txt')) {
			$c = decode(file_get_contents($obj->path.'/config.txt'));
			if($c !== false) $obj->config = new Object($c);
		}

		return $obj;
	}

	public function getWidgets() {
		return $this->loadFromDirectory('player/widgets');
	}

	public function getWidget($name, $file = false, $widget_idx = false) {
		$config = Registry::retrieve('config');
		if(empty($name) || !is_dir($config['paths']['base'].'/player/widgets/'.$name.'/')) return false;

		$widget = new Object(array(
			'name' => makeReadable($name),
			'slug' => makeSeed($name),
			'path' => $config['paths']['base'].'/player/widgets/'.$name,
			'location' => $config['locations']['absolute'].'player/widgets/'.$name.'/'
		));

		if(file_exists($widget->path.'/config.txt')) {
			$c = decode(file_get_contents($widget->path.'/config.txt'));
			if($c !== false) $widget->config = new Object($c);
		}

		$widget->config = merge($widget->config, new Object(array(
			'author' => array(
				'name' => 'Unknown',
				'website' => 'http://webactix.com',
				'version' => '1.0'
			),
			'general' => array(),
			'configWidth' => 450,
			'configHeight' => 200
		)));

		if(!empty($widget->config->name)) $widget->name = $widget->config->name;

		if($file !== false && is_object($file) && $widget_idx !== false) {
			$file_settings = pick($file_settings, $this->collateFileSettings($file, $file->profile));
			if(!empty($file_settings->widgets[$widget_idx])) {
				$widget->file_options = $file_settings->widgets[$widget_idx];
			}
		}
		return $widget;
	}

	public function getPlugins() {
		return $this->loadFromDirectory('player/plugins');
	}

	public function getPlugin($name, $file = false) {
		$config = Registry::retrieve('config');
		if(empty($name) || !is_dir($config['paths']['base'].'/player/plugins/'.$name.'/')) return false;

		$plugin = new Object(array(
			'name' => makeReadable($name),
			'slug' => makeSeed($name),
			'path' => $config['paths']['base'].'/player/plugins/'.$name,
			'location' => $config['locations']['absolute'].'player/plugins/'.$name.'/'
		));

		if(file_exists($plugin->path.'/config.txt')) {
			$c = decode(file_get_contents($plugin->path.'/config.txt'));
			if($c !== false) $plugin->config = new Object($c);
		}

		$plugin->config = merge($plugin->config, new Object(array(
			'author' => array(
				'name' => 'Unknown',
				'website' => 'http://webactix.com',
				'version' => '1.0'
			),
			'general' => array()
		)));

		if(!empty($plugin->config->name)) $plugin->name = $plugin->config->name;

		// File info
		if($file !== false && is_object($file)) {
			$file_settings = $this->collateFileSettings($file, $file->profile);
			if(!empty($file->plugins) && !empty($file_settings->options)) {
				foreach($file->plugins as $p) {
					if($p->slug == $plugin->slug) {
						$plugin->file_options = $p;
					}
				}
			}
		}
		return $plugin;
	}

	public function getSkins() {
		return $this->loadFromDirectory('player/assets/'.$this->options->player.'/skins');
	}

	public function getSkin($name) {
		$player = $this->options->player;
		$config = Registry::retrieve('config');
		if(empty($name) || !is_dir($config['paths']['base'].'/player/assets/'.$player.'/skins/'.$name.'/')) return false;

		$theme = new Object(array(
			'name' => $name,
			'slug' => makeSeed($name),
			'path' => $config['paths']['base'].'/player/assets/'.$player.'/skins/'.$name,
			'location' => $config['locations']['absolute'].'player/assets/'.$player.'/skins/'.$name.'/'
		));

		$t = before('-', $name);
		$theme->type = $t;

		if(file_exists($theme->path.'/config.txt')) {
			$c = decode(file_get_contents($theme->path.'/config.txt'));
			if($c !== false) $theme->config = new Object($c);
		}

		$theme->config = merge(new Object(array(
			'author' => array(
				'name' => 'Unknown',
				'website' => 'http://webactix.com',
				'version' => '1.0'
			),
			'general' => array()
		)), $theme->config);

		if(!isset($theme->config->general->screenshot)) $theme->config->general->screenshot = $theme->location.$theme->name.'.png';
		else $theme->config->general->screenshot = $theme->location.$theme->config->general->screenshot;

		$theme->basic = new Object(array(
			'name' => $theme->name,
			'slug' => $theme->slug,
			'screenshot' => $theme->config->general->screenshot
		));

		return $theme;
	}

	public function getShadows() {
		return $this->loadFromDirectory('player/shadows');
	}

	public function getShadow($name) {
		$config = Registry::retrieve('config');
		if(empty($name) || !is_dir($config['paths']['base'].'/player/shadows/'.$name.'/')) return false;

		$theme = new Object(array(
			'name' => makeReadable($name),
			'slug' => makeSeed($name),
			'path' => $config['paths']['base'].'/player/shadows/'.$name,
			'location' => $config['locations']['absolute'].'player/shadows/'.$name.'/'
		));

		$theme->config = merge(new Object(array(
			'author' => array(
				'name' => 'Unknown',
				'website' => 'http://webactix.com',
				'version' => '1.0'
			),
			'general' => array()
		)), $theme->config);


		$theme->basic = new Object(array(
			'name' => $theme->name,
			'slug' => $theme->slug
		));

		return $theme;
	}

	public function getFrames() {
		return $this->loadFromDirectory('player/frames');
	}

	public function getFrame($name) {
		$config = Registry::retrieve('config');
		if(!is_dir($config['paths']['base'].'/player/frames/'.$name.'/')) return false;

		$frame = new Object(array(
			'name' => makeReadable($name),
			'slug' => makeSeed($name),
			'path' => $config['paths']['base'].'/player/frames/'.$name,
			'location' => $config['locations']['absolute'].'player/frames/'.$name.'/'
		));

		if(file_exists($frame->path.'/config.txt')) {
			$c = decode(file_get_contents($frame->path.'/config.txt'));
			if($c !== false) $frame->config = new Object($c);
		}

		$frame->config = merge($frame->config, new Object(array(
			'author' => array(
				'name' => 'Unknown',
				'website' => 'http://webactix.com',
				'version' => '1.0'
			)
		)));

		if(!empty($frame->config->name)) $frame->name = $frame->config->name;

		if(!empty($frame->config)) $frame->order = $frame->config->order;

		return $frame;
	}

	public function getPageThemes() {
		return $this->loadFromDirectory('themes/3.0/assets/themes');
	}

	public function getPageTheme($name) {
		$config = Registry::retrieve('config');
		if(empty($name) || !is_dir($config['paths']['base'].'/themes/3.0/assets/themes/'.$name.'/')) return false;

		$pageTheme = new Object(array(
			'name' => makeReadable($name),
			'slug' => makeSeed($name),
			'path' => $config['paths']['base'].'/themes/3.0/assets/themes/'.$name,
			'location' => $config['locations']['absolute'].'themes/3.0/assets/themes/'.$name.'/'
		));

		if(file_exists($pageTheme->path.'/config.txt')) {
			$c = decode(file_get_contents($pageTheme->path.'/config.txt'));
			if($c !== false) $pageTheme->config = new Object($c);
		}

		$pageTheme->config = merge($pageTheme->config, new Object(array(
			'author' => array(
				'name' => 'Unknown',
				'website' => 'http://webactix.com',
				'version' => '1.0'
			),
			'allow_content_area' => false
		)));

		if(!empty($pageTheme->config->name)) $pageTheme->name = $pageTheme->config->name;

		return $pageTheme;
	}

	public function getPageWidgets() {
		return $this->loadFromDirectory('themes/3.0/assets/page-widgets');
	}

	public function getPageWidget($name, $file = false, $pageWidget_idx = false, $file_settings = false) {
		$config = Registry::retrieve('config');
		if(empty($name) || !is_dir($config['paths']['base'].'/themes/3.0/assets/page-widgets/'.$name.'/')) return false;

		$pageWidget = new Object(array(
			'name' => makeReadable($name),
			'slug' => makeSeed($name),
			'path' => $config['paths']['base'].'/themes/3.0/assets/page-widgets/'.$name,
			'location' => $config['locations']['absolute'].'themes/3.0/assets/page-widgets/'.$name.'/'
		));

		if(file_exists($pageWidget->path.'/config.txt')) {
			$c = decode(file_get_contents($pageWidget->path.'/config.txt'));
			if($c !== false) $pageWidget->config = new Object($c);
		}

		$pageWidget->config = merge($pageWidget->config, new Object(array(
			'author' => array(
				'name' => 'Unknown',
				'website' => 'http://webactix.com',
				'version' => '1.0'
			),
			'general' => array(),
			'configWidth' => 450,
			'configHeight' => 200
		)));

		if(!empty($pageWidget->config->name)) $pageWidget->name = $pageWidget->config->name;

		// File info
		if($file !== false && is_object($file) && $pageWidget_idx !== false) {
			$file_settings = pick($file_settings, $this->collateFileSettings($file, $file->profile));
			if(!empty($file_settings->page_widgets[$pageWidget_idx])) {//$file_settings->page_widgets[$pageWidget_idx]['slug'] == $pageWidget->slug) {
				$pageWidget->file_options = $file_settings->page_widgets[$pageWidget_idx];
			}
		}

		return $pageWidget;
	}
}

class EVP_Local extends Project {
	public static $defaults = array(
		'supported_video_files' => array('mp4', 'm4v', 'flv'),
		'supported_audio_files' => array(),
		'legacy_video_files' => array('avi', 'mov'),
		'legacy_audio_files' => array(),
		'source' => 'assets/videos/'
	);

	public function initialise($options = false) {
		$this->defaults = self::$defaults;
		$this->setOptions($options);

		// Do we have audio support for this build?
		if($this->options->audioSupport === true) {
			$this->options->supported_audio_files = array('mp3', 'm4a');
		}

		$this->options->supported_files = array_merge($this->options->supported_video_files, $this->options->supported_audio_files);//, $this->options->legacy_video_files, $this->options->legacy_audio_files);
	}

	public function prepareUpload() { // Try to set some sane values and return the maximum file size
		$config = Registry::retrieve('config');
		@ini_set('upload_max_filesize', '50M');
		@ini_set('post_max_size', '55M');

		$maxSize = formatToBytes(ini_get('upload_max_filesize'));
		$maxP = formatToBytes(ini_get('post_max_size'));
		if($maxP < $maxSize) $maxSize = $maxP;

		return $maxSize;
	}

	public function canUpload() { // Can we upload to the directory?
		$config = Registry::retrieve('config');
		return is_writable($config['paths']['base'].DIRECTORY_SEPARATOR.$this->options->source);
	}

	public function getFiles() { // Will get supported files from the local hosting
		$config = Registry::retrieve('config');
		$local_files = getFiles($config['paths']['base'].DIRECTORY_SEPARATOR.$this->options->source);
		if(empty($local_files)) return array();
		$files = array();
		foreach($local_files as $file_location) {
			$extension = getExtension($file_location);
			if(!in_array($extension, $this->options->supported_files)) continue;
			$file_full = basename($file_location);
			$file_name = basename($file_location, '.'.$extension);
			$type = ((in_array($extension, $this->options->supported_audio_files) || in_array($extension, $this->options->legacy_audio_files)) ? 'audio' : 'video');
			$file = new Object(array(
				'id' => base64_encode($file_full),
				'name' => $file_name, // This is the 'name_mask' equivalent - can be changed etc
				'file_name' => $file_full, // This is always going to be the name of the original file name
				'time' => filemtime($file_location),
				'size' => filesize($file_location),
				'extension' => $extension,
				'type' => $type,
				'location' => url($config['locations']['absolute'].$this->options->source.$file_full),
				'source' => 1
			));
			$files[] = $file;
		}
		return $files;
	}
}

class EVP_S3 extends Project {
	public static $defaults = array(
		'supported_video_files' => array('mp4', 'm4v', 'flv'),
		'supported_audio_files' => array(),
		'legacy_video_files' => array('avi', 'mov'),
		'legacy_audio_files' => array(),
		'type' => 'STD' // Can also be RTMP
	);

	public function initialise($access_key, $secret_key, $bucket, $options = false) {
		$this->defaults = self::$defaults;
		$this->setOptions($options);

		// Do we have audio support for this build?
		if($this->options->audioSupport === true) {
			$this->options->supported_audio_files = array('mp3', 'm4a');
		}

		$this->options->supported_files = array_merge($this->options->supported_video_files, $this->options->supported_audio_files);//, $this->options->legacy_video_files, $this->options->legacy_audio_files);

		CFCredentials::set(array(
			'development' => array(
				'key' => $access_key,
				'secret' => $secret_key,
				'default_cache_config' => '',
				'certificate_authority' => false
			),
			'@default' => 'development'
		));

		$this->aws = new Object();
		$this->aws->s3 = new AmazonS3();
		$this->aws->cloudfront = new AmazonCloudFront();
		$this->bucket = $bucket;
	}

	public function loadFilesRaw() {
		$opt = array();
		$objects = array();

		do {
			$list = $this->aws->s3->list_objects($this->bucket, $opt);

			$body = (array) $list->body;

			if(is_array($body['Contents'])) $objects = array_merge($objects, $body['Contents']);

			$opt = array_merge($opt, array(
				'marker' => (isset($body['Contents']) && is_array($body['Contents'])) ?
					((string) end($body['Contents'])->Key) :
					((string) $list->body->Contents->Key)
			));
		} while ((string) $list->body->IsTruncated === 'true');

		return $objects;
	}

	public function loadFiles() {
		$files = array();
		$objects = $this->loadFilesRaw();

		if(empty($objects)) return false;

		foreach($objects as $raw) {
			$obj = array(
				'name' => (string)$raw->Key,
				'time' => strtotime((string)$raw->LastModified),
				'size' => (int)$raw->Size,
				'hash' => substr((string)$raw->ETag, 1, -1),
			);

			$files[] = $obj;
		}

		return $files;
	}

	public function loadFile($file_name) {
		$raw = $this->aws->s3->get_object_metadata($this->bucket, $file_name);

		if(!$raw) return false;

		$obj = array(
			'name' => (string)$raw['Key'],
			'time' => strtotime((string)$raw['LastModified']),
			'size' => (int)$raw['Size'],
			'hash' => substr((string)$raw['ETag'], 1, -1)
		);

		return $obj;
	}

	public function getFiles($s3_files = false) { // Will grab supported files from S3
	//if(!$s3_files) $s3_files = $this->remote->getBucket($this->bucket);
		if(!$s3_files) $s3_files = $this->loadFiles();

		if(empty($s3_files)) return array();
		$files = array();
		foreach($s3_files as $data) {
			$extension = getExtension($data['name']);
			if(!in_array($extension, $this->options->supported_files)) continue;
			$type = ((in_array($extension, $this->options->supported_audio_files) || in_array($extension, $this->options->legacy_audio_files)) ? 'audio' : 'video');
			$file_full = basename($data['name']);
			$file_name = basename($data['name'], '.'.$extension);
			$file = new Object(array(
				'id' => base64_encode($data['name']),
				'name' => $file_name, // This is the 'name_mask' equivalent - can be changed etc
				'file_name' => $file_full, // This is always going to be the name of the original file name
				'time' => $data['time'],
				'size' => $data['size'],
				'extension' => $extension,
				'type' => $type,
				'location' => url("http://{$this->bucket}.s3.amazonaws.com/{$data['name']}"),
				'source' => 2,
			));
			$files[] = $file;
		}
		return $files;
	}

	public function getUrl($file_name, $lifetime = 259200) {//86400) {
		return $this->aws->s3->get_object_url($this->bucket, $file_name, gmtime() + $lifetime, array(
			'https' => !empty($_SERVER['HTTPS'])
		));
	}

	public function createBucket($region = false) {
		$config = Registry::retrieve('config');
		$bucket_prefix = 'evp3-';
		$bucket = $bucket_prefix.uniqid().'-'.md5($_SERVER['HTTP_HOST']);

		if(!$region) $region = AmazonS3::REGION_US_E1;

		$response = $this->aws->s3->create_bucket($bucket, $region, AmazonS3::ACL_AUTH_READ);
		if($response->isOK()) {
			$this->aws->s3->create_object($bucket, 'crossdomain.xml', array(
				'fileUpload' => $config['paths']['base'].'/assets/crossdomain.xml',
				'acl' => AmazonS3::ACL_PUBLIC
			));
			return array('success' => true, 'bucket' => $bucket);
		}

		return array('success' => false, 'reason' => (string)$response->body->Message.'. You have '.(string)$response->body->CurrentNumberOfBuckets.' and you are allowed '.(string)$response->body->AllowedNumberOfBuckets.'.');
	}
}

EVP::$defaults['hosted'] = false;
EVP::$defaults['commercial'] = true;
EVP::$defaults['newrelic'] = (extension_loaded('newrelic') && EVP::$defaults['hosted'] === true);

if(EVP::$defaults['newrelic']) newrelic_set_appname('EasyVideoSuite');
?>
