<?php
class EVP_Statistics extends Project {
	public $defaults = array(
		'cache_user_data' => 604800, // 1 week
		'cache_user_data_limit' => '1000'
	);

	public $get_cache = array();

	public function initialise($options = false) {
		$this->setOptions($options);
	//$size = grab(getRow("SELECT COUNT(`ip`) AS total FROM {$this->options->prefix}cache_users"), 'total');
	//if($size >= $this->options->cache_user_data_limit) query("TRUNCATE TABLE {$this->options->prefix}cache_users");
	}

	// Has $ip clicked the $seed link $within seconds?
	public function hasClicked($id, $ip, $within = 3600) {
		$id = escape($id, true);
		$ip = escape($ip, true);
		// Now let's try and select the info
		$now = gmdate('Y-m-d H:i:s');
		$yes = getRow("SELECT `time` FROM {$this->options->prefix}track_total_starts WHERE `ip` = '{$ip}' && `id` = '{$id}' && TIME_TO_SEC(TIMEDIFF('{$now}', time)) <= '{$within}' LIMIT 1");
		return $yes;
	}

	public function get($seed) {
		if(empty($this->get_cache[$seed])) {
			$item = Registry::get('EVP')->getFile($seed);
			if(!$item) return false;
			$this->get_cache[$seed] = $item;
		} else {
			$item = $this->get_cache[$seed];
		}
		return $item;
	}

	public function getFeedbackRating($file_ref) {
		$file_ref = escape($file_ref, true);
		if(empty($file_ref)) return false;

		$rating = 0;
		$ratings = getArray("SELECT `rating` FROM {$this->options->prefix}ratings WHERE `file_ref` = '{$file_ref}'");

		if(!empty($ratings)) {
			$ratings = flattenByKey($ratings, 'rating');
			$total_ratings = sizeof($ratings);
			$total_rate = array_sum($ratings);
			$rating = ceil($total_rate / $total_ratings);
		}

		return $rating;
	}

	public function track($type = 'start', $player_time = 0, $file_ref, $user, $referrer = '', $uuid = false, $platform = false) {
		// We need to locate the root of this referrer
		if(!empty($referrer)) {
			$referrer = @parse_url($referrer, PHP_URL_HOST);
		} else {
			$referrer = '';
		}
		$now = gmdate('Y-m-d H:i:s');
		$player_time = ceil(escape($player_time, true));

		switch($type) {
			case 'start':
			case 'complete':
				$month = gmdate('F');
				$day = gmdate('l');
				$hour = gmdate('G');
				$country = $user->country_name;

				// Put them in the totals table
				query("INSERT INTO {$this->options->prefix}track_total_{$type}s (`file_ref`, `uuid`, `ip`, `month`, `day`, `hour`, `time`, `country` ".($type == 'complete' ? ', `referrer`' : '').") VALUES ('{$file_ref}', '{$uuid}', '{$user->ip}', '{$month}', '{$day}', '{$hour}', '{$now}', '{$country}' ".($type == 'complete' ? ', \''.$referrer.'\'' : '').")");

				// Find out if this uuid has been tracked for this video already
			//$existing = getRow("SELECT `uuid` FROM {$this->options->prefix}track_unique_{$type}s WHERE `file_ref` = '{$file_ref}' && `uuid` = '{$uuid}'");

				// If they have NOT, add 'em in
			//if(empty($existing)) query("INSERT INTO {$this->options->prefix}track_unique_{$type}s (`file_ref`, `uuid`, `month`, `day`, `hour`, `time`, `country`) VALUES ('{$file_ref}', '{$uuid}', '{$month}', '{$day}', '{$hour}', '{$now}', '{$country}')");

				// And now, let's increase the static totals inside track_static
				$static = getRow("SELECT `id`, `starts`, `completes`, `start_platform_desktop`, `start_platform_ios`, `start_platform_ios-legacy`, `start_platform_android`, `start_platform_msie`, `start_platform_webkit`, `start_platform_opera`, `start_platform_firefox` FROM {$this->options->prefix}track_static WHERE `file_ref` = '{$file_ref}'");

				if(empty($static)) { // Nothing has been tracked for this before, so let's insert the row

					if($type == 'start') {
						if(!empty($platform) && in_array($platform, array('desktop', 'ios', 'ios-legacy', 'android', 'desktop-msie', 'desktop-webkit', 'desktop-opera', 'desktop-firefox'))) {
							$start_type = 'start_platform_'.str_replace('desktop-', '', $platform);
						} else {
							$start_type = 'start_platform_desktop';
						}

						query("INSERT INTO {$this->options->prefix}track_static (`file_ref`, `starts`, `completes`, `{$start_type}`) VALUES ('{$file_ref}', '".($type == 'start' ? 1 : 0)."', '".($type == 'complete' ? 1 : 0)."', '1')");

					} else {
						query("INSERT INTO {$this->options->prefix}track_static (`file_ref`, `starts`, `completes`) VALUES ('{$file_ref}', '".($type == 'start' ? 1 : 0)."', '".($type == 'complete' ? 1 : 0)."')");
					}
				} else { // Good; let's update these rows
					$static->starts += ($type == 'start' ? 1 : 0);
					$static->completes += ($type == 'complete' ? 1 : 0);

					if($type == 'start') {
						if(!empty($platform) && in_array($platform, array('desktop', 'ios', 'ios-legacy', 'android', 'desktop-msie', 'desktop-webkit', 'desktop-opera', 'desktop-firefox'))) {
							$static->{'start_platform_'.str_replace('desktop-', '', $platform)} += 1;
						} else {
							$static->start_platform_desktop += 1;
						}
					}

					$query = "UPDATE {$this->options->prefix}track_static SET ";
					foreach($static as $key => $value) {
						if($key == 'id') continue; // Skip this one
						if(empty($value)) $value = 0;
						$query.= "`{$key}` = '{$value}', ";
					}

					$query = rtrim($query, ", ")." WHERE `id` = '{$static->id}' LIMIT 1";

					query($query);
				}

				break;
			case 'progress':
			//$existing = getRow("SELECT `uuid` FROM {$this->options->prefix}track_progression WHERE `file_ref` = '{$file_ref}' && `uuid` = '{$uuid}' && `player_time` = '{$player_time}'");
			//if(!$existing) query("INSERT INTO {$this->options->prefix}track_progression (`file_ref`, `uuid`, `ip`, `player_time`, `time`) VALUES ('{$file_ref}', '{$uuid}', '{$user->ip}', '{$player_time}', '{$now}')");
				query("INSERT INTO {$this->options->prefix}track_progression (`file_ref`, `uuid`, `ip`, `player_time`, `time`) VALUES ('{$file_ref}', '{$uuid}', '{$user->ip}', '{$player_time}', '{$now}')");
				break;
		}

		$this->fireEvent('onTrack', array($type, $file_ref, $user, $referrer));
		return $this;
	}

	public function averageDropOff($file_ref, $where_string = '') { // $where_string can be like "`country` = 'US'"
		$video = $this->get($file_ref);
		if(!$video) return false;
		$progress = getArray("SELECT `uuid`, MAX(`player_time`) AS highest_progress FROM {$this->options->prefix}track_progression WHERE `file_ref` = '{$file_ref}' GROUP BY `uuid`");
		if(empty($progress)) return false;
		$total = 0;
		$hits = sizeof($progress);
		foreach($progress as $i) {
			$total += $i->highest_progress;
		}
		$interval = ($video->metadata['duration'] / 10);
		$avg = ($total / $hits) * $interval;
		if($avg > $video->metadata['duration']) $avg = $video->metadata['duration'];

		// Let's work out if they all complete it too
		$unique_completes = getRow("SELECT `unique_completes` FROM {$this->options->prefix}track_static WHERE `file_ref` = '{$file_ref}'");
		if(empty($unique_completes)) return $avg;

		if(($avg + $interval) >= $video->metadata['duration']) $avg = $video->metadata['duration'];

		return $avg;
	}

	public function getMostRecentStart($file_id) {
		if(!is_object($file_id)) $file = $this->get($file_id);
		else $file = $file_id;
		if(!$file) return false;

		$recent = getRow("SELECT `file_ref`, `uuid`, `time`, `ip`, `country` FROM {$this->options->prefix}track_total_starts WHERE `file_ref` = '{$file_id}' && `country` != 'Unknown' ORDER BY `time` DESC LIMIT 1");

		return $recent;
	}

	public function getMostRecentComplete($file_id) {
		if(!is_object($file_id)) $file = $this->get($file_id);
		else $file = $file_id;
		if(!$file) return false;

		$recent = getRow("SELECT `file_ref`, `uuid`, `time`, `ip`, `country` FROM {$this->options->prefix}track_total_starts WHERE `file_ref` = '{$file_id}' && `country` != 'Unknown' ORDER BY `time` DESC LIMIT 1");

		return $recent;
	}

	public function getStats($file_ref) {
		$video = $this->get($file_ref);
		if(!$video) return false;

		$evp = Registry::get('EVP');

		$stats = new Object();

		// Grab the static numbers for this video
		$stats->static = getRow("SELECT `starts`, `completes`, `unique_starts`, `unique_completes`, `start_platform_desktop`, `start_platform_ios`, `start_platform_ios-legacy`, `start_platform_android`, `start_platform_msie`, `start_platform_webkit`, `start_platform_opera`, `start_platform_firefox` FROM {$this->options->prefix}track_static WHERE `file_ref` = '{$file_ref}'");

		// Let's grab any ratings
		$stats->static->rating = $this->getFeedbackRating($file_ref);

		// Handle comments
		$stats->comments = new stdClass;
		$stats->comments->raw = getArray("SELECT `id`, `parent_id`, `isOperator`, `date`, `name`, `email`, `body` FROM {$this->options->prefix}comments WHERE `file_ref` = '{$file_ref}'");
		if(!empty($stats->comments->raw)) {
			$stats->comments->total = sizeof($stats->comments->raw);
			$commenters = array();
			$today = array();
			$today_floor = gmdate('Y-m-d 00:00:00');
			$today_ceil = gmdate('Y-m-d 23:59:59');
			foreach($stats->comments->raw as $comment) {
				$commenters[] = $comment->email;
				if($comment->date >= $today_floor && $comment->date <= $today_ceil) $today[] = $comment;
			}
			$stats->comments->commenters = sizeof(array_unique($commenters));
			$stats->comments->today = sizeof($today);
		}

		// Handle surveys
		$stats->surveys = array();
		$results = getArray("SELECT `survey_name`, `question_idx`, `answer_idx`, COUNT(answer_idx) AS total FROM {$this->options->prefix}surveys WHERE `file_ref` = '{$file_ref}' GROUP BY `answer_idx`, `question_idx`, `survey_name` ORDER BY `question_idx` DESC, `answer_idx` ASC");
	//$results = getArray("SELECT `survey_name`, `question_idx`, `answer_idx`, COUNT(answer_idx) AS `total` FROM {$this->options->prefix}surveys WHERE `file_ref` = '{$file_ref}' GROUP BY `answer_idx`");
	//$results = getArray("SELECT `uuid`, `date`, `survey_name`, `question_idx`, `answer_idx` FROM {$this->options->prefix}surveys WHERE `file_ref` = '{$file_ref}'");
		if(!empty($results)) {
			foreach($results as $r) {
				$stats->surveys[$r->survey_name][$r->question_idx][$r->answer_idx] = $r->total;
			}
		}
		$stats->surveys = new Object($stats->surveys);

		// Now let's get the info for the country breakdowns
		$stats->geo = new stdClass;
		$geo_starts = getArray("SELECT COUNT(`ip`) as total, `country` FROM {$this->options->prefix}track_total_starts WHERE `file_ref` = '{$file_ref}' GROUP BY `country` ORDER BY total DESC");
		$geo_completes = getArray("SELECT COUNT(`ip`) as total, `country` FROM {$this->options->prefix}track_total_completes WHERE `file_ref` = '{$file_ref}' GROUP BY `country` ORDER BY total DESC");
		$stats->geo->starts = array();
		$stats->geo->completes = array();
		if(!empty($geo_starts)) {
			foreach($geo_starts as &$x) {
				$x->country = utf8_encode($x->country);
				$stats->geo->starts[$x->country] = $x->total;
			}
		}
		if(!empty($geo_completes)) {
			foreach($geo_completes as &$x) {
				$x->country = utf8_encode($x->country);
				$stats->geo->completes[$x->country] = $x->total;
			}
		}

		// Grab the referrer information
		$stats->referrers = array();
		$referrers = getArray("SELECT COUNT(`ip`) AS total, `referrer` FROM {$this->options->prefix}track_total_completes WHERE `file_ref` = '{$file_ref}' GROUP BY `referrer`");
		if(!empty($referrers)) foreach($referrers as $r) if(!empty($r->referrer)) $stats->referrers[$r->referrer] = $r->total;

		// Let's get the completed plays, grouped by month, then day, then hour - this is easy
		$stats->date = array();
		$date_completes_day = getArray("SELECT COUNT(`ip`) as total, `day` FROM {$this->options->prefix}track_total_completes WHERE `file_ref` = '{$file_ref}' GROUP BY `day`");
		if(!empty($date_completes_day)) {
		//foreach($date_completes_month as $idx => $x) $stats->date['completes']['months'][$x->month] = $x->total;
			foreach($date_completes_day as $idx => $x) $stats->date['completes']['days'][$x->day] = $x->total;
		}
		if(!$evp->options->hosted) {
			$date_completes_month = getArray("SELECT COUNT(`ip`) as total, `month` FROM {$this->options->prefix}track_total_completes WHERE `file_ref` = '{$file_ref}' GROUP BY `month`");
			if(!empty($date_completes_month)) {
				foreach($date_completes_month as $idx => $x) $stats->date['completes']['months'][$x->month] = $x->total;
			}
		}

		// Now let's get the progression data throughout this video - this will be interesting to do efficiently
		$stats->progression = array();
		$progression = getArray("SELECT COUNT(`uuid`) AS hits, `player_time` FROM {$this->options->prefix}track_progression WHERE `file_ref` = '{$file_ref}' GROUP BY `player_time`");
		if(!empty($progression)) foreach($progression as $p) $stats->progression[$p->player_time] = $p->hits;

		// Now this is a special case - get the starts and completes for the past X days
		$earliest = gmdate('Y-m-d 00:00:00', strtotime('-14 days')); // The start of the day, 2 week ago
		$startData = getArray("SELECT COUNT(`ip`) AS total, DATE_FORMAT(`time`, '%Y-%m-%d') AS date FROM {$this->options->prefix}track_total_starts WHERE `file_ref` = '{$file_ref}' && `time` >= '{$earliest}' GROUP BY date");
		$completionData = getArray("SELECT COUNT(`ip`) AS total, DATE_FORMAT(`time`, '%Y-%m-%d') AS date FROM {$this->options->prefix}track_total_completes WHERE `file_ref` = '{$file_ref}' && `time` >= '{$earliest}' GROUP BY date");
		$saleData = getArray("SELECT COUNT(`ip`) AS total, DATE_FORMAT(`date`, '%Y-%m-%d') AS output_date FROM {$this->options->prefix}conversions WHERE `file_id` = '{$file_ref}' && `converted` = '1' && `date` >= '{$earliest}' GROUP BY output_date");
		if(!empty($completionData) || !empty($startData)) {
			$indexedData = array();
			if(!empty($completionData)) {
				foreach($completionData as $i) $indexedData[$i->date]['completes'] = $i->total;
			}
			if(!empty($startData)) {
				foreach($startData as $i) $indexedData[$i->date]['starts'] = $i->total;
			}
			if(!empty($saleData)) {
				foreach($saleData as $i) $indexedData[$i->output_date]['sales'] = $i->total; // Slightly different format!
			}
			$stats->recent = $indexedData;
		} else {
			$stats->recent = array();
		}

		//
		//
		// Conversion information under here
		//
		//

		$stats->total_sales = (int)grab(getRow("SELECT COUNT(converted) AS total FROM {$this->options->prefix}conversions WHERE `file_id` = '{$file_ref}' && `converted` = '1'"), 'total');
		$stats->total_conversions = (int)grab(getRow("SELECT COUNT(converted) AS total FROM {$this->options->prefix}conversions WHERE `file_id` = '{$file_ref}' && `converted` = '1' && `upsell` != '1'"), 'total');
		$stats->total_income = grab(getRow("SELECT SUM(price) AS total FROM {$this->options->prefix}conversions WHERE `file_id` = '{$file_ref}' && `converted` = '1'"), 'total');
		$stats->total_conversion_income = grab(getRow("SELECT SUM(price) AS total FROM {$this->options->prefix}conversions WHERE `file_id` = '{$file_ref}' && `converted` = '1' && `upsell` != '1'"), 'total');

		$stats->conversions = (int)$stats->total_conversions;
		$stats->conversion_income = $stats->total_conversion_income;

		$stats->upsells = (int)$stats->total_sales - $stats->total_conversions;
		$stats->upsell_income = $stats->total_income - $stats->total_conversion_income;

		$products = getArray("SELECT `name`, SUM(`price`) AS income, COUNT(id) AS sales, `upsell` FROM {$this->options->prefix}conversions WHERE `file_id` = '{$file_ref}' && `converted` = '1' GROUP BY name");
		$stats->products = $products;

		$this->fireEvent('onGetStats', array($stats, $video));
		return $stats;
	}

	public function getStaticStats($file_ref) {
		$video = $this->get($file_ref);
		if(!$video) return false;

		// Grab the static numbers for this video
		$static = getRow("SELECT `starts`, `completes`, `start_platform_desktop`, `start_platform_ios`, `start_platform_ios-legacy`, `start_platform_android`, `start_platform_msie`, `start_platform_webkit`, `start_platform_opera`, `start_platform_firefox` FROM {$this->options->prefix}track_static WHERE `file_ref` = '{$file_ref}'");

		return $static;
	}

	public function getUserData($ip) {

		if(strpos($ip, ':') !== false) { // Cannot geo-locate IPv6 addresses
			$user = new Object(array(
				'ip' => $ip,
				'country_code' => 'Unknown',
				'country_name' => 'Unknown'
			));
			$this->fireEvent('onGetUserData', array($user));
			return $user;
		}

		// Do we have a recent cache of this ip?
		$cached = getRow("SELECT `data` FROM {$this->options->prefix}cache_users WHERE `ip` = '{$ip}'");
		if(!empty($cached)) {
			$user = decode(unescape($cached->data, true));
		} else {
			$user = new Object(array(
				'ip' => $ip,
				'country_code' => 'Unknown',
				'country_name' => 'Unknown'
			));

			$request = new Request_Curl(array(
				'url' => 'http://www.telize.com/geoip/'.$ip,
				'method' => 'get',
				'timeout' => 3
			));

			$data = $request->send();

			if(!empty($data)) {
				$data = trim($data);
				$data = json_decode($data);

				if(is_object($data) && empty($data->code)) {
					$user->country_code = (empty($data->country_code) || strtolower($data->country_code) == 'xx' ? 'Unknown' : $data->country_code);
					$user->country_name = (empty($data->country) || strtolower($data->country) == '(private address)' || strtolower($data->country) == '(unknown country?)' ? 'Unknown' : $data->country);

					$user->country_name = ucwords(strtolower($user->country_name));

				} else {
					$this->fireEvent('onWebActixGeoError', array($data->statusMessage, $key));
				}
			}
			$now = gmdate('Y-m-d H:i:s');
			$user_enc = escape(encode($user), true);
			query("INSERT INTO {$this->options->prefix}cache_users (`cached`, `ip`, `data`) VALUES ('{$now}', '{$ip}', '{$user_enc}')");
		}

		$user = new Object($user);
		$this->fireEvent('onGetUserData', array($user));
		return $user;
	}
}

?>
