<?php
require('application.php');

if(empty($config['evp'])) {
	header("Location: install/index.php");
	exit;
}

require('application.bootstrap.php');
$page = new Page('signin.php', 'master.php', array('theme' => $evp->settings->theme, 'version' => $evp->options->project_version));
$page->title(array(pick($evp->settings->site_name, $evp->options->project_name), 'Sign in'));

$page->meta('viewport', 'user-scalable=no,width=device-width');
$page->js($config['locations']['themeDir'].'../../admin/themes/3.0/scripts/libraries/moobutton.js');

// Are we handling a reset?
if($_REQUEST['mode'] == 'reset') {
	$email = escape(trim($_REQUEST['email']), true);
	$xs = Registry::get('UserManager', 0);
	$yes = getRow("SELECT `id`, `username` FROM {$xs->options->prefix}users WHERE `username` = '{$email}'");
	if($yes) {
		$password = randomStr(8, 'alpha');
		$username = $yes->username;
		query("UPDATE {$xs->options->prefix}users SET `password` = SHA1('{$password}') WHERE `id` = '{$yes->id}'");
		$message = "<p>Your password for {$evp->settings->site_name} has been reset.</p><p>Your username is: {$username}<br />Your new password is: {$password}</p><p>Please <a href=\"{$config['locations']['absolute']}admin/\">click this link</a> to sign in.</p>";
		if($evp->settings->disable_password_email !== '1' || stripos($username, '@') === false) { // If email is disabled or this isn't an email-based username
			ob_start();
			// Let's merge the email config in..
			$s = $evp->settings;
			if(!empty($s->smtp_host) && !empty($s->smtp_port) && !empty($s->smtp_username) && !empty($s->smtp_password)) {
				$c = Registry::retrieve('config');
				$c['smtp'] = array(
				'host' => $evp->settings->smtp_host,
				'port' => $evp->settings->smtp_port,
				'username' => $evp->settings->smtp_username,
				'password' => $evp->settings->smtp_password,
				'security' => ($port == 465)
				);
				Registry::store('config', $c);
			}
			$username = strtolower($username);
			$sent = sendEmail(array($username, $username), 'support@easyvideosuite.com', "{$evp->settings->site_name}: Password reset", $message);
			ob_end_clean();
		} else { // Fake a fake send so that it triggers the FTP mechanism..
			$sent = false;
		}
		if(!$sent && !$evp->options->hosted) { // Didn't send AND not hosted
			$rdm = date('Y-m-d-H-i-s');
			$password_file = $config['paths']['base'].DIRECTORY_SEPARATOR.'assets'.DIRECTORY_SEPARATOR.'cache'.DIRECTORY_SEPARATOR.'00-password-reset-'.$rdm.'.php';
			$password_content = "<?php\n/*\n  Your password has been reset\n  You can sign in here: {$config['locations']['absolute']}\n  Your username is: {$username}\n  Your password is: {$password}\n  It was reset at ".date('d/m/Y H:i:s')." by ".getRemoteIP()."\n*/\n?>\n\n<p><strong>Please go into your FTP program or file manager to view this file rather than trying through a web browser!</strong></p>\n";
			$written = @file_put_contents($password_file, $password_content);
			if($written) {
				$page->set('resetmsg', 'Your new password <strong>could not</strong> be emailed to you, so for security reasons, we have saved it to your website.<br />Please look in your FTP and look in the following folder for the file:<br /><br />'.$password_file.'<br /><br /><strong>You will need to open this .php file in a text editor such as Notepad</strong> - do not try to view it in your web browser.');
			} else {
				$page->set('resetmsg', 'Your new password <strong>could not</strong> be emailed to you, nor could it be saved to your website. You will need to contact our support desk and explain the problem and ask them to reset your password for security reasons. They will need your FTP host, username and password.');
			}
		//$page->set('resetmsg', "Your new password could <strong>not</strong> be emailed to you so please make sure you sign in NOW!.<br /><br />Your username is {$username} and your password is <strong>{$password}</strong>. Please make sure that you sign in above. You can reset your password to something more memorable from the Settings page once you are in.");
		} elseif(!$sent && $evp->options->commercial) { // Didn't send AND is hosted
			$page->set('resetmsg', 'Unfortunately your new password could not be emailed to you. Please contact our support desk and tell us the subdomain of your installation and they can reset your password for you manually. This is for security reasons and should only happen rarely. We apologise for the inconvenience.');
		} else {
			$page->set('resetmsg', "Your new details have been sent to your email address: {$username}. You can reset your password to something more memorable from the Settings page once you have signed in.");
		}
		$page->set('resetmsgtype', 'success');
	} else {
		$page->set('resetmsg', "There isn't a user with the email address '{$email}'. Please try a different email address, or if you need your password resetting manually, contact our support with your web hosting control panel details.");
		$page->set('resetmsgtype', 'error');
	}
}

// We we handling a login?
if(!empty($_REQUEST['username']) && !empty($_REQUEST['password'])) {

	// On a sign-in attempt, let's see if the .htaccess files both exist
	// If they don't exist, and it's self-hosted, disable mod_rewrite here
	if($evp->options->hosted === false) {
		if(!file_exists($config['paths']['base'].'/.htaccess') || !file_exists($config['paths']['base'].'/player/.htaccess')) {
			$evp->updateSetting('mod_rewrite', 0);
		}
	}

	if($xs->signIn($_REQUEST['username'], $_REQUEST['password'])) {
		// Great! We'll get redirected below!
	} else {
		$page->set('failedLogin', true);
	}
}

// Are we already logged in?
if(!$xs->isGuest()) {
	$pass = pick(base64_decode(urldecode($_REQUEST['return'])), url('admin/', false, true));

	// If this is hosted, and you don't have S3 details, go back to the installer
	if($evp->options->hosted == true && ($evp->settings->us3_s3_setup_unfinished == '1' || empty($evp->settings->s3_accesskey) || empty($evp->settings->s3_secretkey) || empty($evp->settings->s3_bucket))) {
		$pass = url('https://evsuite.com/v3/index-signin.php', array(
			'subdomain' => $config['locations']['subdomain'],
			'username' => $xs->userData->username,
			'password' => $xs->userData->password
		));
	}

	redirect($pass);
}

setcookie('evp_infuse', '', time() - 3600, '/');

// Special things for this page
$page->addEvent('onTemplateMerge', 'onTemplateMerge');
echo $page->parse();
?>
