<?php
$form_id = 'evp-'.randomStr(5);

/*
// For uploading images
$bucket = $evp->settings->s3_bucket;
$accessKeyId = $evp->settings->s3_accesskey;
$secret = $evp->settings->s3_secretkey;

// prepare policy
$policy = base64_encode(json_encode(array(
	'expiration' => date('Y-m-d\TH:i:s.000\Z', strtotime('+1 day')),  
	'conditions' => array(
		array('bucket' => $bucket),
		array('acl' => 'public-read'),
		array('starts-with', '$key', ''),
		// http://docs.amazonwebservices.com/AmazonS3/latest/dev/HTTPPOSTFlash.html
		array('success_action_status' => '201'),
		// Plupload internally adds name field, so we need to mention it here
		array('starts-with', '$name', ''), 	
		// http://docs.amazonwebservices.com/AmazonS3/latest/dev/HTTPPOSTFlash.html
		array('starts-with', '$Filename', ''), 
	)
)));

// sign policy
$signature = base64_encode(hash_hmac('sha1', $policy, $secret, true));

// seed for the image
$image_seed = makeSeed($file->name).'-';
*/

if(!$evp->s3 && !$evp->local) {
	die('<p>You do not have Amazon S3 configured, nor can you upload files to your server. This means that unfortunately you cannot upload an image! Please enable one of these to allow this functionality.</p>');
}

// Upload stuff
if($evp->s3) {
	$bucket = $evp->settings->s3_bucket;
	$accessKeyId = $evp->settings->s3_accesskey;
	$secret = $evp->settings->s3_secretkey;
	
	$upload_url = "http://{$bucket}.s3.amazonaws.com/";
	$upload_path = $upload_url;
	
	// prepare policy
	$policy = base64_encode(json_encode(array(
		'expiration' => date('Y-m-d\TH:i:s.000\Z', strtotime('+1 day')),  
		'conditions' => array(
			array('bucket' => $bucket),
			array('acl' => 'public-read'),
			array('starts-with', '$key', ''),
			array('success_action_status' => '201'),
			array('starts-with', '$name', ''),
			array('starts-with', '$Filename', ''), 
		)
	)));
	
	// sign policy
	$signature = base64_encode(hash_hmac('sha1', $policy, $secret, true));
} else {
	$upload_url = url('admin/xhr.upload.php');
	$upload_path = url('assets/videos/');
	$policy = '';
	$signature = '';
}

// seed for the image
$file_image_seed = makeSeed($file->name).'-page-widget-';

$config = Registry::retrieve('config');
?>
<style type="text/css">
#<?php echo $form_id; ?>-preview img { max-width: 310px; max-height: 250px; }
</style>
<form id="<?php echo $form_id; ?>" class="styled" method="post" action="<?php echo url('themes/3.0/assets/page-widgets/load.php', array('widget' => $pageWidget_slug, 'file_ref' => $file_reference, 'widget_idx' => $pageWidget_idx, 'widget_file' => 'save.php', 'source_mode' => $source_mode)); ?>">

	<div class="" style="width:220px;">
		<div class="setting-group descend" id="<?php echo $form_id; ?>-select-wrap">
			<input class="" id="<?php echo $form_id; ?>-select" data-behavior="Button" type="button" data-button-width="130" data-button-type="action" value="Select the image" />
		</div>
		
		<div id="<?php echo $form_id; ?>-uploader"></div>
	</div>
	
	<div class="" id="<?php echo $form_id; ?>-preview"></div>
	
	<input type="hidden" name="src" id="<?php echo $form_id; ?>-src" value="<?php echo $pageWidget->file_options['src']; ?>" /> 
	
	<div class="setting-group descend align-left margin-right">
		<label>URL? (Optional)</label>
		<input type="text" id="<?php echo $form_id; ?>-href" value="<?php echo $pageWidget->file_options['href']; ?>" name="href" style="width:144px;" />
	</div>
	
	<div class="setting-group descend align-left margin-right">
		<label>Width</label>
		<input type="number" id="<?php echo $form_id; ?>-width" value="<?php echo $pageWidget->file_options['width']; ?>" name="width" style="width:50px;" />
	</div>
	
	<div class="setting-group descend align-left">
		<label>Height</label>
		<input type="number" id="<?php echo $form_id; ?>-height" value="<?php echo $pageWidget->file_options['height']; ?>" name="height" style="width:50px;" />
	</div>
	
	<div class="setting-group clear" id="<?php echo $form_id; ?>-save">
		<input id="<?php echo $form_id; ?>-submit" type="submit" value="Save" data-behavior="Button" data-button-width="100" data-button-type="action" class="clear align-right" />
	</div>
</form>
<script type="text/javascript">
(function() {
	var form = $('<?php echo $form_id; ?>');
	var submit_button = $('<?php echo $form_id; ?>-submit');
	var preview = $('<?php echo $form_id; ?>-preview');
	
	var build_preview = function(src) {
		if(!src) {
			if(!(Browser.Engine.trident == true && Browser.version <= 8)) {
				$('<?php echo $form_id; ?>-width').set('disabled', true);
				$('<?php echo $form_id; ?>-height').set('disabled', true);
			}
			preview.dissolve();
			return;
		}
		
		preview.reveal();
		
		var img = preview.getElement('img') || new Element('img').inject(preview);
		
		var r = new Date().getTime();
		document.id(preview).spin().getElement('img').set('src', src+'?v='+r).addEvent('load', function() {
			document.id(preview).unspin();
		});
	}
	
	build_preview('<?php echo $pageWidget->file_options['src']; ?>');
	
	(function($) {
		var uploader = new plupload.Uploader({
			'runtimes': 'flash',
			'browse_button': '<?php echo $form_id; ?>-select',
			'container': '<?php echo $form_id; ?>-select-wrap',
			'max_file_size': '10mb',
			'file_data_name': 'file',
			'url': '<?php echo $upload_url; ?>',
			'filters': [
				{'title': "Images", 'extensions': "jpg,gif,png,jpeg"}
			],
			'flash_swf_url': '<?php echo $config['locations']['absolute'].$config['locations']['folder_name'].'/themes/'.$evp->settings->theme.'/'; ?>scripts/libraries/plupload/plupload.flash.swf',//'<?php echo $config['locations']['themeDir']; ?>scripts/libraries/plupload/plupload.flash.swf',
			'multipart': true,
			'multipart_params': {
				'key': '<?php echo $file_image_seed; ?>${filename}',
				'Filename': '<?php echo $file_image_seed; ?>${filename}',
				'acl': 'public-read',
				'success_action_status': '201',
				'AWSAccessKeyId' : '<?php echo $evp->settings->s3_accesskey; ?>',		
				'policy': '<?php echo $policy; ?>',
				'signature': '<?php echo $signature; ?>'
			}
		});
		
		(function() {
			uploader.init();
		}).delay(750);
		
		uploader.bind('Init', function() {
			clearInterval(window['evp-image-uploader-<?php echo $form_id; ?>']);
		});
	
		uploader.bind('FilesAdded', function(up, files) {
			document.id('<?php echo $form_id; ?>-save').spin();
			up.refresh(); // Reposition Flash/Silverlight
			(function() {
				up.start();
			}).delay(500);
		});
	
		uploader.bind('Error', function(up, err) {
			if(typeof console != 'undefined') {
				console.error(err.message);
				console.log(err, uploader);
			}
			
			if(err.message == 'Init error.') {
				window['evp-image-uploader-<?php echo $form_id; ?>'] = setTimeout(function() {
					uploader.init();
				}, 200);
			} else {
				alert(err.message);
				document.id('<?php echo $form_id; ?>-save').unspin();
				up.refresh(); // Reposition Flash/Silverlight
			}
		});
	
		uploader.bind('FileUploaded', function(up, file) {
			// Get the image
			var location = '<?php echo $upload_path;//url('assets/uploads/'); ?>';
			
			var ext = file.name.split('.').pop();
			var file_name = file.name;//base64_encode(file.name)+'.'+ext;
			file_name = '<?php echo $file_image_seed; ?>'+file_name;
			var file_location = location+file_name;
			
			// Update the src
			document.id('<?php echo $form_id; ?>-save').unspin();
			document.id('<?php echo $form_id; ?>-src').set('value', file_location);
			
			// Update preview
			build_preview(file_location);
			
			// Update the dimensions
			preview.getElement('img').addEvent('load', function() {
				var i = new Element('img', {'src': this.get('src'), 'styles': {'position': 'absolute', 'left': '-999999px'}}).inject(document.body);
				i.addEvent('load', function() {
					var d = this.getSize();
					document.id('<?php echo $form_id; ?>-width').set('value', d.x);
					document.id('<?php echo $form_id; ?>-height').set('value', d.y);
					
					if(!(Browser.Engine.trident == true && Browser.version <= 8)) {
						document.id('<?php echo $form_id; ?>-width').set('disabled', false);
						document.id('<?php echo $form_id; ?>-height').set('disabled', false);
					}
				});
			});
			
			// Update the live preview
			form.getParent('.widget-config-panel').unspin().retrieve('evp-widget-config-close')({'data': {'file_options': {'src': document.id('<?php echo $form_id; ?>-src').get('value')}}}, false);
		});
	}(jQuery));
	
	form.set('send', {
		'onComplete': function(response) {
			form.getParent('.widget-config-panel').unspin().retrieve('evp-widget-config-close')(response);
		}
	});
	
	submit_button.addEvent('click', function(event) {
		if(event) event.stop();
		form.getParent('.widget-config-panel').spin();
		// We could do validation here etc, but let's just go for it
		form.send();
	});
})();
</script>