<?php
require($config['paths']['base'].'/libraries/uploader.php');

// Do the upload
$uploader = new Uploader('file', array(
	'mode' => 'normal'
));

function page_widget_image_failure($event, $error) {
	Ajax::failed(array('msg' => $error));
}

function page_widget_image_success($event, $idx, $path, $original_name) {
	global $pageWidget, $pageWidget_slug, $pageWidget_idx, $file_reference, $file_ref, $evp, $evp_api, $config;
	
	// Let's rename $original_name into $file_name
	$file_name = base64_encode($original_name);
	$ext = getExtension($original_name);
	rename($config['paths']['base'].'/assets/uploads/'.$original_name, $config['paths']['base'].'/assets/uploads/'.$file_name.'.'.$ext);
	
	// Let's save these values
	$evp_api->files_option($file_reference, "page_widgets[{$pageWidget_idx}][src]", $file_name.'.'.$ext);
	
	// Refresh the data
	// Note this is different to the others as it uses file_ref, which doesn't get modified in load.php
	if($source_mode == 'video') {
		$file = $evp->getFile($file_reference);
		$file_settings = false;
	} elseif($source_mode == 'playlist') {
		$file = $evp->getPlaylist($file_ref);
		$file_settings = $file;
	} elseif($source_mode == 'splittest') {
		$file = $evp->getSplitTest($file_ref);
		$file_settings = $file;
	}
	
	$pageWidget = $evp->getPageWidget($pageWidget_slug, $file, $pageWidget_idx, $file_settings);
	
	Ajax::success(array('msg' => 'Saved your settings successfully!', 'data' => $pageWidget));
}

$uploader->addEvent('onSuccess', 'page_widget_image_success');
$uploader->addEvent('onFailure', 'page_widget_image_failure');

if(!empty($_FILES)) {
	$original_name = $_FILES['file']['name'][0];
	$original_name = str_replace('.'.getExtension($original_name), '', $original_name);
	
	$uploader->upload('/assets/uploads/', array('jpg', 'gif', 'png', 'jpeg'), $original_name);
} elseif(!empty($_POST)) {
	// Let's save these values
	$src = escape($_POST['src'], true);
	$href = escape($_POST['href'], true);
	$width = escape($_POST['width'], true);
	$height = escape($_POST['height'], true);
	
	$evp_api->files_option($file_reference, "page_widgets[{$pageWidget_idx}][src]", $src);
	$evp_api->files_option($file_reference, "page_widgets[{$pageWidget_idx}][href]", $href);
	$evp_api->files_option($file_reference, "page_widgets[{$pageWidget_idx}][width]", $width);
	$evp_api->files_option($file_reference, "page_widgets[{$pageWidget_idx}][height]", $height);
	
	// Refresh the data
	if($source_mode == 'video') {
		$file = $evp->getFile($file_reference);
		$file_settings = false;
	} elseif($source_mode == 'playlist') {
		$file = $evp->getPlaylist($file->id);
		$file_settings = $file;
	} elseif($source_mode == 'splittest') {
		$file = $evp->getSplitTest($file->id);
		$file_settings = $file;
	}

	$pageWidget = $evp->getPageWidget($pageWidget_slug, $file, $pageWidget_idx, $file_settings);
	
	Ajax::success(array('msg' => 'Saved your settings successfully!', 'data' => $pageWidget));
} else {
	// Refresh the data
	if($source_mode == 'video') {
		$file = $evp->getFile($file_reference);
		$file_settings = false;
	} elseif($source_mode == 'playlist') {
		$file = $evp->getPlaylist($file->id);
		$file_settings = $file;
	} elseif($source_mode == 'splittest') {
		$file = $evp->getSplitTest($file->id);
		$file_settings = $file;
	}

	$pageWidget = $evp->getPageWidget($pageWidget_slug, $file, $pageWidget_idx, $file_settings);

	page_widget_image_failure(false, 'No image specified.');
}
?>