<?php
$form_id = 'evp-'.randomStr(5);

$available_elements = array();
$file_settings = $evp->collateFileSettings($file, $profile);
if(!empty($file_settings->events)) {
	foreach($file_settings->events as $name => $pel) {
		$pel = new Object($pel);
		if($pel->data->{'event-mode'} == 'external') $available_elements[$name] = $name;
	}
}
?>

<?php if(empty($available_elements)) : ?>

	<p class="error">You don't have any external Events configured, so you cannot use this widget! Please go and add some external Events on your video Timeline or delete this Page Widget!</p>

<?php else : ?>
	<form id="<?php echo $form_id; ?>" class="styled" method="post" action="<?php echo url('themes/3.0/assets/page-widgets/load.php', array('widget' => $pageWidget_slug, 'file_ref' => $file_reference, 'widget_idx' => $pageWidget_idx, 'widget_file' => 'save.php', 'source_mode' => $source_mode)); ?>">
	
		<div class="setting-group descend">
			<label>Select the external Event you want to display</label>
			<div class="clear"></div>
			<?php
			echo build_select($form_id.'-element', 'element', $available_elements, $pageWidget->file_options['element'], false, array('data-behavior' => 'SelectBox', 'style' => 'width:250px;'));
			?>
		</div>
		
	<div class="setting-group">
		<label>Centre this Event?</label>
		<input type="checkbox" name="align_centre" style="margin-top:11px;" <?php if($pageWidget->file_options['align_centre'] == true) echo 'checked="checked"'; ?> />
	</div>
		
		<div class="setting-group">
			<input id="<?php echo $form_id; ?>-submit" type="submit" value="Save" data-behavior="Button" data-button-width="100" data-button-type="action" class="clear align-right" />
		</div>
	</form>
	<script type="text/javascript">
	window.addEvent('domready', function() {
		var form = $('<?php echo $form_id; ?>');
		var submit_button = $('<?php echo $form_id; ?>-submit');
		
		form.set('send', {
			'onComplete': function(response) {
				form.getParent('.widget-config-panel').unspin().retrieve('evp-widget-config-close')(response);
			}
		});
		
		submit_button.addEvent('click', function(event) {
			if(event) event.stop();
			form.getParent('.widget-config-panel').spin();
			// We could do validation here etc, but let's just go for it
			form.send();
		});
	});
	</script>
<?php endif; ?>