<?php
// This file can access $file, $file_settings and $pageWidget
// You can assign things to $pageWidget if you need to
// File-specific stuff goes in $pageWidget->file_options

// This MUST expose a function called build_page_widget_[slug](), which returns the appropriate HTML

function build_page_widget_my_video($pageWidget, $file, $file_settings) {
	$evp = Registry::get('EVP');
	global $profile;
	
	$source_mode = 'video';
	if($file->source_mode == 'playlist') $source_mode = 'playlist';
	elseif($file->source_mode == 'splittest') $source_mode = 'splittest';
	
	if($source_mode == 'video') {
		$embed_code = $evp->videoEmbedCode($file, 'sd', $profile, false, 'js', $_GET['settings']);
	} elseif($source_mode == 'playlist') {
		$embed_code = $evp->playlistEmbedCode($file, false, 'js', $_GET['settings']);
	} elseif($source_mode == 'splittest') {
		$embed_code = $evp->splitEmbedCode($file, false, 'js', $_GET['settings']);
	}
	
	$classes = array('evp-site-block', 'evp-site-widget', 'evp-site-widget-my-video');
	if($file_settings->options['shadow'] != 'no-shadow') $classes[] = 'video-has-shadow';
	if($file_settings->options['frame'] != 'no-frame') $classes[] = 'video-has-frame';
	
	$classes[] = 'video-type-'.$source_mode;
	
	return '<div class="'.implode(' ', $classes).'"><div class="evp-site-content"><center>'.$embed_code.'</center></div></div>';
}

?>